﻿// Generated by Construct 2, the HTML5 game and app creator :: http://www.scirra.com
/*! CocoonJSExtensions - v2.0.0 - 2014-04-10 www.ludei.com */(function() {
    // There should not be a CocoonJS object when this code is executed.
    // if (typeof window.CocoonJS !== 'undefined') throw("This is strange, a CocoonJS object already exists when trying to create it.");

    /**
     * The basic object for all the CocoonJS related specific APIs === extensions.
     * @namespace
     */
    CocoonJS = window.CocoonJS ? window.CocoonJS : {};

    CocoonJS.nativeExtensionObjectAvailable = typeof window.ext !== 'undefined';

    /**
     * This type represents a 2D size structure with horizontal and vertical values.
     * @class
     */
    CocoonJS.Size = {
        /**
         * The horizontal size value.
         */
        width: 0,

        /**
         * The vertical size value.
         */
        height: 0
    };

    /**
     * This utility function allows to create an object oriented like hierarchy between two functions using their prototypes.
     * This function adds a "superclass" and a "__super" attributes to the subclass and it's functions to reference the super class.
     * @param {function} subc The subclass function.
     * @param {function} superc The superclass function.
     */
    CocoonJS.extend = function(subc, superc) {
        var subcp = subc.prototype;

        // Class pattern.
        var CocoonJSExtendHierarchyChainClass = function() {};
        CocoonJSExtendHierarchyChainClass.prototype = superc.prototype;

        subc.prototype = new CocoonJSExtendHierarchyChainClass(); // chain prototypes.
        subc.superclass = superc.prototype;
        subc.prototype.constructor = subc;

        // Reset constructor. See Object Oriented Javascript for an in-depth explanation of this.
        if (superc.prototype.constructor === Object.prototype.constructor) {
            superc.prototype.constructor = superc;
        }

        // Check all the elements in the subclass prototype and add them to the chain object's prototype.
        for (var method in subcp) {
            if (subcp.hasOwnProperty(method)) {
                subc.prototype[method] = subcp[method];

                // // tenemos en super un metodo con igual nombre.
                // if ( superc.prototype[method]) 
                // {
                //     subc.prototype[method]= (function(fn, fnsuper) 
                //     {
                //         return function() 
                //         {
                //             var prevMethod= this.__super;

                //             this.__super= fnsuper;

                //             var retValue= fn.apply(
                //                     this,
                //                     Array.prototype.slice.call(arguments) );

                //             this.__super= prevMethod;

                //             return retValue;
                //         };
                //     })(subc.prototype[method], superc.prototype[method]);
                // }
            }
        }
    }

    /**
     * IMPORTANT: This function should only be used by Ludei.
     * This function allows a call to the native extension object function reusing the same arguments object.
     * Why is interesting to use this function instead of calling the native object's function directly?
     * As the CocoonJS object functions expicitly receive parameters, if they are not present and the native call is direcly mapped,
     * undefined arguments are passed to the native side. Some native functions do not check the parameters validation
     * correctly (just check the number of parameters passed).
     * Another solution instead of using this function call is to correctly check if the parameters are valid (not undefined) to make the
     * call, but it takes more work than using this approach.
     * @static
     * @param {string} nativeExtensionObjectName The name of the native extension object name. The object that is a member of the 'ext' object.
     * @param {string} nativeFunctionName The name of the function to be called inside the native extension object.
     * @param {object} arguments The arguments object of the CocoonJS extension object function. It contains all the arguments passed to the CocoonJS extension object function and these are the ones that will be passed to the native call too.
     * @param {boolean} [async] A flag to indicate if the makeCall (false or undefined) or the makeCallAsync function should be used to perform the native call.
     * @returns Whatever the native function call returns.
     */
    CocoonJS.makeNativeExtensionObjectFunctionCall = function(nativeExtensionObjectName, nativeFunctionName, args, async) {
        if (CocoonJS.nativeExtensionObjectAvailable) {
            var argumentsArray = Array.prototype.slice.call(args);
            argumentsArray.unshift(nativeFunctionName);
            var nativeExtensionObject = ext[nativeExtensionObjectName];
            var makeCallFunction = async ? nativeExtensionObject.makeCallAsync : nativeExtensionObject.makeCall;
            var ret = makeCallFunction.apply(nativeExtensionObject, argumentsArray);
            var finalRet = ret;
            if (typeof ret === "string") {
                try {
                    finalRet = JSON.parse(ret);
                } catch (error) {}
            }
            return finalRet;
        }
    };

    /**
     * Returns an object retrieved from a path specified by a dot specified text path starting from a given base object.
     * It could be useful to find the reference of an object from a defined base object. For example the base object could be window and the
     * path could be "CocoonJS.App" or "document.body".
     * @param {Object} baseObject The object to start from to find the object using the given text path.
     * @param {string} objectPath The path in the form of a text using the dot notation. i.e. "document.body"
     * For example:
     * var body = getObjectFromPath(window, "document.body");
     */
    CocoonJS.getObjectFromPath = function(baseObject, objectPath) {
        var parts = objectPath.split('.');
        var obj = baseObject;
        for (var i = 0, len = parts.length; i < len; ++i) {
            obj[parts[i]] = obj[parts[i]] || undefined;
            obj = obj[parts[i]];
        }
        return obj;
    };

    /**
     * Returns the key for a value in a dictionary. It looks for an specific value inside a dictionary and returns the corresponding key.
     * @param {Object} dictionary The dictionary to look for the value in and get the corresponding key.
     * @param {Object} value The value to look for inside the dictionary and return it's corresponding key.
     * @return The key that corresponds to the given value it is has been found or null.
     */
    CocoonJS.getKeyForValueInDictionary = function(dictionary, value) {
        var finalKey = null;
        for (var key in dictionary) {
            if (dictionary[key] === value) {
                finalKey = key;
                break;
            }
        }
        return finalKey;
    }

    /**
     * Finds a string inside a given array of strings by looking for a given substring. It can also
     * specify if the search must be performed taking care or not of the case sensitivity.
     * @param {Array} stringArray The array of strings in which to to look for the string.
     * @param {string} subString The substring to look for inside all the strings of the array.
     * @param {boolean} caseSensitive A flag to indicate if the search must be performed taking case of the
     * case sensitiveness (true) or not (false).
     * @return {string} The string that has been found or null if the substring is not inside any of the string of the array.
     */
    CocoonJS.findStringInStringArrayThatIsIndexOf = function(stringArray, subString, caseSensitive) {
        var foundString = null;
        subString = caseSensitive ? subString : subString.toUpperCase();
        for (var i = 0; foundString == null && i < stringArray.length; i++) {
            foundString = caseSensitive ? stringArray[i] : stringArray[i].toUpperCase();
            foundString = foundString.indexOf(subString) >= 0 ? stringArray[i] : null;
        }
        return foundString;
    };

    /**
     * A class that represents objects to handle events. Event handlers have always the same structure:
     * Mainly they provide the addEventListener and removeEventListener functions.
     * Both functions receive a callback function that will be added or removed. All the added callback
     * functions will be called when the event takes place.
     * Additionally they also allow the addEventListenerOnce and notifyEventListeners functions.
     * @constructor
     * @param {string} nativeExtensionObjectName The name of the native extension object (inside the ext object) to be used.
     * @param {string} cocoonJSExtensionObjectName The name of the sugarized extension object.
     * @param {string} nativeEventName The name of the native event inside the ext object.
     * @param {number} [chainFunction] An optional function used to preprocess the listener callbacks. This function, if provided,
     * will be called before any of the other listeners.
     */
    CocoonJS.EventHandler = function(nativeExtensionObjectName, cocoonJSExtensionObjectName, nativeEventName, chainFunction) {
        this.listeners = [];
        this.listenersOnce = [];
        this.chainFunction = chainFunction;

        /**
         * Adds a callback function so it can be called when the event takes place.
         * @param {function} listener The callback function to be added to the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.addEventListener = function(listener) {
            if (chainFunction) {
                var f = function() {
                    chainFunction.call(this, arguments.callee.sourceListener, Array.prototype.slice.call(arguments));
                };
                listener.CocoonJSEventHandlerChainFunction = f;
                f.sourceListener = listener;
                listener = f;
            }

            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListener(nativeEventName, listener);
            }
            var indexOfListener = this.listeners.indexOf(listener);
            if (indexOfListener < 0) {
                this.listeners.push(listener);
            }
        };

        this.addEventListenerOnce = function(listener) {
            if (chainFunction) {
                var f = function() {
                    chainFunction(arguments.callee.sourceListener, Array.prototype.slice.call(arguments));
                };
                f.sourceListener = listener;
                listener = f;
            }

            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListenerOnce(nativeEventName, listener);
            } else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0) {
                    this.listenersOnce.push(listener);
                }
            }
        };

        /**
         * Removes a callback function that was added to the event handler so it won't be called when the event takes place.
         * @param {function} listener The callback function to be removed from the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.removeEventListener = function(listener) {

            if (chainFunction) {
                listener = listener.CocoonJSEventHandlerChainFunction;
                delete listener.CocoonJSEventHandlerChainFunction;
            }

            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].removeEventListener(nativeEventName, listener);
            } else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener >= 0) {
                    this.listeners.splice(indexOfListener, 1);
                }
            }
        };

        this.notifyEventListeners = function() {
            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            var argumentsArray = Array.prototype.slice.call(arguments);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].notifyEventListeners(nativeEventName, argumentsArray);
            } else {
                var listeners = Array.prototype.slice.call(this.listeners);
                var listenersOnce = Array.prototype.slice.call(this.listenersOnce);
                var _this = this;
                // Notify listeners after a while ;) === do not block this thread.
                setTimeout(function() {
                    for (var i = 0; i < listeners.length; i++) {
                        listeners[i].apply(_this, argumentsArray);
                    }
                    for (var i = 0; i < listenersOnce.length; i++) {
                        listenersOnce[i].apply(_this, argumentsArray);
                    }
                }, 0);

                _this.listenersOnce = [];
            }
        };
        return this;
    };

    /**
     * A simple timer class. Update it every loop iteration and get values from accumulated time to elapsed time in seconds or milliseconds.
     */
    CocoonJS.Timer = function() {
        this.reset();
        return this;
    };

    CocoonJS.Timer.prototype = {
        currentTimeInMillis: 0,
        lastTimeInMillis: 0,
        elapsedTimeInMillis: 0,
        elapsedTimeInSeconds: 0,
        accumTimeInMillis: 0,

        /**
		Resets the timer to 0.
		*/
        reset: function() {
            this.currentTimeInMillis = this.lastTimeInMillis = new Date().getTime();
            this.accumTimeInMillis = this.elapsedTimeInMillis = this.elapsedTimeInSeconds = 0;
        },

        /**
		Updates the timer calculating the elapsed time between update calls.
		*/
        update: function() {
            this.currentTimeInMillis = new Date().getTime();
            this.elapsedTimeInMillis = this.currentTimeInMillis - this.lastTimeInMillis;
            this.elapsedTimeInSeconds = this.elapsedTimeInMillis / 1000.0;
            this.lastTimeInMillis = this.currentTimeInMillis;
            this.accumTimeInMillis += this.elapsedTimeInMillis;
        }
    };

})();;(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents all the basic functionalities available in the CocoonJS extension API.
     * @namespace
     */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_APP !== 'undefined';

    /**
     * The predefined possible layouts for the FPS overlay.
     * @namespace
     * @enum
     */
    CocoonJS.App.FPSLayout = {
        TOP_LEFT:'top-left',
        TOP_RIGHT:'top-right',
        BOTTOM_LEFT:'bottom-left',
        BOTTOM_RIGHT:'bottom-right'
    };

    /**
    * The predefined possible orientations. there can be a bit level combination of them using the OR operator.
    * @namespace
    * @enum
    */
    CocoonJS.App.Orientations = {
        PORTRAIT : 1,
        PORTRAIT_UPSIDE_DOWN : 2,
        LANDSCAPE_LEFT : 4,
        LANDSCAPE_RIGHT : 8,
        PORTRAIT : 1 | 2,
        LANDSCAPE : 4 | 8,
        BOTH : 1 | 2 | 4 | 8
    };

    /**
     * Contains all the possible values to specify the input keyboard type to be used when introducing text.
     * @namespace
     * @enum
     */
    CocoonJS.App.KeyboardType = {
        /**
         * Represents a generic text input keyboard.
         */
        TEXT:"text",

        /**
         * Represents a number like input keyboard.
         */
        NUMBER:"num",

        /**
         * Represents a phone like input keyboard.
         */
        PHONE:"phone",

        /**
         * Represents an email like input keyboard.
         */
        EMAIL:"email",

        /**
         * Represents an URL like input keyboard.
         */
        URL:"url"
    };

    /**
     * The storage types to be used with file system related operations.
     * @namespace
     * @enum
     */
    CocoonJS.App.StorageType = {
        /**
         * Represents the application storage. The application storage is the place where all the resources that come with the application are stored.
         */
        APP_STORAGE:"APP_STORAGE",

        /**
         * Represents the internal storage. The internal storage is a different storage space that the application storage and only the data that the application has stored
         * in it will be in this storage. It is internal to the platform/device.
         */
        INTERNAL_STORAGE:"INTERNAL_STORAGE",

        /**
         * Represents an external storage. The external storage is similar to the internal storage in the sense that it only contains information that the application has written
         * in it but it represents an external storage device like a SD-CARD. If there is no exrernal storage, it will represent the same as the internal storage.
         */
        EXTERNAL_STORAGE:"EXTERNAL_STORAGE",

        /**
         * Represents the temporal storage. Same as the internal and external storage spaces in the sense that it only contains information that the application has written
         * in it but the main difference is that the information in this storage may dissapear without notice.
         */
        TEMPORARY_STORAGE:"TEMPORARY_STORAGE"
    };

    /**
     * The capture types to capture screenshots using CocoonJS native capabilities.
     * @namespace
     * @enum
     */
    CocoonJS.App.CaptureType = {
        /**
         Captures everything, both the CocoonJS GL hardware accelerated surface and the system views (like the WebView).
         */
        EVERYTHING:0,

        /**
         * Captures just the CocoonJS GL hardware accelerated surface.
         */
        JUST_COCOONJS_GL_SURFACE:1,

        /**
         * Captures just the sustem views (like the webview)
         */
        JUST_SYSTEM_VIEWS:2
    };

    /**
     * @ignore
     * Forward service might not be available if only one JS service is included
     */
    function isNativeBridgeServiceAvailable(){
        if (CocoonJS.App.forward.nativeAvailable === 'boolean') {
            //cached value
            return CocoonJS.App.forward.nativeAvailable;
        }
        else {
            var available = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forwardAvailable", arguments);
            available = !!available;
            CocoonJS.App.forward.nativeAvailable = available;
            return available;
        }

    }

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It waits until the code is executed and the result of it is returned === synchronous.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @return {string} The result of the execution of the passed JavaScript code in the different JavaScript environment.
     */
    CocoonJS.App.forward = function (javaScriptCode) {
        if (CocoonJS.App.nativeExtensionObjectAvailable && isNativeBridgeServiceAvailable()) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forward", arguments);
        }
        else {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                //return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                return window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It is asyncrhonous so it does not wait until the code is executed and the result of it is returned. Instead, it calls a callback function when the execution has finished to pass the result.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @param {function} [returnCallback] A function callback that will be called when the passed JavaScript code is executed in a different thread to pass the result of the execution in the different JavaScript environment.
     */
    CocoonJS.App.forwardAsync = function (javaScriptCode, returnCallback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable && isNativeBridgeServiceAvailable()) {
            if (typeof returnCallback !== 'undefined') {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode, returnCallback);
            }
            else {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode);
            }
        }
        else {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                // window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Pops up a text dialog so the user can introduce some text and the application can get it back. It is the first approach CocoonJS has taken to be able to introduce
     * text input in a easy way. The dialog execution events are passed to the application through the {@link CocoonJS.App.onTextDialogFinished} and the {@link CocoonJS.App.onTextDialogCancelled} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [text] Default value is "". The initial text to be introduced in the text input field.
     * @param {CocoonJS.App.KeyboardType} [keyboardType] Default value is {@link CocoonJS.App.KeyboardType.TEXT}. The keyboard type to be used when the text has to be introduced.
     * @param {string} [cancelButtonText] Default value is "". The text to be displayed in the cancel button of the dialog.
     * @param {string} [okButtonText] Default value is "". The text to be displayed in the ok button of the dialog.
     * @see CocoonJS.App.onTextDialogFinished
     * @see CocoonJS.App.onTextDialogCancelled
     */
    CocoonJS.App.showTextDialog = function (title, message, text, keyboardType, cancelButtonText, okButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTextDialog", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            if (!text) {
                text = "";
            }
            setTimeout(function() {
                var result = prompt(message, text);
                var eventObject = result ? CocoonJS.App.onTextDialogFinished : CocoonJS.App.onTextDialogCancelled;
                eventObject.notifyEventListeners(result);
            }, 0);
        }
    };

    /**
     * Pops up a message dialog so the user can decide between a yes or no like confirmation. The message box execution events are passed to the application through the {@link CocoonJS.App.onMessageBoxConfirmed} and the {@link CocoonJS.App.onMessageBoxDenied} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [confirmButtonText] Default value is "Yes". The text to be displayed for the confirm button.
     * @param {string} [denyButtonText] Default value is "No". The text to be displayed for the deny button.
     * @see CocoonJS.App.onMessageBoxConfirmed
     * @see CocoonJS.App.onMessageBoxDenied
     */
    CocoonJS.App.showMessageBox = function (title, message, confirmButtonText, denyButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showMessageBox", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            setTimeout(function() {
                var result = confirm(message);
                var eventObject = result ? CocoonJS.App.onMessageBoxConfirmed : CocoonJS.App.onMessageBoxDenied;
                eventObject.notifyEventListeners();
            }, 0);
        }
    };

    /**
     * It allows to load a new JavaScript/HTML5 resource that can be loaded either locally (inside the platform/device storage) or using a remote URL.
     * @function
     * @param {string} path A path to a resource stored in the platform or in a URL to a remote resource.
     * @param {CocoonJS.App.StorageType} [storageType] If the path argument represents a locally stored resource, the developer can specify the storage where it is stored. If no value is passes, the {@link CocoonJS.App.StorageType.APP_STORAGE} value is used by default.
     */
    CocoonJS.App.load = function (path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadPath", arguments);
        }
        else if (!navigator.isCocoonJS) {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function (event) {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // TODO: As window load event is not being called (WHY???), I have decided to call the listeners directly
                        // var callback= function(event){
                        //     window.removeEventListener("load", callback);
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInCocoonJSSucceed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                        // };
                        // window.addEventListener("load", callback);
                        window.location.href = path;
                    }
                    else if (xhr.status === 404) {
                        this.onreadystatechange = null;
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInCocoonJSFailed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the current context.
     * @function
     */
    CocoonJS.App.reload = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reload", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.location.reload();
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.location.reload();
            }
        }
    };

    /**
     * Opens a given URL using a system service that is able to open it. For example, open a HTTP URL using the system WebBrowser.+
     * @function
     * @param {string} url The URL to be opened by a system service.
     */
    CocoonJS.App.openURL = function (url) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "openURL", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            window.open(url, '_blank');
        }
    }

    /**
     * Forces the app to be finished.
     * @function
     */
    CocoonJS.App.forceToFinish = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forceToFinish", arguments);
        }
        else if (!navigator.isCocoonJS) {
            window.close();
        }
    }

    /**
     * Enables or disables the auto lock to control if the screen keeps on after an inactivity period.
     * When the auto lock is enabled and the application has no user input for a short period, the system puts the device into a "sleepâ€ state where the screen dims or turns off.
     * When the auto lock is disabled the screen keeps on even when there is no user input for long times.
     * @param enabled A boolean value that controls whether to enable or disable the auto lock.
     */
    CocoonJS.App.setAutoLockEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setAutoLockEnabled", arguments);
        }
    }

    /**
     * Creates a canvas element that is automatically resized to the screen size. When the app is being executed
     * inside CocoonJS. This canvas is optimized for rendering so it is higly recommended to use it if it fits
     * your app needs. If your app uses one canvas as the main canvas where all other canvases and images are displayed, Ludei recommends to
     * call this function in order to create this main canvas. A usual 2x performance gain is achieved by doing so
     * depending on the device and the graphics card driver.
     * @function
     * @return {object} The canvas object that should be used as the main canvas and that is resized to the screen resolution.
     */
    CocoonJS.App.createScreenCanvas = function () {
        var screenCanvas;
        if (navigator.isCocoonJS) {
            screenCanvas = document.createElement("screencanvas");
        }
        else if (!navigator.isCocoonJS) {
            screenCanvas = document.createElement("canvas");
            screenCanvas.width = window.innerWidth;
            screenCanvas.height = window.innerHeight;
        }
        return screenCanvas;
    };

    /**
     * Disables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.disableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Enables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.enableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Disables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.disableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "WebView");
        }
    };

    /**
     * Enables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.enableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "WebView");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the accelerometer updates.
     * It defines the rate at which the devicemotion events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setAccelerometerUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setAccelerometerUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for accelerometer related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for accelerometer related events.
     */
    CocoonJS.App.getAccelerometerUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getAccelerometerUpdateIntervalInSeconds");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the gyroscope updates.
     * It defines the rate at which the devicemotion and deviceorientation events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setGyroscopeUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setGyroscopeUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for gyroscope related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for gyroscope related events.
     */
    CocoonJS.App.getGyroscopeUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("getGyroscopeUpdateIntervalInSeconds");
        }
    };


    /**
     * Setups a origin proxy for a given typeName. What this means is that after calling this function the environment that makes this call will suddenly
     * have a way of creating instances of the given typeName and those instances will act as a transparent proxy to counterpart instances in the destination environment.
     * Manipulating attributes, calling funcitions or handling events will all be performed in the destination environment but the developer will think they will be
     * happening in the origin environment.
     * IMPORTANT NOTE: These proxies only work with types that use attributes and function parameters and return types that are primitive like numbers, strings or arrays.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} [attributeNames] A list of the names of the attributes to be proxified.
     * @param {array} [functionNames] A list of the names of the functions to be proxified.
     * @param {array} [eventHandlerNames] A list of the names of the event handlers to be proxified (onXXXX like attributes that represent callbacks).
     * A valid typeName and at least one valid array for attribute, function or event handler names is mandatory.
     */
    CocoonJS.App.setupOriginProxyType = function (typeName, attributeNames, functionNames, eventHandlerNames) {
        // Control the parameters.
        if (!typeName) throw "The given typeName must be valid.";
        if (!attributeNames && !functionNames && !eventHandlerNames) throw "There is no point on setting up a proxy for no attributes, functions nor eventHandlers.";
        attributeNames = attributeNames ? attributeNames : [];
        functionNames = functionNames ? functionNames : [];
        eventHandlerNames = eventHandlerNames ? eventHandlerNames : [];

        // The parent object will be the window. It could be another object but careful, the destination side should know about this.
        // TODO: Specify the parentObject as a parameter, obtain it's path from the window object and pass it to the destination environment so it knows about it.
        var parentObject = window;

        // Setup the destination side too.
        var jsCode = "CocoonJS.App.setupDestinationProxyType(" + JSON.stringify(typeName) + ", " + JSON.stringify(eventHandlerNames) + ");";
        CocoonJS.App.forward(jsCode);

        var originalType = parentObject[typeName];

        // Constructor. This will be the new proxified type in the origin environment. Instances of this type will be created by the developer without knowing that they are
        // internally calling to their counterparts in the destination environment.
        parentObject[typeName] = function () {
            var _this = this;

            // Each proxy object will have a origin object inside with all the necessary information to be a proxy to the destination.
            this._cocoonjs_proxy_object_data = {};
            // The id is obtained calling to the destination side to create an instance of the type.
            var jsCode = "CocoonJS.App.newDestinationProxyObject(" + JSON.stringify(typeName) + ");";
            this._cocoonjs_proxy_object_data.id = CocoonJS.App.forward(jsCode);
            // The eventHandlers dictionary contains objects of the type { eventHandlerName : string, eventHandler : function } to be able to make the callbacks when the 
            // webview makes the corresponding calls.
            this._cocoonjs_proxy_object_data.eventHandlers = {};
            // Also store the typename inside each instance.
            this._cocoonjs_proxy_object_data.typeName = typeName;
            // A dictionary to store the event handlers
            this._cocoonjs_proxy_object_data.eventListeners = {};

            // TODO: eventHandlers and eventListeners should be in the same list ;)

            // Store all the proxy instances in a list that belongs to the type itself.
            parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[this._cocoonjs_proxy_object_data.id] = this;

            // Create a setter and a getter for all the attribute names that have been specified. When the attributes are accessed (set or get) a call to the destination counterpart will be performed.
            for (var i = 0; i < attributeNames.length; i++) {
                (function (attributeName) {
                    _this.__defineSetter__(attributeName, function (value) {
                        var jsCode = "CocoonJS.App.setDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ", " + JSON.stringify(value) + ");";
                        return CocoonJS.App.forward(jsCode);
                    });
                    _this.__defineGetter__(attributeName, function () {
                        var jsCode = "CocoonJS.App.getDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ");";
                        return CocoonJS.App.forward(jsCode);
                    });
                })(attributeNames[i]);
            }

            // Create a function that performs a call to the destination environment counterpart for all the function names that have been specified.
            for (var i = 0; i < functionNames.length; i++) {
                (function (functionName) {
                    _this[functionName] = function () {
                        // Get the arguments as an array and add the typeName, the proxy id and the functionName before all the other arguments before making the call to the destination counterpart.
                        var argumentsArray = Array.prototype.slice.call(arguments);
                        argumentsArray.unshift(functionName);
                        argumentsArray.unshift(this._cocoonjs_proxy_object_data.id);
                        argumentsArray.unshift(typeName);
                        // Use the array to create the correct function call.
                        var jsCode = "CocoonJS.App.callDestinationProxyObjectFunction(";
                        for (var i = 0; i < argumentsArray.length; i++) {
                            // The second argument (the id) should not be stringified
                            jsCode += (i !== 1 ? JSON.stringify(argumentsArray[i]) : argumentsArray[i]) + (i < argumentsArray.length - 1 ? ", " : "");
                        }
                        jsCode += ");";
                        // TODO: This next call should be synchronous but it seems that some customers are experiencing some crash issues. Making it async solves these crashes.
                        // Another possible solution could be to be able to specify which calls could be async and which sync in the proxification array.
                        var ret = CocoonJS.App.forwardAsync(jsCode);
                        return ret;
                    };
                })(functionNames[i]);
            }

            // Create a setter and getter for all the event handler names that have been specified. When the event handlers are accessed, store them inside the corresponding position on the eventHandlers
            // array so they can be called when the destination environment makes the corresponding callback call.
            for (var i = 0; i < eventHandlerNames.length; i++) {
                (function (eventHandlerName) {
                    _this.__defineSetter__(eventHandlerName, function (value) {
                        _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName] = value;
                    });
                    _this.__defineGetter__(eventHandlerName, function () {
                        return _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                    });
                })(eventHandlerNames[i]);
            }

            // Setup the add and remove event listeners in the proxy object
            _this.addEventListener = function (eventTypeName, eventCallback) {
                var addEventCallback = true;
                // Check for the eventListeners
                var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                if (eventListeners) {
                    // As the eventListeners were already added, check that the same callback has not been added.
                    addEventCallback = eventListeners.indexOf(eventCallback) < 0;
                }
                else {
                    // There are no event listeners, so add the one and add the listeners array for the specific event type name
                    eventListeners = [];
                    _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = eventListeners;

                    // Forward the call so the other end registers a event listener (only one is needed).
                    var jsCode = "CocoonJS.App.addDestinationProxyObjectEventListener(" + JSON.stringify(_this._cocoonjs_proxy_object_data.typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                }
                // Only if the alforithm above specify so, add the eventcallback and notify the destination environment to do the same
                if (addEventCallback) {
                    eventListeners.push(eventCallback);
                }
            };

            _this.removeEventListener = function (eventTypeName, eventCallback) {
                // Check for the eventListeners
                var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                if (eventListeners) {
                    var eventCallbackIndex = eventListeners.indexOf(eventCallback);
                    if (eventCallbackIndex >= 0) {
                        eventListeners.splice(eventCallbackIndex, 1);
                    }
                }
            };

            // Return the proxy instance.
            return this;
        };

        // The type will contain a proxy data structure to store all the instances that are created so they are available when the destination environment calls back. 
        parentObject[typeName]._cocoonjs_proxy_type_data =
        {
            originalType:originalType,
            proxyObjects:[]
        };

        /**
         * Deletes a proxy instance from both the CocoonJS environment structures and also deleting it's webview environment counterpart.
         * This function should be manually called whenever a proxy instance won't be accessed anymore.
         * @param {object} object The proxy object to be deleted.
         */
        parentObject[typeName]._cocoonjs_proxy_type_data.deleteProxyObject = function (object) {
            var proxyObjectKey = CocoonJS.getKeyForValueInDictionary(this.proxyObjects, object);
            if (proxyObjectKey) {
                var jsCode = "CocoonJS.App.deleteDestinationProxyObject(" + JSON.stringify(typeName) + ", " + object._cocoonjs_proxy_object_data.id + ");";
                CocoonJS.App.forwardAsync(jsCode);
                object._cocoonjs_proxy_object_data = null;
                delete this.proxyObjects[proxyObjectKey];
            }
        };

        /**
         * Calls a event handler for the given proxy object id and eventHandlerName.
         * @param {number} id The id to be used to look for the proxy object for which to make the call to it's event handler.
         * @param {string} eventHandlerName The name of the handler to be called.
         * NOTE: Events are a complex thing in the HTML specification. This function just performs a call but at least provides a
         * structure to the event passing the target (the proxy object).
         * TODO: The destination should serialize the event object as far as it can so many parameters can be passed to the origin
         * side. Using JSON.stringify in the destination side and parse in origin side maybe? Still must add the target to the event structure though.
         */
        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler = function (id, eventHandlerName) {
            var object = this.proxyObjects[id];
            var eventHandler = object._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
            if (eventHandler) {
                eventHandler({ target:object });
            }
        };

        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners = function (id, eventTypeName) {
            var object = this.proxyObjects[id];
            var eventListeners = object._cocoonjs_proxy_object_data.eventListeners[eventTypeName].slice();
            for (var i = 0; i < eventListeners.length; i++) {
                eventListeners[i]({ target:object });
            }
        };
    };

    /**
     * Takes down the proxification of a type and restores it to it's original type. Do not worry if you pass a type name that is not proxified yet. The
     * function will handle it correctly for compativility reasons.
     * @param {string} typeName The name of the type to be deproxified (take down the proxification and restore the type to it's original state)
     */
    CocoonJS.App.takedownOriginProxyType = function (typeName) {
        var parentObject = window;
        if (parentObject[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
            parentObject[typeName] = parentObject[typeName]._cocoonjs_proxy_type_data.originalType;
        }
    };

    /**
     * Deletes everything related to a proxy object in both environments. Do not worry of you do not pass a proxified object to the
     * function. For compatibility reasons, you can still have calls to this function even when no poxification of a type has been done.
     * @param {object} object The proxified object to be deleted.
     */
    CocoonJS.App.deleteOriginProxyObject = function (object) {
        var parentObject = window;
        if (object && object._cocoonjs_proxy_object_data) {
            parentObject[object._cocoonjs_proxy_object_data.typeName]._cocoonjs_proxy_type_data.deleteProxyObject(object);
        }
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when an event handler need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventHandlerName The name of the event handler to be called.
     */
    CocoonJS.App.callOriginProxyObjectEventHandler = function (typeName, id, eventHandlerName) {
        var parentObject = window;
        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler(id, eventHandlerName);
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when all the event listeners related to a specific event need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventTypeName The name of the event type to call the listeners related to it.
     */
    CocoonJS.App.callOriginProxyObjectEventListeners = function (typeName, id, eventTypeName) {
        var parentObject = window;
        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners(id, eventTypeName);
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Setups all the structures that are needed to proxify a destination type to an origin type.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} eventHandlerNames An array with al the event handlers to be proxified. Needed in order to be able to create callbacks for all the event handlers
     * and call to the CocoonJS counterparts accordingly.
     */
    CocoonJS.App.setupDestinationProxyType = function (typeName, eventHandlerNames) {
        var parentObject = window;

        // Add a cocoonjs structure to the destination proxified type to store some useful information like all the proxy instances that are created, plus the id counter 
        // and the names of all the event handlers and some utility functions.
        parentObject[typeName]._cocoonjs_proxy_type_data =
        {
            nextId:0,
            proxyObjects:{},
            eventHandlerNames:eventHandlerNames
        }
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Takes down the proxy type at the destination environment. Just removes the data structure related to proxies that was added to the type when proxification tool place.
     * @param {string} typeName The name of the type to take the proxification down.
     */
    CocoonJS.App.takedownDestinationProxyType = function (typeName) {
        var parentObject = window;
        if (parent[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
            delete parentObject[typeName]._cocoonjs_proxy_type_data;
        }
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Creates a new destination object instance and generates a id to reference it from the original environment.
     * @param {string} typeName The name of the type to be proxified and to generate an instance.
     * @return The id to be used from the original environment to identify the corresponding destination object instance.
     */
    CocoonJS.App.newDestinationProxyObject = function (typeName) {
        var parentObject = window;

        var proxyObject = new parentObject[typeName]();
        // Also store some additional information in the proxy object
        proxyObject._cocoonjs_proxy_object_data = {};
        // Like the type name, that could be useful late ;)
        proxyObject._cocoonjs_proxy_object_data.typeName = typeName;
        // Caculate the id for the object. It will be returned to the origin environment so this object can be referenced later
        var proxyObjectId = parentObject[typeName]._cocoonjs_proxy_type_data.nextId;
        // Store the created object in the structure defined in the setup of proxification with an id associated to it
        parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[proxyObjectId] = proxyObject;
        // Also store the id inside the proxy object itself
        proxyObject._cocoonjs_proxy_object_data.id = proxyObjectId;
        // Calculate a new id for the next object.
        parentObject[typeName]._cocoonjs_proxy_type_data.nextId++;

        // Setup all the event handlers.
        for (var i = 0; i < parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames.length; i++) {
            (function (eventHandlerName) {
                proxyObject[eventHandlerName] = function (event) {
                    var proxyObject = this; // event.target;
                    // var eventHandlerName = CocoonJS.getKeyForValueInDictionary(proxyObject, this); // Avoid closures ;)
                    var jsCode = "CocoonJS.App.callOriginProxyObjectEventHandler(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventHandlerName) + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                };
            })(parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames[i]);
        }

        // Add the dictionary where the event listeners (callbacks) will be added.
        proxyObject._cocoonjs_proxy_object_data.eventListeners = {};

        return proxyObjectId;
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the origin environement whenever it is needed to work with proxy objects.
     * Calls a function of a destination object idetified by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} functionName The name of the function to be called.
     * @return Whatever the function call returns.
     */
    CocoonJS.App.callDestinationProxyObjectFunction = function (typeName, id, functionName) {
        var parentObject = window;
        var argumentsArray = Array.prototype.slice.call(arguments);
        argumentsArray.splice(0, 3);
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        var result = proxyObject[functionName].apply(proxyObject, argumentsArray);
        return result;
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Sets a value to the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be set.
     * @param {unknown} attributeValue The value to be set to the attribute.
     */
    CocoonJS.App.setDestinationProxyObjectAttribute = function (typeName, id, attributeName, attributeValue) {
        var parentObject = window;
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        proxyObject[attributeName] = attributeValue;
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Retrieves the value of the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be retrieved.
     */
    CocoonJS.App.getDestinationProxyObjectAttribute = function (typeName, id, attributeName) {
        var parentObject = window;
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        return proxyObject[attributeName];
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Deletes a proxy object identifying it using it's typeName and id. Deleting a proxy object mainly means to remove the instance from the global structure
     * that hold all the instances.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     */
    CocoonJS.App.deleteDestinationProxyObject = function (typeName, id) {
        var parentObject = window;
        delete parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     */
    CocoonJS.App.addDestinationProxyObjectEventListener = function (typeName, id, eventTypeName) {
        var parentObject = window;
        // Look for the proxy object
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];

        var callback = function (event) {
            var proxyObject = this; // event.target;
            // var eventTypeName = CocoonJS.getKeyForValueInDictionary(proxyObject._cocoonjs_proxy_object_data.eventListeners, this); // Avoid closures ;)
            // TODO: Is there a way to retrieve the callbackId without a closure?
            var jsCode = "CocoonJS.App.callOriginProxyObjectEventListeners(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
            CocoonJS.App.forwardAsync(jsCode);
        };

        proxyObject._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = callback;

        // Finally add the event listener callback to the proxy object
        proxyObject.addEventListener(eventTypeName, callback);
    };

    // TODO: We could add a removeDestinationProxyObjectEventListener although it seems that is not completely necessary.

    /**
     * Proxifies the XMLHttpRequest type for the environment where this call is made. After calling this function, all the new objects
     * of XMLHttpRequest that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyXHR = function () {
        var ATTRIBUTE_NAMES =
            [
                "timeout",
                "withCredentials",
                "upload",
                "status",
                "statusText",
                "responseType",
                "response",
                "responseText",
                "responseXML",
                "readyState"
            ];
        var FUNCTION_NAMES =
            [
                "open",
                "setRequestHeader",
                "send",
                "abort",
                "getResponseHeader",
                "getAllResponseHeaders",
                "overrideMimeType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onloadstart",
                "onprogress",
                "onabort",
                "onerror",
                "onload",
                "ontimeout",
                "onloadend",
                "onreadystatechange"
            ];
        CocoonJS.App.setupOriginProxyType("XMLHttpRequest", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Proxifies the Audio type for the environment where this call is made. After calling this function, all the new objects
     * of Audio that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyAudio = function () {
        var ATTRIBUTE_NAMES =
            [
                "src",
                "loop",
                "volume",
                "preload"
            ];
        var FUNCTION_NAMES =
            [
                "play",
                "pause",
                "load",
                "canPlayType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onended",
                "oncanplay",
                "oncanplaythrough",
                "onerror"
            ];
        CocoonJS.App.setupOriginProxyType("Audio", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Captures a image of the screen synchronously and saves it to a file. Sync mode allows to capture the screen in the middle of a frame rendering.
     * @param {string} fileName Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} storageType The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @return The URL of the saved file.
     * @throws exception if the image fails to be stored or there is another error.
     * @see CocoonJS.App.onCaptureScreenSucceeded
     * @see CocoonJS.App.onCaptureScreenFailed
     */
    CocoonJS.App.captureScreen = function (fileName, storageType, captureType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("captureScreen", fileName, storageType, captureType);
        }
    };

    /**
     * Captures a image of the screen asynchronously and saves it to a file.
     * Async mode captures a final frame as soon as possible.
     * @param {string} Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} [storageType] The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface, 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @param {function} callback. Response callback, check the error property to monitor errors. Check the 'url' property to get the URL of the saved Image
     */
    CocoonJS.App.captureScreenAsync = function (fileName, storageType, captureType, callback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCallAsync("captureScreen", fileName, storageType, captureType, callback);
        }
    };

    /**
     * Returns the device UUID
     * @return {string} The device UUID
     */
    CocoonJS.App.getDeviceId = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceId");
        }
    };

    /**
     * Structure that defines the getDeviceInfo returned information
     */
    CocoonJS.App.DeviceInfo = {

        /**
        * The operating system name (ios, android,...)
        * @type string
        */
        os: null,

        /**
        * The operating system version (4.2.2, 5.0,...)
        * @type string
        */
        version: null,

        /**
        * The operating system screen density in dpi
        * @type string
        */
        dpi: null,

        /**
        * The device manufacturer (apple, samsung, lg,...)
        * @type string
        */
        brand: null,

        /**
        * The device model (iPhone 4S, SAMSUNG-SGH-I997, SAMSUNG-SGH-I997R, etc)
        * @type string
        */
        model: null,

        /**
        * The phone IMEI
        * Android: The phone IMEI is returned or null if the device has not telepohny
        * iOS: null is returned as we cannot get the IMEI in iOS, no public API available for that yet.
        * @type string
        */
        imei: null,

        /**
        * The platform Id
        * Android: The ANDROID_ID is used.
        * iOS: The OpenUDID is used as there is no Android ANDROID_ID equivalent in iOS
        * @type string
        */
        platformId: null,

        /**
        * The Odin generated id https://code.google.com/p/odinmobile/
        * @type string
        */
        odin: null,

        /**
        * The OpenUDID generated Id https://github.com/ylechelle/OpenUDID
        * @type string
        */
        openudid: null
    };

    /**
     * Returns the device Info
     * @return {CocoonJS.App.DeviceInfo} The device Info
     */
    CocoonJS.App.getDeviceInfo = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceInfo");
        }
    };

    /**
     *
     * @constructor
     */
    CocoonJS.App.WebDialog = function() {

        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            this.webDialogID = window.ext.IDTK_APP.makeCall("createWebDialog");
        }
        else {
            var iframe = document.createElement("iframe");
            iframe.id = "CocoonJSWebDialogIFrame";
            iframe.name = "CocoonJSWebDialogIFrame";
            iframe.style.cssText = "position:fixed;left:0;top:0;bottom:0;right:0; width:100%; height:100%;margin:0;padding:0;";
            var me = this;
            iframe.onload = function(){
                me.iframeloaded = true;
                var js = "CocoonJS = {}; CocoonJS.WebDialog = {}; CocoonJS.WebDialog.close = function()" +
                    "{" +
                    "   window.parent.CocoonJSCloseWebDialog();" +
                    "};";
                me.evalIframe(js);
                for (var i = 0; i < me.pendingEvals.length; ++i) {
                    me.evalIframe(me.pendingEvals[i]);
                }
                me.pendingEvals = [];
            }
            iframe.onerror = function(){
                me.close();
            }
            this.iframe = iframe;
            this.pendingEvals = [];

            window.CocoonJSCloseWebDialog = function() {
               me.close();
            }
        }

    }

    CocoonJS.App.WebDialog.prototype = {

        show: function(url, callback) {
            this.closeCallback = function() {
                CocoonJS.App.enableTouchInCocoonJS();
                if (callback)
                    callback();
            }
            if (CocoonJS.App.nativeExtensionObjectAvailable) {
                CocoonJS.App.disableTouchInCocoonJS();
                return window.ext.IDTK_APP.makeCallAsync("showWebDialog", this.webDialogID, url, this.closeCallback);
            }
            else {
                this.iframe.src = url;
                document.body.appendChild(this.iframe);
            }

        },
        close: function() {
            if (CocoonJS.App.nativeExtensionObjectAvailable) {
                return window.ext.IDTK_APP.makeCallAsync("closeWebDialog", this.webDialogID);
            }
            else {
                if (this.iframe.parentNode) {
                    this.iframe.parentNode.removeChild(this.iframe);
                }
            }
            if (this.closeCallback)
                this.closeCallback();
        },
        evalIframe: function(js) {
            window.frames["CocoonJSWebDialogIFrame"].eval(js);
        },
        eval: function(js) {
            if (CocoonJS.App.nativeExtensionObjectAvailable) {
                return window.ext.IDTK_APP.makeCallAsync("evalWebDialog", this.webDialogID, js);
            }
            else {
                if (this.iframeloaded)
                    this.evalIframe(js);
                else
                    this.pendingEvals.push(js);
            }
        }

    };


    /**
    * Retrieves the preferred orientation that has been set in the system.
    * @return {number} The preferred orientation in the system as a combination of the possible {@link CocoonJS.App.Orientations}
    */
    CocoonJS.App.getPreferredOrientation = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getPreferredOrientation");
        }
        else {
            return 0;
        }
    };

    /**
    * Sets the preferred orientation in the system.
    * @param {number} preferredOrientation The preferred orientation to be set. A combinatio of the possible {@link CocoonJS.App.Orientations}
    */
    CocoonJS.App.setPreferredOrientation = function(preferredOrientation) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("setPreferredOrientation", preferredOrientation);
        }
    }

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function's documentation is represented by {@link CocoonJS.App.OnTextDialogFinishedListener}
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogFinished = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogfinish");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogCancelled = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogcancel");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxConfirmed = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxconfirmed");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxDenied = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxdenied");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspended.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspended = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspended");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is activated.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onActivated = new CocoonJS.EventHandler("IDTK_APP", "App", "onactivated");

})();
;(function()
{
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewSucceed} event calls.
     * @name OnLoadInTheWebViewSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInTheWebViewSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewFailed} event calls.
     * @name OnLoadInTheWebViewFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInTheWebViewFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");

    function checkEmulatedWebViewReady() {
        var emulatedWB = CocoonJS.App.EmulatedWebView;
        if (emulatedWB) {
            return; //ready
        }

        emulatedWB = document.createElement('div'); 
        emulatedWB.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewDiv'); 
        emulatedWB.style.width = 0; 
        emulatedWB.style.height = 0; 
        emulatedWB.style.position = "absolute"; 
        emulatedWB.style.left = 0; 
        emulatedWB.style.top = 0;
        emulatedWB.style.backgroundColor = 'transparent';
        emulatedWB.style.border = "0px solid #000"; 

        var frame = document.createElement("IFRAME");
        frame.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
        frame.setAttribute('name', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
        frame.style.width = 0; 
        frame.style.height = 0; 
        frame.frameBorder = 0;
        frame.allowtransparency = true;

        emulatedWB.appendChild(frame);
        CocoonJS.App.EmulatedWebView = emulatedWB;
        CocoonJS.App.EmulatedWebViewIFrame = frame;

        if(!document.body) {
            document.body = document.createElement("body");
        }
        document.body.appendChild(CocoonJS.App.EmulatedWebView);
    }

    /**
    * Pauses the CocoonJS JavaScript execution loop.
    * @function
    * @augments CocoonJS.App
    */
    CocoonJS.App.pause = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "pause", arguments);
        }
    };

    /**
    * Resumes the CocoonJS JavaScript execution loop.
    * @static
    * @function
    */
    CocoonJS.App.resume = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "resume", arguments);
        }
    };

    /**
    * Loads a resource in the WebView environment from the CocoonJS environment.
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    * @see CocoonJS.App.onLoadInTheWebViewSucceed
    * @see CocoonJS.App.onLoadInTheWebViewFailed
    */
    CocoonJS.App.loadInTheWebView = function(path, storageType)
    {
        if (navigator.isCocoonJS && CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadInTheWebView", arguments)
        }
        else
        {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function(event) {
                if (xhr.readyState === 4)
                {
                    if (xhr.status === 200)
                    {

                        checkEmulatedWebViewReady();
                        var callback= function(event){
                            CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners(path);
                            CocoonJS.App.EmulatedWebViewIFrame.removeEventListener("load", callback);
                        };

                        CocoonJS.App.EmulatedWebViewIFrame.addEventListener(
                            "load", 
                            callback
                        );
                        CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.href= path;
                    }
                    else if (xhr.status === 404)
                    {
                        this.onreadystatechange = null;
                        CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners(path);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the WebView context.
     * @function
     */
    CocoonJS.App.reloadWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable && navigator.isCocoonJS)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reloadWebView", arguments);
        }
        else
        {
            checkEmulatedWebViewReady();
            CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.reload();
        }
    };

    /**
    * Shows the webview.
    * @function
    * @param {int} x The top lef x coordinate of the rectangle where the webview will be shown.
    * @param {int} y The top lef y coordinate of the rectangle where the webview will be shown.
    * @param {width} y The width of the rectangle where the webview will be shown.
    * @param {height} y The height of the rectangle where the webview will be shown.
    */
    CocoonJS.App.showTheWebView = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable && navigator.isCocoonJS)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTheWebView", arguments)
        }
        else
        {
            checkEmulatedWebViewReady();
            CocoonJS.App.EmulatedWebViewIFrame.style.width = (width ? width/window.devicePixelRatio : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebViewIFrame.style.height = (height ? height/window.devicePixelRatio : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.left = (x ? x : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.top = (y ? y : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.width = (width ? width/window.devicePixelRatio : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebView.style.height = (height ? height/window.devicePixelRatio : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.display = "block";

            console.log(CocoonJS.App.EmulatedWebViewIFrame.style.cssText);
        }
    };

    /**
    * Hides the webview.
    * @function
    */
    CocoonJS.App.hideTheWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('hide');";
            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            checkEmulatedWebViewReady();
            CocoonJS.App.EmulatedWebView.style.display = "none";
        }
    };

    /**
    * Marks a audio file to be used as music by the system. CocoonJS, internally, differentiates among music files and sound files.
    * Music files are usually bigger in size and longer in duration that sound files. There can only be just one music file 
    * playing at a specific given time. The developer can mark as many files as he/she wants to be treated as music. When the corresponding
    * HTML5 audio object is used, the system will automatically know how to treat the audio resource as music or as sound.
    * Note that it is not mandatory to use this function. The system automatically tries to identify if a file is suitable to be treated as music
    * or as sound by checking file size and duration thresholds. It is recommended, though, that the developer specifies him/herself what he/she considers
    * to be music.
    * @function
    * @param {string} audioFilePath The same audio file path that will be used to create HTML5 audio objects.
    */
    CocoonJS.App.markAsMusic = function(audioFilePath)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "addForceMusic", arguments);
        }
    };

    /**
    * Activates or deactivates the antialas functionality from the CocoonJS rendering.
    * @function
    * @param {boolean} enable A flag that indicates if the antialas should be activated (true) or deactivated (false).
    */
    CocoonJS.App.setAntialias = function(enable)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultAntialias", arguments);
        }
    };

    /**
    * Sets a callback function that will be called whenever the system tries to finish the app.
    * The developer can specify how the system will react to the finish of the app by returning a
    * boolean value in the callback function: true means, close the app, false means that the developer
    * will handle the app close.
    * A common example of this is the back button in Android devices. When the back button is pressed, this
    * callback will be called and the system will react depending on the developers choice finishing, or not,
    * the application.
    * @function
    * @param {function} appShouldFinishCallback A function object that will be called when the system
    * determines that the app should be finished. This function must return a true or a false value
    * depending on what the developer wants: true === finish the app, false === do not close the app.
    */
    CocoonJS.App.setAppShouldFinishCallback = function(appShouldFinishCallback)
    {
        if (navigator.isCocoonJS)
        {
            window.onidtkappfinish = appShouldFinishCallback;
        }
    }

    /**
    * Sets the texture reduction options. The texture reduction is a process that allows big images to be reduced/scaled down when they are loaded.
    * Although the quality of the images may decrease, it can be very useful in low end devices or those with limited amount of memory.
    * The function sets the threshold on image size (width or height) that will be used in order to know if an image should be reduced or not.
    * It also allows to specify a list of strings to identify in which images file paths should be applied (when they meet the size threshold requirement) 
    * The developer will still think that the image is of the original size. CocoonJS handles all of the internals to be able to show the image correctly.
    * IMPORTANT NOTE: This function should be called when the application is initialized before any image is set to be loaded for obvious reasons ;).
    * and in which sould be forbid (even if they meet the threshold requirement).
    * @function
    * @param {number} sizeThreshold This parameter specifies the minimun size (either width or height) that an image should have in order to be reduced.
    * @param {string or array} [applyTo] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it will be reduced. This parameter can also be null.
    * @param {string or array} [forbidFor] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it won't be reduced. This parameter should be used in order to mantain the 
    * quality of some images even they meet the size threshold requirement.
    */
    CocoonJS.App.setTextureReduction = function(sizeThreshold, applyTo, forbidFor)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultTextureReducerThreshold", arguments);
        }
    };


    /**
    * Prints to the console the memory usage of the currently alive textures
    * @function
    */
    CocoonJS.App.logMemoryInfo = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "logMemoryInfo", arguments);
        }
    };

    /**
    * Enable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.enableFPSInTheWebView = function(fpsLayout, textColor)
    {
        if (!CocoonJS.App.fpsInTheWebViewEnabled)
        {
            fpsLayout = fpsLayout ? fpsLayout : CocoonJS.App.FPSLayout.TOP_RIGHT;
            textColor = textColor ? textColor : "white";
            var jsCode = "" +
                "(function()" +
                "{" +
                    "var COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES = ['js/CocoonJSExtensions/CocoonJS.js', 'js/CocoonJSExtensions/CocoonJS_App.js', 'js/CocoonJSExtensions/CocoonJS_App_ForWebView.js'];" +
                    "var loadedScriptCounter = 0;" + 
                    "var loadedScriptFunction = function() " +
                    "{ " +
                        "loadedScriptCounter++;"+
                        "if (loadedScriptCounter >= COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length)"+
                        "{"+
                            "CocoonJS.App.enableFPS(" + JSON.stringify(fpsLayout) + ", " + JSON.stringify(textColor) + ");"+
                        "}"+
                    "};"+
                    "for (var i = 0; i < COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length; i++)"+
                    "{"+
                        "var s = document.createElement('script');"+
                        "s.onload = loadedScriptFunction;"+
                        "s.src = COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES[i];"+
                        "document.body.appendChild(s);"+
                    "}" +
                "})();";
            setTimeout(function()
            {
                CocoonJS.App.forward(jsCode);
            }, 3000);
            CocoonJS.App.fpsInTheWebViewEnabled = true;
        }
    };

    /**
    * Disable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.disableFPSInTheWebView = function()
    {
        // TODO: Implement this function.
    };

    
})();
;(function(){
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");
    if (navigator.isCocoonJS) return;

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.App.nativeExtensionObjectAvailable;

    /**
    * Shows a transparent WebView on top of the CocoonJS hardware accelerated environment rendering context.
    * @function
    * @param {number} [x] The horizontal position where to show the WebView.
    * @param {number} [y] The vertical position where to show the WebView.
    * @param {number} [width] The horitonzal size of the WebView.
    * @param {number} [height] the vertical size of the WebView.
    */
    CocoonJS.App.show = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "show", arguments);
        }
        else
        {
            var div = window.parent.document.getElementById('CocoonJS_App_ForCocoonJS_WebViewDiv');
            div.style.left = (x ? x : div.style.left)+'px';
            div.style.top = (y ? y : div.style.top)+'px';
            div.style.width = (width ? width/window.devicePixelRatio : window.parent.innerWidth)+'px';
            div.style.height = (height ? height/window.devicePixelRatio : window.parent.innerHeight)+'px';
            div.style.display = "block";
            var iframe = window.parent.document.getElementById('CocoonJS_App_ForCocoonJS_WebViewIFrame');
            iframe.style.width = (width ? width/window.devicePixelRatio : window.parent.innerWidth)+'px';
            iframe.style.height = (height ? height/window.devicePixelRatio : window.parent.innerHeight)+'px';
        }
    };

    /**
    * Hides the transparent WebView on top of the CocoonJS hardware acceleration environment rendering contect.
    * @function
    */
    CocoonJS.App.hide = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "hide", arguments);
        }
        else
        {
            window.parent.document.getElementById('CocoonJS_App_ForCocoonJS_WebViewDiv').style.display = "none";
        }
    };

    /**
    * Loads a resource in the CocoonJS environment from the CocoonJS environment. 
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    */
    CocoonJS.App.loadInCocoonJS = function(path, storageType)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('loadPath'";
            if (typeof path !== 'undefined')
            {
                javaScriptCodeToForward += ", '" + path + "'";
                if (typeof storageType !== 'undefined')
                {
                    javaScriptCodeToForward += ", '" + storageType + "'";
                }
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else
        {
            CocoonJS.App.forwardAsync("CocoonJS.App.load('" + path + "');");
        }
    };

    /**
     * Reloads the last loaded path in the CocoonJS context.
     * @function
     */
    CocoonJS.App.reloadCocoonJS = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.App.forwardAsync("ext.IDTK_APP.makeCall('reload');");
        }
        else if (!navigator.isCocoonJS)
        {
            window.parent.location.reload();
        }
    };

    /**
    * This function allows to forward console messages from the WebView to the CocoonJS
    * debug console. What it does is to change the console object for a new one
    * with all it's methods (log, error, info, debug and warn) forwarding their
    * messages to the CocoonJS environment.
    * The original console object is stored in the CocoonJS.App.originalConsole property.
    * @function
    */
    CocoonJS.App.proxifyConsole = function() 
    {
        if (!CocoonJS.nativeExtensionObjectAvailable) return;

        if (typeof CocoonJS.App.originalConsole === 'undefined')
        {
            CocoonJS.App.originalConsole = window.console;
        }
        var functions = ["log", "error", "info", "debug", "warn"];

        var newConsole = {};
        for (var i = 0; i < functions.length; i++)
        {
            newConsole[functions[i]] = function(functionName)
            {
                return function(message)
                {
                    var jsCode = "console." + functionName + "(" + JSON.stringify(message) + ");";
                    CocoonJS.App.originalConsole.log(jsCode);
                    ext.IDTK_APP.makeCallAsync("forward", jsCode);
                };
            }(functions[i]);
        }
        if (!newConsole.assert) {
            newConsole.assert = function assert() {
                if (arguments.length > 0 && !arguments[0]) {
                    var str = 'Assertion failed: ' + (arguments.length > 1 ? arguments[1] : '');
                    newConsole.error(str);
                }
            }
        }        
        window.console = newConsole;
    };

    /**
    * This function restores the original console object and removes the proxified console object.
    * @function
    */
    CocoonJS.App.deproxifyConsole = function()
    {
        if (window.navigator.isCocoonJS || !CocoonJS.nativeExtensionObjectAvailable) return;
        if (typeof CocoonJS.App.originalConsole !== 'undefined')
        {
            window.console = CocoonJS.App.originalConsole;
            CocoonJS.App.originalConsole = undefined;
        }
    };

    /**
    * Everytime the page is loaded, proxify the console.
    * @ignore
    */
    window.addEventListener("load", function()
    {
        CocoonJS.App.proxifyConsole();
    });

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInCocoonJSSucceed} event calls.
     * @name OnLoadInCocoonJSSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in CocoonJS.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the CocoonJS load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInCocoonJSSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInCocoonJSSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInCocoonJSFailed} event calls.
     * @name OnLoadInCocoonJSFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in CocoonJS.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the CocoonJS load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInCocoonJSFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInCocoonJSFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Advertisement extension API.
    * @namespace
    */
    CocoonJS.Ad = {};

    CocoonJS.Ad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_AD !== 'undefined';

    /**
    * The predefined possible layouts for a banner ad.
    * @namespace 
    */
	CocoonJS.Ad.BannerLayout = 
	{
		/**
		* Specifies that the banner must be shown in the top of the screen and vertically centered.
		*/
	    TOP_CENTER      : "TOP_CENTER",

		/**
		* Specifies that the banner must be shown in the bottom of the screen and vertically centered.
		*/
	    BOTTOM_CENTER   : "BOTTOM_CENTER"
	};

	/**
    * A rectangle object that contains the banner dimensions
    * @namespace 
    * @constructor
    * @param {int} x The top lef x coordinate of the rectangle.
    * @param {int} y The top lef y coordinate of the rectangle.
    * @param {width} y The rectangle width.
    * @param {height} y The rectangle height.
    */
	CocoonJS.Ad.Rectangle = function(x, y, width, height) 
	{
		/**
		* The top lef x coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.x = x;

		/**
		* The top lef y coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.y = y;

	    /**
		* The rectangle width
		* @field 
		* @type {int}
		*/
	    this.width = width;

	    /**
		* The rectangle height
		* @field 
		* @type {int}
		*/
	    this.height = height;
	};

	CocoonJS.Ad.Banner = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
    	* The callback function does not receive any parameter.
    	* @param {number} width The banner width
    	* @param {number} height The banner height
    	* @static
    	* @event
    	*/
		this.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener(args[1], args[2]);
    		}
    	});
	};

	CocoonJS.Ad.Banner.prototype = {

		/**
		* Shows a banner ad if available.
		* @function
		*/
		showBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", [this.id], true);
			}
		},

		/**
		* Hides the banner ad if it was being shown.
		* @function
		*/
		hideBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", [this.id], true);
			}
		},

		/**
		* Refreshes the banner.
		* @function
		*/
		refreshBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", [this.id], true);
			}
		},

		/**
		* Gets the rectangle representing the banner screen position.
		* @function
		* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
		*/
		getRectangle : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", [this.id]);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* @function
		* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
		*/
		setRectangle : function(rect)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", [this.id, rect],true);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* You can use this method if you want to have better control of the banner screen positioning.
		* @function
		* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
		*/
		setBannerLayout : function(bannerLayout)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", [this.id, bannerLayout],true);
			}
		}
	};

	CocoonJS.Ad.Fullscreen = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
		this.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

    	/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});
	};

	CocoonJS.Ad.Fullscreen.prototype = {

		/**
		* Shows a full screen ad if available.
		* @function
		* @see CocoonJS.Ad.onFullScreenShown
		* @see CocoonJS.Ad.onFullScreenHidden
		*/
		showFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", [this.id], true);
			}
		},

		/**
		* Refreshes the fullscreen.
		* @function
		*/
		refreshFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", [this.id], true);
			}
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Ad.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "requestInitialization", arguments, true);
		}
	};

	/**
	* Creates a new banner ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createBanner = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createBanner", [parameters]);
			var banner = new CocoonJS.Ad.Banner(adId);

			return banner;
		}
	};

	/**
	* Releases a banner.
	* @function
	* @param {object} The banner ad object to be released.
	*/
	CocoonJS.Ad.releaseBanner = function(banner)
	{
		if (typeof banner === "undefined") {
            throw "The banner ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseBanner", [banner.id]);
		}
	};

	/**
	* Creates a new fullscreen ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createFullscreen = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createFullscreen", [parameters]);
			var fullscreen = new CocoonJS.Ad.Fullscreen(adId);

			return fullscreen;
		}
	};

	/**
	* Releases a fullscreen ad.
	* @function
	* @param {object} The fullscreen ad object to be released.
	*/
	CocoonJS.Ad.releaseFullscreen = function(fullscreen)
	{
		if (typeof fullscreen === "undefined") {
            throw "The fullscreen ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseFullscreen", [fullscreen.id]);
		}
	};

	/**
	* Shows a banner ad if available.
	* @function
	* @see CocoonJS.Ad.setBannerLayout
	* @see CocoonJS.Ad.onBannerShown
	*/
	CocoonJS.Ad.showBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", arguments, true);
		}
	};

	/**
	* Hides the banner ad if it was being shown.
	* @function
	*/
	CocoonJS.Ad.hideBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", arguments, true);
		}
	};

	/**
	* Refreshes the banner.
	* @function
	*/
	CocoonJS.Ad.refreshBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", arguments, true);
		}
	};

	/**
	* Shows a full screen ad if available.
	* @function
	* @see CocoonJS.Ad.onFullScreenShown
	* @see CocoonJS.Ad.onFullScreenHidden
	*/
	CocoonJS.Ad.showFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", arguments, true);
		}
	};

	/**
	* Refreshes the fullscreen.
	* @function
	*/
	CocoonJS.Ad.refreshFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", arguments, true);
		}
	};

	/**
	* Makes a request to preload a banner ad.
	* @function
	*/
	CocoonJS.Ad.preloadBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadBanner", arguments, true);
		}
	};

	/**
	* Makes a request to preload a full screen ad.
	* @function
	*/
	CocoonJS.Ad.preloadFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadFullScreen", arguments, true);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* @function
	* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.setRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", arguments, true);
		}
	};

	/**
	* Gets the rectangle representing the banner screen position.
	* @function
	* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.getRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", arguments);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* You can use this method if you want to have better control of the banner screen positioning.
	* @function
	* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
	*/
	CocoonJS.Ad.setBannerLayout = function(bannerLayout)
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", arguments, true);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide"); 

	/**
	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
	* The callback function does not receive any parameter.
	* @param {number} width The banner width
	* @param {number} height The banner height
	* @static
	* @event
	*/
	CocoonJS.Ad.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready"); 

})();;(function() {

    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * @namespace
     */
    CocoonJS.Social = {};

    /**
     * This class provides an abstraction API for all the Social Services
     * Each Social service has it's own official API but can also be used within this API interface
     * @class
     */
    CocoonJS.Social.SocialService = function() {
        /**
         * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login status changes
         * The callback parameters: loggedIn status (boolean) and error
         * @memberOf CocoonJS.Social.SocialService
         */
        this.onLoginStatusChanged = new CocoonJS.EventHandler("", "dummy", "onLoginStatusChanged");

        return this;
    }

    CocoonJS.Social.SocialService.prototype = {

        /**
         * Check if the user is logged in.
         * @return {boolean} true if the user is still logged in, false otherwise.
         */
        isLoggedIn: function() {
             return false;
        },

        /**
         * Authenticate the user
         * @param {function} callback. The callback function. Response params: loggedIn(boolean) and error
         */
        login : function(callback) {
            if (callback)
                callback(false, {message:"Not implemented!"});
        },

        /**
         * Log the user out of your application.
         * @param {function} [callback] The callback function. Response params: error
         */
        logout: function(callback) {
            if (callback)
                callback({message:"Not implemented!"});
        },

        /**
         * Returns the information of the currently logged in user.
         * @return {@link CocoonJS.Social.User}
         */
        getLoggedInUser : function() {
            return null;
        },

        /**
         * Checks if the current logged in user has publish permissions
         * @param callback The callback function. Response params: permissions granted and error
         */
        hasPublishPermissions: function(callback) {
            callback(true);
        },

        /**
         * Requests publish permissions for the current logged in user
         * @param callback The callback function. Response params: granted and error
         */
        requestPublishPermissions: function(callback) {
            if (callback)
                callback(true, null);
        },
        /**
         * Retrieves user information for a specific user ID.
         * @param {function} callback The callback function. Response params: {@link CocoonJS.Social.User} and error.
         * @param {string} [userID] The id of the user to retrieve the information from. If no userID is specified, the currently logged in user is assumed.
         */
        requestUser: function(callback, userID) {
            callback(null, {message:"Not implemented!"});
        },
        /**
         * Request to retrieve the profile image of a user
         * @param {function} callback The callback function. Response params: ImageURL and error.
         * @param {string} [userID] The id of the user to get the image for. If no userID is specified, the currently logged user is used.
         * @param {CocoonJS.Social.ImageSize} [imageSize] The desired size of the image. Default value: SMALL.
         */
        requestUserImage : function(callback, userID, imageSize) {
            callback("", {message:"Not implemented!"})
        },

        /**
         * Retrieves user friends for a specific user ID.
         * @param {function} callback The callback function. Response params: Array of {@link CocoonJS.Social.User} and error.
         * @param {string} [userID] The id of the user to retrieve the information from. If no userID is specified, the currently logged in user is assumed.
         */
        requestFriends: function(callback, userID) {
            callback([], {message:"Not implemented!"});
        },

        /**
         * Shares a message without the intervention of the user
         * This action might require publish permissions. If the user has not publish permissions they are automatically requested.
         * @param {CocoonJS.Social.Message} message A object representing the information to be published.
         * @param {function} [callback] The callback function. Response params: error
         */
        publishMessage: function(message, callback) {
            callback({message:"Not implemented!"});
        },

        /**
         * Presents a native/web dialog that allows the user to share a message
         * @param {CocoonJS.Social.Message} message A object representing the information to be published.
         * @param {function} [callback] The callback function. Response params: error
         */
        publishMessageWithDialog: function(message, callback) {
            callback({message:"Not implemented!"});
        }
    }


    /**
     * This class extends the Social Service API with an extended Social Gaming abstraction API (achievements, leaderboards, etc.)
     * @class
     */
    CocoonJS.Social.SocialGamingService = function() {
        CocoonJS.Social.SocialGamingService.superclass.constructor.call(this);
        return this;
    }

    CocoonJS.Social.SocialGamingService.prototype = {

        _cachedAchievements: null,
        _achievementsMap: null,
        _leaderboardsTemplate: null,
        _achievementsTemplate: null,

        /**
         * Retrieves the score for a user from a specific leaderboard
         * @param {function} callback The callback function. Response params: {@link CocoonJS.Social.Score} and error.
         * @param {CocoonJS.Social.ScoreParams} [params] The params to retrieve the score. If no params are specified, the currently logged in user and the default leaderboard are assumed.
         */
        requestScore: function(callback, params) {
            callback(null, {message:"Not implemented!"})
        },

        /**
         * Submits the score for a user to a specific leaderboard
         * @param {number} score the score to submit
         * @param {function} [callback] The callback function. Response params: error.
         * @param {CocoonJS.Social.ScoreParams} [params] The params to submit the score. If no params are specified, the currently logged in user and the default leaderboard are assumed.
         */
        submitScore: function(score, callback, params ) {
            if (callback)
                callback({message:"Not implemented!"})
        },

        /**
         * Shows a modal leaderboard view using a platform dependant view.
         * @param {CocoonJS.Social.ScoreParams} [params] The params to choose the leaderboard and other settings. If no params are specified the default leaderboard id and settings will be assumed.
         * @param {function} [callback] The callback function invoked when the modal leaderboard view is closed by the user. Response params: error.
         * @see setTemplates
         */
        showLeaderboard : function(callback, params) {
            if (callback)
                callback({message:"Not implemented!"})
        },

        /**
         * Retrieves all the achievements of the application.
         * @param {function} callback The callback function. Response params: array of {@link CocoonJS.Social.Achievement} and error.
         */
        requestAllAchievements : function(callback) {
            callback([], {message:"Not implemented!"})
        },

        /**
         * Retrieves the achievements earned by a user.
         * @param {function} callback The callback function. Response params: array of {@link CocoonJS.Social.Achievement} and error.
         * @param {string} [userId] The id of the user to retrieve the information from. If no userID is specified, the currently logged in user is assumed.
         */
        requestAchievements : function(callback, userID) {
            callback([], {message:"Not implemented!"})
        },
        /**
         * Submits the achievement for the current logged In user
         * @param achievementID The achievement ID to submit
         * @param callback [callback] The callback function. Response params: error.
         */
        submitAchievement: function(achievementID, callback) {
            if (callback)
                callback({message:"Not implemented!"})
        },
        /**
         * Resets all the achievements of the current logged in user
         * @param {function} [callback] The callback function. Response params: error.
         */
        resetAchievements : function(callback) {
            if (callback)
                callback([], {message:"Not implemented!"})
        },
        /**
         * Shows a modal achievements view using a platform dependant view.
         * @param {function} [callback] The callback function invoked when the modal achievements view is closed by the user. Response params: error.
         * @see setTemplates
         */
        showAchievements : function(callback) {
            if (!this._achievementsTemplate)
                throw "Please, provide a html template for achievements with the setTemplates method";
            var dialog = new CocoonJS.App.WebDialog();
            var callbackSent = false;
            dialog.show(this._achievementsTemplate, function(error) {
                dialog.closed = true;
                if (!callbackSent && callback)
                    callback(error);
            });
            var me = this;
            this.requestAchievements(function(achievements, error){
                if (dialog.closed)
                    return;
                if (error) {
                    callbackSent = true;
                    if (callback)
                        callback(error);
                    return;
                }

                var achs = [];
                if (me._cachedAchievements) {
                    for (var i = 0; i < me._cachedAchievements.length; ++i) {
                        var ach = me._cachedAchievements[i];
                        achs.push(ach);
                        if (achievements && achievements.length) {
                            for (var j = 0; j< achievements.length; ++j) {
                                if (achievements[j].achievementID === ach.achievementID) {
                                    ach.achieved = true;
                                    break;
                                }
                            }
                        }
                    }
                }
                var js = "addAchievements(" + JSON.stringify(achs) + ");";
                dialog.eval(js);
            });
        },

        /**
         * Set the map for using custom achievement IDs.
         * The map must be a customID to realID map (accessing map.customID must return the real achievement ID)
         * Whenever this map is enabled users are able to submit achievements with the real achievement ID or with the custom one.
         * @params {object} map The achievements map. A null map disables this feature.
         */
        setAchievementsMap: function(map) {
            this._achievementsMap = map;
            if (this._cachedAchievements) {
               this.syncAchievementsMap(this._cachedAchievements);
            }
        },

        /**
         * Provides some templates to be used in the leaderboards and achievements views
         * Some social services (like Facebook) don't have a native view to show achievements or leaderboards views, and use html templates instead
         * @param {string} leaderboardsTemplate relative path to the leaderboards template
         * @param {string} achievementsTemplate relative path to the achievements template
         * @see showAchievements
         * @see showLeaderboard
         */
        setTemplates: function(leaderboardsTemplate, achievementsTemplate) {
            this._leaderboardsTemplate = leaderboardsTemplate;
            this._achievementsTemplate = achievementsTemplate;
        },

        //Internal utility methods

        /**
         * @ignore
         */
        setCachedAchievements: function(achievements) {
            this._cachedAchievements = achievements;
            if (achievements && this._achievementsMap) {
                this.syncAchievementsMap(this._cachedAchievements);
            }
        },

        /**
         * @ignore
         */
        findAchievement: function(id) {
            if (!this._cachedAchievements)
                return null;
            for (var i = 0; i < this._cachedAchievements.length; ++i) {
                if (id === this._cachedAchievements[i].achievementID) {
                    return this._cachedAchievements[i];
                }
            }
            return null;
        },

        /**
         * @ignore
         */
        translateAchievementID: function(id) {
            if (this._achievementsMap) {
                for (var customID in this._achievementsMap) {
                    if (customID == id) { //important: compare with double equal, because id can be numeric
                        return this._achievementsMap[customID];
                    }
                }
            }
            return id;
        },
        /**
         * @ignore
         * @param {array} achievements array of achievements
         */
        syncAchievementsMap: function(achievements) {
            if (!this._achievementsMap)
                return;
            for (var i = 0; i< achievements.length; ++i) {
                for (var customID in this._achievementsMap) {
                     if (this._achievementsMap[customID] === achievements[i].achievementID) {
                         achievements[i].customID = customID;
                     }
                }
            }

        }
    }

    /**
     * @ignore
     */
    CocoonJS.extend(CocoonJS.Social.SocialGamingService, CocoonJS.Social.SocialService);


    /**
     * This enumeration represents the possible images to be obtained for a user in the social gaming extension.
     * @namespace
     * @enum
     */
    CocoonJS.Social.ImageSize =
    {
        /**
         * Represent a thumbnail like image size.
         */
        THUMB : "thumb",
        /**
         * Represents the small image size.
         */
        SMALL : "small",
        /**
         * Represents the medium image size.
         */
        MEDIUM : "medium",
        /**
         * Represents the large image size.
         */
        LARGE : "large"
    };


    /**
     * The data structure that represents the information of a user inside the social gaming extension.
     * @class
     * @constructor
     * @param {string} userID The id of the user.
     * @param {string} userName The user name of the user.
     */
    CocoonJS.Social.User = function(userID, userName, userImage)
    {
        /**
         * The id of the user.
         * @field
         * @type string
         */
        this.userID = userID;
        /**
         * The user name of the user.
         * @field
         * @type string
         */
        this.userName = userName;

        /**
         * The user image URL
         * If the image URL is not provided by default fetch it using requestUserImage method.
         * @field
         * @type {string}
         */
        this.userImage = userImage;

        return this;
    };

    /**
     * This type represents a message to be published.
     * @class
     * @constructor
     * @param {string} message The message to be published.
     * @param {string} mediaURL An URL to a media (image, video, ...)
     * @param {string} linkURL An URL to add to the message so the user can click on that link to get more information.
     * @param {string} linkText The text that will appear in the message link.
     * @param {string} linkCaption The text caption that will appear in the message link.
     */
    CocoonJS.Social.Message = function(message, mediaURL, linkURL, linkText, linkCaption)
    {
        /**
         * The message to be published.
         * @field
         * @type string
         */
        this.message = message;
        /**
         * An URL to a media (image, video, ...)
         * @field
         * @type string
         */
        this.mediaURL = mediaURL;
        /**
         * An URL to add to the message so the user can click on that link to get more information.
         * @field
         * @type string
         */
        this.linkURL = linkURL;
        /**
         * The text that will appear in the message link.
         * @field
         * @type string
         */
        this.linkText = linkText;
        /**
         * The text caption that will appear in the message link.
         * @field
         * @type string
         */
        this.linkCaption = linkCaption;

        return this;
    };


    /**
     * The data structure that represents the information of the user score in the application.
     * @class
     * @constructor
     * @param {string} userID The user id.
     * @param {number} score The score of the user.
     * @param {string} userName The name of the user.
     * @param {string} imageURL The url of the user image.
     * @param {number} leaderboardID The id of the leaderboard the score belongs to.
     */
    CocoonJS.Social.Score = function(userID, score, userName, imageURL, leaderboardID)
    {
        /**
         * The user id.
         * @type string
         */
        this.userID = userID;
        /**
         * The score of the user.
         * @type number
         */
        this.score = score || 0;
        /**
         * The name of the user.
         * @type string
         */
        this.userName = userName;
        /**
         * The url of the user image.
         * @type string
         */
        this.imageURL = imageURL;
        /**
         * The id of the leaderboard the score belongs to.
         * @type string
         */
        this.leaderboardID = leaderboardID;

        return this;
    };

    /**
     * The data structure that represents params to retrieve or submit scores
     * @class
     * @constructor
     * @param {string} userID The user id. If no userID is specified the current logged in user is assumed.
     * @param {string} leaderboardID The leaderboard ID. If no leaderboard is specified the default leaderboard is assumed.
     * @param {boolean} [friendScope = false] If enabled the query will get only scores from friends in the social network
     * @param {CocoonJS.Social.TimeScope} [timeScope=0] The time scope for the scores.
     */
    CocoonJS.Social.ScoreParams = function(userID, leaderboardID, friends, timeScope) {
        /**
         * The user id.
         * @type string
         */
        this.userID = userID;
        /**
         * The id of the leaderboard.
         * @type string
         */
        this.leaderboardID = leaderboardID;

        /**
         * Friends scope
         * @type {boolean}
         */
        this.friends = !!friends;

        /**
         * The time scope
         * @type {number}
         */
        this.timeScope = timeScope || 2;
    }

    /**
     * @enum
     * This enumeration represents the possible Time Scopes for a leaderboad query.
     */
    CocoonJS.Social.TimeScope =
    {
        ALL_TIME: 0,
        WEEK: 1,
        TODAY:2
    };

    /**
     * The data structure that represents the information of an achievement in the application.
     * @class
     * @constructor
     * @param {string} achievementID The id of the achievement info.
     * @param {string} title The title of the achievement.
     * @param {string} description The description of the achievement.
     * @param {string} imageURL The url to the image representing the achievement.
     * @param {number} points The points value of the achievement
     */
    CocoonJS.Social.Achievement = function(achievementID, title, description, imageURL, points)
    {
        /**
         * The id of the achievement.
         * @type string
         */
        this.achievementID = achievementID;
        /**
         * The optional custom id of the achievement defined by the user.
         * @type string
         */
        this.customID = achievementID;
        /**
         * The title of the achievement.
         * @type string
         */
        this.title = title;
        /**
         * The description of the achievement.
         * @type string
         */
        this.description = description;
        /**
         * The url to the image representing the achievement.
         * @type string
         */
        this.imageURL = imageURL;
        /**
         * The points value of the achievement
         * @type number
         */
        this.points = points || 0;

        return this;
    };

})();(function(){

    // The CocoonJS and CocoonJS.Social must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating the extension types.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS.Social === null) throw("The CocoonJS.Social object must exist and be valid before creating the extension types.");

    /**
     * @class
     * @constructor
     * Represents a type that mimics the original GameCenter API (somehow ;)) with the addition of the possibility to 
     * retrieve an abstract high level interface API to handle a SocialGamingService (APIs defined by Ludei) and multiplayer support.
     */
    CocoonJS.Social.GameCenterExtension = function() {
        this.nativeExtensionName = "IDTK_SRV_GAMECENTER";
        this.extensionName = "Social.GameCenter";
        this.nativeExtensionObjectAvailable =  CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[this.nativeExtensionName] !== 'undefined';

        var me = this;
        if (this.nativeExtensionObjectAvailable) {
            this.onGameCenterLoginStateChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onGameCenterLoginStateChanged");

            this.onGameCenterLoginStateChanged.addEventListener(function(localPlayer,error){
                me._currentPlayer = localPlayer;
            });
        }
        return this;
    };

    CocoonJS.Social.GameCenterExtension.prototype = {

        _currentPlayer: null,

        /**
         * Return a CocoonJS SocialGaming interface for the Game Center Extension
         * You can use the Game Center extension in two ways, with 1:1 official API equivalent or with the CocoonJS Social API abstraction
         * @see CocoonJS.Social.SocialGamingService
         * @returns {CocoonJS.Social.SocialGamingService}
         */
        getSocialInterface: function() {
            if (!this._socialService) {
                this._socialService = new CocoonJS.Social.SocialGamingServiceGameCenter(this);
            }
            return this._socialService;
        },

        /**
         * Return a CocoonJS Multiplayer interface for the Game Center Extension
         * @returns {CocoonJS.Multiplayer.MultiplayerService}
         */
        getMultiplayerInterface: function() {
            return CocoonJS.Multiplayer.GameCenter;
        },

        isLoggedIn: function() {
            return this._currentPlayer && this._currentPlayer.isAuthenticated;
        },

        /**
         * Authenticate the user
         * @params {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.LocalPlayer and error.
         */
        login: function(callback) {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "login", [function(response, error) {
                    me._currentPlayer = response;
                    if (callback) {
                        callback(response,error);
                    }
                }], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Synchronous accessor for the current authResponse
         * @returns {CocoonJS.Social.GameCenter.LocalPlayer} current Local Player data
         */
        getLocalPlayer: function() {
            if (this._currentPlayer)
                return this._currentPlayer;
            if (this.nativeExtensionObjectAvailable) {
                this._currentPlayer = CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLocalPlayer", []);
                return this._currentPlayer;
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the players for the provided identifiers.
         * @param {array} playerIDs Array of player identifiers
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Player array and error
         */
        loadPlayers: function(playerIDs, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadPlayers", [playerIDs, callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the friends for the current logged in user.
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Player array and error
         */
        loadFriends: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadFriends", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the earned achievements for the current logged in user.
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Achievements array and error
         */
        loadAchievements: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadAchievements", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the application achievement descriptions
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.AchievementDescription array and error
         */
        loadAchievementDescriptions: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadAchievementDescriptions", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the application achievement descriptions
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Leaderboard object and error
         * @param {CocoonJS.Social.GameCenter.Leaderboard} [query] Optional query parameters
         */
        loadScores: function(callback, query) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadScores", [query,callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Report user score to the server
         * @param {CocoonJS.Social.GameCenter.Score} score definition of the score and it's category (leaderboardID).
         * If no category is specified the default one is used.
         * @param {function} callback The callback function. Response params: error
         */
        submitScore: function(score, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitScore", [score,callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Report user earned achievements to the server
         * @param {array} achievements Array of CocoonJS.Social.GameCenter.Achievement objects
         * @param {function} callback The callback function. Response params: error
         */
        submitAchievements: function(achievements, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitAchievements", [achievements,callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Resets all the achievements of the current logged in user
         * @param {function} [callback] The callback function. Response params: error.
         */
        resetAchievements : function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "resetAchievements", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Shows a native view with the standard user interface for achievements
         * @param {function} callback The callback function when the view is closed by the user. Response params: error
         */
        showAchievements: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showAchievements", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Shows a native view with the standard user interface for leaderboards
         * @param {function} callback The callback function when the view is closed by the user. Response params: error
         * @param {CocoonJS.Social.GameCenter.Leaderboard} [query] Optional parameters
         */
        showLeaderboards: function(callback, query) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showLeaderboards", [query, callback], true);
            }
            else {
                throw "Game Center not available";
            }
        }
    };

    /**
     * @namespace
     * This is the global variable that enables access to the GameCenter API mimic and the high level abstract API
     * to handle Social and Multiplayer aspects created by Ludei.
     * @see CocoonJS.Social.GameCenterExtension
     */
    CocoonJS.Social.GameCenter = new CocoonJS.Social.GameCenterExtension();

    /**
     * @class
     * The data structure that represents the information of a Game Center player (Readonly)
     */
    CocoonJS.Social.GameCenter.Player = function() {
        /**
         * The identifier of the player.
         * @type string
         */
        this.playerID = "";
        /**
         * The alias of the player.
         * @type string
         */
        this.alias = "";
        /**
         * True if the user is friend of the local player
         * @type boolean
         */
        this.isFriend = false;
    }

    /**
     * @class
     * The data structure that represents the information of the Game Center Local Player (Readonly)
     */
    CocoonJS.Social.GameCenter.LocalPlayer = function() {
        /**
         * The identifier of the player.
         * @type string
         */
        this.playerID = "";
        /**
         * The alias of the player.
         * @type string
         */
        this.alias = "";
        /**
         * Indicates the authentication state of the current player
         * @type boolean
         */
        this.isAuthenticated = false;
    }

    /**
     * The data structure that represents an earned achievement by the user
     * @class
     * @constructor
     * @param {string} identifier The id of the achievement.
     * @param {number} [percentComplete] The percentage on which the achievement has been completed. 100% by default.
     */
    CocoonJS.Social.GameCenter.Achievement = function(identifier, percentComplete) {
        /**
         * The identifier of the achievement.
         * @type string
         */
        this.identifier = identifier;
        /**
         * Percentage of achievement complete (from 0 to 100)
         * @type number
         */
        this.percentComplete = percentComplete;
        /**
         *  Date the achievement was last reported (unix time)
         * @type number
         */
        this.lastReportedDate = 0;
    }

    /**
     * @class
     * The data structure that represents achievements defined by the application (Readonly)
     */
    CocoonJS.Social.GameCenter.AchievementDescription = function() {
        /**
         * The identifier of the achievement.
         * @type string
         */
        this.identifier = "";
        /**
         * The title of the achievement
         * @type string
         */
        this.title = "";
        /**
         * The description for an achieved achievement
         * @type string
         */
        this.achievedDescription = "";
        /**
         * The description for an unachieved achievement.
         * @type string
         */
        this.achievedDescription = "";

        /**
         * The maximum points of the achievement
         * @type number
         */
        this.maximumPoints = 0;
    }

    /**
     * @class
     * @constructor
     * The data structure that a score in the leaderboards
     * @param {number} value The value of the score.
     * @param {string} category The category where the score is associated.
     */
    CocoonJS.Social.GameCenter.Score = function(value,category) {
        /**
         * The score value as a 64bit integer.
         * @type number
         */
        this.value = value;
        /**
         * Leaderboard category
         * @type string
         */
        this.category = category;
        /**
         * The identifier of the player that recorded the score
         * @type string
         */
        this.playerID = "";
        /**
         * The rank of the player within the leaderboard
         * @type number
         */
        this.rank = 0;
    }

    /**
     * @class
     * @constructor
     * The data structure that represents the set of high scores for the current game
     * @param {string} category The category of the leaderboard.
     * @param {array} payerIDs
     * @param {CocoonJS.Social.GameCenter.TimeScope} timeScope
     * @param {CocoonJS.Social.GameCenter.PayerScope} payerScope
     * @param {number} rangeStart
     * @param {number} rangeLength
     */
    CocoonJS.Social.GameCenter.Leaderboard = function(category, playerIDs, timeScope, playerScope, rangeStart, rangeLength) {
        /**
         * leaderboard category (query parameter)
         * @type string
         */
        this.category = category;
        /**
         * Player identifiers array (query parameter)
         * @type string
         */
        this.playerIDs = category;
        /**
         * Time scope (query parameter)
         * @type CocoonJS.Social.GameCenter.TimeScope
         */
        this.timeScope = timeScope;
        /**
         * Player scope (query parameter)
         * @type CocoonJS.Social.GameCenter.PlayerScope
         */
        this.playerScope = playerScope;
        /**
         * Leaderboards start at index 1 and the length should be less than 100 (query parameter)
         * @type number
         */
        this.rangeStart = rangeStart;
        /**
         * Leaderboards start at index 1 and the length should be less than 100 (query parameter)
         * @type number
         */
        this.rangeLength = rangeLength;
        /**
         * Scores array (response parameter)
         * @type Array of CocoonJS.Social.GameCenter.Score
         */
        this.scores = [];
        /**
         * Local player score (response parameter)
         * @type CocoonJS.Social.GameCenter.Score
         */
        this.localPlayerScore = [];
        /**
         * Localized category title
         * @type string
         */
        this.localizedTitle = localizedTitle;
    }

    /**
     * @enum
     * This enumeration represents the possible Time Scopes for a leaderboad query.
     */
    CocoonJS.Social.GameCenter.TimeScope =
    {
        TODAY: 0,
        WEEK: 1,
        ALL_TIME:2
    };

    /**
     * @enum
     * This enumeration represents the possible Player Scopes for a leaderboad query.
     */
    CocoonJS.Social.GameCenter.PlayerScope =
    {
        GLOBAL: 0,
        FRIENDS: 1
    };


    //Social API Interface
    CocoonJS.Social.SocialGamingServiceGameCenter = function(gcExtension) {
        CocoonJS.Social.SocialGamingServiceGameCenter.superclass.constructor.call(this);
        this.gc = gcExtension;
        var me = this;
        this.gc.onGameCenterLoginStateChanged.addEventListener(function(localPlayer, error){
            me.onLoginStatusChanged.notifyEventListeners(localPlayer.isAuthenticated,error);
        });
        return this;
    }

    CocoonJS.Social.SocialGamingServiceGameCenter.prototype =  {

        _cachedAchievements: null,

        isLoggedIn: function() {
            return this.gc.isLoggedIn();
        },
        login : function(callback) {
            this.gc.login(function(localPlayer, error){
                if (callback)
                    callback(localPlayer.isAuthenticated, error);
            });
        },
        logout: function(callback) {
            if (callback)
                callback({message:"User has to logout from the Game Center APP"});
        },
        getLoggedInUser : function() {
            return fromGCPLayerToCocoonUser(this.gc._currentPlayer ? this.gc._currentPlayer : this.gc.getLocalPlayer());
        },

        requestUser: function(callback, userId) {
            if (userId) {
                this.gc.loadPlayers([userId], function(response, error) {
                    var user = response && response.length ? fromGCPLayerToCocoonUser(response[0]) : null;
                    callback(user, error);
                });
            }
            else {
                var me = this;
                setTimeout(function(){
                    callback(me.getLoggedInUser());
                })
            }
        },
        requestFriends: function(callback, userId) {
            this.gc.loadFriends(function(friends, error){
                var users = [];
                if (friends && friends.length) {
                    for (var i= 0; i< friends.length; ++i) {
                        users.push(fromGCPLayerToCocoonUser(friends[i]));
                    }
                }
                callback(users, error);
            });
        },
        requestScore: function(callback, params) {
            var query = {};
            var options = params || {};
            if (options.leaderboardID)
                query.category = options.leaderboardID;
            query.playerIDs = [options.userID || this.getLoggedInUser().userID];

            this.gc.loadScores(function(response, error) {
                var gcScore = null;
                if (options.userID && response && response.scores && response.scores.length)
                    gcScore = response.scores[0];
                else if (response && response.localPlayerScore)
                    gcScore = response.localPlayerScore;
                var loadedScore = gcScore ? new CocoonJS.Social.Score(gcScore.playerID, gcScore.value, "","", gcScore.category) : null;
                callback(loadedScore,error);
            }, query);
        },

        submitScore: function(score, callback, params) {
            var options = params || {};
            this.gc.submitScore({value:score, category:options.leaderboardID || ""}, function(error){
                if (callback)
                    callback(error);
            });
        },

        showLeaderboard : function(callback, params) {
            var options = params || {};
            this.gc.showLeaderboards(function(error){
                if (callback)
                    callback(error);
            }, {category:options.leaderboardID || ""});
        },
        //internal utility function
        prepareAchievements: function(reload, callback) {

            if (!this._cachedAchievements || reload) {
                var me = this;
                this.gc.loadAchievementDescriptions(function(response, error){
                    if (error) {
                        callback([],error);
                    }
                    else {
                       var achievements = [];
                       if (response && response.length) {
                           for (var i = 0; i < response.length; i++) {
                               achievements.push(fromGCAchievementDescriptionToCocoonAchievement(response[i]))
                           }
                       }
                       me.setCachedAchievements(achievements);
                       callback(achievements, null);
                    }

                });
            }
            else {
                callback(this._cachedAchievements, null);
            }
        },

        requestAllAchievements : function(callback) {
            this.prepareAchievements(true, callback);
        },

        requestAchievements : function(callback, userID) {
            var me = this;
            this.prepareAchievements(false, function(allAchievements, error){
                if (error) {
                    callback([], error);
                    return;
                }
                me.gc.loadAchievements(function(response, error){
                    if (!error) {
                        var achievements = [];
                        if (response && response.length) {
                            for (var i = 0; i < response.length; i++) {
                                var ach = me.findAchievement(response[i].identifier);
                                if (ach)
                                    achievements.push(ach);
                            }
                        }
                        callback(achievements, null);
                    }
                    else {
                        callback([], response.error);
                    }

                });
            });
        },
        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var achID = this.translateAchievementID(achievementID);
            this.gc.submitAchievements([{identifier:achID, percentComplete:100}], callback);
        },
        resetAchievements : function(callback) {
            this.gc.resetAchievements(callback);
        },
        showAchievements : function(callback) {
            this.gc.showAchievements(function(error){
                if (callback)
                    callback(error);
            });
        }
    }

    CocoonJS.extend(CocoonJS.Social.SocialGamingServiceGameCenter, CocoonJS.Social.SocialGamingService);

    /**
     * @ignore
     */
    function fromGCPLayerToCocoonUser(player){
        return new CocoonJS.Social.User(player.playerID, player.alias);
    }
    /**
     * @ignore
     */
    function fromGCAchievementDescriptionToCocoonAchievement(ach) {
        return new CocoonJS.Social.Achievement(ach.identifier,ach.title, ach.achievedDescription,"", ach.maximumPoints);
    }
})();
;(function() {

    // The CocoonJS and CocoonJS.Social must exist before creating the extension.
    if (!window.CocoonJS) throw("The CocoonJS object must exist and be valid before creating the extension types.");
    if (!window.CocoonJS.Social) throw("The CocoonJS.Social object must exist and be valid before creating the extension types.");

    /**
     * @class
     * @constructor
     * Represents a type that mimics the original Google Play Games API with the addition of the possibility to
     * retrieve an abstract high level interface API to handle a SocialGamingService (APIs defined by Ludei).
     * Original Google Play Games API: https://developers.google.com/api-client-library/javascript/referencedocs/
     */
    CocoonJS.Social.GooglePlayGamesExtension = function (){
        this.nativeExtensionName = "IDTK_SRV_GOOGLE_PLAY_GAMES";
        this.extensionName = "Social.GooglePlayGames";
        this.nativeExtensionObjectAvailable =  CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[this.nativeExtensionName] !== 'undefined';

        this.auth = new CocoonJS.Social.GooglePlayGamesAuthExtension(this);
        this.client = new CocoonJS.Social.GooglePlayGamesClientExtension(this);
        this.defaultScopes = ["https://www.googleapis.com/auth/games","https://www.googleapis.com/auth/plus.login"];
        this.gamesAPI = "/games/v1";
        this.plusAPI = "/plus/v1";

        this.onSessionChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSessionChanged");

        CocoonJS.Social.GooglePlayGames = this; //the object it's being created but the addEventListener needs it now
        var me = this;
        this.onSessionChanged.addEventListener(function(session, error) {
            me.token = fromSessionToAuthTokenObject(session,error);
            if (session && session.access_token) {
                //fetch user data
                me.client.request({path: me.gamesAPI + "/players/me", callback: function(response) {
                    me.currentPlayer = response;
                }});
            }
        });

        return this;
    };

    CocoonJS.Social.GooglePlayGamesExtension.prototype = {

        token: null,
        settings: {},
        socialService: null,
        currentPlayer: null,
        initialized: false,

        auth: null,
        client: null,

        /**
         * Initializes the service and tries to restore the last session
         * @param {Object} params Initialization options
         * params.clientId {string} The application clientID. Omit if its already provided in the native application via cloud configuration.
         * params.defaultLeaderboard {string} The default leaderboard ID. You can omit it if you specify the leaderboardID in all the score queries or submits
         * params.showAchievementNotifications {boolean} Enable or disable the native view notifications when an achievement is unlocked.
         */
        init: function(params) {
            if (!params || typeof params !== 'object')
                throw "Invalid params argument";
            this.settings = params;
            this.initialized = true;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "init", [this.settings.clientId], true);
            }
            else {

                var me = this;
                var initWebAPi = function() {
                    gapi.auth.authorize({immediate: true, scope: me.defaultScopes, client_id:me.settings.clientId},function(response) {
                        me.token = response;
                        if (response && response.access_token) {
                            me.onSessionChanged.notifyEventListeners(response);
                        }
                    })
                }

                if (!window.gapi) {
                    window.onGapiLoadCallback = function() {
                        //initialization timeout recommended by google to avoid some race conditions
                        window.setTimeout(initWebAPi, 1);
                    }
                    var script = document.createElement("script");
                    script.src = "https://apis.google.com/js/client.js?onload=onGapiLoadCallback";
                    document.getElementsByTagName('head')[0].appendChild(script);
                }
                else {
                    initWebAPi();
                }
            }
        },

        /**
         * Return a CocoonJS SocialGaming interface for the Google Play Games Extension
         * You can use the Google Play Games extension in two ways, with the official SDK API equivalent or with the CocoonJS Social API abstraction
         * @see CocoonJS.Social.SocialGamingService
         * @returns {CocoonJS.Social.SocialGamingService}
         */
        getSocialInterface: function() {

            if (!this.initialized) {
                throw "You must call init() before getting the Social Interface";
            }
            if (!this.socialService) {
                this.socialService = new CocoonJS.Social.SocialGamingServiceGooglePlayGames(this);
            }
            return this.socialService;
        },

        /**
         * Return a CocoonJS Multiplayer interface for the Game Center Extension
         * @returns {CocoonJS.Multiplayer.MultiplayerService}
         */
        getMultiplayerInterface: function() {
            return CocoonJS.Multiplayer.GooglePlayGames;
        },

        share: function() {


            window.open(this.href,'', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=600,width=600');return false;

        }

    };

    CocoonJS.Social.GooglePlayGamesAuthExtension = function(extension) {
        this.extension = extension;
        return this;
    }

    CocoonJS.Social.GooglePlayGamesAuthExtension.prototype = {
        /**
         * Initiates the OAuth 2.0 authorization process.
         * The browser displays a popup window prompting the user authenticate and authorize.
         * After the user authorizes, the popup closes and the callback function fires.
         * @param {object} A key/value map of parameters for the request (client_id, inmediate, response_type, scope)
         * @param {function} callback The function to call once the login process is complete. The function takes an OAuth 2.0 token object as its only parameter.
         */
        authorize: function(params, callback) {
            var me = this;
            if (this.extension.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "authorize", [params, function(response, error) {
                    me.extension.token = fromSessionToAuthTokenObject(response,error);
                    if (callback) {
                        callback(me.extension.token);
                    }
                }], true);
            }
            else {
                gapi.auth.authorize(params, function(response){
                    me.extension.token = response;
                    me.extension.onSessionChanged.notifyEventListeners(response, response ? response.error : null);
                    if (callback)
                        callback(response);
                });
            }
        },

        /**
         * Log the user out of the application
         * @param callback
         */
        disconnect: function(callback) {

            if (this.extension.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "disconnect", [callback], true);
            }
            else {
                //TODO
                if (callback)
                    callback({error: "Not implemented yet"});
            }
        },

        /**
         *  Initializes the authorization feature. Call this when the client loads to prevent popup blockers from blocking the auth window on gapi.auth.authorize calls.
         *  @param {Function} callback A callback to execute when the auth feature is ready to make authorization calls
         */
        init: function(callback) {

            if (this.extension.nativeExtensionObjectAvailable) {
                callback();
            }
            else {
                gapi.auth.init(callback);
            }
        },

        /**
         * Retrieves the OAuth 2.0 token for the application.
         */
        getToken: function() {
            if (this.extension.nativeExtensionObjectAvailable) {
                return this.extension.token;
            }
            else {
                return gapi.auth.getToken();
            }
        },
        /*
         * Retrieves the OAuth 2.0 token for the application.
         */
        setToken: function(token) {
            if (this.extension.nativeExtensionObjectAvailable) {
                this.extension.token = token;
            }
            else {
                gapi.auth.setToken(token);
            }
        }
    }


    CocoonJS.Social.GooglePlayGamesClientExtension = function(extension) {
        this.extension = extension;
        return this;
    }

    CocoonJS.Social.GooglePlayGamesClientExtension.prototype = {

        /**
         * Sets the API key for the application, which can be found in the Developer Console. Some APIs require this to be set in order to work.
         * @param apiKey The API key to set
         */
        setApiKey: function(apiKey) {
            if (this.extension.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "setApiKey", [apiKey],true);
            }
            else {
                gapi.client.setApiKey(apiKey);
            }
        },

        /**
         * Creates a HTTP request for making RESTful requests.
         * @param {object} args (More info: https://developers.google.com/api-client-library/javascript/reference/referencedocs#gapiclientrequest)
         * @return {object} If no callback is supplied, a request object is returned. The request can then be executed using gapi.client.HttpRequest.execute(callback).
         */
        request: function(args) {
            if (this.extension.nativeExtensionObjectAvailable) {
                if (args.callback) {
                    CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "request", [args, function(response,error){
                        var result = response;
                        if (error) {
                            result = response || {};
                            result.error = error;
                        }
                        args.callback(result);
                    }],true);
                    return null;
                }
                else {
                    var me = this;
                    //return a function to mimic the HttpRequest class
                    var httpRequest =  {
                        execute: function(callback) {
                            CocoonJS.makeNativeExtensionObjectFunctionCall(me.extension.nativeExtensionName, "request", [args, function(response, error){
                                var result = response;
                                if (error) {
                                    result = response || {};
                                    result.error = error;
                                }
                                callback(result);
                            }],true);
                        }
                    };
                    return httpRequest;
                }
            }
            else {
                return gapi.client.request(args);
            }
        }
    }

    /**
     * @namespace
     * This is the global variable that enables access to the Google Play Games API mimic and the high level abstract API
     * to handle Social aspects, created by Ludei.
     * @see CocoonJS.Social.GooglePlayGamesExtension
     */
    CocoonJS.Social.GooglePlayGames = new CocoonJS.Social.GooglePlayGamesExtension();


    /**
     * @ignore
     */
    function fromSessionToAuthTokenObject(response, error) {
        var obj = response || {};
        return {
            access_token: response.access_token,
            state: response.state,
            error: error,
            expires_in: response.expirationDate ? response.expirationDate - Date.now() : 0,
            player_id: response.playerId
        }
    }


    CocoonJS.Social.SocialGamingServiceGooglePlayGames = function (apiObject) {
        CocoonJS.Social.SocialGamingServiceGooglePlayGames.superclass.constructor.call(this);
        this.gapi = apiObject;
        var me = this;

        this.gapi.onSessionChanged.addEventListener(function(session){
            var obj = session || {};
            me.onLoginStatusChanged.notifyEventListeners(!!obj.access_token, obj.error);
        });

        return this;
    }

    CocoonJS.Social.SocialGamingServiceGooglePlayGames.prototype =  {

        isLoggedIn: function() {
            return (this.gapi.token && this.gapi.token.access_token) ? true: false;
        },
        login : function(callback) {
            var me = this;
            this.gapi.auth.authorize({client_id:this.gapi.settings.clientId, scope: this.gapi.defaultScopes}, function(response) {
                if (callback) {
                    callback(me.isLoggedIn(),response.error);
                }
            });
        },
        logout: function(callback) {
            this.gapi.auth.disconnect(callback);
        },
        getLoggedInUser : function() {
            return this.gapi.currentPlayer ? fromGPUserToCocoonUser(this.gapi.currentPlayer) : null;
        },
        requestUser: function(callback, userId) {
            var playerId = userId || "me";
            this.gapi.client.request({path: this.gapi.gamesAPI + "/players/" + playerId, callback: function(response) {
                var user = response && !response.error ? fromGPPlayerToCocoonUser(response) : null;
                callback(user, response.error);
            }});
        },
        requestUserImage: function(callback, userID, imageSize) {
            this.requestUser(function(user, error){
                if (user && user.userImage) {
                    var pixelSize = fromImageSizeToGPSize(imageSize || CocoonJS.Social.ImageSize.MEDIUM);
                    if (user.userImage.indexOf("sz=") ===  -1) {
                        user.userImage+="?sz=" + pixelSize;
                    }
                    else {
                        user.userImage = user.userImage.replace(/sz=\d+/g,"sz=" + pixelSize);
                    }
                }
                callback(user ? user.userImage : null, error);
            }, userID);

        },
        requestFriends: function(callback, userId) {
            var params = { orderBy: "best"};
            var playerId = userId || "me";
            this.gapi.client.request({path: this.gapi.plusAPI + "/people/" + playerId + "/people/visible", params: params, callback: function(response) {
                if (response && !response.error) {
                    var friends = [];
                    for (var i = 0; i< response.items.length; ++i) {
                        friends.push(fromGPPersonToCocoonUser(response.items[i]));
                    }
                    callback(friends);
                }
                else {
                    callback([], response ? response.error : null);
                }
            }});
        },

        publishMessage: function(message, callback) {
            if (callback)
                callback("Not supported... use publishMessageWithDialog method instead");
        },

        publishMessageWithDialog: function(message, callback) {

            if (this.gapi.nativeExtensionObjectAvailable) {
                var params = {
                    prefilledText: message.message,
                    mediaUrl: message.mediaURL,
                    mediaTitle: message.linkCaption,
                    mediaDescription: message.linkText,
                    url: message.linkURL
                }

                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "shareMessage", [params, callback], true)
            }
            else {

                var me = this;
                var share = function() {
                    var options = {
                        contenturl: 'https://plus.google.com/pages/',
                        contentdeeplinkid: '/pages',
                        clientid: me.gapi.settings.clientId,
                        cookiepolicy: 'single_host_origin',
                        prefilltext: message.message,
                        calltoactionlabel: 'CREATE',
                        calltoactionurl: 'http://plus.google.com/pages/create',
                        calltoactiondeeplinkid: '/pages/create'
                    };

                    gapi.interactivepost.render('sharePost', options);
                }

                if (!gapi.interactivepost) {
                    var script = document.createElement('script'); script.type = 'text/javascript'; script.async = true;
                    script.src = 'https://apis.google.com/js/plusone.js';
                    script.onload = function() {
                        share();
                    }
                    document.getElementsByTagName('head')[0].appendChild(script);
                }
                else {
                    share();
                }
            }
        },

        requestScore: function(callback, params) {
            params = params || {};
            var playerId = params.userID || "me";
            var leaderboardID = params.leaderboardID || this.gapi.settings.defaultLeaderboard;
            if (!leaderboardID)
                throw "leaderboardID not provided in the params. You can also set the default leaderboard in the init method";

            this.gapi.client.request({path: this.gapi.gamesAPI + "/players/" + playerId + "/leaderboards/" + leaderboardID + "/scores/ALL_TIME", callback: function(response) {
                if (response && response.error) {
                    callback(null, response.error)
                }
                else if (response && response.items && response.items.length > 0) {
                    var item = response.items[0];
                    var data = new CocoonJS.Social.Score(playerId, item.scoreValue,"","", item.leaderboard_id);
                    callback(data, null);
                }
                else {
                    //No score has been submitted yet for the user
                    callback(null,null);
                }
            }});

        },

        submitScore: function(score, callback, params) {
            params = params || {};
            var leaderboardID = params.leaderboardID || this.gapi.settings.defaultLeaderboard;
            if (!leaderboardID)
                throw "leaderboardID not provided in the params. You can also set the default leaderboard in the init method";


            this.gapi.client.request({path: this.gapi.gamesAPI + "/leaderboards/" + leaderboardID + "/scores",
                                      method: "POST", params:{score: score}, callback: function(response) {
                    if (callback) {
                        callback(response ? response.error : null);
                    }
            }});

        },

        showLeaderboard : function(callback, params) {
            params = params || {};
            var leaderboardID = params.leaderboardID || this.gapi.settings.defaultLeaderboard;
            if (!leaderboardID)
                throw "leaderboardID not provided in the params. You can also set the default leaderboard in the init method";

            var ios = /(iPad|iPhone|iPod)/ig.test( navigator.userAgent );
            if (!ios && this.gapi.nativeExtensionObjectAvailable) {
                var timeScope = params.timeScope || 0;
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "showLeaderboard", [leaderboardID, timeScope, callback], true);
            }
            else {
                if (!this._leaderboardsTemplate)
                    throw "Please, provide a html template for leaderboards with the setTemplates method";
                var dialog = new CocoonJS.App.WebDialog();
                var callbackSent = false;
                dialog.show(this._leaderboardsTemplate, function(error) {
                    dialog.closed = true;
                    if (!callbackSent && callback)
                        callback(error);
                });
                var me = this;
                var collection = params.friends ? "SOCIAL" : "PUBLIC";
                var timeSpan = "ALL_TIME";
                if (params.timeScope === CocoonJS.Social.TimeScope.WEEK) {
                    timeSpan = "WEEKLY";
                }
                else if (params.timeScope === CocoonJS.Social.TimeScope.TODAY) {
                    timeSpan = "DAILY";
                }
                this.gapi.client.request({path: this.gapi.gamesAPI + "/leaderboards/" + leaderboardID + "/window/" + collection,
                    method: "GET", params:{timeSpan: timeSpan}, callback: function(response) {
                        if (dialog.closed)
                            return;
                        if (response.error) {
                            if (callback) {
                                callbackSent = true;
                                callback(response.error);
                                dialog.close();
                            }
                            return;
                        }
                        var scores = [];
                        var items = [];
                        if (response && response.items) {
                            items = response.items.slice(0);
                        }
                        if (response && response.playerScore) {
                            items.push(response.playerScore);
                        }
                        for (var i = 0; i< items.length; ++i) {
                            var item = items[i];
                            var score = fromGPScoreToCocoonScore(item, leaderboardID);
                            score.imageURL+="?sz=50";
                            score.position = item.scoreRank || i + 1;
                            score.me = false;
                            scores.push(score);
                        }
                        var js = "addScores(" + JSON.stringify(scores) + ")";
                        dialog.eval(js);
                    }});
            }
        },

        //internal utility function
        prepareAchievements: function(reload, callback) {
            if (!this._cachedAchievements || reload) {
                var me = this;
                this.gapi.client.request({path: this.gapi.gamesAPI + "/achievements", callback: function(response) {
                    if (response && !response.error) {
                        var achievements = [];
                        if (response && response.items) {
                            for (var i = 0; i < response.items.length; i++) {
                                achievements.push(fromGPAchievementToCocoonAchievement(response.items[i]))
                            }
                        }
                        me.setCachedAchievements(achievements);
                        callback(achievements, null);
                    }
                    else {
                        callback([], response ? response.error : null);
                    }
                }});
            }
            else {
                callback(this._cachedAchievements, null);
            }
        },

        requestAllAchievements : function(callback) {
            this.prepareAchievements(true, callback);
        },

        requestAchievements : function(callback, userID) {
            var me = this;
            this.prepareAchievements(false, function(allAchievements, error){
                if (error) {
                    callback([], error);
                    return;
                }
                var playerID = userID || "me";
                me.gapi.client.request({path: me.gapi.gamesAPI + "/players/" + playerID + "/achievements",
                                        params: {state: "UNLOCKED"}, callback: function(response) {
                    if (response && !response.error) {
                        var achievements = [];
                        if (response.items) {
                            for (var i = 0; i < response.items.length; i++) {
                                var ach = me.findAchievement(response.items[i].id);
                                if (ach)
                                    achievements.push(ach);
                            }
                        }
                        callback(achievements, null);
                    }
                    else {
                        callback([], response ? response.error : null);
                    }
                }});

            });
        },
        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var achID = this.translateAchievementID(achievementID);
            if (this.gapi.nativeExtensionObjectAvailable) {
                //native API allows to show a native notification view. (REST API doesn't)
                var showNotification = !!this.gapi.settings.showAchievementNotifications;
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "unlockAchievement", [achID, showNotification, callback], true);
            }
            else {
                //REST api
                this.gapi.client.request({path: this.gapi.gamesAPI + "/achievements/" + achID + "/unlock",
                    method: "POST", callback: function(response) {
                        if (callback) {
                            callback(response ? response.error : null);
                        }
                    }});
            }
        },
        resetAchievements : function(callback) {
            this.gapi.client.request({path: "/games/v1management/achievements/reset",
                method: "POST", callback: function(response) {
                    if (callback) {
                        callback(response ? response.error : null);
                    }
                }});
        },
        showAchievements : function(callback) {
            var ios = /(iPad|iPhone|iPod)/ig.test( navigator.userAgent );
            if (!ios && this.gapi.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "showAchievements", [callback], true);
            }
            else {
                CocoonJS.Social.SocialGamingServiceGooglePlayGames.superclass.showAchievements.call(this);
            }
        }
    }

    CocoonJS.extend(CocoonJS.Social.SocialGamingServiceGooglePlayGames, CocoonJS.Social.SocialGamingService);


    /**
     *@ignore
     */
    function fromGPPlayerToCocoonUser (gpPlayer) {
        return new CocoonJS.Social.User (gpPlayer.playerId, gpPlayer.displayName, gpPlayer.avatarImageUrl);
    }
    /**
     *@ignore
     */
    function fromGPPersonToCocoonUser (gpUser) {
        var avatar = gpUser.image ? gpUser.image.url : "";
        avatar = avatar.replace(/sz=\d+/g,"sz=100");
        return new CocoonJS.Social.User (gpUser.id, gpUser.displayName, avatar);
    }
    /**
     *@ignore
     */
    function fromImageSizeToGPSize (imageSize) {
        if (imageSize === CocoonJS.Social.ImageSize.THUMB) {
            return 100;
        }
        else if (imageSize === CocoonJS.Social.ImageSize.MEDIUM) {
            return 200;
        }
        else if (imageSize === CocoonJS.Social.ImageSize.LARGE) {
            return 512;
        }
    }
    /**
     *@ignore
     */
    function fromGPAchievementToCocoonAchievement(gpItem) {
        var result = new CocoonJS.Social.Achievement (
            gpItem.id,
            gpItem.name,
            gpItem.description,
            gpItem.revealedIconUrl,
            0
        );
        result.gpAchievementData = gpItem;
        return result;
    }
    /**
     *@ignore
     */
    function fromGPScoreToCocoonScore(gpItem, leaderboardID) {
        return new CocoonJS.Social.Score(gpItem.player.playerId, gpItem.scoreValue, gpItem.player.displayName, gpItem.player.avatarImageUrl, leaderboardID);
    }

})();
;(function() {

    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.Social object must exist and be valid before creating a Social Manager extension object.");

    CocoonJS.Social.ManagerService = function() {
       this.services = [];
    }

    CocoonJS.Social.ManagerService.prototype = {

        services:null,

        registerSocialService : function(service) {
            this.services.push(service);
        },

        submitAchievement : function(achievementID) {
            for (var i = 0; i < this.services.length; ++i) {
                var service = this.services[i];
                if (!service.readOnlyHint && service.isLoggedIn())  {
                    service.submitAchievement(achievementID, function(error) {
                        if (error)
                            console.error("Error submitting achievement: " + error.message);
                    });
                }
            }
        },

        submitScore : function(score, params) {
            for (var i = 0; i < this.services.length; ++i) {
                var service = this.services[i];
                if (!service.readOnlyHint && service.isLoggedIn())  {
                    service.submitScore(score, function(error) {
                        if (error)
                            console.error("Error submitting score: " + error.message);
                    }, params);
                }
            }
        },

        getLoggedInServices : function() {
            var result= [];

            for (var i = 0; i < this.services.length; ++i) {
                var service = this.services[i];
                if (!service.fakeSocialService &&  service.isLoggedIn())  {
                    result.push(service);
                }
            }
            return result;
        },

        isLoggedInAnySocialService : function() {
            return this.getLoggedInServices().length > 0;
        }
    }

    CocoonJS.Social.Manager = new CocoonJS.Social.ManagerService();

})();;(function() {

    // The CocoonJS and CocoonJS.Social must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating the extension types.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS.Social === null) throw("The CocoonJS.Social object must exist and be valid before creating the extension types.");

    /** 
     * @class
     * @constructor 
     * Represents a type that mimics the original Facebook API with the addition of the possibility to
     * retrieve an abstract high level interface API to handle a SocialGamingService (APIs defined by Ludei).
     */
    CocoonJS.Social.FacebookExtension = function (){
        this.nativeExtensionName = "IDTK_SRV_FACEBOOK";
        this.extensionName = "Social.Facebook";
        this.nativeExtensionObjectAvailable =  CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[this.nativeExtensionName] !== 'undefined';
        this.Event = new CocoonJS.Social.FacebookEvent(this.nativeExtensionObjectAvailable);

        var me = this;
        if (this.nativeExtensionObjectAvailable) {

            this.onFacebookSessionStateChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onFacebookSessionStateChanged");

            CocoonJS.Social.Facebook = this; //the object it's being created but the addEventListener needs it now
            this.onFacebookSessionStateChanged.addEventListener(function(session, error) {
                var data = fromCocoonFBSessionToFBAPISession(session,error);
                if (session.state == 0) {
                    me.Event.notify("auth.login", data);
                }
                me.Event.notify("auth.authResponseChange", data);
                me.Event.notify("auth.statusChange", data);
            });
        }
        return this;
    };

    CocoonJS.Social.FacebookExtension.prototype = {

        _currentSession: null,
        _appId: null,
        _socialService: null,

        /**
         * Initialize the SDK with your app ID. This will let you make calls against the Facebook API. All FB.API methods must be called after FB.init.
         * @param {object} options. Check available options here: https://developers.facebook.com/docs/reference/javascript/FB.init/
         */
        init: function(options) {
            if (!options || !options.appId) {
                throw "appId must be specified!";
            }

            this._appId = options.appId;

            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "init", [options], true);
            }
            else {
                FB.init(options);
            }

            var me = this;
            this.Event.subscribe("auth.authResponseChange", function(session) {
                me._currentSession = session;
                if (session.authResponse && !session.authResponse.user){
                    me.api("me?fields=username", function(response) {
                        me._currentSession.authResponse.user = response;
                    });
                }
            });
        },

        /**
         * Return a CocoonJS SocialGaming interface for the Facebook Extension
         * You can use the Facebook extension in two ways, with the official SDK API equivalent or with the CocoonJS Social API abstraction
         * @see CocoonJS.Social.SocialGamingService
         * @returns {CocoonJS.Social.SocialGamingService}
         */
        getSocialInterface: function() {

            if (!this._appId) {
                throw "You must call init() before getting the Social Interface";
            }
            if (!this._socialService) {
                this._socialService = new CocoonJS.Social.SocialGamingServiceFacebook(this);
            }
            return this._socialService;
        },

        /**
         * Authenticate the user
         * By default, calling login will attempt to authenticate the user with only the basic permissions.
         * If you want one or more additional permissions, call login with an option object,
         * and set the scope parameter with a comma-separated list of the permissions you wish to request from the user
         * @param {object} login options
         * @params {function} callback The callback function with received session data or error.
         */
        login: function(callback, options) {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "login", [options, function(response, error) {
                    me._currentSession = fromCocoonFBSessionToFBAPISession(response,error);
                    if (callback) {
                        callback(me._currentSession);
                    }

                }], true);
            }
            else {
                FB.login(function(response){
                    me._currentSession = response;
                    if (callback)
                        callback(response);
                }, options);
            }

        },

        /**
         * Log the user out of your application
         * You will need to have a valid access token for the user in order to call the function.
         * @param {function} callback called when the user is logged out
         */
        logout: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "logout", [function(response, error) {
                    if (callback) {
                        callback(fromCocoonFBSessionToFBAPISession(response, error));
                    }

                }],true);
            }
            else {
                FB.logout(function(response){
                    if (callback) {
                        callback(response);
                    }
                });
            }

        },

        /**
         * Synchronous accessor for the current authResponse
         * @returns {object} current Facebook session data
         */
        getAuthResponse: function() {

            if (this.nativeExtensionObjectAvailable) {
                var response = CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getFacebookSession", []);
                return fromCocoonFBSessionToFBAPISession(response);
            }
            else {
                return FB.getAuthResponse();
            }

        },

        /**
         * Allows you to determine if a user is logged in to Facebook and has authenticated your app.
         * There are three possible states for a user:
         * 1. the user is logged into Facebook and has authenticated your application (connected)
         * 2. the user is logged into Facebook but has not authenticated your application (not_authorized)
         * 3. the user is not logged into Facebook at this time and so we don't know if they've authenticated your application or not
         * @param {function} callback The callback function.
         * @param {boolean} force Force reloading the login status (default false).
         */
        getLoginStatus: function(callback, force) {
            if (this.nativeExtensionObjectAvailable) {

                var me = this;
                setTimeout(function(){
                    var response = CocoonJS.makeNativeExtensionObjectFunctionCall(me.nativeExtensionName, "getFacebookSession", []);
                    if (callback) {
                        callback(fromCocoonFBSessionToFBAPISession(response));
                    }

                },50);
            }
            else {
                FB.getLoginStatus(callback, force);
            }

        },
        /**
         * Makes API calls to the Graph API.
         * @param path The Graph API url path
         * @param method the http method (default "GET")
         * @param params the parameters for the query
         * @param cb the callback function to handle the response
         */
        api: function(path, method, params, cb ) {

            if (this.nativeExtensionObjectAvailable) {
                var openGraph = arguments[0];
                var httpMethod = arguments.length > 3 ? arguments[1] : "GET";
                var options = null;
                if (arguments.length == 3) options = arguments[1];
                if (arguments.length == 4) options = arguments[2];
                var callback = arguments.length > 1 ? arguments[arguments.length -1 ] : function(){};

                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "api", [openGraph, httpMethod, options, callback], true);
            }
            else {
                FB.api(path,method,params,cb);
            }
        },

        /**
         * A generic method for triggering Dialogs which allow the user to take some action.
         * @param params The required arguments vary based on the method being used, but specifying the method itself is mandatory
         * @param cb Callback function to handle the result. Not all methods may have a response.
         */
        ui: function(params, cb) {

            if (this.nativeExtensionObjectAvailable){
                var params = arguments[0];
                var callback = arguments.length > 1 ? arguments[1]: function(){};

                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "ui", [params, callback], true);
            }
            else if (!navigator.isCocoonJS)
            {
                FB.ui(params,cb);
            }
        },

        /**
         * @param {string} permissionsType "read" or "publish"
         * @param permissions comma separated Facebook permission names
         * @param callback response authResponse callback
         */

        requestAdditionalPermissions: function(permissionsType, permissions, callback) {
            if (this.nativeExtensionObjectAvailable) {

                var permsArray = permissions.split(',');
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAdditionalPermissions", [permissionsType, permsArray, function(session, error){
                    if (callback) {
                        callback(fromCocoonFBSessionToFBAPISession(session,error));
                    }
                }], true);
            }
            else {
                FB.login(callback, {scope:permissions});
            }
        },

        /**
         * Query the current user facebook permissions
         * @param callback Handler function which receives a dictionary with the granted permissions
         */
        getPermissions: function(callback) {
            this.api('me/permissions', function(response) {
                callback(response.data && response.data[0] ? response.data[0] : {});
            });
        },

        /**
         * Presents a dialog in the Facebook application that allows the user to share a status update
         * If the Facebook Application is not available it does a fallback to a feed dialog
         * No publish permissions are required.
         * @param params Dialog params (description, caption, name, link, picture)
         * @param callback Handler with response data or error
         */
        showShareDialog: function(params, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showShareDialog", [params, callback], true);
            }
            else {
                params.method = "feed";
                FB.ui(params, callback);
            }
        },

        /**
         * Upload a local image file to Facebook and get response
         * @param file The local file url to submit to Facebook (For example the one capture with screenCapture API)
         * @param callback Handler to process response with the photoid and other data or the error
         */
        uploadPhoto: function(file, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "uploadPhoto", [file, callback], true);
            }
            else {
                //TODO
                callback({error: {message: "Not implemented"}});
            }
        },

        /**
         * Shows a native UI component that can be used to pick friends.
         * @param callback Handlerv function. The response contains the boolen 'donePressed' value and an array of selected users in the 'selection' property.
         */
        showFriendPicker: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showFriendPicker", [callback], true);
            }
            else {
                //TODO
                callback({error: {message: "Not implemented"}});
            }
        }

    };

    /**
     * @class
     * @constructor
     */
    CocoonJS.Social.FacebookEvent = function(nativeAvailable ) {
        this.nativeExtensionObjectAvailable = nativeAvailable;
        return this;
    }

    CocoonJS.Social.FacebookEvent.prototype = {
        /**
         * Global Events to which you can subscribe:
         * auth.login - fired when the auth status changes from unknown to connected
         * auth.authResponseChange - fired when the authResponse changes
         * auth.statusChange - fired when the status changes
         * @param name Name of the event
         * @param callback The handler function
         */
        subscribe: function(name, callback){
            if (this.nativeExtensionObjectAvailable)
            {
                var eventKey = name + 'listeners';
                this[eventKey] = this[eventKey] || [];
                this[eventKey].push(callback);
            }
            else if (!navigator.isCocoonJS)
            {
                FB.Event.subscribe(name,callback);
            }
        },
        /**
         * Removes handlers on events so that it no longer invokes your callback when the event fires.
         * @param name Name of the event.
         * @param callback The handler function.
         */
        unsubscribe: function(name, callback) {
            if (this.nativeExtensionObjectAvailable)
            {
                var eventKey = name + 'listeners';
                var array = this[eventKey];
                if (array) {
                    var index = array.indexOf(callback);
                    if (index !== -1) {
                        array.splice(index,1);
                    }
                }
            }
            else if (!navigator.isCocoonJS)
            {
                FB.Event.unsubscribe(name,callback);
            }
        },

        /**
         * @ignore
         */
        notify: function(name, param) {
            var eventKey = name + 'listeners';
            var array = this[eventKey];
            if (array) {
                for (var i = 0; i< array.length; ++i) {
                    array[i](param);
                }
            }

        }
    };

    /**
     * @namespace 
     * This is the global variable that enables access to the Facebook API mimic and the high level abstract API
     * to handle Social aspects, created by Ludei.
     * @see CocoonJS.Social.FacebookExtension
     */
    CocoonJS.Social.Facebook = new CocoonJS.Social.FacebookExtension();

    /**
     * @ignore
     */
    function fromCocoonFBStatusToFBAPIState(state) {
        if (state === 0) {
            return "connected";
        }
        else if (state === 1) {
            return "not_authorized";
        }
        else {
            return "unknown";
        }
    }

    /**
     * @ignore
     */
    function fromCocoonFBSessionToFBAPISession(response, error) {

        var authResponse = null;
        if (response.state === 0) {
            authResponse = {
                accessToken: response.accessToken,
                expirationDate: response.expirationDate,
                userID: response.user ? response.userID : null,
                permissions: response.permissions,
                user: response.user
            }
        }

        return {
            status: fromCocoonFBStatusToFBAPIState(response.state),
            authResponse: authResponse,
            error: error
        }

    }

    CocoonJS.Social.SocialGamingServiceFacebook = function (fbExtension) {
        CocoonJS.Social.SocialGamingServiceFacebook.superclass.constructor.call(this);
        this.fb = fbExtension;
        var me = this;
        this.fb.Event.subscribe("auth.authResponseChange", function(session) {
            me.onLoginStatusChanged.notifyEventListeners(session.status == "connected", session.error);
        });
        return this;
    }

    CocoonJS.Social.SocialGamingServiceFacebook.prototype =  {

        currentPermissions: null,

        isLoggedIn: function() {
            return this.fb._currentSession && this.fb._currentSession.status === "connected";
        },
        login : function(callback) {
            var me = this;
            this.fb.login(function(response){
                if (callback)
                    callback(me.isLoggedIn(), response.error);
            });
        },
        logout: function(callback) {
            this.fb.logout(function(response){
                if (callback)
                    callback(response.error);
            });
        },
        getLoggedInUser : function() {
            var authResponse = this.fb._currentSession ? this.fb._currentSession.authResponse : null;
            if (authResponse && authResponse.user) {
                return fromFBUserToCocoonUser(authResponse.user);
            }
            else if (authResponse && authResponse.userID) {
                return new CocoonJS.Social.User(authResponse.userID, "Loading...");
            }
            return null;
        },
        hasPublishPermissions: function(callback) {
            this.fb.getPermissions(function(perms, error){
               callback(perms.publish_actions, error);
            });
        },
        requestPublishPermissions: function(callback) {
            var me = this;
            this.fb.requestAdditionalPermissions("publish", "publish_actions", function(response){
                if (response.error)
                    callback(false, error);
                else {
                    me.hasPublishPermissions(function(granted, error){
                        callback(granted,error);
                    });
                }
            });
        },
        requestUser: function(calback, userId) {
            var apiCall = (userId || "me");
            this.fb.api(apiCall, function(response){
                var user = response.error ? null : fromFBUserToCocoonUser(response);
                calback(user, response.error);
            });
        },
        requestUserImage: function(callback, userID, imageSize) {
            if (!userID && this.isLoggedIn()) {
                userID = this.fb._currentSession.authResponse.userID;
            }
            var fbPictureSize = "small";
            if (imageSize === CocoonJS.Social.ImageSize.THUMB) {
                  fbPictureSize = "square"
            }
            else if (imageSize === CocoonJS.Social.ImageSize.MEDIUM) {
                fbPictureSize = "normal";
            }
            else if (imageSize === CocoonJS.Social.ImageSize.LARGE) {
                fbPictureSize = "large";
            }
            var url = "https://graph.facebook.com/" + userID + "/picture?type=" + fbPictureSize;
            callback(url);
        },
        requestFriends: function(callback, userId) {
            var apiCall = (userId || "me") + "/friends";
            this.fb.api(apiCall, function(response){
                var friends = [];
                if (!response.error) {
                    for (var i=0; i<response.data.length; i++)
                    {
                        friends.push(fromFBUserToCocoonUser(response.data[i]));
                    }
                }
                callback(friends, response.error);
            });
        },

        //internal utility function
        preparePublishAction: function(callback) {
            if (!this.currentPermissions) {
                var me = this;
                this.fb.getPermissions(function(perms){
                    me.currentPermissions = perms;
                    if (perms)
                        me.preparePublishAction(callback);
                });
            }
            else if (this.currentPermissions.publish_actions) {
                callback(true);
            }
            else{
                this.currentPermissions = null;
                this.fb.requestAdditionalPermissions("publish", "publish_actions", function(response) {
                     callback(response.error ? false : true);
                });
            }

        },
        publishMessage: function(message, callback) {
            this.preparePublishAction(function(granted) {
                if (granted) {
                    var params = fromCocoonMessageToFBMessage(message);
                    var apiCall = "me/feed";
                    this.fb.api(apiCall, params, function(response) {
                        if (callback)
                            callback(response.error);
                    });
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }
            });
        },

        publishMessageWithDialog: function(message, callback) {
            this.fb.showShareDialog(fromCocoonMessageToFBMessage(message), function(response){
                 if (callback) {
                     callback(response.error);
                 }
            });
        },

        requestScore: function(callback, params) {
            var apiCall = ((params && params.userID) ? params.userID : "me") + "/scores";
            this.fb.api(apiCall, function(response) {
                if (response.error) {
                    callback(null, response.error)
                }
                else if (response.data && response.data.length > 0) {
                    var data = fromFBScoreToCocoonScore(response.data[0]);
                    callback(data, null);
                }
                else {
                    //No score has been submitted yet for the user
                    callback(null,null);
                }

            });
        },

        submitScore: function(score, callback, params) {
            var me = this;
            this.preparePublishAction(function(granted) {
                if (granted) {
                    me.requestScore(function(currentScore, error) {
                        if (error) {
                            //can't get the user top score. Don't send the new one because it might be worse than the top score
                            if (callback)
                                callback(error);
                           return;
                        }
                        var topScore = currentScore ? currentScore.score : 0;
                        if (score <= topScore) {
                            //don't submit the new score because a better score is already submitted
                            if (callback)
                                callback(null);
                            return;
                        }
                        var apiCall = "/" + ((params && params.userID) ? params.userID : "me") + "/scores";
                        me.fb.api(apiCall, 'POST', {score:score}, function (response) {
                             if (callback)
                                callback(response.error);
                        });
                    }, params)
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }

            })
        },

        showLeaderboard : function(callback, params) {
            if (!this._leaderboardsTemplate)
                throw "Please, provide a html template for leaderboards with the setTemplates method";
            var dialog = new CocoonJS.App.WebDialog();
            var callbackSent = false;
            dialog.show(this._leaderboardsTemplate, function(error) {
                dialog.closed = true;
                if (!callbackSent && callback)
                    callback(error);
            });
            var me = this;
            this.fb.api(me.fb._appId + "/scores", function(response) {
                if (dialog.closed)
                    return;
                if (response.error) {
                    if (callback) {
                        callbackSent = true;
                        callback(response.error);
                        dialog.close();
                    }
                    return;
                }
                var scores = [];
                if (response.data && response.data.length) {
                    for (var i = 0; i< response.data.length; ++i) {
                        var score = fromFBScoreToCocoonScore(response.data[i]);
                        score.position = i;
                        score.imageURL = "https://graph.facebook.com/" + score.userID + "/picture";
                        score.me = score.userID === me.fb._currentSession.authResponse.userID;
                        scores.push(score);
                    }
                }
                var js = "addScores(" + JSON.stringify(scores) + ")";
                dialog.eval(js);
            });
        },

        //internal utility function
        prepareAchievements: function(reload, callback) {

            if (!this._cachedAchievements || reload) {
                var me = this;
                this.fb.api(this.fb._appId + '/achievements', function(response) {
                    if (!response.error) {
                        var achievements = [];
                        if (response.data) {
                            for (var i = 0; i < response.data.length; i++) {
                                achievements.push(fromFBAchievementToCocoonAchievement(response.data[i]))
                            }
                        }
                        me.setCachedAchievements(achievements);
                        callback(achievements, null);
                    }
                    else {
                        callback([], response.error);
                    }
                });
            }
            else {
                callback(this._cachedAchievements, null);
            }
        },

        requestAllAchievements : function(callback) {
            this.prepareAchievements(true, callback);
        },

        requestAchievements : function(callback, userID) {
            var me = this;
            this.prepareAchievements(false, function(allAchievements, error){

                if (error) {
                    callback([], error);
                    return;
                }
                var apiCall = (userID || "me") + "/achievements";
                me.fb.api(apiCall, function(response) {
                    if (!response.error) {
                        var achievements = [];
                        if (response.data) {
                            for (var i = 0; i < response.data.length; i++) {
                                var ach = me.findAchievement((response.data[i].achievement || response.data[i].data.achievement).id);
                                if (ach)
                                    achievements.push(ach);
                            }
                        }
                        callback(achievements, null);
                    }
                    else {
                        callback([], response.error);
                    }
                });

            });
        },
        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var achID = this.translateAchievementID(achievementID);
            var me = this;
            this.preparePublishAction(function(granted) {
                if (granted) {
                    me.fb.api("me/achievements", "POST", {achievement:achID}, function (response) {
                        if (callback) {
                            callback(response.error);
                        }
                    });
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }

            });
        },
        resetAchievements : function(callback) {
            var me = this;
            this.preparePublishAction(function(granted) {
                if (granted) {
                    me.requestAchievements(function(achievements, error){
                        if (error) {
                            if (callback)
                                callback(error);
                            return;
                        }
                        var someError = null;
                        var remaining = achievements.length;
                        for (var i = 0; i < achievements.length; ++i) {
                            me.fb.api("me/achievements", "DELETE", {achievement:achievements[i].fbAchievementData.url}, function (response) {
                                if (response.error) {
                                   someError = response.error;
                                }
                                remaining--;
                                if (remaining == 0 && callback) {
                                    callback(someError);
                                }
                            });
                        }

                    });
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }

            });
        },
        showAchievements : function(callback) {
            if (!this._achievementsTemplate)
                throw "Please, provide a html template for achievements with the setTemplates method";
            var dialog = new CocoonJS.App.WebDialog();
            var callbackSent = false;
            dialog.show(this._achievementsTemplate, function(error) {
                dialog.closed = true;
                if (!callbackSent && callback)
                    callback(error);
            });
            var me = this;
            this.requestAchievements(function(achievements, error){
                if (dialog.closed)
                    return;
                if (error) {
                    callbackSent = true;
                    if (callback)
                        callback(error);
                    return;
                }

                var achs = [];
                if (me._cachedAchievements) {
                    for (var i = 0; i < me._cachedAchievements.length; ++i) {
                        var ach = me._cachedAchievements[i];
                        achs.push(ach);
                        if (achievements && achievements.length) {
                            for (var j = 0; j< achievements.length; ++j) {
                                if (achievements[j].achievementID === ach.achievementID) {
                                    ach.achieved = true;
                                    break;
                                }
                            }
                        }
                    }
                }
                var js = "addAchievements(" + JSON.stringify(achs) + ");";
                dialog.eval(js);
            });
        }
    }

    CocoonJS.extend(CocoonJS.Social.SocialGamingServiceFacebook, CocoonJS.Social.SocialGamingService);

    /**
     *@ignore
     */
    function fromFBUserToCocoonUser (facebookUser) {
        return new CocoonJS.Social.User (facebookUser.id, facebookUser.username);
    }

    /**
     *@ignore
     */
    function fromCocoonMessageToFBMessage(message) {
        return {
            link: message.linkURL,
            description: message.message,
            name: message.linkText,
            caption: message.linkCaption,
            picture: message.mediaURL
        }
    }
    /**
     *@ignore
     */
    function fromFBScoreToCocoonScore(fbResponse, requestScoreParams) {
        var result = new CocoonJS.Social.Score(fbResponse.user.id, fbResponse.score, fbResponse.user.name);
        if (requestScoreParams) {
            result.leaderboardID = requestScoreParams.leaderboardID;
        }
        result.imageURL = 'https://graph.facebook.com/' + fbResponse.user.id + '/picture';
        return result;
    }
    /**
     *@ignore
     */
    function fromFBAchievementToCocoonAchievement(fbResponse) {
        var result = new CocoonJS.Social.Achievement (
            fbResponse.id,
            fbResponse.title,
            fbResponse.description,
            fbResponse.image[0].url,
            fbResponse.data.points
        );
        result.fbAchievementData = fbResponse;
        return result;
    }

    if (!navigator.isCocoonJS) {
        // Load the Facebook SDK
        var parent = document.getElementsByTagName('script')[0];
        var script = document.createElement('script');
        //script.async = true;
        var prot= location.protocol ? location.protocol : "http:"
        script.src = prot + "//connect.facebook.net/en_US/all.js";
        parent.parentNode.insertBefore(script, parent);
    }

})();;(function() {

    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.Social object must exist and be valid before creating a Social Local Storage extension object.");


    /**
     * @constructor
     */
    CocoonJS.Social.LocalStorageService = function() {
        CocoonJS.Social.LocalStorageService.superclass.constructor.call(this);
        this.fakeSocialService = true;
    }

    CocoonJS.Social.LocalStorageService.prototype = {

        loggedIn: false,
        keys: {
            score: "CocoonJS.Social.LocalStorageService.score",
            earnedAchievements: "CocoonJS.Social.LocalStorageService.earned"
        },
        isLoggedIn: function() {
            return this.loggedIn;
        },

        login : function(callback) {
            if (!this.loggedIn)
                this.onLoginStatusChanged.notifyEventListeners(true);
            this.loggedIn = true;
            if (callback)
                setTimeout(function(){callback(true)},0);
        },

        logout: function(callback) {
            if (this.loggedIn)
                this.onLoginStatusChanged.notifyEventListeners(true);
            this.loggedIn = false;

            if (callback)
                setTimeout(function(){callback()},0);
        },

        getLoggedInUser : function() {
            return new CocoonJS.Social.User("me", "LocalStorage");
        },

        requestUser: function(callback, userID) {
            var user = new CocoonJS.Social.User(userID || "me", "LocalStorage");
            if (callback)
                setTimeout(function(){callback(user)},0);
        },

        requestScore: function(callback, params) {
            var scoreItem = localStorage.getItem(this.keys.score);
            var score = parseInt(scoreItem) || 0;
            setTimeout(function(){callback(new CocoonJS.Social.Score("me", score))},0);
        },

        submitScore: function(score, callback, params ) {
            var scoreItem = localStorage.getItem(this.keys.score);
            var topScore = parseInt(scoreItem) || 0;
            if (score > topScore)
                localStorage.setItem(this.keys.score, score);
            if (callback)
                setTimeout(function(){callback()},0);
        },
        getLocalStorageEarnedAchievements: function() {
            var achievementsItem = localStorage.getItem(this.keys.earnedAchievements);
            var earned = [];
            if (achievementsItem) {
                var array = JSON.stringify(achievementsItem);
                if (array && array.length) {
                    earned = array;
                }
            }
            return earned;
        },
        requestAchievements : function(callback, userID) {
            var earned = this.getLocalStorageEarnedAchievements();
            setTimeout(function(){callback(earned)},0);
        },

        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var earned = this.getLocalStorageEarnedAchievements();
            var exists = false;
            for (var i = 0; i< earned.length; ++i) {
               if (earned[i] === achievementID) {
                   exists = true;
                   break;
               }
            }
            if (!exists) {
                earned.push(achievementID);
                localStorage.setItem(this.keys.earnedAchievements, JSON.stringify(earned));
            }

            if (callback)
                setTimeout(function(){callback()},0);
        },
        resetAchievements : function(callback) {
            localStorage.removeItem(this.keys.earnedAchievements);
            if (callback)
                setTimeout(function(){callback()},0);
        }
    };

    CocoonJS.extend(CocoonJS.Social.LocalStorageService, CocoonJS.Social.SocialGamingService);

    CocoonJS.Social.LocalStorage = new CocoonJS.Social.LocalStorageService();

})();;(function() {

    // The CocoonJS must exist before creating the extension.
    if (!window.CocoonJS) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    CocoonJS.Multiplayer = {};

	/**
	* This type represents the access to a native Multiplayer extension API.
    * This service allows to programmatically create matches to invite other players and to receive match invitations sent by other players.
    * Your game must authenticate the related social service before you can use this service.
	* @class
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.Multiplayer.MultiplayerService = function(nativeExtensionName, extensionName)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + nativeExtensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';

        var me = this;

        /**
         * This {@link CocoonJS.EventHandler} object allows listening to events called when an invitation has been received from another player and the user has accepted it
         * The invitation will start loading.
         * While the invitation is loading a system view might appear on the screen.
         * You should pause/stop your current game and prepare it to process a new match
         * @memberOf CocoonJS.Multiplayer.MultiplayerService
         */
        this.onInvitationReceived = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onInvitationReceived");
        /**
         * This {@link CocoonJS.EventHandler} object allows listening to events called when an accepted invitation has been loaded
         * The invitation is ready to be processed (start the match or handle the error)
         * @memberOf CocoonJS.Multiplayer.MultiplayerService
         * Received params: {CocoonJS.Multiplayer.Match} and error
         */
        this.onInvitationLoaded = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onInvitationLoaded", function(sourceListener, args){
            var matchID = args[0];
            var error = args[1];
            if (matchID && !error) {
                me.currentMatch =  new CocoonJS.Multiplayer.Match(me.nativeExtensionName, me.extensionName, matchID);
                sourceListener(me.currentMatch, null)
            }
            else {
                sourceListener(null, error);
            }
        });



        return this;
	};


	CocoonJS.Multiplayer.MultiplayerService.prototype = {

        currentMatch: null,

        /**
         * Presents a system View for the matchmaking and creates a new Match
         * @param {CocoonJS.Multiplayer.MatchRequest} matchRequest The parameters for the match
         * @param {Function} callback The callback function. Response parameters: {CocoonJS.Multiplayer.Match} and error;
         */
        findMatch : function(matchRequest, callback)  {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "findMatch", [matchRequest, function(matchID,error) {
                    if (matchID && !error) {
                        me.currentMatch =  new CocoonJS.Multiplayer.Match(me.nativeExtensionName, me.extensionName, matchID);
                        callback(me.currentMatch, null)
                    }
                    else {
                        callback(null, error);
                    }
                }], true);
            }
        },

        /**
         * Sends an automatch request to join the authenticated user to a match. It doesn't present a system view while waiting to other players.
         * @param  {CocoonJS.Multiplayer.MatchRequest} matchRequest The parameters for the match
         * @param {Function} callback The callback function. Response parameters: {CocoonJS.Multiplayer.Match} and error;
         */
        findAutoMatch : function(matchRequest, callback) {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "findAutoMatch", [matchRequest, function(matchID, error){
                    if (matchID && !error) {
                        me.currentMatch =  new CocoonJS.Multiplayer.Match(me.nativeExtensionName, me.extensionName, matchID);
                        callback(me.currentMatch, null)
                    }
                    else {
                        callback(null, error);
                    }
                }], true);
            }
        },

        /**
         * Cancels the ongoing automatch request
         */
        cancelAutoMatch : function() {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "cancelAutoMatch", [], true);
            }
        },

        /**
         * Automatically adds players to an ongoing match owned by the user.
         * @param {CocoonJS.Multiplayer.MatchRequest} matchRequest The parameters for the match
         * @param {CocoonJS.Multiplayer.Match} matchRequest The match where new players will be added
         * @param {Function} callback The callback function. Response parameters: error
         */
        addPlayersToMatch : function(matchRequest, match, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "addPlayersToMatch", [matchRequest, match.matchID, callback], true);
            }
        },
        /**
         * Get the current match reference.
         * @return {CocoonJS.Multiplayer.Match} the current match reference
         */
        getMatch : function() {
            return this.currentMatch;
        }
	};

	/**
	* This type provides a transmission network between a group of users.
	* The match might be returned before connections have been established between players. At this stage, all the players are in the process of connecting to each other.
	* Always check the getExpectedPlayerCount value before starting a match. When its value reaches zero, all expected players are connected, and your game can begin the match.
	* Do not forget to call the start method of the match when your game is ready to process received messages via onMatchDataReceived listener.
	* @class
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	* @param {number} matchID The match ID user for native service bridge.
	*/
	CocoonJS.Multiplayer.Match = function(nativeExtensionName, extensionName, matchID)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + nativeExtensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';
	    this.matchID = matchID;
	    var me = this;


	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a match receives data from the network
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchDataReceivedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} data The received data
	    * @param {string} playerID The playerID where the data is received from.
	    */
	    this.onMatchDataReceived = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchDataReceived", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1], args[2]);
	    		}
	    	});

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a player connection state changes.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchStateChangedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} playerID The player whose state has changed
	    * @param {CocoonJS.Multiplayer.ConnectionState} The new connection state of the player
	    */
	    this.onMatchStateChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchStateChanged", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1], args[2]);
	    		}
	    	});

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a netowrk connection with a player fails
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchConnectionWithPlayerFailedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} playerID The player whose state has changed
	    * @param {string} error The error message
	    */
	    this.onMatchConnectionWithPlayerFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchConnectionWithPlayerFailed", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1], args[2]);
	    		}
	    	});

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the match fails
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchFailedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} error The error message
	    */
	    this.onMatchFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchFailed", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1]);
	    		}
	    	});
	};

	CocoonJS.Multiplayer.Match.prototype = {

		/**
		* Start processing received messages. The user must call this method when the game is ready to process messages. Messages received before being prepared are stored and processed later.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		*/
		start : function() {
			if (this.nativeExtensionObjectAvailable) {
				CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "startMatch", [this.matchID], true);
			}
		},

		/**
		* Transmits data to all players connected to the match. The match queues the data and transmits it when the network becomes available.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		* @see CocoonJS.Multiplayer.Match.onMatchStateChanged
		* @see CocoonJS.Multiplayer.Match.onMatchConnectionWithPlayerFailed
		* @see CocoonJS.Multiplayer.Match.onMatchFailed
		* @param {string} data The data to transmit
		* @param {CocoonJS.Multiplayer.SendDataMode} sendMode The optional {@link CocoonJS.Multiplayer.SendDataMode} value. The default value is RELIABLE.
		* @return {boolean} TRUE if the data was successfully queued for transmission; FALSE if the match was unable to queue the data
		*/
		sendDataToAllPlayers : function(data, sendMode) {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "sendDataToAllPlayers", [this.matchID, data, sendMode]);
			}
		},

		/**
		* Transmits data to a list of connected players. The match queues the data and transmits it when the network becomes available.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		* @see CocoonJS.Multiplayer.Match.onMatchStateChanged
		* @see CocoonJS.Multiplayer.Match.onMatchConnectionWithPlayerFailed
		* @see CocoonJS.Multiplayer.Match.onMatchFailed
		* @param {string} data The data to transmit
		* @param {array} playerIDs An array containing the identifier strings for the list of players who should receive the data
		* @param {CocoonJS.Multiplayer.SendDataMode} sendMode The optional {@link CocoonJS.Multiplayer.SendDataMode} value. The default value is RELIABLE.
		* @return {boolean} TRUE if the data was successfully queued for transmission; FALSE if the match was unable to queue the data
		*/
		sendData : function(data, playerIDs,  sendMode) {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "sendData", [this.matchID, data, playerIDs, sendMode]);
			}
		},

		/**
		* Disconnects the local player from the match and releases the match. Calling disconnect notifies other players that you have left the match.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		* @see CocoonJS.Multiplayer.Match.onMatchStateChanged
		* @see CocoonJS.Multiplayer.Match.onMatchConnectionWithPlayerFailed
		* @see CocoonJS.Multiplayer.Match.onMatchFailed
		*/
		disconnect : function() {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "disconnect", [this.matchID], true);
			}
		},

		/**
		* Requests additional information of the current players in the match
        * @param {Function} callback The callback function. Response params: players array and error
		*/
		requestPlayersInfo : function(callback) {
			if (this.nativeExtensionObjectAvailable){
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestPlayersInfo", [this.matchID, callback], true);
			}
		},

		/**
		* Method to request the remaining players count who have not yet connected to the match.
		* @function
		* @return {number} The remaining number of players who have not yet connected to the match
		*/
		getExpectedPlayerCount : function() {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getExpectedPlayerCount", [this.matchID]);
			}
		},
		/**
		* This method returns an array with all the player identifiers taking part in the match.
		* @return {array} The player identifiers for the players in the match
		*/
		getPlayerIDs : function() {
			if (this.nativeExtensionObjectAvailable){
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getPlayerIDs", [this.matchID]);
			}
		},

        /**
         * Gets the local playerID taking part in the match.
         * @return {string} the playerID attached to the match manager.
         */
        getLocalPlayerID : function() {
            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLocalPlayerID", [this.matchID]);
            }
            return "";
        },

	};

	/**
	* This enum represents the modes to send data
	* @namespace
	* @enum
	*/
	CocoonJS.Multiplayer.SendDataMode =  {
		/**
		* The data is sent continuously until it is successfully received by the intended recipients or the connection times out
		*/
	    RELIABLE : 0,

		/**
		* The data is sent once and is not sent again if a transmission error occurs.
		*/
	    UNRELIABLE : 1
	};


	/**
	* This enum represents the connection state of a player
	* @namespace
	* @enum
	*/
	CocoonJS.Multiplayer.ConnectionState = {
		/**
		* The connection is in unknown state.
		*/
	    UNKNOWN : 0,

	    /**
		* The connection is in connected state.
		*/
	    CONNECTED : 1,

	    /**
		* The connection is in disconnected state.
		*/
	    DISCONNECTED : 2
	};

	/**
	* The data structure that represents the information of a player inside a multiplayer match.
	* @class
	* @constructor
	* @param {string} The id of the user.
	* @param {string} The name of the user.
	*/
	CocoonJS.Multiplayer.PlayerInfo = function(userID, userName) {
		/**
		* The id of the user.
		* @field
		* @type string
		*/
		this.userID = userID;

		/**
		* The name of the user.
		* @field
		* @type string
		*/
		this.userName = userName;
	};

	/**
	* This data structure is used to specify the parameters for a new new multiplayer match.
	* @class
	* @constructor
	* @param {number} minPlayers The minimum number of players that may join the match.
	* @param {number} maxPlayers The maximum number of players that may join the match.
	* @param {array}  [playersToInvite] Optional list of player identifers for players to invite to the match.
	* @param {number} [playerGroup] Optional number identifying a subset of players allowed to join the match.
	* @param {number} [playerAttributes] Optional mask that specifies the role that the local player would like to play in the game.
	*/
	CocoonJS.Multiplayer.MatchRequest = function(minPlayers, maxPlayers, playersToInvite, playerGroup, playerAttributes) {
		/**
		* The minimum number of players that may join the match.
		* @field
		* @type number
		*/
		this.minPlayers = minPlayers;

		/**
		* The maximum number of players that may join the match.
		* @field
		* @type number
		*/
		this.maxPlayers = maxPlayers;

		/**
		* Optional list of player identifers for players to invite to the match.
		* @field
		* @type Array
		*/
		this.playersToInvite = playersToInvite;

		/**
		* Optional number identifying a subset of players allowed to join the match.
		* @field
		* @type number
		*/
		this.playerGroup = playerGroup;

		/**
		* Optional mask that specifies the role that the local player would like to play in the game.
		* @field
		* @type number
		*/
		this.playerAttributes = playerAttributes;

		return this;
	};

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (!window) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (!window.CocoonJS.Multiplayer) throw("The CocoonJS.Multiplayer object must exist and be valid before creating a Game Center extension object.");

	/**
	* @namespace
	* This instance represents the extension object to access GameCenter Multiplayer API.
	* @see CocoonJS.Multiplayer.MultiplayerService
	*/
	CocoonJS.Multiplayer.GameCenter = new CocoonJS.Multiplayer.MultiplayerService("IDTK_SRV_MULTIPLAYER_GAMECENTER", "Multiplayer.GameCenter");
})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (!window.CocoonJS) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (!window.CocoonJS.Multiplayer) throw("The CocoonJS.Multiplayer object must exist and be valid before creating a Multiplayer Loopback extension object.");


    var loopbackServices = [];
    var indexCounter = 0;
    var matchServices = [];
    var matchCounter = 0;

    /**
     * This service provides a loopback implementation of the {@link CocoonJS.Multiplayer.MultiplayerService}
     * @constructor
     */
    CocoonJS.Multiplayer.LoopbackService = function() {

        CocoonJS.Multiplayer.LoopbackService.superclass.constructor.call(this, "dummy","dummy");
        loopbackServices.push(this);
        this.playerID = "" + indexCounter;
        indexCounter++;

    }

    CocoonJS.Multiplayer.LoopbackService.prototype =  {

        findMatch : function(request, callback)  {

            this.findMatchCallback = callback;

            //checks if the service is already added to the match list
            var exists = false;
            for (var i = 0; i< matchServices.length; ++i) {
                if (matchServices[i] === this) {
                    exists = true; break;
                }
            }
            if (!exists)
                matchServices.push(this);

            //Create the match is all required players are ready
            //TODO: check more conditions (playerGroup, playerAttributes) to complete a match
            if (matchServices.length >= request.minPlayers) {
                var playerIDs = [];
                //create playerIDs array
                for (var i = 0; i< matchServices.length; ++i) {
                    playerIDs.push(matchServices[i].getPlayerID());
                }

                //notify the found match to each manager
                for (var i = 0; i< matchServices.length; ++i) {
                    var match = new LoopbackMatch(matchServices[i]);
                    match.playerIDs = playerIDs.slice();
                    matchServices[i].currentMatch = match;
                    matchServices[i].findMatchCallback(match, null);
                }
                //clear pending list
                matchServices = [];
            }


        },
        findAutoMatch : function(matchRequest, callback) {
            this.findMatch(matchRequest,callback);
        },
        cancelAutoMatch : function() {

        },

        addPlayersToMatch : function(matchRequest, match, callback) {
            callback({message:"Not implemmented"});
        },
        getPlayerID : function() {
            return this.playerID;
        },

        getMatch : function() {
            return this.currentMatch;
        }
    }

    CocoonJS.extend(CocoonJS.Multiplayer.LoopbackService, CocoonJS.Multiplayer.MultiplayerService);

    var LoopbackMatch = function(service) {
        matchCounter++;
        LoopbackMatch.superclass.constructor.call(this, "","",matchCounter);
        this.started = false;
        this.disconnected = false;
        this.pendingData = [];
        this.service = service;
    }

    LoopbackMatch.prototype = {

        start : function() {
            var me = this;
            setTimeout(function() {
                me.started = true;
                for (var i = 0; i < me.pendingData.length; ++i) {
                    me.onMatchDataReceived.notifyEventListeners(me.matchID,me.pendingData[i].data, me.pendingData[i].player);
                }

            },0);

        },
        sendDataToAllPlayers : function(data, sendMode) {
            this.sendData(data, this.playerIDs, sendMode);
        },

        sendData : function(data, playerIDs,  sendMode) {
            var me = this;
            setTimeout(function() {
                for (var i = 0; i< loopbackServices.length; ++i) {
                    var destService = null;
                    for (var j = 0; j < playerIDs.length; ++j) {
                        if (playerIDs[j] === loopbackServices[i].getPlayerID()) {
                            destService = loopbackServices[i];
                        }
                    }
                    if (destService) {
                        destService.getMatch().notifyDataReceived(data,me.service.getPlayerID());
                    }
                }
            },0);
        },

        disconnect : function() {
            this.disconnected = true;
            for (var i = 0; i < this.playerIDs.length; ++i) {
                var p = this.playerIDs[i];
                for (var j = 0; j < loopbackServices.length; ++j) {
                    if (loopbackServices[j].getPlayerID() === p) {
                        var match = loopbackServices[i].getMatch();
                        if (!match.disconnected) {
                            match.onMatchStateChanged.notifyEventListeners(match, this.service.getPlayerID(), CocoonJS.Multiplayer.ConnectionState.DISCONNECTED);
                        }
                    }
                }
            }
        },

        requestPlayersInfo : function(callback) {
            var me = this;
            setTimeout(function() {
               var playersInfo = [];
                for (var i = 0; i < me.playerIDs.length; ++i) {
                    playersInfo[i] = {userID: me.playerIDs[i], userName: "Player" + me.playerIDs[i]};
                };
                callback(playersInfo);
            },1);
        },

        getExpectedPlayerCount : function() {
            return 0;
        },
        getPlayerIDs : function() {
            return this.playerIDs;
        },
        getLocalPlayerID: function() {
            return this.service.playerID;
        },
        notifyDataReceived: function(data, fromPlayer) {
            if (!this.started) {
                this.pendingData.push({data:data, player:fromPlayer});
            }
            else {
                this.onMatchDataReceived.notifyEventListeners(this.matchID,data,fromPlayer);
            }
        }

    };

    CocoonJS.extend(LoopbackMatch, CocoonJS.Multiplayer.Match);

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (!window) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (!window.CocoonJS.Multiplayer) throw("The CocoonJS.Multiplayer object must exist and be valid before creating a Google Play Games extension object.");

    /**
     * @namespace
     * This instance represents the extension object to access Google Play Games Multiplayer API.
     * @see CocoonJS.Multiplayer.MultiplayerService
     */
    CocoonJS.Multiplayer.GooglePlayGames = new CocoonJS.Multiplayer.MultiplayerService("IDTK_SRV_MULTIPLAYER_GPG", "Multiplayer.GooglePlayGames");
})();
;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS In-App Purchase extension.
    * @namespace
    */
    CocoonJS.Store = {};

    CocoonJS.Store.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_STORE !== 'undefined';

	/**
	* The data structure that represents the information of a product in the store.
	* @namespace
	* @constructor
	* @param {string} The id of the product.
	* @param {string} The alias of the product.
	* @param {CocoonJS.Store.ProductType} The product type @see CocoonJS.Store.ProductType.
	* @param {string} The title of the product.
	* @param {string} The description of the product.
	* @param {string} The localized price of the product.
	* @param {string} The URL of the asset to be downloaded for this purchase.
	*/
	CocoonJS.Store.ProductInfo = function(productAlias, productId, productType, title, description, price, localizedPrice, downloadURL)
	{
		/**
		* The id of the product.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The alias of the product.
		* @field
		* @type string
		*/
		this.productAlias = productAlias;

		/**
		* The product type @see CocoonJS.Store.ProductType
		* @field
		* @type CocoonJS.Store.ProductType
		*/
		this.productType = productType;

		/**
		* The title of the product.
		* @field
		* @type string
		*/
		this.title = title;

		/**
		* The description of the product.
		* @field
		* @type string
		*/
		this.description = description;

		/**
		* The price of the product.
		* @field
		* @type string
		*/
		this.price = price;

		/**
		* The localized price of the product.
		* @field
		* @type string
		*/
		this.localizedPrice = localizedPrice;

		/**
		* The URL of the asset to be downloaded for this purchase.
		* @field
		* @type string
		*/
		this.downloadURL = downloadURL;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.ProductType = 
	{
		/**
		* A consumable product. See platform documentation for further information.
		*/
	    CONSUMABLE : 0,

		/**
		* A non-cunsumable product. . See platform documentation for further information.
		*/
	    NON_CONSUMABLE : 1,

	    /**
		* An auto-renewable subscription. See platform documentation for further information.
		*/
	    AUTO_RENEWABLE_SUBSCRIPTION : 2,

	    /**
		* A free subscription. See platform documentation for further information.
		*/
	    FREE_SUBSCRIPTION : 3,

	    /**
		* A non-renewable subscription. See platform documentation for further information.
		*/
	    NON_RENEWABLE_SUBSCRIPTION : 4
	};

	/**
    * The predefined possible store types.
    * @namespace 
    */
	CocoonJS.Store.StoreType = 
	{
		/**
		* Apple AppStore
		*/
	    APP_STORE : 0,

	    /**
	    * Android Play Store
	    */
	    PLAY_STORE : 1,

		/**
		* Mock Store
		*/
		MOCK_STORE : 2,

		/**
	    * Amazon AppStore
	    */
	    CHROME_STORE : 3,

	    /**
	    * Amazon AppStore
	    */
	    AMAZON_STORE : 4,

	    /**
	    * Nook Store
	    */
	    NOOK_STORE : 5
	};

	/**
	* The data structure that represents the information of a purchase.
	* @namespace
	* @constructor
	* @param {string} The transaction id of a purchase.
	* @param {string} The time when the purchase was done in seconds since 1970.
	* @param {CocoonJS.Store.PurchaseState} The state of the purchase. @see CocoonJS.Store.PurchaseState
	* @param {string} The product id related to this purchase.
	* @param {number} The number of products of the productId kind purchased in this transaction.
	*/
	CocoonJS.Store.PurchaseInfo = function(transactionId, purchaseTime, purchaseState, productId, quantity)
	{
		/**
		* The transaction id of a purchase.
		* @field
		* @type string
		*/
		this.transactionId = transactionId;

		/**
		* The time when the purchase was done in seconds since 1970.
		* @field
		* @type string
		*/
		this.purchaseTime = purchaseTime;

		/**
		* The state of the purchase. @see CocoonJS.Store.PurchaseState
		* @field
		* @type CocoonJS.Store.PurchaseState
		*/
		this.purchaseState = purchaseState;

		/**
		* The product id related to this purchase.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The number of products of the productId kind purchased in this transaction.
		* @field
		* @type number
		*/
		this.quantity = quantity;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.PurchaseState = 
	{
		/**
		* The product has been successfully purchased. The transaction has ended successfully.
		*/
	    PURCHASED : 0,

		/**
		* The purchase has been canceled.
		*/
	    CANCELED : 1,

	    /**
		* The purchase has been refunded.
		*/
	    REFUNDED : 2,

	    /**
		* The purchase (subscriptions only) has expired and is no longer valid.
		*/
	    EXPIRED : 3
	};

	/**
	* Gets the name of the native store implementation. 
	* @return {CocoonJS.Store.StoreType} The store type
	* @function
	*/ 
	CocoonJS.Store.getStoreType = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getStoreType", arguments);
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Store.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") 
        {
            parameters = {};
        }
        else
        {
        	if (parameters['managed'] !== undefined) parameters['remote'] = parameters['managed'];
        	if (parameters['sandbox'] !== undefined) parameters['debug'] = parameters['sandbox'];
        }

		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "requestInitialization", arguments, true);
		}
	};

	/**
	* Starts the Store Service. 
	* This will make the system to initialize the Store Service and probably Store callbacks will start to be received after calling this method so you should have set your event handler before calling this method so don't lose any callback.
	* @function
	*/ 
	CocoonJS.Store.start = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "start", arguments);
		}
	};

	/**
	* This method allows you to check is the  Store service is available in this platform. 
	* Not all iOS and Android devices will have the Store service available so you should check if it is before calling any other method.
	* @function
	* @return {boolean} True if the service is available and false otherwise.
	*/ 
	CocoonJS.Store.canPurchase = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "canPurchase", arguments);
		}
	};

	/**
	* Fetches the products from the CocoonJS Cloud Compiling service store configuration. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @deprecated You should now use fetchProductsFromStore. We don't support cloud products now.
	* @function
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromServer = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromServer", arguments, true);
		}
	};

	/**
	* Fetches the products information from the Store. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @function
	* @param {array} productIds An array with the ids of the products to retrieve information from.
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromStore = function(productIds)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromStore", arguments, true);
		}
	};

	/**
	* Finish a purchase transaction and removes the transaction from the transaction queue. 
	* This method must be called after a purchase finishes successfully and the  {@link CocoonJS.Store.onProductPurchaseCompleted} callback has been received. 
	* If the purchase includes some asset to download from an external server this method must be called after the asset has been successfully downloaded. 
	* If you do not finish the transaction because the asset has not been correctly downloaded the {@link CocoonJS.Store.onProductPurchaseStarted} method will be called again later on.
	* @function
	* @param {string} transactionId The transactionId of the purchase to finish.
	*/ 
	CocoonJS.Store.finishPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "finishPurchase", arguments, true);
		}
	};

	/**
	* Consumes a purchase. This makes that product to be purchasable again. 
	* @function
	* @param {string} transactionId The transaction Id of the purchase to consume.
	* @param {string} productId The product Id of the product to be consumed.
	*/ 
	CocoonJS.Store.consumePurchase = function(transactionId, productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "consumePurchase", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeature", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id showing a modal progress dialog. 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.puchaseProductModal = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModal", arguments, true);
		}
	};

	/**
	* Request the purchase of a product given it's product id showing a dialog with a preview of the product (title and description). 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProductModalWithPreview = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModalWithPreview", arguments, true);
		}
	};

	/**
	* Returns if a product has been already purchased or not. 
	* @function
	* @param {string} productId The product id or alias of the product to be checked.
	* @returns {boolean} A flag that indicates whether the product has been already purchased (true) or not (false).
	*/
	CocoonJS.Store.isProductPurchased = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "isFeaturePurchased", arguments);
		}
	};

	/**
	* Restores all the purchases from the platform's market. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchases", arguments, true);
		}
	};

	/**
	* Restores all the purchases from the platform's market showing a modal progress dialog. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchasesModal = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchasesModal", arguments, true);
		}
	};

	/**
	* Returns all the products available to be purchased.
	* @function
	* @returns {array} An array with  all the {@link CocoonJS.Store.ProductInfo} objects available for purchase.
	*/
	CocoonJS.Store.getProducts = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getProducts", arguments);
		}
	};

	/**
	* Adds a product to the products local DB. 
	* @function
	* @param {CocoonJS.Store.ProductInfo} product The product to be added to the local products DB.
	*/
	CocoonJS.Store.addProduct = function(product)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addProduct", arguments);
		}
	};

	/**
	* Removes a product from the products local DB given its productId. 
	* @function
	* @param {string} productId The product or alias of the product to be removed from the local products DB.
	*/
	CocoonJS.Store.removeProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removeProduct", arguments);
		}
	};

	/**
	* Returns all the locally stored purchases.
	* @function
	* @returns {array} An array with all the {@link CocoonJS.Store.PurchaseInfo} completed purchases.
	*/
	CocoonJS.Store.getPurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getPurchases", arguments);
		}
	};

	/**
	* Adds a purchase to the local purchases DB. 
	* @function
	* @param {CocoonJS.Store.StorePurchase} purchase The purchase to be added.
	*/ 
	CocoonJS.Store.addPurchase = function(purchase)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addPurchase", arguments);
		}
	};

	/**
	* Removes a purchase from the local purchases DB given it's transaction id. 
	* @function
	* @param {string} transactionId The id of the transaction to be removed.
	*/ 
	CocoonJS.Store.removePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removePurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase cancel. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be canceled.
	*/
	CocoonJS.Store.cancelPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "cancelPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase refundment. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be refunded.
	*/
	CocoonJS.Store.refundPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "refundPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase expiration. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be expired.
	*/
	CocoonJS.Store.expirePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "expirePurchase", arguments);
		}
	};

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onProductsFetchStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchStarted");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has completed.
    * The callback function receives a parameter with an the valid products array.
    * @static
    * @event
    * @param {array} validProducts An array of {@link CocoonJS.Store.ProductInfo} objects representing all the valid fetched products.
    */
	CocoonJS.Store.onProductsFetchCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onProductsFetchFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product starts.
    * The callback function receives a parameters with the information of the purchased product @see CocoonJS.Store.ProductInfo.
    * @static
	* @event
    * @param {string} productId The product id of the product being purchased.
    */
	CocoonJS.Store.onProductPurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseStarted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a request for purchase verification has been received from the Store.
    * The callback function receives two parameters, one with the productId of the purchased product and another one with a JSON object containing the data to be verified.
    * In Andorid this JSON object will containt two keys: signedData and signature. You will need that information to verify the purchase against the backend server.
    * @static
    * @event
    * @param {string} productId The product id of the product to be verified.
    * @param {string} data The string with the data to be verified.
    */
	CocoonJS.Store.onProductPurchaseVerificationRequestReceived = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseVerificationRequestReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product succeeds.
    * The callback function receives as parameter the information of the purchase {@see CocoonJS.Store.PurchaseInfo}.
    * @static
    * @event
    * @param {CocoonJS.Store.PurchaseInfo} purchaseInfo The purchase info.
    */
	CocoonJS.Store.onProductPurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product fails.
    * The callback function receives a parameters with the product id and an error message.
    * @static
    * @event
    * @param {string} productId The product id.
    * @param {string} msg The error message.
    */
	CocoonJS.Store.onProductPurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has completed.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onRestorePurchasesFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesFailed");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has started.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase being consumed.
    */
	CocoonJS.Store.onConsumePurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has completed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the consumed purchase.
    */
	CocoonJS.Store.onConsumePurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has failed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase that couldn't be consumed.
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onConsumePurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseFailed");

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS camera extension API.
    * @namespace
    */
    CocoonJS.Camera = {};

    CocoonJS.Camera.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_CAMERA !== 'undefined';

    /**
    * The predefined possible camera types.
    * @namespace 
    */
	CocoonJS.Camera.CameraType = {
		/**
		* Represents the front camera on the device.
		*/
	    FRONT : "FRONT",

	    /**
	    * Represents the back camera on the device.
	    */
	    BACK : "BACK"
	};

    /**
    * The predefined possible camera video capturing image format types.
    * @namespace 
    */
	CocoonJS.Camera.CaptureFormatType = {
		/**
		*/
	    JPEG : "JPEG",

		/**
		*/
	    RGB_565 : "RGB_565",

		/**
		*/
	    NV21 : "NV21", 

		/**
		*/
	    NV16 : "NV16",

		/**
		*/
	    YUY2 : "YUY2",

		/**
		*/
	    YV12 : "YV12",

		/**
		*/
	    BGRA32 : "32BGRA"
	};

	/**
	* The data structure that represents the information of a camera. It includes all the information to be able to setup a camera to capture video or to take pictures.
	* @namespace
	*/
	CocoonJS.Camera.CameraInfo =  {
		/**
		* The index of the camera.
		*/
		cameraIndex : 0,

		/**
		* The type of the camera among the possible values in {@link CocoonJS.Camera.CameraType}.
		*/
		cameraType : CocoonJS.Camera.CameraType.BACK,

		/**
		* An array of {@link CocoonJS.Size} values that represent the supported video sizes for the camera.
		*/
		supportedVideoSizes : [],

		/**
		* An array of numbers that represent the supported video frame rates for the camera.
		*/
		supportedVideoFrameRates : [],

		/**
		* An array of {@link CocoonJS.Camera.CaptureFormatType} values that represent the supported video format types for the camera.
		*/
		supportedVideoCaptureImageFormats : []
	};

	/**
	* Returns the number of available camera in the platform/device.
	* @returns {number} The number of cameras available in the platform/device.
	*/
	CocoonJS.Camera.getNumberOfCameras = function()
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getNumberOfCameras", arguments);
		}
	};

	/**
	* Returns an array of {@link CocoonJS.Camera.CameraInfo} objects representing all the information of all the cameras available in the platform/device.
	* @returns {Array} An array of {@link CocoonJS.Camera.CameraInfo} objects.
	*/
	CocoonJS.Camera.getAllCamerasInfo = function()
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getAllCamerasInfo", arguments);
		}
	};

	/**
	* Returns the {@link CocoonJS.Camera.CameraInfo} object that represents all the information of the specified camera index in the platform/device.
	* @param {number} cameraIndex The index of the camera to get the info from. The index should be inside 0 and N (N being the value returned by {@link CocoonJS.Camera.getNumberOfCameras}).
	* @returns {CocoonJS.Camera.CameraInfo} The {@link CocoonJS.Camera.CameraInfo} of the given camera index.
	*/
	CocoonJS.Camera.getCameraInfoByIndex = function(cameraIndex)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getCameraInfoByIndex", arguments);
		}
	};

	/**
	* Returns the {@link CocoonJS.Camera.CameraInfo} object that represents all the information of the first camera of the specified type found in the platform/device.
	* @param {CocoonJS.Camera.CameraType} cameraType The type of the camera to get the info from. 
	* @returns {CocoonJS.Camera.CameraInfo} The {@link CocoonJS.Camera.CameraInfo} of the first camera of the given camera type that has been found in the platform/device.
	*/
	CocoonJS.Camera.getCameraInfoByType = function(cameraType)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getCameraInfoByType", arguments);
		}
	};

	/**
	* Starts a camera to capture video. The developer must specify at least the index of the camera to be used. Some other setup parameters can also be passed to control the video capture. A image object
	* that will be automatically updated with the captured frames is returned so the developer just need to draw the image in every frame. A null image object is returned if the setup did not work or there is
	* no available camera.
	* @param {number} cameraIndex The index of the camera to start video capture with.
	* @param captureWidth The hozirontal size of the video capture resolution. If the value does not correspond to any of the sizes supported by the camera, the closest one is used. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the maximum size available is used.
	* @param captureHeight The vertical size of the video capture resolution. If value does not correspond to any of the sizes supported by the camera, the closest one is used. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the maximum size available is used.
	* @param captureFrameRate The frame rate to capture the video at. If the value does not correspond to any of the frame rates supported by the camera, the closest one is used. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the maximum frame rate available is used.
	*Â @param captureImageFormat A value from the available {@link CocoonJS.Camera.CaptureFormatType} formats to specify the format of the images that will be captured. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the first available capture image format is used.
	* @returns {image} A image object that will automatically update itself with the captured frames or null if the camera capture could not start.
	*/
	CocoonJS.Camera.startCapturing = function(cameraIndex, captureWidth, captureHeight, captureFrameRate, captureImageFormat)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "startCapturing", arguments);
		}
	};

	/**
	* Stops a camera that is already started capturing video.
	* @param cameraIndex The index of the camera to stop capturing video.
	*/
	CocoonJS.Camera.stopCapturing = function(cameraIndex)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "stopCapturing", arguments);
		}
	};

	/**
	* Indicates if a camera is capturing video or not.
	* @param cameraIndex The index of the camera to check if is capturing video or not.
	* @returns {boolean} A flag indicating if the given camera (by index) is capturing video (true) or not (false).
	*/
	CocoonJS.Camera.isCapturing = function(cameraIndex)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "isCapturing", arguments);
		}
	};

})();;(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the functionalities related to OUYA android gaming control.
     * @namespace
     */
    CocoonJS.Gamepad = {};

    CocoonJS.Gamepad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.Gamepad !== 'undefined';

    /**
    * This enumeration simplifies the access to the indices for button and axis elements according to the HTML5 gamepad standard API specification.
    * You may use these values to access the buttons and axes arrays inside the Gamepad objects, according to the W3C gamepad API specification.
    * For example: 
    * gamepad.button[CocoonJS.Gamepad.BUTTON_LEFT_TRIGGER]; 
    * gamepad.axes[CocoonJS.Gamepad.AXIS_LEFT_JOYSTICK_X]; 
    * @namespace
    */
    CocoonJS.Gamepad.Indices = {
        /**
        * Represents the button 0 (the A on the XBOX controller, the O on the OUYA controller)
        */
        BUTTON_0                : 0, 
        /**
        * Represents the button 1 (the B on the XBOX controller, the A on the OUYA controller)
        */
        BUTTON_1                : 1,
        /**
        * Represents the button 2 (the X on the XBOX controller, the U on the OUYA controller)
        */
        BUTTON_2                : 2,
        /**
        * Represents the button 3 (the Y on the XBOX controller, the Y on the OUYA controller)
        */
        BUTTON_3                : 3,
        /**
        * Represents the left bumper button.
        */
        BUTTON_LEFT_BUMPER      : 4,
        /**
        * Represents the right bumper button.
        */
        BUTTON_RIGHT_BUMPER     : 5,
        
        /**
        * Represents the left trigger button.
        */
        BUTTON_LEFT_TRIGGER     : 6,
        /**
        * Represents the right trigger button.
        */
        BUTTON_RIGHT_TRIGGER    : 7,
        
        /**
        * Represents the left joystick button.
        */
        BUTTON_LEFT_JOYSTICK    : 10,
        /**
        * Represents the right joystick button.
        */
        BUTTON_RIGHT_JOYSTICK   : 11,
        /**
        * Represents the dpad up button.
        */
        BUTTON_DPAD_UP          : 12,
        /**
        * Represents the dpad down button.
        */
        BUTTON_DPAD_DOWN        : 13,
        /**
        * Represents the dpad left button.
        */
        BUTTON_DPAD_LEFT        : 14,
        /**
        * Represents the dpad right button.
        */
        BUTTON_DPAD_RIGHT       : 15,
        /**
        * Represents the menu button.
        */
        BUTTON_MENU             : 16,
        
        /**
        * Represents the left joystick horizontal axis.
        */
        AXIS_LEFT_JOYSTICK_X     : 0,
        /**
        * Represents the left joystick vertical axis.
        */
        AXIS_LEFT_JOYSTICK_Y     : 1,
        /**
        * Represents the right joystick horizontal axis.
        */
        AXIS_RIGHT_JOYSTICK_X    : 2,
        /**
        * Represents the right joystick vertical axis.
        */
        AXIS_RIGHT_JOYSTICK_Y    : 3
    };

    // If the extension is present and the navigator does not provide the gamepad API:
    // 1.- Add the getGamepads function to the navigator object.
    // 2.- Replace the window add and remove event listener functions to call to the extension for the gamepad related events.
    var systemSupportsGamepads = navigator["getGamepads"] || navigator["webkitGetGamepads"];
    if (systemSupportsGamepads) 
    {
        if (!navigator.getGamepads)
        {
            console.log("navigator.getGamepads does not exist.");
            if (navigator.webkitGetGamepads)
            {
                console.log("navigator.webkitGamepads exists, adding navigator.getGamepads to point to it.");
                navigator.getGamepads = navigator.webkitGetGamepads;
            }
            else
            {
                console.log("navigator.webkitGetGamepads does not exist either.");
            }
        }
    }
})();



;(function() {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw ("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the CocoonJS Notification extension.
     * @namespace
     */
    CocoonJS.Notification = {};

    CocoonJS.Notification.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_NOTIFICATION !== 'undefined';

    /**
     * The data structure that represents the information of a local notification.
     * @namespace
     * @constructor
     * @param {string} message The notification message.
     * @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
     * @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
     * @param {object} userData The JSON data to attached to the notification.
     * @param {string} contentBody The body content to be showed in the expanded notification information.
     * @param {string} contentTitle The title to be showed in the expanded notification information.
     * @param {number} date Time in millisecs from 1970 when the notification will be fired.
     */
    CocoonJS.Notification.createLocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime) {

        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "createLocalNotification", arguments);
        }
    };


    /**
     * The data structure that represents the information of a local notification.
     * @namespace
     * @constructor
     * @deprecated
     * @param {string} message The notification message.
     * @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
     * @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
     * @param {object} userData The JSON data to attached to the notification.
     * @param {string} contentBody The body content to be showed in the expanded notification information.
     * @param {string} contentTitle The title to be showed in the expanded notification information.
     * @param {number} date Time in millisecs from 1970 when the notification will be fired.
     */
    CocoonJS.Notification.LocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime) {
        //The id is initialized with -1 for compatibility issues.
        //The new way to use is createLocalNotification. These can be cancelled and the ID is sent from native code to the 
        this.id = -1;

        /**
         * The notification message.
         * @field
         * @type string
         */
        this.message = message;

        /**
         * A flag that indicates if the sound should be enabled for the notification.
         * @field
         * @type boolean
         */
        this.soundEnabled = soundEnabled;

        /**
         * (iOS only) The number that will appear in the badge of the application icon in the home screen.
         * @field
         * @type number
         */
        this.badgeNumber = badgeNumber;

        /**
         * The JSON data to attached to the notification.
         * @field
         * @type object
         */
        this.userData = userData;

        /**
         * (Android only) The body content to be showed in the expanded notification information.
         * @field
         * @type string
         */
        if (contentBody !== undefined)
            this.contentBody = contentBody;
        else
            this.contentBody = "";

        /**
         * (Android only) The title to be showed in the expanded notification information.
         * @field
         * @type string
         */
        if (contentTitle !== undefined)
            this.contentTitle = contentTitle;
        else
            this.contentTitle = "";

        /**
         * Time in millisecs from 1970 when the local notification will be fired
         * @field
         * @type number
         */
        var currentTime = new Date().getTime();
        if (scheduleTime !== undefined) {
            this.scheduleTime = scheduleTime;
        } else {
            this.scheduleTime = currentTime;
        }
    };

    /**
     * The data structure that represents the information of a push notification.
     * @namespace
     * @constructor
     * @param {string} message The notification message.
     * @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
     * @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
     * @param {object} userData The JSON data to attached to the notification.
     * @param {array} channels An array containing the channels names this notification will be delivered to.
     * @param {number} expirationTime A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
     * @param {number} expirationTimeInterval An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
     */
    CocoonJS.Notification.PushNotification = function(message, soundEnabled, badgeNumber, userData, channels, expirationTime, expirationTimeInterval) {
        /**
         * The notification message.
         * @field
         * @type string
         */
        this.message = message;

        /**
         * A flag that indicates if the sound should be enabled for the notification.
         * @field
         * @type boolean
         */
        this.soundEnabled = soundEnabled;

        /**
         * The number that will appear in the badge of the application icon in the home screen.
         * @field
         * @type number
         */
        this.badgeNumber = badgeNumber;

        /**
         * The JSON data to attached to the notification.
         * @field
         * @type object
         */
        this.userData = userData

        /**
         * An array containing the channels names this notification will be delivered to.
         * @field
         * @type array
         */
        this.channels = channels;

        /**
         * A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
         * @field
         * @type number
         */
        if (expirationTime !== undefined)
            this.expirationTime = expirationTime;
        else
            this.expirationTime = 0;

        /**
         * An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
         * @field
         * @type number
         */
        if (expirationTimeInterval !== undefined)
            this.expirationTimeInterval = expirationTimeInterval;
        else
            this.expirationTimeInterval = 0;
    };

    /**
     * Start processing received notifications. The user must call this method when the game is ready to process notifications. Notifications received before being prepared are stored and processed later.
     */
    CocoonJS.Notification.start = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "start", arguments);
        }
    };


    /**
     * Register to be able to receive push notifications.
     * The registration process is controlled using the {@link CocoonJS.Notification.onRegisterForPushNotificationsSucceed} and {@link CocoonJS.Notification.onRegisterForPushNotificationsFailed} event handlers.
     * @function
     * @see {CocoonJS.Notification.onRegisterForPushNotificationsSucceed}
     * @see {CocoonJS.Notification.onRegisterForPushNotificationsFailed}
     */
    CocoonJS.Notification.registerForPushNotifications = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "registerForPushNotifications", arguments, true);
        }
    };

    /**
     * Unregister from receiving push notifications.
     * The unregistration process is controlled using the {@link CocoonJS.Notification.onUnregisterForPushNotificationsSucceed} event handler.
     * @function
     * @see CocoonJS.Notification.onUnregisterForPushNotificationsSucceed
     */
    CocoonJS.Notification.unregisterForPushNotifications = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unregisterForPushNotifications", arguments, true);
        }
    };

    /**
     * Cancel the local notification with Id provided.
     * The last sent local notification will be remove from the notifications bar.
     * @function
     */
    CocoonJS.Notification.cancelLocalNotification = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments);
        }
    };

    /**
     * Cancel the last sent local notification.
     * The last sent local notification will be remove from the notifications bar.
     * @function
     */

    //TODO: Change this function to be an extension of cancelLocalNotification
    CocoonJS.Notification.cancelLastSentLocalNotificiation = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments, true);
        }
    };

    /**
     * Cancel all sent local notifications.
     * All the notifications will ve removed from the notifications bar.
     * @function
     */
    CocoonJS.Notification.cancelAllLocalNotifications = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelAllLocalNotifications", arguments);
        }
    };

    /**
     * Send a local notification.
     * @function
     * @param {CocoonJS.Notification.LocalNotification} localNotification The local notification to be sent.
     */
    CocoonJS.Notification.sendLocalNotification = function(localNotification) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendLocalNotification", arguments, true);
        }
    };

    /**
     * Subscribe to a channel in order to receive notifications targeted to that channel.
     * @function
     * @param {string} channel The channel id to subscribe to.
     */
    CocoonJS.Notification.subscribeToChannel = function(channel) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "subscribe", arguments, true);
        }
    };

    /**
     * Unsubscribe from a channel in order to stop receiving notifications targeted to it.
     * @function
     * @param {string} channel The channel id to unsubscribe from.
     */
    CocoonJS.Notification.unsubscribeFromChannel = function(channel) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unsubscribe", arguments, true);
        }
    };

    /**
     * Send a push notification.
     * @function
     * @param {CocoonJS.Notification.PushNotification} pushNotification The push notification object to be sent.
     * @see CocoonJS.Notification.onPushNotificationDeliverySucceed
     * @see CocoonJS.Notification.onPushNotificationDeliveryFailed
     */
    CocoonJS.Notification.sendPushNotification = function(pushNotification) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendPushNotification", arguments, true);
        }
    };

    /**
     * (iOS only) Set the badge number for this application.
     * This is useful if you want to modify the badge number set by a notification.
     * @function
     * @param {number} badgeNumber The number of the badge.
     */
    CocoonJS.Notification.setBadgeNumber = function(badgeNumber) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "setBadgeNumber", arguments);
        }
    };

    /**
     * (iOS only) Returns the current badge number.
     * @function
     * @returns {number} The badge number.
     */
    CocoonJS.Notification.getBadgeNumber = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getBadgeNumber", arguments);
        }
    };

    /**
     * Returns the last received user data from a Local notification.
     * @function
     * @returns {object} The last received user data from a Local notification.
     */
    CocoonJS.Notification.getLastReceivedLocalNotificationData = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedLocalNotificationData", arguments);
        }
    };

    /**
     * Returns the last received user data from a Push notification.
     * @function
     * @returns {object} The last received user data from a Push notification.
     */
    CocoonJS.Notification.getLastReceivedPushNotificationData = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedPushNotificationData", arguments);
        }
    };

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notification succeeds.
     * The callback function does not receive any parameter.
     * @static
     * @event
     * @param {string} token The token (apid or device token) received at registration time.
     * @memberOf CocoonJS.Notification
     */
    CocoonJS.Notification.onRegisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceRegistered");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the unregistration for push notifications succeeds.
     * The callback function does not receive any parameter.
     * @static
     * @event
     * @memberOf CocoonJS.Notification
     */
    CocoonJS.Notification.onUnregisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceUnregistered");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notifications fails.
     * The callback function receives a parameter with error information.
     * @static
     * @event
     * @param {string} msg The error message.
     */
    CocoonJS.Notification.onRegisterForPushNotificationsFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceFailedToRegister");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when a push notification is received.
     * The callback function receives a parameter with the userData of the received notification.
     * @static
     * @event
     * @param {object} userData An object with the notification userData information.
     */
    CocoonJS.Notification.onPushNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationReceived");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when a local notification is received.
     * The callback function receives a parameter with the userData of the received notification.
     * @static
     * @event
     * @param {object} userData An object with the notification userData information.
     */
    CocoonJS.Notification.onLocalNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "localNotificationReceived");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when a notification is successfully delivered.
     * The callback function receives a parameter with the notificationId of the delivered notification.
     * @static
     * @event
     * @param {string} userData A string with the notification userData information.
     */
    CocoonJS.Notification.onPushNotificationDeliverySucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationSuccessfullyDelivered");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the delivery of push a notification fails.
     * The callback function receives a parameter with error information.
     * @static
     * @event
     * @param {string} msg The error message.
     */
    CocoonJS.Notification.onPushNotificationDeliveryFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationDeliveryError");

})();
/*! CocoonJSExtensions - v2.0.0 - 2014-04-10 www.ludei.com */window.ext&&"undefined"!=typeof window.ext.IDTK_SRV_BOX2D?(window.Box2D={},window.Box2D.Dynamics={},window.Box2D.Dynamics.Joints={},window.Box2D.Common={},window.Box2D.Common.Math={},window.Box2D.Collision={},window.Box2D.Collision.Shapes={},function(){"use strict";function a(a){console.error(a)}var b=function(a,b){void 0===a&&(a=0),void 0===b&&(b=0),this.x=a,this.y=b};window.Box2D.Common.Math.b2Vec2=b,b.prototype.SetZero=function(){this.x=0,this.y=0},b.prototype.Set=function(a,b){void 0===a&&(a=0),void 0===b&&(b=0),this.x=a,this.y=b},b.prototype.SetV=function(b){void 0===b&&a("undefined 'v' in b2Vec2.SetV"),this.x=b.x,this.y=b.y},b.Make=function(a,c){return void 0===a&&(a=0),void 0===c&&(c=0),new b(a,c)},void 0===b.Get&&(b.Get=b.Make,b._freeCache=[],b.Free=function(){}),b.prototype.Copy=function(){return new b(this.x,this.y)},b.prototype.Add=function(b){void 0===b&&a("undefined 'v' in b2Vec2.Add"),this.x+=b.x,this.y+=b.y},b.prototype.Subtract=function(b){void 0===b&&a("undefined 'v' in b2Vec2.Subtract"),this.x-=b.x,this.y-=b.y},b.prototype.Multiply=function(a){void 0===a&&(a=0),this.x*=a,this.y*=a},b.prototype.Length=function(){return Math.sqrt(this.x*this.x+this.y*this.y)},b.prototype.LengthSquared=function(){return this.x*this.x+this.y*this.y},b.prototype.Normalize=function(){var a=Math.sqrt(this.x*this.x+this.y*this.y);if(a<Number.MIN_VALUE)return 0;var b=1/a;return this.x*=b,this.y*=b,a},b.prototype.NegativeSelf=function(){this.x=-this.x,this.y=-this.y};var c=function(){this.col1=new b,this.col2=new b,this.SetIdentity()};window.Box2D.Common.Math.b2Mat22=c,c.FromAngle=function(a){void 0===a&&(a=0);var b=new c;return b.Set(a),b},c.FromVV=function(a,b){var d=new c;return d.SetVV(a,b),d},c.prototype.Set=function(a){void 0===a&&(a=0);var b=Math.cos(a),c=Math.sin(a);this.col1.x=b,this.col2.x=-c,this.col1.y=c,this.col2.y=b},c.prototype.SetVV=function(a,b){this.col1.SetV(a),this.col2.SetV(b)},c.prototype.Copy=function(){var a=new c;return a.SetM(this),a},c.prototype.SetM=function(a){this.col1.SetV(a.col1),this.col2.SetV(a.col2)},c.prototype.AddM=function(a){this.col1.x+=a.col1.x,this.col1.y+=a.col1.y,this.col2.x+=a.col2.x,this.col2.y+=a.col2.y},c.prototype.SetIdentity=function(){this.col1.x=1,this.col2.x=0,this.col1.y=0,this.col2.y=1},c.prototype.SetZero=function(){this.col1.x=0,this.col2.x=0,this.col1.y=0,this.col2.y=0},c.prototype.GetAngle=function(){return Math.atan2(this.col1.y,this.col1.x)},c.prototype.GetInverse=function(a){var b=this.col1.x,c=this.col2.x,d=this.col1.y,e=this.col2.y,f=b*e-c*d;return 0!==f&&(f=1/f),a.col1.x=f*e,a.col2.x=-f*c,a.col1.y=-f*d,a.col2.y=f*b,a},c.prototype.Solve=function(a,b,c){void 0===b&&(b=0),void 0===c&&(c=0);var d=this.col1.x,e=this.col2.x,f=this.col1.y,g=this.col2.y,h=d*g-e*f;return 0!==h&&(h=1/h),a.x=h*(g*b-e*c),a.y=h*(d*c-f*b),a},c.prototype.Abs=function(){this.col1.Abs(),this.col2.Abs()};var d=function(a,d){this.position=new b,this.R=new c,void 0===a&&(a=null),void 0===d&&(d=null),a&&(this.position.SetV(a),this.R.SetM(d))};window.Box2D.Common.Math.b2Transform=d,d.prototype.Initialize=function(a,b){this.position.SetV(a),this.R.SetM(b)},d.prototype.SetIdentity=function(){this.position.SetZero(),this.R.SetIdentity()},d.prototype.Set=function(a){this.position.SetV(a.position),this.R.SetM(a.R)},d.prototype.SetAngle=function(){return Math.atan2(this.R.col1.y,this.R.col1.x)};var e=function(){};window.Box2D.Common.Math.b2Math=e,e.IsValid=function(a){return void 0===a&&(a=0),isFinite(a)},e.Dot=function(a,b){return a.x*b.x+a.y*b.y},e.CrossVV=function(a,b){return a.x*b.y-a.y*b.x},e.CrossVF=function(a,c){void 0===c&&(c=0);var d=new b(c*a.y,-c*a.x);return d},e.CrossFV=function(a,c){void 0===a&&(a=0);var d=new b(-a*c.y,a*c.x);return d},e.MulMV=function(c,d){void 0===d&&a("undefined 'v' in b2Math.MulMV");var e=new b(c.col1.x*d.x+c.col2.x*d.y,c.col1.y*d.x+c.col2.y*d.y);return e},e.MulTMV=function(a,c){var d=new b(e.Dot(c,a.col1),e.Dot(c,a.col2));return d},e.MulX=function(a,b){var c=e.MulMV(a.R,b);return c.x+=a.position.x,c.y+=a.position.y,c},e.MulXT=function(a,b){var c=e.SubtractVV(b,a.position),d=c.x*a.R.col1.x+c.y*a.R.col1.y;return c.y=c.x*a.R.col2.x+c.y*a.R.col2.y,c.x=d,c},e.AddVV=function(a,c){var d=new b(a.x+c.x,a.y+c.y);return d},e.SubtractVV=function(a,c){var d=new b(a.x-c.x,a.y-c.y);return d},e.Distance=function(a,b){var c=a.x-b.x,d=a.y-b.y;return Math.sqrt(c*c+d*d)},e.DistanceSquared=function(a,b){var c=a.x-b.x,d=a.y-b.y;return c*c+d*d},e.MulFV=function(a,c){void 0===a&&(a=0);var d=new b(a*c.x,a*c.y);return d},e.AddMM=function(a,b){var d=c.FromVV(e.AddVV(a.col1,b.col1),e.AddVV(a.col2,b.col2));return d},e.MulMM=function(a,b){var d=c.FromVV(e.MulMV(a,b.col1),e.MulMV(a,b.col2));return d},e.MulTMM=function(a,d){var f=new b(e.Dot(a.col1,d.col1),e.Dot(a.col2,d.col1)),g=new b(e.Dot(a.col1,d.col2),e.Dot(a.col2,d.col2)),h=c.FromVV(f,g);return h},e.Abs=function(a){return void 0===a&&(a=0),a>0?a:-a},e.AbsV=function(a){var c=new b(e.Abs(a.x),e.Abs(a.y));return c},e.AbsM=function(a){var b=c.FromVV(e.AbsV(a.col1),e.AbsV(a.col2));return b},e.Min=function(a,b){return void 0===a&&(a=0),void 0===b&&(b=0),b>a?a:b},e.MinV=function(a,c){var d=new b(e.Min(a.x,c.x),e.Min(a.y,c.y));return d},e.Max=function(a,b){return void 0===a&&(a=0),void 0===b&&(b=0),a>b?a:b},e.MaxV=function(a,c){var d=new b(e.Max(a.x,c.x),e.Max(a.y,c.y));return d},e.Clamp=function(a,b,c){return void 0===a&&(a=0),void 0===b&&(b=0),void 0===c&&(c=0),b>a?b:a>c?c:a},e.ClampV=function(a,b,c){return e.MaxV(b,e.MinV(a,c))},e.Swap=function(a,b){var c=a[0];a[0]=b[0],b[0]=c},e.Random=function(){return 2*Math.random()-1},e.RandomRange=function(a,b){void 0===a&&(a=0),void 0===b&&(b=0);var c=Math.random();return c=(b-a)*c+a},e.NextPowerOfTwo=function(a){return void 0===a&&(a=0),a|=a>>1&2147483647,a|=a>>2&1073741823,a|=a>>4&268435455,a|=a>>8&16777215,a|=a>>16&65535,a+1},e.IsPowerOfTwo=function(a){void 0===a&&(a=0);var b=a>0&&0===(a&a-1);return b},e.b2Vec2_zero=new b(0,0),e.b2Mat22_identity=c.FromVV(new b(1,0),new b(0,1)),e.b2Transform_identity=new d(e.b2Vec2_zero,e.b2Mat22_identity);var f=function(){this.e_aabbBit=4,this.e_centerOfMassBit=16,this.e_controllerBit=32,this.e_jointBit=2,this.e_pairBit=8,this.e_shapeBit=0};window.Box2D.Dynamics.b2DebugDraw=f,f.prototype.AppendFlags=function(){},f.prototype.ClearFlags=function(){},f.prototype.DrawCircle=function(){},f.prototype.DrawPolygon=function(){},f.prototype.DrawSegment=function(){},f.prototype.DrawSolidCircle=function(){},f.prototype.DrawSolidPolygon=function(){},f.prototype.DrawTransform=function(){},f.prototype.GetAlpha=function(){},f.prototype.GetDrawScale=function(){},f.prototype.GetFillAlpha=function(){},f.prototype.GetFlags=function(){},f.prototype.GetLineThickness=function(){},f.prototype.GetSprite=function(){},f.prototype.GetXFormScale=function(){},f.prototype.SetAlpha=function(){},f.prototype.SetDrawScale=function(){},f.prototype.SetFillAlpha=function(){},f.prototype.SetFlags=function(){},f.prototype.SetLineThickness=function(){},f.prototype.SetSprite=function(){},f.prototype.SetXFormScale=function(){};var g=function(){this.position=new b(0,0),this.linearVelocity=new b,this.userData=null,this.angle=0,this.linearVelocity.Set(0,0),this.angularVelocity=0,this.linearDamping=0,this.angularDamping=0,this.allowSleep=!0,this.awake=!0,this.fixedRotation=!1,this.bullet=!1,this.type=i.b2_staticBody,this.active=!0,this.inertiaScale=1};window.Box2D.Dynamics.b2BodyDef=g;var h=function(a,c,d,e){this.m_body=a,this.m_userData=c,this.m_fixtureID=d,this.m_shape={},this.m_shape.m_centroid=new b,this.m_isSensor=!1,this.m_density=e.density,this.m_friction=e.friction,this.m_restitution=e.restitution,this.m_isSensor=e.isSensor};window.Box2D.Dynamics.b2Fixture=h,h.prototype.GetBody=function(){return this.m_body},h.prototype.GetShape=function(){return console.log("fixture.GetShape not yet supported in CocoonJS Box2D binding"),null},h.prototype.GetUserData=function(){return this.m_userData},h.prototype.SetSensor=function(a){this.m_isSensor=a,window.ext.IDTK_SRV_BOX2D.makeCall("setSensor",this.m_body.m_world.m_worldID,this.m_fixtureID,this.m_isSensor)},h.prototype.IsSensor=function(){return this.m_isSensor},h.prototype.SetDensity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setDensity",this.m_body.m_world.m_worldID,this.m_fixtureID,a),this.m_density=a},h.prototype.SetFriction=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFriction",this.m_body.m_world.m_worldID,this.m_fixtureID,a),this.m_friction=a},h.prototype.SetRestitution=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setRestitution",this.m_body.m_world.m_worldID,this.m_fixtureID,a),this.m_restitution=a},h.prototype.GetDensity=function(){return this.m_density},h.prototype.GetFriction=function(){return this.m_friction},h.prototype.GetRestitution=function(){return this.m_restitution};var i=function(a,b){var e=a.userData;a.userData=null,this.m_world=b,this.m_xf=new d(a.position,c.FromAngle(a.angle)),this.m_fixtures=[],this.m_active=a.active,a.type===i.b2_staticBody&&(a.density=0),this.m_bodyID=window.ext.IDTK_SRV_BOX2D.makeCall("createBody",b.m_worldID,a),this.m_userData=e,a.userData=e};window.Box2D.Dynamics.b2Body=i,i.prototype.CreateFixture=function(a){var b=a.userData;a.userData=null;var c=window.ext.IDTK_SRV_BOX2D.makeCall("createFixture",this.m_world.m_worldID,this.m_bodyID,a);a.userData=b;var d=new h(this,b,c,a);return this.m_world.m_fixturesList[c]=d,this.m_fixtures.push(d),d},i.prototype.GetFixtureList=function(){return 0===this.m_fixtures.length?null:this.m_fixtures[0]},i.prototype.DestroyFixture=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteFixture",this.m_world.m_worldID,a.m_fixtureID),delete this.m_world.m_fixturesList[a.m_fixtureID]},i.prototype.SetPositionAndAngle=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("setBodyTransform",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b),this.m_xf.R.Set(b),this.m_xf.position.SetV(a)},i.prototype.GetPosition=function(){return this.m_xf.position},i.prototype.SetPosition=function(a){this.SetPositionAndAngle(a,this.GetAngle())},i.prototype.GetLinearVelocity=function(){var a=window.ext.IDTK_SRV_BOX2D.makeCall("getLinearVelocity",this.m_world.m_worldID,this.m_bodyID);return new b(a[0],a[1])},i.prototype.GetWorldCenter=function(){var a=window.ext.IDTK_SRV_BOX2D.makeCall("getWorldCenter",this.m_world.m_worldID,this.m_bodyID);return new b(a[0],a[1])},i.prototype.GetLocalCenter=function(){var a=window.ext.IDTK_SRV_BOX2D.makeCall("getLocalCenter",this.m_world.m_worldID,this.m_bodyID);return new b(a[0],a[1])},i.prototype.GetLocalPoint=function(a){return e.MulXT(this.m_xf,a)},i.prototype.ApplyImpulse=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyImpulse",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)},i.prototype.GetMass=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getMass",this.m_world.m_worldID,this.m_bodyID)},i.prototype.IsAwake=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("isAwake",this.m_world.m_worldID,this.m_bodyID)},i.prototype.GetAngularVelocity=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getAngularVelocity",this.m_world.m_worldID,this.m_bodyID)},i.prototype.SetFixedRotation=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFixedRotation",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetAwake=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAwake",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetLinearVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearVelocity",this.m_world.m_worldID,this.m_bodyID,a.x,a.y)},i.prototype.ApplyForceToCenter=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyForceToCenter",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b)},i.prototype.ApplyForce=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyForce",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)},i.prototype.ApplyTorque=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyTorque",this.m_world.m_worldID,this.m_bodyID,a,b)},i.prototype.SetLinearDamping=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearDamping",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetAngularVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAngularVelocity",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetType=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setType",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetActive=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setActive",this.m_world.m_worldID,this.m_bodyID,a),this.m_active=a},i.prototype.IsActive=function(){return this.m_active},i.prototype.GetAngle=function(){return this.m_xf.R.GetAngle()},i.prototype.SetAngle=function(a){void 0===a&&(a=0),this.SetPositionAndAngle(this.GetPosition(),a)},i.prototype.GetContactList=function(){for(var a=window.ext.IDTK_SRV_BOX2D.makeCall("getObjectContacts",this.m_world.m_worldID,this.m_bodyID),b=[],c=0;c<a.length;c++)b.push(this.m_world.m_bodyList[a[c]]);return b},i.prototype.SetUserData=function(a){this.m_userData=a},i.prototype.GetUserData=function(){return this.m_userData},i.prototype.GetWorld=function(){return this.m_world},window.Box2D.Dynamics.b2Body.b2_staticBody=0,window.Box2D.Dynamics.b2Body.b2_kinematicBody=1,window.Box2D.Dynamics.b2Body.b2_dynamicBody=2;var j=function(a,b,c){this.m_fixtureA=a,this.m_fixtureB=b,this.m_touching=c};window.Box2D.Dynamics.b2Contact=j,j.prototype.GetFixtureA=function(){return this.m_fixtureA},j.prototype.GetFixtureB=function(){return this.m_fixtureB},j.prototype.IsTouching=function(){return this.m_touching};var k=function(){};window.Box2D.Dynamics.b2ContactListener=k,k.prototype.BeginContact=function(){},k.prototype.EndContact=function(){},k.prototype.PreSolve=function(){},k.prototype.PostSolve=function(){},window.Box2D.Dynamics.b2ContactListener.b2_defaultListener=new k;var l=function(){};window.Box2D.Dynamics.b2ContactFilter=l;var m=function(a,b){this.m_bodyList=[],this.m_jointList=[],this.m_fixturesList=[],this.m_contactListener=null,this.m_jointsList=[],this.m_worldID=window.ext.IDTK_SRV_BOX2D.makeCall("createWorld",a.x,a.y,b)};window.Box2D.Dynamics.b2World=m,m.prototype.SetContactListener=function(a){this.m_contactListener=a},m.prototype.SetContactFilter=function(a){var b=a,c=this,d=function(a,d){var e=c.m_fixturesList[a],f=c.m_fixturesList[d];return b.ShouldCollide(e,f)};window.ext.IDTK_SRV_BOX2D.makeCall("setContactFilter",this.m_worldID,d)},m.prototype.CreateBody=function(a){var b=new i(a,this);return this.m_bodyList[b.m_bodyID]=b,b},m.prototype.DestroyBody=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteBody",this.m_worldID,a.m_bodyID),delete this.m_bodyList[a.m_bodyID];for(var b=0;b<a.m_fixtures.length;++b)delete this.m_fixturesList[a.m_fixtures[b].m_fixtureID]},m.prototype.CreateJoint=function(a){if(a.bodyA.m_bodyID!==a.bodyB.m_bodyID){var b=a.bodyA,c=a.bodyB;a.bodyA=b.m_bodyID,a.bodyB=c.m_bodyID;var d="createDistanceJoint";a.type===o.e_revoluteJoint&&(d="createRevoluteJoint");var e=new o(a);return e.m_jointID=window.ext.IDTK_SRV_BOX2D.makeCall(d,this.m_worldID,a),a.bodyA=b,a.bodyB=c,this.m_jointsList.push(e),e}},m.prototype.DestroyJoint=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("destroyJoint",this.m_worldID,a.m_jointID)},m.prototype.GetJointList=function(){if(0===this.m_jointsList.length)return null;for(var a=0;a<this.m_jointsList.length-1;++a)this.m_jointsList[a].next=this.m_jointsList[a+1];return this.m_jointsList[this.m_jointsList.length-1].next=null,this.m_jointsList[0]},m.prototype.SetContinuousPhysics=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setContinuous",this.m_worldID,a)},m.prototype.SetGravity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setGravity",this.m_worldID,a.x,a.y)},m.prototype.Step=function(a,b,c){var d,e=window.ext.IDTK_SRV_BOX2D.makeCall("step",this.m_worldID,a,b,c),f=e[0];for(d=1;4*f>=d;d+=4){var g=this.m_bodyList[e[d+0]];if(null===g)break;g.m_xf.position.Set(e[d+1],e[d+2]),g.m_xf.R.Set(e[d+3])}if(null!==this.m_contactListener){var h=window.ext.IDTK_SRV_BOX2D.makeCall("getLastContacts",this.m_worldID);for(f=h[0],d=1;3*f>=d;d+=3){var i=h[d+0],k=h[d+1],l=h[d+2],m=this.m_fixturesList[i],n=this.m_fixturesList[k];"undefined"!=typeof m&&"undefined"!=typeof n?this.m_contactListener.BeginContact(new j(m,n,l)):console.log("One of the fixtures in a contact DOESN'T EXIST!!")}}},m.prototype.ClearForces=function(){window.ext.IDTK_SRV_BOX2D.makeCall("clearForces",this.m_worldID)},m.prototype.SetDebugDraw=function(){},m.prototype.DrawDebugData=function(){},window.Box2D.Collision.Shapes.b2CircleShape=function(a){this.radius=a,this.type="circle"},window.Box2D.Collision.Shapes.b2PolygonShape=function(){this.SetAsBox=function(a,b){this.type="box",this.width=a,this.height=b},this.SetAsEdge=function(a,b){this.type="edge",this.p1x=a.x,this.p1y=a.y,this.p2x=b.x,this.p2y=b.y},this.SetAsArray=function(a,b){this.type="polygon",this.vertices=[];for(var c=0;b>c;c++)this.vertices.push(a[c].x),this.vertices.push(a[c].y)}};var n=function(){this.shape=null,this.userData=null,this.friction=.2,this.restitution=0,this.density=0,this.isSensor=!1,this.filter={categoryBits:1,maskBits:65535,groupIndex:0}};window.Box2D.Dynamics.b2FixtureDef=n;var o=function(a){this.bodyA=a.bodyA,this.bodyB=a.bodyB,this.userData=a.userData,this.type=a.type,this.next=null};window.Box2D.Dynamics.Joints.b2Joint=o,o.prototype.GetBodyA=function(){return this.bodyA},o.prototype.GetBodyB=function(){return this.bodyB},o.prototype.GetUserData=function(){return this.userData},o.prototype.GetType=function(){return this.type},o.prototype.GetNext=function(){return this.next},o.e_distanceJoint=0,o.e_revoluteJoint=1;var p=function(a,c,d,e){if(this.type=o.e_distanceJoint,this.localAnchorA=new b,this.localAnchorB=new b,this.userData=null,void 0!==a&&(this.bodyA=a),void 0!==c&&(this.bodyB=c),void 0!==d&&this.localAnchorA.SetV(d),void 0!==e&&this.localAnchorB.SetV(e),void 0!==d&&void 0!==e){var f=e.x-d.x,g=e.y-d.y;this.length=Math.sqrt(f*f+g*g)}this.frequencyHz=0,this.dampingRatio=0};window.Box2D.Dynamics.Joints.b2DistanceJointDef=p;var q=function(a,c,d,e){this.type=o.e_revoluteJoint,this.localAnchorA=new b,this.localAnchorB=new b,this.userData=null,void 0!==a&&(this.bodyA=a),void 0!==c&&(this.bodyB=c),void 0!==d&&this.localAnchorA.SetV(d),void 0!==e&&this.localAnchorB.SetV(e),this.referenceAngle=0,this.lowerAngle=0,this.upperAngle=0,this.maxMotorTorque=0,this.motorSpeed=0,this.enableLimit=!1,this.enableMotor=!1};q.prototype.Initialize=function(a,b,c){this.bodyA=a,this.bodyB=b,this.localAnchorA=this.bodyA.GetLocalPoint(c),this.localAnchorB=this.bodyB.GetLocalPoint(c),this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()},window.Box2D.Dynamics.Joints.b2RevoluteJointDef=q}()):console.log("The CocoonJS binding for Box2D has been ignored because ext.IDTK_SRV_BOX2D is not available");
(function() {
var cr = {};
cr.plugins_ = {};
cr.behaviors = {};
if (typeof Object.getPrototypeOf !== "function")
{
	if (typeof "test".__proto__ === "object")
	{
		Object.getPrototypeOf = function(object) {
			return object.__proto__;
		};
	}
	else
	{
		Object.getPrototypeOf = function(object) {
			return object.constructor.prototype;
		};
	}
}
(function(){
	cr.logexport = function (msg)
	{
		if (window.console && window.console.log)
			window.console.log(msg);
	};
	cr.seal = function(x)
	{
		return x;
	};
	cr.freeze = function(x)
	{
		return x;
	};
	cr.is_undefined = function (x)
	{
		return typeof x === "undefined";
	};
	cr.is_number = function (x)
	{
		return typeof x === "number";
	};
	cr.is_string = function (x)
	{
		return typeof x === "string";
	};
	cr.isPOT = function (x)
	{
		return x > 0 && ((x - 1) & x) === 0;
	};
	cr.nextHighestPowerOfTwo = function(x) {
		--x;
		for (var i = 1; i < 32; i <<= 1) {
			x = x | x >> i;
		}
		return x + 1;
	}
	cr.abs = function (x)
	{
		return (x < 0 ? -x : x);
	};
	cr.max = function (a, b)
	{
		return (a > b ? a : b);
	};
	cr.min = function (a, b)
	{
		return (a < b ? a : b);
	};
	cr.PI = Math.PI;
	cr.round = function (x)
	{
		return (x + 0.5) | 0;
	};
	cr.floor = function (x)
	{
		if (x >= 0)
			return x | 0;
		else
			return (x | 0) - 1;		// correctly round down when negative
	};
	cr.ceil = function (x)
	{
		var f = x | 0;
		return (f === x ? f : f + 1);
	};
	function Vector2(x, y)
	{
		this.x = x;
		this.y = y;
		cr.seal(this);
	};
	Vector2.prototype.offset = function (px, py)
	{
		this.x += px;
		this.y += py;
		return this;
	};
	Vector2.prototype.mul = function (px, py)
	{
		this.x *= px;
		this.y *= py;
		return this;
	};
	cr.vector2 = Vector2;
	cr.segments_intersect = function(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y)
	{
		var max_ax, min_ax, max_ay, min_ay, max_bx, min_bx, max_by, min_by;
		if (a1x < a2x)
		{
			min_ax = a1x;
			max_ax = a2x;
		}
		else
		{
			min_ax = a2x;
			max_ax = a1x;
		}
		if (b1x < b2x)
		{
			min_bx = b1x;
			max_bx = b2x;
		}
		else
		{
			min_bx = b2x;
			max_bx = b1x;
		}
		if (max_ax < min_bx || min_ax > max_bx)
			return false;
		if (a1y < a2y)
		{
			min_ay = a1y;
			max_ay = a2y;
		}
		else
		{
			min_ay = a2y;
			max_ay = a1y;
		}
		if (b1y < b2y)
		{
			min_by = b1y;
			max_by = b2y;
		}
		else
		{
			min_by = b2y;
			max_by = b1y;
		}
		if (max_ay < min_by || min_ay > max_by)
			return false;
		var dpx = b1x - a1x + b2x - a2x;
		var dpy = b1y - a1y + b2y - a2y;
		var qax = a2x - a1x;
		var qay = a2y - a1y;
		var qbx = b2x - b1x;
		var qby = b2y - b1y;
		var d = cr.abs(qay * qbx - qby * qax);
		var la = qbx * dpy - qby * dpx;
		if (cr.abs(la) > d)
			return false;
		var lb = qax * dpy - qay * dpx;
		return cr.abs(lb) <= d;
	};
	function Rect(left, top, right, bottom)
	{
		this.set(left, top, right, bottom);
		cr.seal(this);
	};
	Rect.prototype.set = function (left, top, right, bottom)
	{
		this.left = left;
		this.top = top;
		this.right = right;
		this.bottom = bottom;
	};
	Rect.prototype.copy = function (r)
	{
		this.left = r.left;
		this.top = r.top;
		this.right = r.right;
		this.bottom = r.bottom;
	};
	Rect.prototype.width = function ()
	{
		return this.right - this.left;
	};
	Rect.prototype.height = function ()
	{
		return this.bottom - this.top;
	};
	Rect.prototype.offset = function (px, py)
	{
		this.left += px;
		this.top += py;
		this.right += px;
		this.bottom += py;
		return this;
	};
	Rect.prototype.normalize = function ()
	{
		var temp = 0;
		if (this.left > this.right)
		{
			temp = this.left;
			this.left = this.right;
			this.right = temp;
		}
		if (this.top > this.bottom)
		{
			temp = this.top;
			this.top = this.bottom;
			this.bottom = temp;
		}
	};
	Rect.prototype.intersects_rect = function (rc)
	{
		return !(rc.right < this.left || rc.bottom < this.top || rc.left > this.right || rc.top > this.bottom);
	};
	Rect.prototype.intersects_rect_off = function (rc, ox, oy)
	{
		return !(rc.right + ox < this.left || rc.bottom + oy < this.top || rc.left + ox > this.right || rc.top + oy > this.bottom);
	};
	Rect.prototype.contains_pt = function (x, y)
	{
		return (x >= this.left && x <= this.right) && (y >= this.top && y <= this.bottom);
	};
	Rect.prototype.equals = function (r)
	{
		return this.left === r.left && this.top === r.top && this.right === r.right && this.bottom === r.bottom;
	};
	cr.rect = Rect;
	function Quad()
	{
		this.tlx = 0;
		this.tly = 0;
		this.trx = 0;
		this.try_ = 0;	// is a keyword otherwise!
		this.brx = 0;
		this.bry = 0;
		this.blx = 0;
		this.bly = 0;
		cr.seal(this);
	};
	Quad.prototype.set_from_rect = function (rc)
	{
		this.tlx = rc.left;
		this.tly = rc.top;
		this.trx = rc.right;
		this.try_ = rc.top;
		this.brx = rc.right;
		this.bry = rc.bottom;
		this.blx = rc.left;
		this.bly = rc.bottom;
	};
	Quad.prototype.set_from_rotated_rect = function (rc, a)
	{
		if (a === 0)
		{
			this.set_from_rect(rc);
		}
		else
		{
			var sin_a = Math.sin(a);
			var cos_a = Math.cos(a);
			var left_sin_a = rc.left * sin_a;
			var top_sin_a = rc.top * sin_a;
			var right_sin_a = rc.right * sin_a;
			var bottom_sin_a = rc.bottom * sin_a;
			var left_cos_a = rc.left * cos_a;
			var top_cos_a = rc.top * cos_a;
			var right_cos_a = rc.right * cos_a;
			var bottom_cos_a = rc.bottom * cos_a;
			this.tlx = left_cos_a - top_sin_a;
			this.tly = top_cos_a + left_sin_a;
			this.trx = right_cos_a - top_sin_a;
			this.try_ = top_cos_a + right_sin_a;
			this.brx = right_cos_a - bottom_sin_a;
			this.bry = bottom_cos_a + right_sin_a;
			this.blx = left_cos_a - bottom_sin_a;
			this.bly = bottom_cos_a + left_sin_a;
		}
	};
	Quad.prototype.offset = function (px, py)
	{
		this.tlx += px;
		this.tly += py;
		this.trx += px;
		this.try_ += py;
		this.brx += px;
		this.bry += py;
		this.blx += px;
		this.bly += py;
		return this;
	};
	var minresult = 0;
	var maxresult = 0;
	function minmax4(a, b, c, d)
	{
		if (a < b)
		{
			if (c < d)
			{
				if (a < c)
					minresult = a;
				else
					minresult = c;
				if (b > d)
					maxresult = b;
				else
					maxresult = d;
			}
			else
			{
				if (a < d)
					minresult = a;
				else
					minresult = d;
				if (b > c)
					maxresult = b;
				else
					maxresult = c;
			}
		}
		else
		{
			if (c < d)
			{
				if (b < c)
					minresult = b;
				else
					minresult = c;
				if (a > d)
					maxresult = a;
				else
					maxresult = d;
			}
			else
			{
				if (b < d)
					minresult = b;
				else
					minresult = d;
				if (a > c)
					maxresult = a;
				else
					maxresult = c;
			}
		}
	};
	Quad.prototype.bounding_box = function (rc)
	{
		minmax4(this.tlx, this.trx, this.brx, this.blx);
		rc.left = minresult;
		rc.right = maxresult;
		minmax4(this.tly, this.try_, this.bry, this.bly);
		rc.top = minresult;
		rc.bottom = maxresult;
	};
	Quad.prototype.contains_pt = function (x, y)
	{
		var v0x = this.trx - this.tlx;
		var v0y = this.try_ - this.tly;
		var v1x = this.brx - this.tlx;
		var v1y = this.bry - this.tly;
		var v2x = x - this.tlx;
		var v2y = y - this.tly;
		var dot00 = v0x * v0x + v0y * v0y
		var dot01 = v0x * v1x + v0y * v1y
		var dot02 = v0x * v2x + v0y * v2y
		var dot11 = v1x * v1x + v1y * v1y
		var dot12 = v1x * v2x + v1y * v2y
		var invDenom = 1.0 / (dot00 * dot11 - dot01 * dot01);
		var u = (dot11 * dot02 - dot01 * dot12) * invDenom;
		var v = (dot00 * dot12 - dot01 * dot02) * invDenom;
		if ((u >= 0.0) && (v > 0.0) && (u + v < 1))
			return true;
		v0x = this.blx - this.tlx;
		v0y = this.bly - this.tly;
		var dot00 = v0x * v0x + v0y * v0y
		var dot01 = v0x * v1x + v0y * v1y
		var dot02 = v0x * v2x + v0y * v2y
		invDenom = 1.0 / (dot00 * dot11 - dot01 * dot01);
		u = (dot11 * dot02 - dot01 * dot12) * invDenom;
		v = (dot00 * dot12 - dot01 * dot02) * invDenom;
		return (u >= 0.0) && (v > 0.0) && (u + v < 1);
	};
	Quad.prototype.at = function (i, xory)
	{
		if (xory)
		{
			switch (i)
			{
				case 0: return this.tlx;
				case 1: return this.trx;
				case 2: return this.brx;
				case 3: return this.blx;
				case 4: return this.tlx;
				default: return this.tlx;
			}
		}
		else
		{
			switch (i)
			{
				case 0: return this.tly;
				case 1: return this.try_;
				case 2: return this.bry;
				case 3: return this.bly;
				case 4: return this.tly;
				default: return this.tly;
			}
		}
	};
	Quad.prototype.midX = function ()
	{
		return (this.tlx + this.trx  + this.brx + this.blx) / 4;
	};
	Quad.prototype.midY = function ()
	{
		return (this.tly + this.try_ + this.bry + this.bly) / 4;
	};
	Quad.prototype.intersects_segment = function (x1, y1, x2, y2)
	{
		if (this.contains_pt(x1, y1) || this.contains_pt(x2, y2))
			return true;
		var a1x, a1y, a2x, a2y;
		var i;
		for (i = 0; i < 4; i++)
		{
			a1x = this.at(i, true);
			a1y = this.at(i, false);
			a2x = this.at(i + 1, true);
			a2y = this.at(i + 1, false);
			if (cr.segments_intersect(x1, y1, x2, y2, a1x, a1y, a2x, a2y))
				return true;
		}
		return false;
	};
	Quad.prototype.intersects_quad = function (rhs)
	{
		var midx = rhs.midX();
		var midy = rhs.midY();
		if (this.contains_pt(midx, midy))
			return true;
		midx = this.midX();
		midy = this.midY();
		if (rhs.contains_pt(midx, midy))
			return true;
		var a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y;
		var i, j;
		for (i = 0; i < 4; i++)
		{
			for (j = 0; j < 4; j++)
			{
				a1x = this.at(i, true);
				a1y = this.at(i, false);
				a2x = this.at(i + 1, true);
				a2y = this.at(i + 1, false);
				b1x = rhs.at(j, true);
				b1y = rhs.at(j, false);
				b2x = rhs.at(j + 1, true);
				b2y = rhs.at(j + 1, false);
				if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
					return true;
			}
		}
		return false;
	};
	cr.quad = Quad;
	cr.RGB = function (red, green, blue)
	{
		return Math.max(Math.min(red, 255), 0)
			 | (Math.max(Math.min(green, 255), 0) << 8)
			 | (Math.max(Math.min(blue, 255), 0) << 16);
	};
	cr.GetRValue = function (rgb)
	{
		return rgb & 0xFF;
	};
	cr.GetGValue = function (rgb)
	{
		return (rgb & 0xFF00) >> 8;
	};
	cr.GetBValue = function (rgb)
	{
		return (rgb & 0xFF0000) >> 16;
	};
	cr.shallowCopy = function (a, b, allowOverwrite)
	{
		var attr;
		for (attr in b)
		{
			if (b.hasOwnProperty(attr))
			{
;
				a[attr] = b[attr];
			}
		}
		return a;
	};
	cr.arrayRemove = function (arr, index)
	{
		var i, len;
		index = cr.floor(index);
		if (index < 0 || index >= arr.length)
			return;							// index out of bounds
		if (index === 0)					// removing first item
			arr.shift();
		else if (index === arr.length - 1)	// removing last item
			arr.pop();
		else
		{
			for (i = index, len = arr.length - 1; i < len; i++)
				arr[i] = arr[i + 1];
			arr.length = len;
		}
	};
	cr.shallowAssignArray = function (dest, src)
	{
		dest.length = src.length;
		var i, len;
		for (i = 0, len = src.length; i < len; i++)
			dest[i] = src[i];
	};
	cr.appendArray = function (a, b)
	{
		a.push.apply(a, b);
	};
	cr.arrayFindRemove = function (arr, item)
	{
		var index = arr.indexOf(item);
		if (index !== -1)
			cr.arrayRemove(arr, index);
	};
	cr.clamp = function(x, a, b)
	{
		if (x < a)
			return a;
		else if (x > b)
			return b;
		else
			return x;
	};
	cr.to_radians = function(x)
	{
		return x / (180.0 / cr.PI);
	};
	cr.to_degrees = function(x)
	{
		return x * (180.0 / cr.PI);
	};
	cr.clamp_angle_degrees = function (a)
	{
		a %= 360;       // now in (-360, 360) range
		if (a < 0)
			a += 360;   // now in [0, 360) range
		return a;
	};
	cr.clamp_angle = function (a)
	{
		a %= 2 * cr.PI;       // now in (-2pi, 2pi) range
		if (a < 0)
			a += 2 * cr.PI;   // now in [0, 2pi) range
		return a;
	};
	cr.to_clamped_degrees = function (x)
	{
		return cr.clamp_angle_degrees(cr.to_degrees(x));
	};
	cr.to_clamped_radians = function (x)
	{
		return cr.clamp_angle(cr.to_radians(x));
	};
	cr.angleTo = function(x1, y1, x2, y2)
	{
		var dx = x2 - x1;
        var dy = y2 - y1;
		return Math.atan2(dy, dx);
	};
	cr.angleDiff = function (a1, a2)
	{
		if (a1 === a2)
			return 0;
		var s1 = Math.sin(a1);
		var c1 = Math.cos(a1);
		var s2 = Math.sin(a2);
		var c2 = Math.cos(a2);
		var n = s1 * s2 + c1 * c2;
		if (n >= 1)
			return 0;
		if (n <= -1)
			return cr.PI;
		return Math.acos(n);
	};
	cr.angleRotate = function (start, end, step)
	{
		var ss = Math.sin(start);
		var cs = Math.cos(start);
		var se = Math.sin(end);
		var ce = Math.cos(end);
		if (Math.acos(ss * se + cs * ce) > step)
		{
			if (cs * se - ss * ce > 0)
				return cr.clamp_angle(start + step);
			else
				return cr.clamp_angle(start - step);
		}
		else
			return cr.clamp_angle(end);
	};
	cr.angleClockwise = function (a1, a2)
	{
		var s1 = Math.sin(a1);
		var c1 = Math.cos(a1);
		var s2 = Math.sin(a2);
		var c2 = Math.cos(a2);
		return c1 * s2 - s1 * c2 <= 0;
	};
	cr.rotatePtAround = function (px, py, a, ox, oy, getx)
	{
		if (a === 0)
			return getx ? px : py;
		var sin_a = Math.sin(a);
		var cos_a = Math.cos(a);
		px -= ox;
		py -= oy;
		var left_sin_a = px * sin_a;
		var top_sin_a = py * sin_a;
		var left_cos_a = px * cos_a;
		var top_cos_a = py * cos_a;
		px = left_cos_a - top_sin_a;
		py = top_cos_a + left_sin_a;
		px += ox;
		py += oy;
		return getx ? px : py;
	}
	cr.distanceTo = function(x1, y1, x2, y2)
	{
		var dx = x2 - x1;
        var dy = y2 - y1;
		return Math.sqrt(dx*dx + dy*dy);
	};
	cr.xor = function (x, y)
	{
		return !x !== !y;
	};
	cr.lerp = function (a, b, x)
	{
		return a + (b - a) * x;
	};
	cr.unlerp = function (a, b, c)
	{
		if (a === b)
			return 0;		// avoid divide by 0
		return (c - a) / (b - a);
	};
	cr.anglelerp = function (a, b, x)
	{
		var diff = cr.angleDiff(a, b);
		if (cr.angleClockwise(b, a))
		{
			return a + diff * x;
		}
		else
		{
			return a - diff * x;
		}
	};
	cr.hasAnyOwnProperty = function (o)
	{
		var p;
		for (p in o)
		{
			if (o.hasOwnProperty(p))
				return true;
		}
		return false;
	};
	cr.wipe = function (obj)
	{
		var p;
		for (p in obj)
		{
			if (obj.hasOwnProperty(p))
				delete obj[p];
		}
	};
	var startup_time = +(new Date());
	cr.performance_now = function()
	{
		if (typeof window["performance"] !== "undefined")
		{
			var winperf = window["performance"];
			if (typeof winperf.now !== "undefined")
				return winperf.now();
			else if (typeof winperf["webkitNow"] !== "undefined")
				return winperf["webkitNow"]();
			else if (typeof winperf["mozNow"] !== "undefined")
				return winperf["mozNow"]();
			else if (typeof winperf["msNow"] !== "undefined")
				return winperf["msNow"]();
		}
		return Date.now() - startup_time;
	};
	var supports_set = ((typeof window === "undefined" || !window["c2ejecta"]) && (typeof Set !== "undefined" && typeof Set.prototype["forEach"] !== "undefined"));
	function ObjectSet_()
	{
		this.s = null;
		this.items = null;			// lazy allocated (hopefully results in better GC performance)
		this.item_count = 0;
		if (supports_set)
		{
			this.s = new Set();
		}
		this.values_cache = [];
		this.cache_valid = true;
		cr.seal(this);
	};
	ObjectSet_.prototype.contains = function (x)
	{
		if (this.isEmpty())
			return false;
		if (supports_set)
			return this.s["has"](x);
		else
			return (this.items && this.items.hasOwnProperty(x));
	};
	ObjectSet_.prototype.add = function (x)
	{
		if (supports_set)
		{
			if (!this.s["has"](x))
			{
				this.s["add"](x);
				this.cache_valid = false;
			}
		}
		else
		{
			var str = x.toString();
			var items = this.items;
			if (!items)
			{
				this.items = {};
				this.items[str] = x;
				this.item_count = 1;
				this.cache_valid = false;
			}
			else if (!items.hasOwnProperty(str))
			{
				items[str] = x;
				this.item_count++;
				this.cache_valid = false;
			}
		}
	};
	ObjectSet_.prototype.remove = function (x)
	{
		if (this.isEmpty())
			return;
		if (supports_set)
		{
			if (this.s["has"](x))
			{
				this.s["delete"](x);
				this.cache_valid = false;
			}
		}
		else if (this.items)
		{
			var str = x.toString();
			var items = this.items;
			if (items.hasOwnProperty(str))
			{
				delete items[str];
				this.item_count--;
				this.cache_valid = false;
			}
		}
	};
	ObjectSet_.prototype.clear = function (/*wipe_*/)
	{
		if (this.isEmpty())
			return;
		if (supports_set)
		{
			this.s["clear"]();			// best!
		}
		else
		{
				this.items = null;		// creates garbage; will lazy allocate on next add()
			this.item_count = 0;
		}
		this.values_cache.length = 0;
		this.cache_valid = true;
	};
	ObjectSet_.prototype.isEmpty = function ()
	{
		return this.count() === 0;
	};
	ObjectSet_.prototype.count = function ()
	{
		if (supports_set)
			return this.s["size"];
		else
			return this.item_count;
	};
	var current_arr = null;
	var current_index = 0;
	function set_append_to_arr(x)
	{
		current_arr[current_index++] = x;
	};
	ObjectSet_.prototype.update_cache = function ()
	{
		if (this.cache_valid)
			return;
		if (supports_set)
		{
			this.values_cache.length = this.s["size"];
			current_arr = this.values_cache;
			current_index = 0;
			this.s["forEach"](set_append_to_arr);
;
			current_arr = null;
			current_index = 0;
		}
		else
		{
			var values_cache = this.values_cache;
			values_cache.length = this.item_count;
			var p, n = 0, items = this.items;
			if (items)
			{
				for (p in items)
				{
					if (items.hasOwnProperty(p))
						values_cache[n++] = items[p];
				}
			}
;
		}
		this.cache_valid = true;
	};
	ObjectSet_.prototype.valuesRef = function ()
	{
		this.update_cache();
		return this.values_cache;
	};
	cr.ObjectSet = ObjectSet_;
	function KahanAdder_()
	{
		this.c = 0;
        this.y = 0;
        this.t = 0;
        this.sum = 0;
		cr.seal(this);
	};
	KahanAdder_.prototype.add = function (v)
	{
		this.y = v - this.c;
	    this.t = this.sum + this.y;
	    this.c = (this.t - this.sum) - this.y;
	    this.sum = this.t;
	};
    KahanAdder_.prototype.reset = function ()
    {
        this.c = 0;
        this.y = 0;
        this.t = 0;
        this.sum = 0;
    };
	cr.KahanAdder = KahanAdder_;
	cr.regexp_escape = function(text)
	{
		return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
	};
	function CollisionPoly_(pts_array_)
	{
		this.pts_cache = [];
		this.bboxLeft = 0;
		this.bboxTop = 0;
		this.bboxRight = 0;
		this.bboxBottom = 0;
		this.convexpolys = null;		// for physics behavior to cache separated polys
		this.set_pts(pts_array_);
		cr.seal(this);
	};
	CollisionPoly_.prototype.set_pts = function(pts_array_)
	{
		this.pts_array = pts_array_;
		this.pts_count = pts_array_.length / 2;			// x, y, x, y... in array
		this.pts_cache.length = pts_array_.length;
		this.cache_width = -1;
		this.cache_height = -1;
		this.cache_angle = 0;
	};
	CollisionPoly_.prototype.is_empty = function()
	{
		return !this.pts_array.length;
	};
	CollisionPoly_.prototype.update_bbox = function ()
	{
		var myptscache = this.pts_cache;
		var bboxLeft_ = myptscache[0];
		var bboxRight_ = bboxLeft_;
		var bboxTop_ = myptscache[1];
		var bboxBottom_ = bboxTop_;
		var x, y, i = 1, i2, len = this.pts_count;
		for ( ; i < len; ++i)
		{
			i2 = i*2;
			x = myptscache[i2];
			y = myptscache[i2+1];
			if (x < bboxLeft_)
				bboxLeft_ = x;
			if (x > bboxRight_)
				bboxRight_ = x;
			if (y < bboxTop_)
				bboxTop_ = y;
			if (y > bboxBottom_)
				bboxBottom_ = y;
		}
		this.bboxLeft = bboxLeft_;
		this.bboxRight = bboxRight_;
		this.bboxTop = bboxTop_;
		this.bboxBottom = bboxBottom_;
	};
	CollisionPoly_.prototype.set_from_rect = function(rc, offx, offy)
	{
		this.pts_cache.length = 8;
		this.pts_count = 4;
		var myptscache = this.pts_cache;
		myptscache[0] = rc.left - offx;
		myptscache[1] = rc.top - offy;
		myptscache[2] = rc.right - offx;
		myptscache[3] = rc.top - offy;
		myptscache[4] = rc.right - offx;
		myptscache[5] = rc.bottom - offy;
		myptscache[6] = rc.left - offx;
		myptscache[7] = rc.bottom - offy;
		this.cache_width = rc.right - rc.left;
		this.cache_height = rc.bottom - rc.top;
		this.update_bbox();
	};
	CollisionPoly_.prototype.set_from_quad = function(q, offx, offy, w, h)
	{
		this.pts_cache.length = 8;
		this.pts_count = 4;
		var myptscache = this.pts_cache;
		myptscache[0] = q.tlx - offx;
		myptscache[1] = q.tly - offy;
		myptscache[2] = q.trx - offx;
		myptscache[3] = q.try_ - offy;
		myptscache[4] = q.brx - offx;
		myptscache[5] = q.bry - offy;
		myptscache[6] = q.blx - offx;
		myptscache[7] = q.bly - offy;
		this.cache_width = w;
		this.cache_height = h;
		this.update_bbox();
	};
	CollisionPoly_.prototype.set_from_poly = function (r)
	{
		this.pts_count = r.pts_count;
		cr.shallowAssignArray(this.pts_cache, r.pts_cache);
		this.bboxLeft = r.bboxLeft;
		this.bboxTop - r.bboxTop;
		this.bboxRight = r.bboxRight;
		this.bboxBottom = r.bboxBottom;
	};
	CollisionPoly_.prototype.cache_poly = function(w, h, a)
	{
		if (this.cache_width === w && this.cache_height === h && this.cache_angle === a)
			return;		// cache up-to-date
		this.cache_width = w;
		this.cache_height = h;
		this.cache_angle = a;
		var i, i2, i21, len, x, y;
		var sina = 0;
		var cosa = 1;
		var myptsarray = this.pts_array;
		var myptscache = this.pts_cache;
		if (a !== 0)
		{
			sina = Math.sin(a);
			cosa = Math.cos(a);
		}
		for (i = 0, len = this.pts_count; i < len; i++)
		{
			i2 = i*2;
			i21 = i2+1;
			x = myptsarray[i2] * w;
			y = myptsarray[i21] * h;
			myptscache[i2] = (x * cosa) - (y * sina);
			myptscache[i21] = (y * cosa) + (x * sina);
		}
		this.update_bbox();
	};
	CollisionPoly_.prototype.contains_pt = function (a2x, a2y)
	{
		var myptscache = this.pts_cache;
		if (a2x === myptscache[0] && a2y === myptscache[1])
			return true;
		var i, i2, imod, len = this.pts_count;
		var a1x = this.bboxLeft - 110;
		var a1y = this.bboxTop - 101;
		var a3x = this.bboxRight + 131
		var a3y = this.bboxBottom + 120;
		var b1x, b1y, b2x, b2y;
		var count1 = 0, count2 = 0;
		for (i = 0; i < len; i++)
		{
			i2 = i*2;
			imod = ((i+1)%len)*2;
			b1x = myptscache[i2];
			b1y = myptscache[i2+1];
			b2x = myptscache[imod];
			b2y = myptscache[imod+1];
			if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
				count1++;
			if (cr.segments_intersect(a3x, a3y, a2x, a2y, b1x, b1y, b2x, b2y))
				count2++;
		}
		return (count1 % 2 === 1) || (count2 % 2 === 1);
	};
	CollisionPoly_.prototype.intersects_poly = function (rhs, offx, offy)
	{
		var rhspts = rhs.pts_cache;
		var mypts = this.pts_cache;
		if (this.contains_pt(rhspts[0] + offx, rhspts[1] + offy))
			return true;
		if (rhs.contains_pt(mypts[0] - offx, mypts[1] - offy))
			return true;
		var i, i2, imod, leni, j, j2, jmod, lenj;
		var a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y;
		for (i = 0, leni = this.pts_count; i < leni; i++)
		{
			i2 = i*2;
			imod = ((i+1)%leni)*2;
			a1x = mypts[i2];
			a1y = mypts[i2+1];
			a2x = mypts[imod];
			a2y = mypts[imod+1];
			for (j = 0, lenj = rhs.pts_count; j < lenj; j++)
			{
				j2 = j*2;
				jmod = ((j+1)%lenj)*2;
				b1x = rhspts[j2] + offx;
				b1y = rhspts[j2+1] + offy;
				b2x = rhspts[jmod] + offx;
				b2y = rhspts[jmod+1] + offy;
				if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
					return true;
			}
		}
		return false;
	};
	CollisionPoly_.prototype.intersects_segment = function (offx, offy, x1, y1, x2, y2)
	{
		var mypts = this.pts_cache;
		if (this.contains_pt(x1 - offx, y1 - offy))
			return true;
		var i, leni, i2, imod;
		var a1x, a1y, a2x, a2y;
		for (i = 0, leni = this.pts_count; i < leni; i++)
		{
			i2 = i*2;
			imod = ((i+1)%leni)*2;
			a1x = mypts[i2] + offx;
			a1y = mypts[i2+1] + offy;
			a2x = mypts[imod] + offx;
			a2y = mypts[imod+1] + offy;
			if (cr.segments_intersect(x1, y1, x2, y2, a1x, a1y, a2x, a2y))
				return true;
		}
		return false;
	};
	CollisionPoly_.prototype.mirror = function (px)
	{
		var i, leni, i2;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i2 = i*2;
			this.pts_cache[i2] = px * 2 - this.pts_cache[i2];
		}
	};
	CollisionPoly_.prototype.flip = function (py)
	{
		var i, leni, i21;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i21 = i*2+1;
			this.pts_cache[i21] = py * 2 - this.pts_cache[i21];
		}
	};
	CollisionPoly_.prototype.diag = function ()
	{
		var i, leni, i2, i21, temp;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i2 = i*2;
			i21 = i2+1;
			temp = this.pts_cache[i2];
			this.pts_cache[i2] = this.pts_cache[i21];
			this.pts_cache[i21] = temp;
		}
	};
	cr.CollisionPoly = CollisionPoly_;
	function SparseGrid_(cellwidth_, cellheight_)
	{
		this.cellwidth = cellwidth_;
		this.cellheight = cellheight_;
		this.cells = {};
	};
	SparseGrid_.prototype.totalCellCount = 0;
	SparseGrid_.prototype.getCell = function (x_, y_, create_if_missing)
	{
		var ret;
		var col = this.cells[x_];
		if (!col)
		{
			if (create_if_missing)
			{
				ret = allocGridCell(this, x_, y_);
				this.cells[x_] = {};
				this.cells[x_][y_] = ret;
				return ret;
			}
			else
				return null;
		}
		ret = col[y_];
		if (ret)
			return ret;
		else if (create_if_missing)
		{
			ret = allocGridCell(this, x_, y_);
			this.cells[x_][y_] = ret;
			return ret;
		}
		else
			return null;
	};
	SparseGrid_.prototype.XToCell = function (x_)
	{
		return cr.floor(x_ / this.cellwidth);
	};
	SparseGrid_.prototype.YToCell = function (y_)
	{
		return cr.floor(y_ / this.cellheight);
	};
	SparseGrid_.prototype.update = function (inst, oldrange, newrange)
	{
		var x, lenx, y, leny, cell;
		if (oldrange)
		{
			for (x = oldrange.left, lenx = oldrange.right; x <= lenx; ++x)
			{
				for (y = oldrange.top, leny = oldrange.bottom; y <= leny; ++y)
				{
					if (newrange && newrange.contains_pt(x, y))
						continue;	// is still in this cell
					cell = this.getCell(x, y, false);	// don't create if missing
					if (!cell)
						continue;	// cell does not exist yet
					cell.remove(inst);
					if (cell.isEmpty())
					{
						freeGridCell(cell);
						this.cells[x][y] = null;
					}
				}
			}
		}
		if (newrange)
		{
			for (x = newrange.left, lenx = newrange.right; x <= lenx; ++x)
			{
				for (y = newrange.top, leny = newrange.bottom; y <= leny; ++y)
				{
					if (oldrange && oldrange.contains_pt(x, y))
						continue;	// is still in this cell
					this.getCell(x, y, true).insert(inst);
				}
			}
		}
	};
	SparseGrid_.prototype.queryRange = function (rc, result)
	{
		var x, lenx, ystart, y, leny, cell;
		x = this.XToCell(rc.left);
		ystart = this.YToCell(rc.top);
		lenx = this.XToCell(rc.right);
		leny = this.YToCell(rc.bottom);
		for ( ; x <= lenx; ++x)
		{
			for (y = ystart; y <= leny; ++y)
			{
				cell = this.getCell(x, y, false);
				if (!cell)
					continue;
				cell.dump(result);
			}
		}
	};
	cr.SparseGrid = SparseGrid_;
	var gridcellcache = [];
	function allocGridCell(grid_, x_, y_)
	{
		var ret;
		SparseGrid_.prototype.totalCellCount++;
		if (gridcellcache.length)
		{
			ret = gridcellcache.pop();
			ret.grid = grid_;
			ret.x = x_;
			ret.y = y_;
			return ret;
		}
		else
			return new cr.GridCell(grid_, x_, y_);
	};
	function freeGridCell(c)
	{
		SparseGrid_.prototype.totalCellCount--;
		c.objects.clear();
		if (gridcellcache.length < 1000)
			gridcellcache.push(c);
	};
	function GridCell_(grid_, x_, y_)
	{
		this.grid = grid_;
		this.x = x_;
		this.y = y_;
		this.objects = new cr.ObjectSet();
	};
	GridCell_.prototype.isEmpty = function ()
	{
		return this.objects.isEmpty();
	};
	GridCell_.prototype.insert = function (inst)
	{
		this.objects.add(inst);
	};
	GridCell_.prototype.remove = function (inst)
	{
		this.objects.remove(inst);
	};
	GridCell_.prototype.dump = function (result)
	{
		cr.appendArray(result, this.objects.valuesRef());
	};
	cr.GridCell = GridCell_;
	var fxNames = [ "lighter",
					"xor",
					"copy",
					"destination-over",
					"source-in",
					"destination-in",
					"source-out",
					"destination-out",
					"source-atop",
					"destination-atop"];
	cr.effectToCompositeOp = function(effect)
	{
		if (effect <= 0 || effect >= 11)
			return "source-over";
		return fxNames[effect - 1];	// not including "none" so offset by 1
	};
	cr.setGLBlend = function(this_, effect, gl)
	{
		if (!gl)
			return;
		this_.srcBlend = gl.ONE;
		this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
		switch (effect) {
		case 1:		// lighter (additive)
			this_.srcBlend = gl.ONE;
			this_.destBlend = gl.ONE;
			break;
		case 2:		// xor
			break;	// todo
		case 3:		// copy
			this_.srcBlend = gl.ONE;
			this_.destBlend = gl.ZERO;
			break;
		case 4:		// destination-over
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.ONE;
			break;
		case 5:		// source-in
			this_.srcBlend = gl.DST_ALPHA;
			this_.destBlend = gl.ZERO;
			break;
		case 6:		// destination-in
			this_.srcBlend = gl.ZERO;
			this_.destBlend = gl.SRC_ALPHA;
			break;
		case 7:		// source-out
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.ZERO;
			break;
		case 8:		// destination-out
			this_.srcBlend = gl.ZERO;
			this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 9:		// source-atop
			this_.srcBlend = gl.DST_ALPHA;
			this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 10:	// destination-atop
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.SRC_ALPHA;
			break;
		}
	};
	cr.round6dp = function (x)
	{
		return cr.round(x * 1000000) / 1000000;
	};
	/*
	var localeCompare_options = {
		"usage": "search",
		"sensitivity": "accent"
	};
	var has_localeCompare = !!"a".localeCompare;
	var localeCompare_works1 = (has_localeCompare && "a".localeCompare("A", undefined, localeCompare_options) === 0);
	var localeCompare_works2 = (has_localeCompare && "a".localeCompare("á", undefined, localeCompare_options) !== 0);
	var supports_localeCompare = (has_localeCompare && localeCompare_works1 && localeCompare_works2);
	*/
	cr.equals_nocase = function (a, b)
	{
		if (typeof a !== "string" || typeof b !== "string")
			return false;
		if (a.length !== b.length)
			return false;
		if (a === b)
			return true;
		/*
		if (supports_localeCompare)
		{
			return (a.localeCompare(b, undefined, localeCompare_options) === 0);
		}
		else
		{
		*/
			return a.toLowerCase() === b.toLowerCase();
	};
}());
var MatrixArray=typeof Float32Array!=="undefined"?Float32Array:Array,glMatrixArrayType=MatrixArray,vec3={},mat3={},mat4={},quat4={};vec3.create=function(a){var b=new MatrixArray(3);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2]);return b};vec3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];return b};vec3.add=function(a,b,c){if(!c||a===c)return a[0]+=b[0],a[1]+=b[1],a[2]+=b[2],a;c[0]=a[0]+b[0];c[1]=a[1]+b[1];c[2]=a[2]+b[2];return c};
vec3.subtract=function(a,b,c){if(!c||a===c)return a[0]-=b[0],a[1]-=b[1],a[2]-=b[2],a;c[0]=a[0]-b[0];c[1]=a[1]-b[1];c[2]=a[2]-b[2];return c};vec3.negate=function(a,b){b||(b=a);b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];return b};vec3.scale=function(a,b,c){if(!c||a===c)return a[0]*=b,a[1]*=b,a[2]*=b,a;c[0]=a[0]*b;c[1]=a[1]*b;c[2]=a[2]*b;return c};
vec3.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=Math.sqrt(c*c+d*d+e*e);if(g){if(g===1)return b[0]=c,b[1]=d,b[2]=e,b}else return b[0]=0,b[1]=0,b[2]=0,b;g=1/g;b[0]=c*g;b[1]=d*g;b[2]=e*g;return b};vec3.cross=function(a,b,c){c||(c=a);var d=a[0],e=a[1],a=a[2],g=b[0],f=b[1],b=b[2];c[0]=e*b-a*f;c[1]=a*g-d*b;c[2]=d*f-e*g;return c};vec3.length=function(a){var b=a[0],c=a[1],a=a[2];return Math.sqrt(b*b+c*c+a*a)};vec3.dot=function(a,b){return a[0]*b[0]+a[1]*b[1]+a[2]*b[2]};
vec3.direction=function(a,b,c){c||(c=a);var d=a[0]-b[0],e=a[1]-b[1],a=a[2]-b[2],b=Math.sqrt(d*d+e*e+a*a);if(!b)return c[0]=0,c[1]=0,c[2]=0,c;b=1/b;c[0]=d*b;c[1]=e*b;c[2]=a*b;return c};vec3.lerp=function(a,b,c,d){d||(d=a);d[0]=a[0]+c*(b[0]-a[0]);d[1]=a[1]+c*(b[1]-a[1]);d[2]=a[2]+c*(b[2]-a[2]);return d};vec3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+"]"};
mat3.create=function(a){var b=new MatrixArray(9);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8]);return b};mat3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];return b};mat3.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=1;a[5]=0;a[6]=0;a[7]=0;a[8]=1;return a};
mat3.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[5];a[1]=a[3];a[2]=a[6];a[3]=c;a[5]=a[7];a[6]=d;a[7]=e;return a}b[0]=a[0];b[1]=a[3];b[2]=a[6];b[3]=a[1];b[4]=a[4];b[5]=a[7];b[6]=a[2];b[7]=a[5];b[8]=a[8];return b};mat3.toMat4=function(a,b){b||(b=mat4.create());b[15]=1;b[14]=0;b[13]=0;b[12]=0;b[11]=0;b[10]=a[8];b[9]=a[7];b[8]=a[6];b[7]=0;b[6]=a[5];b[5]=a[4];b[4]=a[3];b[3]=0;b[2]=a[2];b[1]=a[1];b[0]=a[0];return b};
mat3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+"]"};mat4.create=function(a){var b=new MatrixArray(16);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8],b[9]=a[9],b[10]=a[10],b[11]=a[11],b[12]=a[12],b[13]=a[13],b[14]=a[14],b[15]=a[15]);return b};
mat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=a[12];b[13]=a[13];b[14]=a[14];b[15]=a[15];return b};mat4.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=0;a[5]=1;a[6]=0;a[7]=0;a[8]=0;a[9]=0;a[10]=1;a[11]=0;a[12]=0;a[13]=0;a[14]=0;a[15]=1;return a};
mat4.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[3],g=a[6],f=a[7],h=a[11];a[1]=a[4];a[2]=a[8];a[3]=a[12];a[4]=c;a[6]=a[9];a[7]=a[13];a[8]=d;a[9]=g;a[11]=a[14];a[12]=e;a[13]=f;a[14]=h;return a}b[0]=a[0];b[1]=a[4];b[2]=a[8];b[3]=a[12];b[4]=a[1];b[5]=a[5];b[6]=a[9];b[7]=a[13];b[8]=a[2];b[9]=a[6];b[10]=a[10];b[11]=a[14];b[12]=a[3];b[13]=a[7];b[14]=a[11];b[15]=a[15];return b};
mat4.determinant=function(a){var b=a[0],c=a[1],d=a[2],e=a[3],g=a[4],f=a[5],h=a[6],i=a[7],j=a[8],k=a[9],l=a[10],n=a[11],o=a[12],m=a[13],p=a[14],a=a[15];return o*k*h*e-j*m*h*e-o*f*l*e+g*m*l*e+j*f*p*e-g*k*p*e-o*k*d*i+j*m*d*i+o*c*l*i-b*m*l*i-j*c*p*i+b*k*p*i+o*f*d*n-g*m*d*n-o*c*h*n+b*m*h*n+g*c*p*n-b*f*p*n-j*f*d*a+g*k*d*a+j*c*h*a-b*k*h*a-g*c*l*a+b*f*l*a};
mat4.inverse=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=a[4],h=a[5],i=a[6],j=a[7],k=a[8],l=a[9],n=a[10],o=a[11],m=a[12],p=a[13],r=a[14],s=a[15],A=c*h-d*f,B=c*i-e*f,t=c*j-g*f,u=d*i-e*h,v=d*j-g*h,w=e*j-g*i,x=k*p-l*m,y=k*r-n*m,z=k*s-o*m,C=l*r-n*p,D=l*s-o*p,E=n*s-o*r,q=1/(A*E-B*D+t*C+u*z-v*y+w*x);b[0]=(h*E-i*D+j*C)*q;b[1]=(-d*E+e*D-g*C)*q;b[2]=(p*w-r*v+s*u)*q;b[3]=(-l*w+n*v-o*u)*q;b[4]=(-f*E+i*z-j*y)*q;b[5]=(c*E-e*z+g*y)*q;b[6]=(-m*w+r*t-s*B)*q;b[7]=(k*w-n*t+o*B)*q;b[8]=(f*D-h*z+j*x)*q;
b[9]=(-c*D+d*z-g*x)*q;b[10]=(m*v-p*t+s*A)*q;b[11]=(-k*v+l*t-o*A)*q;b[12]=(-f*C+h*y-i*x)*q;b[13]=(c*C-d*y+e*x)*q;b[14]=(-m*u+p*B-r*A)*q;b[15]=(k*u-l*B+n*A)*q;return b};mat4.toRotationMat=function(a,b){b||(b=mat4.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
mat4.toMat3=function(a,b){b||(b=mat3.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[4];b[4]=a[5];b[5]=a[6];b[6]=a[8];b[7]=a[9];b[8]=a[10];return b};mat4.toInverseMat3=function(a,b){var c=a[0],d=a[1],e=a[2],g=a[4],f=a[5],h=a[6],i=a[8],j=a[9],k=a[10],l=k*f-h*j,n=-k*g+h*i,o=j*g-f*i,m=c*l+d*n+e*o;if(!m)return null;m=1/m;b||(b=mat3.create());b[0]=l*m;b[1]=(-k*d+e*j)*m;b[2]=(h*d-e*f)*m;b[3]=n*m;b[4]=(k*c-e*i)*m;b[5]=(-h*c+e*g)*m;b[6]=o*m;b[7]=(-j*c+d*i)*m;b[8]=(f*c-d*g)*m;return b};
mat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2],f=a[3],h=a[4],i=a[5],j=a[6],k=a[7],l=a[8],n=a[9],o=a[10],m=a[11],p=a[12],r=a[13],s=a[14],a=a[15],A=b[0],B=b[1],t=b[2],u=b[3],v=b[4],w=b[5],x=b[6],y=b[7],z=b[8],C=b[9],D=b[10],E=b[11],q=b[12],F=b[13],G=b[14],b=b[15];c[0]=A*d+B*h+t*l+u*p;c[1]=A*e+B*i+t*n+u*r;c[2]=A*g+B*j+t*o+u*s;c[3]=A*f+B*k+t*m+u*a;c[4]=v*d+w*h+x*l+y*p;c[5]=v*e+w*i+x*n+y*r;c[6]=v*g+w*j+x*o+y*s;c[7]=v*f+w*k+x*m+y*a;c[8]=z*d+C*h+D*l+E*p;c[9]=z*e+C*i+D*n+E*r;c[10]=z*g+C*
j+D*o+E*s;c[11]=z*f+C*k+D*m+E*a;c[12]=q*d+F*h+G*l+b*p;c[13]=q*e+F*i+G*n+b*r;c[14]=q*g+F*j+G*o+b*s;c[15]=q*f+F*k+G*m+b*a;return c};mat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1],b=b[2];c[0]=a[0]*d+a[4]*e+a[8]*b+a[12];c[1]=a[1]*d+a[5]*e+a[9]*b+a[13];c[2]=a[2]*d+a[6]*e+a[10]*b+a[14];return c};
mat4.multiplyVec4=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2],b=b[3];c[0]=a[0]*d+a[4]*e+a[8]*g+a[12]*b;c[1]=a[1]*d+a[5]*e+a[9]*g+a[13]*b;c[2]=a[2]*d+a[6]*e+a[10]*g+a[14]*b;c[3]=a[3]*d+a[7]*e+a[11]*g+a[15]*b;return c};
mat4.translate=function(a,b,c){var d=b[0],e=b[1],b=b[2],g,f,h,i,j,k,l,n,o,m,p,r;if(!c||a===c)return a[12]=a[0]*d+a[4]*e+a[8]*b+a[12],a[13]=a[1]*d+a[5]*e+a[9]*b+a[13],a[14]=a[2]*d+a[6]*e+a[10]*b+a[14],a[15]=a[3]*d+a[7]*e+a[11]*b+a[15],a;g=a[0];f=a[1];h=a[2];i=a[3];j=a[4];k=a[5];l=a[6];n=a[7];o=a[8];m=a[9];p=a[10];r=a[11];c[0]=g;c[1]=f;c[2]=h;c[3]=i;c[4]=j;c[5]=k;c[6]=l;c[7]=n;c[8]=o;c[9]=m;c[10]=p;c[11]=r;c[12]=g*d+j*e+o*b+a[12];c[13]=f*d+k*e+m*b+a[13];c[14]=h*d+l*e+p*b+a[14];c[15]=i*d+n*e+r*b+a[15];
return c};mat4.scale=function(a,b,c){var d=b[0],e=b[1],b=b[2];if(!c||a===c)return a[0]*=d,a[1]*=d,a[2]*=d,a[3]*=d,a[4]*=e,a[5]*=e,a[6]*=e,a[7]*=e,a[8]*=b,a[9]*=b,a[10]*=b,a[11]*=b,a;c[0]=a[0]*d;c[1]=a[1]*d;c[2]=a[2]*d;c[3]=a[3]*d;c[4]=a[4]*e;c[5]=a[5]*e;c[6]=a[6]*e;c[7]=a[7]*e;c[8]=a[8]*b;c[9]=a[9]*b;c[10]=a[10]*b;c[11]=a[11]*b;c[12]=a[12];c[13]=a[13];c[14]=a[14];c[15]=a[15];return c};
mat4.rotate=function(a,b,c,d){var e=c[0],g=c[1],c=c[2],f=Math.sqrt(e*e+g*g+c*c),h,i,j,k,l,n,o,m,p,r,s,A,B,t,u,v,w,x,y,z;if(!f)return null;f!==1&&(f=1/f,e*=f,g*=f,c*=f);h=Math.sin(b);i=Math.cos(b);j=1-i;b=a[0];f=a[1];k=a[2];l=a[3];n=a[4];o=a[5];m=a[6];p=a[7];r=a[8];s=a[9];A=a[10];B=a[11];t=e*e*j+i;u=g*e*j+c*h;v=c*e*j-g*h;w=e*g*j-c*h;x=g*g*j+i;y=c*g*j+e*h;z=e*c*j+g*h;e=g*c*j-e*h;g=c*c*j+i;d?a!==d&&(d[12]=a[12],d[13]=a[13],d[14]=a[14],d[15]=a[15]):d=a;d[0]=b*t+n*u+r*v;d[1]=f*t+o*u+s*v;d[2]=k*t+m*u+A*
v;d[3]=l*t+p*u+B*v;d[4]=b*w+n*x+r*y;d[5]=f*w+o*x+s*y;d[6]=k*w+m*x+A*y;d[7]=l*w+p*x+B*y;d[8]=b*z+n*e+r*g;d[9]=f*z+o*e+s*g;d[10]=k*z+m*e+A*g;d[11]=l*z+p*e+B*g;return d};mat4.rotateX=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[4],g=a[5],f=a[6],h=a[7],i=a[8],j=a[9],k=a[10],l=a[11];c?a!==c&&(c[0]=a[0],c[1]=a[1],c[2]=a[2],c[3]=a[3],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[4]=e*b+i*d;c[5]=g*b+j*d;c[6]=f*b+k*d;c[7]=h*b+l*d;c[8]=e*-d+i*b;c[9]=g*-d+j*b;c[10]=f*-d+k*b;c[11]=h*-d+l*b;return c};
mat4.rotateY=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[0],g=a[1],f=a[2],h=a[3],i=a[8],j=a[9],k=a[10],l=a[11];c?a!==c&&(c[4]=a[4],c[5]=a[5],c[6]=a[6],c[7]=a[7],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+i*-d;c[1]=g*b+j*-d;c[2]=f*b+k*-d;c[3]=h*b+l*-d;c[8]=e*d+i*b;c[9]=g*d+j*b;c[10]=f*d+k*b;c[11]=h*d+l*b;return c};
mat4.rotateZ=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[0],g=a[1],f=a[2],h=a[3],i=a[4],j=a[5],k=a[6],l=a[7];c?a!==c&&(c[8]=a[8],c[9]=a[9],c[10]=a[10],c[11]=a[11],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+i*d;c[1]=g*b+j*d;c[2]=f*b+k*d;c[3]=h*b+l*d;c[4]=e*-d+i*b;c[5]=g*-d+j*b;c[6]=f*-d+k*b;c[7]=h*-d+l*b;return c};
mat4.frustum=function(a,b,c,d,e,g,f){f||(f=mat4.create());var h=b-a,i=d-c,j=g-e;f[0]=e*2/h;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=e*2/i;f[6]=0;f[7]=0;f[8]=(b+a)/h;f[9]=(d+c)/i;f[10]=-(g+e)/j;f[11]=-1;f[12]=0;f[13]=0;f[14]=-(g*e*2)/j;f[15]=0;return f};mat4.perspective=function(a,b,c,d,e){a=c*Math.tan(a*Math.PI/360);b*=a;return mat4.frustum(-b,b,-a,a,c,d,e)};
mat4.ortho=function(a,b,c,d,e,g,f){f||(f=mat4.create());var h=b-a,i=d-c,j=g-e;f[0]=2/h;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=2/i;f[6]=0;f[7]=0;f[8]=0;f[9]=0;f[10]=-2/j;f[11]=0;f[12]=-(a+b)/h;f[13]=-(d+c)/i;f[14]=-(g+e)/j;f[15]=1;return f};
mat4.lookAt=function(a,b,c,d){d||(d=mat4.create());var e,g,f,h,i,j,k,l,n=a[0],o=a[1],a=a[2];g=c[0];f=c[1];e=c[2];c=b[1];j=b[2];if(n===b[0]&&o===c&&a===j)return mat4.identity(d);c=n-b[0];j=o-b[1];k=a-b[2];l=1/Math.sqrt(c*c+j*j+k*k);c*=l;j*=l;k*=l;b=f*k-e*j;e=e*c-g*k;g=g*j-f*c;(l=Math.sqrt(b*b+e*e+g*g))?(l=1/l,b*=l,e*=l,g*=l):g=e=b=0;f=j*g-k*e;h=k*b-c*g;i=c*e-j*b;(l=Math.sqrt(f*f+h*h+i*i))?(l=1/l,f*=l,h*=l,i*=l):i=h=f=0;d[0]=b;d[1]=f;d[2]=c;d[3]=0;d[4]=e;d[5]=h;d[6]=j;d[7]=0;d[8]=g;d[9]=i;d[10]=k;d[11]=
0;d[12]=-(b*n+e*o+g*a);d[13]=-(f*n+h*o+i*a);d[14]=-(c*n+j*o+k*a);d[15]=1;return d};mat4.fromRotationTranslation=function(a,b,c){c||(c=mat4.create());var d=a[0],e=a[1],g=a[2],f=a[3],h=d+d,i=e+e,j=g+g,a=d*h,k=d*i;d*=j;var l=e*i;e*=j;g*=j;h*=f;i*=f;f*=j;c[0]=1-(l+g);c[1]=k+f;c[2]=d-i;c[3]=0;c[4]=k-f;c[5]=1-(a+g);c[6]=e+h;c[7]=0;c[8]=d+i;c[9]=e-h;c[10]=1-(a+l);c[11]=0;c[12]=b[0];c[13]=b[1];c[14]=b[2];c[15]=1;return c};
mat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+", "+a[9]+", "+a[10]+", "+a[11]+", "+a[12]+", "+a[13]+", "+a[14]+", "+a[15]+"]"};quat4.create=function(a){var b=new MatrixArray(4);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3]);return b};quat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];return b};
quat4.calculateW=function(a,b){var c=a[0],d=a[1],e=a[2];if(!b||a===b)return a[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e)),a;b[0]=c;b[1]=d;b[2]=e;b[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e));return b};quat4.inverse=function(a,b){if(!b||a===b)return a[0]*=-1,a[1]*=-1,a[2]*=-1,a;b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];b[3]=a[3];return b};quat4.length=function(a){var b=a[0],c=a[1],d=a[2],a=a[3];return Math.sqrt(b*b+c*c+d*d+a*a)};
quat4.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=Math.sqrt(c*c+d*d+e*e+g*g);if(f===0)return b[0]=0,b[1]=0,b[2]=0,b[3]=0,b;f=1/f;b[0]=c*f;b[1]=d*f;b[2]=e*f;b[3]=g*f;return b};quat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2],a=a[3],f=b[0],h=b[1],i=b[2],b=b[3];c[0]=d*b+a*f+e*i-g*h;c[1]=e*b+a*h+g*f-d*i;c[2]=g*b+a*i+d*h-e*f;c[3]=a*b-d*f-e*h-g*i;return c};
quat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2],b=a[0],f=a[1],h=a[2],a=a[3],i=a*d+f*g-h*e,j=a*e+h*d-b*g,k=a*g+b*e-f*d,d=-b*d-f*e-h*g;c[0]=i*a+d*-b+j*-h-k*-f;c[1]=j*a+d*-f+k*-b-i*-h;c[2]=k*a+d*-h+i*-f-j*-b;return c};quat4.toMat3=function(a,b){b||(b=mat3.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,h=d+d,i=e+e,j=c*f,k=c*h;c*=i;var l=d*h;d*=i;e*=i;f*=g;h*=g;g*=i;b[0]=1-(l+e);b[1]=k+g;b[2]=c-h;b[3]=k-g;b[4]=1-(j+e);b[5]=d+f;b[6]=c+h;b[7]=d-f;b[8]=1-(j+l);return b};
quat4.toMat4=function(a,b){b||(b=mat4.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,h=d+d,i=e+e,j=c*f,k=c*h;c*=i;var l=d*h;d*=i;e*=i;f*=g;h*=g;g*=i;b[0]=1-(l+e);b[1]=k+g;b[2]=c-h;b[3]=0;b[4]=k-g;b[5]=1-(j+e);b[6]=d+f;b[7]=0;b[8]=c+h;b[9]=d-f;b[10]=1-(j+l);b[11]=0;b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
quat4.slerp=function(a,b,c,d){d||(d=a);var e=a[0]*b[0]+a[1]*b[1]+a[2]*b[2]+a[3]*b[3],g,f;if(Math.abs(e)>=1)return d!==a&&(d[0]=a[0],d[1]=a[1],d[2]=a[2],d[3]=a[3]),d;g=Math.acos(e);f=Math.sqrt(1-e*e);if(Math.abs(f)<0.001)return d[0]=a[0]*0.5+b[0]*0.5,d[1]=a[1]*0.5+b[1]*0.5,d[2]=a[2]*0.5+b[2]*0.5,d[3]=a[3]*0.5+b[3]*0.5,d;e=Math.sin((1-c)*g)/f;c=Math.sin(c*g)/f;d[0]=a[0]*e+b[0]*c;d[1]=a[1]*e+b[1]*c;d[2]=a[2]*e+b[2]*c;d[3]=a[3]*e+b[3]*c;return d};
quat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+"]"};
(function()
{
	var MAX_VERTICES = 8000;						// equates to 2500 objects being drawn
	var MAX_INDICES = (MAX_VERTICES / 2) * 3;		// 6 indices for every 4 vertices
	var MAX_POINTS = 8000;
	var MULTI_BUFFERS = 4;							// cycle 4 buffers to try and avoid blocking
	var BATCH_NULL = 0;
	var BATCH_QUAD = 1;
	var BATCH_SETTEXTURE = 2;
	var BATCH_SETOPACITY = 3;
	var BATCH_SETBLEND = 4;
	var BATCH_UPDATEMODELVIEW = 5;
	var BATCH_RENDERTOTEXTURE = 6;
	var BATCH_CLEAR = 7;
	var BATCH_POINTS = 8;
	var BATCH_SETPROGRAM = 9;
	var BATCH_SETPROGRAMPARAMETERS = 10;
	var BATCH_SETTEXTURE1 = 11;
	function GLWrap_(gl, isMobile)
	{
		this.isIE = /msie/i.test(navigator.userAgent) || /trident/i.test(navigator.userAgent);
		this.width = 0;		// not yet known, wait for call to setSize()
		this.height = 0;
		this.cam = vec3.create([0, 0, 100]);			// camera position
		this.look = vec3.create([0, 0, 0]);				// lookat position
		this.up = vec3.create([0, 1, 0]);				// up vector
		this.worldScale = vec3.create([1, 1, 1]);		// world scaling factor
		this.matP = mat4.create();						// perspective matrix
		this.matMV = mat4.create();						// model view matrix
		this.lastMV = mat4.create();
		this.currentMV = mat4.create();
		this.gl = gl;
		this.initState();
	};
	GLWrap_.prototype.initState = function ()
	{
		var gl = this.gl;
		var i, len;
		this.lastOpacity = 1;
		this.lastTexture0 = null;			// last bound to TEXTURE0
		this.lastTexture1 = null;			// last bound to TEXTURE1
		this.currentOpacity = 1;
		gl.clearColor(0, 0, 0, 0);
		gl.clear(gl.COLOR_BUFFER_BIT);
		gl.enable(gl.BLEND);
        gl.blendFunc(gl.ONE, gl.ONE_MINUS_SRC_ALPHA);
		gl.disable(gl.CULL_FACE);
		gl.disable(gl.DEPTH_TEST);
		this.maxTextureSize = gl.getParameter(gl.MAX_TEXTURE_SIZE);
		this.lastSrcBlend = gl.ONE;
		this.lastDestBlend = gl.ONE_MINUS_SRC_ALPHA;
		this.pointBuffer = gl.createBuffer();
		gl.bindBuffer(gl.ARRAY_BUFFER, this.pointBuffer);
		this.vertexBuffers = new Array(MULTI_BUFFERS);
		this.texcoordBuffers = new Array(MULTI_BUFFERS);
		for (i = 0; i < MULTI_BUFFERS; i++)
		{
			this.vertexBuffers[i] = gl.createBuffer();
			gl.bindBuffer(gl.ARRAY_BUFFER, this.vertexBuffers[i]);
			this.texcoordBuffers[i] = gl.createBuffer();
			gl.bindBuffer(gl.ARRAY_BUFFER, this.texcoordBuffers[i]);
		}
		this.curBuffer = 0;
		this.indexBuffer = gl.createBuffer();
		gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, this.indexBuffer);
		this.vertexData = new Float32Array(MAX_VERTICES * 2);
		this.texcoordData = new Float32Array(MAX_VERTICES * 2);
		this.pointData = new Float32Array(MAX_POINTS * 4);
		var indexData = new Uint16Array(MAX_INDICES);
		i = 0, len = MAX_INDICES;
		var fv = 0;
		while (i < len)
		{
			indexData[i++] = fv;		// top left
			indexData[i++] = fv + 1;	// top right
			indexData[i++] = fv + 2;	// bottom right (first tri)
			indexData[i++] = fv;		// top left
			indexData[i++] = fv + 2;	// bottom right
			indexData[i++] = fv + 3;	// bottom left
			fv += 4;
		}
		gl.bufferData(gl.ELEMENT_ARRAY_BUFFER, indexData, gl.STATIC_DRAW);
		this.vertexPtr = 0;
		this.pointPtr = 0;
		var fsSource, vsSource;
		this.shaderPrograms = [];
		fsSource = [
			"varying mediump vec2 vTex;",
			"uniform lowp float opacity;",
			"uniform lowp sampler2D samplerFront;",
			"void main(void) {",
			"	gl_FragColor = texture2D(samplerFront, vTex);",
			"	gl_FragColor *= opacity;",
			"}"
		].join("\n");
		vsSource = [
			"attribute highp vec2 aPos;",
			"attribute mediump vec2 aTex;",
			"varying mediump vec2 vTex;",
			"uniform highp mat4 matP;",
			"uniform highp mat4 matMV;",
			"void main(void) {",
			"	gl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);",
			"	vTex = aTex;",
			"}"
		].join("\n");
		var shaderProg = this.createShaderProgram({src: fsSource}, vsSource, "<default>");
;
		this.shaderPrograms.push(shaderProg);		// Default shader is always shader 0
		fsSource = [
			"uniform mediump sampler2D samplerFront;",
			"varying lowp float opacity;",
			"void main(void) {",
			"	gl_FragColor = texture2D(samplerFront, gl_PointCoord);",
			"	gl_FragColor *= opacity;",
			"}"
		].join("\n");
		var pointVsSource = [
			"attribute vec4 aPos;",
			"varying float opacity;",
			"uniform mat4 matP;",
			"uniform mat4 matMV;",
			"void main(void) {",
			"	gl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);",
			"	gl_PointSize = aPos.z;",
			"	opacity = aPos.w;",
			"}"
		].join("\n");
		shaderProg = this.createShaderProgram({src: fsSource}, pointVsSource, "<point>");
;
		this.shaderPrograms.push(shaderProg);		// Point shader is always shader 1
		for (var shader_name in cr.shaders)
		{
			if (cr.shaders.hasOwnProperty(shader_name))
				this.shaderPrograms.push(this.createShaderProgram(cr.shaders[shader_name], vsSource, shader_name));
		}
		gl.activeTexture(gl.TEXTURE0);
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.batch = [];
		this.batchPtr = 0;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
		this.lastProgram = -1;				// start -1 so first switchProgram can do work
		this.currentProgram = -1;			// current program during batch execution
		this.currentShader = null;
		this.fbo = gl.createFramebuffer();
		this.renderToTex = null;
		this.tmpVec3 = vec3.create([0, 0, 0]);
;
;
		var pointsizes = gl.getParameter(gl.ALIASED_POINT_SIZE_RANGE);
		this.minPointSize = pointsizes[0];
		this.maxPointSize = pointsizes[1];
;
		this.switchProgram(0);
		cr.seal(this);
	};
	function GLShaderProgram(gl, shaderProgram, name)
	{
		this.gl = gl;
		this.shaderProgram = shaderProgram;
		this.name = name;
		this.locAPos = gl.getAttribLocation(shaderProgram, "aPos");
		this.locATex = gl.getAttribLocation(shaderProgram, "aTex");
		this.locMatP = gl.getUniformLocation(shaderProgram, "matP");
		this.locMatMV = gl.getUniformLocation(shaderProgram, "matMV");
		this.locOpacity = gl.getUniformLocation(shaderProgram, "opacity");
		this.locSamplerFront = gl.getUniformLocation(shaderProgram, "samplerFront");
		this.locSamplerBack = gl.getUniformLocation(shaderProgram, "samplerBack");
		this.locDestStart = gl.getUniformLocation(shaderProgram, "destStart");
		this.locDestEnd = gl.getUniformLocation(shaderProgram, "destEnd");
		this.locSeconds = gl.getUniformLocation(shaderProgram, "seconds");
		this.locPixelWidth = gl.getUniformLocation(shaderProgram, "pixelWidth");
		this.locPixelHeight = gl.getUniformLocation(shaderProgram, "pixelHeight");
		this.locLayerScale = gl.getUniformLocation(shaderProgram, "layerScale");
		this.locLayerAngle = gl.getUniformLocation(shaderProgram, "layerAngle");
		this.locViewOrigin = gl.getUniformLocation(shaderProgram, "viewOrigin");
		this.hasAnyOptionalUniforms = !!(this.locPixelWidth || this.locPixelHeight || this.locSeconds || this.locSamplerBack || this.locDestStart || this.locDestEnd || this.locLayerScale || this.locLayerAngle || this.locViewOrigin);
		if (this.locOpacity)
			gl.uniform1f(this.locOpacity, 1);
		if (this.locSamplerFront)
			gl.uniform1i(this.locSamplerFront, 0);
		if (this.locSamplerBack)
			gl.uniform1i(this.locSamplerBack, 1);
		if (this.locDestStart)
			gl.uniform2f(this.locDestStart, 0.0, 0.0);
		if (this.locDestEnd)
			gl.uniform2f(this.locDestEnd, 1.0, 1.0);
		if (this.locLayerScale)
			gl.uniform1f(this.locLayerScale, 1.0);
		if (this.locLayerAngle)
			gl.uniform1f(this.locLayerAngle, 0.0);
		if (this.locViewOrigin)
			gl.uniform2f(this.locViewOrigin, 0.0, 0.0);
		this.hasCurrentMatMV = false;		// matMV needs updating
	};
	GLWrap_.prototype.createShaderProgram = function(shaderEntry, vsSource, name)
	{
		var gl = this.gl;
		var fragmentShader = gl.createShader(gl.FRAGMENT_SHADER);
		gl.shaderSource(fragmentShader, shaderEntry.src);
		gl.compileShader(fragmentShader);
		if (!gl.getShaderParameter(fragmentShader, gl.COMPILE_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			return null;
		}
		var vertexShader = gl.createShader(gl.VERTEX_SHADER);
		gl.shaderSource(vertexShader, vsSource);
		gl.compileShader(vertexShader);
		if (!gl.getShaderParameter(vertexShader, gl.COMPILE_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			gl.deleteShader(vertexShader);
			return null;
		}
		var shaderProgram = gl.createProgram();
		gl.attachShader(shaderProgram, fragmentShader);
		gl.attachShader(shaderProgram, vertexShader);
		gl.linkProgram(shaderProgram);
		if (!gl.getProgramParameter(shaderProgram, gl.LINK_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			gl.deleteShader(vertexShader);
			gl.deleteProgram(shaderProgram);
			return null;
		}
		gl.useProgram(shaderProgram);
;
		gl.deleteShader(fragmentShader);
		gl.deleteShader(vertexShader);
		var ret = new GLShaderProgram(gl, shaderProgram, name);
		ret.extendBoxHorizontal = shaderEntry.extendBoxHorizontal || 0;
		ret.extendBoxVertical = shaderEntry.extendBoxVertical || 0;
		ret.crossSampling = !!shaderEntry.crossSampling;
		ret.animated = !!shaderEntry.animated;
		ret.parameters = shaderEntry.parameters || [];
		var i, len;
		for (i = 0, len = ret.parameters.length; i < len; i++)
		{
			ret.parameters[i][1] = gl.getUniformLocation(shaderProgram, ret.parameters[i][0]);
			gl.uniform1f(ret.parameters[i][1], 0);
		}
		cr.seal(ret);
		return ret;
	};
	GLWrap_.prototype.getShaderIndex = function(name_)
	{
		var i, len;
		for (i = 0, len = this.shaderPrograms.length; i < len; i++)
		{
			if (this.shaderPrograms[i].name === name_)
				return i;
		}
		return -1;
	};
	GLWrap_.prototype.project = function (x, y, out)
	{
		var mv = this.matMV;
		var proj = this.matP;
		var fTempo = [0, 0, 0, 0, 0, 0, 0, 0];
		fTempo[0] = mv[0]*x+mv[4]*y+mv[12];
		fTempo[1] = mv[1]*x+mv[5]*y+mv[13];
		fTempo[2] = mv[2]*x+mv[6]*y+mv[14];
		fTempo[3] = mv[3]*x+mv[7]*y+mv[15];
		fTempo[4] = proj[0]*fTempo[0]+proj[4]*fTempo[1]+proj[8]*fTempo[2]+proj[12]*fTempo[3];
		fTempo[5] = proj[1]*fTempo[0]+proj[5]*fTempo[1]+proj[9]*fTempo[2]+proj[13]*fTempo[3];
		fTempo[6] = proj[2]*fTempo[0]+proj[6]*fTempo[1]+proj[10]*fTempo[2]+proj[14]*fTempo[3];
		fTempo[7] = -fTempo[2];
		if(fTempo[7]===0.0)	//The w value
			return;
		fTempo[7]=1.0/fTempo[7];
		fTempo[4]*=fTempo[7];
		fTempo[5]*=fTempo[7];
		fTempo[6]*=fTempo[7];
		out[0]=(fTempo[4]*0.5+0.5)*this.width;
		out[1]=(fTempo[5]*0.5+0.5)*this.height;
	};
	GLWrap_.prototype.setSize = function(w, h, force)
	{
		if (this.width === w && this.height === h && !force)
			return;
		this.endBatch();
		this.width = w;
		this.height = h;
		this.gl.viewport(0, 0, w, h);
		mat4.perspective(45, w / h, 1, 1000, this.matP);
		mat4.lookAt(this.cam, this.look, this.up, this.matMV);
		var tl = [0, 0];
		var br = [0, 0];
		this.project(0, 0, tl);
		this.project(1, 1, br);
		this.worldScale[0] = 1 / (br[0] - tl[0]);
		this.worldScale[1] = -1 / (br[1] - tl[1]);
		var i, len, s;
		for (i = 0, len = this.shaderPrograms.length; i < len; i++)
		{
			s = this.shaderPrograms[i];
			s.hasCurrentMatMV = false;
			if (s.locMatP)
			{
				this.gl.useProgram(s.shaderProgram);
				this.gl.uniformMatrix4fv(s.locMatP, false, this.matP);
			}
		}
		this.gl.useProgram(this.shaderPrograms[this.lastProgram].shaderProgram);
		this.gl.bindTexture(this.gl.TEXTURE_2D, null);
		this.gl.activeTexture(this.gl.TEXTURE1);
		this.gl.bindTexture(this.gl.TEXTURE_2D, null);
		this.gl.activeTexture(this.gl.TEXTURE0);
		this.lastTexture0 = null;
		this.lastTexture1 = null;
	};
	GLWrap_.prototype.resetModelView = function ()
	{
		mat4.lookAt(this.cam, this.look, this.up, this.matMV);
		mat4.scale(this.matMV, this.worldScale);
	};
	GLWrap_.prototype.translate = function (x, y)
	{
		if (x === 0 && y === 0)
			return;
		this.tmpVec3[0] = x;// * this.worldScale[0];
		this.tmpVec3[1] = y;// * this.worldScale[1];
		this.tmpVec3[2] = 0;
		mat4.translate(this.matMV, this.tmpVec3);
	};
	GLWrap_.prototype.scale = function (x, y)
	{
		if (x === 1 && y === 1)
			return;
		this.tmpVec3[0] = x;
		this.tmpVec3[1] = y;
		this.tmpVec3[2] = 1;
		mat4.scale(this.matMV, this.tmpVec3);
	};
	GLWrap_.prototype.rotateZ = function (a)
	{
		if (a === 0)
			return;
		mat4.rotateZ(this.matMV, a);
	};
	GLWrap_.prototype.updateModelView = function()
	{
		var anydiff = false;
		for (var i = 0; i < 16; i++)
		{
			if (this.lastMV[i] !== this.matMV[i])
			{
				anydiff = true;
				break;
			}
		}
		if (!anydiff)
			return;
		var b = this.pushBatch();
		b.type = BATCH_UPDATEMODELVIEW;
		if (b.mat4param)
			mat4.set(this.matMV, b.mat4param);
		else
			b.mat4param = mat4.create(this.matMV);
		mat4.set(this.matMV, this.lastMV);
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	/*
	var debugBatch = false;
	jQuery(document).mousedown(
		function(info) {
			if (info.which === 2)
				debugBatch = true;
		}
	);
	*/
	function GLBatchJob(type_, glwrap_)
	{
		this.type = type_;
		this.glwrap = glwrap_;
		this.gl = glwrap_.gl;
		this.opacityParam = 0;		// for setOpacity()
		this.startIndex = 0;		// for quad()
		this.indexCount = 0;		// "
		this.texParam = null;		// for setTexture()
		this.mat4param = null;		// for updateModelView()
		this.shaderParams = [];		// for user parameters
		cr.seal(this);
	};
	GLBatchJob.prototype.doSetTexture = function ()
	{
		this.gl.bindTexture(this.gl.TEXTURE_2D, this.texParam);
	};
	GLBatchJob.prototype.doSetTexture1 = function ()
	{
		var gl = this.gl;
		gl.activeTexture(gl.TEXTURE1);
		gl.bindTexture(gl.TEXTURE_2D, this.texParam);
		gl.activeTexture(gl.TEXTURE0);
	};
	GLBatchJob.prototype.doSetOpacity = function ()
	{
		var o = this.opacityParam;
		var glwrap = this.glwrap;
		glwrap.currentOpacity = o;
		var curProg = glwrap.currentShader;
		if (curProg.locOpacity)
			this.gl.uniform1f(curProg.locOpacity, o);
	};
	GLBatchJob.prototype.doQuad = function ()
	{
		this.gl.drawElements(this.gl.TRIANGLES, this.indexCount, this.gl.UNSIGNED_SHORT, this.startIndex * 2);
	};
	GLBatchJob.prototype.doSetBlend = function ()
	{
		this.gl.blendFunc(this.startIndex, this.indexCount);
	};
	GLBatchJob.prototype.doUpdateModelView = function ()
	{
		var i, len, s, shaderPrograms = this.glwrap.shaderPrograms, currentProgram = this.glwrap.currentProgram;
		for (i = 0, len = shaderPrograms.length; i < len; i++)
		{
			s = shaderPrograms[i];
			if (i === currentProgram && s.locMatMV)
			{
				this.gl.uniformMatrix4fv(s.locMatMV, false, this.mat4param);
				s.hasCurrentMatMV = true;
			}
			else
				s.hasCurrentMatMV = false;
		}
		mat4.set(this.mat4param, this.glwrap.currentMV);
	};
	GLBatchJob.prototype.doRenderToTexture = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		if (this.texParam)
		{
			if (glwrap.lastTexture1 === this.texParam)
			{
				gl.activeTexture(gl.TEXTURE1);
				gl.bindTexture(gl.TEXTURE_2D, null);
				glwrap.lastTexture1 = null;
				gl.activeTexture(gl.TEXTURE0);
			}
			gl.bindFramebuffer(gl.FRAMEBUFFER, glwrap.fbo);
			gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, this.texParam, 0);
		}
		else
		{
			gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, null, 0);
			gl.bindFramebuffer(gl.FRAMEBUFFER, null);
		}
	};
	GLBatchJob.prototype.doClear = function ()
	{
		var gl = this.gl;
		if (this.startIndex === 0)		// clear whole surface
		{
			gl.clearColor(this.mat4param[0], this.mat4param[1], this.mat4param[2], this.mat4param[3]);
			gl.clear(gl.COLOR_BUFFER_BIT);
		}
		else							// clear rectangle
		{
			gl.enable(gl.SCISSOR_TEST);
			gl.scissor(this.mat4param[0], this.mat4param[1], this.mat4param[2], this.mat4param[3]);
			gl.clearColor(0, 0, 0, 0);
			gl.clear(this.gl.COLOR_BUFFER_BIT);
			gl.disable(gl.SCISSOR_TEST);
		}
	};
	GLBatchJob.prototype.doPoints = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		var s = glwrap.shaderPrograms[1];
		gl.useProgram(s.shaderProgram);
		if (!s.hasCurrentMatMV && s.locMatMV)
		{
			gl.uniformMatrix4fv(s.locMatMV, false, glwrap.currentMV);
			s.hasCurrentMatMV = true;
		}
		gl.enableVertexAttribArray(s.locAPos);
		gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.pointBuffer);
		gl.vertexAttribPointer(s.locAPos, 4, gl.FLOAT, false, 0, 0);
		gl.drawArrays(gl.POINTS, this.startIndex / 4, this.indexCount);
		s = glwrap.currentShader;
		gl.useProgram(s.shaderProgram);
		if (s.locAPos >= 0)
		{
			gl.enableVertexAttribArray(s.locAPos);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.vertexBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
		}
		if (s.locATex >= 0)
		{
			gl.enableVertexAttribArray(s.locATex);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.texcoordBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
	};
	GLBatchJob.prototype.doSetProgram = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		var s = glwrap.shaderPrograms[this.startIndex];		// recycled param to save memory
		glwrap.currentProgram = this.startIndex;			// current batch program
		glwrap.currentShader = s;
		gl.useProgram(s.shaderProgram);						// switch to
		if (!s.hasCurrentMatMV && s.locMatMV)
		{
			gl.uniformMatrix4fv(s.locMatMV, false, glwrap.currentMV);
			s.hasCurrentMatMV = true;
		}
		if (s.locOpacity)
			gl.uniform1f(s.locOpacity, glwrap.currentOpacity);
		if (s.locAPos >= 0)
		{
			gl.enableVertexAttribArray(s.locAPos);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.vertexBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
		}
		if (s.locATex >= 0)
		{
			gl.enableVertexAttribArray(s.locATex);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.texcoordBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
	}
	GLBatchJob.prototype.doSetProgramParameters = function ()
	{
		var i, len, s = this.glwrap.currentShader;
		var gl = this.gl;
		var mat4param = this.mat4param;
		if (s.locSamplerBack && this.glwrap.lastTexture1 !== this.texParam)
		{
			gl.activeTexture(gl.TEXTURE1);
			gl.bindTexture(gl.TEXTURE_2D, this.texParam);
			this.glwrap.lastTexture1 = this.texParam;
			gl.activeTexture(gl.TEXTURE0);
		}
		if (s.locPixelWidth)
			gl.uniform1f(s.locPixelWidth, mat4param[0]);
		if (s.locPixelHeight)
			gl.uniform1f(s.locPixelHeight, mat4param[1]);
		if (s.locDestStart)
			gl.uniform2f(s.locDestStart, mat4param[2], mat4param[3]);
		if (s.locDestEnd)
			gl.uniform2f(s.locDestEnd, mat4param[4], mat4param[5]);
		if (s.locLayerScale)
			gl.uniform1f(s.locLayerScale, mat4param[6]);
		if (s.locLayerAngle)
			gl.uniform1f(s.locLayerAngle, mat4param[7]);
		if (s.locViewOrigin)
			gl.uniform2f(s.locViewOrigin, mat4param[8], mat4param[9]);
		if (s.locSeconds)
			gl.uniform1f(s.locSeconds, cr.performance_now() / 1000.0);
		if (s.parameters.length)
		{
			for (i = 0, len = s.parameters.length; i < len; i++)
			{
				gl.uniform1f(s.parameters[i][1], this.shaderParams[i]);
			}
		}
	};
	GLWrap_.prototype.pushBatch = function ()
	{
		if (this.batchPtr === this.batch.length)
			this.batch.push(new GLBatchJob(BATCH_NULL, this));
		return this.batch[this.batchPtr++];
	};
	GLWrap_.prototype.endBatch = function ()
	{
		if (this.batchPtr === 0)
			return;
		if (this.gl.isContextLost())
			return;
		var gl = this.gl;
		if (this.pointPtr > 0)
		{
			gl.bindBuffer(gl.ARRAY_BUFFER, this.pointBuffer);
			gl.bufferData(gl.ARRAY_BUFFER, this.pointData.subarray(0, this.pointPtr), gl.STREAM_DRAW);
			if (s && s.locAPos >= 0 && s.name === "<point>")
				gl.vertexAttribPointer(s.locAPos, 4, gl.FLOAT, false, 0, 0);
		}
		if (this.vertexPtr > 0)
		{
			var s = this.currentShader;
			gl.bindBuffer(gl.ARRAY_BUFFER, this.vertexBuffers[this.curBuffer]);
			gl.bufferData(gl.ARRAY_BUFFER, this.vertexData.subarray(0, this.vertexPtr), gl.STREAM_DRAW);
			if (s && s.locAPos >= 0 && s.name !== "<point>")
				gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
			gl.bindBuffer(gl.ARRAY_BUFFER, this.texcoordBuffers[this.curBuffer]);
			gl.bufferData(gl.ARRAY_BUFFER, this.texcoordData.subarray(0, this.vertexPtr), gl.STREAM_DRAW);
			if (s && s.locATex >= 0 && s.name !== "<point>")
				gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
		var i, len, b;
		for (i = 0, len = this.batchPtr; i < len; i++)
		{
			b = this.batch[i];
			switch (b.type) {
			case 1:
				b.doQuad();
				break;
			case 2:
				b.doSetTexture();
				break;
			case 3:
				b.doSetOpacity();
				break;
			case 4:
				b.doSetBlend();
				break;
			case 5:
				b.doUpdateModelView();
				break;
			case 6:
				b.doRenderToTexture();
				break;
			case 7:
				b.doClear();
				break;
			case 8:
				b.doPoints();
				break;
			case 9:
				b.doSetProgram();
				break;
			case 10:
				b.doSetProgramParameters();
				break;
			case 11:
				b.doSetTexture1();
				break;
			}
		}
		this.batchPtr = 0;
		this.vertexPtr = 0;
		this.pointPtr = 0;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
		this.curBuffer++;
		if (this.curBuffer >= MULTI_BUFFERS)
			this.curBuffer = 0;
	};
	GLWrap_.prototype.setOpacity = function (op)
	{
		if (op === this.lastOpacity)
			return;
		var b = this.pushBatch();
		b.type = BATCH_SETOPACITY;
		b.opacityParam = op;
		this.lastOpacity = op;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.setTexture = function (tex)
	{
		if (tex === this.lastTexture0)
			return;
;
		var b = this.pushBatch();
		b.type = BATCH_SETTEXTURE;
		b.texParam = tex;
		this.lastTexture0 = tex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.setBlend = function (s, d)
	{
		if (s === this.lastSrcBlend && d === this.lastDestBlend)
			return;
		var b = this.pushBatch();
		b.type = BATCH_SETBLEND;
		b.startIndex = s;		// recycle params to save memory
		b.indexCount = d;
		this.lastSrcBlend = s;
		this.lastDestBlend = d;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.isPremultipliedAlphaBlend = function ()
	{
		return (this.lastSrcBlend === this.gl.ONE && this.lastDestBlend === this.gl.ONE_MINUS_SRC_ALPHA);
	};
	GLWrap_.prototype.setAlphaBlend = function ()
	{
		this.setBlend(this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA);
	};
	GLWrap_.prototype.setNoPremultiplyAlphaBlend = function ()
	{
		this.setBlend(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA);
	};
	var LAST_VERTEX = MAX_VERTICES * 2 - 8;
	GLWrap_.prototype.quad = function(tlx, tly, trx, try_, brx, bry, blx, bly)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		vd[v] = tlx;
		td[v++] = 0;
		vd[v] = tly;
		td[v++] = 0;
		vd[v] = trx;
		td[v++] = 1;
		vd[v] = try_;
		td[v++] = 0;
		vd[v] = brx;
		td[v++] = 1;
		vd[v] = bry;
		td[v++] = 1;
		vd[v] = blx;
		td[v++] = 0;
		vd[v] = bly;
		td[v++] = 1;
		this.vertexPtr = v;
	};
	GLWrap_.prototype.quadTex = function(tlx, tly, trx, try_, brx, bry, blx, bly, rcTex)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		var rc_left = rcTex.left;
		var rc_top = rcTex.top;
		var rc_right = rcTex.right;
		var rc_bottom = rcTex.bottom;
		vd[v] = tlx;
		td[v++] = rc_left;
		vd[v] = tly;
		td[v++] = rc_top;
		vd[v] = trx;
		td[v++] = rc_right;
		vd[v] = try_;
		td[v++] = rc_top;
		vd[v] = brx;
		td[v++] = rc_right;
		vd[v] = bry;
		td[v++] = rc_bottom;
		vd[v] = blx;
		td[v++] = rc_left;
		vd[v] = bly;
		td[v++] = rc_bottom;
		this.vertexPtr = v;
	};
	GLWrap_.prototype.quadTexUV = function(tlx, tly, trx, try_, brx, bry, blx, bly, tlu, tlv, tru, trv, bru, brv, blu, blv)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		vd[v] = tlx;
		td[v++] = tlu;
		vd[v] = tly;
		td[v++] = tlv;
		vd[v] = trx;
		td[v++] = tru;
		vd[v] = try_;
		td[v++] = trv;
		vd[v] = brx;
		td[v++] = bru;
		vd[v] = bry;
		td[v++] = brv;
		vd[v] = blx;
		td[v++] = blu;
		vd[v] = bly;
		td[v++] = blv;
		this.vertexPtr = v;
	};
	var LAST_POINT = MAX_POINTS - 4;
	GLWrap_.prototype.point = function(x_, y_, size_, opacity_)
	{
		if (this.pointPtr >= LAST_POINT)
			this.endBatch();
		var p = this.pointPtr;			// point cursor
		var pd = this.pointData;		// point data array
		if (this.hasPointBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount++;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_POINTS;
			b.startIndex = p;
			b.indexCount = 1;
			this.hasPointBatchTop = true;
			this.hasQuadBatchTop = false;
		}
		pd[p++] = x_;
		pd[p++] = y_;
		pd[p++] = size_;
		pd[p++] = opacity_;
		this.pointPtr = p;
	};
	GLWrap_.prototype.switchProgram = function (progIndex)
	{
		if (this.lastProgram === progIndex)
			return;			// no change
		var shaderProg = this.shaderPrograms[progIndex];
		if (!shaderProg)
		{
			if (this.lastProgram === 0)
				return;								// already on default shader
			progIndex = 0;
			shaderProg = this.shaderPrograms[0];
		}
		var b = this.pushBatch();
		b.type = BATCH_SETPROGRAM;
		b.startIndex = progIndex;
		this.lastProgram = progIndex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.programUsesDest = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return !!(s.locDestStart || s.locDestEnd);
	};
	GLWrap_.prototype.programUsesCrossSampling = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return !!(s.locDestStart || s.locDestEnd || s.crossSampling);
	};
	GLWrap_.prototype.programExtendsBox = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return s.extendBoxHorizontal !== 0 || s.extendBoxVertical !== 0;
	};
	GLWrap_.prototype.getProgramBoxExtendHorizontal = function (progIndex)
	{
		return this.shaderPrograms[progIndex].extendBoxHorizontal;
	};
	GLWrap_.prototype.getProgramBoxExtendVertical = function (progIndex)
	{
		return this.shaderPrograms[progIndex].extendBoxVertical;
	};
	GLWrap_.prototype.getProgramParameterType = function (progIndex, paramIndex)
	{
		return this.shaderPrograms[progIndex].parameters[paramIndex][2];
	};
	GLWrap_.prototype.programIsAnimated = function (progIndex)
	{
		return this.shaderPrograms[progIndex].animated;
	};
	GLWrap_.prototype.setProgramParameters = function (backTex, pixelWidth, pixelHeight, destStartX, destStartY, destEndX, destEndY, layerScale, layerAngle, viewOriginLeft, viewOriginTop, params)
	{
		var i, len;
		var s = this.shaderPrograms[this.lastProgram];
		var b, mat4param, shaderParams;
		if (s.hasAnyOptionalUniforms || params.length)
		{
			b = this.pushBatch();
			b.type = BATCH_SETPROGRAMPARAMETERS;
			if (b.mat4param)
				mat4.set(this.matMV, b.mat4param);
			else
				b.mat4param = mat4.create();
			mat4param = b.mat4param;
			mat4param[0] = pixelWidth;
			mat4param[1] = pixelHeight;
			mat4param[2] = destStartX;
			mat4param[3] = destStartY;
			mat4param[4] = destEndX;
			mat4param[5] = destEndY;
			mat4param[6] = layerScale;
			mat4param[7] = layerAngle;
			mat4param[8] = viewOriginLeft;
			mat4param[9] = viewOriginTop;
			if (s.locSamplerBack)
			{
;
				b.texParam = backTex;
			}
			else
				b.texParam = null;
			if (params.length)
			{
				shaderParams = b.shaderParams;
				shaderParams.length = params.length;
				for (i = 0, len = params.length; i < len; i++)
					shaderParams[i] = params[i];
			}
			this.hasQuadBatchTop = false;
			this.hasPointBatchTop = false;
		}
	};
	GLWrap_.prototype.clear = function (r, g, b_, a)
	{
		var b = this.pushBatch();
		b.type = BATCH_CLEAR;
		b.startIndex = 0;					// clear all mode
		if (!b.mat4param)
			b.mat4param = mat4.create();
		b.mat4param[0] = r;
		b.mat4param[1] = g;
		b.mat4param[2] = b_;
		b.mat4param[3] = a;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.clearRect = function (x, y, w, h)
	{
		if (w < 0 || h < 0)
			return;							// invalid clear area
		var b = this.pushBatch();
		b.type = BATCH_CLEAR;
		b.startIndex = 1;					// clear rect mode
		if (!b.mat4param)
			b.mat4param = mat4.create();
		b.mat4param[0] = x;
		b.mat4param[1] = y;
		b.mat4param[2] = w;
		b.mat4param[3] = h;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.present = function ()
	{
		this.endBatch();
		this.gl.flush();
		/*
		if (debugBatch)
		{
;
			debugBatch = false;
		}
		*/
	};
	function nextHighestPowerOfTwo(x) {
		--x;
		for (var i = 1; i < 32; i <<= 1) {
			x = x | x >> i;
		}
		return x + 1;
	}
	var all_textures = [];
	var textures_by_src = {};
	var BF_RGBA8 = 0;
	var BF_RGB8 = 1;
	var BF_RGBA4 = 2;
	var BF_RGB5_A1 = 3;
	var BF_RGB565 = 4;
	GLWrap_.prototype.loadTexture = function (img, tiling, linearsampling, pixelformat, tiletype)
	{
		tiling = !!tiling;
		linearsampling = !!linearsampling;
		var tex_key = img.src + "," + tiling + "," + linearsampling + (tiling ? ("," + tiletype) : "");
		var webGL_texture = null;
		if (typeof img.src !== "undefined" && textures_by_src.hasOwnProperty(tex_key))
		{
			webGL_texture = textures_by_src[tex_key];
			webGL_texture.c2refcount++;
			return webGL_texture;
		}
		this.endBatch();
;
		var gl = this.gl;
		var isPOT = (cr.isPOT(img.width) && cr.isPOT(img.height));
		webGL_texture = gl.createTexture();
		gl.bindTexture(gl.TEXTURE_2D, webGL_texture);
		gl.pixelStorei(gl["UNPACK_PREMULTIPLY_ALPHA_WEBGL"], true);
		var internalformat = gl.RGBA;
		var format = gl.RGBA;
		var type = gl.UNSIGNED_BYTE;
		if (pixelformat && !this.isIE)
		{
			switch (pixelformat) {
			case BF_RGB8:
				internalformat = gl.RGB;
				format = gl.RGB;
				break;
			case BF_RGBA4:
				type = gl.UNSIGNED_SHORT_4_4_4_4;
				break;
			case BF_RGB5_A1:
				type = gl.UNSIGNED_SHORT_5_5_5_1;
				break;
			case BF_RGB565:
				internalformat = gl.RGB;
				format = gl.RGB;
				type = gl.UNSIGNED_SHORT_5_6_5;
				break;
			}
		}
		if (!isPOT && tiling)
		{
			var canvas = document.createElement("canvas");
			canvas.width = cr.nextHighestPowerOfTwo(img.width);
			canvas.height = cr.nextHighestPowerOfTwo(img.height);
			var ctx = canvas.getContext("2d");
			ctx["webkitImageSmoothingEnabled"] = linearsampling;
			ctx["mozImageSmoothingEnabled"] = linearsampling;
			ctx["msImageSmoothingEnabled"] = linearsampling;
			ctx["imageSmoothingEnabled"] = linearsampling;
			ctx.drawImage(img,
						  0, 0, img.width, img.height,
						  0, 0, canvas.width, canvas.height);
			gl.texImage2D(gl.TEXTURE_2D, 0, internalformat, format, type, canvas);
		}
		else
			gl.texImage2D(gl.TEXTURE_2D, 0, internalformat, format, type, img);
		if (tiling)
		{
			if (tiletype === "repeat-x")
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
			}
			else if (tiletype === "repeat-y")
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
			}
			else
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
			}
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
		}
		if (linearsampling)
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
			if (isPOT)
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR_MIPMAP_LINEAR);
				gl.generateMipmap(gl.TEXTURE_2D);
			}
			else
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
		}
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
		webGL_texture.c2width = img.width;
		webGL_texture.c2height = img.height;
		webGL_texture.c2refcount = 1;
		webGL_texture.c2texkey = tex_key;
		all_textures.push(webGL_texture);
		textures_by_src[tex_key] = webGL_texture;
		return webGL_texture;
	};
	GLWrap_.prototype.createEmptyTexture = function (w, h, linearsampling, _16bit, tiling)
	{
		this.endBatch();
		var gl = this.gl;
		if (this.isIE)
			_16bit = false;
		var webGL_texture = gl.createTexture();
		gl.bindTexture(gl.TEXTURE_2D, webGL_texture);
		gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, w, h, 0, gl.RGBA, _16bit ? gl.UNSIGNED_SHORT_4_4_4_4 : gl.UNSIGNED_BYTE, null);
		if (tiling)
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
		}
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, linearsampling ? gl.LINEAR : gl.NEAREST);
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, linearsampling ? gl.LINEAR : gl.NEAREST);
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
		webGL_texture.c2width = w;
		webGL_texture.c2height = h;
		all_textures.push(webGL_texture);
		return webGL_texture;
	};
	GLWrap_.prototype.videoToTexture = function (video_, texture_, _16bit)
	{
		this.endBatch();
		var gl = this.gl;
		if (this.isIE)
			_16bit = false;
		gl.bindTexture(gl.TEXTURE_2D, texture_);
		gl.pixelStorei(gl["UNPACK_PREMULTIPLY_ALPHA_WEBGL"], true);
		gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, _16bit ? gl.UNSIGNED_SHORT_4_4_4_4 : gl.UNSIGNED_BYTE, video_);
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
	};
	GLWrap_.prototype.deleteTexture = function (tex)
	{
		if (!tex)
			return;
		if (typeof tex.c2refcount !== "undefined" && tex.c2refcount > 1)
		{
			tex.c2refcount--;
			return;
		}
		this.endBatch();
		if (tex === this.lastTexture0)
		{
			this.gl.bindTexture(this.gl.TEXTURE_2D, null);
			this.lastTexture0 = null;
		}
		if (tex === this.lastTexture1)
		{
			this.gl.activeTexture(this.gl.TEXTURE1);
			this.gl.bindTexture(this.gl.TEXTURE_2D, null);
			this.gl.activeTexture(this.gl.TEXTURE0);
			this.lastTexture1 = null;
		}
		cr.arrayFindRemove(all_textures, tex);
		if (typeof tex.c2texkey !== "undefined")
			delete textures_by_src[tex.c2texkey];
		this.gl.deleteTexture(tex);
	};
	GLWrap_.prototype.estimateVRAM = function ()
	{
		var total = this.width * this.height * 4 * 2;
		var i, len, t;
		for (i = 0, len = all_textures.length; i < len; i++)
		{
			t = all_textures[i];
			total += (t.c2width * t.c2height * 4);
		}
		return total;
	};
	GLWrap_.prototype.textureCount = function ()
	{
		return all_textures.length;
	};
	GLWrap_.prototype.setRenderingToTexture = function (tex)
	{
		if (tex === this.renderToTex)
			return;
;
		var b = this.pushBatch();
		b.type = BATCH_RENDERTOTEXTURE;
		b.texParam = tex;
		this.renderToTex = tex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	cr.GLWrap = GLWrap_;
}());
;
(function()
{
	function Runtime(canvas)
	{
		if (!canvas || (!canvas.getContext && !canvas["dc"]))
			return;
		if (canvas["c2runtime"])
			return;
		else
			canvas["c2runtime"] = this;
		var self = this;
		this.isCrosswalk = /crosswalk/i.test(navigator.userAgent) || /xwalk/i.test(navigator.userAgent) || !!(typeof window["c2isCrosswalk"] !== "undefined" && window["c2isCrosswalk"]);
		this.isPhoneGap = (!this.isCrosswalk && (typeof window["device"] !== "undefined" && (typeof window["device"]["cordova"] !== "undefined" || typeof window["device"]["phonegap"] !== "undefined")));
		this.isDirectCanvas = !!canvas["dc"];
		this.isAppMobi = (typeof window["AppMobi"] !== "undefined" || this.isDirectCanvas);
		this.isCocoonJs = !!window["c2cocoonjs"];
		this.isEjecta = !!window["c2ejecta"];
		if (this.isCocoonJs)
		{
			CocoonJS["App"]["onSuspended"].addEventListener(function() {
				self["setSuspended"](true);
			});
			CocoonJS["App"]["onActivated"].addEventListener(function () {
				self["setSuspended"](false);
			});
		}
		if (this.isEjecta)
		{
			document.addEventListener("pagehide", function() {
				self["setSuspended"](true);
			});
			document.addEventListener("pageshow", function() {
				self["setSuspended"](false);
			});
			document.addEventListener("resize", function () {
				self["setSize"](window.innerWidth, window.innerHeight);
			});
		}
		this.isDomFree = (this.isDirectCanvas || this.isCocoonJs || this.isEjecta);
		this.isTizen = /tizen/i.test(navigator.userAgent);
		this.isAndroid = /android/i.test(navigator.userAgent) && !this.isTizen;		// tizen says "like Android"
		this.isIE = /msie/i.test(navigator.userAgent) || /trident/i.test(navigator.userAgent);
		this.isiPhone = /iphone/i.test(navigator.userAgent) || /ipod/i.test(navigator.userAgent);	// treat ipod as an iphone
		this.isiPad = /ipad/i.test(navigator.userAgent);
		this.isiOS = this.isiPhone || this.isiPad || this.isEjecta;
		this.isiPhoneiOS6 = (this.isiPhone && /os\s6/i.test(navigator.userAgent));
		this.isChrome = /chrome/i.test(navigator.userAgent) || /chromium/i.test(navigator.userAgent);
		this.isAmazonWebApp = /amazonwebappplatform/i.test(navigator.userAgent);
		this.isFirefox = /firefox/i.test(navigator.userAgent);
		this.isSafari = !this.isChrome && /safari/i.test(navigator.userAgent);		// Chrome includes Safari in UA
		this.isWindows = /windows/i.test(navigator.userAgent);
		this.isNodeWebkit = (typeof window["c2nodewebkit"] !== "undefined" || /nodewebkit/i.test(navigator.userAgent));
		this.isArcade = (typeof window["is_scirra_arcade"] !== "undefined");
		this.isWindows8App = !!(typeof window["c2isWindows8"] !== "undefined" && window["c2isWindows8"]);
		this.isWindows8Capable = !!(typeof window["c2isWindows8Capable"] !== "undefined" && window["c2isWindows8Capable"]);
		this.isWindowsPhone8 = !!(typeof window["c2isWindowsPhone8"] !== "undefined" && window["c2isWindowsPhone8"]);
		this.isWindowsPhone81 = !!(typeof window["c2isWindowsPhone81"] !== "undefined" && window["c2isWindowsPhone81"]);
		this.isWinJS = (this.isWindows8App || this.isWindows8Capable || this.isWindowsPhone81);	// note not WP8.0
		this.isBlackberry10 = !!(typeof window["c2isBlackberry10"] !== "undefined" && window["c2isBlackberry10"]);
		this.isAndroidStockBrowser = (this.isAndroid && !this.isChrome && !this.isFirefox && !this.isAmazonWebApp && !this.isDomFree);
		this.devicePixelRatio = 1;
		this.isMobile = (this.isPhoneGap || this.isCrosswalk || this.isAppMobi || this.isCocoonJs || this.isAndroid || this.isiOS || this.isWindowsPhone8 || this.isWindowsPhone81 || this.isBlackberry10 || this.isTizen || this.isEjecta);
		if (!this.isMobile)
		{
			this.isMobile = /(blackberry|bb10|playbook|palm|symbian|nokia|windows\s+ce|phone|mobile|tablet|kindle|silk)/i.test(navigator.userAgent);
		}
		if (typeof cr_is_preview !== "undefined" && !this.isNodeWebkit && (window.location.search === "?nw" || /nodewebkit/i.test(navigator.userAgent)))
		{
			this.isNodeWebkit = true;
		}
		this.isDebug = (typeof cr_is_preview !== "undefined" && window.location.search.indexOf("debug") > -1)
		this.canvas = canvas;
		this.canvasdiv = document.getElementById("c2canvasdiv");
		this.gl = null;
		this.glwrap = null;
		this.ctx = null;
		this.fullscreenOldMarginCss = "";
		this.firstInFullscreen = false;
		this.oldWidth = 0;		// for restoring non-fullscreen canvas after fullscreen
		this.oldHeight = 0;
		this.canvas.oncontextmenu = function (e) { if (e.preventDefault) e.preventDefault(); return false; };
		this.canvas.onselectstart = function (e) { if (e.preventDefault) e.preventDefault(); return false; };
		if (this.isDirectCanvas)
			window["c2runtime"] = this;
		if (this.isNodeWebkit)
		{
			window.ondragover = function(e) { e.preventDefault(); return false; };
			window.ondrop = function(e) { e.preventDefault(); return false; };
			require("nw.gui")["App"]["clearCache"]();
		}
		this.width = canvas.width;
		this.height = canvas.height;
		this.draw_width = this.width;
		this.draw_height = this.height;
		this.cssWidth = this.width;
		this.cssHeight = this.height;
		this.lastWindowWidth = window.innerWidth;
		this.lastWindowHeight = window.innerHeight;
		this.redraw = true;
		this.isSuspended = false;
		if (!Date.now) {
		  Date.now = function now() {
			return +new Date();
		  };
		}
		this.plugins = [];
		this.types = {};
		this.types_by_index = [];
		this.behaviors = [];
		this.layouts = {};
		this.layouts_by_index = [];
		this.eventsheets = {};
		this.eventsheets_by_index = [];
		this.wait_for_textures = [];        // for blocking until textures loaded
		this.triggers_to_postinit = [];
		this.all_global_vars = [];
		this.all_local_vars = [];
		this.solidBehavior = null;
		this.jumpthruBehavior = null;
		this.deathRow = new cr.ObjectSet();
		this.isInClearDeathRow = false;
		this.isInOnDestroy = 0;					// needs to support recursion so increments and decrements and is true if > 0
		this.isRunningEvents = false;
		this.createRow = [];
		this.isLoadingState = false;
		this.saveToSlot = "";
		this.loadFromSlot = "";
		this.loadFromJson = "";
		this.lastSaveJson = "";
		this.signalledContinuousPreview = false;
		this.suspendDrawing = false;		// for hiding display until continuous preview loads
		this.dt = 0;
        this.dt1 = 0;
		this.logictime = 0;			// used to calculate CPUUtilisation
		this.cpuutilisation = 0;
		this.zeroDtCount = 0;
        this.timescale = 1.0;
        this.kahanTime = new cr.KahanAdder();
		this.last_tick_time = 0;
		this.measuring_dt = true;
		this.fps = 0;
		this.last_fps_time = 0;
		this.tickcount = 0;
		this.execcount = 0;
		this.framecount = 0;        // for fps
		this.objectcount = 0;
		this.changelayout = null;
		this.destroycallbacks = [];
		this.event_stack = [];
		this.event_stack_index = -1;
		this.localvar_stack = [[]];
		this.localvar_stack_index = 0;
		this.trigger_depth = 0;		// recursion depth for triggers
		this.pushEventStack(null);
		this.loop_stack = [];
		this.loop_stack_index = -1;
		this.next_uid = 0;
		this.next_puid = 0;		// permanent unique ids
		this.layout_first_tick = true;
		this.family_count = 0;
		this.suspend_events = [];
		this.raf_id = -1;
		this.timeout_id = -1;
		this.isloading = true;
		this.loadingprogress = 0;
		this.isNodeFullscreen = false;
		this.stackLocalCount = 0;	// number of stack-based local vars for recursion
		this.halfFramerateMode = false;
		this.lastRafTime = 0;		// time of last requestAnimationFrame call
		this.ranLastRaf = false;	// false if last requestAnimationFrame was skipped for half framerate mode
		this.had_a_click = false;
		this.isInUserInputEvent = false;
        this.objects_to_tick = new cr.ObjectSet();
		this.objects_to_tick2 = new cr.ObjectSet();
		this.registered_collisions = [];
		this.temp_poly = new cr.CollisionPoly([]);
		this.temp_poly2 = new cr.CollisionPoly([]);
		this.allGroups = [];				// array of all event groups
        this.groups_by_name = {};
		this.cndsBySid = {};
		this.actsBySid = {};
		this.varsBySid = {};
		this.blocksBySid = {};
		this.running_layout = null;			// currently running layout
		this.layer_canvas = null;			// for layers "render-to-texture"
		this.layer_ctx = null;
		this.layer_tex = null;
		this.layout_tex = null;
		this.layout_canvas = null;
		this.layout_ctx = null;
		this.is_WebGL_context_lost = false;
		this.uses_background_blending = false;	// if any shader uses background blending, so entire layout renders to texture
		this.fx_tex = [null, null];
		this.fullscreen_scaling = 0;
		this.files_subfolder = "";			// path with project files
		this.objectsByUid = {};				// maps every in-use UID (as a string) to its instance
		this.loaderlogo = null;
		this.snapshotCanvas = null;
		this.snapshotData = "";
		this.load();
		this.isRetina = ((!this.isDomFree || this.isEjecta) && this.useHighDpi && !this.isAndroidStockBrowser);
		this.devicePixelRatio = (this.isRetina ? (window["devicePixelRatio"] || window["webkitDevicePixelRatio"] || window["mozDevicePixelRatio"] || window["msDevicePixelRatio"] || 1) : 1);
		this.ClearDeathRow();
		var attribs;
		var alpha_canvas = this.alphaBackground && !(this.isNodeWebkit || this.isWinJS || this.isWindowsPhone8 || this.isCrosswalk);
		if (this.fullscreen_mode > 0)
			this["setSize"](window.innerWidth, window.innerHeight, true);
		try {
			if (this.enableWebGL && (this.isCocoonJs || this.isEjecta || !this.isDomFree))
			{
				attribs = {
					"alpha": alpha_canvas,
					"depth": false,
					"antialias": false,
					"failIfMajorPerformanceCaveat": true
				};
				this.gl = (canvas.getContext("webgl", attribs) || canvas.getContext("experimental-webgl", attribs));
			}
		}
		catch (e) {
		}
		if (this.gl)
		{
;
			if (!this.isDomFree)
			{
				this.overlay_canvas = document.createElement("canvas");
				jQuery(this.overlay_canvas).appendTo(this.canvas.parentNode);
				this.overlay_canvas.oncontextmenu = function (e) { return false; };
				this.overlay_canvas.onselectstart = function (e) { return false; };
				this.overlay_canvas.width = this.cssWidth;
				this.overlay_canvas.height = this.cssHeight;
				jQuery(this.overlay_canvas).css({"width": this.cssWidth + "px",
												"height": this.cssHeight + "px"});
				this.positionOverlayCanvas();
				this.overlay_ctx = this.overlay_canvas.getContext("2d");
			}
			this.glwrap = new cr.GLWrap(this.gl, this.isMobile);
			this.glwrap.setSize(canvas.width, canvas.height);
			this.ctx = null;
			this.canvas.addEventListener("webglcontextlost", function (ev) {
				ev.preventDefault();
				self.onContextLost();
				console.log("[Construct 2] WebGL context lost");
				window["cr_setSuspended"](true);		// stop rendering
			}, false);
			this.canvas.addEventListener("webglcontextrestored", function (ev) {
				self.glwrap.initState();
				self.glwrap.setSize(self.glwrap.width, self.glwrap.height, true);
				self.layer_tex = null;
				self.layout_tex = null;
				self.fx_tex[0] = null;
				self.fx_tex[1] = null;
				self.onContextRestored();
				self.redraw = true;
				console.log("[Construct 2] WebGL context restored");
				window["cr_setSuspended"](false);		// resume rendering
			}, false);
			var i, len, j, lenj, k, lenk, t, s, l, y;
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				for (j = 0, lenj = t.effect_types.length; j < lenj; j++)
				{
					s = t.effect_types[j];
					s.shaderindex = this.glwrap.getShaderIndex(s.id);
					this.uses_background_blending = this.uses_background_blending || this.glwrap.programUsesDest(s.shaderindex);
				}
			}
			for (i = 0, len = this.layouts_by_index.length; i < len; i++)
			{
				l = this.layouts_by_index[i];
				for (j = 0, lenj = l.effect_types.length; j < lenj; j++)
				{
					s = l.effect_types[j];
					s.shaderindex = this.glwrap.getShaderIndex(s.id);
				}
				for (j = 0, lenj = l.layers.length; j < lenj; j++)
				{
					y = l.layers[j];
					for (k = 0, lenk = y.effect_types.length; k < lenk; k++)
					{
						s = y.effect_types[k];
						s.shaderindex = this.glwrap.getShaderIndex(s.id);
						this.uses_background_blending = this.uses_background_blending || this.glwrap.programUsesDest(s.shaderindex);
					}
				}
			}
		}
		else
		{
			if (this.fullscreen_mode > 0 && this.isDirectCanvas)
			{
;
				this.canvas = null;
				document.oncontextmenu = function (e) { return false; };
				document.onselectstart = function (e) { return false; };
				this.ctx = AppMobi["canvas"]["getContext"]("2d");
				try {
					this.ctx["samplingMode"] = this.linearSampling ? "smooth" : "sharp";
					this.ctx["globalScale"] = 1;
					this.ctx["HTML5CompatibilityMode"] = true;
					this.ctx["imageSmoothingEnabled"] = this.linearSampling;
				} catch(e){}
				if (this.width !== 0 && this.height !== 0)
				{
					this.ctx.width = this.width;
					this.ctx.height = this.height;
				}
			}
			if (!this.ctx)
			{
;
				if (this.isCocoonJs)
				{
					attribs = {
						"antialias": !!this.linearSampling,
						"alpha": alpha_canvas
					};
					this.ctx = canvas.getContext("2d", attribs);
				}
				else
				{
					attribs = {
						"alpha": alpha_canvas
					};
					this.ctx = canvas.getContext("2d", attribs);
				}
				this.ctx["webkitImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["mozImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["msImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["imageSmoothingEnabled"] = this.linearSampling;
			}
			this.overlay_canvas = null;
			this.overlay_ctx = null;
		}
		this.tickFunc = function () { self.tick(false); };
		if (window != window.top && !this.isDomFree && !this.isWinJS && !this.isWindowsPhone8)
		{
			document.addEventListener("mousedown", function () {
				window.focus();
			}, true);
			document.addEventListener("touchstart", function () {
				window.focus();
			}, true);
		}
		if (typeof cr_is_preview !== "undefined")
		{
			if (this.isCocoonJs)
				console.log("[Construct 2] In preview-over-wifi via CocoonJS mode");
			if (window.location.search.indexOf("continuous") > -1)
			{
				cr.logexport("Reloading for continuous preview");
				this.loadFromSlot = "__c2_continuouspreview";
				this.suspendDrawing = true;
			}
			if (this.pauseOnBlur && !this.isMobile)
			{
				jQuery(window).focus(function ()
				{
					self["setSuspended"](false);
				});
				jQuery(window).blur(function ()
				{
					self["setSuspended"](true);
				});
			}
		}
		if (this.fullscreen_mode === 0 && this.isRetina && this.devicePixelRatio > 1)
		{
			this["setSize"](this.original_width, this.original_height, true);
		}
		this.tryLockOrientation();
		this.go();			// run loading screen
		this.extra = {};
		cr.seal(this);
	};
	var webkitRepaintFlag = false;
	Runtime.prototype["setSize"] = function (w, h, force)
	{
		var offx = 0, offy = 0;
		var neww = 0, newh = 0, intscale = 0;
		var tryHideAddressBar = (this.isiPhoneiOS6 && this.isSafari && !navigator["standalone"] && !this.isDomFree && !this.isPhoneGap);
		if (tryHideAddressBar)
			h += 60;		// height of Safari iPhone iOS 6 address bar
		if (this.lastWindowWidth === w && this.lastWindowHeight === h && !force)
			return;
		this.lastWindowWidth = w;
		this.lastWindowHeight = h;
		var mode = this.fullscreen_mode;
		var orig_aspect, cur_aspect;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.isNodeFullscreen);
		if (!isfullscreen && this.fullscreen_mode === 0 && !force)
			return;			// ignore size events when not fullscreen and not using a fullscreen-in-browser mode
		if (isfullscreen && this.fullscreen_scaling > 0)
			mode = this.fullscreen_scaling;
		if (mode >= 4)
		{
			orig_aspect = this.original_width / this.original_height;
			cur_aspect = w / h;
			if (cur_aspect > orig_aspect)
			{
				neww = h * orig_aspect;
				if (mode === 5)	// integer scaling
				{
					intscale = neww / this.original_width;
					if (intscale > 1)
						intscale = Math.floor(intscale);
					else if (intscale < 1)
						intscale = 1 / Math.ceil(1 / intscale);
					neww = this.original_width * intscale;
					newh = this.original_height * intscale;
					offx = (w - neww) / 2;
					offy = (h - newh) / 2;
					w = neww;
					h = newh;
				}
				else
				{
					offx = (w - neww) / 2;
					w = neww;
				}
			}
			else
			{
				newh = w / orig_aspect;
				if (mode === 5)	// integer scaling
				{
					intscale = newh / this.original_height;
					if (intscale > 1)
						intscale = Math.floor(intscale);
					else if (intscale < 1)
						intscale = 1 / Math.ceil(1 / intscale);
					neww = this.original_width * intscale;
					newh = this.original_height * intscale;
					offx = (w - neww) / 2;
					offy = (h - newh) / 2;
					w = neww;
					h = newh;
				}
				else
				{
					offy = (h - newh) / 2;
					h = newh;
				}
			}
			if (isfullscreen && !this.isNodeWebkit)
			{
				offx = 0;
				offy = 0;
			}
			offx = Math.floor(offx);
			offy = Math.floor(offy);
			w = Math.floor(w);
			h = Math.floor(h);
		}
		else if (this.isNodeWebkit && this.isNodeFullscreen && this.fullscreen_mode_set === 0)
		{
			offx = Math.floor((w - this.original_width) / 2);
			offy = Math.floor((h - this.original_height) / 2);
			w = this.original_width;
			h = this.original_height;
		}
		if (mode < 2)
			this.aspect_scale = this.devicePixelRatio;
		if (this.isRetina && this.isiPad && this.devicePixelRatio > 1)	// don't apply to iPad 1-2
		{
			if (w >= 1024)
				w = 1023;		// 2046 retina pixels
			if (h >= 1024)
				h = 1023;
		}
		var multiplier = this.devicePixelRatio;
		this.cssWidth = w;
		this.cssHeight = h;
		this.width = Math.round(w * multiplier);
		this.height = Math.round(h * multiplier);
		this.redraw = true;
		if (this.wantFullscreenScalingQuality)
		{
			this.draw_width = this.width;
			this.draw_height = this.height;
			this.fullscreenScalingQuality = true;
		}
		else
		{
			if ((this.width < this.original_width && this.height < this.original_height) || mode === 1)
			{
				this.draw_width = this.width;
				this.draw_height = this.height;
				this.fullscreenScalingQuality = true;
			}
			else
			{
				this.draw_width = this.original_width;
				this.draw_height = this.original_height;
				this.fullscreenScalingQuality = false;
				/*var orig_aspect = this.original_width / this.original_height;
				var cur_aspect = this.width / this.height;
				if ((this.fullscreen_mode !== 2 && cur_aspect > orig_aspect) || (this.fullscreen_mode === 2 && cur_aspect < orig_aspect))
					this.aspect_scale = this.height / this.original_height;
				else
					this.aspect_scale = this.width / this.original_width;*/
				if (mode === 2)		// scale inner
				{
					orig_aspect = this.original_width / this.original_height;
					cur_aspect = this.lastWindowWidth / this.lastWindowHeight;
					if (cur_aspect < orig_aspect)
						this.draw_width = this.draw_height * cur_aspect;
					else if (cur_aspect > orig_aspect)
						this.draw_height = this.draw_width / cur_aspect;
				}
				else if (mode === 3)
				{
					orig_aspect = this.original_width / this.original_height;
					cur_aspect = this.lastWindowWidth / this.lastWindowHeight;
					if (cur_aspect > orig_aspect)
						this.draw_width = this.draw_height * cur_aspect;
					else if (cur_aspect < orig_aspect)
						this.draw_height = this.draw_width / cur_aspect;
				}
			}
		}
		if (this.canvasdiv && !this.isDomFree)
		{
			jQuery(this.canvasdiv).css({"width": w + "px",
										"height": h + "px",
										"margin-left": offx,
										"margin-top": offy});
			if (typeof cr_is_preview !== "undefined")
			{
				jQuery("#borderwrap").css({"width": w + "px",
											"height": h + "px"});
			}
		}
		if (this.canvas)
		{
			this.canvas.width = Math.round(w * multiplier);
			this.canvas.height = Math.round(h * multiplier);
			if (this.isEjecta)
			{
				this.canvas.style.left = offx + "px";
				this.canvas.style.top = offy + "px";
				this.canvas.style.width = w + "px";
				this.canvas.style.height = h + "px";
			}
			else if (this.isRetina && !this.isDomFree)
			{
				jQuery(this.canvas).css({"width": w + "px",
										"height": h + "px"});
			}
		}
		if (this.overlay_canvas)
		{
			this.overlay_canvas.width = w;
			this.overlay_canvas.height = h;
			jQuery(this.overlay_canvas).css({"width": w + "px",
											"height": h + "px"});
		}
		if (this.glwrap)
		{
			this.glwrap.setSize(Math.round(w * multiplier), Math.round(h * multiplier));
		}
		if (this.isDirectCanvas && this.ctx)
		{
			this.ctx.width = w;
			this.ctx.height = h;
		}
		if (this.ctx)
		{
			this.ctx["webkitImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["mozImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["msImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["imageSmoothingEnabled"] = this.linearSampling;
		}
		this.tryLockOrientation();
		if (!this.isDomFree && (tryHideAddressBar || this.isiPhone))
		{
			window.setTimeout(function () {
				window.scrollTo(0, 1);
			}, 100);
		}
	};
	Runtime.prototype.tryLockOrientation = function ()
	{
		if (!this.autoLockOrientation || this.orientations === 0)
			return;
		var orientation = "portrait";
		if (this.orientations === 2)
			orientation = "landscape";
		if (screen["lockOrientation"])
			screen["lockOrientation"](orientation);
		else if (screen["webkitLockOrientation"])
			screen["webkitLockOrientation"](orientation);
		else if (screen["mozLockOrientation"])
			screen["mozLockOrientation"](orientation);
		else if (screen["msLockOrientation"])
			screen["msLockOrientation"](orientation);
	};
	Runtime.prototype.onContextLost = function ()
	{
		this.is_WebGL_context_lost = true;
		var i, len, t;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onLostWebGLContext)
				t.onLostWebGLContext();
		}
	};
	Runtime.prototype.onContextRestored = function ()
	{
		this.is_WebGL_context_lost = false;
		var i, len, t;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onRestoreWebGLContext)
				t.onRestoreWebGLContext();
		}
	};
	Runtime.prototype.positionOverlayCanvas = function()
	{
		if (this.isDomFree)
			return;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"] || this.isNodeFullscreen);
		var overlay_position = isfullscreen ? jQuery(this.canvas).offset() : jQuery(this.canvas).position();
		overlay_position.position = "absolute";
		jQuery(this.overlay_canvas).css(overlay_position);
	};
	var caf = window["cancelAnimationFrame"] ||
	  window["mozCancelAnimationFrame"]    ||
	  window["webkitCancelAnimationFrame"] ||
	  window["msCancelAnimationFrame"]     ||
	  window["oCancelAnimationFrame"];
	Runtime.prototype["setSuspended"] = function (s)
	{
		var i, len;
		if (s && !this.isSuspended)
		{
			cr.logexport("[Construct 2] Suspending");
			this.isSuspended = true;			// next tick will be last
			if (this.raf_id !== -1 && caf)		// note: CocoonJS does not implement cancelAnimationFrame
				caf(this.raf_id);
			if (this.timeout_id !== -1)
				clearTimeout(this.timeout_id);
			for (i = 0, len = this.suspend_events.length; i < len; i++)
				this.suspend_events[i](true);
		}
		else if (!s && this.isSuspended)
		{
			cr.logexport("[Construct 2] Resuming");
			this.isSuspended = false;
			this.last_tick_time = cr.performance_now();	// ensure first tick is a zero-dt one
			this.last_fps_time = cr.performance_now();	// reset FPS counter
			this.framecount = 0;
			this.logictime = 0;
			for (i = 0, len = this.suspend_events.length; i < len; i++)
				this.suspend_events[i](false);
			this.tick(false);						// kick off runtime again
		}
	};
	Runtime.prototype.addSuspendCallback = function (f)
	{
		this.suspend_events.push(f);
	};
	Runtime.prototype.load = function ()
	{
;
		var pm = cr.getProjectModel();
		this.name = pm[0];
		this.first_layout = pm[1];
		this.fullscreen_mode = pm[11];	// 0 = off, 1 = crop, 2 = scale inner, 3 = scale outer, 4 = letterbox scale, 5 = integer letterbox scale
		this.fullscreen_mode_set = pm[11];
		this.original_width = pm[9];
		this.original_height = pm[10];
		this.parallax_x_origin = this.original_width / 2;
		this.parallax_y_origin = this.original_height / 2;
		if (this.isDomFree && !this.isEjecta && (pm[11] >= 4 || pm[11] === 0))
		{
			cr.logexport("[Construct 2] Letterbox scale fullscreen modes are not supported on this platform - falling back to 'Scale outer'");
			this.fullscreen_mode = 3;
			this.fullscreen_mode_set = 3;
		}
		this.uses_loader_layout = pm[17];
		this.loaderstyle = pm[18];
		if (this.loaderstyle === 0)
		{
			this.loaderlogo = new Image();
			this.loaderlogo.src = "loading-logo.png";
		}
		this.next_uid = pm[20];
		this.system = new cr.system_object(this);
		var i, len, j, lenj, k, lenk, idstr, m, b, t, f;
		var plugin, plugin_ctor;
		for (i = 0, len = pm[2].length; i < len; i++)
		{
			m = pm[2][i];
;
			cr.add_common_aces(m);
			plugin = new m[0](this);
			plugin.singleglobal = m[1];
			plugin.is_world = m[2];
			plugin.must_predraw = m[9];
			if (plugin.onCreate)
				plugin.onCreate();  // opportunity to override default ACEs
			cr.seal(plugin);
			this.plugins.push(plugin);
		}
		pm = cr.getProjectModel();
		for (i = 0, len = pm[3].length; i < len; i++)
		{
			m = pm[3][i];
			plugin_ctor = m[1];
;
			plugin = null;
			for (j = 0, lenj = this.plugins.length; j < lenj; j++)
			{
				if (this.plugins[j] instanceof plugin_ctor)
				{
					plugin = this.plugins[j];
					break;
				}
			}
;
;
			var type_inst = new plugin.Type(plugin);
;
			type_inst.name = m[0];
			type_inst.is_family = m[2];
			type_inst.instvar_sids = m[3].slice(0);
			type_inst.vars_count = m[3].length;
			type_inst.behs_count = m[4];
			type_inst.fx_count = m[5];
			type_inst.sid = m[11];
			if (type_inst.is_family)
			{
				type_inst.members = [];				// types in this family
				type_inst.family_index = this.family_count++;
				type_inst.families = null;
			}
			else
			{
				type_inst.members = null;
				type_inst.family_index = -1;
				type_inst.families = [];			// families this type belongs to
			}
			type_inst.family_var_map = null;
			type_inst.family_beh_map = null;
			type_inst.family_fx_map = null;
			type_inst.is_contained = false;
			type_inst.container = null;
			if (m[6])
			{
				type_inst.texture_file = m[6][0];
				type_inst.texture_filesize = m[6][1];
				type_inst.texture_pixelformat = m[6][2];
			}
			else
			{
				type_inst.texture_file = null;
				type_inst.texture_filesize = 0;
				type_inst.texture_pixelformat = 0;		// rgba8
			}
			if (m[7])
			{
				type_inst.animations = m[7];
			}
			else
			{
				type_inst.animations = null;
			}
			type_inst.index = i;                                // save index in to types array in type
			type_inst.instances = [];                           // all instances of this type
			type_inst.deadCache = [];							// destroyed instances to recycle next create
			type_inst.solstack = [new cr.selection(type_inst)]; // initialise SOL stack with one empty SOL
			type_inst.cur_sol = 0;
			type_inst.default_instance = null;
			type_inst.default_layerindex = 0;
			type_inst.stale_iids = true;
			type_inst.updateIIDs = cr.type_updateIIDs;
			type_inst.getFirstPicked = cr.type_getFirstPicked;
			type_inst.getPairedInstance = cr.type_getPairedInstance;
			type_inst.getCurrentSol = cr.type_getCurrentSol;
			type_inst.pushCleanSol = cr.type_pushCleanSol;
			type_inst.pushCopySol = cr.type_pushCopySol;
			type_inst.popSol = cr.type_popSol;
			type_inst.getBehaviorByName = cr.type_getBehaviorByName;
			type_inst.getBehaviorIndexByName = cr.type_getBehaviorIndexByName;
			type_inst.getEffectIndexByName = cr.type_getEffectIndexByName;
			type_inst.applySolToContainer = cr.type_applySolToContainer;
			type_inst.getInstanceByIID = cr.type_getInstanceByIID;
			type_inst.collision_grid = new cr.SparseGrid(this.original_width, this.original_height);
			type_inst.any_cell_changed = true;
			type_inst.any_instance_parallaxed = false;
			type_inst.extra = {};
			type_inst.toString = cr.type_toString;
			type_inst.behaviors = [];
			for (j = 0, lenj = m[8].length; j < lenj; j++)
			{
				b = m[8][j];
				var behavior_ctor = b[1];
				var behavior_plugin = null;
				for (k = 0, lenk = this.behaviors.length; k < lenk; k++)
				{
					if (this.behaviors[k] instanceof behavior_ctor)
					{
						behavior_plugin = this.behaviors[k];
						break;
					}
				}
				if (!behavior_plugin)
				{
					behavior_plugin = new behavior_ctor(this);
					behavior_plugin.my_types = [];						// types using this behavior
					behavior_plugin.my_instances = new cr.ObjectSet(); 	// instances of this behavior
					if (behavior_plugin.onCreate)
						behavior_plugin.onCreate();
					cr.seal(behavior_plugin);
					this.behaviors.push(behavior_plugin);
					if (cr.behaviors.solid && behavior_plugin instanceof cr.behaviors.solid)
						this.solidBehavior = behavior_plugin;
					if (cr.behaviors.jumpthru && behavior_plugin instanceof cr.behaviors.jumpthru)
						this.jumpthruBehavior = behavior_plugin;
				}
				if (behavior_plugin.my_types.indexOf(type_inst) === -1)
					behavior_plugin.my_types.push(type_inst);
				var behavior_type = new behavior_plugin.Type(behavior_plugin, type_inst);
				behavior_type.name = b[0];
				behavior_type.sid = b[2];
				behavior_type.onCreate();
				cr.seal(behavior_type);
				type_inst.behaviors.push(behavior_type);
			}
			type_inst.global = m[9];
			type_inst.isOnLoaderLayout = m[10];
			type_inst.effect_types = [];
			for (j = 0, lenj = m[12].length; j < lenj; j++)
			{
				type_inst.effect_types.push({
					id: m[12][j][0],
					name: m[12][j][1],
					shaderindex: -1,
					active: true,
					index: j
				});
			}
			type_inst.tile_poly_data = m[13];
			if (!this.uses_loader_layout || type_inst.is_family || type_inst.isOnLoaderLayout || !plugin.is_world)
			{
				type_inst.onCreate();
				cr.seal(type_inst);
			}
			if (type_inst.name)
				this.types[type_inst.name] = type_inst;
			this.types_by_index.push(type_inst);
			if (plugin.singleglobal)
			{
				var instance = new plugin.Instance(type_inst);
				instance.uid = this.next_uid++;
				instance.puid = this.next_puid++;
				instance.iid = 0;
				instance.get_iid = cr.inst_get_iid;
				instance.toString = cr.inst_toString;
				instance.properties = m[14];
				instance.onCreate();
				cr.seal(instance);
				type_inst.instances.push(instance);
				this.objectsByUid[instance.uid.toString()] = instance;
			}
		}
		for (i = 0, len = pm[4].length; i < len; i++)
		{
			var familydata = pm[4][i];
			var familytype = this.types_by_index[familydata[0]];
			var familymember;
			for (j = 1, lenj = familydata.length; j < lenj; j++)
			{
				familymember = this.types_by_index[familydata[j]];
				familymember.families.push(familytype);
				familytype.members.push(familymember);
			}
		}
		for (i = 0, len = pm[23].length; i < len; i++)
		{
			var containerdata = pm[23][i];
			var containertypes = [];
			for (j = 0, lenj = containerdata.length; j < lenj; j++)
				containertypes.push(this.types_by_index[containerdata[j]]);
			for (j = 0, lenj = containertypes.length; j < lenj; j++)
			{
				containertypes[j].is_contained = true;
				containertypes[j].container = containertypes;
			}
		}
		if (this.family_count > 0)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				if (t.is_family || !t.families.length)
					continue;
				t.family_var_map = new Array(this.family_count);
				t.family_beh_map = new Array(this.family_count);
				t.family_fx_map = new Array(this.family_count);
				var all_fx = [];
				var varsum = 0;
				var behsum = 0;
				var fxsum = 0;
				for (j = 0, lenj = t.families.length; j < lenj; j++)
				{
					f = t.families[j];
					t.family_var_map[f.family_index] = varsum;
					varsum += f.vars_count;
					t.family_beh_map[f.family_index] = behsum;
					behsum += f.behs_count;
					t.family_fx_map[f.family_index] = fxsum;
					fxsum += f.fx_count;
					for (k = 0, lenk = f.effect_types.length; k < lenk; k++)
						all_fx.push(cr.shallowCopy({}, f.effect_types[k]));
				}
				t.effect_types = all_fx.concat(t.effect_types);
				for (j = 0, lenj = t.effect_types.length; j < lenj; j++)
					t.effect_types[j].index = j;
			}
		}
		for (i = 0, len = pm[5].length; i < len; i++)
		{
			m = pm[5][i];
			var layout = new cr.layout(this, m);
			cr.seal(layout);
			this.layouts[layout.name] = layout;
			this.layouts_by_index.push(layout);
		}
		for (i = 0, len = pm[6].length; i < len; i++)
		{
			m = pm[6][i];
			var sheet = new cr.eventsheet(this, m);
			cr.seal(sheet);
			this.eventsheets[sheet.name] = sheet;
			this.eventsheets_by_index.push(sheet);
		}
		for (i = 0, len = this.eventsheets_by_index.length; i < len; i++)
			this.eventsheets_by_index[i].postInit();
		for (i = 0, len = this.eventsheets_by_index.length; i < len; i++)
			this.eventsheets_by_index[i].updateDeepIncludes();
		for (i = 0, len = this.triggers_to_postinit.length; i < len; i++)
			this.triggers_to_postinit[i].postInit();
		this.triggers_to_postinit.length = 0;
		this.files_subfolder = pm[7];
		this.pixel_rounding = pm[8];
		this.aspect_scale = 1.0;
		this.enableWebGL = pm[12];
		this.linearSampling = pm[13];
		this.alphaBackground = pm[14];
		this.versionstr = pm[15];
		this.useHighDpi = pm[16];
		this.orientations = pm[19];		// 0 = any, 1 = portrait, 2 = landscape
		this.autoLockOrientation = (this.orientations > 0);
		this.pauseOnBlur = pm[21];
		this.wantFullscreenScalingQuality = pm[22];		// false = low quality, true = high quality
		this.fullscreenScalingQuality = this.wantFullscreenScalingQuality;
		this.start_time = Date.now();
	};
	var anyImageHadError = false;
	Runtime.prototype.waitForImageLoad = function (img_)
	{
		img_.onerror = function (e)
		{
			img_.c2error = true;
			anyImageHadError = true;
			if (console && console.error)
				console.error("Error loading image '" + img_.src + "': ", e);
		};
		this.wait_for_textures.push(img_);
	};
	Runtime.prototype.findWaitingTexture = function (src_)
	{
		var i, len;
		for (i = 0, len = this.wait_for_textures.length; i < len; i++)
		{
			if (this.wait_for_textures[i].cr_src === src_)
				return this.wait_for_textures[i];
		}
		return null;
	};
	Runtime.prototype.areAllTexturesLoaded = function ()
	{
		var totalsize = 0;
		var completedsize = 0;
		var ret = true;
		var i, len, img;
		for (i = 0, len = this.wait_for_textures.length; i < len; i++)
		{
			img = this.wait_for_textures[i];
			var filesize = img.cr_filesize;
			if (!filesize || filesize <= 0)
				filesize = 50000;
			totalsize += filesize;
			if ((img.complete || img["loaded"]) && !img.c2error)
				completedsize += filesize;
			else
				ret = false;    // not all textures loaded
		}
		if (totalsize == 0)
			this.progress = 0;
		else
			this.progress = (completedsize / totalsize);
		return ret;
	};
	Runtime.prototype.go = function ()
	{
		if (!this.ctx && !this.glwrap)
			return;
		var ctx = this.ctx || this.overlay_ctx;
		if (this.overlay_canvas)
			this.positionOverlayCanvas();
		this.progress = 0;
		this.last_progress = -1;
		if (this.areAllTexturesLoaded())
			this.go_textures_done();
		else
		{
			var ms_elapsed = Date.now() - this.start_time;
			if (ctx)
			{
				var overlay_width = this.width;
				var overlay_height = this.height;
				var multiplier = this.devicePixelRatio;
				if (this.overlay_canvas)
				{
					overlay_width = this.cssWidth;
					overlay_height = this.cssHeight;
					multiplier = 1;
				}
				if (this.loaderstyle !== 3 && (this.isCocoonJs || (ms_elapsed >= 500 && this.last_progress != this.progress)))
				{
					ctx.clearRect(0, 0, overlay_width, overlay_height);
					var mx = overlay_width / 2;
					var my = overlay_height / 2;
					var haslogo = (this.loaderstyle === 0 && this.loaderlogo.complete);
					var hlw = 40 * multiplier;
					var hlh = 0;
					var logowidth = 80 * multiplier;
					var logoheight;
					if (haslogo)
					{
						logowidth = this.loaderlogo.width * multiplier;
						logoheight = this.loaderlogo.height * multiplier;
						hlw = logowidth / 2;
						hlh = logoheight / 2;
						ctx.drawImage(this.loaderlogo, cr.floor(mx - hlw), cr.floor(my - hlh), logowidth, logoheight);
					}
					if (this.loaderstyle <= 1)
					{
						my += hlh + (haslogo ? 12 * multiplier : 0);
						mx -= hlw;
						mx = cr.floor(mx) + 0.5;
						my = cr.floor(my) + 0.5;
						ctx.fillStyle = anyImageHadError ? "red" : "DodgerBlue";
						ctx.fillRect(mx, my, Math.floor(logowidth * this.progress), 6 * multiplier);
						ctx.strokeStyle = "black";
						ctx.strokeRect(mx, my, logowidth, 6 * multiplier);
						ctx.strokeStyle = "white";
						ctx.strokeRect(mx - 1 * multiplier, my - 1 * multiplier, logowidth + 2 * multiplier, 8 * multiplier);
					}
					else if (this.loaderstyle === 2)
					{
						ctx.font = (this.isEjecta ? "12pt ArialMT" : "12pt Arial");
						ctx.fillStyle = anyImageHadError ? "#f00" : "#999";
						ctx.textBaseLine = "middle";
						var percent_text = Math.round(this.progress * 100) + "%";
						var text_dim = ctx.measureText ? ctx.measureText(percent_text) : null;
						var text_width = text_dim ? text_dim.width : 0;
						ctx.fillText(percent_text, mx - (text_width / 2), my);
					}
				}
				this.last_progress = this.progress;
			}
			setTimeout((function (self) { return function () { self.go(); }; })(this), (this.isCocoonJs ? 10 : 100));
		}
	};
	Runtime.prototype.go_textures_done = function ()
	{
		if (this.overlay_canvas)
		{
			this.canvas.parentNode.removeChild(this.overlay_canvas);
			this.overlay_ctx = null;
			this.overlay_canvas = null;
		}
		this.start_time = Date.now();
		this.last_fps_time = cr.performance_now();       // for counting framerate
		var i, len, t;
		if (this.uses_loader_layout)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				if (!t.is_family && !t.isOnLoaderLayout && t.plugin.is_world)
				{
					t.onCreate();
					cr.seal(t);
				}
			}
		}
		else
			this.isloading = false;
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			this.layouts_by_index[i].createGlobalNonWorlds();
		}
		if (this.fullscreen_mode >= 2)
		{
			var orig_aspect = this.original_width / this.original_height;
			var cur_aspect = this.width / this.height;
			if ((this.fullscreen_mode !== 2 && cur_aspect > orig_aspect) || (this.fullscreen_mode === 2 && cur_aspect < orig_aspect))
				this.aspect_scale = this.height / this.original_height;
			else
				this.aspect_scale = this.width / this.original_width;
		}
		if (this.first_layout)
			this.layouts[this.first_layout].startRunning();
		else
			this.layouts_by_index[0].startRunning();
;
		if (!this.uses_loader_layout)
		{
			this.loadingprogress = 1;
			this.trigger(cr.system_object.prototype.cnds.OnLoadFinished, null);
		}
		if (navigator["splashscreen"] && navigator["splashscreen"]["hide"])
			navigator["splashscreen"]["hide"]();
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onAppBegin)
				t.onAppBegin();
		}
		this.tick(false);
		if (this.isDirectCanvas)
			AppMobi["webview"]["execute"]("onGameReady();");
	};
	var raf = window["requestAnimationFrame"] ||
	  window["mozRequestAnimationFrame"]    ||
	  window["webkitRequestAnimationFrame"] ||
	  window["msRequestAnimationFrame"]     ||
	  window["oRequestAnimationFrame"];
	Runtime.prototype.tick = function (background_wake)
	{
		if (!this.running_layout)
			return;
		var logic_start = cr.performance_now();
		if (this.halfFramerateMode && this.ranLastRaf)
		{
			if (logic_start - this.lastRafTime < 29)
			{
				this.ranLastRaf = false;
				this.lastRafTime = logic_start;
				if (raf)
					this.raf_id = raf(this.tickFunc, this.canvas);
				else	// no idea if this works without raf/hi res timers but let's hope for the best
					this.timeout_id = setTimeout(this.tickFunc, this.isMobile ? 1 : 16);
				return;		// skipped this frame
			}
		}
		this.ranLastRaf = true;
		this.lastRafTime = logic_start;
		var fsmode = this.fullscreen_mode;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"]);
		if ((isfullscreen || this.isNodeFullscreen) && this.fullscreen_scaling > 0)
			fsmode = this.fullscreen_scaling;
		if (fsmode > 0 && (!this.isiPhone || window.self !== window.top))
		{
			var curwidth = window.innerWidth;
			var curheight = window.innerHeight;
			if (this.lastWindowWidth !== curwidth || this.lastWindowHeight !== curheight)
			{
					this["setSize"](curwidth, curheight);
			}
		}
		if (!this.isDomFree)
		{
			if (isfullscreen)
			{
				if (!this.firstInFullscreen)
				{
					this.fullscreenOldMarginCss = jQuery(this.canvas).css("margin") || "0";
					this.firstInFullscreen = true;
				}
				if (!this.isChrome && !this.isNodeWebkit)
				{
					jQuery(this.canvas).css({
						"margin-left": "" + Math.floor((screen.width - (this.width / this.devicePixelRatio)) / 2) + "px",
						"margin-top": "" + Math.floor((screen.height - (this.height / this.devicePixelRatio)) / 2) + "px"
					});
				}
			}
			else
			{
				if (this.firstInFullscreen)
				{
					if (!this.isChrome && !this.isNodeWebkit)
					{
						jQuery(this.canvas).css("margin", this.fullscreenOldMarginCss);
					}
					this.fullscreenOldMarginCss = "";
					this.firstInFullscreen = false;
					if (this.fullscreen_mode === 0)
					{
						this["setSize"](Math.round(this.oldWidth / this.devicePixelRatio), Math.round(this.oldHeight / this.devicePixelRatio), true);
					}
				}
				else
				{
					this.oldWidth = this.width;
					this.oldHeight = this.height;
				}
			}
		}
		if (this.isloading)
		{
			var done = this.areAllTexturesLoaded();		// updates this.progress
			this.loadingprogress = this.progress;
			if (done)
			{
				this.isloading = false;
				this.progress = 1;
				this.trigger(cr.system_object.prototype.cnds.OnLoadFinished, null);
			}
		}
		this.logic();
		if ((this.redraw || this.isCocoonJs) && !this.is_WebGL_context_lost && !this.suspendDrawing && !background_wake)
		{
			this.redraw = false;
			if (this.glwrap)
				this.drawGL();
			else
				this.draw();
			if (this.snapshotCanvas)
			{
				if (this.canvas && this.canvas.toDataURL)
				{
					this.snapshotData = this.canvas.toDataURL(this.snapshotCanvas[0], this.snapshotCanvas[1]);
					this.trigger(cr.system_object.prototype.cnds.OnCanvasSnapshot, null);
				}
				this.snapshotCanvas = null;
			}
		}
		if (!this.hit_breakpoint)
		{
			this.tickcount++;
			this.execcount++;
			this.framecount++;
		}
		this.logictime += cr.performance_now() - logic_start;
		if (this.isSuspended || background_wake)
			return;
		if (raf)
			this.raf_id = raf(this.tickFunc, this.canvas);
		else
		{
			this.timeout_id = setTimeout(this.tickFunc, this.isMobile ? 1 : 16);
		}
	};
	Runtime.prototype.logic = function ()
	{
		var i, leni, j, lenj, k, lenk, type, inst, binst;
		var cur_time = cr.performance_now();
		if (cur_time - this.last_fps_time >= 1000)  // every 1 second
		{
			this.last_fps_time += 1000;
			this.fps = this.framecount;
			this.framecount = 0;
			this.cpuutilisation = this.logictime;
			this.logictime = 0;
		}
		if (this.measuring_dt)
		{
			if (this.last_tick_time !== 0)
			{
				var ms_diff = cur_time - this.last_tick_time;
				if (ms_diff === 0 && !this.isDebug)
				{
					this.zeroDtCount++;
					if (this.zeroDtCout >= 10)
						this.measuring_dt = false;
					this.dt1 = 1.0 / 60.0;            // 60fps assumed (0.01666...)
				}
				else
				{
					this.dt1 = ms_diff / 1000.0; // dt measured in seconds
					if (this.dt1 > 0.5)
						this.dt1 = 0;
					else if (this.dt1 > 0.1)
						this.dt1 = 0.1;
				}
			}
			this.last_tick_time = cur_time;
		}
        this.dt = this.dt1 * this.timescale;
        this.kahanTime.add(this.dt);
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"] || this.isNodeFullscreen);
		if (this.fullscreen_mode >= 2 /* scale */ || (isfullscreen && this.fullscreen_scaling > 0))
		{
			var orig_aspect = this.original_width / this.original_height;
			var cur_aspect = this.width / this.height;
			var mode = this.fullscreen_mode;
			if (isfullscreen && this.fullscreen_scaling > 0)
				mode = this.fullscreen_scaling;
			if ((mode !== 2 && cur_aspect > orig_aspect) || (mode === 2 && cur_aspect < orig_aspect))
			{
				this.aspect_scale = this.height / this.original_height;
			}
			else
			{
				this.aspect_scale = this.width / this.original_width;
			}
			if (this.running_layout)
			{
				this.running_layout.scrollToX(this.running_layout.scrollX);
				this.running_layout.scrollToY(this.running_layout.scrollY);
			}
		}
		else
			this.aspect_scale = (this.isRetina ? this.devicePixelRatio : 1);
		this.ClearDeathRow();
		this.isInOnDestroy++;
		this.system.runWaits();		// prevent instance list changing
		this.isInOnDestroy--;
		this.ClearDeathRow();		// allow instance list changing
		this.isInOnDestroy++;
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					inst.behavior_insts[k].tick();
				}
			}
		}
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;	// type doesn't have any behaviors
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					binst = inst.behavior_insts[k];
					if (binst.posttick)
						binst.posttick();
				}
			}
		}
        var tickarr = this.objects_to_tick.valuesRef();
        for (i = 0, leni = tickarr.length; i < leni; i++)
            tickarr[i].tick();
		this.isInOnDestroy--;		// end preventing instance lists from being changed
		this.handleSaveLoad();		// save/load now if queued
		i = 0;
		while (this.changelayout && i++ < 10)
		{
			this.doChangeLayout(this.changelayout);
		}
        for (i = 0, leni = this.eventsheets_by_index.length; i < leni; i++)
            this.eventsheets_by_index[i].hasRun = false;
		if (this.running_layout.event_sheet)
			this.running_layout.event_sheet.run();
		this.registered_collisions.length = 0;
		this.layout_first_tick = false;
		this.isInOnDestroy++;		// prevent instance lists from being changed
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;	// type doesn't have any behaviors
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				var inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					binst = inst.behavior_insts[k];
					if (binst.tick2)
						binst.tick2();
				}
			}
		}
        tickarr = this.objects_to_tick2.valuesRef();
        for (i = 0, leni = tickarr.length; i < leni; i++)
            tickarr[i].tick2();
		this.isInOnDestroy--;		// end preventing instance lists from being changed
	};
	Runtime.prototype.doChangeLayout = function (changeToLayout)
	{
;
		var prev_layout = this.running_layout;
		this.running_layout.stopRunning();
		var i, len, j, lenj, k, lenk, type, inst, binst;
		if (this.glwrap)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				type = this.types_by_index[i];
				if (type.is_family)
					continue;
				if (type.unloadTextures && (!type.global || type.instances.length === 0) && changeToLayout.initial_types.indexOf(type) === -1)
				{
					type.unloadTextures();
				}
			}
		}
		if (prev_layout == changeToLayout)
			this.system.waits.length = 0;
		changeToLayout.startRunning();
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (!type.global && !type.plugin.singleglobal)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				if (inst.onLayoutChange)
					inst.onLayoutChange();
				if (inst.behavior_insts)
				{
					for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
					{
						binst = inst.behavior_insts[k];
						if (binst.onLayoutChange)
							binst.onLayoutChange();
					}
				}
			}
		}
		this.redraw = true;
		this.layout_first_tick = true;
		this.ClearDeathRow();
	};
    Runtime.prototype.tickMe = function (inst)
    {
        this.objects_to_tick.add(inst);
    };
	Runtime.prototype.untickMe = function (inst)
	{
		this.objects_to_tick.remove(inst);
	};
	Runtime.prototype.tick2Me = function (inst)
    {
        this.objects_to_tick2.add(inst);
    };
	Runtime.prototype.untick2Me = function (inst)
	{
		this.objects_to_tick2.remove(inst);
	};
    Runtime.prototype.getDt = function (inst)
    {
        if (!inst || inst.my_timescale === -1.0)
            return this.dt;
        return this.dt1 * inst.my_timescale;
    };
	Runtime.prototype.draw = function ()
	{
		this.running_layout.draw(this.ctx);
		if (this.isDirectCanvas)
			this.ctx["present"]();
	};
	Runtime.prototype.drawGL = function ()
	{
		this.running_layout.drawGL(this.glwrap);
		this.glwrap.present();
	};
	Runtime.prototype.addDestroyCallback = function (f)
	{
		if (f)
			this.destroycallbacks.push(f);
	};
	Runtime.prototype.removeDestroyCallback = function (f)
	{
		cr.arrayFindRemove(this.destroycallbacks, f);
	};
	Runtime.prototype.getObjectByUID = function (uid_)
	{
;
		var uidstr = uid_.toString();
		if (this.objectsByUid.hasOwnProperty(uidstr))
			return this.objectsByUid[uidstr];
		else
			return null;
	};
	Runtime.prototype.DestroyInstance = function (inst)
	{
		var i, len;
		if (!this.deathRow.contains(inst))
		{
			this.deathRow.add(inst);
			if (inst.is_contained)
			{
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					this.DestroyInstance(inst.siblings[i]);
				}
			}
			if (this.isInClearDeathRow)
				this.deathRow.values_cache.push(inst);
			this.isInOnDestroy++;		// support recursion
			this.trigger(Object.getPrototypeOf(inst.type.plugin).cnds.OnDestroyed, inst);
			this.isInOnDestroy--;
		}
	};
	Runtime.prototype.ClearDeathRow = function ()
	{
		var inst, index, type, instances, binst;
		var i, j, k, leni, lenj, lenk;
		var w, f;
		this.isInClearDeathRow = true;
		for (i = 0, leni = this.createRow.length; i < leni; i++)
		{
			inst = this.createRow[i];
			type = inst.type;
			type.instances.push(inst);
			for (j = 0, lenj = type.families.length; j < lenj; j++)
			{
				type.families[j].instances.push(inst);
				type.families[j].stale_iids = true;
			}
		}
		this.createRow.length = 0;
		var arr = this.deathRow.valuesRef();	// get array of items from set
		for (i = 0; i < arr.length; i++)		// check array length every time in case it changes
		{
			inst = arr[i];
			type = inst.type;
			instances = type.instances;
			for (j = 0, lenj = this.destroycallbacks.length; j < lenj; j++)
				this.destroycallbacks[j](inst);
			cr.arrayFindRemove(instances, inst);
			if (instances.length === 0)
				type.any_instance_parallaxed = false;
			if (inst.collcells)
			{
				type.collision_grid.update(inst, inst.collcells, null);
			}
			if (inst.layer)
			{
				cr.arrayRemove(inst.layer.instances, inst.get_zindex());
				inst.layer.zindices_stale = true;
			}
			for (j = 0, lenj = type.families.length; j < lenj; j++)
			{
				cr.arrayFindRemove(type.families[j].instances, inst);
				type.families[j].stale_iids = true;
			}
			if (inst.behavior_insts)
			{
				for (j = 0, lenj = inst.behavior_insts.length; j < lenj; j++)
				{
					binst = inst.behavior_insts[j];
					if (binst.onDestroy)
						binst.onDestroy();
					binst.behavior.my_instances.remove(inst);
				}
			}
            this.objects_to_tick.remove(inst);
			this.objects_to_tick2.remove(inst);
			for (j = 0, lenj = this.system.waits.length; j < lenj; j++)
			{
				w = this.system.waits[j];
				if (w.sols.hasOwnProperty(type.index))
					cr.arrayFindRemove(w.sols[type.index].insts, inst);
				if (!type.is_family)
				{
					for (k = 0, lenk = type.families.length; k < lenk; k++)
					{
						f = type.families[k];
						if (w.sols.hasOwnProperty(f.index))
							cr.arrayFindRemove(w.sols[f.index].insts, inst);
					}
				}
			}
			if (inst.onDestroy)
				inst.onDestroy();
			if (this.objectsByUid.hasOwnProperty(inst.uid.toString()))
				delete this.objectsByUid[inst.uid.toString()];
			this.objectcount--;
			if (type.deadCache.length < 64)
				type.deadCache.push(inst);
			type.stale_iids = true;
		}
		if (!this.deathRow.isEmpty())
			this.redraw = true;
		this.deathRow.clear();
		this.isInClearDeathRow = false;
	};
	Runtime.prototype.createInstance = function (type, layer, sx, sy)
	{
		if (type.is_family)
		{
			var i = cr.floor(Math.random() * type.members.length);
			return this.createInstance(type.members[i], layer, sx, sy);
		}
		if (!type.default_instance)
		{
			return null;
		}
		return this.createInstanceFromInit(type.default_instance, layer, false, sx, sy, false);
	};
	var all_behaviors = [];
	Runtime.prototype.createInstanceFromInit = function (initial_inst, layer, is_startup_instance, sx, sy, skip_siblings)
	{
		var i, len, j, lenj, p, effect_fallback, x, y;
		if (!initial_inst)
			return null;
		var type = this.types_by_index[initial_inst[1]];
;
;
		var is_world = type.plugin.is_world;
;
		if (this.isloading && is_world && !type.isOnLoaderLayout)
			return null;
		if (is_world && !this.glwrap && initial_inst[0][11] === 11)
			return null;
		var original_layer = layer;
		if (!is_world)
			layer = null;
		var inst;
		if (type.deadCache.length)
		{
			inst = type.deadCache.pop();
			inst.recycled = true;
			type.plugin.Instance.call(inst, type);
		}
		else
		{
			inst = new type.plugin.Instance(type);
			inst.recycled = false;
		}
		if (is_startup_instance && !skip_siblings)
			inst.uid = initial_inst[2];
		else
			inst.uid = this.next_uid++;
		this.objectsByUid[inst.uid.toString()] = inst;
		inst.puid = this.next_puid++;
		inst.iid = type.instances.length;
		for (i = 0, len = this.createRow.length; i < len; ++i)
		{
			if (this.createRow[i].type === type)
				inst.iid++;
		}
		inst.get_iid = cr.inst_get_iid;
		var initial_vars = initial_inst[3];
		if (inst.recycled)
		{
			cr.wipe(inst.extra);
		}
		else
		{
			inst.extra = {};
			if (typeof cr_is_preview !== "undefined")
			{
				inst.instance_var_names = [];
				inst.instance_var_names.length = initial_vars.length;
				for (i = 0, len = initial_vars.length; i < len; i++)
					inst.instance_var_names[i] = initial_vars[i][1];
			}
			inst.instance_vars = [];
			inst.instance_vars.length = initial_vars.length;
		}
		for (i = 0, len = initial_vars.length; i < len; i++)
			inst.instance_vars[i] = initial_vars[i][0];
		if (is_world)
		{
			var wm = initial_inst[0];
;
			inst.x = cr.is_undefined(sx) ? wm[0] : sx;
			inst.y = cr.is_undefined(sy) ? wm[1] : sy;
			inst.z = wm[2];
			inst.width = wm[3];
			inst.height = wm[4];
			inst.depth = wm[5];
			inst.angle = wm[6];
			inst.opacity = wm[7];
			inst.hotspotX = wm[8];
			inst.hotspotY = wm[9];
			inst.blend_mode = wm[10];
			effect_fallback = wm[11];
			if (!this.glwrap && type.effect_types.length)	// no WebGL renderer and shaders used
				inst.blend_mode = effect_fallback;			// use fallback blend mode - destroy mode was handled above
			inst.compositeOp = cr.effectToCompositeOp(inst.blend_mode);
			if (this.gl)
				cr.setGLBlend(inst, inst.blend_mode, this.gl);
			if (inst.recycled)
			{
				for (i = 0, len = wm[12].length; i < len; i++)
				{
					for (j = 0, lenj = wm[12][i].length; j < lenj; j++)
						inst.effect_params[i][j] = wm[12][i][j];
				}
				inst.bbox.set(0, 0, 0, 0);
				inst.collcells.set(0, 0, -1, -1);
				inst.bquad.set_from_rect(inst.bbox);
				inst.bbox_changed_callbacks.length = 0;
			}
			else
			{
				inst.effect_params = wm[12].slice(0);
				for (i = 0, len = inst.effect_params.length; i < len; i++)
					inst.effect_params[i] = wm[12][i].slice(0);
				inst.active_effect_types = [];
				inst.active_effect_flags = [];
				inst.active_effect_flags.length = type.effect_types.length;
				inst.bbox = new cr.rect(0, 0, 0, 0);
				inst.collcells = new cr.rect(0, 0, -1, -1);
				inst.bquad = new cr.quad();
				inst.bbox_changed_callbacks = [];
				inst.set_bbox_changed = cr.set_bbox_changed;
				inst.add_bbox_changed_callback = cr.add_bbox_changed_callback;
				inst.contains_pt = cr.inst_contains_pt;
				inst.update_bbox = cr.update_bbox;
				inst.update_collision_cell = cr.update_collision_cell;
				inst.get_zindex = cr.inst_get_zindex;
			}
			inst.tilemap_exists = false;
			inst.tilemap_width = 0;
			inst.tilemap_height = 0;
			inst.tilemap_data = null;
			if (wm.length === 14)
			{
				inst.tilemap_exists = true;
				inst.tilemap_width = wm[13][0];
				inst.tilemap_height = wm[13][1];
				inst.tilemap_data = wm[13][2];
			}
			for (i = 0, len = type.effect_types.length; i < len; i++)
				inst.active_effect_flags[i] = true;
			inst.updateActiveEffects = cr.inst_updateActiveEffects;
			inst.updateActiveEffects();
			inst.uses_shaders = !!inst.active_effect_types.length;
			inst.bbox_changed = true;
			inst.cell_changed = true;
			type.any_cell_changed = true;
			inst.visible = true;
            inst.my_timescale = -1.0;
			inst.layer = layer;
			inst.zindex = layer.instances.length;	// will be placed at top of current layer
			if (typeof inst.collision_poly === "undefined")
				inst.collision_poly = null;
			inst.collisionsEnabled = true;
			this.redraw = true;
		}
		inst.toString = cr.inst_toString;
		var initial_props, binst;
		all_behaviors.length = 0;
		for (i = 0, len = type.families.length; i < len; i++)
		{
			all_behaviors.push.apply(all_behaviors, type.families[i].behaviors);
		}
		all_behaviors.push.apply(all_behaviors, type.behaviors);
		if (inst.recycled)
		{
			for (i = 0, len = all_behaviors.length; i < len; i++)
			{
				var btype = all_behaviors[i];
				binst = inst.behavior_insts[i];
				binst.recycled = true;
				btype.behavior.Instance.call(binst, btype, inst);
				initial_props = initial_inst[4][i];
				for (j = 0, lenj = initial_props.length; j < lenj; j++)
					binst.properties[j] = initial_props[j];
				binst.onCreate();
				btype.behavior.my_instances.add(inst);
			}
		}
		else
		{
			inst.behavior_insts = [];
			for (i = 0, len = all_behaviors.length; i < len; i++)
			{
				var btype = all_behaviors[i];
				var binst = new btype.behavior.Instance(btype, inst);
				binst.recycled = false;
				binst.properties = initial_inst[4][i].slice(0);
				binst.onCreate();
				cr.seal(binst);
				inst.behavior_insts.push(binst);
				btype.behavior.my_instances.add(inst);
			}
		}
		initial_props = initial_inst[5];
		if (inst.recycled)
		{
			for (i = 0, len = initial_props.length; i < len; i++)
				inst.properties[i] = initial_props[i];
		}
		else
			inst.properties = initial_props.slice(0);
		this.createRow.push(inst);
		if (layer)
		{
;
			layer.instances.push(inst);
			if (layer.parallaxX !== 1 || layer.parallaxY !== 1)
				type.any_instance_parallaxed = true;
		}
		this.objectcount++;
		if (type.is_contained)
		{
			inst.is_contained = true;
			if (inst.recycled)
				inst.siblings.length = 0;
			else
				inst.siblings = [];			// note: should not include self in siblings
			if (!is_startup_instance && !skip_siblings)	// layout links initial instances
			{
				for (i = 0, len = type.container.length; i < len; i++)
				{
					if (type.container[i] === type)
						continue;
					if (!type.container[i].default_instance)
					{
						return null;
					}
					inst.siblings.push(this.createInstanceFromInit(type.container[i].default_instance, original_layer, false, is_world ? inst.x : sx, is_world ? inst.y : sy, true));
				}
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					inst.siblings[i].siblings.push(inst);
					for (j = 0; j < len; j++)
					{
						if (i !== j)
							inst.siblings[i].siblings.push(inst.siblings[j]);
					}
				}
			}
		}
		else
		{
			inst.is_contained = false;
			inst.siblings = null;
		}
		inst.onCreate();
		if (!inst.recycled)
			cr.seal(inst);
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i].postCreate)
				inst.behavior_insts[i].postCreate();
		}
		return inst;
	};
	Runtime.prototype.getLayerByName = function (layer_name)
	{
		var i, len;
		for (i = 0, len = this.running_layout.layers.length; i < len; i++)
		{
			var layer = this.running_layout.layers[i];
			if (cr.equals_nocase(layer.name, layer_name))
				return layer;
		}
		return null;
	};
	Runtime.prototype.getLayerByNumber = function (index)
	{
		index = cr.floor(index);
		if (index < 0)
			index = 0;
		if (index >= this.running_layout.layers.length)
			index = this.running_layout.layers.length - 1;
		return this.running_layout.layers[index];
	};
	Runtime.prototype.getLayer = function (l)
	{
		if (cr.is_number(l))
			return this.getLayerByNumber(l);
		else
			return this.getLayerByName(l.toString());
	};
	Runtime.prototype.clearSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].getCurrentSol().select_all = true;
		}
	};
	Runtime.prototype.pushCleanSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].pushCleanSol();
		}
	};
	Runtime.prototype.pushCopySol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].pushCopySol();
		}
	};
	Runtime.prototype.popSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].popSol();
		}
	};
	Runtime.prototype.updateAllCells = function (type)
	{
		if (!type.any_cell_changed)
			return;		// all instances must already be up-to-date
		var i, len, instances = type.instances;
		for (i = 0, len = instances.length; i < len; ++i)
		{
			instances[i].update_collision_cell();
		}
		var createRow = this.createRow;
		for (i = 0, len = createRow.length; i < len; ++i)
		{
			if (createRow[i].type === type)
				createRow[i].update_collision_cell();
		}
		type.any_cell_changed = false;
	};
	Runtime.prototype.getCollisionCandidates = function (layer, rtype, bbox, candidates)
	{
		var i, len, t;
		var is_parallaxed = (layer ? (layer.parallaxX !== 1 || layer.parallaxY !== 1) : false);
		if (rtype.is_family)
		{
			for (i = 0, len = rtype.members.length; i < len; ++i)
			{
				t = rtype.members[i];
				if (is_parallaxed || t.any_instance_parallaxed)
				{
					cr.appendArray(candidates, t.instances);
				}
				else
				{
					this.updateAllCells(t);
					t.collision_grid.queryRange(bbox, candidates);
				}
			}
		}
		else
		{
			if (is_parallaxed || rtype.any_instance_parallaxed)
			{
				cr.appendArray(candidates, rtype.instances);
			}
			else
			{
				this.updateAllCells(rtype);
				rtype.collision_grid.queryRange(bbox, candidates);
			}
		}
	};
	Runtime.prototype.getTypesCollisionCandidates = function (layer, types, bbox, candidates)
	{
		var i, len;
		for (i = 0, len = types.length; i < len; ++i)
		{
			this.getCollisionCandidates(layer, types[i], bbox, candidates);
		}
	};
	Runtime.prototype.getSolidCollisionCandidates = function (layer, bbox, candidates)
	{
		var solid = this.getSolidBehavior();
		if (!solid)
			return null;
		this.getTypesCollisionCandidates(layer, solid.my_types, bbox, candidates);
	};
	Runtime.prototype.getJumpthruCollisionCandidates = function (layer, bbox, candidates)
	{
		var jumpthru = this.getJumpthruBehavior();
		if (!jumpthru)
			return null;
		this.getTypesCollisionCandidates(layer, jumpthru.my_types, bbox, candidates);
	};
	Runtime.prototype.testAndSelectCanvasPointOverlap = function (type, ptx, pty, inverted)
	{
		var sol = type.getCurrentSol();
		var i, j, inst, len;
		var lx, ly;
		if (sol.select_all)
		{
			if (!inverted)
			{
				sol.select_all = false;
				sol.instances.length = 0;   // clear contents
			}
			for (i = 0, len = type.instances.length; i < len; i++)
			{
				inst = type.instances[i];
				inst.update_bbox();
				lx = inst.layer.canvasToLayer(ptx, pty, true);
				ly = inst.layer.canvasToLayer(ptx, pty, false);
				if (inst.contains_pt(lx, ly))
				{
					if (inverted)
						return false;
					else
						sol.instances.push(inst);
				}
			}
		}
		else
		{
			j = 0;
			for (i = 0, len = sol.instances.length; i < len; i++)
			{
				inst = sol.instances[i];
				inst.update_bbox();
				lx = inst.layer.canvasToLayer(ptx, pty, true);
				ly = inst.layer.canvasToLayer(ptx, pty, false);
				if (inst.contains_pt(lx, ly))
				{
					if (inverted)
						return false;
					else
					{
						sol.instances[j] = sol.instances[i];
						j++;
					}
				}
			}
			if (!inverted)
				sol.instances.length = j;
		}
		type.applySolToContainer();
		if (inverted)
			return true;		// did not find anything overlapping
		else
			return sol.hasObjects();
	};
	Runtime.prototype.testOverlap = function (a, b)
	{
		if (!a || !b || a === b || !a.collisionsEnabled || !b.collisionsEnabled)
			return false;
		a.update_bbox();
		b.update_bbox();
		var layera = a.layer;
		var layerb = b.layer;
		var different_layers = (layera !== layerb && (layera.parallaxX !== layerb.parallaxX || layerb.parallaxY !== layerb.parallaxY || layera.scale !== layerb.scale || layera.angle !== layerb.angle || layera.zoomRate !== layerb.zoomRate));
		var i, len, i2, i21, x, y, haspolya, haspolyb, polya, polyb;
		if (!different_layers)	// same layers: easy check
		{
			if (!a.bbox.intersects_rect(b.bbox))
				return false;
			if (!a.bquad.intersects_quad(b.bquad))
				return false;
			if (a.tilemap_exists && b.tilemap_exists)
				return false;
			if (a.tilemap_exists)
				return this.testTilemapOverlap(a, b);
			if (b.tilemap_exists)
				return this.testTilemapOverlap(b, a);
			haspolya = (a.collision_poly && !a.collision_poly.is_empty());
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolya && !haspolyb)
				return true;
			if (haspolya)
			{
				a.collision_poly.cache_poly(a.width, a.height, a.angle);
				polya = a.collision_poly;
			}
			else
			{
				this.temp_poly.set_from_quad(a.bquad, a.x, a.y, a.width, a.height);
				polya = this.temp_poly;
			}
			if (haspolyb)
			{
				b.collision_poly.cache_poly(b.width, b.height, b.angle);
				polyb = b.collision_poly;
			}
			else
			{
				this.temp_poly.set_from_quad(b.bquad, b.x, b.y, b.width, b.height);
				polyb = this.temp_poly;
			}
			return polya.intersects_poly(polyb, b.x - a.x, b.y - a.y);
		}
		else	// different layers: need to do full translated check
		{
			haspolya = (a.collision_poly && !a.collision_poly.is_empty());
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (haspolya)
			{
				a.collision_poly.cache_poly(a.width, a.height, a.angle);
				this.temp_poly.set_from_poly(a.collision_poly);
			}
			else
			{
				this.temp_poly.set_from_quad(a.bquad, a.x, a.y, a.width, a.height);
			}
			polya = this.temp_poly;
			if (haspolyb)
			{
				b.collision_poly.cache_poly(b.width, b.height, b.angle);
				this.temp_poly2.set_from_poly(b.collision_poly);
			}
			else
			{
				this.temp_poly2.set_from_quad(b.bquad, b.x, b.y, b.width, b.height);
			}
			polyb = this.temp_poly2;
			for (i = 0, len = polya.pts_count; i < len; i++)
			{
				i2 = i * 2;
				i21 = i2 + 1;
				x = polya.pts_cache[i2];
				y = polya.pts_cache[i21];
				polya.pts_cache[i2] = layera.layerToCanvas(x + a.x, y + a.y, true);
				polya.pts_cache[i21] = layera.layerToCanvas(x + a.x, y + a.y, false);
			}
			polya.update_bbox();
			for (i = 0, len = polyb.pts_count; i < len; i++)
			{
				i2 = i * 2;
				i21 = i2 + 1;
				x = polyb.pts_cache[i2];
				y = polyb.pts_cache[i21];
				polyb.pts_cache[i2] = layerb.layerToCanvas(x + b.x, y + b.y, true);
				polyb.pts_cache[i21] = layerb.layerToCanvas(x + b.x, y + b.y, false);
			}
			polyb.update_bbox();
			return polya.intersects_poly(polyb, 0, 0);
		}
	};
	var tmpQuad = new cr.quad();
	var tmpRect = new cr.rect(0, 0, 0, 0);
	var collrect_candidates = [];
	Runtime.prototype.testTilemapOverlap = function (tm, a)
	{
		var i, len, c, rc;
		var bbox = a.bbox;
		var tmx = tm.x;
		var tmy = tm.y;
		tm.getCollisionRectCandidates(bbox, collrect_candidates);
		var collrects = collrect_candidates;
		var haspolya = (a.collision_poly && !a.collision_poly.is_empty());
		for (i = 0, len = collrects.length; i < len; ++i)
		{
			c = collrects[i];
			rc = c.rc;
			if (bbox.intersects_rect_off(rc, tmx, tmy))
			{
				tmpQuad.set_from_rect(rc);
				tmpQuad.offset(tmx, tmy);
				if (tmpQuad.intersects_quad(a.bquad))
				{
					if (haspolya)
					{
						a.collision_poly.cache_poly(a.width, a.height, a.angle);
						if (c.poly)
						{
							if (c.poly.intersects_poly(a.collision_poly, a.x - (tmx + rc.left), a.y - (tmy + rc.top)))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							this.temp_poly.set_from_quad(tmpQuad, 0, 0, rc.right - rc.left, rc.bottom - rc.top);
							if (this.temp_poly.intersects_poly(a.collision_poly, a.x, a.y))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
					}
					else
					{
						if (c.poly)
						{
							this.temp_poly.set_from_quad(a.bquad, 0, 0, a.width, a.height);
							if (c.poly.intersects_poly(this.temp_poly, -(tmx + rc.left), -(tmy + rc.top)))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
				}
			}
		}
		collrect_candidates.length = 0;
		return false;
	};
	Runtime.prototype.testRectOverlap = function (r, b)
	{
		if (!b || !b.collisionsEnabled)
			return false;
		b.update_bbox();
		var layerb = b.layer;
		var haspolyb, polyb;
		if (!b.bbox.intersects_rect(r))
			return false;
		if (b.tilemap_exists)
		{
			b.getCollisionRectCandidates(r, collrect_candidates);
			var collrects = collrect_candidates;
			var i, len, c, tilerc;
			var tmx = b.x;
			var tmy = b.y;
			for (i = 0, len = collrects.length; i < len; ++i)
			{
				c = collrects[i];
				tilerc = c.rc;
				if (r.intersects_rect_off(tilerc, tmx, tmy))
				{
					if (c.poly)
					{
						this.temp_poly.set_from_rect(r, 0, 0);
						if (c.poly.intersects_poly(this.temp_poly, -(tmx + tilerc.left), -(tmy + tilerc.top)))
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
					else
					{
						collrect_candidates.length = 0;
						return true;
					}
				}
			}
			collrect_candidates.length = 0;
			return false;
		}
		else
		{
			tmpQuad.set_from_rect(r);
			if (!b.bquad.intersects_quad(tmpQuad))
				return false;
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolyb)
				return true;
			b.collision_poly.cache_poly(b.width, b.height, b.angle);
			tmpQuad.offset(-r.left, -r.top);
			this.temp_poly.set_from_quad(tmpQuad, 0, 0, 1, 1);
			return b.collision_poly.intersects_poly(this.temp_poly, r.left - b.x, r.top - b.y);
		}
	};
	Runtime.prototype.testSegmentOverlap = function (x1, y1, x2, y2, b)
	{
		if (!b || !b.collisionsEnabled)
			return false;
		b.update_bbox();
		var layerb = b.layer;
		var haspolyb, polyb;
		tmpRect.set(cr.min(x1, x2), cr.min(y1, y2), cr.max(x1, x2), cr.max(y1, y2));
		if (!b.bbox.intersects_rect(tmpRect))
			return false;
		if (b.tilemap_exists)
		{
			b.getCollisionRectCandidates(tmpRect, collrect_candidates);
			var collrects = collrect_candidates;
			var i, len, c, tilerc;
			var tmx = b.x;
			var tmy = b.y;
			for (i = 0, len = collrects.length; i < len; ++i)
			{
				c = collrects[i];
				tilerc = c.rc;
				if (tmpRect.intersects_rect_off(tilerc, tmx, tmy))
				{
					tmpQuad.set_from_rect(tilerc);
					tmpQuad.offset(tmx, tmy);
					if (tmpQuad.intersects_segment(x1, y1, x2, y2))
					{
						if (c.poly)
						{
							if (c.poly.intersects_segment(tmx + tilerc.left, tmy + tilerc.top, x1, y1, x2, y2))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
				}
			}
			collrect_candidates.length = 0;
			return false;
		}
		else
		{
			if (!b.bquad.intersects_segment(x1, y1, x2, y2))
				return false;
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolyb)
				return true;
			b.collision_poly.cache_poly(b.width, b.height, b.angle);
			return b.collision_poly.intersects_segment(b.x, b.y, x1, y1, x2, y2);
		}
	};
	Runtime.prototype.typeHasBehavior = function (t, b)
	{
		if (!b)
			return false;
		var i, len, j, lenj, f;
		for (i = 0, len = t.behaviors.length; i < len; i++)
		{
			if (t.behaviors[i].behavior instanceof b)
				return true;
		}
		if (!t.is_family)
		{
			for (i = 0, len = t.families.length; i < len; i++)
			{
				f = t.families[i];
				for (j = 0, lenj = f.behaviors.length; j < lenj; j++)
				{
					if (f.behaviors[j].behavior instanceof b)
						return true;
				}
			}
		}
		return false;
	};
	Runtime.prototype.typeHasNoSaveBehavior = function (t)
	{
		return this.typeHasBehavior(t, cr.behaviors.NoSave);
	};
	Runtime.prototype.typeHasPersistBehavior = function (t)
	{
		return this.typeHasBehavior(t, cr.behaviors.Persist);
	};
	Runtime.prototype.getSolidBehavior = function ()
	{
		return this.solidBehavior;
	};
	Runtime.prototype.getJumpthruBehavior = function ()
	{
		return this.jumpthruBehavior;
	};
	var candidates = [];
	Runtime.prototype.testOverlapSolid = function (inst)
	{
		var i, len, s;
		inst.update_bbox();
		this.getSolidCollisionCandidates(inst.layer, inst.bbox, candidates);
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			s = candidates[i];
			if (!s.extra.solidEnabled)
				continue;
			if (this.testOverlap(inst, s))
			{
				candidates.length = 0;
				return s;
			}
		}
		candidates.length = 0;
		return null;
	};
	Runtime.prototype.testRectOverlapSolid = function (r)
	{
		var i, len, s;
		this.getSolidCollisionCandidates(null, r, candidates);
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			s = candidates[i];
			if (!s.extra.solidEnabled)
				continue;
			if (this.testRectOverlap(r, s))
			{
				candidates.length = 0;
				return s;
			}
		}
		candidates.length = 0;
		return null;
	};
	var jumpthru_array_ret = [];
	Runtime.prototype.testOverlapJumpThru = function (inst, all)
	{
		var ret = null;
		if (all)
		{
			ret = jumpthru_array_ret;
			ret.length = 0;
		}
		inst.update_bbox();
		this.getJumpthruCollisionCandidates(inst.layer, inst.bbox, candidates);
		var i, len, j;
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			j = candidates[i];
			if (!j.extra.jumpthruEnabled)
				continue;
			if (this.testOverlap(inst, j))
			{
				if (all)
					ret.push(j);
				else
				{
					candidates.length = 0;
					return j;
				}
			}
		}
		candidates.length = 0;
		return ret;
	};
	Runtime.prototype.pushOutSolid = function (inst, xdir, ydir, dist, include_jumpthrus, specific_jumpthru)
	{
		var push_dist = dist || 50;
		var oldx = inst.x
		var oldy = inst.y;
		var i;
		var last_overlapped = null, secondlast_overlapped = null;
		for (i = 0; i < push_dist; i++)
		{
			inst.x = (oldx + (xdir * i));
			inst.y = (oldy + (ydir * i));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, last_overlapped))
			{
				last_overlapped = this.testOverlapSolid(inst);
				if (last_overlapped)
					secondlast_overlapped = last_overlapped;
				if (!last_overlapped)
				{
					if (include_jumpthrus)
					{
						if (specific_jumpthru)
							last_overlapped = (this.testOverlap(inst, specific_jumpthru) ? specific_jumpthru : null);
						else
							last_overlapped = this.testOverlapJumpThru(inst);
						if (last_overlapped)
							secondlast_overlapped = last_overlapped;
					}
					if (!last_overlapped)
					{
						if (secondlast_overlapped)
							this.pushInFractional(inst, xdir, ydir, secondlast_overlapped, 16);
						return true;
					}
				}
			}
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.pushOut = function (inst, xdir, ydir, dist, otherinst)
	{
		var push_dist = dist || 50;
		var oldx = inst.x
		var oldy = inst.y;
		var i;
		for (i = 0; i < push_dist; i++)
		{
			inst.x = (oldx + (xdir * i));
			inst.y = (oldy + (ydir * i));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, otherinst))
				return true;
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.pushInFractional = function (inst, xdir, ydir, obj, limit)
	{
		var divisor = 2;
		var frac;
		var forward = false;
		var overlapping = false;
		var bestx = inst.x;
		var besty = inst.y;
		while (divisor <= limit)
		{
			frac = 1 / divisor;
			divisor *= 2;
			inst.x += xdir * frac * (forward ? 1 : -1);
			inst.y += ydir * frac * (forward ? 1 : -1);
			inst.set_bbox_changed();
			if (this.testOverlap(inst, obj))
			{
				forward = true;
				overlapping = true;
			}
			else
			{
				forward = false;
				overlapping = false;
				bestx = inst.x;
				besty = inst.y;
			}
		}
		if (overlapping)
		{
			inst.x = bestx;
			inst.y = besty;
			inst.set_bbox_changed();
		}
	};
	Runtime.prototype.pushOutSolidNearest = function (inst, max_dist_)
	{
		var max_dist = (cr.is_undefined(max_dist_) ? 100 : max_dist_);
		var dist = 0;
		var oldx = inst.x
		var oldy = inst.y;
		var dir = 0;
		var dx = 0, dy = 0;
		var last_overlapped = this.testOverlapSolid(inst);
		if (!last_overlapped)
			return true;		// already clear of solids
		while (dist <= max_dist)
		{
			switch (dir) {
			case 0:		dx = 0; dy = -1; dist++; break;
			case 1:		dx = 1; dy = -1; break;
			case 2:		dx = 1; dy = 0; break;
			case 3:		dx = 1; dy = 1; break;
			case 4:		dx = 0; dy = 1; break;
			case 5:		dx = -1; dy = 1; break;
			case 6:		dx = -1; dy = 0; break;
			case 7:		dx = -1; dy = -1; break;
			}
			dir = (dir + 1) % 8;
			inst.x = cr.floor(oldx + (dx * dist));
			inst.y = cr.floor(oldy + (dy * dist));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, last_overlapped))
			{
				last_overlapped = this.testOverlapSolid(inst);
				if (!last_overlapped)
					return true;
			}
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.registerCollision = function (a, b)
	{
		if (!a.collisionsEnabled || !b.collisionsEnabled)
			return;
		this.registered_collisions.push([a, b]);
	};
	Runtime.prototype.checkRegisteredCollision = function (a, b)
	{
		var i, len, x;
		for (i = 0, len = this.registered_collisions.length; i < len; i++)
		{
			x = this.registered_collisions[i];
			if ((x[0] == a && x[1] == b) || (x[0] == b && x[1] == a))
				return true;
		}
		return false;
	};
	Runtime.prototype.calculateSolidBounceAngle = function(inst, startx, starty, obj)
	{
		var objx = inst.x;
		var objy = inst.y;
		var radius = cr.max(10, cr.distanceTo(startx, starty, objx, objy));
		var startangle = cr.angleTo(startx, starty, objx, objy);
		var firstsolid = obj || this.testOverlapSolid(inst);
		if (!firstsolid)
			return cr.clamp_angle(startangle + cr.PI);
		var cursolid = firstsolid;
		var i, curangle, anticlockwise_free_angle, clockwise_free_angle;
		var increment = cr.to_radians(5);	// 5 degree increments
		for (i = 1; i < 36; i++)
		{
			curangle = startangle - i * increment;
			inst.x = startx + Math.cos(curangle) * radius;
			inst.y = starty + Math.sin(curangle) * radius;
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, cursolid))
			{
				cursolid = obj ? null : this.testOverlapSolid(inst);
				if (!cursolid)
				{
					anticlockwise_free_angle = curangle;
					break;
				}
			}
		}
		if (i === 36)
			anticlockwise_free_angle = cr.clamp_angle(startangle + cr.PI);
		var cursolid = firstsolid;
		for (i = 1; i < 36; i++)
		{
			curangle = startangle + i * increment;
			inst.x = startx + Math.cos(curangle) * radius;
			inst.y = starty + Math.sin(curangle) * radius;
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, cursolid))
			{
				cursolid = obj ? null : this.testOverlapSolid(inst);
				if (!cursolid)
				{
					clockwise_free_angle = curangle;
					break;
				}
			}
		}
		if (i === 36)
			clockwise_free_angle = cr.clamp_angle(startangle + cr.PI);
		inst.x = objx;
		inst.y = objy;
		inst.set_bbox_changed();
		if (clockwise_free_angle === anticlockwise_free_angle)
			return clockwise_free_angle;
		var half_diff = cr.angleDiff(clockwise_free_angle, anticlockwise_free_angle) / 2;
		var normal;
		if (cr.angleClockwise(clockwise_free_angle, anticlockwise_free_angle))
		{
			normal = cr.clamp_angle(anticlockwise_free_angle + half_diff + cr.PI);
		}
		else
		{
			normal = cr.clamp_angle(clockwise_free_angle + half_diff);
		}
;
		var vx = Math.cos(startangle);
		var vy = Math.sin(startangle);
		var nx = Math.cos(normal);
		var ny = Math.sin(normal);
		var v_dot_n = vx * nx + vy * ny;
		var rx = vx - 2 * v_dot_n * nx;
		var ry = vy - 2 * v_dot_n * ny;
		return cr.angleTo(0, 0, rx, ry);
	};
	var triggerSheetIndex = -1;
	Runtime.prototype.trigger = function (method, inst, value /* for fast triggers */)
	{
;
		if (!this.running_layout)
			return false;
		var sheet = this.running_layout.event_sheet;
		if (!sheet)
			return false;     // no event sheet active; nothing to trigger
		var ret = false;
		var r, i, len;
		triggerSheetIndex++;
		var deep_includes = sheet.deep_includes;
		for (i = 0, len = deep_includes.length; i < len; ++i)
		{
			r = this.triggerOnSheet(method, inst, deep_includes[i], value);
			ret = ret || r;
		}
		r = this.triggerOnSheet(method, inst, sheet, value);
		ret = ret || r;
		triggerSheetIndex--;
		return ret;
    };
    Runtime.prototype.triggerOnSheet = function (method, inst, sheet, value)
    {
        var ret = false;
		var i, leni, r, families;
		if (!inst)
		{
			r = this.triggerOnSheetForTypeName(method, inst, "system", sheet, value);
			ret = ret || r;
		}
		else
		{
			r = this.triggerOnSheetForTypeName(method, inst, inst.type.name, sheet, value);
			ret = ret || r;
			families = inst.type.families;
			for (i = 0, leni = families.length; i < leni; ++i)
			{
				r = this.triggerOnSheetForTypeName(method, inst, families[i].name, sheet, value);
				ret = ret || r;
			}
		}
		return ret;             // true if anything got triggered
	};
	Runtime.prototype.triggerOnSheetForTypeName = function (method, inst, type_name, sheet, value)
	{
		var i, leni;
		var ret = false, ret2 = false;
		var trig, index;
		var fasttrigger = (typeof value !== "undefined");
		var triggers = (fasttrigger ? sheet.fasttriggers : sheet.triggers);
		var obj_entry = triggers[type_name];
		if (!obj_entry)
			return ret;
		var triggers_list = null;
		for (i = 0, leni = obj_entry.length; i < leni; ++i)
		{
			if (obj_entry[i].method == method)
			{
				triggers_list = obj_entry[i].evs;
				break;
			}
		}
		if (!triggers_list)
			return ret;
		var triggers_to_fire;
		if (fasttrigger)
		{
			triggers_to_fire = triggers_list[value];
		}
		else
		{
			triggers_to_fire = triggers_list;
		}
		if (!triggers_to_fire)
			return null;
		for (i = 0, leni = triggers_to_fire.length; i < leni; i++)
		{
			trig = triggers_to_fire[i][0];
			index = triggers_to_fire[i][1];
			ret2 = this.executeSingleTrigger(inst, type_name, trig, index);
			ret = ret || ret2;
		}
		return ret;
	};
	Runtime.prototype.executeSingleTrigger = function (inst, type_name, trig, index)
	{
		var i, leni;
		var ret = false;
		this.trigger_depth++;
		var current_event = this.getCurrentEventStack().current_event;
		if (current_event)
			this.pushCleanSol(current_event.solModifiersIncludingParents);
		var isrecursive = (this.trigger_depth > 1);		// calling trigger from inside another trigger
		this.pushCleanSol(trig.solModifiersIncludingParents);
		if (isrecursive)
			this.pushLocalVarStack();
		var event_stack = this.pushEventStack(trig);
		event_stack.current_event = trig;
		if (inst)
		{
			var sol = this.types[type_name].getCurrentSol();
			sol.select_all = false;
			sol.instances.length = 1;
			sol.instances[0] = inst;
			this.types[type_name].applySolToContainer();
		}
		var ok_to_run = true;
		if (trig.parent)
		{
			var temp_parents_arr = event_stack.temp_parents_arr;
			var cur_parent = trig.parent;
			while (cur_parent)
			{
				temp_parents_arr.push(cur_parent);
				cur_parent = cur_parent.parent;
			}
			temp_parents_arr.reverse();
			for (i = 0, leni = temp_parents_arr.length; i < leni; i++)
			{
				if (!temp_parents_arr[i].run_pretrigger())   // parent event failed
				{
					ok_to_run = false;
					break;
				}
			}
		}
		if (ok_to_run)
		{
			this.execcount++;
			if (trig.orblock)
				trig.run_orblocktrigger(index);
			else
				trig.run();
			ret = ret || event_stack.last_event_true;
		}
		this.popEventStack();
		if (isrecursive)
			this.popLocalVarStack();
		this.popSol(trig.solModifiersIncludingParents);
		if (current_event)
			this.popSol(current_event.solModifiersIncludingParents);
		if (this.isInOnDestroy === 0 && triggerSheetIndex === 0 && !this.isRunningEvents && (!this.deathRow.isEmpty() || this.createRow.length))
		{
			this.ClearDeathRow();
		}
		this.trigger_depth--;
		return ret;
	};
	Runtime.prototype.getCurrentCondition = function ()
	{
		var evinfo = this.getCurrentEventStack();
		return evinfo.current_event.conditions[evinfo.cndindex];
	};
	Runtime.prototype.getCurrentAction = function ()
	{
		var evinfo = this.getCurrentEventStack();
		return evinfo.current_event.actions[evinfo.actindex];
	};
	Runtime.prototype.pushLocalVarStack = function ()
	{
		this.localvar_stack_index++;
		if (this.localvar_stack_index >= this.localvar_stack.length)
			this.localvar_stack.push([]);
	};
	Runtime.prototype.popLocalVarStack = function ()
	{
;
		this.localvar_stack_index--;
	};
	Runtime.prototype.getCurrentLocalVarStack = function ()
	{
		return this.localvar_stack[this.localvar_stack_index];
	};
	Runtime.prototype.pushEventStack = function (cur_event)
	{
		this.event_stack_index++;
		if (this.event_stack_index >= this.event_stack.length)
			this.event_stack.push(new cr.eventStackFrame());
		var ret = this.getCurrentEventStack();
		ret.reset(cur_event);
		return ret;
	};
	Runtime.prototype.popEventStack = function ()
	{
;
		this.event_stack_index--;
	};
	Runtime.prototype.getCurrentEventStack = function ()
	{
		return this.event_stack[this.event_stack_index];
	};
	Runtime.prototype.pushLoopStack = function (name_)
	{
		this.loop_stack_index++;
		if (this.loop_stack_index >= this.loop_stack.length)
		{
			this.loop_stack.push(cr.seal({ name: name_, index: 0, stopped: false }));
		}
		var ret = this.getCurrentLoop();
		ret.name = name_;
		ret.index = 0;
		ret.stopped = false;
		return ret;
	};
	Runtime.prototype.popLoopStack = function ()
	{
;
		this.loop_stack_index--;
	};
	Runtime.prototype.getCurrentLoop = function ()
	{
		return this.loop_stack[this.loop_stack_index];
	};
	Runtime.prototype.getEventVariableByName = function (name, scope)
	{
		var i, leni, j, lenj, sheet, e;
		while (scope)
		{
			for (i = 0, leni = scope.subevents.length; i < leni; i++)
			{
				e = scope.subevents[i];
				if (e instanceof cr.eventvariable && cr.equals_nocase(name, e.name))
					return e;
			}
			scope = scope.parent;
		}
		for (i = 0, leni = this.eventsheets_by_index.length; i < leni; i++)
		{
			sheet = this.eventsheets_by_index[i];
			for (j = 0, lenj = sheet.events.length; j < lenj; j++)
			{
				e = sheet.events[j];
				if (e instanceof cr.eventvariable && cr.equals_nocase(name, e.name))
					return e;
			}
		}
		return null;
	};
	Runtime.prototype.getLayoutBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			if (this.layouts_by_index[i].sid === sid_)
				return this.layouts_by_index[i];
		}
		return null;
	};
	Runtime.prototype.getObjectTypeBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			if (this.types_by_index[i].sid === sid_)
				return this.types_by_index[i];
		}
		return null;
	};
	Runtime.prototype.getGroupBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.allGroups.length; i < len; i++)
		{
			if (this.allGroups[i].sid === sid_)
				return this.allGroups[i];
		}
		return null;
	};
	function makeSaveDb(e)
	{
		var db = e.target.result;
		db.createObjectStore("saves", { keyPath: "slot" });
	};
	function IndexedDB_WriteSlot(slot_, data_, oncomplete_, onerror_)
	{
		var request = indexedDB.open("_C2SaveStates");
		request.onupgradeneeded = makeSaveDb;
		request.onerror = onerror_;
		request.onsuccess = function (e)
		{
			var db = e.target.result;
			db.onerror = onerror_;
			var transaction = db.transaction(["saves"], "readwrite");
			var objectStore = transaction.objectStore("saves");
			var putReq = objectStore.put({"slot": slot_, "data": data_ });
			putReq.onsuccess = oncomplete_;
		};
	};
	function IndexedDB_ReadSlot(slot_, oncomplete_, onerror_)
	{
		var request = indexedDB.open("_C2SaveStates");
		request.onupgradeneeded = makeSaveDb;
		request.onerror = onerror_;
		request.onsuccess = function (e)
		{
			var db = e.target.result;
			db.onerror = onerror_;
			var transaction = db.transaction(["saves"]);
			var objectStore = transaction.objectStore("saves");
			var readReq = objectStore.get(slot_);
			readReq.onsuccess = function (e)
			{
				if (readReq.result)
					oncomplete_(readReq.result["data"]);
				else
					oncomplete_(null);
			};
		};
	};
	Runtime.prototype.signalContinuousPreview = function ()
	{
		this.signalledContinuousPreview = true;
	};
	function doContinuousPreviewReload()
	{
		cr.logexport("Reloading for continuous preview");
		if (!!window["c2cocoonjs"])
		{
			CocoonJS["App"]["reload"]();
		}
		else
		{
			if (window.location.search.indexOf("continuous") > -1)
				window.location.reload(true);
			else
				window.location = window.location + "?continuous";
		}
	};
	Runtime.prototype.handleSaveLoad = function ()
	{
		var self = this;
		var savingToSlot = this.saveToSlot;
		var savingJson = this.lastSaveJson;
		var loadingFromSlot = this.loadFromSlot;
		var continuous = false;
		if (this.signalledContinuousPreview)
		{
			continuous = true;
			savingToSlot = "__c2_continuouspreview";
			this.signalledContinuousPreview = false;
		}
		if (savingToSlot.length)
		{
			this.ClearDeathRow();
			savingJson = this.saveToJSONString();
			if (window.indexedDB && !this.isCocoonJs)
			{
				IndexedDB_WriteSlot(savingToSlot, savingJson, function ()
				{
					cr.logexport("Saved state to IndexedDB storage (" + savingJson.length + " bytes)");
					self.lastSaveJson = savingJson;
					self.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
					self.lastSaveJson = "";
					if (continuous)
						doContinuousPreviewReload();
				}, function (e)
				{
					try {
						localStorage.setItem("__c2save_" + savingToSlot, savingJson);
						cr.logexport("Saved state to WebStorage (" + savingJson.length + " bytes)");
						self.lastSaveJson = savingJson;
						self.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
						self.lastSaveJson = "";
						if (continuous)
							doContinuousPreviewReload();
					}
					catch (f)
					{
						cr.logexport("Failed to save game state: " + e + "; " + f);
					}
				});
			}
			else
			{
				try {
					localStorage.setItem("__c2save_" + savingToSlot, savingJson);
					cr.logexport("Saved state to WebStorage (" + savingJson.length + " bytes)");
					self.lastSaveJson = savingJson;
					this.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
					self.lastSaveJson = "";
					if (continuous)
						doContinuousPreviewReload();
				}
				catch (e)
				{
					cr.logexport("Error saving to WebStorage: " + e);
				}
			}
			this.saveToSlot = "";
			this.loadFromSlot = "";
			this.loadFromJson = "";
		}
		if (loadingFromSlot.length)
		{
			if (window.indexedDB && !this.isCocoonJs)
			{
				IndexedDB_ReadSlot(loadingFromSlot, function (result_)
				{
					if (result_)
					{
						self.loadFromJson = result_;
						cr.logexport("Loaded state from IndexedDB storage (" + self.loadFromJson.length + " bytes)");
					}
					else
					{
						self.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
						cr.logexport("Loaded state from WebStorage (" + self.loadFromJson.length + " bytes)");
					}
					self.suspendDrawing = false;
					if (!self.loadFromJson.length)
						self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
				}, function (e)
				{
					self.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
					cr.logexport("Loaded state from WebStorage (" + self.loadFromJson.length + " bytes)");
					self.suspendDrawing = false;
					if (!self.loadFromJson.length)
						self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
				});
			}
			else
			{
				this.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
				cr.logexport("Loaded state from WebStorage (" + this.loadFromJson.length + " bytes)");
				this.suspendDrawing = false;
				if (!self.loadFromJson.length)
					self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
			}
			this.loadFromSlot = "";
			this.saveToSlot = "";
		}
		if (this.loadFromJson.length)
		{
			this.ClearDeathRow();
			this.loadFromJSONString(this.loadFromJson);
			this.lastSaveJson = this.loadFromJson;
			this.trigger(cr.system_object.prototype.cnds.OnLoadComplete, null);
			this.lastSaveJson = "";
			this.loadFromJson = "";
		}
	};
	function CopyExtraObject(extra)
	{
		var p, ret = {};
		for (p in extra)
		{
			if (extra.hasOwnProperty(p))
			{
				if (extra[p] instanceof cr.ObjectSet)
					continue;
				if (extra[p] && typeof extra[p].c2userdata !== "undefined")
					continue;
				ret[p] = extra[p];
			}
		}
		return ret;
	};
	Runtime.prototype.saveToJSONString = function()
	{
		var i, len, j, lenj, type, layout, typeobj, g, c, a, v, p;
		var o = {
			"c2save":				true,
			"version":				1,
			"rt": {
				"time":				this.kahanTime.sum,
				"timescale":		this.timescale,
				"tickcount":		this.tickcount,
				"execcount":		this.execcount,
				"next_uid":			this.next_uid,
				"running_layout":	this.running_layout.sid,
				"start_time_offset": (Date.now() - this.start_time)
			},
			"types": {},
			"layouts": {},
			"events": {
				"groups": {},
				"cnds": {},
				"acts": {},
				"vars": {}
			}
		};
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || this.typeHasNoSaveBehavior(type))
				continue;
			typeobj = {
				"instances": []
			};
			if (cr.hasAnyOwnProperty(type.extra))
				typeobj["ex"] = CopyExtraObject(type.extra);
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				typeobj["instances"].push(this.saveInstanceToJSON(type.instances[j]));
			}
			o["types"][type.sid.toString()] = typeobj;
		}
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			layout = this.layouts_by_index[i];
			o["layouts"][layout.sid.toString()] = layout.saveToJSON();
		}
		var ogroups = o["events"]["groups"];
		for (i = 0, len = this.allGroups.length; i < len; i++)
		{
			g = this.allGroups[i];
			ogroups[g.sid.toString()] = this.groups_by_name[g.group_name].group_active;
		}
		var ocnds = o["events"]["cnds"];
		for (p in this.cndsBySid)
		{
			if (this.cndsBySid.hasOwnProperty(p))
			{
				c = this.cndsBySid[p];
				if (cr.hasAnyOwnProperty(c.extra))
					ocnds[p] = { "ex": CopyExtraObject(c.extra) };
			}
		}
		var oacts = o["events"]["acts"];
		for (p in this.actsBySid)
		{
			if (this.actsBySid.hasOwnProperty(p))
			{
				a = this.actsBySid[p];
				if (cr.hasAnyOwnProperty(a.extra))
					oacts[p] = { "ex": a.extra };
			}
		}
		var ovars = o["events"]["vars"];
		for (p in this.varsBySid)
		{
			if (this.varsBySid.hasOwnProperty(p))
			{
				v = this.varsBySid[p];
				if (!v.is_constant && (!v.parent || v.is_static))
					ovars[p] = v.data;
			}
		}
		o["system"] = this.system.saveToJSON();
		return JSON.stringify(o);
	};
	Runtime.prototype.refreshUidMap = function ()
	{
		var i, len, type, j, lenj, inst;
		this.objectsByUid = {};
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				this.objectsByUid[inst.uid.toString()] = inst;
			}
		}
	};
	Runtime.prototype.loadFromJSONString = function (str)
	{
		var o = JSON.parse(str);
		if (!o["c2save"])
			return;		// probably not a c2 save state
		if (o["version"] > 1)
			return;		// from future version of c2; assume not compatible
		var rt = o["rt"];
		this.kahanTime.reset();
		this.kahanTime.sum = rt["time"];
		this.timescale = rt["timescale"];
		this.tickcount = rt["tickcount"];
		this.start_time = Date.now() - rt["start_time_offset"];
		var layout_sid = rt["running_layout"];
		if (layout_sid !== this.running_layout.sid)
		{
			var changeToLayout = this.getLayoutBySid(layout_sid);
			if (changeToLayout)
				this.doChangeLayout(changeToLayout);
			else
				return;		// layout that was saved on has gone missing (deleted?)
		}
		this.isLoadingState = true;
		var i, len, j, lenj, k, lenk, p, type, existing_insts, load_insts, inst, binst, layout, layer, g, iid, t;
		var otypes = o["types"];
		for (p in otypes)
		{
			if (otypes.hasOwnProperty(p))
			{
				type = this.getObjectTypeBySid(parseInt(p, 10));
				if (!type || type.is_family || this.typeHasNoSaveBehavior(type))
					continue;
				if (otypes[p]["ex"])
					type.extra = otypes[p]["ex"];
				else
					cr.wipe(type.extra);
				existing_insts = type.instances;
				load_insts = otypes[p]["instances"];
				for (i = 0, len = cr.min(existing_insts.length, load_insts.length); i < len; i++)
				{
					this.loadInstanceFromJSON(existing_insts[i], load_insts[i]);
				}
				for (i = load_insts.length, len = existing_insts.length; i < len; i++)
					this.DestroyInstance(existing_insts[i]);
				for (i = existing_insts.length, len = load_insts.length; i < len; i++)
				{
					layer = null;
					if (type.plugin.is_world)
					{
						layer = this.running_layout.getLayerBySid(load_insts[i]["w"]["l"]);
						if (!layer)
							continue;
					}
					inst = this.createInstanceFromInit(type.default_instance, layer, false, 0, 0, true);
					this.loadInstanceFromJSON(inst, load_insts[i]);
				}
				type.stale_iids = true;
			}
		}
		this.ClearDeathRow();
		this.refreshUidMap();
		var olayouts = o["layouts"];
		for (p in olayouts)
		{
			if (olayouts.hasOwnProperty(p))
			{
				layout = this.getLayoutBySid(parseInt(p, 10));
				if (!layout)
					continue;		// must've gone missing
				layout.loadFromJSON(olayouts[p]);
			}
		}
		var ogroups = o["events"]["groups"];
		for (p in ogroups)
		{
			if (ogroups.hasOwnProperty(p))
			{
				g = this.getGroupBySid(parseInt(p, 10));
				if (g && this.groups_by_name[g.group_name])
					this.groups_by_name[g.group_name].group_active = ogroups[p];
			}
		}
		var ocnds = o["events"]["cnds"];
		for (p in ocnds)
		{
			if (ocnds.hasOwnProperty(p) && this.cndsBySid.hasOwnProperty(p))
			{
				this.cndsBySid[p].extra = ocnds[p]["ex"];
			}
		}
		var oacts = o["events"]["acts"];
		for (p in oacts)
		{
			if (oacts.hasOwnProperty(p) && this.actsBySid.hasOwnProperty(p))
			{
				this.actsBySid[p].extra = oacts[p]["ex"];
			}
		}
		var ovars = o["events"]["vars"];
		for (p in ovars)
		{
			if (ovars.hasOwnProperty(p) && this.varsBySid.hasOwnProperty(p))
			{
				this.varsBySid[p].data = ovars[p];
			}
		}
		this.next_uid = rt["next_uid"];
		this.isLoadingState = false;
		this.system.loadFromJSON(o["system"]);
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				if (type.is_contained)
				{
					iid = inst.get_iid();
					inst.siblings.length = 0;
					for (k = 0, lenk = type.container.length; k < lenk; k++)
					{
						t = type.container[k];
						if (type === t)
							continue;
;
						inst.siblings.push(t.instances[iid]);
					}
				}
				if (inst.afterLoad)
					inst.afterLoad();
				if (inst.behavior_insts)
				{
					for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
					{
						binst = inst.behavior_insts[k];
						if (binst.afterLoad)
							binst.afterLoad();
					}
				}
			}
		}
		this.redraw = true;
	};
	Runtime.prototype.saveInstanceToJSON = function(inst, state_only)
	{
		var i, len, world, behinst, et;
		var type = inst.type;
		var plugin = type.plugin;
		var o = {};
		if (state_only)
			o["c2"] = true;		// mark as known json data from Construct 2
		else
			o["uid"] = inst.uid;
		if (cr.hasAnyOwnProperty(inst.extra))
			o["ex"] = CopyExtraObject(inst.extra);
		if (inst.instance_vars && inst.instance_vars.length)
		{
			o["ivs"] = {};
			for (i = 0, len = inst.instance_vars.length; i < len; i++)
			{
				o["ivs"][inst.type.instvar_sids[i].toString()] = inst.instance_vars[i];
			}
		}
		if (plugin.is_world)
		{
			world = {
				"x": inst.x,
				"y": inst.y,
				"w": inst.width,
				"h": inst.height,
				"l": inst.layer.sid,
				"zi": inst.get_zindex()
			};
			if (inst.angle !== 0)
				world["a"] = inst.angle;
			if (inst.opacity !== 1)
				world["o"] = inst.opacity;
			if (inst.hotspotX !== 0.5)
				world["hX"] = inst.hotspotX;
			if (inst.hotspotY !== 0.5)
				world["hY"] = inst.hotspotY;
			if (inst.blend_mode !== 0)
				world["bm"] = inst.blend_mode;
			if (!inst.visible)
				world["v"] = inst.visible;
			if (!inst.collisionsEnabled)
				world["ce"] = inst.collisionsEnabled;
			if (inst.my_timescale !== -1)
				world["mts"] = inst.my_timescale;
			if (type.effect_types.length)
			{
				world["fx"] = [];
				for (i = 0, len = type.effect_types.length; i < len; i++)
				{
					et = type.effect_types[i];
					world["fx"].push({"name": et.name,
									  "active": inst.active_effect_flags[et.index],
									  "params": inst.effect_params[et.index] });
				}
			}
			o["w"] = world;
		}
		if (inst.behavior_insts && inst.behavior_insts.length)
		{
			o["behs"] = {};
			for (i = 0, len = inst.behavior_insts.length; i < len; i++)
			{
				behinst = inst.behavior_insts[i];
				if (behinst.saveToJSON)
					o["behs"][behinst.type.sid.toString()] = behinst.saveToJSON();
			}
		}
		if (inst.saveToJSON)
			o["data"] = inst.saveToJSON();
		return o;
	};
	Runtime.prototype.getInstanceVarIndexBySid = function (type, sid_)
	{
		var i, len;
		for (i = 0, len = type.instvar_sids.length; i < len; i++)
		{
			if (type.instvar_sids[i] === sid_)
				return i;
		}
		return -1;
	};
	Runtime.prototype.getBehaviorIndexBySid = function (inst, sid_)
	{
		var i, len;
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i].type.sid === sid_)
				return i;
		}
		return -1;
	};
	Runtime.prototype.loadInstanceFromJSON = function(inst, o, state_only)
	{
		var p, i, len, iv, oivs, world, fxindex, obehs, behindex;
		var oldlayer;
		var type = inst.type;
		var plugin = type.plugin;
		if (state_only)
		{
			if (!o["c2"])
				return;
		}
		else
			inst.uid = o["uid"];
		if (o["ex"])
			inst.extra = o["ex"];
		else
			cr.wipe(inst.extra);
		oivs = o["ivs"];
		if (oivs)
		{
			for (p in oivs)
			{
				if (oivs.hasOwnProperty(p))
				{
					iv = this.getInstanceVarIndexBySid(type, parseInt(p, 10));
					if (iv < 0 || iv >= inst.instance_vars.length)
						continue;		// must've gone missing
					inst.instance_vars[iv] = oivs[p];
				}
			}
		}
		if (plugin.is_world)
		{
			world = o["w"];
			if (inst.layer.sid !== world["l"])
			{
				oldlayer = inst.layer;
				inst.layer = this.running_layout.getLayerBySid(world["l"]);
				if (inst.layer)
				{
					inst.layer.instances.push(inst);
					inst.layer.zindices_stale = true;
					cr.arrayFindRemove(oldlayer.instances, inst);
					oldlayer.zindices_stale = true;
				}
				else
				{
					inst.layer = oldlayer;
					this.DestroyInstance(inst);
				}
			}
			inst.x = world["x"];
			inst.y = world["y"];
			inst.width = world["w"];
			inst.height = world["h"];
			inst.zindex = world["zi"];
			inst.angle = world.hasOwnProperty("a") ? world["a"] : 0;
			inst.opacity = world.hasOwnProperty("o") ? world["o"] : 1;
			inst.hotspotX = world.hasOwnProperty("hX") ? world["hX"] : 0.5;
			inst.hotspotY = world.hasOwnProperty("hY") ? world["hY"] : 0.5;
			inst.visible = world.hasOwnProperty("v") ? world["v"] : true;
			inst.collisionsEnabled = world.hasOwnProperty("ce") ? world["ce"] : true;
			inst.my_timescale = world.hasOwnProperty("mts") ? world["mts"] : -1;
			inst.blend_mode = world.hasOwnProperty("bm") ? world["bm"] : 0;;
			inst.compositeOp = cr.effectToCompositeOp(inst.blend_mode);
			if (this.gl)
				cr.setGLBlend(inst, inst.blend_mode, this.gl);
			inst.set_bbox_changed();
			if (world.hasOwnProperty("fx"))
			{
				for (i = 0, len = world["fx"].length; i < len; i++)
				{
					fxindex = type.getEffectIndexByName(world["fx"][i]["name"]);
					if (fxindex < 0)
						continue;		// must've gone missing
					inst.active_effect_flags[fxindex] = world["fx"][i]["active"];
					inst.effect_params[fxindex] = world["fx"][i]["params"];
				}
			}
			inst.updateActiveEffects();
		}
		obehs = o["behs"];
		if (obehs)
		{
			for (p in obehs)
			{
				if (obehs.hasOwnProperty(p))
				{
					behindex = this.getBehaviorIndexBySid(inst, parseInt(p, 10));
					if (behindex < 0)
						continue;		// must've gone missing
					inst.behavior_insts[behindex].loadFromJSON(obehs[p]);
				}
			}
		}
		if (o["data"])
			inst.loadFromJSON(o["data"]);
	};
	cr.runtime = Runtime;
	cr.createRuntime = function (canvasid)
	{
		return new Runtime(document.getElementById(canvasid));
	};
	cr.createDCRuntime = function (w, h)
	{
		return new Runtime({ "dc": true, "width": w, "height": h });
	};
	window["cr_createRuntime"] = cr.createRuntime;
	window["cr_createDCRuntime"] = cr.createDCRuntime;
	window["createCocoonJSRuntime"] = function ()
	{
		window["c2cocoonjs"] = true;
		var canvas = document.createElement("screencanvas") || document.createElement("canvas");
		canvas.screencanvas = true;
		document.body.appendChild(canvas);
		var rt = new Runtime(canvas);
		window["c2runtime"] = rt;
		window.addEventListener("orientationchange", function () {
			window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		});
		window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		return rt;
	};
	window["createEjectaRuntime"] = function ()
	{
		var canvas = document.getElementById("canvas");
		var rt = new Runtime(canvas);
		window["c2runtime"] = rt;
		window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		return rt;
	};
}());
window["cr_getC2Runtime"] = function()
{
	var canvas = document.getElementById("c2canvas");
	if (canvas)
		return canvas["c2runtime"];
	else if (window["c2runtime"])
		return window["c2runtime"];
	else
		return null;
}
window["cr_sizeCanvas"] = function(w, h)
{
	if (w === 0 || h === 0)
		return;
	var runtime = window["cr_getC2Runtime"]();
	if (runtime)
		runtime["setSize"](w, h);
}
window["cr_setSuspended"] = function(s)
{
	var runtime = window["cr_getC2Runtime"]();
	if (runtime)
		runtime["setSuspended"](s);
}
;
(function()
{
	function Layout(runtime, m)
	{
		this.runtime = runtime;
		this.event_sheet = null;
		this.scrollX = (this.runtime.original_width / 2);
		this.scrollY = (this.runtime.original_height / 2);
		this.scale = 1.0;
		this.angle = 0;
		this.first_visit = true;
		this.name = m[0];
		this.width = m[1];
		this.height = m[2];
		this.unbounded_scrolling = m[3];
		this.sheetname = m[4];
		this.sid = m[5];
		var lm = m[6];
		var i, len;
		this.layers = [];
		this.initial_types = [];
		for (i = 0, len = lm.length; i < len; i++)
		{
			var layer = new cr.layer(this, lm[i]);
			layer.number = i;
			cr.seal(layer);
			this.layers.push(layer);
		}
		var im = m[7];
		this.initial_nonworld = [];
		for (i = 0, len = im.length; i < len; i++)
		{
			var inst = im[i];
			var type = this.runtime.types_by_index[inst[1]];
;
			if (!type.default_instance)
				type.default_instance = inst;
			this.initial_nonworld.push(inst);
			if (this.initial_types.indexOf(type) === -1)
				this.initial_types.push(type);
		}
		this.effect_types = [];
		this.active_effect_types = [];
		this.effect_params = [];
		for (i = 0, len = m[8].length; i < len; i++)
		{
			this.effect_types.push({
				id: m[8][i][0],
				name: m[8][i][1],
				shaderindex: -1,
				active: true,
				index: i
			});
			this.effect_params.push(m[8][i][2].slice(0));
		}
		this.updateActiveEffects();
		this.rcTex = new cr.rect(0, 0, 1, 1);
		this.rcTex2 = new cr.rect(0, 0, 1, 1);
		this.persist_data = {};
	};
	Layout.prototype.saveObjectToPersist = function (inst)
	{
		var sidStr = inst.type.sid.toString();
		if (!this.persist_data.hasOwnProperty(sidStr))
			this.persist_data[sidStr] = [];
		var type_persist = this.persist_data[sidStr];
		type_persist.push(this.runtime.saveInstanceToJSON(inst));
	};
	Layout.prototype.hasOpaqueBottomLayer = function ()
	{
		var layer = this.layers[0];
		return !layer.transparent && layer.opacity === 1.0 && !layer.forceOwnTexture && layer.visible;
	};
	Layout.prototype.updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.active)
				this.active_effect_types.push(et);
		}
	};
	Layout.prototype.getEffectByName = function (name_)
	{
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.name === name_)
				return et;
		}
		return null;
	};
	var created_instances = [];
	Layout.prototype.startRunning = function ()
	{
		if (this.sheetname)
		{
			this.event_sheet = this.runtime.eventsheets[this.sheetname];
;
			this.event_sheet.updateDeepIncludes();
		}
		this.runtime.running_layout = this;
		this.scrollX = (this.runtime.original_width / 2);
		this.scrollY = (this.runtime.original_height / 2);
		var i, k, len, lenk, type, type_instances, inst, iid, t, s, p, q, type_data, layer;
		for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
		{
			type = this.runtime.types_by_index[i];
			if (type.is_family)
				continue;		// instances are only transferred for their real type
			type_instances = type.instances;
			for (k = 0, lenk = type_instances.length; k < lenk; k++)
			{
				inst = type_instances[k];
				if (inst.layer)
				{
					var num = inst.layer.number;
					if (num >= this.layers.length)
						num = this.layers.length - 1;
					inst.layer = this.layers[num];
					inst.layer.instances.push(inst);
					inst.layer.zindices_stale = true;
				}
			}
		}
		var layer;
		created_instances.length = 0;
		this.boundScrolling();
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			layer = this.layers[i];
			layer.createInitialInstances();		// fills created_instances
			layer.disableAngle = true;
			var px = layer.canvasToLayer(0, 0, true, true);
			var py = layer.canvasToLayer(0, 0, false, true);
			layer.disableAngle = false;
			if (this.runtime.pixel_rounding)
			{
				px = (px + 0.5) | 0;
				py = (py + 0.5) | 0;
			}
			layer.rotateViewport(px, py, null);
		}
		var uids_changed = false;
		if (!this.first_visit)
		{
			for (p in this.persist_data)
			{
				if (this.persist_data.hasOwnProperty(p))
				{
					type = this.runtime.getObjectTypeBySid(parseInt(p, 10));
					if (!type || type.is_family || !this.runtime.typeHasPersistBehavior(type))
						continue;
					type_data = this.persist_data[p];
					for (i = 0, len = type_data.length; i < len; i++)
					{
						layer = null;
						if (type.plugin.is_world)
						{
							layer = this.getLayerBySid(type_data[i]["w"]["l"]);
							if (!layer)
								continue;
						}
						inst = this.runtime.createInstanceFromInit(type.default_instance, layer, false, 0, 0, true);
						this.runtime.loadInstanceFromJSON(inst, type_data[i]);
						uids_changed = true;
						created_instances.push(inst);
					}
					type_data.length = 0;
				}
			}
			for (i = 0, len = this.layers.length; i < len; i++)
			{
				this.layers[i].instances.sort(sortInstanceByZIndex);
				this.layers[i].zindices_stale = true;		// in case of duplicates/holes
			}
		}
		if (uids_changed)
		{
			this.runtime.ClearDeathRow();
			this.runtime.refreshUidMap();
		}
		for (i = 0; i < created_instances.length; i++)
		{
			inst = created_instances[i];
			if (!inst.type.is_contained)
				continue;
			iid = inst.get_iid();
			for (k = 0, lenk = inst.type.container.length; k < lenk; k++)
			{
				t = inst.type.container[k];
				if (inst.type === t)
					continue;
				if (t.instances.length > iid)
					inst.siblings.push(t.instances[iid]);
				else
				{
					if (!t.default_instance)
					{
					}
					else
					{
						s = this.runtime.createInstanceFromInit(t.default_instance, inst.layer, true, inst.x, inst.y, true);
						this.runtime.ClearDeathRow();
						t.updateIIDs();
						inst.siblings.push(s);
						created_instances.push(s);		// come back around and link up its own instances too
					}
				}
			}
		}
		for (i = 0, len = this.initial_nonworld.length; i < len; i++)
		{
			inst = this.runtime.createInstanceFromInit(this.initial_nonworld[i], null, true);
;
		}
		this.runtime.changelayout = null;
		this.runtime.ClearDeathRow();
		if (this.runtime.ctx && !this.runtime.isDomFree)
		{
			for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
			{
				t = this.runtime.types_by_index[i];
				if (t.is_family || !t.instances.length || !t.preloadCanvas2D)
					continue;
				t.preloadCanvas2D(this.runtime.ctx);
			}
		}
		/*
		if (this.runtime.glwrap)
		{
			console.log("Estimated VRAM at layout start: " + this.runtime.glwrap.textureCount() + " textures, approx. " + Math.round(this.runtime.glwrap.estimateVRAM() / 1024) + " kb");
		}
		*/
		for (i = 0, len = created_instances.length; i < len; i++)
		{
			inst = created_instances[i];
			this.runtime.trigger(Object.getPrototypeOf(inst.type.plugin).cnds.OnCreated, inst);
		}
		created_instances.length = 0;
		this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutStart, null);
		this.first_visit = false;
	};
	Layout.prototype.createGlobalNonWorlds = function ()
	{
		var i, k, len, initial_inst, inst, type;
		for (i = 0, k = 0, len = this.initial_nonworld.length; i < len; i++)
		{
			initial_inst = this.initial_nonworld[i];
			type = this.runtime.types_by_index[initial_inst[1]];
			if (type.global)
				inst = this.runtime.createInstanceFromInit(initial_inst, null, true);
			else
			{
				this.initial_nonworld[k] = initial_inst;
				k++;
			}
		}
		this.initial_nonworld.length = k;
	};
	Layout.prototype.stopRunning = function ()
	{
;
		/*
		if (this.runtime.glwrap)
		{
			console.log("Estimated VRAM at layout end: " + this.runtime.glwrap.textureCount() + " textures, approx. " + Math.round(this.runtime.glwrap.estimateVRAM() / 1024) + " kb");
		}
		*/
		this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutEnd, null);
		this.runtime.system.waits.length = 0;
		var i, leni, j, lenj;
		var layer_instances, inst, type;
		for (i = 0, leni = this.layers.length; i < leni; i++)
		{
			layer_instances = this.layers[i].instances;
			for (j = 0, lenj = layer_instances.length; j < lenj; j++)
			{
				inst = layer_instances[j];
				if (!inst.type.global)
				{
					if (this.runtime.typeHasPersistBehavior(inst.type))
						this.saveObjectToPersist(inst);
					this.runtime.DestroyInstance(inst);
				}
			}
			this.runtime.ClearDeathRow();
			layer_instances.length = 0;
			this.layers[i].zindices_stale = true;
		}
		for (i = 0, leni = this.runtime.types_by_index.length; i < leni; i++)
		{
			type = this.runtime.types_by_index[i];
			if (type.global || type.plugin.is_world || type.plugin.singleglobal || type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
				this.runtime.DestroyInstance(type.instances[j]);
			this.runtime.ClearDeathRow();
		}
	};
	Layout.prototype.draw = function (ctx)
	{
		var layout_canvas;
		var layout_ctx = ctx;
		var ctx_changed = false;
		var render_offscreen = !this.runtime.fullscreenScalingQuality;
		if (render_offscreen)
		{
			if (!this.runtime.layout_canvas)
			{
				this.runtime.layout_canvas = document.createElement("canvas");
				layout_canvas = this.runtime.layout_canvas;
				layout_canvas.width = this.runtime.draw_width;
				layout_canvas.height = this.runtime.draw_height;
				this.runtime.layout_ctx = layout_canvas.getContext("2d");
				ctx_changed = true;
			}
			layout_canvas = this.runtime.layout_canvas;
			layout_ctx = this.runtime.layout_ctx;
			if (layout_canvas.width !== this.runtime.draw_width)
			{
				layout_canvas.width = this.runtime.draw_width;
				ctx_changed = true;
			}
			if (layout_canvas.height !== this.runtime.draw_height)
			{
				layout_canvas.height = this.runtime.draw_height;
				ctx_changed = true;
			}
			if (ctx_changed)
			{
				layout_ctx["webkitImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["mozImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["msImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["imageSmoothingEnabled"] = this.runtime.linearSampling;
			}
		}
		layout_ctx.globalAlpha = 1;
		layout_ctx.globalCompositeOperation = "source-over";
		if (this.runtime.alphaBackground && !this.hasOpaqueBottomLayer())
			layout_ctx.clearRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		var i, len, l;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			l = this.layers[i];
			if (l.visible && l.opacity > 0 && l.blend_mode !== 11)
				l.draw(layout_ctx);
		}
		if (render_offscreen)
		{
			ctx.drawImage(layout_canvas, 0, 0, this.runtime.width, this.runtime.height);
		}
	};
	Layout.prototype.drawGL = function (glw)
	{
		var render_to_texture = (this.active_effect_types.length > 0 ||
								 this.runtime.uses_background_blending ||
								 !this.runtime.fullscreenScalingQuality);
		if (render_to_texture)
		{
			if (!this.runtime.layout_tex)
			{
				this.runtime.layout_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			if (this.runtime.layout_tex.c2width !== this.runtime.draw_width || this.runtime.layout_tex.c2height !== this.runtime.draw_height)
			{
				glw.deleteTexture(this.runtime.layout_tex);
				this.runtime.layout_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			glw.setRenderingToTexture(this.runtime.layout_tex);
			if (!this.runtime.fullscreenScalingQuality)
			{
				glw.setSize(this.runtime.draw_width, this.runtime.draw_height);
			}
		}
		else
		{
			if (this.runtime.layout_tex)
			{
				glw.setRenderingToTexture(null);
				glw.deleteTexture(this.runtime.layout_tex);
				this.runtime.layout_tex = null;
			}
		}
		if (this.runtime.alphaBackground && !this.hasOpaqueBottomLayer())
			glw.clear(0, 0, 0, 0);
		var i, len;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			if (this.layers[i].visible && this.layers[i].opacity > 0)
				this.layers[i].drawGL(glw);
		}
		if (render_to_texture)
		{
			if (this.active_effect_types.length === 0 ||
				(this.active_effect_types.length === 1 && this.runtime.fullscreenScalingQuality))
			{
				if (this.active_effect_types.length === 1)
				{
					var etindex = this.active_effect_types[0].index;
					glw.switchProgram(this.active_effect_types[0].shaderindex);
					glw.setProgramParameters(null,								// backTex
											 1.0 / this.runtime.draw_width,		// pixelWidth
											 1.0 / this.runtime.draw_height,	// pixelHeight
											 0.0, 0.0,							// destStart
											 1.0, 1.0,							// destEnd
											 this.scale,						// layerScale
											 this.angle,						// layerAngle
											 0.0, 0.0,							// viewOrigin
											 this.effect_params[etindex]);		// fx parameters
					if (glw.programIsAnimated(this.active_effect_types[0].shaderindex))
						this.runtime.redraw = true;
				}
				else
					glw.switchProgram(0);
				if (!this.runtime.fullscreenScalingQuality)
				{
					glw.setSize(this.runtime.width, this.runtime.height);
				}
				glw.setRenderingToTexture(null);				// to backbuffer
				glw.setOpacity(1);
				glw.setTexture(this.runtime.layout_tex);
				glw.setAlphaBlend();
				glw.resetModelView();
				glw.updateModelView();
				var halfw = this.runtime.width / 2;
				var halfh = this.runtime.height / 2;
				glw.quad(-halfw, halfh, halfw, halfh, halfw, -halfh, -halfw, -halfh);
				glw.setTexture(null);
			}
			else
			{
				this.renderEffectChain(glw, null, null, null);
			}
		}
	};
	Layout.prototype.getRenderTarget = function()
	{
		return (this.active_effect_types.length > 0 ||
				this.runtime.uses_background_blending ||
				!this.runtime.fullscreenScalingQuality) ? this.runtime.layout_tex : null;
	};
	Layout.prototype.getMinLayerScale = function ()
	{
		var m = this.layers[0].getScale();
		var i, len, l;
		for (i = 1, len = this.layers.length; i < len; i++)
		{
			l = this.layers[i];
			if (l.parallaxX === 0 && l.parallaxY === 0)
				continue;
			if (l.getScale() < m)
				m = l.getScale();
		}
		return m;
	};
	Layout.prototype.scrollToX = function (x)
	{
		if (!this.unbounded_scrolling)
		{
			var widthBoundary = (this.runtime.draw_width * (1 / this.getMinLayerScale()) / 2);
			if (x > this.width - widthBoundary)
				x = this.width - widthBoundary;
			if (x < widthBoundary)
				x = widthBoundary;
		}
		if (this.scrollX !== x)
		{
			this.scrollX = x;
			this.runtime.redraw = true;
		}
	};
	Layout.prototype.scrollToY = function (y)
	{
		if (!this.unbounded_scrolling)
		{
			var heightBoundary = (this.runtime.draw_height * (1 / this.getMinLayerScale()) / 2);
			if (y > this.height - heightBoundary)
				y = this.height - heightBoundary;
			if (y < heightBoundary)
				y = heightBoundary;
		}
		if (this.scrollY !== y)
		{
			this.scrollY = y;
			this.runtime.redraw = true;
		}
	};
	Layout.prototype.boundScrolling = function ()
	{
		this.scrollToX(this.scrollX);
		this.scrollToY(this.scrollY);
	};
	Layout.prototype.renderEffectChain = function (glw, layer, inst, rendertarget)
	{
		var active_effect_types = inst ?
							inst.active_effect_types :
							layer ?
								layer.active_effect_types :
								this.active_effect_types;
		var layerScale = 1, layerAngle = 0, viewOriginLeft = 0, viewOriginTop = 0;
		if (inst)
		{
			layerScale = inst.layer.getScale();
			layerAngle = inst.layer.getAngle();
			viewOriginLeft = inst.layer.viewLeft;
			viewOriginTop = inst.layer.viewTop;
		}
		else if (layer)
		{
			layerScale = layer.getScale();
			layerAngle = layer.getAngle();
			viewOriginLeft = layer.viewLeft;
			viewOriginTop = layer.viewTop;
		}
		var fx_tex = this.runtime.fx_tex;
		var i, len, last, temp, fx_index = 0, other_fx_index = 1;
		var y, h;
		var windowWidth = this.runtime.draw_width;
		var windowHeight = this.runtime.draw_height;
		var halfw = windowWidth / 2;
		var halfh = windowHeight / 2;
		var rcTex = layer ? layer.rcTex : this.rcTex;
		var rcTex2 = layer ? layer.rcTex2 : this.rcTex2;
		var screenleft = 0, clearleft = 0;
		var screentop = 0, cleartop = 0;
		var screenright = windowWidth, clearright = windowWidth;
		var screenbottom = windowHeight, clearbottom = windowHeight;
		var boxExtendHorizontal = 0;
		var boxExtendVertical = 0;
		var inst_layer_angle = inst ? inst.layer.getAngle() : 0;
		if (inst)
		{
			for (i = 0, len = active_effect_types.length; i < len; i++)
			{
				boxExtendHorizontal += glw.getProgramBoxExtendHorizontal(active_effect_types[i].shaderindex);
				boxExtendVertical += glw.getProgramBoxExtendVertical(active_effect_types[i].shaderindex);
			}
			var bbox = inst.bbox;
			screenleft = layer.layerToCanvas(bbox.left, bbox.top, true, true);
			screentop = layer.layerToCanvas(bbox.left, bbox.top, false, true);
			screenright = layer.layerToCanvas(bbox.right, bbox.bottom, true, true);
			screenbottom = layer.layerToCanvas(bbox.right, bbox.bottom, false, true);
			if (inst_layer_angle !== 0)
			{
				var screentrx = layer.layerToCanvas(bbox.right, bbox.top, true, true);
				var screentry = layer.layerToCanvas(bbox.right, bbox.top, false, true);
				var screenblx = layer.layerToCanvas(bbox.left, bbox.bottom, true, true);
				var screenbly = layer.layerToCanvas(bbox.left, bbox.bottom, false, true);
				temp = Math.min(screenleft, screenright, screentrx, screenblx);
				screenright = Math.max(screenleft, screenright, screentrx, screenblx);
				screenleft = temp;
				temp = Math.min(screentop, screenbottom, screentry, screenbly);
				screenbottom = Math.max(screentop, screenbottom, screentry, screenbly);
				screentop = temp;
			}
			screenleft -= boxExtendHorizontal;
			screentop -= boxExtendVertical;
			screenright += boxExtendHorizontal;
			screenbottom += boxExtendVertical;
			rcTex2.left = screenleft / windowWidth;
			rcTex2.top = 1 - screentop / windowHeight;
			rcTex2.right = screenright / windowWidth;
			rcTex2.bottom = 1 - screenbottom / windowHeight;
			clearleft = screenleft = cr.floor(screenleft);
			cleartop = screentop = cr.floor(screentop);
			clearright = screenright = cr.ceil(screenright);
			clearbottom = screenbottom = cr.ceil(screenbottom);
			clearleft -= boxExtendHorizontal;
			cleartop -= boxExtendVertical;
			clearright += boxExtendHorizontal;
			clearbottom += boxExtendVertical;
			if (screenleft < 0)					screenleft = 0;
			if (screentop < 0)					screentop = 0;
			if (screenright > windowWidth)		screenright = windowWidth;
			if (screenbottom > windowHeight)	screenbottom = windowHeight;
			if (clearleft < 0)					clearleft = 0;
			if (cleartop < 0)					cleartop = 0;
			if (clearright > windowWidth)		clearright = windowWidth;
			if (clearbottom > windowHeight)		clearbottom = windowHeight;
			rcTex.left = screenleft / windowWidth;
			rcTex.top = 1 - screentop / windowHeight;
			rcTex.right = screenright / windowWidth;
			rcTex.bottom = 1 - screenbottom / windowHeight;
		}
		else
		{
			rcTex.left = rcTex2.left = 0;
			rcTex.top = rcTex2.top = 0;
			rcTex.right = rcTex2.right = 1;
			rcTex.bottom = rcTex2.bottom = 1;
		}
		var pre_draw = (inst && (((inst.angle || inst_layer_angle) && glw.programUsesDest(active_effect_types[0].shaderindex)) || boxExtendHorizontal !== 0 || boxExtendVertical !== 0 || inst.opacity !== 1 || inst.type.plugin.must_predraw)) || (layer && !inst && layer.opacity !== 1);
		glw.setAlphaBlend();
		if (pre_draw)
		{
			if (!fx_tex[fx_index])
			{
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			if (fx_tex[fx_index].c2width !== windowWidth || fx_tex[fx_index].c2height !== windowHeight)
			{
				glw.deleteTexture(fx_tex[fx_index]);
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			glw.switchProgram(0);
			glw.setRenderingToTexture(fx_tex[fx_index]);
			h = clearbottom - cleartop;
			y = (windowHeight - cleartop) - h;
			glw.clearRect(clearleft, y, clearright - clearleft, h);
			if (inst)
			{
				inst.drawGL(glw);
			}
			else
			{
				glw.setTexture(this.runtime.layer_tex);
				glw.setOpacity(layer.opacity);
				glw.resetModelView();
				glw.translate(-halfw, -halfh);
				glw.updateModelView();
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
			}
			rcTex2.left = rcTex2.top = 0;
			rcTex2.right = rcTex2.bottom = 1;
			if (inst)
			{
				temp = rcTex.top;
				rcTex.top = rcTex.bottom;
				rcTex.bottom = temp;
			}
			fx_index = 1;
			other_fx_index = 0;
		}
		glw.setOpacity(1);
		var last = active_effect_types.length - 1;
		var post_draw = glw.programUsesCrossSampling(active_effect_types[last].shaderindex) ||
						(!layer && !inst && !this.runtime.fullscreenScalingQuality);
		var etindex = 0;
		for (i = 0, len = active_effect_types.length; i < len; i++)
		{
			if (!fx_tex[fx_index])
			{
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			if (fx_tex[fx_index].c2width !== windowWidth || fx_tex[fx_index].c2height !== windowHeight)
			{
				glw.deleteTexture(fx_tex[fx_index]);
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			glw.switchProgram(active_effect_types[i].shaderindex);
			etindex = active_effect_types[i].index;
			if (glw.programIsAnimated(active_effect_types[i].shaderindex))
				this.runtime.redraw = true;
			if (i == 0 && !pre_draw)
			{
				glw.setRenderingToTexture(fx_tex[fx_index]);
				h = clearbottom - cleartop;
				y = (windowHeight - cleartop) - h;
				glw.clearRect(clearleft, y, clearright - clearleft, h);
				if (inst)
				{
					glw.setProgramParameters(rendertarget,					// backTex
											 1.0 / inst.width,				// pixelWidth
											 1.0 / inst.height,				// pixelHeight
											 rcTex2.left, rcTex2.top,		// destStart
											 rcTex2.right, rcTex2.bottom,	// destEnd
											 layerScale,
											 layerAngle,
											 viewOriginLeft, viewOriginTop,
											 inst.effect_params[etindex]);	// fx params
					inst.drawGL(glw);
				}
				else
				{
					glw.setProgramParameters(rendertarget,					// backTex
											 1.0 / windowWidth,				// pixelWidth
											 1.0 / windowHeight,			// pixelHeight
											 0.0, 0.0,						// destStart
											 1.0, 1.0,						// destEnd
											 layerScale,
											 layerAngle,
											 viewOriginLeft, viewOriginTop,
											 layer ?						// fx params
												layer.effect_params[etindex] :
												this.effect_params[etindex]);
					glw.setTexture(layer ? this.runtime.layer_tex : this.runtime.layout_tex);
					glw.resetModelView();
					glw.translate(-halfw, -halfh);
					glw.updateModelView();
					glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
				}
				rcTex2.left = rcTex2.top = 0;
				rcTex2.right = rcTex2.bottom = 1;
				if (inst && !post_draw)
				{
					temp = screenbottom;
					screenbottom = screentop;
					screentop = temp;
				}
			}
			else
			{
				glw.setProgramParameters(rendertarget,						// backTex
										 1.0 / windowWidth,					// pixelWidth
										 1.0 / windowHeight,				// pixelHeight
										 rcTex2.left, rcTex2.top,			// destStart
										 rcTex2.right, rcTex2.bottom,		// destEnd
										 layerScale,
										 layerAngle,
										 viewOriginLeft, viewOriginTop,
										 inst ?								// fx params
											inst.effect_params[etindex] :
											layer ?
												layer.effect_params[etindex] :
												this.effect_params[etindex]);
				glw.setTexture(null);
				if (i === last && !post_draw)
				{
					if (inst)
						glw.setBlend(inst.srcBlend, inst.destBlend);
					else if (layer)
						glw.setBlend(layer.srcBlend, layer.destBlend);
					glw.setRenderingToTexture(rendertarget);
				}
				else
				{
					glw.setRenderingToTexture(fx_tex[fx_index]);
					h = clearbottom - cleartop;
					y = (windowHeight - cleartop) - h;
					glw.clearRect(clearleft, y, clearright - clearleft, h);
				}
				glw.setTexture(fx_tex[other_fx_index]);
				glw.resetModelView();
				glw.translate(-halfw, -halfh);
				glw.updateModelView();
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
				if (i === last && !post_draw)
					glw.setTexture(null);
			}
			fx_index = (fx_index === 0 ? 1 : 0);
			other_fx_index = (fx_index === 0 ? 1 : 0);		// will be opposite to fx_index since it was just assigned
		}
		if (post_draw)
		{
			glw.switchProgram(0);
			if (inst)
				glw.setBlend(inst.srcBlend, inst.destBlend);
			else if (layer)
				glw.setBlend(layer.srcBlend, layer.destBlend);
			else
			{
				if (!this.runtime.fullscreenScalingQuality)
				{
					glw.setSize(this.runtime.width, this.runtime.height);
					halfw = this.runtime.width / 2;
					halfh = this.runtime.height / 2;
					screenleft = 0;
					screentop = 0;
					screenright = this.runtime.width;
					screenbottom = this.runtime.height;
				}
			}
			glw.setRenderingToTexture(rendertarget);
			glw.setTexture(fx_tex[other_fx_index]);
			glw.resetModelView();
			glw.translate(-halfw, -halfh);
			glw.updateModelView();
			if (inst && active_effect_types.length === 1 && !pre_draw)
				glw.quadTex(screenleft, screentop, screenright, screentop, screenright, screenbottom, screenleft, screenbottom, rcTex);
			else
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
			glw.setTexture(null);
		}
	};
	Layout.prototype.getLayerBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			if (this.layers[i].sid === sid_)
				return this.layers[i];
		}
		return null;
	};
	Layout.prototype.saveToJSON = function ()
	{
		var i, len, layer, et;
		var o = {
			"sx": this.scrollX,
			"sy": this.scrollY,
			"s": this.scale,
			"a": this.angle,
			"w": this.width,
			"h": this.height,
			"fv": this.first_visit,			// added r127
			"persist": this.persist_data,
			"fx": [],
			"layers": {}
		};
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			o["fx"].push({"name": et.name, "active": et.active, "params": this.effect_params[et.index] });
		}
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			layer = this.layers[i];
			o["layers"][layer.sid.toString()] = layer.saveToJSON();
		}
		return o;
	};
	Layout.prototype.loadFromJSON = function (o)
	{
		var i, len, fx, p, layer;
		this.scrollX = o["sx"];
		this.scrollY = o["sy"];
		this.scale = o["s"];
		this.angle = o["a"];
		this.width = o["w"];
		this.height = o["h"];
		this.persist_data = o["persist"];
		if (typeof o["fv"] !== "undefined")
			this.first_visit = o["fv"];
		var ofx = o["fx"];
		for (i = 0, len = ofx.length; i < len; i++)
		{
			fx = this.getEffectByName(ofx[i]["name"]);
			if (!fx)
				continue;		// must've gone missing
			fx.active = ofx[i]["active"];
			this.effect_params[fx.index] = ofx[i]["params"];
		}
		this.updateActiveEffects();
		var olayers = o["layers"];
		for (p in olayers)
		{
			if (olayers.hasOwnProperty(p))
			{
				layer = this.getLayerBySid(parseInt(p, 10));
				if (!layer)
					continue;		// must've gone missing
				layer.loadFromJSON(olayers[p]);
			}
		}
	};
	cr.layout = Layout;
	function Layer(layout, m)
	{
		this.layout = layout;
		this.runtime = layout.runtime;
		this.instances = [];        // running instances
		this.scale = 1.0;
		this.angle = 0;
		this.disableAngle = false;
		this.tmprect = new cr.rect(0, 0, 0, 0);
		this.tmpquad = new cr.quad();
		this.viewLeft = 0;
		this.viewRight = 0;
		this.viewTop = 0;
		this.viewBottom = 0;
		this.zindices_stale = false;
		this.name = m[0];
		this.index = m[1];
		this.sid = m[2];
		this.visible = m[3];		// initially visible
		this.background_color = m[4];
		this.transparent = m[5];
		this.parallaxX = m[6];
		this.parallaxY = m[7];
		this.opacity = m[8];
		this.forceOwnTexture = m[9];
		this.zoomRate = m[10];
		this.blend_mode = m[11];
		this.effect_fallback = m[12];
		this.compositeOp = "source-over";
		this.srcBlend = 0;
		this.destBlend = 0;
		this.render_offscreen = false;
		var im = m[13];
		var i, len;
		this.initial_instances = [];
		for (i = 0, len = im.length; i < len; i++)
		{
			var inst = im[i];
			var type = this.runtime.types_by_index[inst[1]];
;
			if (!type.default_instance)
			{
				type.default_instance = inst;
				type.default_layerindex = this.index;
			}
			this.initial_instances.push(inst);
			if (this.layout.initial_types.indexOf(type) === -1)
				this.layout.initial_types.push(type);
		}
		this.effect_types = [];
		this.active_effect_types = [];
		this.effect_params = [];
		for (i = 0, len = m[14].length; i < len; i++)
		{
			this.effect_types.push({
				id: m[14][i][0],
				name: m[14][i][1],
				shaderindex: -1,
				active: true,
				index: i
			});
			this.effect_params.push(m[14][i][2].slice(0));
		}
		this.updateActiveEffects();
		this.rcTex = new cr.rect(0, 0, 1, 1);
		this.rcTex2 = new cr.rect(0, 0, 1, 1);
	};
	Layer.prototype.updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.active)
				this.active_effect_types.push(et);
		}
	};
	Layer.prototype.getEffectByName = function (name_)
	{
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.name === name_)
				return et;
		}
		return null;
	};
	Layer.prototype.createInitialInstances = function ()
	{
		var i, k, len, inst, initial_inst, type, keep, hasPersistBehavior;
		for (i = 0, k = 0, len = this.initial_instances.length; i < len; i++)
		{
			initial_inst = this.initial_instances[i];
			type = this.runtime.types_by_index[initial_inst[1]];
;
			hasPersistBehavior = this.runtime.typeHasPersistBehavior(type);
			keep = true;
			if (!hasPersistBehavior || this.layout.first_visit)
			{
				inst = this.runtime.createInstanceFromInit(initial_inst, this, true);
;
				created_instances.push(inst);
				if (inst.type.global)
					keep = false;
			}
			if (keep)
			{
				this.initial_instances[k] = this.initial_instances[i];
				k++;
			}
		}
		this.initial_instances.length = k;
		this.runtime.ClearDeathRow();		// flushes creation row so IIDs will be correct
		if (!this.runtime.glwrap && this.effect_types.length)	// no WebGL renderer and shaders used
			this.blend_mode = this.effect_fallback;				// use fallback blend mode
		this.compositeOp = cr.effectToCompositeOp(this.blend_mode);
		if (this.runtime.gl)
			cr.setGLBlend(this, this.blend_mode, this.runtime.gl);
	};
	Layer.prototype.updateZIndices = function ()
	{
		if (!this.zindices_stale)
			return;
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
;
;
			this.instances[i].zindex = i;
		}
		this.zindices_stale = false;
	};
	Layer.prototype.getScale = function (include_aspect)
	{
		return this.getNormalScale() * (this.runtime.fullscreenScalingQuality || include_aspect ? this.runtime.aspect_scale : 1);
	};
	Layer.prototype.getNormalScale = function ()
	{
		return ((this.scale * this.layout.scale) - 1) * this.zoomRate + 1;
	};
	Layer.prototype.getAngle = function ()
	{
		if (this.disableAngle)
			return 0;
		return cr.clamp_angle(this.layout.angle + this.angle);
	};
	Layer.prototype.draw = function (ctx)
	{
		this.render_offscreen = (this.forceOwnTexture || this.opacity !== 1.0 || this.blend_mode !== 0);
		var layer_canvas = this.runtime.canvas;
		var layer_ctx = ctx;
		var ctx_changed = false;
		if (this.render_offscreen)
		{
			if (!this.runtime.layer_canvas)
			{
				this.runtime.layer_canvas = document.createElement("canvas");
;
				layer_canvas = this.runtime.layer_canvas;
				layer_canvas.width = this.runtime.draw_width;
				layer_canvas.height = this.runtime.draw_height;
				this.runtime.layer_ctx = layer_canvas.getContext("2d");
;
				ctx_changed = true;
			}
			layer_canvas = this.runtime.layer_canvas;
			layer_ctx = this.runtime.layer_ctx;
			if (layer_canvas.width !== this.runtime.draw_width)
			{
				layer_canvas.width = this.runtime.draw_width;
				ctx_changed = true;
			}
			if (layer_canvas.height !== this.runtime.draw_height)
			{
				layer_canvas.height = this.runtime.draw_height;
				ctx_changed = true;
			}
			if (ctx_changed)
			{
				layer_ctx["webkitImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["mozImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["msImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["imageSmoothingEnabled"] = this.runtime.linearSampling;
			}
			if (this.transparent)
				layer_ctx.clearRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		}
		layer_ctx.globalAlpha = 1;
		layer_ctx.globalCompositeOperation = "source-over";
		if (!this.transparent)
		{
			layer_ctx.fillStyle = "rgb(" + this.background_color[0] + "," + this.background_color[1] + "," + this.background_color[2] + ")";
			layer_ctx.fillRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		}
		layer_ctx.save();
		this.disableAngle = true;
		var px = this.canvasToLayer(0, 0, true, true);
		var py = this.canvasToLayer(0, 0, false, true);
		this.disableAngle = false;
		if (this.runtime.pixel_rounding)
		{
			px = (px + 0.5) | 0;
			py = (py + 0.5) | 0;
		}
		this.rotateViewport(px, py, layer_ctx);
		var myscale = this.getScale();
		layer_ctx.scale(myscale, myscale);
		layer_ctx.translate(-px, -py);
		var i, len, inst, bbox;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			if (!inst.visible || inst.width === 0 || inst.height === 0)
				continue;
			inst.update_bbox();
			bbox = inst.bbox;
			if (bbox.right < this.viewLeft || bbox.bottom < this.viewTop || bbox.left > this.viewRight || bbox.top > this.viewBottom)
				continue;
			layer_ctx.globalCompositeOperation = inst.compositeOp;
			inst.draw(layer_ctx);
		}
		layer_ctx.restore();
		if (this.render_offscreen)
		{
			ctx.globalCompositeOperation = this.compositeOp;
			ctx.globalAlpha = this.opacity;
			ctx.drawImage(layer_canvas, 0, 0);
		}
	};
	Layer.prototype.rotateViewport = function (px, py, ctx)
	{
		var myscale = this.getScale();
		this.viewLeft = px;
		this.viewTop = py;
		this.viewRight = px + (this.runtime.draw_width * (1 / myscale));
		this.viewBottom = py + (this.runtime.draw_height * (1 / myscale));
		var myAngle = this.getAngle();
		if (myAngle !== 0)
		{
			if (ctx)
			{
				ctx.translate(this.runtime.draw_width / 2, this.runtime.draw_height / 2);
				ctx.rotate(-myAngle);
				ctx.translate(this.runtime.draw_width / -2, this.runtime.draw_height / -2);
			}
			this.tmprect.set(this.viewLeft, this.viewTop, this.viewRight, this.viewBottom);
			this.tmprect.offset((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
			this.tmpquad.set_from_rotated_rect(this.tmprect, myAngle);
			this.tmpquad.bounding_box(this.tmprect);
			this.tmprect.offset((this.viewLeft + this.viewRight) / 2, (this.viewTop + this.viewBottom) / 2);
			this.viewLeft = this.tmprect.left;
			this.viewTop = this.tmprect.top;
			this.viewRight = this.tmprect.right;
			this.viewBottom = this.tmprect.bottom;
		}
	}
	Layer.prototype.drawGL = function (glw)
	{
		var windowWidth = this.runtime.draw_width;
		var windowHeight = this.runtime.draw_height;
		var shaderindex = 0;
		var etindex = 0;
		this.render_offscreen = (this.forceOwnTexture || this.opacity !== 1.0 || this.active_effect_types.length > 0 || this.blend_mode !== 0);
		if (this.render_offscreen)
		{
			if (!this.runtime.layer_tex)
			{
				this.runtime.layer_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			if (this.runtime.layer_tex.c2width !== this.runtime.draw_width || this.runtime.layer_tex.c2height !== this.runtime.draw_height)
			{
				glw.deleteTexture(this.runtime.layer_tex);
				this.runtime.layer_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			glw.setRenderingToTexture(this.runtime.layer_tex);
			if (this.transparent)
				glw.clear(0, 0, 0, 0);
		}
		if (!this.transparent)
		{
			glw.clear(this.background_color[0] / 255, this.background_color[1] / 255, this.background_color[2] / 255, 1);
		}
		this.disableAngle = true;
		var px = this.canvasToLayer(0, 0, true, true);
		var py = this.canvasToLayer(0, 0, false, true);
		this.disableAngle = false;
		if (this.runtime.pixel_rounding)
		{
			px = (px + 0.5) | 0;
			py = (py + 0.5) | 0;
		}
		this.rotateViewport(px, py, null);
		var myscale = this.getScale();
		glw.resetModelView();
		glw.scale(myscale, myscale);
		glw.rotateZ(-this.getAngle());
		glw.translate((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
		glw.updateModelView();
		var i, len, inst, bbox;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			if (!inst.visible || inst.width === 0 || inst.height === 0)
				continue;
			inst.update_bbox();
			bbox = inst.bbox;
			if (bbox.right < this.viewLeft || bbox.bottom < this.viewTop || bbox.left > this.viewRight || bbox.top > this.viewBottom)
				continue;
			if (inst.uses_shaders)
			{
				shaderindex = inst.active_effect_types[0].shaderindex;
				etindex = inst.active_effect_types[0].index;
				if (inst.active_effect_types.length === 1 && !glw.programUsesCrossSampling(shaderindex) &&
					!glw.programExtendsBox(shaderindex) && ((!inst.angle && !inst.layer.getAngle()) || !glw.programUsesDest(shaderindex)) &&
					inst.opacity === 1 && !inst.type.plugin.must_predraw)
				{
					glw.switchProgram(shaderindex);
					glw.setBlend(inst.srcBlend, inst.destBlend);
					if (glw.programIsAnimated(shaderindex))
						this.runtime.redraw = true;
					var destStartX = 0, destStartY = 0, destEndX = 0, destEndY = 0;
					if (glw.programUsesDest(shaderindex))
					{
						var bbox = inst.bbox;
						var screenleft = this.layerToCanvas(bbox.left, bbox.top, true, true);
						var screentop = this.layerToCanvas(bbox.left, bbox.top, false, true);
						var screenright = this.layerToCanvas(bbox.right, bbox.bottom, true, true);
						var screenbottom = this.layerToCanvas(bbox.right, bbox.bottom, false, true);
						destStartX = screenleft / windowWidth;
						destStartY = 1 - screentop / windowHeight;
						destEndX = screenright / windowWidth;
						destEndY = 1 - screenbottom / windowHeight;
					}
					glw.setProgramParameters(this.render_offscreen ? this.runtime.layer_tex : this.layout.getRenderTarget(), // backTex
											 1.0 / inst.width,			// pixelWidth
											 1.0 / inst.height,			// pixelHeight
											 destStartX, destStartY,
											 destEndX, destEndY,
											 this.getScale(),
											 this.getAngle(),
											 this.viewLeft, this.viewTop,
											 inst.effect_params[etindex]);
					inst.drawGL(glw);
				}
				else
				{
					this.layout.renderEffectChain(glw, this, inst, this.render_offscreen ? this.runtime.layer_tex : this.layout.getRenderTarget());
					glw.resetModelView();
					glw.scale(myscale, myscale);
					glw.rotateZ(-this.getAngle());
					glw.translate((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
					glw.updateModelView();
				}
			}
			else
			{
				glw.switchProgram(0);		// un-set any previously set shader
				glw.setBlend(inst.srcBlend, inst.destBlend);
				inst.drawGL(glw);
			}
		}
		if (this.render_offscreen)
		{
			shaderindex = this.active_effect_types.length ? this.active_effect_types[0].shaderindex : 0;
			etindex = this.active_effect_types.length ? this.active_effect_types[0].index : 0;
			if (this.active_effect_types.length === 0 || (this.active_effect_types.length === 1 &&
				!glw.programUsesCrossSampling(shaderindex) && this.opacity === 1))
			{
				if (this.active_effect_types.length === 1)
				{
					glw.switchProgram(shaderindex);
					glw.setProgramParameters(this.layout.getRenderTarget(),		// backTex
											 1.0 / this.runtime.draw_width,		// pixelWidth
											 1.0 / this.runtime.draw_height,	// pixelHeight
											 0.0, 0.0,							// destStart
											 1.0, 1.0,							// destEnd
											 this.getScale(),					// layerScale
											 this.getAngle(),
											 this.viewLeft, this.viewTop,
											 this.effect_params[etindex]);		// fx parameters
					if (glw.programIsAnimated(shaderindex))
						this.runtime.redraw = true;
				}
				else
					glw.switchProgram(0);
				glw.setRenderingToTexture(this.layout.getRenderTarget());
				glw.setOpacity(this.opacity);
				glw.setTexture(this.runtime.layer_tex);
				glw.setBlend(this.srcBlend, this.destBlend);
				glw.resetModelView();
				glw.updateModelView();
				var halfw = this.runtime.draw_width / 2;
				var halfh = this.runtime.draw_height / 2;
				glw.quad(-halfw, halfh, halfw, halfh, halfw, -halfh, -halfw, -halfh);
				glw.setTexture(null);
			}
			else
			{
				this.layout.renderEffectChain(glw, this, null, this.layout.getRenderTarget());
			}
		}
	};
	Layer.prototype.canvasToLayer = function (ptx, pty, getx, using_draw_area)
	{
		var multiplier = this.runtime.devicePixelRatio;
		if (this.runtime.isRetina)
		{
			ptx *= multiplier;
			pty *= multiplier;
		}
		var ox = this.runtime.parallax_x_origin;
		var oy = this.runtime.parallax_y_origin;
		var x = ((this.layout.scrollX - ox) * this.parallaxX) + ox;
		var y = ((this.layout.scrollY - oy) * this.parallaxY) + oy;
		var invScale = 1 / this.getScale(!using_draw_area);
		if (using_draw_area)
		{
			x -= (this.runtime.draw_width * invScale) / 2;
			y -= (this.runtime.draw_height * invScale) / 2;
		}
		else
		{
			x -= (this.runtime.width * invScale) / 2;
			y -= (this.runtime.height * invScale) / 2;
		}
		x += ptx * invScale;
		y += pty * invScale;
		var a = this.getAngle();
		if (a !== 0)
		{
			x -= this.layout.scrollX;
			y -= this.layout.scrollY;
			var cosa = Math.cos(a);
			var sina = Math.sin(a);
			var x_temp = (x * cosa) - (y * sina);
			y = (y * cosa) + (x * sina);
			x = x_temp;
			x += this.layout.scrollX;
			y += this.layout.scrollY;
		}
		return getx ? x : y;
	};
	Layer.prototype.layerToCanvas = function (ptx, pty, getx, using_draw_area)
	{
		var a = this.getAngle();
		if (a !== 0)
		{
			ptx -= this.layout.scrollX;
			pty -= this.layout.scrollY;
			var cosa = Math.cos(-a);
			var sina = Math.sin(-a);
			var x_temp = (ptx * cosa) - (pty * sina);
			pty = (pty * cosa) + (ptx * sina);
			ptx = x_temp;
			ptx += this.layout.scrollX;
			pty += this.layout.scrollY;
		}
		var ox = this.runtime.parallax_x_origin;
		var oy = this.runtime.parallax_y_origin;
		var x = ((this.layout.scrollX - ox) * this.parallaxX) + ox;
		var y = ((this.layout.scrollY - oy) * this.parallaxY) + oy;
		var invScale = 1 / this.getScale(!using_draw_area);
		if (using_draw_area)
		{
			x -= (this.runtime.draw_width * invScale) / 2;
			y -= (this.runtime.draw_height * invScale) / 2;
		}
		else
		{
			x -= (this.runtime.width * invScale) / 2;
			y -= (this.runtime.height * invScale) / 2;
		}
		x = (ptx - x) / invScale;
		y = (pty - y) / invScale;
		var multiplier = this.runtime.devicePixelRatio;
		if (this.runtime.isRetina)
		{
			x /= multiplier;
			y /= multiplier;
		}
		return getx ? x : y;
	};
	Layer.prototype.rotatePt = function (x_, y_, getx)
	{
		if (this.getAngle() === 0)
			return getx ? x_ : y_;
		var nx = this.layerToCanvas(x_, y_, true);
		var ny = this.layerToCanvas(x_, y_, false);
		this.disableAngle = true;
		var px = this.canvasToLayer(nx, ny, true);
		var py = this.canvasToLayer(nx, ny, true);
		this.disableAngle = false;
		return getx ? px : py;
	};
	Layer.prototype.saveToJSON = function ()
	{
		var i, len, et;
		var o = {
			"s": this.scale,
			"a": this.angle,
			"vl": this.viewLeft,
			"vt": this.viewTop,
			"vr": this.viewRight,
			"vb": this.viewBottom,
			"v": this.visible,
			"bc": this.background_color,
			"t": this.transparent,
			"px": this.parallaxX,
			"py": this.parallaxY,
			"o": this.opacity,
			"zr": this.zoomRate,
			"fx": [],
			"instances": []
		};
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			o["fx"].push({"name": et.name, "active": et.active, "params": this.effect_params[et.index] });
		}
		return o;
	};
	function sortInstanceByZIndex(a, b)
	{
		return a.zindex - b.zindex;
	};
	Layer.prototype.loadFromJSON = function (o)
	{
		var i, len, p, inst, fx;
		this.scale = o["s"];
		this.angle = o["a"];
		this.viewLeft = o["vl"];
		this.viewTop = o["vt"];
		this.viewRight = o["vr"];
		this.viewBottom = o["vb"];
		this.visible = o["v"];
		this.background_color = o["bc"];
		this.transparent = o["t"];
		this.parallaxX = o["px"];
		this.parallaxY = o["py"];
		this.opacity = o["o"];
		this.zoomRate = o["zr"];
		var ofx = o["fx"];
		for (i = 0, len = ofx.length; i < len; i++)
		{
			fx = this.getEffectByName(ofx[i]["name"]);
			if (!fx)
				continue;		// must've gone missing
			fx.active = ofx[i]["active"];
			this.effect_params[fx.index] = ofx[i]["params"];
		}
		this.updateActiveEffects();
		this.instances.sort(sortInstanceByZIndex);
		this.zindices_stale = true;
	};
	cr.layer = Layer;
}());
;
(function()
{
	var allUniqueSolModifiers = [];
	function testSolsMatch(arr1, arr2)
	{
		var i, len = arr1.length;
		switch (len) {
		case 0:
			return true;
		case 1:
			return arr1[0] === arr2[0];
		case 2:
			return arr1[0] === arr2[0] && arr1[1] === arr2[1];
		default:
			for (i = 0; i < len; i++)
			{
				if (arr1[i] !== arr2[i])
					return false;
			}
			return true;
		}
	};
	function solArraySorter(t1, t2)
	{
		return t1.index - t2.index;
	};
	function findMatchingSolModifier(arr)
	{
		var i, len, u, temp, subarr;
		if (arr.length === 2)
		{
			if (arr[0].index > arr[1].index)
			{
				temp = arr[0];
				arr[0] = arr[1];
				arr[1] = temp;
			}
		}
		else if (arr.length > 2)
			arr.sort(solArraySorter);		// so testSolsMatch compares in same order
		if (arr.length >= allUniqueSolModifiers.length)
			allUniqueSolModifiers.length = arr.length + 1;
		if (!allUniqueSolModifiers[arr.length])
			allUniqueSolModifiers[arr.length] = [];
		subarr = allUniqueSolModifiers[arr.length];
		for (i = 0, len = subarr.length; i < len; i++)
		{
			u = subarr[i];
			if (testSolsMatch(arr, u))
				return u;
		}
		subarr.push(arr);
		return arr;
	};
	function EventSheet(runtime, m)
	{
		this.runtime = runtime;
		this.triggers = {};
		this.fasttriggers = {};
        this.hasRun = false;
        this.includes = new cr.ObjectSet(); 	// all event sheets included by this sheet, at first-level indirection only
		this.deep_includes = [];				// all includes from this sheet recursively, in trigger order
		this.already_included_sheets = [];		// used while building deep_includes
		this.name = m[0];
		var em = m[1];		// events model
		this.events = [];       // triggers won't make it to this array
		var i, len;
		for (i = 0, len = em.length; i < len; i++)
			this.init_event(em[i], null, this.events);
	};
    EventSheet.prototype.toString = function ()
    {
        return this.name;
    };
	EventSheet.prototype.init_event = function (m, parent, nontriggers)
	{
		switch (m[0]) {
		case 0:	// event block
		{
			var block = new cr.eventblock(this, parent, m);
			cr.seal(block);
			if (block.orblock)
			{
				nontriggers.push(block);
				var i, len;
				for (i = 0, len = block.conditions.length; i < len; i++)
				{
					if (block.conditions[i].trigger)
						this.init_trigger(block, i);
				}
			}
			else
			{
				if (block.is_trigger())
					this.init_trigger(block, 0);
				else
					nontriggers.push(block);
			}
			break;
		}
		case 1: // variable
		{
			var v = new cr.eventvariable(this, parent, m);
			cr.seal(v);
			nontriggers.push(v);
			break;
		}
        case 2:	// include
        {
            var inc = new cr.eventinclude(this, parent, m);
			cr.seal(inc);
            nontriggers.push(inc);
			break;
        }
		default:
;
		}
	};
	EventSheet.prototype.postInit = function ()
	{
		var i, len;
		for (i = 0, len = this.events.length; i < len; i++)
		{
			this.events[i].postInit(i < len - 1 && this.events[i + 1].is_else_block);
		}
	};
	EventSheet.prototype.updateDeepIncludes = function ()
	{
		this.deep_includes.length = 0;
		this.already_included_sheets.length = 0;
		this.addDeepIncludes(this);
		this.already_included_sheets.length = 0;
	};
	EventSheet.prototype.addDeepIncludes = function (root_sheet)
	{
		var i, len, inc, sheet;
		var deep_includes = root_sheet.deep_includes;
		var already_included_sheets = root_sheet.already_included_sheets;
		var arr = this.includes.valuesRef();
		for (i = 0, len = arr.length; i < len; ++i)
		{
			inc = arr[i];
			sheet = inc.include_sheet;
			if (!inc.isActive() || root_sheet === sheet || already_included_sheets.indexOf(sheet) > -1)
				continue;
			already_included_sheets.push(sheet);
			sheet.addDeepIncludes(root_sheet);
			deep_includes.push(sheet);
		}
	};
	EventSheet.prototype.run = function (from_include)
	{
		if (!this.runtime.resuming_breakpoint)
		{
			this.hasRun = true;
			if (!from_include)
				this.runtime.isRunningEvents = true;
		}
		var i, len;
		for (i = 0, len = this.events.length; i < len; i++)
		{
			var ev = this.events[i];
			ev.run();
				this.runtime.clearSol(ev.solModifiers);
				if (!this.runtime.deathRow.isEmpty() || this.runtime.createRow.length)
					this.runtime.ClearDeathRow();
		}
			if (!from_include)
				this.runtime.isRunningEvents = false;
	};
	function isPerformanceSensitiveTrigger(method)
	{
		if (cr.plugins_.Sprite && method === cr.plugins_.Sprite.prototype.cnds.OnFrameChanged)
		{
			return true;
		}
		return false;
	};
	EventSheet.prototype.init_trigger = function (trig, index)
	{
		if (!trig.orblock)
			this.runtime.triggers_to_postinit.push(trig);	// needs to be postInit'd later
		var i, len;
		var cnd = trig.conditions[index];
		var type_name;
		if (cnd.type)
			type_name = cnd.type.name;
		else
			type_name = "system";
		var fasttrigger = cnd.fasttrigger;
		var triggers = (fasttrigger ? this.fasttriggers : this.triggers);
		if (!triggers[type_name])
			triggers[type_name] = [];
		var obj_entry = triggers[type_name];
		var method = cnd.func;
		if (fasttrigger)
		{
			if (!cnd.parameters.length)				// no parameters
				return;
			var firstparam = cnd.parameters[0];
			if (firstparam.type !== 1 ||			// not a string param
				firstparam.expression.type !== 2)	// not a string literal node
			{
				return;
			}
			var fastevs;
			var firstvalue = firstparam.expression.value.toLowerCase();
			var i, len;
			for (i = 0, len = obj_entry.length; i < len; i++)
			{
				if (obj_entry[i].method == method)
				{
					fastevs = obj_entry[i].evs;
					if (!fastevs[firstvalue])
						fastevs[firstvalue] = [[trig, index]];
					else
						fastevs[firstvalue].push([trig, index]);
					return;
				}
			}
			fastevs = {};
			fastevs[firstvalue] = [[trig, index]];
			obj_entry.push({ method: method, evs: fastevs });
		}
		else
		{
			for (i = 0, len = obj_entry.length; i < len; i++)
			{
				if (obj_entry[i].method == method)
				{
					obj_entry[i].evs.push([trig, index]);
					return;
				}
			}
			if (isPerformanceSensitiveTrigger(method))
				obj_entry.unshift({ method: method, evs: [[trig, index]]});
			else
				obj_entry.push({ method: method, evs: [[trig, index]]});
		}
	};
	cr.eventsheet = EventSheet;
	function Selection(type)
	{
		this.type = type;
		this.instances = [];        // subset of picked instances
		this.else_instances = [];	// subset of unpicked instances
		this.select_all = true;
	};
	Selection.prototype.hasObjects = function ()
	{
		if (this.select_all)
			return this.type.instances.length;
		else
			return this.instances.length;
	};
	Selection.prototype.getObjects = function ()
	{
		if (this.select_all)
			return this.type.instances;
		else
			return this.instances;
	};
	/*
	Selection.prototype.ensure_picked = function (inst, skip_siblings)
	{
		var i, len;
		var orblock = inst.runtime.getCurrentEventStack().current_event.orblock;
		if (this.select_all)
		{
			this.select_all = false;
			if (orblock)
			{
				cr.shallowAssignArray(this.else_instances, inst.type.instances);
				cr.arrayFindRemove(this.else_instances, inst);
			}
			this.instances.length = 1;
			this.instances[0] = inst;
		}
		else
		{
			if (orblock)
			{
				i = this.else_instances.indexOf(inst);
				if (i !== -1)
				{
					this.instances.push(this.else_instances[i]);
					this.else_instances.splice(i, 1);
				}
			}
			else
			{
				if (this.instances.indexOf(inst) === -1)
					this.instances.push(inst);
			}
		}
		if (!skip_siblings)
		{
		}
	};
	*/
	Selection.prototype.pick_one = function (inst)
	{
		if (!inst)
			return;
		if (inst.runtime.getCurrentEventStack().current_event.orblock)
		{
			if (this.select_all)
			{
				this.instances.length = 0;
				cr.shallowAssignArray(this.else_instances, inst.type.instances);
				this.select_all = false;
			}
			var i = this.else_instances.indexOf(inst);
			if (i !== -1)
			{
				this.instances.push(this.else_instances[i]);
				this.else_instances.splice(i, 1);
			}
		}
		else
		{
			this.select_all = false;
			this.instances.length = 1;
			this.instances[0] = inst;
		}
	};
	cr.selection = Selection;
	function EventBlock(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.solModifiersIncludingParents = [];
		this.solWriterAfterCnds = false;	// block does not change SOL after running its conditions
		this.group = false;					// is group of events
		this.initially_activated = false;	// if a group, is active on startup
		this.toplevelevent = false;			// is an event block parented only by a top-level group
		this.toplevelgroup = false;			// is parented only by other groups or is top-level (i.e. not in a subevent)
		this.has_else_block = false;		// is followed by else
;
		this.conditions = [];
		this.actions = [];
		this.subevents = [];
		this.group_name = "";
		this.group = false;
		this.initially_activated = false;
		this.group_active = false;
		this.contained_includes = null;
        if (m[1])
        {
			this.group_name = m[1][1].toLowerCase();
			this.group = true;
			this.initially_activated = !!m[1][0];
			this.contained_includes = [];
			this.group_active = this.initially_activated;
			this.runtime.allGroups.push(this);
            this.runtime.groups_by_name[this.group_name] = this;
        }
		this.orblock = m[2];
		this.sid = m[4];
		if (!this.group)
			this.runtime.blocksBySid[this.sid.toString()] = this;
		var i, len;
		var cm = m[5];
		for (i = 0, len = cm.length; i < len; i++)
		{
			var cnd = new cr.condition(this, cm[i]);
			cnd.index = i;
			cr.seal(cnd);
			this.conditions.push(cnd);
			/*
			if (cnd.is_logical())
				this.is_logical = true;
			if (cnd.type && !cnd.type.plugin.singleglobal && this.cndReferences.indexOf(cnd.type) === -1)
				this.cndReferences.push(cnd.type);
			*/
			this.addSolModifier(cnd.type);
		}
		var am = m[6];
		for (i = 0, len = am.length; i < len; i++)
		{
			var act = new cr.action(this, am[i]);
			act.index = i;
			cr.seal(act);
			this.actions.push(act);
		}
		if (m.length === 8)
		{
			var em = m[7];
			for (i = 0, len = em.length; i < len; i++)
				this.sheet.init_event(em[i], this, this.subevents);
		}
		this.is_else_block = false;
		if (this.conditions.length)
		{
			this.is_else_block = (this.conditions[0].type == null && this.conditions[0].func == cr.system_object.prototype.cnds.Else);
		}
	};
	window["_c2hh_"] = "DE94D5084CD4F909EB35D1699CE34FF54E49B8F3";
	EventBlock.prototype.postInit = function (hasElse/*, prevBlock_*/)
	{
		var i, len;
		var p = this.parent;
		if (this.group)
		{
			this.toplevelgroup = true;
			while (p)
			{
				if (!p.group)
				{
					this.toplevelgroup = false;
					break;
				}
				p = p.parent;
			}
		}
		this.toplevelevent = !this.is_trigger() && (!this.parent || (this.parent.group && this.parent.toplevelgroup));
		this.has_else_block = !!hasElse;
		this.solModifiersIncludingParents = this.solModifiers.slice(0);
		p = this.parent;
		while (p)
		{
			for (i = 0, len = p.solModifiers.length; i < len; i++)
				this.addParentSolModifier(p.solModifiers[i]);
			p = p.parent;
		}
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
		this.solModifiersIncludingParents = findMatchingSolModifier(this.solModifiersIncludingParents);
		var i, len/*, s*/;
		for (i = 0, len = this.conditions.length; i < len; i++)
			this.conditions[i].postInit();
		for (i = 0, len = this.actions.length; i < len; i++)
			this.actions[i].postInit();
		for (i = 0, len = this.subevents.length; i < len; i++)
		{
			this.subevents[i].postInit(i < len - 1 && this.subevents[i + 1].is_else_block);
		}
		/*
		if (this.is_else_block && this.prev_block)
		{
			for (i = 0, len = this.prev_block.solModifiers.length; i < len; i++)
			{
				s = this.prev_block.solModifiers[i];
				if (this.solModifiers.indexOf(s) === -1)
					this.solModifiers.push(s);
			}
		}
		*/
	};
	EventBlock.prototype.setGroupActive = function (a)
	{
		if (this.group_active === !!a)
			return;		// same state
		this.group_active = !!a;
		var i, len;
		for (i = 0, len = this.contained_includes.length; i < len; ++i)
		{
			this.contained_includes[i].updateActive();
		}
		if (len > 0 && this.runtime.running_layout.event_sheet)
			this.runtime.running_layout.event_sheet.updateDeepIncludes();
	};
	function addSolModifierToList(type, arr)
	{
		var i, len, t;
		if (!type)
			return;
		if (arr.indexOf(type) === -1)
			arr.push(type);
		if (type.is_contained)
		{
			for (i = 0, len = type.container.length; i < len; i++)
			{
				t = type.container[i];
				if (type === t)
					continue;		// already handled
				if (arr.indexOf(t) === -1)
					arr.push(t);
			}
		}
	};
	EventBlock.prototype.addSolModifier = function (type)
	{
		addSolModifierToList(type, this.solModifiers);
	};
	EventBlock.prototype.addParentSolModifier = function (type)
	{
		addSolModifierToList(type, this.solModifiersIncludingParents);
	};
	EventBlock.prototype.setSolWriterAfterCnds = function ()
	{
		this.solWriterAfterCnds = true;
		if (this.parent)
			this.parent.setSolWriterAfterCnds();
	};
	EventBlock.prototype.is_trigger = function ()
	{
		if (!this.conditions.length)    // no conditions
			return false;
		else
			return this.conditions[0].trigger;
	};
	EventBlock.prototype.run = function ()
	{
		var i, len, any_true = false, cnd_result;
		var runtime = this.runtime;
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		var conditions = this.conditions;
			if (!this.is_else_block)
				evinfo.else_branch_ran = false;
		if (this.orblock)
		{
			if (conditions.length === 0)
				any_true = true;		// be sure to run if empty block
				evinfo.cndindex = 0
			for (len = conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				if (conditions[evinfo.cndindex].trigger)		// skip triggers when running OR block
					continue;
				cnd_result = conditions[evinfo.cndindex].run();
				if (cnd_result)			// make sure all conditions run and run if any were true
					any_true = true;
			}
			evinfo.last_event_true = any_true;
			if (any_true)
				this.run_actions_and_subevents();
		}
		else
		{
				evinfo.cndindex = 0
			for (len = conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				cnd_result = conditions[evinfo.cndindex].run();
				if (!cnd_result)    // condition failed
				{
					evinfo.last_event_true = false;
					if (this.toplevelevent && (!runtime.deathRow.isEmpty() || runtime.createRow.length))
						runtime.ClearDeathRow();
					return;		// bail out now
				}
			}
			evinfo.last_event_true = true;
			this.run_actions_and_subevents();
		}
		this.end_run(evinfo);
	};
	EventBlock.prototype.end_run = function (evinfo)
	{
		if (evinfo.last_event_true && this.has_else_block)
			evinfo.else_branch_ran = true;
		if (this.toplevelevent && (!this.runtime.deathRow.isEmpty() || this.runtime.createRow.length))
			this.runtime.ClearDeathRow();
	};
	EventBlock.prototype.run_orblocktrigger = function (index)
	{
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		if (this.conditions[index].run())
		{
			this.run_actions_and_subevents();
			this.runtime.getCurrentEventStack().last_event_true = true;
		}
	};
	EventBlock.prototype.run_actions_and_subevents = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		var len;
		for (evinfo.actindex = 0, len = this.actions.length; evinfo.actindex < len; evinfo.actindex++)
		{
			if (this.actions[evinfo.actindex].run())
				return;
		}
		this.run_subevents();
	};
	EventBlock.prototype.resume_actions_and_subevents = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		var len;
		for (len = this.actions.length; evinfo.actindex < len; evinfo.actindex++)
		{
			if (this.actions[evinfo.actindex].run())
				return;
		}
		this.run_subevents();
	};
	EventBlock.prototype.run_subevents = function ()
	{
		if (!this.subevents.length)
			return;
		var i, len, subev, pushpop/*, skipped_pop = false, pop_modifiers = null*/;
		var last = this.subevents.length - 1;
			this.runtime.pushEventStack(this);
		if (this.solWriterAfterCnds)
		{
			for (i = 0, len = this.subevents.length; i < len; i++)
			{
				subev = this.subevents[i];
					pushpop = (!this.toplevelgroup || (!this.group && i < last));
					if (pushpop)
						this.runtime.pushCopySol(subev.solModifiers);
				subev.run();
					if (pushpop)
						this.runtime.popSol(subev.solModifiers);
					else
						this.runtime.clearSol(subev.solModifiers);
			}
		}
		else
		{
			for (i = 0, len = this.subevents.length; i < len; i++)
			{
				this.subevents[i].run();
			}
		}
			this.runtime.popEventStack();
	};
	EventBlock.prototype.run_pretrigger = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		var any_true = false;
		var i, len;
		for (evinfo.cndindex = 0, len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
		{
;
			if (this.conditions[evinfo.cndindex].run())
				any_true = true;
			else if (!this.orblock)			// condition failed (let OR blocks run all conditions anyway)
				return false;               // bail out
		}
		return this.orblock ? any_true : true;
	};
	EventBlock.prototype.retrigger = function ()
	{
		this.runtime.execcount++;
		var prevcndindex = this.runtime.getCurrentEventStack().cndindex;
		var len;
		var evinfo = this.runtime.pushEventStack(this);
		if (!this.orblock)
		{
			for (evinfo.cndindex = prevcndindex + 1, len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				if (!this.conditions[evinfo.cndindex].run())    // condition failed
				{
					this.runtime.popEventStack();               // moving up level of recursion
					return false;                               // bail out
				}
			}
		}
		this.run_actions_and_subevents();
		this.runtime.popEventStack();
		return true;		// ran an iteration
	};
	EventBlock.prototype.isFirstConditionOfType = function (cnd)
	{
		var cndindex = cnd.index;
		if (cndindex === 0)
			return true;
		--cndindex;
		for ( ; cndindex >= 0; --cndindex)
		{
			if (this.conditions[cndindex].type === cnd.type)
				return false;
		}
		return true;
	};
	cr.eventblock = EventBlock;
	function Condition(block, m)
	{
		this.block = block;
		this.sheet = block.sheet;
		this.runtime = block.runtime;
		this.parameters = [];
		this.results = [];
		this.extra = {};		// for plugins to stow away some custom info
		this.index = -1;
		this.anyParamVariesPerInstance = false;
		this.func = m[1];
;
		this.trigger = (m[3] > 0);
		this.fasttrigger = (m[3] === 2);
		this.looping = m[4];
		this.inverted = m[5];
		this.isstatic = m[6];
		this.sid = m[7];
		this.runtime.cndsBySid[this.sid.toString()] = this;
		if (m[0] === -1)		// system object
		{
			this.type = null;
			this.run = this.run_system;
			this.behaviortype = null;
			this.beh_index = -1;
		}
		else
		{
			this.type = this.runtime.types_by_index[m[0]];
;
			if (this.isstatic)
				this.run = this.run_static;
			else
				this.run = this.run_object;
			if (m[2])
			{
				this.behaviortype = this.type.getBehaviorByName(m[2]);
;
				this.beh_index = this.type.getBehaviorIndexByName(m[2]);
;
			}
			else
			{
				this.behaviortype = null;
				this.beh_index = -1;
			}
			if (this.block.parent)
				this.block.parent.setSolWriterAfterCnds();
		}
		if (this.fasttrigger)
			this.run = this.run_true;
		if (m.length === 10)
		{
			var i, len;
			var em = m[9];
			for (i = 0, len = em.length; i < len; i++)
			{
				var param = new cr.parameter(this, em[i]);
				cr.seal(param);
				this.parameters.push(param);
			}
			this.results.length = em.length;
		}
	};
	Condition.prototype.postInit = function ()
	{
		var i, len, p;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			p = this.parameters[i];
			p.postInit();
			if (p.variesPerInstance)
				this.anyParamVariesPerInstance = true;
		}
	};
	/*
	Condition.prototype.is_logical = function ()
	{
		return !this.type || this.type.plugin.singleglobal;
	};
	*/
	Condition.prototype.run_true = function ()
	{
		return true;
	};
	Condition.prototype.run_system = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		return cr.xor(this.func.apply(this.runtime.system, this.results), this.inverted);
	};
	Condition.prototype.run_static = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		var ret = this.func.apply(this.behaviortype ? this.behaviortype : this.type, this.results);
		this.type.applySolToContainer();
		return ret;
	};
	Condition.prototype.run_object = function ()
	{
		var i, j, k, leni, lenj, p, ret, met, inst, s, sol2;
		var type = this.type;
		var sol = type.getCurrentSol();
		var is_orblock = this.block.orblock && !this.trigger;		// triggers in OR blocks need to work normally
		var offset = 0;
		var is_contained = type.is_contained;
		var is_family = type.is_family;
		var family_index = type.family_index;
		var beh_index = this.beh_index;
		var is_beh = (beh_index > -1);
		var params_vary = this.anyParamVariesPerInstance;
		var parameters = this.parameters;
		var results = this.results;
		var inverted = this.inverted;
		var func = this.func;
		var arr, container;
		if (params_vary)
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
			{
				p = parameters[j];
				if (!p.variesPerInstance)
					results[j] = p.get(0);
			}
		}
		else
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
				results[j] = parameters[j].get(0);
		}
		if (sol.select_all) {
			sol.instances.length = 0;       // clear contents
			sol.else_instances.length = 0;
			arr = type.instances;
			for (i = 0, leni = arr.length; i < leni; ++i)
			{
				inst = arr[i];
;
				if (params_vary)
				{
					for (j = 0, lenj = parameters.length; j < lenj; ++j)
					{
						p = parameters[j];
						if (p.variesPerInstance)
							results[j] = p.get(i);        // default SOL index is current object
					}
				}
				if (is_beh)
				{
					offset = 0;
					if (is_family)
					{
						offset = inst.type.family_beh_map[family_index];
					}
					ret = func.apply(inst.behavior_insts[beh_index + offset], results);
				}
				else
					ret = func.apply(inst, results);
				met = cr.xor(ret, inverted);
				if (met)
					sol.instances.push(inst);
				else if (is_orblock)					// in OR blocks, keep the instances not meeting the condition for subsequent testing
					sol.else_instances.push(inst);
			}
			if (type.finish)
				type.finish(true);
			sol.select_all = false;
			type.applySolToContainer();
			return sol.hasObjects();
		}
		else {
			k = 0;
			var using_else_instances = (is_orblock && !this.block.isFirstConditionOfType(this));
			arr = (using_else_instances ? sol.else_instances : sol.instances);
			var any_true = false;
			for (i = 0, leni = arr.length; i < leni; ++i)
			{
				inst = arr[i];
;
				if (params_vary)
				{
					for (j = 0, lenj = parameters.length; j < lenj; ++j)
					{
						p = parameters[j];
						if (p.variesPerInstance)
							results[j] = p.get(i);        // default SOL index is current object
					}
				}
				if (is_beh)
				{
					offset = 0;
					if (is_family)
					{
						offset = inst.type.family_beh_map[family_index];
					}
					ret = func.apply(inst.behavior_insts[beh_index + offset], results);
				}
				else
					ret = func.apply(inst, results);
				if (cr.xor(ret, inverted))
				{
					any_true = true;
					if (using_else_instances)
					{
						sol.instances.push(inst);
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().instances.push(s);
							}
						}
					}
					else
					{
						arr[k] = inst;
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().instances[k] = s;
							}
						}
						k++;
					}
				}
				else
				{
					if (using_else_instances)
					{
						arr[k] = inst;
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().else_instances[k] = s;
							}
						}
						k++;
					}
					else if (is_orblock)
					{
						sol.else_instances.push(inst);
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().else_instances.push(s);
							}
						}
					}
				}
			}
			arr.length = k;
			if (is_contained)
			{
				container = type.container;
				for (i = 0, leni = container.length; i < leni; i++)
				{
					sol2 = container[i].getCurrentSol();
					if (using_else_instances)
						sol2.else_instances.length = k;
					else
						sol2.instances.length = k;
				}
			}
			var pick_in_finish = any_true;		// don't pick in finish() if we're only doing the logic test below
			if (using_else_instances && !any_true)
			{
				for (i = 0, leni = sol.instances.length; i < leni; i++)
				{
					inst = sol.instances[i];
					if (params_vary)
					{
						for (j = 0, lenj = parameters.length; j < lenj; j++)
						{
							p = parameters[j];
							if (p.variesPerInstance)
								results[j] = p.get(i);
						}
					}
					if (is_beh)
						ret = func.apply(inst.behavior_insts[beh_index], results);
					else
						ret = func.apply(inst, results);
					if (cr.xor(ret, inverted))
					{
						any_true = true;
						break;		// got our flag, don't need to test any more
					}
				}
			}
			if (type.finish)
				type.finish(pick_in_finish || is_orblock);
			return is_orblock ? any_true : sol.hasObjects();
		}
	};
	cr.condition = Condition;
	function Action(block, m)
	{
		this.block = block;
		this.sheet = block.sheet;
		this.runtime = block.runtime;
		this.parameters = [];
		this.results = [];
		this.extra = {};		// for plugins to stow away some custom info
		this.index = -1;
		this.anyParamVariesPerInstance = false;
		this.func = m[1];
;
		if (m[0] === -1)	// system
		{
			this.type = null;
			this.run = this.run_system;
			this.behaviortype = null;
			this.beh_index = -1;
		}
		else
		{
			this.type = this.runtime.types_by_index[m[0]];
;
			this.run = this.run_object;
			if (m[2])
			{
				this.behaviortype = this.type.getBehaviorByName(m[2]);
;
				this.beh_index = this.type.getBehaviorIndexByName(m[2]);
;
			}
			else
			{
				this.behaviortype = null;
				this.beh_index = -1;
			}
		}
		this.sid = m[3];
		this.runtime.actsBySid[this.sid.toString()] = this;
		if (m.length === 6)
		{
			var i, len;
			var em = m[5];
			for (i = 0, len = em.length; i < len; i++)
			{
				var param = new cr.parameter(this, em[i]);
				cr.seal(param);
				this.parameters.push(param);
			}
			this.results.length = em.length;
		}
	};
	Action.prototype.postInit = function ()
	{
		var i, len, p;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			p = this.parameters[i];
			p.postInit();
			if (p.variesPerInstance)
				this.anyParamVariesPerInstance = true;
		}
	};
	Action.prototype.run_system = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		return this.func.apply(this.runtime.system, this.results);
	};
	Action.prototype.run_object = function ()
	{
		var instances = this.type.getCurrentSol().getObjects();
		var is_family = this.type.is_family;
		var family_index = this.type.family_index;
		var beh_index = this.beh_index;
		var is_beh = (beh_index > -1);
		var params_vary = this.anyParamVariesPerInstance;
		var parameters = this.parameters;
		var results = this.results;
		var func = this.func;
		var i, j, leni, lenj, p, inst, offset;
		if (params_vary)
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
			{
				p = parameters[j];
				if (!p.variesPerInstance)
					results[j] = p.get(0);
			}
		}
		else
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
				results[j] = parameters[j].get(0);
		}
		for (i = 0, leni = instances.length; i < leni; ++i)
		{
			inst = instances[i];
			if (params_vary)
			{
				for (j = 0, lenj = parameters.length; j < lenj; ++j)
				{
					p = parameters[j];
					if (p.variesPerInstance)
						results[j] = p.get(i);    // pass i to use as default SOL index
				}
			}
			if (is_beh)
			{
				offset = 0;
				if (is_family)
				{
					offset = inst.type.family_beh_map[family_index];
				}
				func.apply(inst.behavior_insts[beh_index + offset], results);
			}
			else
				func.apply(inst, results);
		}
		return false;
	};
	cr.action = Action;
	var tempValues = [];
	var tempValuesPtr = -1;
	function Parameter(owner, m)
	{
		this.owner = owner;
		this.block = owner.block;
		this.sheet = owner.sheet;
		this.runtime = owner.runtime;
		this.type = m[0];
		this.expression = null;
		this.solindex = 0;
		this.get = null;
		this.combosel = 0;
		this.layout = null;
		this.key = 0;
		this.object = null;
		this.index = 0;
		this.varname = null;
		this.eventvar = null;
		this.fileinfo = null;
		this.subparams = null;
		this.variadicret = null;
		this.subparams = null;
		this.variadicret = null;
		this.variesPerInstance = false;
		var i, len, param;
		switch (m[0])
		{
			case 0:		// number
			case 7:		// any
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_exp;
				break;
			case 1:		// string
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_exp_str;
				break;
			case 5:		// layer
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_layer;
				break;
			case 3:		// combo
			case 8:		// cmp
				this.combosel = m[1];
				this.get = this.get_combosel;
				break;
			case 6:		// layout
				this.layout = this.runtime.layouts[m[1]];
;
				this.get = this.get_layout;
				break;
			case 9:		// keyb
				this.key = m[1];
				this.get = this.get_key;
				break;
			case 4:		// object
				this.object = this.runtime.types_by_index[m[1]];
;
				this.get = this.get_object;
				this.block.addSolModifier(this.object);
				if (this.owner instanceof cr.action)
					this.block.setSolWriterAfterCnds();
				else if (this.block.parent)
					this.block.parent.setSolWriterAfterCnds();
				break;
			case 10:	// instvar
				this.index = m[1];
				if (owner.type.is_family)
				{
					this.get = this.get_familyvar;
					this.variesPerInstance = true;
				}
				else
					this.get = this.get_instvar;
				break;
			case 11:	// eventvar
				this.varname = m[1];
				this.eventvar = null;
				this.get = this.get_eventvar;
				break;
			case 2:		// audiofile	["name", ismusic]
			case 12:	// fileinfo		"name"
				this.fileinfo = m[1];
				this.get = this.get_audiofile;
				break;
			case 13:	// variadic
				this.get = this.get_variadic;
				this.subparams = [];
				this.variadicret = [];
				for (i = 1, len = m.length; i < len; i++)
				{
					param = new cr.parameter(this.owner, m[i]);
					cr.seal(param);
					this.subparams.push(param);
					this.variadicret.push(0);
				}
				break;
			default:
;
		}
	};
	Parameter.prototype.postInit = function ()
	{
		var i, len;
		if (this.type === 11)		// eventvar
		{
			this.eventvar = this.runtime.getEventVariableByName(this.varname, this.block.parent);
;
		}
		else if (this.type === 13)	// variadic, postInit all sub-params
		{
			for (i = 0, len = this.subparams.length; i < len; i++)
				this.subparams[i].postInit();
		}
		if (this.expression)
			this.expression.postInit();
	};
	Parameter.prototype.maybeVaryForType = function (t)
	{
		if (this.variesPerInstance)
			return;				// already varies per instance, no need to check again
		if (!t)
			return;				// never vary for system type
		if (!t.plugin.singleglobal)
		{
			this.variesPerInstance = true;
			return;
		}
	};
	Parameter.prototype.setVaries = function ()
	{
		this.variesPerInstance = true;
	};
	Parameter.prototype.pushTempValue = function ()
	{
		tempValuesPtr++;
		if (tempValues.length === tempValuesPtr)
			tempValues.push(new cr.expvalue());
		return tempValues[tempValuesPtr];
	};
	Parameter.prototype.popTempValue = function ()
	{
		tempValuesPtr--;
	};
	Parameter.prototype.get_exp = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		return temp.data;      			// return actual JS value, not expvalue
	};
	Parameter.prototype.get_exp_str = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		if (cr.is_string(temp.data))
			return temp.data;
		else
			return "";
	};
	Parameter.prototype.get_object = function ()
	{
		return this.object;
	};
	Parameter.prototype.get_combosel = function ()
	{
		return this.combosel;
	};
	Parameter.prototype.get_layer = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		if (temp.is_number())
			return this.runtime.getLayerByNumber(temp.data);
		else
			return this.runtime.getLayerByName(temp.data);
	}
	Parameter.prototype.get_layout = function ()
	{
		return this.layout;
	};
	Parameter.prototype.get_key = function ()
	{
		return this.key;
	};
	Parameter.prototype.get_instvar = function ()
	{
		return this.index;
	};
	Parameter.prototype.get_familyvar = function (solindex_)
	{
		var solindex = solindex_ || 0;
		var familytype = this.owner.type;
		var realtype = null;
		var sol = familytype.getCurrentSol();
		var objs = sol.getObjects();
		if (objs.length)
			realtype = objs[solindex % objs.length].type;
		else if (sol.else_instances.length)
			realtype = sol.else_instances[solindex % sol.else_instances.length].type;
		else if (familytype.instances.length)
			realtype = familytype.instances[solindex % familytype.instances.length].type;
		else
			return 0;
		return this.index + realtype.family_var_map[familytype.family_index];
	};
	Parameter.prototype.get_eventvar = function ()
	{
		return this.eventvar;
	};
	Parameter.prototype.get_audiofile = function ()
	{
		return this.fileinfo;
	};
	Parameter.prototype.get_variadic = function ()
	{
		var i, len;
		for (i = 0, len = this.subparams.length; i < len; i++)
		{
			this.variadicret[i] = this.subparams[i].get();
		}
		return this.variadicret;
	};
	cr.parameter = Parameter;
	function EventVariable(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.name = m[1];
		this.vartype = m[2];
		this.initial = m[3];
		this.is_static = !!m[4];
		this.is_constant = !!m[5];
		this.sid = m[6];
		this.runtime.varsBySid[this.sid.toString()] = this;
		this.data = this.initial;	// note: also stored in event stack frame for local nonstatic nonconst vars
		if (this.parent)			// local var
		{
			if (this.is_static || this.is_constant)
				this.localIndex = -1;
			else
				this.localIndex = this.runtime.stackLocalCount++;
			this.runtime.all_local_vars.push(this);
		}
		else						// global var
		{
			this.localIndex = -1;
			this.runtime.all_global_vars.push(this);
		}
	};
	EventVariable.prototype.postInit = function ()
	{
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
	};
	EventVariable.prototype.setValue = function (x)
	{
;
		var lvs = this.runtime.getCurrentLocalVarStack();
		if (!this.parent || this.is_static || !lvs)
			this.data = x;
		else	// local nonstatic variable: use event stack to keep value at this level of recursion
		{
			if (this.localIndex >= lvs.length)
				lvs.length = this.localIndex + 1;
			lvs[this.localIndex] = x;
		}
	};
	EventVariable.prototype.getValue = function ()
	{
		var lvs = this.runtime.getCurrentLocalVarStack();
		if (!this.parent || this.is_static || !lvs || this.is_constant)
			return this.data;
		else	// local nonstatic variable
		{
			if (this.localIndex >= lvs.length)
			{
;
				return this.initial;
			}
			if (typeof lvs[this.localIndex] === "undefined")
			{
;
				return this.initial;
			}
			return lvs[this.localIndex];
		}
	};
	EventVariable.prototype.run = function ()
	{
			if (this.parent && !this.is_static && !this.is_constant)
				this.setValue(this.initial);
	};
	cr.eventvariable = EventVariable;
	function EventInclude(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.include_sheet = null;		// determined in postInit
		this.include_sheet_name = m[1];
		this.active = true;
	};
	EventInclude.prototype.toString = function ()
	{
		return "include:" + this.include_sheet.toString();
	};
	EventInclude.prototype.postInit = function ()
	{
        this.include_sheet = this.runtime.eventsheets[this.include_sheet_name];
;
;
        this.sheet.includes.add(this);
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
		var p = this.parent;
		while (p)
		{
			if (p.group)
				p.contained_includes.push(this);
			p = p.parent;
		}
		this.updateActive();
	};
	EventInclude.prototype.run = function ()
	{
			if (this.parent)
				this.runtime.pushCleanSol(this.runtime.types_by_index);
        if (!this.include_sheet.hasRun)
            this.include_sheet.run(true);			// from include
			if (this.parent)
				this.runtime.popSol(this.runtime.types_by_index);
	};
	EventInclude.prototype.updateActive = function ()
	{
		var p = this.parent;
		while (p)
		{
			if (p.group && !p.group_active)
			{
				this.active = false;
				return;
			}
			p = p.parent;
		}
		this.active = true;
	};
	EventInclude.prototype.isActive = function ()
	{
		return this.active;
	};
	cr.eventinclude = EventInclude;
	function EventStackFrame()
	{
		this.temp_parents_arr = [];
		this.reset(null);
		cr.seal(this);
	};
	EventStackFrame.prototype.reset = function (cur_event)
	{
		this.current_event = cur_event;
		this.cndindex = 0;
		this.actindex = 0;
		this.temp_parents_arr.length = 0;
		this.last_event_true = false;
		this.else_branch_ran = false;
		this.any_true_state = false;
	};
	EventStackFrame.prototype.isModifierAfterCnds = function ()
	{
		if (this.current_event.solWriterAfterCnds)
			return true;
		if (this.cndindex < this.current_event.conditions.length - 1)
			return !!this.current_event.solModifiers.length;
		return false;
	};
	cr.eventStackFrame = EventStackFrame;
}());
(function()
{
	function ExpNode(owner_, m)
	{
		this.owner = owner_;
		this.runtime = owner_.runtime;
		this.type = m[0];
;
		this.get = [this.eval_int,
					this.eval_float,
					this.eval_string,
					this.eval_unaryminus,
					this.eval_add,
					this.eval_subtract,
					this.eval_multiply,
					this.eval_divide,
					this.eval_mod,
					this.eval_power,
					this.eval_and,
					this.eval_or,
					this.eval_equal,
					this.eval_notequal,
					this.eval_less,
					this.eval_lessequal,
					this.eval_greater,
					this.eval_greaterequal,
					this.eval_conditional,
					this.eval_system_exp,
					this.eval_object_behavior_exp,
					this.eval_instvar_exp,
					this.eval_object_behavior_exp,
					this.eval_eventvar_exp][this.type];
		var paramsModel = null;
		this.value = null;
		this.first = null;
		this.second = null;
		this.third = null;
		this.func = null;
		this.results = null;
		this.parameters = null;
		this.object_type = null;
		this.beh_index = -1;
		this.instance_expr = null;
		this.varindex = -1;
		this.behavior_type = null;
		this.varname = null;
		this.eventvar = null;
		this.return_string = false;
		switch (this.type) {
		case 0:		// int
		case 1:		// float
		case 2:		// string
			this.value = m[1];
			break;
		case 3:		// unaryminus
			this.first = new cr.expNode(owner_, m[1]);
			break;
		case 18:	// conditional
			this.first = new cr.expNode(owner_, m[1]);
			this.second = new cr.expNode(owner_, m[2]);
			this.third = new cr.expNode(owner_, m[3]);
			break;
		case 19:	// system_exp
			this.func = m[1];
;
			if (this.func === cr.system_object.prototype.exps.random
			 || this.func === cr.system_object.prototype.exps.choose)
			{
				this.owner.setVaries();
			}
			this.results = [];
			this.parameters = [];
			if (m.length === 3)
			{
				paramsModel = m[2];
				this.results.length = paramsModel.length + 1;	// must also fit 'ret'
			}
			else
				this.results.length = 1;      // to fit 'ret'
			break;
		case 20:	// object_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.beh_index = -1;
			this.func = m[2];
			this.return_string = m[3];
			if (cr.plugins_.Function && this.func === cr.plugins_.Function.prototype.exps.Call)
			{
				this.owner.setVaries();
			}
			if (m[4])
				this.instance_expr = new cr.expNode(owner_, m[4]);
			else
				this.instance_expr = null;
			this.results = [];
			this.parameters = [];
			if (m.length === 6)
			{
				paramsModel = m[5];
				this.results.length = paramsModel.length + 1;
			}
			else
				this.results.length = 1;	// to fit 'ret'
			break;
		case 21:		// instvar_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.return_string = m[2];
			if (m[3])
				this.instance_expr = new cr.expNode(owner_, m[3]);
			else
				this.instance_expr = null;
			this.varindex = m[4];
			break;
		case 22:		// behavior_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.behavior_type = this.object_type.getBehaviorByName(m[2]);
;
			this.beh_index = this.object_type.getBehaviorIndexByName(m[2]);
			this.func = m[3];
			this.return_string = m[4];
			if (m[5])
				this.instance_expr = new cr.expNode(owner_, m[5]);
			else
				this.instance_expr = null;
			this.results = [];
			this.parameters = [];
			if (m.length === 7)
			{
				paramsModel = m[6];
				this.results.length = paramsModel.length + 1;
			}
			else
				this.results.length = 1;	// to fit 'ret'
			break;
		case 23:		// eventvar_exp
			this.varname = m[1];
			this.eventvar = null;	// assigned in postInit
			break;
		}
		this.owner.maybeVaryForType(this.object_type);
		if (this.type >= 4 && this.type <= 17)
		{
			this.first = new cr.expNode(owner_, m[1]);
			this.second = new cr.expNode(owner_, m[2]);
		}
		if (paramsModel)
		{
			var i, len;
			for (i = 0, len = paramsModel.length; i < len; i++)
				this.parameters.push(new cr.expNode(owner_, paramsModel[i]));
		}
		cr.seal(this);
	};
	ExpNode.prototype.postInit = function ()
	{
		if (this.type === 23)	// eventvar_exp
		{
			this.eventvar = this.owner.runtime.getEventVariableByName(this.varname, this.owner.block.parent);
;
		}
		if (this.first)
			this.first.postInit();
		if (this.second)
			this.second.postInit();
		if (this.third)
			this.third.postInit();
		if (this.instance_expr)
			this.instance_expr.postInit();
		if (this.parameters)
		{
			var i, len;
			for (i = 0, len = this.parameters.length; i < len; i++)
				this.parameters[i].postInit();
		}
	};
	ExpNode.prototype.eval_system_exp = function (ret)
	{
		this.results[0] = ret;
		var temp = this.owner.pushTempValue();
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			this.parameters[i].get(temp);
			this.results[i + 1] = temp.data;   // passing actual javascript value as argument instead of expvalue
		}
		this.owner.popTempValue();
		this.func.apply(this.runtime.system, this.results);
	};
	ExpNode.prototype.eval_object_behavior_exp = function (ret)
	{
		var sol = this.object_type.getCurrentSol();
		var instances = sol.getObjects();
		if (!instances.length)
		{
			if (sol.else_instances.length)
				instances = sol.else_instances;
			else
			{
				if (this.return_string)
					ret.set_string("");
				else
					ret.set_int(0);
				return;
			}
		}
		this.results[0] = ret;
		ret.object_class = this.object_type;		// so expression can access family type if need be
		var temp = this.owner.pushTempValue();
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++) {
			this.parameters[i].get(temp);
			this.results[i + 1] = temp.data;   // passing actual javascript value as argument instead of expvalue
		}
		var index = this.owner.solindex;
		if (this.instance_expr) {
			this.instance_expr.get(temp);
			if (temp.is_number()) {
				index = temp.data;
				instances = this.object_type.instances;    // pick from all instances, not SOL
			}
		}
		this.owner.popTempValue();
		index %= instances.length;      // wraparound
		if (index < 0)
			index += instances.length;
		var returned_val;
		var inst = instances[index];
		if (this.beh_index > -1)
		{
			var offset = 0;
			if (this.object_type.is_family)
			{
				offset = inst.type.family_beh_map[this.object_type.family_index];
			}
			returned_val = this.func.apply(inst.behavior_insts[this.beh_index + offset], this.results);
		}
		else
			returned_val = this.func.apply(inst, this.results);
;
	};
	ExpNode.prototype.eval_instvar_exp = function (ret)
	{
		var sol = this.object_type.getCurrentSol();
		var instances = sol.getObjects();
		if (!instances.length)
		{
			if (sol.else_instances.length)
				instances = sol.else_instances;
			else
			{
				if (this.return_string)
					ret.set_string("");
				else
					ret.set_int(0);
				return;
			}
		}
		var index = this.owner.solindex;
		if (this.instance_expr)
		{
			var temp = this.owner.pushTempValue();
			this.instance_expr.get(temp);
			if (temp.is_number())
			{
				index = temp.data;
				var type_instances = this.object_type.instances;
				index %= type_instances.length;     // wraparound
				if (index < 0)                      // offset
					index += type_instances.length;
				var to_ret = type_instances[index].instance_vars[this.varindex];
				if (cr.is_string(to_ret))
					ret.set_string(to_ret);
				else
					ret.set_float(to_ret);
				this.owner.popTempValue();
				return;         // done
			}
			this.owner.popTempValue();
		}
		index %= instances.length;      // wraparound
		if (index < 0)
			index += instances.length;
		var inst = instances[index];
		var offset = 0;
		if (this.object_type.is_family)
		{
			offset = inst.type.family_var_map[this.object_type.family_index];
		}
		var to_ret = inst.instance_vars[this.varindex + offset];
		if (cr.is_string(to_ret))
			ret.set_string(to_ret);
		else
			ret.set_float(to_ret);
	};
	ExpNode.prototype.eval_int = function (ret)
	{
		ret.type = cr.exptype.Integer;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_float = function (ret)
	{
		ret.type = cr.exptype.Float;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_string = function (ret)
	{
		ret.type = cr.exptype.String;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_unaryminus = function (ret)
	{
		this.first.get(ret);                // retrieve operand
		if (ret.is_number())
			ret.data = -ret.data;
	};
	ExpNode.prototype.eval_add = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data += temp.data;          // both operands numbers: add
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_subtract = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data -= temp.data;          // both operands numbers: subtract
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_multiply = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data *= temp.data;          // both operands numbers: multiply
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_divide = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data /= temp.data;          // both operands numbers: divide
			ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_mod = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data %= temp.data;          // both operands numbers: modulo
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_power = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data = Math.pow(ret.data, temp.data);   // both operands numbers: raise to power
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_and = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number())
		{
			if (temp.is_string())
			{
				ret.set_string(ret.data.toString() + temp.data);
			}
			else
			{
				if (ret.data && temp.data)
					ret.set_int(1);
				else
					ret.set_int(0);
			}
		}
		else if (ret.is_string())
		{
			if (temp.is_string())
				ret.data += temp.data;
			else
			{
				ret.data += (Math.round(temp.data * 1e10) / 1e10).toString();
			}
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_or = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			if (ret.data || temp.data)
				ret.set_int(1);
			else
				ret.set_int(0);
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_conditional = function (ret)
	{
		this.first.get(ret);                // condition operand
		if (ret.data)                       // is true
			this.second.get(ret);           // evaluate second operand to ret
		else
			this.third.get(ret);            // evaluate third operand to ret
	};
	ExpNode.prototype.eval_equal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data === temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_notequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data !== temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_less = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data < temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_lessequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data <= temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_greater = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data > temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_greaterequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data >= temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_eventvar_exp = function (ret)
	{
		var val = this.eventvar.getValue();
		if (cr.is_number(val))
			ret.set_float(val);
		else
			ret.set_string(val);
	};
	cr.expNode = ExpNode;
	function ExpValue(type, data)
	{
		this.type = type || cr.exptype.Integer;
		this.data = data || 0;
		this.object_class = null;
;
;
;
		if (this.type == cr.exptype.Integer)
			this.data = Math.floor(this.data);
		cr.seal(this);
	};
	ExpValue.prototype.is_int = function ()
	{
		return this.type === cr.exptype.Integer;
	};
	ExpValue.prototype.is_float = function ()
	{
		return this.type === cr.exptype.Float;
	};
	ExpValue.prototype.is_number = function ()
	{
		return this.type === cr.exptype.Integer || this.type === cr.exptype.Float;
	};
	ExpValue.prototype.is_string = function ()
	{
		return this.type === cr.exptype.String;
	};
	ExpValue.prototype.make_int = function ()
	{
		if (!this.is_int())
		{
			if (this.is_float())
				this.data = Math.floor(this.data);      // truncate float
			else if (this.is_string())
				this.data = parseInt(this.data, 10);
			this.type = cr.exptype.Integer;
		}
	};
	ExpValue.prototype.make_float = function ()
	{
		if (!this.is_float())
		{
			if (this.is_string())
				this.data = parseFloat(this.data);
			this.type = cr.exptype.Float;
		}
	};
	ExpValue.prototype.make_string = function ()
	{
		if (!this.is_string())
		{
			this.data = this.data.toString();
			this.type = cr.exptype.String;
		}
	};
	ExpValue.prototype.set_int = function (val)
	{
;
		this.type = cr.exptype.Integer;
		this.data = Math.floor(val);
	};
	ExpValue.prototype.set_float = function (val)
	{
;
		this.type = cr.exptype.Float;
		this.data = val;
	};
	ExpValue.prototype.set_string = function (val)
	{
;
		this.type = cr.exptype.String;
		this.data = val;
	};
	ExpValue.prototype.set_any = function (val)
	{
		if (cr.is_number(val))
		{
			this.type = cr.exptype.Float;
			this.data = val;
		}
		else if (cr.is_string(val))
		{
			this.type = cr.exptype.String;
			this.data = val.toString();
		}
		else
		{
			this.type = cr.exptype.Integer;
			this.data = 0;
		}
	};
	cr.expvalue = ExpValue;
	cr.exptype = {
		Integer: 0,     // emulated; no native integer support in javascript
		Float: 1,
		String: 2
	};
}());
;
cr.system_object = function (runtime)
{
    this.runtime = runtime;
	this.waits = [];
};
cr.system_object.prototype.saveToJSON = function ()
{
	var o = {};
	var i, len, j, lenj, p, w, t, sobj;
	o["waits"] = [];
	var owaits = o["waits"];
	var waitobj;
	for (i = 0, len = this.waits.length; i < len; i++)
	{
		w = this.waits[i];
		waitobj = {
			"t": w.time,
			"ev": w.ev.sid,
			"sm": [],
			"sols": {}
		};
		if (w.ev.actions[w.actindex])
			waitobj["act"] = w.ev.actions[w.actindex].sid;
		for (j = 0, lenj = w.solModifiers.length; j < lenj; j++)
			waitobj["sm"].push(w.solModifiers[j].sid);
		for (p in w.sols)
		{
			if (w.sols.hasOwnProperty(p))
			{
				t = this.runtime.types_by_index[parseInt(p, 10)];
;
				sobj = {
					"sa": w.sols[p].sa,
					"insts": []
				};
				for (j = 0, lenj = w.sols[p].insts.length; j < lenj; j++)
					sobj["insts"].push(w.sols[p].insts[j].uid);
				waitobj["sols"][t.sid.toString()] = sobj;
			}
		}
		owaits.push(waitobj);
	}
	return o;
};
cr.system_object.prototype.loadFromJSON = function (o)
{
	var owaits = o["waits"];
	var i, len, j, lenj, p, w, addWait, e, aindex, t, savedsol, nusol, inst;
	this.waits.length = 0;
	for (i = 0, len = owaits.length; i < len; i++)
	{
		w = owaits[i];
		e = this.runtime.blocksBySid[w["ev"].toString()];
		if (!e)
			continue;	// event must've gone missing
		aindex = -1;
		for (j = 0, lenj = e.actions.length; j < lenj; j++)
		{
			if (e.actions[j].sid === w["act"])
			{
				aindex = j;
				break;
			}
		}
		if (aindex === -1)
			continue;	// action must've gone missing
		addWait = {};
		addWait.sols = {};
		addWait.solModifiers = [];
		addWait.deleteme = false;
		addWait.time = w["t"];
		addWait.ev = e;
		addWait.actindex = aindex;
		for (j = 0, lenj = w["sm"].length; j < lenj; j++)
		{
			t = this.runtime.getObjectTypeBySid(w["sm"][j]);
			if (t)
				addWait.solModifiers.push(t);
		}
		for (p in w["sols"])
		{
			if (w["sols"].hasOwnProperty(p))
			{
				t = this.runtime.getObjectTypeBySid(parseInt(p, 10));
				if (!t)
					continue;		// type must've been deleted
				savedsol = w["sols"][p];
				nusol = {
					sa: savedsol["sa"],
					insts: []
				};
				for (j = 0, lenj = savedsol["insts"].length; j < lenj; j++)
				{
					inst = this.runtime.getObjectByUID(savedsol["insts"][j]);
					if (inst)
						nusol.insts.push(inst);
				}
				addWait.sols[t.index.toString()] = nusol;
			}
		}
		this.waits.push(addWait);
	}
};
(function ()
{
	var sysProto = cr.system_object.prototype;
	function SysCnds() {};
    SysCnds.prototype.EveryTick = function()
    {
        return true;
    };
    SysCnds.prototype.OnLayoutStart = function()
    {
        return true;
    };
    SysCnds.prototype.OnLayoutEnd = function()
    {
        return true;
    };
    SysCnds.prototype.Compare = function(x, cmp, y)
    {
        return cr.do_cmp(x, cmp, y);
    };
    SysCnds.prototype.CompareTime = function (cmp, t)
    {
        var elapsed = this.runtime.kahanTime.sum;
        if (cmp === 0)
        {
            var cnd = this.runtime.getCurrentCondition();
            if (!cnd.extra.CompareTime_executed)
            {
                if (elapsed >= t)
                {
                    cnd.extra.CompareTime_executed = true;
                    return true;
                }
            }
            return false;
        }
        return cr.do_cmp(elapsed, cmp, t);
    };
    SysCnds.prototype.LayerVisible = function (layer)
    {
        if (!layer)
            return false;
        else
            return layer.visible;
    };
	SysCnds.prototype.LayerCmpOpacity = function (layer, cmp, opacity_)
	{
		if (!layer)
			return false;
		return cr.do_cmp(layer.opacity * 100, cmp, opacity_);
	};
    SysCnds.prototype.Repeat = function (count)
    {
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i;
		if (solModifierAfterCnds)
		{
			for (i = 0; i < count && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			for (i = 0; i < count && !current_loop.stopped; i++)
			{
				current_loop.index = i;
				current_event.retrigger();
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
	SysCnds.prototype.While = function (count)
    {
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i;
		if (solModifierAfterCnds)
		{
			for (i = 0; !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				current_loop.index = i;
				if (!current_event.retrigger())		// one of the other conditions returned false
					current_loop.stopped = true;	// break
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			for (i = 0; !current_loop.stopped; i++)
			{
				current_loop.index = i;
				if (!current_event.retrigger())
					current_loop.stopped = true;
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
    SysCnds.prototype.For = function (name, start, end)
    {
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack(name);
        var i;
		if (end < start)
		{
			if (solModifierAfterCnds)
			{
				for (i = start; i >= end && !current_loop.stopped; --i)  // inclusive to end
				{
					this.runtime.pushCopySol(current_event.solModifiers);
					current_loop.index = i;
					current_event.retrigger();
					this.runtime.popSol(current_event.solModifiers);
				}
			}
			else
			{
				for (i = start; i >= end && !current_loop.stopped; --i)  // inclusive to end
				{
					current_loop.index = i;
					current_event.retrigger();
				}
			}
		}
		else
		{
			if (solModifierAfterCnds)
			{
				for (i = start; i <= end && !current_loop.stopped; ++i)  // inclusive to end
				{
					this.runtime.pushCopySol(current_event.solModifiers);
					current_loop.index = i;
					current_event.retrigger();
					this.runtime.popSol(current_event.solModifiers);
				}
			}
			else
			{
				for (i = start; i <= end && !current_loop.stopped; ++i)  // inclusive to end
				{
					current_loop.index = i;
					current_event.retrigger();
				}
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
	var foreach_instancestack = [];
	var foreach_instanceptr = -1;
    SysCnds.prototype.ForEach = function (obj)
    {
        var sol = obj.getCurrentSol();
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var instances = foreach_instancestack[foreach_instanceptr];
		cr.shallowAssignArray(instances, sol.getObjects());
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i, len, j, lenj, inst, s, sol2;
		var is_contained = obj.is_contained;
		if (solModifierAfterCnds)
		{
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				inst = instances[i];
				sol = obj.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			sol.select_all = false;
			sol.instances.length = 1;
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				inst = instances[i];
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
			}
		}
		instances.length = 0;
        this.runtime.popLoopStack();
		foreach_instanceptr--;
		return false;
    };
	function foreach_sortinstances(a, b)
	{
		var va = a.extra.c2_foreachordered_val;
		var vb = b.extra.c2_foreachordered_val;
		if (cr.is_number(va) && cr.is_number(vb))
			return va - vb;
		else
		{
			va = "" + va;
			vb = "" + vb;
			if (va < vb)
				return -1;
			else if (va > vb)
				return 1;
			else
				return 0;
		}
	};
	SysCnds.prototype.ForEachOrdered = function (obj, exp, order)
    {
        var sol = obj.getCurrentSol();
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var instances = foreach_instancestack[foreach_instanceptr];
		cr.shallowAssignArray(instances, sol.getObjects());
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var current_condition = this.runtime.getCurrentCondition();
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
		var i, len, j, lenj, inst, s, sol2;
		for (i = 0, len = instances.length; i < len; i++)
		{
			instances[i].extra.c2_foreachordered_val = current_condition.parameters[1].get(i);
		}
		instances.sort(foreach_sortinstances);
		if (order === 1)
			instances.reverse();
		var is_contained = obj.is_contained;
		if (solModifierAfterCnds)
		{
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				inst = instances[i];
				sol = obj.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			sol.select_all = false;
			sol.instances.length = 1;
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				inst = instances[i];
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
			}
		}
		instances.length = 0;
        this.runtime.popLoopStack();
		foreach_instanceptr--;
		return false;
    };
	SysCnds.prototype.PickByComparison = function (obj_, exp_, cmp_, val_)
	{
		var i, len, k, inst;
		if (!obj_)
			return;
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var tmp_instances = foreach_instancestack[foreach_instanceptr];
		var sol = obj_.getCurrentSol();
		cr.shallowAssignArray(tmp_instances, sol.getObjects());
		if (sol.select_all)
			sol.else_instances.length = 0;
		var current_condition = this.runtime.getCurrentCondition();
		for (i = 0, k = 0, len = tmp_instances.length; i < len; i++)
		{
			inst = tmp_instances[i];
			tmp_instances[k] = inst;
			exp_ = current_condition.parameters[1].get(i);
			val_ = current_condition.parameters[3].get(i);
			if (cr.do_cmp(exp_, cmp_, val_))
			{
				k++;
			}
			else
			{
				sol.else_instances.push(inst);
			}
		}
		tmp_instances.length = k;
		sol.select_all = false;
		cr.shallowAssignArray(sol.instances, tmp_instances);
		tmp_instances.length = 0;
		foreach_instanceptr--;
		obj_.applySolToContainer();
		return !!sol.instances.length;
	};
	SysCnds.prototype.PickByEvaluate = function (obj_, exp_)
	{
		var i, len, k, inst;
		if (!obj_)
			return;
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var tmp_instances = foreach_instancestack[foreach_instanceptr];
		var sol = obj_.getCurrentSol();
		cr.shallowAssignArray(tmp_instances, sol.getObjects());
		if (sol.select_all)
			sol.else_instances.length = 0;
		var current_condition = this.runtime.getCurrentCondition();
		for (i = 0, k = 0, len = tmp_instances.length; i < len; i++)
		{
			inst = tmp_instances[i];
			tmp_instances[k] = inst;
			exp_ = current_condition.parameters[1].get(i);
			if (exp_)
			{
				k++;
			}
			else
			{
				sol.else_instances.push(inst);
			}
		}
		tmp_instances.length = k;
		sol.select_all = false;
		cr.shallowAssignArray(sol.instances, tmp_instances);
		tmp_instances.length = 0;
		foreach_instanceptr--;
		obj_.applySolToContainer();
		return !!sol.instances.length;
	};
    SysCnds.prototype.TriggerOnce = function ()
    {
        var cndextra = this.runtime.getCurrentCondition().extra;
		if (typeof cndextra.TriggerOnce_lastTick === "undefined")
			cndextra.TriggerOnce_lastTick = -1;
        var last_tick = cndextra.TriggerOnce_lastTick;
        var cur_tick = this.runtime.tickcount;
        cndextra.TriggerOnce_lastTick = cur_tick;
        return this.runtime.layout_first_tick || last_tick !== cur_tick - 1;
    };
    SysCnds.prototype.Every = function (seconds)
    {
        var cnd = this.runtime.getCurrentCondition();
        var last_time = cnd.extra.Every_lastTime || 0;
        var cur_time = this.runtime.kahanTime.sum;
		if (typeof cnd.extra.Every_seconds === "undefined")
			cnd.extra.Every_seconds = seconds;
		var this_seconds = cnd.extra.Every_seconds;
        if (cur_time >= last_time + this_seconds)
        {
            cnd.extra.Every_lastTime = last_time + this_seconds;
			if (cur_time >= cnd.extra.Every_lastTime + 0.04)
			{
				cnd.extra.Every_lastTime = cur_time;
			}
			cnd.extra.Every_seconds = seconds;
            return true;
        }
		else if (cur_time < last_time - 0.1)
		{
			cnd.extra.Every_lastTime = cur_time;
		}
		return false;
    };
    SysCnds.prototype.PickNth = function (obj, index)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
		index = cr.floor(index);
        if (index < 0 || index >= instances.length)
            return false;
		var inst = instances[index];
        sol.pick_one(inst);
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.PickRandom = function (obj)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
		var index = cr.floor(Math.random() * instances.length);
        if (index >= instances.length)
            return false;
		var inst = instances[index];
        sol.pick_one(inst);
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.CompareVar = function (v, cmp, val)
    {
        return cr.do_cmp(v.getValue(), cmp, val);
    };
    SysCnds.prototype.IsGroupActive = function (group)
    {
		var g = this.runtime.groups_by_name[group.toLowerCase()];
        return g && g.group_active;
    };
	SysCnds.prototype.IsPreview = function ()
	{
		return typeof cr_is_preview !== "undefined";
	};
	SysCnds.prototype.PickAll = function (obj)
    {
        if (!obj)
            return false;
		if (!obj.instances.length)
			return false;
        var sol = obj.getCurrentSol();
        sol.select_all = true;
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.IsMobile = function ()
	{
		return this.runtime.isMobile;
	};
	SysCnds.prototype.CompareBetween = function (x, a, b)
	{
		return x >= a && x <= b;
	};
	SysCnds.prototype.Else = function ()
	{
		var current_frame = this.runtime.getCurrentEventStack();
		if (current_frame.else_branch_ran)
			return false;		// another event in this else-if chain has run
		else
			return !current_frame.last_event_true;
		/*
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var prev_event = current_event.prev_block;
		if (!prev_event)
			return false;
		if (prev_event.is_logical)
			return !this.runtime.last_event_true;
		var i, len, j, lenj, s, sol, temp, inst, any_picked = false;
		for (i = 0, len = prev_event.cndReferences.length; i < len; i++)
		{
			s = prev_event.cndReferences[i];
			sol = s.getCurrentSol();
			if (sol.select_all || sol.instances.length === s.instances.length)
			{
				sol.select_all = false;
				sol.instances.length = 0;
			}
			else
			{
				if (sol.instances.length === 1 && sol.else_instances.length === 0 && s.instances.length >= 2)
				{
					inst = sol.instances[0];
					sol.instances.length = 0;
					for (j = 0, lenj = s.instances.length; j < lenj; j++)
					{
						if (s.instances[j] != inst)
							sol.instances.push(s.instances[j]);
					}
					any_picked = true;
				}
				else
				{
					temp = sol.instances;
					sol.instances = sol.else_instances;
					sol.else_instances = temp;
					any_picked = true;
				}
			}
		}
		return any_picked;
		*/
	};
	SysCnds.prototype.OnLoadFinished = function ()
	{
		return true;
	};
	SysCnds.prototype.OnCanvasSnapshot = function ()
	{
		return true;
	};
	SysCnds.prototype.EffectsSupported = function ()
	{
		return !!this.runtime.glwrap;
	};
	SysCnds.prototype.OnSaveComplete = function ()
	{
		return true;
	};
	SysCnds.prototype.OnLoadComplete = function ()
	{
		return true;
	};
	SysCnds.prototype.OnLoadFailed = function ()
	{
		return true;
	};
	SysCnds.prototype.ObjectUIDExists = function (u)
	{
		return !!this.runtime.getObjectByUID(u);
	};
	SysCnds.prototype.IsOnPlatform = function (p)
	{
		var rt = this.runtime;
		switch (p) {
		case 0:		// HTML5 website
			return !rt.isDomFree && !rt.isNodeWebkit && !rt.isPhoneGap && !rt.isCrosswalk && !rt.isWinJS && !rt.isWindowsPhone8 && !rt.isBlackberry10 && !rt.isAmazonWebApp;
		case 1:		// iOS
			return rt.isiOS;
		case 2:		// Android
			return rt.isAndroid;
		case 3:		// Windows 8
			return rt.isWindows8App;
		case 4:		// Windows Phone 8
			return rt.isWindowsPhone8;
		case 5:		// Blackberry 10
			return rt.isBlackberry10;
		case 6:		// Tizen
			return rt.isTizen;
		case 7:		// CocoonJS
			return rt.isCocoonJs;
		case 8:		// PhoneGap
			return rt.isPhoneGap;
		case 9:	// Scirra Arcade
			return rt.isArcade;
		case 10:	// node-webkit
			return rt.isNodeWebkit;
		case 11:	// crosswalk
			return rt.isCrosswalk;
		case 12:	// amazon webapp
			return rt.isAmazonWebApp;
		default:	// should not be possible
			return false;
		}
	};
	var cacheRegex = null;
	var lastRegex = "";
	var lastFlags = "";
	function getRegex(regex_, flags_)
	{
		if (!cacheRegex || regex_ !== lastRegex || flags_ !== lastFlags)
		{
			cacheRegex = new RegExp(regex_, flags_);
			lastRegex = regex_;
			lastFlags = flags_;
		}
		cacheRegex.lastIndex = 0;		// reset
		return cacheRegex;
	};
	SysCnds.prototype.RegexTest = function (str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		return regex.test(str_);
	};
	var tmp_arr = [];
	SysCnds.prototype.PickOverlappingPoint = function (obj_, x_, y_)
	{
		if (!obj_)
            return false;
        var sol = obj_.getCurrentSol();
        var instances = sol.getObjects();
		var current_event = this.runtime.getCurrentEventStack().current_event;
		var orblock = current_event.orblock;
		var cnd = this.runtime.getCurrentCondition();
		var i, len, inst, pick;
		if (sol.select_all)
		{
			cr.shallowAssignArray(tmp_arr, instances);
			sol.else_instances.length = 0;
			sol.select_all = false;
			sol.instances.length = 0;
		}
		else
		{
			if (orblock)
			{
				cr.shallowAssignArray(tmp_arr, sol.else_instances);
				sol.else_instances.length = 0;
			}
			else
			{
				cr.shallowAssignArray(tmp_arr, instances);
				sol.instances.length = 0;
			}
		}
		for (i = 0, len = tmp_arr.length; i < len; ++i)
		{
			inst = tmp_arr[i];
			inst.update_bbox();
			pick = cr.xor(inst.contains_pt(x_, y_), cnd.inverted);
			if (pick)
				sol.instances.push(inst);
			else
				sol.else_instances.push(inst);
		}
		obj_.applySolToContainer();
		return cr.xor(!!sol.instances.length, cnd.inverted);
	};
	sysProto.cnds = new SysCnds();
    function SysActs() {};
    SysActs.prototype.GoToLayout = function(to)
    {
		if (this.runtime.isloading)
			return;		// cannot change layout while loading on loader layout
		if (this.runtime.changelayout)
			return;		// already changing to a different layout
;
        this.runtime.changelayout = to;
    };
    SysActs.prototype.CreateObject = function (obj, layer, x, y)
    {
        if (!layer || !obj)
            return;
        var inst = this.runtime.createInstance(obj, layer, x, y);
		if (!inst)
			return;
		this.runtime.isInOnDestroy++;
		var i, len, s;
		this.runtime.trigger(Object.getPrototypeOf(obj.plugin).cnds.OnCreated, inst);
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				this.runtime.trigger(Object.getPrototypeOf(s.type.plugin).cnds.OnCreated, s);
			}
		}
		this.runtime.isInOnDestroy--;
        var sol = obj.getCurrentSol();
        sol.select_all = false;
		sol.instances.length = 1;
		sol.instances[0] = inst;
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				sol = s.type.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = s;
			}
		}
    };
    SysActs.prototype.SetLayerVisible = function (layer, visible_)
    {
        if (!layer)
            return;
		if (layer.visible !== visible_)
		{
			layer.visible = visible_;
			this.runtime.redraw = true;
		}
    };
	SysActs.prototype.SetLayerOpacity = function (layer, opacity_)
	{
		if (!layer)
			return;
		opacity_ = cr.clamp(opacity_ / 100, 0, 1);
		if (layer.opacity !== opacity_)
		{
			layer.opacity = opacity_;
			this.runtime.redraw = true;
		}
	};
	SysActs.prototype.SetLayerScaleRate = function (layer, sr)
	{
		if (!layer)
			return;
		if (layer.zoomRate !== sr)
		{
			layer.zoomRate = sr;
			this.runtime.redraw = true;
		}
	};
	SysActs.prototype.SetLayoutScale = function (s)
	{
		if (!this.runtime.running_layout)
			return;
		if (this.runtime.running_layout.scale !== s)
		{
			this.runtime.running_layout.scale = s;
			this.runtime.running_layout.boundScrolling();
			this.runtime.redraw = true;
		}
	};
    SysActs.prototype.ScrollX = function(x)
    {
        this.runtime.running_layout.scrollToX(x);
    };
    SysActs.prototype.ScrollY = function(y)
    {
        this.runtime.running_layout.scrollToY(y);
    };
    SysActs.prototype.Scroll = function(x, y)
    {
        this.runtime.running_layout.scrollToX(x);
        this.runtime.running_layout.scrollToY(y);
    };
    SysActs.prototype.ScrollToObject = function(obj)
    {
        var inst = obj.getFirstPicked();
        if (inst)
        {
            this.runtime.running_layout.scrollToX(inst.x);
            this.runtime.running_layout.scrollToY(inst.y);
        }
    };
	SysActs.prototype.SetVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(x);
			else
				v.setValue(parseFloat(x));
		}
		else if (v.vartype === 1)
			v.setValue(x.toString());
	};
	SysActs.prototype.AddVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(v.getValue() + x);
			else
				v.setValue(v.getValue() + parseFloat(x));
		}
		else if (v.vartype === 1)
			v.setValue(v.getValue() + x.toString());
	};
	SysActs.prototype.SubVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(v.getValue() - x);
			else
				v.setValue(v.getValue() - parseFloat(x));
		}
	};
    SysActs.prototype.SetGroupActive = function (group, active)
    {
		var g = this.runtime.groups_by_name[group.toLowerCase()];
		if (!g)
			return;
		switch (active) {
		case 0:
			g.setGroupActive(false);
			break;
		case 1:
			g.setGroupActive(true);
			break;
		case 2:
			g.setGroupActive(!g.group_active);
			break;
		}
    };
    SysActs.prototype.SetTimescale = function (ts_)
    {
        var ts = ts_;
        if (ts < 0)
            ts = 0;
        this.runtime.timescale = ts;
    };
    SysActs.prototype.SetObjectTimescale = function (obj, ts_)
    {
        var ts = ts_;
        if (ts < 0)
            ts = 0;
        if (!obj)
            return;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
        var i, len;
        for (i = 0, len = instances.length; i < len; i++)
        {
            instances[i].my_timescale = ts;
        }
    };
    SysActs.prototype.RestoreObjectTimescale = function (obj)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
        var i, len;
        for (i = 0, len = instances.length; i < len; i++)
        {
            instances[i].my_timescale = -1.0;
        }
    };
	var waitobjrecycle = [];
	function allocWaitObject()
	{
		var w;
		if (waitobjrecycle.length)
			w = waitobjrecycle.pop();
		else
		{
			w = {};
			w.sols = {};
			w.solModifiers = [];
		}
		w.deleteme = false;
		return w;
	};
	function freeWaitObject(w)
	{
		cr.wipe(w.sols);
		w.solModifiers.length = 0;
		waitobjrecycle.push(w);
	};
	var solstateobjects = [];
	function allocSolStateObject()
	{
		var s;
		if (solstateobjects.length)
			s = solstateobjects.pop();
		else
		{
			s = {};
			s.insts = [];
		}
		s.sa = false;
		return s;
	};
	function freeSolStateObject(s)
	{
		s.insts.length = 0;
		solstateobjects.push(s);
	};
	SysActs.prototype.Wait = function (seconds)
	{
		if (seconds < 0)
			return;
		var i, len, s, t, ss;
		var evinfo = this.runtime.getCurrentEventStack();
		var waitobj = allocWaitObject();
		waitobj.time = this.runtime.kahanTime.sum + seconds;
		waitobj.ev = evinfo.current_event;
		waitobj.actindex = evinfo.actindex + 1;	// pointing at next action
		for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
		{
			t = this.runtime.types_by_index[i];
			s = t.getCurrentSol();
			if (s.select_all && evinfo.current_event.solModifiers.indexOf(t) === -1)
				continue;
			waitobj.solModifiers.push(t);
			ss = allocSolStateObject();
			ss.sa = s.select_all;
			cr.shallowAssignArray(ss.insts, s.instances);
			waitobj.sols[i.toString()] = ss;
		}
		this.waits.push(waitobj);
		return true;
	};
	SysActs.prototype.SetLayerScale = function (layer, scale)
    {
        if (!layer)
            return;
		if (layer.scale === scale)
			return;
        layer.scale = scale;
        this.runtime.redraw = true;
    };
	SysActs.prototype.ResetGlobals = function ()
	{
		var i, len, g;
		for (i = 0, len = this.runtime.all_global_vars.length; i < len; i++)
		{
			g = this.runtime.all_global_vars[i];
			g.data = g.initial;
		}
	};
	SysActs.prototype.SetLayoutAngle = function (a)
	{
		a = cr.to_radians(a);
		a = cr.clamp_angle(a);
		if (this.runtime.running_layout)
		{
			if (this.runtime.running_layout.angle !== a)
			{
				this.runtime.running_layout.angle = a;
				this.runtime.redraw = true;
			}
		}
	};
	SysActs.prototype.SetLayerAngle = function (layer, a)
    {
        if (!layer)
            return;
		a = cr.to_radians(a);
		a = cr.clamp_angle(a);
		if (layer.angle === a)
			return;
        layer.angle = a;
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerParallax = function (layer, px, py)
    {
        if (!layer)
            return;
		if (layer.parallaxX === px / 100 && layer.parallaxY === py / 100)
			return;
        layer.parallaxX = px / 100;
		layer.parallaxY = py / 100;
		if (layer.parallaxX !== 1 || layer.parallaxY !== 1)
		{
			var i, len, instances = layer.instances;
			for (i = 0, len = instances.length; i < len; ++i)
			{
				instances[i].type.any_instance_parallaxed = true;
			}
		}
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerBackground = function (layer, c)
    {
        if (!layer)
            return;
		var r = cr.GetRValue(c);
		var g = cr.GetGValue(c);
		var b = cr.GetBValue(c);
		if (layer.background_color[0] === r && layer.background_color[1] === g && layer.background_color[2] === b)
			return;
        layer.background_color[0] = r;
		layer.background_color[1] = g;
		layer.background_color[2] = b;
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerTransparent = function (layer, t)
    {
        if (!layer)
            return;
		if (!!t === !!layer.transparent)
			return;
		layer.transparent = !!t;
        this.runtime.redraw = true;
    };
	SysActs.prototype.StopLoop = function ()
	{
		if (this.runtime.loop_stack_index < 0)
			return;		// no loop currently running
		this.runtime.getCurrentLoop().stopped = true;
	};
	SysActs.prototype.GoToLayoutByName = function (layoutname)
	{
		if (this.runtime.isloading)
			return;		// cannot change layout while loading on loader layout
		if (this.runtime.changelayout)
			return;		// already changing to different layout
;
		var l;
		for (l in this.runtime.layouts)
		{
			if (this.runtime.layouts.hasOwnProperty(l) && cr.equals_nocase(l, layoutname))
			{
				this.runtime.changelayout = this.runtime.layouts[l];
				return;
			}
		}
	};
	SysActs.prototype.RestartLayout = function (layoutname)
	{
		if (this.runtime.isloading)
			return;		// cannot restart loader layouts
		if (this.runtime.changelayout)
			return;		// already changing to a different layout
;
		if (!this.runtime.running_layout)
			return;
		this.runtime.changelayout = this.runtime.running_layout;
		var i, len, g;
		for (i = 0, len = this.runtime.allGroups.length; i < len; i++)
		{
			g = this.runtime.allGroups[i];
			g.setGroupActive(g.initially_activated);
		}
	};
	SysActs.prototype.SnapshotCanvas = function (format_, quality_)
	{
		this.runtime.snapshotCanvas = [format_ === 0 ? "image/png" : "image/jpeg", quality_ / 100];
		this.runtime.redraw = true;		// force redraw so snapshot is always taken
	};
	SysActs.prototype.SetCanvasSize = function (w, h)
	{
		if (w <= 0 || h <= 0)
			return;
		var mode = this.runtime.fullscreen_mode;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.runtime.isNodeFullscreen);
		if (isfullscreen && this.runtime.fullscreen_scaling > 0)
			mode = this.runtime.fullscreen_scaling;
		if (mode === 0)
		{
			this.runtime["setSize"](w, h, true);
		}
		else
		{
			this.runtime.original_width = w;
			this.runtime.original_height = h;
			this.runtime["setSize"](this.runtime.lastWindowWidth, this.runtime.lastWindowHeight, true);
		}
	};
	SysActs.prototype.SetLayoutEffectEnabled = function (enable_, effectname_)
	{
		if (!this.runtime.running_layout || !this.runtime.glwrap)
			return;
		var et = this.runtime.running_layout.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var enable = (enable_ === 1);
		if (et.active == enable)
			return;		// no change
		et.active = enable;
		this.runtime.running_layout.updateActiveEffects();
		this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayerEffectEnabled = function (layer, enable_, effectname_)
	{
		if (!layer || !this.runtime.glwrap)
			return;
		var et = layer.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var enable = (enable_ === 1);
		if (et.active == enable)
			return;		// no change
		et.active = enable;
		layer.updateActiveEffects();
		this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayoutEffectParam = function (effectname_, index_, value_)
	{
		if (!this.runtime.running_layout || !this.runtime.glwrap)
			return;
		var et = this.runtime.running_layout.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var params = this.runtime.running_layout.effect_params[et.index];
		index_ = Math.floor(index_);
		if (index_ < 0 || index_ >= params.length)
			return;		// effect index out of bounds
		if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
			value_ /= 100.0;
		if (params[index_] === value_)
			return;		// no change
		params[index_] = value_;
		if (et.active)
			this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayerEffectParam = function (layer, effectname_, index_, value_)
	{
		if (!layer || !this.runtime.glwrap)
			return;
		var et = layer.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var params = layer.effect_params[et.index];
		index_ = Math.floor(index_);
		if (index_ < 0 || index_ >= params.length)
			return;		// effect index out of bounds
		if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
			value_ /= 100.0;
		if (params[index_] === value_)
			return;		// no change
		params[index_] = value_;
		if (et.active)
			this.runtime.redraw = true;
	};
	SysActs.prototype.SaveState = function (slot_)
	{
		this.runtime.saveToSlot = slot_;
	};
	SysActs.prototype.LoadState = function (slot_)
	{
		this.runtime.loadFromSlot = slot_;
	};
	SysActs.prototype.LoadStateJSON = function (jsonstr_)
	{
		this.runtime.loadFromJson = jsonstr_;
	};
	SysActs.prototype.SetHalfFramerateMode = function (set_)
	{
		this.runtime.halfFramerateMode = (set_ !== 0);
	};
	SysActs.prototype.SetFullscreenQuality = function (q)
	{
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.isNodeFullscreen);
		if (!isfullscreen && this.runtime.fullscreen_mode === 0)
			return;
		this.runtime.wantFullscreenScalingQuality = (q !== 0);
		this.runtime["setSize"](this.runtime.lastWindowWidth, this.runtime.lastWindowHeight, true);
	};
	sysProto.acts = new SysActs();
    function SysExps() {};
    SysExps.prototype["int"] = function(ret, x)
    {
        if (cr.is_string(x))
        {
            ret.set_int(parseInt(x, 10));
            if (isNaN(ret.data))
                ret.data = 0;
        }
        else
            ret.set_int(x);
    };
    SysExps.prototype["float"] = function(ret, x)
    {
        if (cr.is_string(x))
        {
            ret.set_float(parseFloat(x));
            if (isNaN(ret.data))
                ret.data = 0;
        }
        else
            ret.set_float(x);
    };
    SysExps.prototype.str = function(ret, x)
    {
        if (cr.is_string(x))
            ret.set_string(x);
        else
            ret.set_string(x.toString());
    };
    SysExps.prototype.len = function(ret, x)
    {
        ret.set_int(x.length || 0);
    };
    SysExps.prototype.random = function (ret, a, b)
    {
        if (b === undefined)
        {
            ret.set_float(Math.random() * a);
        }
        else
        {
            ret.set_float(Math.random() * (b - a) + a);
        }
    };
    SysExps.prototype.sqrt = function(ret, x)
    {
        ret.set_float(Math.sqrt(x));
    };
    SysExps.prototype.abs = function(ret, x)
    {
        ret.set_float(Math.abs(x));
    };
    SysExps.prototype.round = function(ret, x)
    {
        ret.set_int(Math.round(x));
    };
    SysExps.prototype.floor = function(ret, x)
    {
        ret.set_int(Math.floor(x));
    };
    SysExps.prototype.ceil = function(ret, x)
    {
        ret.set_int(Math.ceil(x));
    };
    SysExps.prototype.sin = function(ret, x)
    {
        ret.set_float(Math.sin(cr.to_radians(x)));
    };
    SysExps.prototype.cos = function(ret, x)
    {
        ret.set_float(Math.cos(cr.to_radians(x)));
    };
    SysExps.prototype.tan = function(ret, x)
    {
        ret.set_float(Math.tan(cr.to_radians(x)));
    };
    SysExps.prototype.asin = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.asin(x)));
    };
    SysExps.prototype.acos = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.acos(x)));
    };
    SysExps.prototype.atan = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.atan(x)));
    };
    SysExps.prototype.exp = function(ret, x)
    {
        ret.set_float(Math.exp(x));
    };
    SysExps.prototype.ln = function(ret, x)
    {
        ret.set_float(Math.log(x));
    };
    SysExps.prototype.log10 = function(ret, x)
    {
        ret.set_float(Math.log(x) / Math.LN10);
    };
    SysExps.prototype.max = function(ret)
    {
		var max_ = arguments[1];
		var i, len;
		for (i = 2, len = arguments.length; i < len; i++)
		{
			if (max_ < arguments[i])
				max_ = arguments[i];
		}
		ret.set_float(max_);
    };
    SysExps.prototype.min = function(ret)
    {
        var min_ = arguments[1];
		var i, len;
		for (i = 2, len = arguments.length; i < len; i++)
		{
			if (min_ > arguments[i])
				min_ = arguments[i];
		}
		ret.set_float(min_);
    };
    SysExps.prototype.dt = function(ret)
    {
        ret.set_float(this.runtime.dt);
    };
    SysExps.prototype.timescale = function(ret)
    {
        ret.set_float(this.runtime.timescale);
    };
    SysExps.prototype.wallclocktime = function(ret)
    {
        ret.set_float((Date.now() - this.runtime.start_time) / 1000.0);
    };
    SysExps.prototype.time = function(ret)
    {
        ret.set_float(this.runtime.kahanTime.sum);
    };
    SysExps.prototype.tickcount = function(ret)
    {
        ret.set_int(this.runtime.tickcount);
    };
    SysExps.prototype.objectcount = function(ret)
    {
        ret.set_int(this.runtime.objectcount);
    };
    SysExps.prototype.fps = function(ret)
    {
        ret.set_int(this.runtime.fps);
    };
    SysExps.prototype.loopindex = function(ret, name_)
    {
		var loop, i, len;
        if (!this.runtime.loop_stack.length)
        {
            ret.set_int(0);
            return;
        }
        if (name_)
        {
            for (i = 0, len = this.runtime.loop_stack.length; i < len; i++)
            {
                loop = this.runtime.loop_stack[i];
                if (loop.name === name_)
                {
                    ret.set_int(loop.index);
                    return;
                }
            }
            ret.set_int(0);
        }
        else
        {
			loop = this.runtime.getCurrentLoop();
			ret.set_int(loop ? loop.index : -1);
        }
    };
    SysExps.prototype.distance = function(ret, x1, y1, x2, y2)
    {
        ret.set_float(cr.distanceTo(x1, y1, x2, y2));
    };
    SysExps.prototype.angle = function(ret, x1, y1, x2, y2)
    {
        ret.set_float(cr.to_degrees(cr.angleTo(x1, y1, x2, y2)));
    };
    SysExps.prototype.scrollx = function(ret)
    {
        ret.set_float(this.runtime.running_layout.scrollX);
    };
    SysExps.prototype.scrolly = function(ret)
    {
        ret.set_float(this.runtime.running_layout.scrollY);
    };
    SysExps.prototype.newline = function(ret)
    {
        ret.set_string("\n");
    };
    SysExps.prototype.lerp = function(ret, a, b, x)
    {
        ret.set_float(cr.lerp(a, b, x));
    };
    SysExps.prototype.windowwidth = function(ret)
    {
        ret.set_int(this.runtime.width);
    };
    SysExps.prototype.windowheight = function(ret)
    {
        ret.set_int(this.runtime.height);
    };
	SysExps.prototype.uppercase = function(ret, str)
	{
		ret.set_string(cr.is_string(str) ? str.toUpperCase() : "");
	};
	SysExps.prototype.lowercase = function(ret, str)
	{
		ret.set_string(cr.is_string(str) ? str.toLowerCase() : "");
	};
	SysExps.prototype.clamp = function(ret, x, l, u)
	{
		if (x < l)
			ret.set_float(l);
		else if (x > u)
			ret.set_float(u);
		else
			ret.set_float(x);
	};
	SysExps.prototype.layerscale = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.scale);
	};
	SysExps.prototype.layeropacity = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.opacity * 100);
	};
	SysExps.prototype.layerscalerate = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.zoomRate);
	};
	SysExps.prototype.layerparallaxx = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.parallaxX * 100);
	};
	SysExps.prototype.layerparallaxy = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.parallaxY * 100);
	};
	SysExps.prototype.layoutscale = function (ret)
	{
		if (this.runtime.running_layout)
			ret.set_float(this.runtime.running_layout.scale);
		else
			ret.set_float(0);
	};
	SysExps.prototype.layoutangle = function (ret)
	{
		ret.set_float(cr.to_degrees(this.runtime.running_layout.angle));
	};
	SysExps.prototype.layerangle = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(cr.to_degrees(layer.angle));
	};
	SysExps.prototype.layoutwidth = function (ret)
	{
		ret.set_int(this.runtime.running_layout.width);
	};
	SysExps.prototype.layoutheight = function (ret)
	{
		ret.set_int(this.runtime.running_layout.height);
	};
	SysExps.prototype.find = function (ret, text, searchstr)
	{
		if (cr.is_string(text) && cr.is_string(searchstr))
			ret.set_int(text.search(new RegExp(cr.regexp_escape(searchstr), "i")));
		else
			ret.set_int(-1);
	};
	SysExps.prototype.left = function (ret, text, n)
	{
		ret.set_string(cr.is_string(text) ? text.substr(0, n) : "");
	};
	SysExps.prototype.right = function (ret, text, n)
	{
		ret.set_string(cr.is_string(text) ? text.substr(text.length - n) : "");
	};
	SysExps.prototype.mid = function (ret, text, index_, length_)
	{
		ret.set_string(cr.is_string(text) ? text.substr(index_, length_) : "");
	};
	SysExps.prototype.tokenat = function (ret, text, index_, sep)
	{
		if (cr.is_string(text) && cr.is_string(sep))
		{
			var arr = text.split(sep);
			var i = cr.floor(index_);
			if (i < 0 || i >= arr.length)
				ret.set_string("");
			else
				ret.set_string(arr[i]);
		}
		else
			ret.set_string("");
	};
	SysExps.prototype.tokencount = function (ret, text, sep)
	{
		if (cr.is_string(text) && text.length)
			ret.set_int(text.split(sep).length);
		else
			ret.set_int(0);
	};
	SysExps.prototype.replace = function (ret, text, find_, replace_)
	{
		if (cr.is_string(text) && cr.is_string(find_) && cr.is_string(replace_))
			ret.set_string(text.replace(new RegExp(cr.regexp_escape(find_), "gi"), replace_));
		else
			ret.set_string(cr.is_string(text) ? text : "");
	};
	SysExps.prototype.trim = function (ret, text)
	{
		ret.set_string(cr.is_string(text) ? text.trim() : "");
	};
	SysExps.prototype.pi = function (ret)
	{
		ret.set_float(cr.PI);
	};
	SysExps.prototype.layoutname = function (ret)
	{
		if (this.runtime.running_layout)
			ret.set_string(this.runtime.running_layout.name);
		else
			ret.set_string("");
	};
	SysExps.prototype.renderer = function (ret)
	{
		ret.set_string(this.runtime.gl ? "webgl" : "canvas2d");
	};
	SysExps.prototype.anglediff = function (ret, a, b)
	{
		ret.set_float(cr.to_degrees(cr.angleDiff(cr.to_radians(a), cr.to_radians(b))));
	};
	SysExps.prototype.choose = function (ret)
	{
		var index = cr.floor(Math.random() * (arguments.length - 1));
		ret.set_any(arguments[index + 1]);
	};
	SysExps.prototype.rgb = function (ret, r, g, b)
	{
		ret.set_int(cr.RGB(r, g, b));
	};
	SysExps.prototype.projectversion = function (ret)
	{
		ret.set_string(this.runtime.versionstr);
	};
	SysExps.prototype.anglelerp = function (ret, a, b, x)
	{
		a = cr.to_radians(a);
		b = cr.to_radians(b);
		var diff = cr.angleDiff(a, b);
		if (cr.angleClockwise(b, a))
		{
			ret.set_float(cr.to_clamped_degrees(a + diff * x));
		}
		else
		{
			ret.set_float(cr.to_clamped_degrees(a - diff * x));
		}
	};
	SysExps.prototype.anglerotate = function (ret, a, b, c)
	{
		a = cr.to_radians(a);
		b = cr.to_radians(b);
		c = cr.to_radians(c);
		ret.set_float(cr.to_clamped_degrees(cr.angleRotate(a, b, c)));
	};
	SysExps.prototype.zeropad = function (ret, n, d)
	{
		var s = (n < 0 ? "-" : "");
		if (n < 0) n = -n;
		var zeroes = d - n.toString().length;
		for (var i = 0; i < zeroes; i++)
			s += "0";
		ret.set_string(s + n.toString());
	};
	SysExps.prototype.cpuutilisation = function (ret)
	{
		ret.set_float(this.runtime.cpuutilisation / 1000);
	};
	SysExps.prototype.viewportleft = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewLeft : 0);
	};
	SysExps.prototype.viewporttop = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewTop : 0);
	};
	SysExps.prototype.viewportright = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewRight : 0);
	};
	SysExps.prototype.viewportbottom = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewBottom : 0);
	};
	SysExps.prototype.loadingprogress = function (ret)
	{
		ret.set_float(this.runtime.loadingprogress);
	};
	SysExps.prototype.unlerp = function(ret, a, b, y)
    {
        ret.set_float(cr.unlerp(a, b, y));
    };
	SysExps.prototype.canvassnapshot = function (ret)
	{
		ret.set_string(this.runtime.snapshotData);
	};
	SysExps.prototype.urlencode = function (ret, s)
	{
		ret.set_string(encodeURIComponent(s));
	};
	SysExps.prototype.urldecode = function (ret, s)
	{
		ret.set_string(decodeURIComponent(s));
	};
	SysExps.prototype.canvastolayerx = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.canvasToLayer(x, y, true) : 0);
	};
	SysExps.prototype.canvastolayery = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.canvasToLayer(x, y, false) : 0);
	};
	SysExps.prototype.layertocanvasx = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.layerToCanvas(x, y, true) : 0);
	};
	SysExps.prototype.layertocanvasy = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.layerToCanvas(x, y, false) : 0);
	};
	SysExps.prototype.savestatejson = function (ret)
	{
		ret.set_string(this.runtime.lastSaveJson);
	};
	SysExps.prototype.imagememoryusage = function (ret)
	{
		if (this.runtime.glwrap)
			ret.set_float(Math.round(100 * this.runtime.glwrap.estimateVRAM() / (1024 * 1024)) / 100);
		else
			ret.set_float(0);
	};
	SysExps.prototype.regexsearch = function (ret, str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		ret.set_int(str_ ? str_.search(regex) : -1);
	};
	SysExps.prototype.regexreplace = function (ret, str_, regex_, flags_, replace_)
	{
		var regex = getRegex(regex_, flags_);
		ret.set_string(str_ ? str_.replace(regex, replace_) : "");
	};
	var regexMatches = [];
	var lastMatchesStr = "";
	var lastMatchesRegex = "";
	var lastMatchesFlags = "";
	function updateRegexMatches(str_, regex_, flags_)
	{
		if (str_ === lastMatchesStr && regex_ === lastMatchesRegex && flags_ === lastMatchesFlags)
			return;
		var regex = getRegex(regex_, flags_);
		regexMatches = str_.match(regex);
		lastMatchesStr = str_;
		lastMatchesRegex = regex_;
		lastMatchesFlags = flags_;
	};
	SysExps.prototype.regexmatchcount = function (ret, str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		updateRegexMatches(str_, regex_, flags_);
		ret.set_int(regexMatches ? regexMatches.length : 0);
	};
	SysExps.prototype.regexmatchat = function (ret, str_, regex_, flags_, index_)
	{
		index_ = Math.floor(index_);
		var regex = getRegex(regex_, flags_);
		updateRegexMatches(str_, regex_, flags_);
		if (!regexMatches || index_ < 0 || index_ >= regexMatches.length)
			ret.set_string("");
		else
			ret.set_string(regexMatches[index_]);
	};
	SysExps.prototype.infinity = function (ret)
	{
		ret.set_float(Infinity);
	};
	SysExps.prototype.setbit = function (ret, n, b, v)
	{
		n = n | 0;
		b = b | 0;
		v = (v !== 0 ? 1 : 0);
		ret.set_int((n & ~(1 << b)) | (v << b));
	};
	SysExps.prototype.togglebit = function (ret, n, b)
	{
		n = n | 0;
		b = b | 0;
		ret.set_int(n ^ (1 << b));
	};
	SysExps.prototype.getbit = function (ret, n, b)
	{
		n = n | 0;
		b = b | 0;
		ret.set_int((n & (1 << b)) ? 1 : 0);
	};
	sysProto.exps = new SysExps();
	sysProto.runWaits = function ()
	{
		var i, j, len, w, k, s, ss;
		var evinfo = this.runtime.getCurrentEventStack();
		for (i = 0, len = this.waits.length; i < len; i++)
		{
			w = this.waits[i];
			if (w.time > this.runtime.kahanTime.sum)
				continue;
			evinfo.current_event = w.ev;
			evinfo.actindex = w.actindex;
			evinfo.cndindex = 0;
			for (k in w.sols)
			{
				if (w.sols.hasOwnProperty(k))
				{
					s = this.runtime.types_by_index[parseInt(k, 10)].getCurrentSol();
					ss = w.sols[k];
					s.select_all = ss.sa;
					cr.shallowAssignArray(s.instances, ss.insts);
					freeSolStateObject(ss);
				}
			}
			w.ev.resume_actions_and_subevents();
			this.runtime.clearSol(w.solModifiers);
			w.deleteme = true;
		}
		for (i = 0, j = 0, len = this.waits.length; i < len; i++)
		{
			w = this.waits[i];
			this.waits[j] = w;
			if (w.deleteme)
				freeWaitObject(w);
			else
				j++;
		}
		this.waits.length = j;
	};
}());
;
(function () {
	cr.add_common_aces = function (m)
	{
		var pluginProto = m[0].prototype;
		var singleglobal_ = m[1];
		var position_aces = m[3];
		var size_aces = m[4];
		var angle_aces = m[5];
		var appearance_aces = m[6];
		var zorder_aces = m[7];
		var effects_aces = m[8];
		if (!pluginProto.cnds)
			pluginProto.cnds = {};
		if (!pluginProto.acts)
			pluginProto.acts = {};
		if (!pluginProto.exps)
			pluginProto.exps = {};
		var cnds = pluginProto.cnds;
		var acts = pluginProto.acts;
		var exps = pluginProto.exps;
		if (position_aces)
		{
			cnds.CompareX = function (cmp, x)
			{
				return cr.do_cmp(this.x, cmp, x);
			};
			cnds.CompareY = function (cmp, y)
			{
				return cr.do_cmp(this.y, cmp, y);
			};
			cnds.IsOnScreen = function ()
			{
				var layer = this.layer;
				this.update_bbox();
				var bbox = this.bbox;
				return !(bbox.right < layer.viewLeft || bbox.bottom < layer.viewTop || bbox.left > layer.viewRight || bbox.top > layer.viewBottom);
			};
			cnds.IsOutsideLayout = function ()
			{
				this.update_bbox();
				var bbox = this.bbox;
				var layout = this.runtime.running_layout;
				return (bbox.right < 0 || bbox.bottom < 0 || bbox.left > layout.width || bbox.top > layout.height);
			};
			cnds.PickDistance = function (which, x, y)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var dist = cr.distanceTo(inst.x, inst.y, x, y);
				var i, len, d;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					d = cr.distanceTo(inst.x, inst.y, x, y);
					if ((which === 0 && d < dist) || (which === 1 && d > dist))
					{
						dist = d;
						pickme = inst;
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			acts.SetX = function (x)
			{
				if (this.x !== x)
				{
					this.x = x;
					this.set_bbox_changed();
				}
			};
			acts.SetY = function (y)
			{
				if (this.y !== y)
				{
					this.y = y;
					this.set_bbox_changed();
				}
			};
			acts.SetPos = function (x, y)
			{
				if (this.x !== x || this.y !== y)
				{
					this.x = x;
					this.y = y;
					this.set_bbox_changed();
				}
			};
			acts.SetPosToObject = function (obj, imgpt)
			{
				var inst = obj.getPairedInstance(this);
				if (!inst)
					return;
				var newx, newy;
				if (inst.getImagePoint)
				{
					newx = inst.getImagePoint(imgpt, true);
					newy = inst.getImagePoint(imgpt, false);
				}
				else
				{
					newx = inst.x;
					newy = inst.y;
				}
				if (this.x !== newx || this.y !== newy)
				{
					this.x = newx;
					this.y = newy;
					this.set_bbox_changed();
				}
			};
			acts.MoveForward = function (dist)
			{
				if (dist !== 0)
				{
					this.x += Math.cos(this.angle) * dist;
					this.y += Math.sin(this.angle) * dist;
					this.set_bbox_changed();
				}
			};
			acts.MoveAtAngle = function (a, dist)
			{
				if (dist !== 0)
				{
					this.x += Math.cos(cr.to_radians(a)) * dist;
					this.y += Math.sin(cr.to_radians(a)) * dist;
					this.set_bbox_changed();
				}
			};
			exps.X = function (ret)
			{
				ret.set_float(this.x);
			};
			exps.Y = function (ret)
			{
				ret.set_float(this.y);
			};
			exps.dt = function (ret)
			{
				ret.set_float(this.runtime.getDt(this));
			};
		}
		if (size_aces)
		{
			cnds.CompareWidth = function (cmp, w)
			{
				return cr.do_cmp(this.width, cmp, w);
			};
			cnds.CompareHeight = function (cmp, h)
			{
				return cr.do_cmp(this.height, cmp, h);
			};
			acts.SetWidth = function (w)
			{
				if (this.width !== w)
				{
					this.width = w;
					this.set_bbox_changed();
				}
			};
			acts.SetHeight = function (h)
			{
				if (this.height !== h)
				{
					this.height = h;
					this.set_bbox_changed();
				}
			};
			acts.SetSize = function (w, h)
			{
				if (this.width !== w || this.height !== h)
				{
					this.width = w;
					this.height = h;
					this.set_bbox_changed();
				}
			};
			exps.Width = function (ret)
			{
				ret.set_float(this.width);
			};
			exps.Height = function (ret)
			{
				ret.set_float(this.height);
			};
			exps.BBoxLeft = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.left);
			};
			exps.BBoxTop = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.top);
			};
			exps.BBoxRight = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.right);
			};
			exps.BBoxBottom = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.bottom);
			};
		}
		if (angle_aces)
		{
			cnds.AngleWithin = function (within, a)
			{
				return cr.angleDiff(this.angle, cr.to_radians(a)) <= cr.to_radians(within);
			};
			cnds.IsClockwiseFrom = function (a)
			{
				return cr.angleClockwise(this.angle, cr.to_radians(a));
			};
			cnds.IsBetweenAngles = function (a, b)
			{
				var lower = cr.to_clamped_radians(a);
				var upper = cr.to_clamped_radians(b);
				var angle = cr.clamp_angle(this.angle);
				var obtuse = (!cr.angleClockwise(upper, lower));
				if (obtuse)
					return !(!cr.angleClockwise(angle, lower) && cr.angleClockwise(angle, upper));
				else
					return cr.angleClockwise(angle, lower) && !cr.angleClockwise(angle, upper);
			};
			acts.SetAngle = function (a)
			{
				var newangle = cr.to_radians(cr.clamp_angle_degrees(a));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.RotateClockwise = function (a)
			{
				if (a !== 0 && !isNaN(a))
				{
					this.angle += cr.to_radians(a);
					this.angle = cr.clamp_angle(this.angle);
					this.set_bbox_changed();
				}
			};
			acts.RotateCounterclockwise = function (a)
			{
				if (a !== 0 && !isNaN(a))
				{
					this.angle -= cr.to_radians(a);
					this.angle = cr.clamp_angle(this.angle);
					this.set_bbox_changed();
				}
			};
			acts.RotateTowardAngle = function (amt, target)
			{
				var newangle = cr.angleRotate(this.angle, cr.to_radians(target), cr.to_radians(amt));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.RotateTowardPosition = function (amt, x, y)
			{
				var dx = x - this.x;
				var dy = y - this.y;
				var target = Math.atan2(dy, dx);
				var newangle = cr.angleRotate(this.angle, target, cr.to_radians(amt));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.SetTowardPosition = function (x, y)
			{
				var dx = x - this.x;
				var dy = y - this.y;
				var newangle = Math.atan2(dy, dx);
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			exps.Angle = function (ret)
			{
				ret.set_float(cr.to_clamped_degrees(this.angle));
			};
		}
		if (!singleglobal_)
		{
			cnds.CompareInstanceVar = function (iv, cmp, val)
			{
				return cr.do_cmp(this.instance_vars[iv], cmp, val);
			};
			cnds.IsBoolInstanceVarSet = function (iv)
			{
				return this.instance_vars[iv];
			};
			cnds.PickInstVarHiLow = function (which, iv)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var val = inst.instance_vars[iv];
				var i, len, v;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					v = inst.instance_vars[iv];
					if ((which === 0 && v < val) || (which === 1 && v > val))
					{
						val = v;
						pickme = inst;
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			cnds.PickByUID = function (u)
			{
				var i, len, j, inst, families, instances, sol;
				var cnd = this.runtime.getCurrentCondition();
				if (cnd.inverted)
				{
					sol = this.getCurrentSol();
					if (sol.select_all)
					{
						sol.select_all = false;
						sol.instances.length = 0;
						sol.else_instances.length = 0;
						instances = this.instances;
						for (i = 0, len = instances.length; i < len; i++)
						{
							inst = instances[i];
							if (inst.uid === u)
								sol.else_instances.push(inst);
							else
								sol.instances.push(inst);
						}
						this.applySolToContainer();
						return !!sol.instances.length;
					}
					else
					{
						for (i = 0, j = 0, len = sol.instances.length; i < len; i++)
						{
							inst = sol.instances[i];
							sol.instances[j] = inst;
							if (inst.uid === u)
							{
								sol.else_instances.push(inst);
							}
							else
								j++;
						}
						sol.instances.length = j;
						this.applySolToContainer();
						return !!sol.instances.length;
					}
				}
				else
				{
					inst = this.runtime.getObjectByUID(u);
					if (!inst)
						return false;
					sol = this.getCurrentSol();
					if (!sol.select_all && sol.instances.indexOf(inst) === -1)
						return false;		// not picked
					if (this.is_family)
					{
						families = inst.type.families;
						for (i = 0, len = families.length; i < len; i++)
						{
							if (families[i] === this)
							{
								sol.pick_one(inst);
								this.applySolToContainer();
								return true;
							}
						}
					}
					else if (inst.type === this)
					{
						sol.pick_one(inst);
						this.applySolToContainer();
						return true;
					}
					return false;
				}
			};
			cnds.OnCreated = function ()
			{
				return true;
			};
			cnds.OnDestroyed = function ()
			{
				return true;
			};
			acts.SetInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] = val;
					else
						myinstvars[iv] = parseFloat(val);
				}
				else if (cr.is_string(myinstvars[iv]))
				{
					if (cr.is_string(val))
						myinstvars[iv] = val;
					else
						myinstvars[iv] = val.toString();
				}
				else
;
			};
			acts.AddInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] += val;
					else
						myinstvars[iv] += parseFloat(val);
				}
				else if (cr.is_string(myinstvars[iv]))
				{
					if (cr.is_string(val))
						myinstvars[iv] += val;
					else
						myinstvars[iv] += val.toString();
				}
				else
;
			};
			acts.SubInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] -= val;
					else
						myinstvars[iv] -= parseFloat(val);
				}
				else
;
			};
			acts.SetBoolInstanceVar = function (iv, val)
			{
				this.instance_vars[iv] = val ? 1 : 0;
			};
			acts.ToggleBoolInstanceVar = function (iv)
			{
				this.instance_vars[iv] = 1 - this.instance_vars[iv];
			};
			acts.Destroy = function ()
			{
				this.runtime.DestroyInstance(this);
			};
			if (!acts.LoadFromJsonString)
			{
				acts.LoadFromJsonString = function (str_)
				{
					var o, i, len, binst;
					try {
						o = JSON.parse(str_);
					}
					catch (e) {
						return;
					}
					this.runtime.loadInstanceFromJSON(this, o, true);
					if (this.afterLoad)
						this.afterLoad();
					if (this.behavior_insts)
					{
						for (i = 0, len = this.behavior_insts.length; i < len; ++i)
						{
							binst = this.behavior_insts[i];
							if (binst.afterLoad)
								binst.afterLoad();
						}
					}
				};
			}
			exps.Count = function (ret)
			{
				var count = ret.object_class.instances.length;
				var i, len, inst;
				for (i = 0, len = this.runtime.createRow.length; i < len; i++)
				{
					inst = this.runtime.createRow[i];
					if (ret.object_class.is_family)
					{
						if (inst.type.families.indexOf(ret.object_class) >= 0)
							count++;
					}
					else
					{
						if (inst.type === ret.object_class)
							count++;
					}
				}
				ret.set_int(count);
			};
			exps.PickedCount = function (ret)
			{
				ret.set_int(ret.object_class.getCurrentSol().getObjects().length);
			};
			exps.UID = function (ret)
			{
				ret.set_int(this.uid);
			};
			exps.IID = function (ret)
			{
				ret.set_int(this.get_iid());
			};
			if (!exps.AsJSON)
			{
				exps.AsJSON = function (ret)
				{
					ret.set_string(JSON.stringify(this.runtime.saveInstanceToJSON(this, true)));
				};
			}
		}
		if (appearance_aces)
		{
			cnds.IsVisible = function ()
			{
				return this.visible;
			};
			acts.SetVisible = function (v)
			{
				if (!v !== !this.visible)
				{
					this.visible = v;
					this.runtime.redraw = true;
				}
			};
			cnds.CompareOpacity = function (cmp, x)
			{
				return cr.do_cmp(cr.round6dp(this.opacity * 100), cmp, x);
			};
			acts.SetOpacity = function (x)
			{
				var new_opacity = x / 100.0;
				if (new_opacity < 0)
					new_opacity = 0;
				else if (new_opacity > 1)
					new_opacity = 1;
				if (new_opacity !== this.opacity)
				{
					this.opacity = new_opacity;
					this.runtime.redraw = true;
				}
			};
			exps.Opacity = function (ret)
			{
				ret.set_float(cr.round6dp(this.opacity * 100.0));
			};
		}
		if (zorder_aces)
		{
			cnds.IsOnLayer = function (layer_)
			{
				if (!layer_)
					return false;
				return this.layer === layer_;
			};
			cnds.PickTopBottom = function (which_)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var i, len;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					if (which_ === 0)
					{
						if (inst.layer.index > pickme.layer.index || (inst.layer.index === pickme.layer.index && inst.get_zindex() > pickme.get_zindex()))
						{
							pickme = inst;
						}
					}
					else
					{
						if (inst.layer.index < pickme.layer.index || (inst.layer.index === pickme.layer.index && inst.get_zindex() < pickme.get_zindex()))
						{
							pickme = inst;
						}
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			acts.MoveToTop = function ()
			{
				var zindex = this.get_zindex();
				if (zindex === this.layer.instances.length - 1)
					return;
				cr.arrayRemove(this.layer.instances, zindex);
				this.layer.instances.push(this);
				this.runtime.redraw = true;
				this.layer.zindices_stale = true;
			};
			acts.MoveToBottom = function ()
			{
				var zindex = this.get_zindex();
				if (zindex === 0)
					return;
				cr.arrayRemove(this.layer.instances, zindex);
				this.layer.instances.unshift(this);
				this.runtime.redraw = true;
				this.layer.zindices_stale = true;
			};
			acts.MoveToLayer = function (layerMove)
			{
				if (!layerMove || layerMove == this.layer)
					return;
				cr.arrayRemove(this.layer.instances, this.get_zindex());
				this.layer.zindices_stale = true;
				this.layer = layerMove;
				this.zindex = layerMove.instances.length;
				layerMove.instances.push(this);
				this.runtime.redraw = true;
			};
			acts.ZMoveToObject = function (where_, obj_)
			{
				var isafter = (where_ === 0);
				if (!obj_)
					return;
				var other = obj_.getFirstPicked(this);
				if (!other || other.uid === this.uid)
					return;
				if (this.layer.index !== other.layer.index)
				{
					cr.arrayRemove(this.layer.instances, this.get_zindex());
					this.layer.zindices_stale = true;
					this.layer = other.layer;
					this.zindex = other.layer.instances.length;
					other.layer.instances.push(this);
				}
				var myZ = this.get_zindex();
				var insertZ = other.get_zindex();
				cr.arrayRemove(this.layer.instances, myZ);
				if (myZ < insertZ)
					insertZ--;
				if (isafter)
					insertZ++;
				if (insertZ === this.layer.instances.length)
					this.layer.instances.push(this);
				else
					this.layer.instances.splice(insertZ, 0, this);
				this.layer.zindices_stale = true;
				this.runtime.redraw = true;
			};
			exps.LayerNumber = function (ret)
			{
				ret.set_int(this.layer.number);
			};
			exps.LayerName = function (ret)
			{
				ret.set_string(this.layer.name);
			};
			exps.ZIndex = function (ret)
			{
				ret.set_int(this.get_zindex());
			};
		}
		if (effects_aces)
		{
			acts.SetEffectEnabled = function (enable_, effectname_)
			{
				if (!this.runtime.glwrap)
					return;
				var i = this.type.getEffectIndexByName(effectname_);
				if (i < 0)
					return;		// effect name not found
				var enable = (enable_ === 1);
				if (this.active_effect_flags[i] === enable)
					return;		// no change
				this.active_effect_flags[i] = enable;
				this.updateActiveEffects();
				this.runtime.redraw = true;
			};
			acts.SetEffectParam = function (effectname_, index_, value_)
			{
				if (!this.runtime.glwrap)
					return;
				var i = this.type.getEffectIndexByName(effectname_);
				if (i < 0)
					return;		// effect name not found
				var et = this.type.effect_types[i];
				var params = this.effect_params[i];
				index_ = Math.floor(index_);
				if (index_ < 0 || index_ >= params.length)
					return;		// effect index out of bounds
				if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
					value_ /= 100.0;
				if (params[index_] === value_)
					return;		// no change
				params[index_] = value_;
				if (et.active)
					this.runtime.redraw = true;
			};
		}
	};
	cr.set_bbox_changed = function ()
	{
		this.bbox_changed = true;      		// will recreate next time box requested
		this.cell_changed = true;
		this.type.any_cell_changed = true;	// avoid unnecessary updateAllBBox() calls
		this.runtime.redraw = true;     	// assume runtime needs to redraw
		var i, len, callbacks = this.bbox_changed_callbacks;
		for (i = 0, len = callbacks.length; i < len; ++i)
		{
			callbacks[i](this);
		}
	};
	cr.add_bbox_changed_callback = function (f)
	{
		if (f)
		{
			this.bbox_changed_callbacks.push(f);
		}
	};
	cr.update_bbox = function ()
	{
		if (!this.bbox_changed)
			return;                 // bounding box not changed
		var bbox = this.bbox;
		var bquad = this.bquad;
		bbox.set(this.x, this.y, this.x + this.width, this.y + this.height);
		bbox.offset(-this.hotspotX * this.width, -this.hotspotY * this.height);
		if (!this.angle)
		{
			bquad.set_from_rect(bbox);    // make bounding quad from box
		}
		else
		{
			bbox.offset(-this.x, -this.y);       			// translate to origin
			bquad.set_from_rotated_rect(bbox, this.angle);	// rotate around origin
			bquad.offset(this.x, this.y);      				// translate back to original position
			bquad.bounding_box(bbox);
		}
		bbox.normalize();
		this.bbox_changed = false;  // bounding box up to date
	};
	var tmprc = new cr.rect(0, 0, 0, 0);
	cr.update_collision_cell = function ()
	{
		if (!this.cell_changed || !this.collisionsEnabled)
			return;
		this.update_bbox();
		var mygrid = this.type.collision_grid;
		var collcells = this.collcells;
		var bbox = this.bbox;
		tmprc.set(mygrid.XToCell(bbox.left), mygrid.YToCell(bbox.top), mygrid.XToCell(bbox.right), mygrid.YToCell(bbox.bottom));
		if (collcells.equals(tmprc))
			return;
		if (collcells.right < collcells.left)
			mygrid.update(this, null, tmprc);		// first insertion with invalid rect: don't provide old range
		else
			mygrid.update(this, collcells, tmprc);
		collcells.copy(tmprc);
		this.cell_changed = false;
	};
	cr.inst_contains_pt = function (x, y)
	{
		if (!this.bbox.contains_pt(x, y))
			return false;
		if (!this.bquad.contains_pt(x, y))
			return false;
		if (this.collision_poly && !this.collision_poly.is_empty())
		{
			this.collision_poly.cache_poly(this.width, this.height, this.angle);
			return this.collision_poly.contains_pt(x - this.x, y - this.y);
		}
		else
			return true;
	};
	cr.inst_get_iid = function ()
	{
		this.type.updateIIDs();
		return this.iid;
	};
	cr.inst_get_zindex = function ()
	{
		this.layer.updateZIndices();
		return this.zindex;
	};
	cr.inst_updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et, inst;
		for (i = 0, len = this.active_effect_flags.length; i < len; i++)
		{
			if (this.active_effect_flags[i])
				this.active_effect_types.push(this.type.effect_types[i]);
		}
		this.uses_shaders = !!this.active_effect_types.length;
	};
	cr.inst_toString = function ()
	{
		return "Inst" + this.puid;
	};
	cr.type_getFirstPicked = function (frominst)
	{
		if (frominst && frominst.is_contained && frominst.type != this)
		{
			var i, len, s;
			for (i = 0, len = frominst.siblings.length; i < len; i++)
			{
				s = frominst.siblings[i];
				if (s.type == this)
					return s;
			}
		}
		var instances = this.getCurrentSol().getObjects();
		if (instances.length)
			return instances[0];
		else
			return null;
	};
	cr.type_getPairedInstance = function (inst)
	{
		var instances = this.getCurrentSol().getObjects();
		if (instances.length)
			return instances[inst.get_iid() % instances.length];
		else
			return null;
	};
	cr.type_updateIIDs = function ()
	{
		if (!this.stale_iids || this.is_family)
			return;		// up to date or is family - don't want family to overwrite IIDs
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].iid = i;
		var next_iid = i;
		var createRow = this.runtime.createRow;
		for (i = 0, len = createRow.length; i < len; ++i)
		{
			if (createRow[i].type === this)
				createRow[i].iid = next_iid++;
		}
		this.stale_iids = false;
	};
	cr.type_getInstanceByIID = function (i)
	{
		if (i < this.instances.length)
			return this.instances[i];
		i -= this.instances.length;
		var createRow = this.runtime.createRow;
		var j, lenj;
		for (j = 0, lenj = createRow.length; j < lenj; ++j)
		{
			if (createRow[j].type === this)
			{
				if (i === 0)
					return createRow[j];
				--i;
			}
		}
;
		return null;
	};
	cr.type_getCurrentSol = function ()
	{
		return this.solstack[this.cur_sol];
	};
	cr.type_pushCleanSol = function ()
	{
		this.cur_sol++;
		if (this.cur_sol === this.solstack.length)
			this.solstack.push(new cr.selection(this));
		else
			this.solstack[this.cur_sol].select_all = true;  // else clear next SOL
	};
	cr.type_pushCopySol = function ()
	{
		this.cur_sol++;
		if (this.cur_sol === this.solstack.length)
			this.solstack.push(new cr.selection(this));
		var clonesol = this.solstack[this.cur_sol];
		var prevsol = this.solstack[this.cur_sol - 1];
		if (prevsol.select_all)
			clonesol.select_all = true;
		else
		{
			clonesol.select_all = false;
			cr.shallowAssignArray(clonesol.instances, prevsol.instances);
			cr.shallowAssignArray(clonesol.else_instances, prevsol.else_instances);
		}
	};
	cr.type_popSol = function ()
	{
;
		this.cur_sol--;
	};
	cr.type_getBehaviorByName = function (behname)
	{
		var i, len, j, lenj, f, index = 0;
		if (!this.is_family)
		{
			for (i = 0, len = this.families.length; i < len; i++)
			{
				f = this.families[i];
				for (j = 0, lenj = f.behaviors.length; j < lenj; j++)
				{
					if (behname === f.behaviors[j].name)
					{
						this.extra.lastBehIndex = index;
						return f.behaviors[j];
					}
					index++;
				}
			}
		}
		for (i = 0, len = this.behaviors.length; i < len; i++) {
			if (behname === this.behaviors[i].name)
			{
				this.extra.lastBehIndex = index;
				return this.behaviors[i];
			}
			index++;
		}
		return null;
	};
	cr.type_getBehaviorIndexByName = function (behname)
	{
		var b = this.getBehaviorByName(behname);
		if (b)
			return this.extra.lastBehIndex;
		else
			return -1;
	};
	cr.type_getEffectIndexByName = function (name_)
	{
		var i, len;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			if (this.effect_types[i].name === name_)
				return i;
		}
		return -1;
	};
	cr.type_applySolToContainer = function ()
	{
		if (!this.is_contained || this.is_family)
			return;
		var i, len, j, lenj, t, sol, sol2;
		this.updateIIDs();
		sol = this.getCurrentSol();
		var select_all = sol.select_all;
		var es = this.runtime.getCurrentEventStack();
		var orblock = es && es.current_event && es.current_event.orblock;
		for (i = 0, len = this.container.length; i < len; i++)
		{
			t = this.container[i];
			if (t === this)
				continue;
			t.updateIIDs();
			sol2 = t.getCurrentSol();
			sol2.select_all = select_all;
			if (!select_all)
			{
				sol2.instances.length = sol.instances.length;
				for (j = 0, lenj = sol.instances.length; j < lenj; j++)
					sol2.instances[j] = t.getInstanceByIID(sol.instances[j].iid);
				if (orblock)
				{
					sol2.else_instances.length = sol.else_instances.length;
					for (j = 0, lenj = sol.else_instances.length; j < lenj; j++)
						sol2.else_instances[j] = t.getInstanceByIID(sol.else_instances[j].iid);
				}
			}
		}
	};
	cr.type_toString = function ()
	{
		return "Type" + this.sid;
	};
	cr.do_cmp = function (x, cmp, y)
	{
		if (typeof x === "undefined" || typeof y === "undefined")
			return false;
		switch (cmp)
		{
			case 0:     // equal
				return x === y;
			case 1:     // not equal
				return x !== y;
			case 2:     // less
				return x < y;
			case 3:     // less/equal
				return x <= y;
			case 4:     // greater
				return x > y;
			case 5:     // greater/equal
				return x >= y;
			default:
;
				return false;
		}
	};
})();
cr.shaders = {};
window["cr_cjs_accelerated_physics"] = true;
;
;
cr.plugins_.Arr = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Arr.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var arrCache = [];
	function allocArray()
	{
		if (arrCache.length)
			return arrCache.pop();
		else
			return [];
	};
	if (!Array.isArray)
	{
		Array.isArray = function (vArg) {
			return Object.prototype.toString.call(vArg) === "[object Array]";
		};
	}
	function freeArray(a)
	{
		var i, len;
		for (i = 0, len = a.length; i < len; i++)
		{
			if (Array.isArray(a[i]))
				freeArray(a[i]);
		}
		a.length = 0;
		arrCache.push(a);
	};
	instanceProto.onCreate = function()
	{
		this.cx = this.properties[0];
		this.cy = this.properties[1];
		this.cz = this.properties[2];
		if (!this.recycled)
			this.arr = allocArray();
		var a = this.arr;
		a.length = this.cx;
		var x, y, z;
		for (x = 0; x < this.cx; x++)
		{
			if (!a[x])
				a[x] = allocArray();
			a[x].length = this.cy;
			for (y = 0; y < this.cy; y++)
			{
				if (!a[x][y])
					a[x][y] = allocArray();
				a[x][y].length = this.cz;
				for (z = 0; z < this.cz; z++)
					a[x][y][z] = 0;
			}
		}
		this.forX = 0;
		this.forY = 0;
		this.forZ = 0;
	};
	instanceProto.onDestroy = function ()
	{
		var x;
		for (x = 0; x < this.cx; x++)
			freeArray(this.arr[x]);		// will recurse down and recycle other arrays
		this.arr.length = 0;
	};
	instanceProto.at = function (x, y, z)
	{
		x = Math.floor(x);
		y = Math.floor(y);
		z = Math.floor(z);
		if (isNaN(x) || x < 0 || x > this.cx - 1)
			return 0;
		if (isNaN(y) || y < 0 || y > this.cy - 1)
			return 0;
		if (isNaN(z) || z < 0 || z > this.cz - 1)
			return 0;
		return this.arr[x][y][z];
	};
	instanceProto.set = function (x, y, z, val)
	{
		x = Math.floor(x);
		y = Math.floor(y);
		z = Math.floor(z);
		if (isNaN(x) || x < 0 || x > this.cx - 1)
			return;
		if (isNaN(y) || y < 0 || y > this.cy - 1)
			return;
		if (isNaN(z) || z < 0 || z > this.cz - 1)
			return;
		this.arr[x][y][z] = val;
	};
	instanceProto.getAsJSON = function ()
	{
		return JSON.stringify({
			"c2array": true,
			"size": [this.cx, this.cy, this.cz],
			"data": this.arr
		});
	};
	instanceProto.saveToJSON = function ()
	{
		return {
			"size": [this.cx, this.cy, this.cz],
			"data": this.arr
		};
	};
	instanceProto.loadFromJSON = function (o)
	{
		var sz = o["size"];
		this.cx = sz[0];
		this.cy = sz[1];
		this.cz = sz[2];
		this.arr = o["data"];
	};
	instanceProto.setSize = function (w, h, d)
	{
		if (w < 0) w = 0;
		if (h < 0) h = 0;
		if (d < 0) d = 0;
		if (this.cx === w && this.cy === h && this.cz === d)
			return;		// no change
		this.cx = w;
		this.cy = h;
		this.cz = d;
		var x, y, z;
		var a = this.arr;
		a.length = w;
		for (x = 0; x < this.cx; x++)
		{
			if (cr.is_undefined(a[x]))
				a[x] = allocArray();
			a[x].length = h;
			for (y = 0; y < this.cy; y++)
			{
				if (cr.is_undefined(a[x][y]))
					a[x][y] = allocArray();
				a[x][y].length = d;
				for (z = 0; z < this.cz; z++)
				{
					if (cr.is_undefined(a[x][y][z]))
						a[x][y][z] = 0;
				}
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.CompareX = function (x, cmp, val)
	{
		return cr.do_cmp(this.at(x, 0, 0), cmp, val);
	};
	Cnds.prototype.CompareXY = function (x, y, cmp, val)
	{
		return cr.do_cmp(this.at(x, y, 0), cmp, val);
	};
	Cnds.prototype.CompareXYZ = function (x, y, z, cmp, val)
	{
		return cr.do_cmp(this.at(x, y, z), cmp, val);
	};
	instanceProto.doForEachTrigger = function (current_event)
	{
		this.runtime.pushCopySol(current_event.solModifiers);
		current_event.retrigger();
		this.runtime.popSol(current_event.solModifiers);
	};
	Cnds.prototype.ArrForEach = function (dims)
	{
        var current_event = this.runtime.getCurrentEventStack().current_event;
		this.forX = 0;
		this.forY = 0;
		this.forZ = 0;
		switch (dims) {
		case 0:
			for (this.forX = 0; this.forX < this.cx; this.forX++)
			{
				for (this.forY = 0; this.forY < this.cy; this.forY++)
				{
					for (this.forZ = 0; this.forZ < this.cz; this.forZ++)
					{
						this.doForEachTrigger(current_event);
					}
				}
			}
			break;
		case 1:
			for (this.forX = 0; this.forX < this.cx; this.forX++)
			{
				for (this.forY = 0; this.forY < this.cy; this.forY++)
				{
					this.doForEachTrigger(current_event);
				}
			}
			break;
		case 2:
			for (this.forX = 0; this.forX < this.cx; this.forX++)
			{
				this.doForEachTrigger(current_event);
			}
			break;
		}
		this.forX = 0;
		this.forY = 0;
		this.forZ = 0;
		return false;
	};
	Cnds.prototype.CompareCurrent = function (cmp, val)
	{
		return cr.do_cmp(this.at(this.forX, this.forY, this.forZ), cmp, val);
	};
	Cnds.prototype.Contains = function(val)
	{
		var x, y, z;
		for (x = 0; x < this.cx; x++)
		{
			for (y = 0; y < this.cy; y++)
			{
				for (z = 0; z < this.cz; z++)
				{
					if (this.arr[x][y][z] === val)
						return true;
				}
			}
		}
		return false;
	};
	Cnds.prototype.IsEmpty = function ()
	{
		return this.cx === 0 || this.cy === 0 || this.cz === 0;
	};
	Cnds.prototype.CompareSize = function (axis, cmp, value)
	{
		var s = 0;
		switch (axis) {
		case 0:
			s = this.cx;
			break;
		case 1:
			s = this.cy;
			break;
		case 2:
			s = this.cz;
			break;
		}
		return cr.do_cmp(s, cmp, value);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Clear = function ()
	{
		var x, y, z;
		for (x = 0; x < this.cx; x++)
			for (y = 0; y < this.cy; y++)
				for (z = 0; z < this.cz; z++)
					this.arr[x][y][z] = 0;
	};
	Acts.prototype.SetSize = function (w, h, d)
	{
		this.setSize(w, h, d);
	};
	Acts.prototype.SetX = function (x, val)
	{
		this.set(x, 0, 0, val);
	};
	Acts.prototype.SetXY = function (x, y, val)
	{
		this.set(x, y, 0, val);
	};
	Acts.prototype.SetXYZ = function (x, y, z, val)
	{
		this.set(x, y, z, val);
	};
	Acts.prototype.Push = function (where, value, axis)
	{
		var x = 0, y = 0, z = 0;
		var a = this.arr;
		switch (axis) {
		case 0:	// X axis
			if (where === 0)	// back
			{
				x = a.length;
				a.push(allocArray());
			}
			else				// front
			{
				x = 0;
				a.unshift(allocArray());
			}
			a[x].length = this.cy;
			for ( ; y < this.cy; y++)
			{
				a[x][y] = allocArray();
				a[x][y].length = this.cz;
				for (z = 0; z < this.cz; z++)
					a[x][y][z] = value;
			}
			this.cx++;
			break;
		case 1: // Y axis
			for ( ; x < this.cx; x++)
			{
				if (where === 0)	// back
				{
					y = a[x].length;
					a[x].push(allocArray());
				}
				else				// front
				{
					y = 0;
					a[x].unshift(allocArray());
				}
				a[x][y].length = this.cz;
				for (z = 0; z < this.cz; z++)
					a[x][y][z] = value;
			}
			this.cy++;
			break;
		case 2:	// Z axis
			for ( ; x < this.cx; x++)
			{
				for (y = 0; y < this.cy; y++)
				{
					if (where === 0)	// back
					{
						a[x][y].push(value);
					}
					else				// front
					{
						a[x][y].unshift(value);
					}
				}
			}
			this.cz++;
			break;
		}
	};
	Acts.prototype.Pop = function (where, axis)
	{
		var x = 0, y = 0, z = 0;
		var a = this.arr;
		switch (axis) {
		case 0:	// X axis
			if (this.cx === 0)
				break;
			if (where === 0)	// back
			{
				freeArray(a.pop());
			}
			else				// front
			{
				freeArray(a.shift());
			}
			this.cx--;
			break;
		case 1: // Y axis
			if (this.cy === 0)
				break;
			for ( ; x < this.cx; x++)
			{
				if (where === 0)	// back
				{
					freeArray(a[x].pop());
				}
				else				// front
				{
					freeArray(a[x].shift());
				}
			}
			this.cy--;
			break;
		case 2:	// Z axis
			if (this.cz === 0)
				break;
			for ( ; x < this.cx; x++)
			{
				for (y = 0; y < this.cy; y++)
				{
					if (where === 0)	// back
					{
						a[x][y].pop();
					}
					else				// front
					{
						a[x][y].shift();
					}
				}
			}
			this.cz--;
			break;
		}
	};
	Acts.prototype.Reverse = function (axis)
	{
		var x = 0, y = 0, z = 0;
		var a = this.arr;
		if (this.cx === 0 || this.cy === 0 || this.cz === 0)
			return;		// no point reversing empty array
		switch (axis) {
		case 0:	// X axis
			a.reverse();
			break;
		case 1: // Y axis
			for ( ; x < this.cx; x++)
				a[x].reverse();
			break;
		case 2:	// Z axis
			for ( ; x < this.cx; x++)
				for (y = 0; y < this.cy; y++)
					a[x][y].reverse();
			this.cz--;
			break;
		}
	};
	function compareValues(va, vb)
	{
		if (cr.is_number(va) && cr.is_number(vb))
			return va - vb;
		else
		{
			var sa = "" + va;
			var sb = "" + vb;
			if (sa < sb)
				return -1;
			else if (sa > sb)
				return 1;
			else
				return 0;
		}
	}
	Acts.prototype.Sort = function (axis)
	{
		var x = 0, y = 0, z = 0;
		var a = this.arr;
		if (this.cx === 0 || this.cy === 0 || this.cz === 0)
			return;		// no point sorting empty array
		switch (axis) {
		case 0:	// X axis
			a.sort(function (a, b) {
				return compareValues(a[0][0], b[0][0]);
			});
			break;
		case 1: // Y axis
			for ( ; x < this.cx; x++)
			{
				a[x].sort(function (a, b) {
					return compareValues(a[0], b[0]);
				});
			}
			break;
		case 2:	// Z axis
			for ( ; x < this.cx; x++)
			{
				for (y = 0; y < this.cy; y++)
				{
					a[x][y].sort(compareValues);
				}
			}
			break;
		}
	};
	Acts.prototype.Delete = function (index, axis)
	{
		var x = 0, y = 0, z = 0;
		index = Math.floor(index);
		var a = this.arr;
		if (index < 0)
			return;
		switch (axis) {
		case 0:	// X axis
			if (index >= this.cx)
				break;
			freeArray(a[index]);
			a.splice(index, 1);
			this.cx--;
			break;
		case 1: // Y axis
			if (index >= this.cy)
				break;
			for ( ; x < this.cx; x++)
			{
				freeArray(a[x][index]);
				a[x].splice(index, 1);
			}
			this.cy--;
			break;
		case 2:	// Z axis
			if (index >= this.cz)
				break;
			for ( ; x < this.cx; x++)
			{
				for (y = 0; y < this.cy; y++)
				{
					a[x][y].splice(index, 1);
				}
			}
			this.cz--;
			break;
		}
	};
	Acts.prototype.Insert = function (value, index, axis)
	{
		var x = 0, y = 0, z = 0;
		index = Math.floor(index);
		var a = this.arr;
		if (index < 0)
			return;
		switch (axis) {
		case 0:	// X axis
			if (index > this.cx)
				return;
			x = index;
			a.splice(x, 0, allocArray());
			a[x].length = this.cy;
			for ( ; y < this.cy; y++)
			{
				a[x][y] = allocArray();
				a[x][y].length = this.cz;
				for (z = 0; z < this.cz; z++)
					a[x][y][z] = value;
			}
			this.cx++;
			break;
		case 1: // Y axis
			if (index > this.cy)
				return;
			for ( ; x < this.cx; x++)
			{
				y = index;
				a[x].splice(y, 0, allocArray());
				a[x][y].length = this.cz;
				for (z = 0; z < this.cz; z++)
					a[x][y][z] = value;
			}
			this.cy++;
			break;
		case 2:	// Z axis
			if (index > this.cz)
				return;
			for ( ; x < this.cx; x++)
			{
				for (y = 0; y < this.cy; y++)
				{
					a[x][y].splice(index, 0, value);
				}
			}
			this.cz++;
			break;
		}
	};
	Acts.prototype.JSONLoad = function (json_)
	{
		var o;
		try {
			o = JSON.parse(json_);
		}
		catch(e) { return; }
		if (!o["c2array"])		// presumably not a c2array object
			return;
		var sz = o["size"];
		this.cx = sz[0];
		this.cy = sz[1];
		this.cz = sz[2];
		this.arr = o["data"];
	};
	Acts.prototype.JSONDownload = function (filename)
	{
		var a = document.createElement("a");
		if (typeof a.download === "undefined")
		{
			var str = 'data:text/html,' + encodeURIComponent("<p><a download='" + filename + "' href=\"data:application/json,"
				+ encodeURIComponent(this.getAsJSON())
				+ "\">Download link</a></p>");
			window.open(str);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename;
			a.href = "data:application/json," + encodeURIComponent(this.getAsJSON());
			a.download = filename;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.At = function (ret, x, y_, z_)
	{
		var y = y_ || 0;
		var z = z_ || 0;
		ret.set_any(this.at(x, y, z));
	};
	Exps.prototype.Width = function (ret)
	{
		ret.set_int(this.cx);
	};
	Exps.prototype.Height = function (ret)
	{
		ret.set_int(this.cy);
	};
	Exps.prototype.Depth = function (ret)
	{
		ret.set_int(this.cz);
	};
	Exps.prototype.CurX = function (ret)
	{
		ret.set_int(this.forX);
	};
	Exps.prototype.CurY = function (ret)
	{
		ret.set_int(this.forY);
	};
	Exps.prototype.CurZ = function (ret)
	{
		ret.set_int(this.forZ);
	};
	Exps.prototype.CurValue = function (ret)
	{
		ret.set_any(this.at(this.forX, this.forY, this.forZ));
	};
	Exps.prototype.Front = function (ret)
	{
		ret.set_any(this.at(0, 0, 0));
	};
	Exps.prototype.Back = function (ret)
	{
		ret.set_any(this.at(this.cx - 1, 0, 0));
	};
	Exps.prototype.IndexOf = function (ret, v)
	{
		for (var i = 0; i < this.cx; i++)
		{
			if (this.arr[i][0][0] === v)
			{
				ret.set_int(i);
				return;
			}
		}
		ret.set_int(-1);
	};
	Exps.prototype.LastIndexOf = function (ret, v)
	{
		for (var i = this.cx - 1; i >= 0; i--)
		{
			if (this.arr[i][0][0] === v)
			{
				ret.set_int(i);
				return;
			}
		}
		ret.set_int(-1);
	};
	Exps.prototype.AsJSON = function (ret)
	{
		ret.set_string(this.getAsJSON());
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Audio = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Audio.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	var audRuntime = null;
	var audInst = null;
	var audTag = "";
	var appPath = "";			// for PhoneGap only
	var API_HTML5 = 0;
	var API_WEBAUDIO = 1;
	var API_PHONEGAP = 2;
	var API_APPMOBI = 3;
	var api = API_HTML5;
	var context = null;
	var audioBuffers = [];		// cache of buffers
	var audioInstances = [];	// cache of instances
	var lastAudio = null;
	var useOgg = false;			// determined at create time
	var timescale_mode = 0;
	var silent = false;
	var masterVolume = 1;
	var listenerX = 0;
	var listenerY = 0;
	var panningModel = 1;		// HRTF
	var distanceModel = 1;		// Inverse
	var refDistance = 10;
	var maxDistance = 10000;
	var rolloffFactor = 1;
	var micSource = null;
	var micTag = "";
	var isMusicWorkaround = false;
	var musicPlayNextTouch = [];
	function dbToLinear(x)
	{
		var v = dbToLinear_nocap(x);
		if (v < 0)
			v = 0;
		if (v > 1)
			v = 1;
		return v;
	};
	function linearToDb(x)
	{
		if (x < 0)
			x = 0;
		if (x > 1)
			x = 1;
		return linearToDb_nocap(x);
	};
	function dbToLinear_nocap(x)
	{
		return Math.pow(10, x / 20);
	};
	function linearToDb_nocap(x)
	{
		return (Math.log(x) / Math.log(10)) * 20;
	};
	var effects = {};
	function getDestinationForTag(tag)
	{
		tag = tag.toLowerCase();
		if (effects.hasOwnProperty(tag))
		{
			if (effects[tag].length)
				return effects[tag][0].getInputNode();
		}
		return context["destination"];
	};
	function createGain()
	{
		if (context["createGain"])
			return context["createGain"]();
		else
			return context["createGainNode"]();
	};
	function createDelay(d)
	{
		if (context["createDelay"])
			return context["createDelay"](d);
		else
			return context["createDelayNode"](d);
	};
	function startSource(s)
	{
		if (s["start"])
			s["start"](0);
		else
			s["noteOn"](0);
	};
	function startSourceAt(s, x, d)
	{
		if (s["start"])
			s["start"](0, x);
		else
			s["noteGrainOn"](0, x, d - x);
	};
	function stopSource(s)
	{
		try {
			if (s["stop"])
				s["stop"](0);
			else
				s["noteOff"](0);
		}
		catch (e) {}
	};
	function setAudioParam(ap, value, ramp, time)
	{
		if (!ap)
			return;		// iOS is missing some parameters
		ap["cancelScheduledValues"](0);
		if (time === 0)
		{
			ap["value"] = value;
			return;
		}
		var curTime = context["currentTime"];
		time += curTime;
		switch (ramp) {
		case 0:		// step
			ap["setValueAtTime"](value, time);
			break;
		case 1:		// linear
			ap["setValueAtTime"](ap["value"], curTime);		// to set what to ramp from
			ap["linearRampToValueAtTime"](value, time);
			break;
		case 2:		// exponential
			ap["setValueAtTime"](ap["value"], curTime);		// to set what to ramp from
			ap["exponentialRampToValueAtTime"](value, time);
			break;
		}
	};
	var filterTypes = ["lowpass", "highpass", "bandpass", "lowshelf", "highshelf", "peaking", "notch", "allpass"];
	function FilterEffect(type, freq, detune, q, gain, mix)
	{
		this.type = "filter";
		this.params = [type, freq, detune, q, gain, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.filterNode = context["createBiquadFilter"]();
		if (typeof this.filterNode["type"] === "number")
			this.filterNode["type"] = type;
		else
			this.filterNode["type"] = filterTypes[type];
		this.filterNode["frequency"]["value"] = freq;
		if (this.filterNode["detune"])		// iOS 6 doesn't have detune yet
			this.filterNode["detune"]["value"] = detune;
		this.filterNode["Q"]["value"] = q;
		this.filterNode["gain"]["value"] = gain;
		this.inputNode["connect"](this.filterNode);
		this.inputNode["connect"](this.dryNode);
		this.filterNode["connect"](this.wetNode);
	};
	FilterEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	FilterEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.filterNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	FilterEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	FilterEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[5] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 1:		// filter frequency
			this.params[1] = value;
			setAudioParam(this.filterNode["frequency"], value, ramp, time);
			break;
		case 2:		// filter detune
			this.params[2] = value;
			setAudioParam(this.filterNode["detune"], value, ramp, time);
			break;
		case 3:		// filter Q
			this.params[3] = value;
			setAudioParam(this.filterNode["Q"], value, ramp, time);
			break;
		case 4:		// filter/delay gain (note value is in dB here)
			this.params[4] = value;
			setAudioParam(this.filterNode["gain"], value, ramp, time);
			break;
		}
	};
	function DelayEffect(delayTime, delayGain, mix)
	{
		this.type = "delay";
		this.params = [delayTime, delayGain, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.mainNode = createGain();
		this.delayNode = createDelay(delayTime);
		this.delayNode["delayTime"]["value"] = delayTime;
		this.delayGainNode = createGain();
		this.delayGainNode["gain"]["value"] = delayGain;
		this.inputNode["connect"](this.mainNode);
		this.inputNode["connect"](this.dryNode);
		this.mainNode["connect"](this.wetNode);
		this.mainNode["connect"](this.delayNode);
		this.delayNode["connect"](this.delayGainNode);
		this.delayGainNode["connect"](this.mainNode);
	};
	DelayEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	DelayEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.mainNode["disconnect"]();
		this.delayNode["disconnect"]();
		this.delayGainNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	DelayEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	DelayEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[2] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 4:		// filter/delay gain (note value is passed in dB but needs to be linear here)
			this.params[1] = dbToLinear(value);
			setAudioParam(this.delayGainNode["gain"], dbToLinear(value), ramp, time);
			break;
		case 5:		// delay time
			this.params[0] = value;
			setAudioParam(this.delayNode["delayTime"], value, ramp, time);
			break;
		}
	};
	function ConvolveEffect(buffer, normalize, mix, src)
	{
		this.type = "convolve";
		this.params = [normalize, mix, src];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.convolveNode = context["createConvolver"]();
		if (buffer)
		{
			this.convolveNode["normalize"] = normalize;
			this.convolveNode["buffer"] = buffer;
		}
		this.inputNode["connect"](this.convolveNode);
		this.inputNode["connect"](this.dryNode);
		this.convolveNode["connect"](this.wetNode);
	};
	ConvolveEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	ConvolveEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.convolveNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	ConvolveEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	ConvolveEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		}
	};
	function FlangerEffect(delay, modulation, freq, feedback, mix)
	{
		this.type = "flanger";
		this.params = [delay, modulation, freq, feedback, mix];
		this.inputNode = createGain();
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - (mix / 2);
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix / 2;
		this.feedbackNode = createGain();
		this.feedbackNode["gain"]["value"] = feedback;
		this.delayNode = createDelay(delay + modulation);
		this.delayNode["delayTime"]["value"] = delay;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = modulation;
		this.inputNode["connect"](this.delayNode);
		this.inputNode["connect"](this.dryNode);
		this.delayNode["connect"](this.wetNode);
		this.delayNode["connect"](this.feedbackNode);
		this.feedbackNode["connect"](this.delayNode);
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.delayNode["delayTime"]);
		startSource(this.oscNode);
	};
	FlangerEffect.prototype.connectTo = function (node)
	{
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
	};
	FlangerEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.delayNode["disconnect"]();
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.dryNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.feedbackNode["disconnect"]();
	};
	FlangerEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	FlangerEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[4] = value;
			setAudioParam(this.wetNode["gain"], value / 2, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - (value / 2), ramp, time);
			break;
		case 6:		// modulation
			this.params[1] = value / 1000;
			setAudioParam(this.oscGainNode["gain"], value / 1000, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[2] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		case 8:		// feedback
			this.params[3] = value / 100;
			setAudioParam(this.feedbackNode["gain"], value / 100, ramp, time);
			break;
		}
	};
	function PhaserEffect(freq, detune, q, modulation, modfreq, mix)
	{
		this.type = "phaser";
		this.params = [freq, detune, q, modulation, modfreq, mix];
		this.inputNode = createGain();
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - (mix / 2);
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix / 2;
		this.filterNode = context["createBiquadFilter"]();
		if (typeof this.filterNode["type"] === "number")
			this.filterNode["type"] = 7;	// all-pass
		else
			this.filterNode["type"] = "allpass";
		this.filterNode["frequency"]["value"] = freq;
		if (this.filterNode["detune"])		// iOS 6 doesn't have detune yet
			this.filterNode["detune"]["value"] = detune;
		this.filterNode["Q"]["value"] = q;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = modfreq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = modulation;
		this.inputNode["connect"](this.filterNode);
		this.inputNode["connect"](this.dryNode);
		this.filterNode["connect"](this.wetNode);
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.filterNode["frequency"]);
		startSource(this.oscNode);
	};
	PhaserEffect.prototype.connectTo = function (node)
	{
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
	};
	PhaserEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.filterNode["disconnect"]();
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.dryNode["disconnect"]();
		this.wetNode["disconnect"]();
	};
	PhaserEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	PhaserEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[5] = value;
			setAudioParam(this.wetNode["gain"], value / 2, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - (value / 2), ramp, time);
			break;
		case 1:		// filter frequency
			this.params[0] = value;
			setAudioParam(this.filterNode["frequency"], value, ramp, time);
			break;
		case 2:		// filter detune
			this.params[1] = value;
			setAudioParam(this.filterNode["detune"], value, ramp, time);
			break;
		case 3:		// filter Q
			this.params[2] = value;
			setAudioParam(this.filterNode["Q"], value, ramp, time);
			break;
		case 6:		// modulation
			this.params[3] = value;
			setAudioParam(this.oscGainNode["gain"], value, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[4] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function GainEffect(g)
	{
		this.type = "gain";
		this.params = [g];
		this.node = createGain();
		this.node["gain"]["value"] = g;
	};
	GainEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	GainEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	GainEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	GainEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 4:		// gain
			this.params[0] = dbToLinear(value);
			setAudioParam(this.node["gain"], dbToLinear(value), ramp, time);
			break;
		}
	};
	function TremoloEffect(freq, mix)
	{
		this.type = "tremolo";
		this.params = [freq, mix];
		this.node = createGain();
		this.node["gain"]["value"] = 1 - (mix / 2);
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = mix / 2;
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.node["gain"]);
		startSource(this.oscNode);
	};
	TremoloEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	TremoloEffect.prototype.remove = function ()
	{
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.node["disconnect"]();
	};
	TremoloEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	TremoloEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.node["gain"]["value"], 1 - (value / 2), ramp, time);
			setAudioParam(this.oscGainNode["gain"]["value"], value / 2, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[0] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function RingModulatorEffect(freq, mix)
	{
		this.type = "ringmod";
		this.params = [freq, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.ringNode = createGain();
		this.ringNode["gain"]["value"] = 0;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscNode["connect"](this.ringNode["gain"]);
		startSource(this.oscNode);
		this.inputNode["connect"](this.ringNode);
		this.inputNode["connect"](this.dryNode);
		this.ringNode["connect"](this.wetNode);
	};
	RingModulatorEffect.prototype.connectTo = function (node_)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node_);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node_);
	};
	RingModulatorEffect.prototype.remove = function ()
	{
		this.oscNode["disconnect"]();
		this.ringNode["disconnect"]();
		this.inputNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	RingModulatorEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	RingModulatorEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[0] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function DistortionEffect(threshold, headroom, drive, makeupgain, mix)
	{
		this.type = "distortion";
		this.params = [threshold, headroom, drive, makeupgain, mix];
		this.inputNode = createGain();
		this.preGain = createGain();
		this.postGain = createGain();
		this.setDrive(drive, dbToLinear_nocap(makeupgain));
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.waveShaper = context["createWaveShaper"]();
		this.curve = new Float32Array(65536);
		this.generateColortouchCurve(threshold, headroom);
		this.waveShaper.curve = this.curve;
		this.inputNode["connect"](this.preGain);
		this.inputNode["connect"](this.dryNode);
		this.preGain["connect"](this.waveShaper);
		this.waveShaper["connect"](this.postGain);
		this.postGain["connect"](this.wetNode);
	};
	DistortionEffect.prototype.setDrive = function (drive, makeupgain)
	{
		if (drive < 0.01)
			drive = 0.01;
		this.preGain["gain"]["value"] = drive;
		this.postGain["gain"]["value"] = Math.pow(1 / drive, 0.6) * makeupgain;
	};
	function e4(x, k)
	{
		return 1.0 - Math.exp(-k * x);
	}
	DistortionEffect.prototype.shape = function (x, linearThreshold, linearHeadroom)
	{
		var maximum = 1.05 * linearHeadroom * linearThreshold;
		var kk = (maximum - linearThreshold);
		var sign = x < 0 ? -1 : +1;
		var absx = x < 0 ? -x : x;
		var shapedInput = absx < linearThreshold ? absx : linearThreshold + kk * e4(absx - linearThreshold, 1.0 / kk);
		shapedInput *= sign;
		return shapedInput;
	};
	DistortionEffect.prototype.generateColortouchCurve = function (threshold, headroom)
	{
		var linearThreshold = dbToLinear_nocap(threshold);
		var linearHeadroom = dbToLinear_nocap(headroom);
		var n = 65536;
		var n2 = n / 2;
		var x = 0;
		for (var i = 0; i < n2; ++i) {
			x = i / n2;
			x = this.shape(x, linearThreshold, linearHeadroom);
			this.curve[n2 + i] = x;
			this.curve[n2 - i - 1] = -x;
		}
	};
	DistortionEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	DistortionEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.preGain["disconnect"]();
		this.waveShaper["disconnect"]();
		this.postGain["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	DistortionEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	DistortionEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[4] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		}
	};
	function CompressorEffect(threshold, knee, ratio, attack, release)
	{
		this.type = "compressor";
		this.params = [threshold, knee, ratio, attack, release];
		this.node = context["createDynamicsCompressor"]();
		try {
			this.node["threshold"]["value"] = threshold;
			this.node["knee"]["value"] = knee;
			this.node["ratio"]["value"] = ratio;
			this.node["attack"]["value"] = attack;
			this.node["release"]["value"] = release;
		}
		catch (e) {}
	};
	CompressorEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	CompressorEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	CompressorEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	CompressorEffect.prototype.setParam = function(param, value, ramp, time)
	{
	};
	function AnalyserEffect(fftSize, smoothing)
	{
		this.type = "analyser";
		this.params = [fftSize, smoothing];
		this.node = context["createAnalyser"]();
		this.node["fftSize"] = fftSize;
		this.node["smoothingTimeConstant"] = smoothing;
		this.freqBins = new Float32Array(this.node["frequencyBinCount"]);
		this.signal = new Uint8Array(fftSize);
		this.peak = 0;
		this.rms = 0;
	};
	AnalyserEffect.prototype.tick = function ()
	{
		this.node["getFloatFrequencyData"](this.freqBins);
		this.node["getByteTimeDomainData"](this.signal);
		var fftSize = this.node["fftSize"];
		var i = 0;
		this.peak = 0;
		var rmsSquaredSum = 0;
		var s = 0;
		for ( ; i < fftSize; i++)
		{
			s = (this.signal[i] - 128) / 128;
			if (s < 0)
				s = -s;
			if (this.peak < s)
				this.peak = s;
			rmsSquaredSum += s * s;
		}
		this.peak = linearToDb(this.peak);
		this.rms = linearToDb(Math.sqrt(rmsSquaredSum / fftSize));
	};
	AnalyserEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	AnalyserEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	AnalyserEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	AnalyserEffect.prototype.setParam = function(param, value, ramp, time)
	{
	};
	var OT_POS_SAMPLES = 4;
	function ObjectTracker()
	{
		this.obj = null;
		this.loadUid = 0;
		this.speeds = [];
		this.lastX = 0;
		this.lastY = 0;
		this.moveAngle = 0;
	};
	ObjectTracker.prototype.setObject = function (obj_)
	{
		this.obj = obj_;
		if (this.obj)
		{
			this.lastX = this.obj.x;
			this.lastY = this.obj.y;
		}
		this.speeds.length = 0;
	};
	ObjectTracker.prototype.hasObject = function ()
	{
		return !!this.obj;
	};
	ObjectTracker.prototype.tick = function (dt)
	{
		if (!this.obj || dt === 0)
			return;
		this.moveAngle = cr.angleTo(this.lastX, this.lastY, this.obj.x, this.obj.y);
		var s = cr.distanceTo(this.lastX, this.lastY, this.obj.x, this.obj.y) / dt;
		if (this.speeds.length < OT_POS_SAMPLES)
			this.speeds.push(s);
		else
		{
			this.speeds.shift();
			this.speeds.push(s);
		}
		this.lastX = this.obj.x;
		this.lastY = this.obj.y;
	};
	ObjectTracker.prototype.getSpeed = function ()
	{
		if (!this.speeds.length)
			return 0;
		var i, len, sum = 0;
		for (i = 0, len = this.speeds.length; i < len; i++)
		{
			sum += this.speeds[i];
		}
		return sum / this.speeds.length;
	};
	ObjectTracker.prototype.getVelocityX = function ()
	{
		return Math.cos(this.moveAngle) * this.getSpeed();
	};
	ObjectTracker.prototype.getVelocityY = function ()
	{
		return Math.sin(this.moveAngle) * this.getSpeed();
	};
	var iOShadtouch = false;	// has had touch input on iOS to work around web audio API muting
	function C2AudioBuffer(src_, is_music)
	{
		this.src = src_;
		this.myapi = api;
		this.is_music = is_music;
		this.added_end_listener = false;
		var self = this;
		this.outNode = null;
		this.mediaSourceNode = null;
		this.panWhenReady = [];		// for web audio API positioned sounds
		this.seekWhenReady = 0;
		this.pauseWhenReady = false;
		this.supportWebAudioAPI = false;
		if (api === API_WEBAUDIO && is_music)
		{
			this.myapi = API_HTML5;
			this.outNode = createGain();
		}
		this.bufferObject = null;			// actual audio object
		this.audioData = null;				// web audio api: ajax request result (compressed audio that needs decoding)
		var request;
		switch (this.myapi) {
		case API_HTML5:
			this.bufferObject = new Audio();
			if (api === API_WEBAUDIO && context["createMediaElementSource"] && !audRuntime.isFirefox && !/wiiu/i.test(navigator.userAgent))
			{
				this.supportWebAudioAPI = true;		// can be routed through web audio api
				this.bufferObject.addEventListener("canplay", function ()
				{
					if (!self.mediaSourceNode)		// protect against this event firing twice
					{
						self.mediaSourceNode = context["createMediaElementSource"](self.bufferObject);
						self.mediaSourceNode["connect"](self.outNode);
					}
				});
			}
			this.bufferObject.autoplay = false;	// this is only a source buffer, not an instance
			this.bufferObject.preload = "auto";
			this.bufferObject.src = src_;
			break;
		case API_WEBAUDIO:
			request = new XMLHttpRequest();
			request.open("GET", src_, true);
			request.responseType = "arraybuffer";
			request.onload = function () {
				self.audioData = request.response;
				self.decodeAudioBuffer();
			};
			request.send();
			break;
		case API_PHONEGAP:
			this.bufferObject = true;
			break;
		case API_APPMOBI:
			this.bufferObject = true;
			break;
		}
	};
	C2AudioBuffer.prototype.decodeAudioBuffer = function ()
	{
		if (this.bufferObject || !this.audioData)
			return;		// audio already decoded or AJAX request not yet complete
		var self = this;
		if (context["decodeAudioData"])
		{
			context["decodeAudioData"](this.audioData, function (buffer) {
					self.bufferObject = buffer;
					var p, i, len, a;
					if (!cr.is_undefined(self.playTagWhenReady) && !silent)
					{
						if (self.panWhenReady.length)
						{
							for (i = 0, len = self.panWhenReady.length; i < len; i++)
							{
								p = self.panWhenReady[i];
								a = new C2AudioInstance(self, p.thistag);
								a.setPannerEnabled(true);
								if (typeof p.objUid !== "undefined")
								{
									p.obj = audRuntime.getObjectByUID(p.objUid);
									if (!p.obj)
										continue;
								}
								if (p.obj)
								{
									var px = cr.rotatePtAround(p.obj.x, p.obj.y, -p.obj.layer.getAngle(), listenerX, listenerY, true);
									var py = cr.rotatePtAround(p.obj.x, p.obj.y, -p.obj.layer.getAngle(), listenerX, listenerY, false);
									a.setPan(px, py, cr.to_degrees(p.obj.angle - p.obj.layer.getAngle()), p.ia, p.oa, p.og);
									a.setObject(p.obj);
								}
								else
								{
									a.setPan(p.x, p.y, p.a, p.ia, p.oa, p.og);
								}
								a.play(self.loopWhenReady, self.volumeWhenReady, self.seekWhenReady);
								if (self.pauseWhenReady)
									a.pause();
								audioInstances.push(a);
							}
							self.panWhenReady.length = 0;
						}
						else
						{
							a = new C2AudioInstance(self, self.playTagWhenReady);
							a.play(self.loopWhenReady, self.volumeWhenReady, self.seekWhenReady);
							if (self.pauseWhenReady)
								a.pause();
							audioInstances.push(a);
						}
					}
					else if (!cr.is_undefined(self.convolveWhenReady))
					{
						var convolveNode = self.convolveWhenReady.convolveNode;
						convolveNode["normalize"] = self.normalizeWhenReady;
						convolveNode["buffer"] = buffer;
					}
			});
		}
		else
		{
			this.bufferObject = context["createBuffer"](this.audioData, false);
			if (!cr.is_undefined(this.playTagWhenReady) && !silent)
			{
				var a = new C2AudioInstance(this, this.playTagWhenReady);
				a.play(this.loopWhenReady, this.volumeWhenReady, this.seekWhenReady);
				if (this.pauseWhenReady)
					a.pause();
				audioInstances.push(a);
			}
			else if (!cr.is_undefined(this.convolveWhenReady))
			{
				var convolveNode = this.convolveWhenReady.convolveNode;
				convolveNode["normalize"] = this.normalizeWhenReady;
				convolveNode["buffer"] = this.bufferObject;
			}
		}
	};
	C2AudioBuffer.prototype.isLoaded = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			return this.bufferObject["readyState"] === 4;	// HAVE_ENOUGH_DATA
		case API_WEBAUDIO:
			return !!this.audioData;			// null until AJAX request completes
		case API_PHONEGAP:
			return true;
		case API_APPMOBI:
			return true;
		}
		return false;
	};
	function C2AudioInstance(buffer_, tag_)
	{
		var self = this;
		this.tag = tag_;
		this.fresh = true;
		this.stopped = true;
		this.src = buffer_.src;
		this.buffer = buffer_;
		this.myapi = api;
		this.is_music = buffer_.is_music;
		this.playbackRate = 1;
		this.pgended = true;			// for PhoneGap only: ended flag
		this.resume_me = false;			// make sure resumes when leaving suspend
		this.is_paused = false;
		this.resume_position = 0;		// for web audio api to resume from correct playback position
		this.looping = false;
		this.is_muted = false;
		this.is_silent = false;
		this.volume = 1;
		this.mutevol = 1;
		this.startTime = audRuntime.kahanTime.sum;
		this.gainNode = null;
		this.pannerNode = null;
		this.pannerEnabled = false;
		this.objectTracker = null;
		this.panX = 0;
		this.panY = 0;
		this.panAngle = 0;
		this.panConeInner = 0;
		this.panConeOuter = 0;
		this.panConeOuterGain = 0;
		this.instanceObject = null;
		var add_end_listener = false;
		if (this.myapi === API_WEBAUDIO && this.buffer.myapi === API_HTML5 && !this.buffer.supportWebAudioAPI)
			this.myapi = API_HTML5;
		switch (this.myapi) {
		case API_HTML5:
			if (this.is_music)
			{
				this.instanceObject = buffer_.bufferObject;
				add_end_listener = !buffer_.added_end_listener;
				buffer_.added_end_listener = true;
			}
			else
			{
				this.instanceObject = new Audio();
				this.instanceObject.autoplay = false;
				this.instanceObject.src = buffer_.bufferObject.src;
				add_end_listener = true;
			}
			if (add_end_listener)
			{
				this.instanceObject.addEventListener('ended', function () {
						audTag = self.tag;
						self.stopped = true;
						audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
				});
			}
			break;
		case API_WEBAUDIO:
			this.gainNode = createGain();
			this.gainNode["connect"](getDestinationForTag(tag_));
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (buffer_.bufferObject)
				{
					this.instanceObject = context["createBufferSource"]();
					this.instanceObject["buffer"] = buffer_.bufferObject;
					this.instanceObject["connect"](this.gainNode);
				}
			}
			else
			{
				this.instanceObject = this.buffer.bufferObject;		// reference the audio element
				this.buffer.outNode["connect"](this.gainNode);
			}
			break;
		case API_PHONEGAP:
			this.instanceObject = new window["Media"](appPath + this.src, null, null, function (status) {
					if (status === window["Media"]["MEDIA_STOPPED"])
					{
						self.pgended = true;
						self.stopped = true;
						audTag = self.tag;
						audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
					}
			});
			break;
		case API_APPMOBI:
			this.instanceObject = true;
			break;
		}
	};
	C2AudioInstance.prototype.hasEnded = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			return this.instanceObject.ended;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (!this.fresh && !this.stopped && this.instanceObject["loop"])
					return false;
				if (this.is_paused)
					return false;
				return (audRuntime.kahanTime.sum - this.startTime) > this.buffer.bufferObject["duration"];
			}
			else
				return this.instanceObject.ended;
		case API_PHONEGAP:
			return this.pgended;
		case API_APPMOBI:
			true;	// recycling an AppMobi sound does not matter because it will just do another throwaway playSound
		}
		return true;
	};
	C2AudioInstance.prototype.canBeRecycled = function ()
	{
		if (this.fresh || this.stopped)
			return true;		// not yet used or is not playing
		return this.hasEnded();
	};
	C2AudioInstance.prototype.setPannerEnabled = function (enable_)
	{
		if (api !== API_WEBAUDIO)
			return;
		if (!this.pannerEnabled && enable_)
		{
			if (!this.gainNode)
				return;
			if (!this.pannerNode)
			{
				this.pannerNode = context["createPanner"]();
				if (typeof this.pannerNode["panningModel"] === "number")
					this.pannerNode["panningModel"] = panningModel;
				else
					this.pannerNode["panningModel"] = ["equalpower", "HRTF", "soundfield"][panningModel];
				if (typeof this.pannerNode["distanceModel"] === "number")
					this.pannerNode["distanceModel"] = distanceModel;
				else
					this.pannerNode["distanceModel"] = ["linear", "inverse", "exponential"][distanceModel];
				this.pannerNode["refDistance"] = refDistance;
				this.pannerNode["maxDistance"] = maxDistance;
				this.pannerNode["rolloffFactor"] = rolloffFactor;
			}
			this.gainNode["disconnect"]();
			this.gainNode["connect"](this.pannerNode);
			this.pannerNode["connect"](getDestinationForTag(this.tag));
			this.pannerEnabled = true;
		}
		else if (this.pannerEnabled && !enable_)
		{
			if (!this.gainNode)
				return;
			this.pannerNode["disconnect"]();
			this.gainNode["disconnect"]();
			this.gainNode["connect"](getDestinationForTag(this.tag));
			this.pannerEnabled = false;
		}
	};
	C2AudioInstance.prototype.setPan = function (x, y, angle, innerangle, outerangle, outergain)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO)
			return;
		this.pannerNode["setPosition"](x, y, 0);
		this.pannerNode["setOrientation"](Math.cos(cr.to_radians(angle)), Math.sin(cr.to_radians(angle)), 0);
		this.pannerNode["coneInnerAngle"] = innerangle;
		this.pannerNode["coneOuterAngle"] = outerangle;
		this.pannerNode["coneOuterGain"] = outergain;
		this.panX = x;
		this.panY = y;
		this.panAngle = angle;
		this.panConeInner = innerangle;
		this.panConeOuter = outerangle;
		this.panConeOuterGain = outergain;
	};
	C2AudioInstance.prototype.setObject = function (o)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO)
			return;
		if (!this.objectTracker)
			this.objectTracker = new ObjectTracker();
		this.objectTracker.setObject(o);
	};
	C2AudioInstance.prototype.tick = function (dt)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO || !this.objectTracker || !this.objectTracker.hasObject() || !this.isPlaying())
		{
			return;
		}
		this.objectTracker.tick(dt);
		var inst = this.objectTracker.obj;
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		this.pannerNode["setPosition"](px, py, 0);
		var a = 0;
		if (typeof this.objectTracker.obj.angle !== "undefined")
		{
			a = inst.angle - inst.layer.getAngle();
			this.pannerNode["setOrientation"](Math.cos(a), Math.sin(a), 0);
		}
		px = cr.rotatePtAround(this.objectTracker.getVelocityX(), this.objectTracker.getVelocityY(), -inst.layer.getAngle(), 0, 0, true);
		py = cr.rotatePtAround(this.objectTracker.getVelocityX(), this.objectTracker.getVelocityY(), -inst.layer.getAngle(), 0, 0, false);
		this.pannerNode["setVelocity"](px, py, 0);
	};
	C2AudioInstance.prototype.play = function (looping, vol, fromPosition)
	{
		var instobj = this.instanceObject;
		this.looping = looping;
		this.volume = vol;
		var seekPos = fromPosition || 0;
		switch (this.myapi) {
		case API_HTML5:
			if (instobj.playbackRate !== 1.0)
				instobj.playbackRate = 1.0;
			if (instobj.volume !== vol * masterVolume)
				instobj.volume = vol * masterVolume;
			if (instobj.loop !== looping)
				instobj.loop = looping;
			if (instobj.muted)
				instobj.muted = false;
			if (instobj.currentTime !== seekPos)
			{
				try {
					instobj.currentTime = seekPos;
				}
				catch (err)
				{
;
				}
			}
			if (this.is_music && isMusicWorkaround && !audRuntime.isInUserInputEvent)
				musicPlayNextTouch.push(this);
			else
			{
				try {
					this.instanceObject.play();
				}
				catch (e) {}	// sometimes throws on WP8.1... try not to kill the app
			}
			break;
		case API_WEBAUDIO:
			this.muted = false;
			this.mutevol = 1;
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (!this.fresh)
				{
					this.instanceObject = context["createBufferSource"]();
					this.instanceObject["buffer"] = this.buffer.bufferObject;
					this.instanceObject["connect"](this.gainNode);
				}
				this.instanceObject.loop = looping;
				this.gainNode["gain"]["value"] = vol * masterVolume;
				if (seekPos === 0)
					startSource(this.instanceObject);
				else
					startSourceAt(this.instanceObject, seekPos, this.getDuration());
			}
			else
			{
				if (instobj.playbackRate !== 1.0)
					instobj.playbackRate = 1.0;
				if (instobj.loop !== looping)
					instobj.loop = looping;
				this.gainNode["gain"]["value"] = vol * masterVolume;
				if (instobj.currentTime !== seekPos)
				{
					try {
						instobj.currentTime = seekPos;
					}
					catch (err)
					{
;
					}
				}
				if (this.is_music && isMusicWorkaround && !audRuntime.isInUserInputEvent)
					musicPlayNextTouch.push(this);
				else
					instobj.play();
			}
			break;
		case API_PHONEGAP:
			if ((!this.fresh && this.stopped) || seekPos !== 0)
				instobj["seekTo"](seekPos);
			instobj["play"]();
			this.pgended = false;
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["playSound"](this.src, looping);
			else
				AppMobi["player"]["playSound"](this.src, looping);
			break;
		}
		this.playbackRate = 1;
		this.startTime = audRuntime.kahanTime.sum - seekPos;
		this.fresh = false;
		this.stopped = false;
		this.is_paused = false;
	};
	C2AudioInstance.prototype.stop = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			if (!this.instanceObject.paused)
				this.instanceObject.pause();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
				stopSource(this.instanceObject);
			else
			{
				if (!this.instanceObject.paused)
					this.instanceObject.pause();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["stop"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["stopSound"](this.src);
			break;
		}
		this.stopped = true;
		this.is_paused = false;
	};
	C2AudioInstance.prototype.pause = function ()
	{
		if (this.fresh || this.stopped || this.hasEnded() || this.is_paused)
			return;
		switch (this.myapi) {
		case API_HTML5:
			if (!this.instanceObject.paused)
				this.instanceObject.pause();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				this.resume_position = this.getPlaybackTime();
				if (this.looping)
					this.resume_position = this.resume_position % this.getDuration();
				stopSource(this.instanceObject);
			}
			else
			{
				if (!this.instanceObject.paused)
					this.instanceObject.pause();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["pause"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["stopSound"](this.src);
			break;
		}
		this.is_paused = true;
	};
	C2AudioInstance.prototype.resume = function ()
	{
		if (this.fresh || this.stopped || this.hasEnded() || !this.is_paused)
			return;
		switch (this.myapi) {
		case API_HTML5:
			this.instanceObject.play();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				this.instanceObject = context["createBufferSource"]();
				this.instanceObject["buffer"] = this.buffer.bufferObject;
				this.instanceObject["connect"](this.gainNode);
				this.instanceObject.loop = this.looping;
				this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
				this.startTime = audRuntime.kahanTime.sum - this.resume_position;
				startSourceAt(this.instanceObject, this.resume_position, this.getDuration());
			}
			else
			{
				this.instanceObject.play();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["play"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["resumeSound"](this.src);
			break;
		}
		this.is_paused = false;
	};
	C2AudioInstance.prototype.seek = function (pos)
	{
		if (this.fresh || this.stopped || this.hasEnded())
			return;
		switch (this.myapi) {
		case API_HTML5:
			try {
				this.instanceObject.currentTime = pos;
			}
			catch (e) {}
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.is_paused)
					this.resume_position = pos;
				else
				{
					this.pause();
					this.resume_position = pos;
					this.resume();
				}
			}
			else
			{
				try {
					this.instanceObject.currentTime = pos;
				}
				catch (e) {}
			}
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["seekSound"](this.src, pos);
			break;
		}
	};
	C2AudioInstance.prototype.reconnect = function (toNode)
	{
		if (this.myapi !== API_WEBAUDIO)
			return;
		if (this.pannerEnabled)
		{
			this.pannerNode["disconnect"]();
			this.pannerNode["connect"](toNode);
		}
		else
		{
			this.gainNode["disconnect"]();
			this.gainNode["connect"](toNode);
		}
	};
	C2AudioInstance.prototype.getDuration = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			if (typeof this.instanceObject.duration !== "undefined")
				return this.instanceObject.duration;
			else
				return 0;
		case API_WEBAUDIO:
			return this.buffer.bufferObject["duration"];
		case API_PHONEGAP:
			return this.instanceObject["getDuration"]();
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				return AppMobi["context"]["getDurationSound"](this.src);
			else
				return 0;
		}
		return 0;
	};
	C2AudioInstance.prototype.getPlaybackTime = function ()
	{
		var duration = this.getDuration();
		var ret = 0;
		switch (this.myapi) {
		case API_HTML5:
			if (typeof this.instanceObject.currentTime !== "undefined")
				ret = this.instanceObject.currentTime;
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.is_paused)
					return this.resume_position;
				else
					ret = audRuntime.kahanTime.sum - this.startTime;
			}
			else if (typeof this.instanceObject.currentTime !== "undefined")
				ret = this.instanceObject.currentTime;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				ret = AppMobi["context"]["getPlaybackTimeSound"](this.src);
			break;
		}
		if (!this.looping && ret > duration)
			ret = duration;
		return ret;
	};
	C2AudioInstance.prototype.isPlaying = function ()
	{
		return !this.is_paused && !this.fresh && !this.stopped && !this.hasEnded();
	};
	C2AudioInstance.prototype.setVolume = function (v)
	{
		this.volume = v;
		this.updateVolume();
	};
	C2AudioInstance.prototype.updateVolume = function ()
	{
		var volToSet = this.volume * masterVolume;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.volume && this.instanceObject.volume !== volToSet)
				this.instanceObject.volume = volToSet;
			break;
		case API_WEBAUDIO:
			this.gainNode["gain"]["value"] = volToSet * this.mutevol;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.getVolume = function ()
	{
		return this.volume;
	};
	C2AudioInstance.prototype.doSetMuted = function (m)
	{
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.muted !== !!m)
				this.instanceObject.muted = !!m;
			break;
		case API_WEBAUDIO:
			this.mutevol = (m ? 0 : 1);
			this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.setMuted = function (m)
	{
		this.is_muted = !!m;
		this.doSetMuted(this.is_muted || this.is_silent);
	};
	C2AudioInstance.prototype.setSilent = function (m)
	{
		this.is_silent = !!m;
		this.doSetMuted(this.is_muted || this.is_silent);
	};
	C2AudioInstance.prototype.setLooping = function (l)
	{
		this.looping = l;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.loop !== !!l)
				this.instanceObject.loop = !!l;
			break;
		case API_WEBAUDIO:
			if (this.instanceObject.loop !== !!l)
				this.instanceObject.loop = !!l;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["setLoopingSound"](this.src, l);
			break;
		}
	};
	C2AudioInstance.prototype.setPlaybackRate = function (r)
	{
		this.playbackRate = r;
		this.updatePlaybackRate();
	};
	C2AudioInstance.prototype.updatePlaybackRate = function ()
	{
		var r = this.playbackRate;
		if ((timescale_mode === 1 && !this.is_music) || timescale_mode === 2)
			r *= audRuntime.timescale;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.playbackRate !== r)
				this.instanceObject.playbackRate = r;
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.instanceObject["playbackRate"]["value"] !== r)
					this.instanceObject["playbackRate"]["value"] = r;
			}
			else
			{
				if (this.instanceObject.playbackRate !== r)
					this.instanceObject.playbackRate = r;
			}
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.setSuspended = function (s)
	{
		switch (this.myapi) {
		case API_HTML5:
			if (s)
			{
				if (this.isPlaying())
				{
					this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
					this.instanceObject["play"]();
			}
			break;
		case API_WEBAUDIO:
			if (s)
			{
				if (this.isPlaying())
				{
					if (this.buffer.myapi === API_WEBAUDIO)
					{
						this.resume_position = this.getPlaybackTime();
						if (this.looping)
							this.resume_position = this.resume_position % this.getDuration();
						stopSource(this.instanceObject);
					}
					else
						this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
				{
					if (this.buffer.myapi === API_WEBAUDIO)
					{
						this.instanceObject = context["createBufferSource"]();
						this.instanceObject["buffer"] = this.buffer.bufferObject;
						this.instanceObject["connect"](this.gainNode);
						this.instanceObject.loop = this.looping;
						this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
						this.startTime = audRuntime.kahanTime.sum - this.resume_position;
						startSourceAt(this.instanceObject, this.resume_position, this.getDuration());
					}
					else
					{
						this.instanceObject["play"]();
					}
				}
			}
			break;
		case API_PHONEGAP:
			if (s)
			{
				if (this.isPlaying())
				{
					this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
					this.instanceObject["play"]();
			}
			break;
		case API_APPMOBI:
			break;
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		audRuntime = this.runtime;
		audInst = this;
		this.listenerTracker = null;
		this.listenerZ = -600;
		if ((this.runtime.isiOS || (this.runtime.isAndroid && (this.runtime.isChrome || this.runtime.isAndroidStockBrowser))) && !this.runtime.isCrosswalk && !this.runtime.isDomFree)
		{
			isMusicWorkaround = true;
		}
		context = null;
		if (typeof AudioContext !== "undefined")
		{
			api = API_WEBAUDIO;
			context = new AudioContext();
		}
		else if (typeof webkitAudioContext !== "undefined")
		{
			api = API_WEBAUDIO;
			context = new webkitAudioContext();
		}
		if ((this.runtime.isiOS && api === API_WEBAUDIO) || isMusicWorkaround)
		{
			document.addEventListener("touchstart", function ()
			{
				var i, len, m;
				if (!iOShadtouch && context)
				{
					var buffer = context["createBuffer"](1, 1, 22050);
					var source = context["createBufferSource"]();
					source["buffer"] = buffer;
					source["connect"](context["destination"]);
					startSource(source);
					iOShadtouch = true;
				}
				if (isMusicWorkaround)
				{
					if (!silent)
					{
						for (i = 0, len = musicPlayNextTouch.length; i < len; ++i)
						{
							m = musicPlayNextTouch[i];
							if (!m.stopped && !m.is_paused)
								m.instanceObject.play();
						}
					}
					musicPlayNextTouch.length = 0;
				}
			}, true);
		}
		if (api !== API_WEBAUDIO)
		{
			if (this.runtime.isPhoneGap)
				api = API_PHONEGAP;
			else if (this.runtime.isAppMobi)
				api = API_APPMOBI;
		}
		if (api === API_PHONEGAP)
		{
			appPath = location.href;
			var i = appPath.lastIndexOf("/");
			if (i > -1)
				appPath = appPath.substr(0, i + 1);
			appPath = appPath.replace("file://", "");
		}
		if (this.runtime.isSafari && this.runtime.isWindows && typeof Audio === "undefined")
		{
			alert("It looks like you're using Safari for Windows without Quicktime.  Audio cannot be played until Quicktime is installed.");
			this.runtime.DestroyInstance(this);
		}
		else
		{
			if (this.runtime.isDirectCanvas)
				useOgg = this.runtime.isAndroid;		// AAC on iOS, OGG on Android
			else
			{
				try {
					useOgg = !!(new Audio().canPlayType('audio/ogg; codecs="vorbis"'));
				}
				catch (e)
				{
					useOgg = false;
				}
			}
			switch (api) {
			case API_HTML5:
;
				break;
			case API_WEBAUDIO:
;
				break;
			case API_PHONEGAP:
;
				break;
			case API_APPMOBI:
;
				break;
			default:
;
			}
			this.runtime.tickMe(this);
		}
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function ()
	{
		timescale_mode = this.properties[0];	// 0 = off, 1 = sounds only, 2 = all
		this.saveload = this.properties[1];		// 0 = all, 1 = sounds only, 2 = music only, 3 = none
		panningModel = this.properties[2];		// 0 = equalpower, 1 = hrtf, 3 = soundfield
		distanceModel = this.properties[3];		// 0 = linear, 1 = inverse, 2 = exponential
		this.listenerZ = -this.properties[4];
		refDistance = this.properties[5];
		maxDistance = this.properties[6];
		rolloffFactor = this.properties[7];
		this.listenerTracker = new ObjectTracker();
		if (api === API_WEBAUDIO)
		{
			context["listener"]["speedOfSound"] = this.properties[8];
			context["listener"]["dopplerFactor"] = this.properties[9];
			context["listener"]["setPosition"](this.runtime.draw_width / 2, this.runtime.draw_height / 2, this.listenerZ);
			context["listener"]["setOrientation"](0, 0, 1, 0, -1, 0);
			window["c2OnAudioMicStream"] = function (localMediaStream, tag)
			{
				if (micSource)
					micSource["disconnect"]();
				micTag = tag.toLowerCase();
				micSource = context["createMediaStreamSource"](localMediaStream);
				micSource["connect"](getDestinationForTag(micTag));
			};
		}
		this.runtime.addSuspendCallback(function(s)
		{
			audInst.onSuspend(s);
		});
		var self = this;
		this.runtime.addDestroyCallback(function (inst)
		{
			self.onInstanceDestroyed(inst);
		});
	};
	instanceProto.onInstanceDestroyed = function (inst)
	{
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (a.objectTracker)
			{
				if (a.objectTracker.obj === inst)
				{
					a.objectTracker.obj = null;
					if (a.pannerEnabled && a.isPlaying() && a.looping)
						a.stop();
				}
			}
		}
		if (this.listenerTracker.obj === inst)
			this.listenerTracker.obj = null;
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"silent": silent,
			"masterVolume": masterVolume,
			"listenerZ": this.listenerZ,
			"listenerUid": this.listenerTracker.hasObject() ? this.listenerTracker.obj.uid : -1,
			"playing": [],
			"effects": {}
		};
		var playingarr = o["playing"];
		var i, len, a, d, p, panobj, playbackTime;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (!a.isPlaying())
				continue;				// no need to save stopped sounds
			if (this.saveload === 3)	// not saving/loading any sounds/music
				continue;
			if (a.is_music && this.saveload === 1)	// not saving/loading music
				continue;
			if (!a.is_music && this.saveload === 2)	// not saving/loading sound
				continue;
			playbackTime = a.getPlaybackTime();
			if (a.looping)
				playbackTime = playbackTime % a.getDuration();
			d = {
				"tag": a.tag,
				"buffersrc": a.buffer.src,
				"is_music": a.is_music,
				"playbackTime": playbackTime,
				"volume": a.volume,
				"looping": a.looping,
				"muted": a.is_muted,
				"playbackRate": a.playbackRate,
				"paused": a.is_paused,
				"resume_position": a.resume_position
			};
			if (a.pannerEnabled)
			{
				d["pan"] = {};
				panobj = d["pan"];
				if (a.objectTracker && a.objectTracker.hasObject())
				{
					panobj["objUid"] = a.objectTracker.obj.uid;
				}
				else
				{
					panobj["x"] = a.panX;
					panobj["y"] = a.panY;
					panobj["a"] = a.panAngle;
				}
				panobj["ia"] = a.panConeInner;
				panobj["oa"] = a.panConeOuter;
				panobj["og"] = a.panConeOuterGain;
			}
			playingarr.push(d);
		}
		var fxobj = o["effects"];
		var fxarr;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				fxarr = [];
				for (i = 0, len = effects[p].length; i < len; i++)
				{
					fxarr.push({ "type": effects[p][i].type, "params": effects[p][i].params });
				}
				fxobj[p] = fxarr;
			}
		}
		return o;
	};
	var objectTrackerUidsToLoad = [];
	instanceProto.loadFromJSON = function (o)
	{
		var setSilent = o["silent"];
		masterVolume = o["masterVolume"];
		this.listenerZ = o["listenerZ"];
		this.listenerTracker.setObject(null);
		var listenerUid = o["listenerUid"];
		if (listenerUid !== -1)
		{
			this.listenerTracker.loadUid = listenerUid;
			objectTrackerUidsToLoad.push(this.listenerTracker);
		}
		var playingarr = o["playing"];
		var i, len, d, src, is_music, tag, playbackTime, looping, vol, b, a, p, pan, panObjUid;
		if (this.saveload !== 3)
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
			{
				a = audioInstances[i];
				if (a.is_music && this.saveload === 1)
					continue;		// only saving/loading sound: leave music playing
				if (!a.is_music && this.saveload === 2)
					continue;		// only saving/loading music: leave sound playing
				a.stop();
			}
		}
		var fxarr, fxtype, fxparams, fx;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				for (i = 0, len = effects[p].length; i < len; i++)
					effects[p][i].remove();
			}
		}
		cr.wipe(effects);
		for (p in o["effects"])
		{
			if (o["effects"].hasOwnProperty(p))
			{
				fxarr = o["effects"][p];
				for (i = 0, len = fxarr.length; i < len; i++)
				{
					fxtype = fxarr[i]["type"];
					fxparams = fxarr[i]["params"];
					switch (fxtype) {
					case "filter":
						addEffectForTag(p, new FilterEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4], fxparams[5]));
						break;
					case "delay":
						addEffectForTag(p, new DelayEffect(fxparams[0], fxparams[1], fxparams[2]));
						break;
					case "convolve":
						src = fxparams[2];
						b = this.getAudioBuffer(src, false);
						if (b.bufferObject)
						{
							fx = new ConvolveEffect(b.bufferObject, fxparams[0], fxparams[1], src);
						}
						else
						{
							fx = new ConvolveEffect(null, fxparams[0], fxparams[1], src);
							b.normalizeWhenReady = fxparams[0];
							b.convolveWhenReady = fx;
						}
						addEffectForTag(p, fx);
						break;
					case "flanger":
						addEffectForTag(p, new FlangerEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "phaser":
						addEffectForTag(p, new PhaserEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4], fxparams[5]));
						break;
					case "gain":
						addEffectForTag(p, new GainEffect(fxparams[0]));
						break;
					case "tremolo":
						addEffectForTag(p, new TremoloEffect(fxparams[0], fxparams[1]));
						break;
					case "ringmod":
						addEffectForTag(p, new RingModulatorEffect(fxparams[0], fxparams[1]));
						break;
					case "distortion":
						addEffectForTag(p, new DistortionEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "compressor":
						addEffectForTag(p, new CompressorEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "analyser":
						addEffectForTag(p, new AnalyserEffect(fxparams[0], fxparams[1]));
						break;
					}
				}
			}
		}
		for (i = 0, len = playingarr.length; i < len; i++)
		{
			if (this.saveload === 3)	// not saving/loading any sounds/music
				continue;
			d = playingarr[i];
			src = d["buffersrc"];
			is_music = d["is_music"];
			tag = d["tag"];
			playbackTime = d["playbackTime"];
			looping = d["looping"];
			vol = d["volume"];
			pan = d["pan"];
			panObjUid = (pan && pan.hasOwnProperty("objUid")) ? pan["objUid"] : -1;
			if (is_music && this.saveload === 1)	// not saving/loading music
				continue;
			if (!is_music && this.saveload === 2)	// not saving/loading sound
				continue;
			a = this.getAudioInstance(src, tag, is_music, looping, vol);
			if (!a)
			{
				b = this.getAudioBuffer(src, is_music);
				b.seekWhenReady = playbackTime;
				b.pauseWhenReady = d["paused"];
				if (pan)
				{
					if (panObjUid !== -1)
					{
						b.panWhenReady.push({ objUid: panObjUid, ia: pan["ia"], oa: pan["oa"], og: pan["og"], thistag: tag });
					}
					else
					{
						b.panWhenReady.push({ x: pan["x"], y: pan["y"], a: pan["a"], ia: pan["ia"], oa: pan["oa"], og: pan["og"], thistag: tag });
					}
				}
				continue;
			}
			a.resume_position = d["resume_position"];
			a.setPannerEnabled(!!pan);
			a.play(looping, vol, playbackTime);
			a.updatePlaybackRate();
			a.updateVolume();
			a.doSetMuted(a.is_muted || a.is_silent);
			if (d["paused"])
				a.pause();
			if (d["muted"])
				a.setMuted(true);
			a.doSetMuted(a.is_muted || a.is_silent);
			if (pan)
			{
				if (panObjUid !== -1)
				{
					a.objectTracker = a.objectTracker || new ObjectTracker();
					a.objectTracker.loadUid = panObjUid;
					objectTrackerUidsToLoad.push(a.objectTracker);
				}
				else
				{
					a.setPan(pan["x"], pan["y"], pan["a"], pan["ia"], pan["oa"], pan["og"]);
				}
			}
		}
		if (setSilent && !silent)			// setting silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(true);
			silent = true;
		}
		else if (!setSilent && silent)		// setting not silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(false);
			silent = false;
		}
	};
	instanceProto.afterLoad = function ()
	{
		var i, len, ot, inst;
		for (i = 0, len = objectTrackerUidsToLoad.length; i < len; i++)
		{
			ot = objectTrackerUidsToLoad[i];
			inst = this.runtime.getObjectByUID(ot.loadUid);
			ot.setObject(inst);
			ot.loadUid = -1;
			if (inst)
			{
				listenerX = inst.x;
				listenerY = inst.y;
			}
		}
		objectTrackerUidsToLoad.length = 0;
	};
	instanceProto.onSuspend = function (s)
	{
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].setSuspended(s);
	};
	instanceProto.tick = function ()
	{
		var dt = this.runtime.dt;
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			a.tick(dt);
			if (a.myapi !== API_HTML5 && a.myapi !== API_APPMOBI)
			{
				if (!a.fresh && !a.stopped && a.hasEnded())
				{
					a.stopped = true;
					audTag = a.tag;
					audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
				}
			}
			if (timescale_mode !== 0)
				a.updatePlaybackRate();
		}
		var p, arr, f;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				arr = effects[p];
				for (i = 0, len = arr.length; i < len; i++)
				{
					f = arr[i];
					if (f.tick)
						f.tick();
				}
			}
		}
		if (api === API_WEBAUDIO && this.listenerTracker.hasObject())
		{
			this.listenerTracker.tick(dt);
			listenerX = this.listenerTracker.obj.x;
			listenerY = this.listenerTracker.obj.y;
			context["listener"]["setPosition"](this.listenerTracker.obj.x, this.listenerTracker.obj.y, this.listenerZ);
			context["listener"]["setVelocity"](this.listenerTracker.getVelocityX(), this.listenerTracker.getVelocityY(), 0);
		}
	};
	instanceProto.getAudioBuffer = function (src_, is_music)
	{
		var i, len, a, ret = null, j, k, lenj, ai;
		for (i = 0, len = audioBuffers.length; i < len; i++)
		{
			a = audioBuffers[i];
			if (a.src === src_)
			{
				ret = a;
				break;
			}
		}
		if (!ret)
		{
			ret = new C2AudioBuffer(src_, is_music);
			audioBuffers.push(ret);
		}
		return ret;
	};
	instanceProto.getAudioInstance = function (src_, tag, is_music, looping, vol)
	{
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (a.src === src_ && (a.canBeRecycled() || is_music))
			{
				a.tag = tag;
				return a;
			}
		}
		var b = this.getAudioBuffer(src_, is_music);
		if (!b.bufferObject)
		{
			if (tag !== "<preload>")
			{
				b.playTagWhenReady = tag;
				b.loopWhenReady = looping;
				b.volumeWhenReady = vol;
			}
			return null;
		}
		a = new C2AudioInstance(b, tag);
		audioInstances.push(a);
		return a;
	};
	var taggedAudio = [];
	function getAudioByTag(tag)
	{
		taggedAudio.length = 0;
		if (!tag.length)
		{
			if (!lastAudio || lastAudio.hasEnded())
				return;
			else
			{
				taggedAudio.length = 1;
				taggedAudio[0] = lastAudio;
				return;
			}
		}
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (cr.equals_nocase(tag, a.tag))
				taggedAudio.push(a);
		}
	};
	function reconnectEffects(tag)
	{
		var i, len, arr, n, toNode = context["destination"];
		if (effects.hasOwnProperty(tag))
		{
			arr = effects[tag];
			if (arr.length)
			{
				toNode = arr[0].getInputNode();
				for (i = 0, len = arr.length; i < len; i++)
				{
					n = arr[i];
					if (i + 1 === len)
						n.connectTo(context["destination"]);
					else
						n.connectTo(arr[i + 1].getInputNode());
				}
			}
		}
		getAudioByTag(tag);
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].reconnect(toNode);
		if (micSource && micTag === tag)
		{
			micSource["disconnect"]();
			micSource["connect"](toNode);
		}
	};
	function addEffectForTag(tag, fx)
	{
		if (!effects.hasOwnProperty(tag))
			effects[tag] = [fx];
		else
			effects[tag].push(fx);
		reconnectEffects(tag);
	};
	function Cnds() {};
	Cnds.prototype.OnEnded = function (t)
	{
		return cr.equals_nocase(audTag, t);
	};
	Cnds.prototype.PreloadsComplete = function ()
	{
		var i, len;
		for (i = 0, len = audioBuffers.length; i < len; i++)
		{
			if (!audioBuffers[i].isLoaded())
				return false;
		}
		return true;
	};
	Cnds.prototype.AdvancedAudioSupported = function ()
	{
		return api === API_WEBAUDIO;
	};
	Cnds.prototype.IsSilent = function ()
	{
		return silent;
	};
	Cnds.prototype.IsAnyPlaying = function ()
	{
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			if (audioInstances[i].isPlaying())
				return true;
		}
		return false;
	};
	Cnds.prototype.IsTagPlaying = function (tag)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			if (taggedAudio[i].isPlaying())
				return true;
		}
		return false;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Play = function (file, looping, vol, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
			return;
		lastAudio.setPannerEnabled(false);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtPosition = function (file, looping, vol, x_, y_, angle_, innerangle_, outerangle_, outergain_, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ x: x_, y: y_, a: angle_, ia: innerangle_, oa: outerangle_, og: dbToLinear(outergain_), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		lastAudio.setPan(x_, y_, angle_, innerangle_, outerangle_, dbToLinear(outergain_));
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtObject = function (file, looping, vol, obj, innerangle, outerangle, outergain, tag)
	{
		if (silent || !obj)
			return;
		var inst = obj.getFirstPicked();
		if (!inst)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ obj: inst, ia: innerangle, oa: outerangle, og: dbToLinear(outergain), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		lastAudio.setPan(px, py, cr.to_degrees(inst.angle - inst.layer.getAngle()), innerangle, outerangle, dbToLinear(outergain));
		lastAudio.setObject(inst);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayByName = function (folder, filename, looping, vol, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
			return;
		lastAudio.setPannerEnabled(false);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtPositionByName = function (folder, filename, looping, vol, x_, y_, angle_, innerangle_, outerangle_, outergain_, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ x: x_, y: y_, a: angle_, ia: innerangle_, oa: outerangle_, og: dbToLinear(outergain_), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		lastAudio.setPan(x_, y_, angle_, innerangle_, outerangle_, dbToLinear(outergain_));
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtObjectByName = function (folder, filename, looping, vol, obj, innerangle, outerangle, outergain, tag)
	{
		if (silent || !obj)
			return;
		var inst = obj.getFirstPicked();
		if (!inst)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ obj: inst, ia: innerangle, oa: outerangle, og: dbToLinear(outergain), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		lastAudio.setPan(px, py, cr.to_degrees(inst.angle - inst.layer.getAngle()), innerangle, outerangle, dbToLinear(outergain));
		lastAudio.setObject(inst);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.SetLooping = function (tag, looping)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setLooping(looping === 0);
	};
	Acts.prototype.SetMuted = function (tag, muted)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setMuted(muted === 0);
	};
	Acts.prototype.SetVolume = function (tag, vol)
	{
		getAudioByTag(tag);
		var v = dbToLinear(vol);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setVolume(v);
	};
	Acts.prototype.Preload = function (file)
	{
		if (silent)
			return;
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		if (api === API_APPMOBI)
		{
			if (this.runtime.isDirectCanvas)
				AppMobi["context"]["loadSound"](src);
			else
				AppMobi["player"]["loadSound"](src);
			return;
		}
		else if (api === API_PHONEGAP)
		{
			return;
		}
		this.getAudioInstance(src, "<preload>", is_music, false);
	};
	Acts.prototype.PreloadByName = function (folder, filename)
	{
		if (silent)
			return;
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		if (api === API_APPMOBI)
		{
			if (this.runtime.isDirectCanvas)
				AppMobi["context"]["loadSound"](src);
			else
				AppMobi["player"]["loadSound"](src);
			return;
		}
		else if (api === API_PHONEGAP)
		{
			return;
		}
		this.getAudioInstance(src, "<preload>", is_music, false);
	};
	Acts.prototype.SetPlaybackRate = function (tag, rate)
	{
		getAudioByTag(tag);
		if (rate < 0.0)
			rate = 0;
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setPlaybackRate(rate);
	};
	Acts.prototype.Stop = function (tag)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].stop();
	};
	Acts.prototype.StopAll = function ()
	{
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].stop();
	};
	Acts.prototype.SetPaused = function (tag, state)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			if (state === 0)
				taggedAudio[i].pause();
			else
				taggedAudio[i].resume();
		}
	};
	Acts.prototype.Seek = function (tag, pos)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			taggedAudio[i].seek(pos);
		}
	};
	Acts.prototype.SetSilent = function (s)
	{
		var i, len;
		if (s === 2)					// toggling
			s = (silent ? 1 : 0);		// choose opposite state
		if (s === 0 && !silent)			// setting silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(true);
			silent = true;
		}
		else if (s === 1 && silent)		// setting not silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(false);
			silent = false;
		}
	};
	Acts.prototype.SetMasterVolume = function (vol)
	{
		masterVolume = dbToLinear(vol);
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].updateVolume();
	};
	Acts.prototype.AddFilterEffect = function (tag, type, freq, detune, q, gain, mix)
	{
		if (api !== API_WEBAUDIO || type < 0 || type >= filterTypes.length || !context["createBiquadFilter"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new FilterEffect(type, freq, detune, q, gain, mix));
	};
	Acts.prototype.AddDelayEffect = function (tag, delay, gain, mix)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new DelayEffect(delay, dbToLinear(gain), mix));
	};
	Acts.prototype.AddFlangerEffect = function (tag, delay, modulation, freq, feedback, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new FlangerEffect(delay / 1000, modulation / 1000, freq, feedback / 100, mix));
	};
	Acts.prototype.AddPhaserEffect = function (tag, freq, detune, q, mod, modfreq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new PhaserEffect(freq, detune, q, mod, modfreq, mix));
	};
	Acts.prototype.AddConvolutionEffect = function (tag, file, norm, mix)
	{
		if (api !== API_WEBAUDIO || !context["createConvolver"])
			return;
		var doNormalize = (norm === 0);
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		var b = this.getAudioBuffer(src, false);
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		var fx;
		if (b.bufferObject)
		{
			fx = new ConvolveEffect(b.bufferObject, doNormalize, mix, src);
		}
		else
		{
			fx = new ConvolveEffect(null, doNormalize, mix, src);
			b.normalizeWhenReady = doNormalize;
			b.convolveWhenReady = fx;
		}
		addEffectForTag(tag, fx);
	};
	Acts.prototype.AddGainEffect = function (tag, g)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new GainEffect(dbToLinear(g)));
	};
	Acts.prototype.AddMuteEffect = function (tag)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new GainEffect(0));	// re-use gain effect with 0 gain
	};
	Acts.prototype.AddTremoloEffect = function (tag, freq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new TremoloEffect(freq, mix));
	};
	Acts.prototype.AddRingModEffect = function (tag, freq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new RingModulatorEffect(freq, mix));
	};
	Acts.prototype.AddDistortionEffect = function (tag, threshold, headroom, drive, makeupgain, mix)
	{
		if (api !== API_WEBAUDIO || !context["createWaveShaper"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new DistortionEffect(threshold, headroom, drive, makeupgain, mix));
	};
	Acts.prototype.AddCompressorEffect = function (tag, threshold, knee, ratio, attack, release)
	{
		if (api !== API_WEBAUDIO || !context["createDynamicsCompressor"])
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new CompressorEffect(threshold, knee, ratio, attack / 1000, release / 1000));
	};
	Acts.prototype.AddAnalyserEffect = function (tag, fftSize, smoothing)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new AnalyserEffect(fftSize, smoothing));
	};
	Acts.prototype.RemoveEffects = function (tag)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		var i, len, arr;
		if (effects.hasOwnProperty(tag))
		{
			arr = effects[tag];
			if (arr.length)
			{
				for (i = 0, len = arr.length; i < len; i++)
					arr[i].remove();
				arr.length = 0;
				reconnectEffects(tag);
			}
		}
	};
	Acts.prototype.SetEffectParameter = function (tag, index, param, value, ramp, time)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var arr;
		if (!effects.hasOwnProperty(tag))
			return;
		arr = effects[tag];
		if (index < 0 || index >= arr.length)
			return;
		arr[index].setParam(param, value, ramp, time);
	};
	Acts.prototype.SetListenerObject = function (obj_)
	{
		if (!obj_ || api !== API_WEBAUDIO)
			return;
		var inst = obj_.getFirstPicked();
		if (!inst)
			return;
		this.listenerTracker.setObject(inst);
		listenerX = inst.x;
		listenerY = inst.y;
	};
	Acts.prototype.SetListenerZ = function (z)
	{
		this.listenerZ = z;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Duration = function (ret, tag)
	{
		getAudioByTag(tag);
		if (taggedAudio.length)
			ret.set_float(taggedAudio[0].getDuration());
		else
			ret.set_float(0);
	};
	Exps.prototype.PlaybackTime = function (ret, tag)
	{
		getAudioByTag(tag);
		if (taggedAudio.length)
			ret.set_float(taggedAudio[0].getPlaybackTime());
		else
			ret.set_float(0);
	};
	Exps.prototype.Volume = function (ret, tag)
	{
		getAudioByTag(tag);
		if (taggedAudio.length)
		{
			var v = taggedAudio[0].getVolume();
			ret.set_float(linearToDb(v));
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.MasterVolume = function (ret)
	{
		ret.set_float(masterVolume);
	};
	Exps.prototype.EffectCount = function (ret, tag)
	{
		tag = tag.toLowerCase();
		var arr = null;
		if (effects.hasOwnProperty(tag))
			arr = effects[tag];
		ret.set_int(arr ? arr.length : 0);
	};
	function getAnalyser(tag, index)
	{
		var arr = null;
		if (effects.hasOwnProperty(tag))
			arr = effects[tag];
		if (arr && index >= 0 && index < arr.length && arr[index].freqBins)
			return arr[index];
		else
			return null;
	};
	Exps.prototype.AnalyserFreqBinCount = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		ret.set_int(analyser ? analyser.node["frequencyBinCount"] : 0);
	};
	Exps.prototype.AnalyserFreqBinAt = function (ret, tag, index, bin)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		bin = Math.floor(bin);
		var analyser = getAnalyser(tag, index);
		if (!analyser)
			ret.set_float(0);
		else if (bin < 0 || bin >= analyser.node["frequencyBinCount"])
			ret.set_float(0);
		else
			ret.set_float(analyser.freqBins[bin]);
	};
	Exps.prototype.AnalyserPeakLevel = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		if (analyser)
			ret.set_float(analyser.peak);
		else
			ret.set_float(0);
	};
	Exps.prototype.AnalyserRMSLevel = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		if (analyser)
			ret.set_float(analyser.rms);
		else
			ret.set_float(0);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Browser = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Browser.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		var self = this;
		window.addEventListener("resize", function () {
			self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnResize, self);
		});
		if (typeof navigator.onLine !== "undefined")
		{
			window.addEventListener("online", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOnline, self);
			});
			window.addEventListener("offline", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOffline, self);
			});
		}
		if (typeof window.applicationCache !== "undefined")
		{
			window.applicationCache.addEventListener('updateready', function() {
				self.runtime.loadingprogress = 1;
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady, self);
			});
			window.applicationCache.addEventListener('progress', function(e) {
				self.runtime.loadingprogress = e["loaded"] / e["total"];
			});
		}
		if (!this.runtime.isDirectCanvas)
		{
			document.addEventListener("appMobi.device.update.available", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady, self);
			});
			document.addEventListener("backbutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
			});
			document.addEventListener("menubutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton, self);
			});
			document.addEventListener("searchbutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnSearchButton, self);
			});
			document.addEventListener("tizenhwkey", function (e) {
				var ret;
				switch (e["keyName"]) {
				case "back":
					ret = self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
					if (!ret)
					{
						if (window["tizen"])
							window["tizen"]["application"]["getCurrentApplication"]()["exit"]();
					}
					break;
				case "menu":
					ret = self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton, self);
					if (!ret)
						e.preventDefault();
					break;
				}
			});
		}
		if (this.runtime.isWindowsPhone81)
		{
			WinJS["Application"]["onbackclick"] = function (e)
			{
				return !!self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
			};
		}
		this.runtime.addSuspendCallback(function(s) {
			if (s)
			{
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageHidden, self);
			}
			else
			{
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageVisible, self);
			}
		});
		this.is_arcade = (typeof window["is_scirra_arcade"] !== "undefined");
	};
	function Cnds() {};
	Cnds.prototype.CookiesEnabled = function()
	{
		return navigator ? navigator.cookieEnabled : false;
	};
	Cnds.prototype.IsOnline = function()
	{
		return navigator ? navigator.onLine : false;
	};
	Cnds.prototype.HasJava = function()
	{
		return navigator ? navigator.javaEnabled() : false;
	};
	Cnds.prototype.OnOnline = function()
	{
		return true;
	};
	Cnds.prototype.OnOffline = function()
	{
		return true;
	};
	Cnds.prototype.IsDownloadingUpdate = function ()
	{
		if (typeof window["applicationCache"] === "undefined")
			return false;
		else
			return window["applicationCache"]["status"] === window["applicationCache"]["DOWNLOADING"];
	};
	Cnds.prototype.OnUpdateReady = function ()
	{
		return true;
	};
	Cnds.prototype.PageVisible = function ()
	{
		return !this.runtime.isSuspended;
	};
	Cnds.prototype.OnPageVisible = function ()
	{
		return true;
	};
	Cnds.prototype.OnPageHidden = function ()
	{
		return true;
	};
	Cnds.prototype.OnResize = function ()
	{
		return true;
	};
	Cnds.prototype.IsFullscreen = function ()
	{
		return !!(document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || this.runtime.isNodeFullscreen);
	};
	Cnds.prototype.OnBackButton = function ()
	{
		return true;
	};
	Cnds.prototype.OnMenuButton = function ()
	{
		return true;
	};
	Cnds.prototype.OnSearchButton = function ()
	{
		return true;
	};
	Cnds.prototype.IsMetered = function ()
	{
		var connection = navigator["connection"] || navigator["mozConnection"] || navigator["webkitConnection"];
		if (!connection)
			return false;
		return connection["metered"];
	};
	Cnds.prototype.IsCharging = function ()
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			return true;
		return battery["charging"];
	};
	Cnds.prototype.IsPortraitLandscape = function (p)
	{
		var current = (window.innerWidth <= window.innerHeight ? 0 : 1);
		return current === p;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Alert = function (msg)
	{
		if (!this.runtime.isDomFree)
			alert(msg.toString());
	};
	Acts.prototype.Close = function ()
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["forceToFinish"]();
		else if (window["tizen"])
			window["tizen"]["application"]["getCurrentApplication"]()["exit"]();
		else if (navigator["app"] && navigator["app"]["exitApp"])
			navigator["app"]["exitApp"]();
		else if (navigator["device"] && navigator["device"]["exitApp"])
			navigator["device"]["exitApp"]();
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.close();
	};
	Acts.prototype.Focus = function ()
	{
		if (this.runtime.isNodeWebkit)
		{
			var win = window["nwgui"]["Window"]["get"]();
			win["focus"]();
		}
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.focus();
	};
	Acts.prototype.Blur = function ()
	{
		if (this.runtime.isNodeWebkit)
		{
			var win = window["nwgui"]["Window"]["get"]();
			win["blur"]();
		}
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.blur();
	};
	Acts.prototype.GoBack = function ()
	{
		if (navigator["app"] && navigator["app"]["backHistory"])
			navigator["app"]["backHistory"]();
		else if (!this.is_arcade && !this.runtime.isDomFree && window.back)
			window.back();
	};
	Acts.prototype.GoForward = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree && window.forward)
			window.forward();
	};
	Acts.prototype.GoHome = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree && window.home)
			window.home();
	};
	Acts.prototype.GoToURL = function (url)
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["openURL"](url);
		else if (this.runtime.isEjecta)
			ejecta["openURL"](url);
		else if (this.runtime.isWinJS)
			Windows["System"]["Launcher"]["launchUriAsync"](new Windows["Foundation"]["Uri"](url));
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.location = url;
	};
	Acts.prototype.GoToURLWindow = function (url, tag)
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["openURL"](url);
		else if (this.runtime.isEjecta)
			ejecta["openURL"](url);
		else if (this.runtime.isWinJS)
			Windows["System"]["Launcher"]["launchUriAsync"](new Windows["Foundation"]["Uri"](url));
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.open(url, tag);
	};
	Acts.prototype.Reload = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree)
			window.location.reload();
	};
	var firstRequestFullscreen = true;
	var crruntime = null;
	function onFullscreenError()
	{
		if (typeof jQuery !== "undefined")
		{
			crruntime["setSize"](jQuery(window).width(), jQuery(window).height());
		}
	};
	Acts.prototype.RequestFullScreen = function (stretchmode)
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Requesting fullscreen is not supported on this platform - the request has been ignored");
			return;
		}
		if (stretchmode >= 2)
			stretchmode += 1;
		if (stretchmode === 6)
			stretchmode = 2;
		if (this.runtime.isNodeWebkit)
		{
			if (!this.runtime.isNodeFullscreen)
			{
				window["nwgui"]["Window"]["get"]()["enterFullscreen"]();
				this.runtime.isNodeFullscreen = true;
				this.runtime.fullscreen_scaling = (stretchmode >= 2 ? stretchmode : 0);
			}
		}
		else
		{
			if (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"])
			{
				return;
			}
			this.runtime.fullscreen_scaling = (stretchmode >= 2 ? stretchmode : 0);
			var elem = this.runtime.canvasdiv || this.runtime.canvas;
			if (firstRequestFullscreen)
			{
				firstRequestFullscreen = false;
				crruntime = this.runtime;
				elem.addEventListener("mozfullscreenerror", onFullscreenError);
				elem.addEventListener("webkitfullscreenerror", onFullscreenError);
				elem.addEventListener("msfullscreenerror", onFullscreenError);
				elem.addEventListener("fullscreenerror", onFullscreenError);
			}
			if (!cr.is_undefined(elem["requestFullscreen"]))
				elem["requestFullscreen"]();
			else if (!cr.is_undefined(elem["webkitRequestFullScreen"]))
			{
				if (typeof Element !== "undefined" && typeof Element["ALLOW_KEYBOARD_INPUT"] !== "undefined")
					elem["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"]);
				else
					elem["webkitRequestFullScreen"]();
			}
			else if (!cr.is_undefined(elem["mozRequestFullScreen"]))
				elem["mozRequestFullScreen"]();
			else if (!cr.is_undefined(elem["msRequestFullscreen"]))
				elem["msRequestFullscreen"]();
		}
	};
	Acts.prototype.CancelFullScreen = function ()
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Exiting fullscreen is not supported on this platform - the request has been ignored");
			return;
		}
		if (this.runtime.isNodeWebkit)
		{
			if (this.runtime.isNodeFullscreen)
			{
				window["nwgui"]["Window"]["get"]()["leaveFullscreen"]();
				this.runtime.isNodeFullscreen = false;
			}
		}
		else
		{
			if (!cr.is_undefined(document["exitFullscreen"]))
				document["exitFullscreen"]();
			else if (!cr.is_undefined(document["webkitCancelFullScreen"]))
				document["webkitCancelFullScreen"]();
			else if (!cr.is_undefined(document["mozCancelFullScreen"]))
				document["mozCancelFullScreen"]();
			else if (!cr.is_undefined(document["msExitFullscreen"]))
				document["msExitFullscreen"]();
		}
	};
	Acts.prototype.Vibrate = function (pattern_)
	{
		try {
			var arr = pattern_.split(",");
			var i, len;
			for (i = 0, len = arr.length; i < len; i++)
			{
				arr[i] = parseInt(arr[i], 10);
			}
			if (navigator["vibrate"])
				navigator["vibrate"](arr);
			else if (navigator["mozVibrate"])
				navigator["mozVibrate"](arr);
			else if (navigator["webkitVibrate"])
				navigator["webkitVibrate"](arr);
			else if (navigator["msVibrate"])
				navigator["msVibrate"](arr);
		}
		catch (e) {}
	};
	Acts.prototype.InvokeDownload = function (url_, filename_)
	{
		var a = document.createElement("a");
		if (typeof a["download"] === "undefined")
		{
			window.open(url_);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename_;
			a.href = url_;
			a["download"] = filename_;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	Acts.prototype.InvokeDownloadString = function (str_, mimetype_, filename_)
	{
		var datauri = "data:" + mimetype_ + "," + encodeURIComponent(str_);
		var a = document.createElement("a");
		if (typeof a["download"] === "undefined")
		{
			window.open(datauri);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename_;
			a.href = datauri;
			a["download"] = filename_;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	Acts.prototype.ConsoleLog = function (type_, msg_)
	{
		if (typeof console === "undefined")
			return;
		if (type_ === 0 && console.log)
			console.log(msg_.toString());
		if (type_ === 1 && console.warn)
			console.warn(msg_.toString());
		if (type_ === 2 && console.error)
			console.error(msg_.toString());
	};
	Acts.prototype.ConsoleGroup = function (name_)
	{
		if (console && console.group)
			console.group(name_);
	};
	Acts.prototype.ConsoleGroupEnd = function ()
	{
		if (console && console.groupEnd)
			console.groupEnd();
	};
	Acts.prototype.ExecJs = function (js_)
	{
		if (eval)
			eval(js_);
	};
	var orientations = [
		"portrait",
		"landscape",
		"portrait-primary",
		"portrait-secondary",
		"landscape-primary",
		"landscape-secondary"
	];
	Acts.prototype.LockOrientation = function (o)
	{
		o = Math.floor(o);
		if (o < 0 || o >= orientations.length)
			return;
		this.runtime.autoLockOrientation = false;
		var orientation = orientations[o];
		if (screen["lockOrientation"])
			screen["lockOrientation"](orientation);
		else if (screen["webkitLockOrientation"])
			screen["webkitLockOrientation"](orientation);
		else if (screen["mozLockOrientation"])
			screen["mozLockOrientation"](orientation);
		else if (screen["msLockOrientation"])
			screen["msLockOrientation"](orientation);
	};
	Acts.prototype.UnlockOrientation = function ()
	{
		this.runtime.autoLockOrientation = false;
		if (screen["unlockOrientation"])
			screen["unlockOrientation"]();
		else if (screen["webkitUnlockOrientation"])
			screen["webkitUnlockOrientation"]();
		else if (screen["mozUnlockOrientation"])
			screen["mozUnlockOrientation"]();
		else if (screen["msUnlockOrientation"])
			screen["msUnlockOrientation"]();
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.URL = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.toString());
	};
	Exps.prototype.Protocol = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.protocol);
	};
	Exps.prototype.Domain = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.hostname);
	};
	Exps.prototype.PathName = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.pathname);
	};
	Exps.prototype.Hash = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.hash);
	};
	Exps.prototype.Referrer = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : document.referrer);
	};
	Exps.prototype.Title = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : document.title);
	};
	Exps.prototype.Name = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.appName);
	};
	Exps.prototype.Version = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.appVersion);
	};
	Exps.prototype.Language = function (ret)
	{
		if (navigator && navigator.language)
			ret.set_string(navigator.language);
		else
			ret.set_string("");
	};
	Exps.prototype.Platform = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.platform);
	};
	Exps.prototype.Product = function (ret)
	{
		if (navigator && navigator.product)
			ret.set_string(navigator.product);
		else
			ret.set_string("");
	};
	Exps.prototype.Vendor = function (ret)
	{
		if (navigator && navigator.vendor)
			ret.set_string(navigator.vendor);
		else
			ret.set_string("");
	};
	Exps.prototype.UserAgent = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.userAgent);
	};
	Exps.prototype.QueryString = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.search);
	};
	Exps.prototype.QueryParam = function (ret, paramname)
	{
		if (this.runtime.isDomFree)
		{
			ret.set_string("");
			return;
		}
		var match = RegExp('[?&]' + paramname + '=([^&]*)').exec(window.location.search);
		if (match)
			ret.set_string(decodeURIComponent(match[1].replace(/\+/g, ' ')));
		else
			ret.set_string("");
	};
	Exps.prototype.Bandwidth = function (ret)
	{
		var connection = navigator["connection"] || navigator["mozConnection"] || navigator["webkitConnection"];
		if (!connection)
			ret.set_float(Number.POSITIVE_INFINITY);
		else
			ret.set_float(connection["bandwidth"]);
	};
	Exps.prototype.BatteryLevel = function (ret)
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			ret.set_float(1);
		else
			ret.set_float(battery["level"]);
	};
	Exps.prototype.BatteryTimeLeft = function (ret)
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			ret.set_float(Number.POSITIVE_INFINITY);
		else
			ret.set_float(battery["dischargingTime"]);
	};
	Exps.prototype.ExecJS = function (ret, js_)
	{
		if (!eval)
		{
			ret.set_any(0);
			return;
		}
		var result = eval(js_);
		if (typeof result === "number")
			ret.set_any(result);
		else if (typeof result === "string")
			ret.set_any(result);
		else if (typeof result === "boolean")
			ret.set_any(result ? 1 : 0);
		else
			ret.set_any(0);
	};
	Exps.prototype.ScreenWidth = function (ret)
	{
		ret.set_int(screen.width);
	};
	Exps.prototype.ScreenHeight = function (ret)
	{
		ret.set_int(screen.height);
	};
	Exps.prototype.DevicePixelRatio = function (ret)
	{
		ret.set_float(this.runtime.devicePixelRatio);
	};
	pluginProto.exps = new Exps();
}());
;
;
/**
* Object holder for the plugin
*/
cr.plugins_.CJSAds = function(runtime)
{
	this.runtime = runtime;
};
/**
* C2 plugin
*/
(function ()
{
	var input_text = "";
	var products_list = [];
	var requested_score = 0;
	var showBanner = true;
	var bannerPosition = 0;
	var preloadingBanner = false;
	var bannerReady = false;
	var preloadingFullscreen = false;
	var fullscreenReady = false;
	var pluginProto = cr.plugins_.CJSAds.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	/**
	* C2 specific behaviour
	*/
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var self;
	instanceProto.onCreate = function()
	{
		this.isShowingBanner  		= false;
		this.isShowingFullscreen 	= false;
		this.triggerProduct 		= "";
		this.socialService 			= null;
		this.socialServiceAvailable = false;
		this.socialServiceSelected 	= this.properties[2];
		this.storeServiceAvailable 	= (this.runtime.isCocoonJs && typeof CocoonJS["Store"]["nativeExtensionObjectAvailable"] !== "undefined");
		this.storeManaged 			= (this.properties[1] !== 1);
		this.storeSandboxed 		= (this.properties[3] !== 0);
		this.socialServiceClientID 	= this.properties[4];
		this.onConsumePurchaseFailedTransactionId 	= "";
		this.onConsumePurchaseCompleted 			= "";
		self = this;
		if (this.runtime.isCocoonJs)
		{
			CocoonJS["App"]["onTextDialogFinished"].addEventListener(function(text) {
				input_text = text;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardOK, self);
			});
			CocoonJS["App"]["onTextDialogCancelled"].addEventListener(function() {
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled, self);
			});
			CocoonJS["Ad"]["onBannerShown"].addEventListener(function ()
			{
				self.isShowingBanner = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnBannerShown, self);
			});
			CocoonJS["Ad"]["onBannerReady"].addEventListener(function ()
			{
				bannerReady = true;
				if (!preloadingBanner)
				{
					if(showBanner){
						CocoonJS["Ad"]["setBannerLayout"](bannerPosition);
						CocoonJS["Ad"]["showBanner"]();
					}
				}
			});
			CocoonJS["Ad"]["onFullScreenShown"].addEventListener(function ()
			{
				self.isShowingFullscreen = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenShown, self);
			});
			CocoonJS["Ad"]["onFullScreenHidden"].addEventListener(function ()
			{
				self.isShowingFullscreen = false;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenHidden, self);
			});
			CocoonJS["Ad"]["onFullScreenReady"].addEventListener(function ()
			{
				fullscreenReady = true;
				if (!preloadFullScreen)
					CocoonJS["Ad"]["showFullScreen"]();
			});
			if (this.storeServiceAvailable)
			{
				CocoonJS["Store"]["onProductPurchaseCompleted"].addEventListener(function (purchase)
				{
					self.triggerProduct = purchase["productId"];
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete, self);
					CocoonJS["Store"]["addPurchase"](purchase);
					CocoonJS["Store"]["consumePurchase"](purchase["transactionId"], purchase["productId"]);
					CocoonJS["Store"]["finishPurchase"](purchase["transactionId"]);
				});
				CocoonJS["Store"]["onConsumePurchaseFailed"].addEventListener(function(transactionId, errorMessage)
				{
					console.log(JSON.stringify(errorMessage));
					this.onConsumePurchaseFailedTransactionId = transactionId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseFailed, self);
				});
				CocoonJS["Store"]["onConsumePurchaseCompleted"].addEventListener(function(transactionId)
				{
					this.onConsumePurchaseCompleted = transactionId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseCompleted, self);
				});
				CocoonJS["Store"]["onProductPurchaseFailed"].addEventListener(function (productId, errorMsg)
				{
					self.triggerProduct = productId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail, self);
				});
				CocoonJS["Store"]["onProductPurchaseStarted"].addEventListener(function (productinfo)
				{
					self.triggerProduct = (productinfo["productId"]) ? productinfo["productId"] : productinfo;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart, self);
				});
				CocoonJS["Store"]["onProductsFetchStarted"].addEventListener(function ()
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchStarted, self);
				});
				CocoonJS["Store"]["onProductsFetchFailed"].addEventListener(function ()
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed, self);
				});
				CocoonJS["Store"]["onProductsFetchCompleted"].addEventListener(function (products)
				{
					for (var i = products.length - 1; i >= 0; i--) {
						CocoonJS["Store"]["addProduct"](products[i]);
						console.log("Adding product to the local database: "+ JSON.stringify(products[i]));
					};
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted, self);
				});
				CocoonJS["Store"]["requestInitialization"]({
					"managed": this.storeManaged,
					"sandbox": this.storeSandboxed
				});
				CocoonJS["Store"]["start"]();
			}
			/**
			* No social service selected, return.
			*/
			if(this.socialServiceSelected === 0) return;
			/*l
			* Set the social interface for the selected service
			*/
			function startGameCenter(){
				console.log("GameCenter selected as social service");
				this.socialService = CocoonJS["Social"]["GameCenter"];
				if(this.socialService){
					if(!!this.socialService["nativeExtensionObjectAvailable"])
					this.socialServiceInterface = this.socialService.getSocialInterface();
				}else{
					throw new Error("Cannot find GameCenter service, are you using the latest CocoonJS Extensions?");
				}
			}
			function startGooglePlay(){
				console.log("GooglePlayGames selected as social service");
				this.socialService = CocoonJS["Social"]["GooglePlayGames"];
				if(this.socialService){
					var config = {};
					if(this.socialServiceClientID) config.clientId = this.socialServiceClientID;
					this.socialService.init(config);
					if(!!this.socialService["nativeExtensionObjectAvailable"]){
						this.socialServiceInterface = this.socialService.getSocialInterface();
					}
				}else{
					throw new Error("Cannot find GooglePlayGames service, are you using the latest CocoonJS Extensions?");
				}
			}
			if(this.socialServiceSelected === 2) startGameCenter.apply(this,[]);
			if(this.socialServiceSelected === 3) startGooglePlay.apply(this,[]);
			if(this.socialServiceSelected === 1){
				if(CocoonJS["Social"]["GooglePlayGames"]["nativeExtensionObjectAvailable"]){
					startGooglePlay.apply(this,[]);
				}else if(CocoonJS["Social"]["GameCenter"]["nativeExtensionObjectAvailable"]){
					startGameCenter.apply(this,[]);
				}else{
					return;
				}
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.IsShowingBanner = function ()
	{
		return this.isShowingBanner;
	};
	Cnds.prototype.IsCocoonJS = function ()
	{
		return this.runtime.isCocoonJs;
	};
	Cnds.prototype.OnBannerShown = function ()
	{
		return true;
	};
	Cnds.prototype.OnFullscreenShown = function ()
	{
		return true;
	};
	Cnds.prototype.OnFullscreenHidden = function ()
	{
		return true;
	};
	Cnds.prototype.IsShowingFullscreen = function ()
	{
		return this.isShowingFullscreen;
	};
	Cnds.prototype.IsStoreAvailable = function ()
	{
		if (this.runtime.isCocoonJs)
			return this.storeServiceAvailable && CocoonJS["Store"]["canPurchase"]();
		else
			return false;
	};
	Cnds.prototype.OnPurchaseStart = function (productid)
	{
		console.log("Cnds.prototype.OnPurchaseStart" + " - " + productid + " - " + this.triggerProduct);
		return this.triggerProduct === productid;
	};
	Cnds.prototype.OnPurchaseComplete = function (productid)
	{
		console.log("Cnds.prototype.OnPurchaseComplete" + " - " + productid + " - " + this.triggerProduct);
		return this.triggerProduct === productid;
	};
	Cnds.prototype.OnPurchaseFail = function (productid)
	{
		console.log("Cnds.prototype.OnPurchaseFail" + " - " + productid + " - " + this.triggerProduct);
		return this.triggerProduct === productid;
	};
	Cnds.prototype.onProductsFetchStarted = function(){
		return true;
	}
	Cnds.prototype.onConsumePurchaseFailed = function(){
		return true;
	}
	Cnds.prototype.onProductsFetchCompleted = function(){
		return true;
	}
	Cnds.prototype.onProductsFetchFailed = function(){
		return true;
	}
	Cnds.prototype.IsProductPurchased = function (productid)
	{
		if (this.runtime.isCocoonJs)
			return CocoonJS["Store"]["isProductPurchased"](productid);
		else
			return false;
	};
	Cnds.prototype.OnKeyboardCancelled = function ()
	{
		return true;
	};
	Cnds.prototype.OnKeyboardOK = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceLoginSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceLoginFailed = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceSubmitScoreSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceSubmitScoreFailed = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceRequestScoreSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceRequestScoreFailed = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceOpenLeaderBoardSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceOpenLeaderBoardClosed = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceOpenAchievementsSuccess = function(){
		return true;
	};
	Cnds.prototype.onSocialServiceOpenAchievementsClosed = function(){
		return true;
	};
	Cnds.prototype.onSocialServiceResetAchievementsCompleted = function(){
		return true;
	};
	Cnds.prototype.onSocialServiceResetAchievementsFailed = function(){
		return true;
	};
	Cnds.prototype.onSocialServiceSubmitAchievementCompleted = function(){
		return true;
	};
	Cnds.prototype.onSocialServiceSubmitAchievementFailed = function(){
		return true;
	};
	pluginProto.cnds = new Cnds();
	/**
	* Plugin actions
	*/
	function Acts() {};
	Acts.prototype.ShowBanner = function (layout_)
	{
		if (!this.runtime.isCocoonJs)
			return;
		bannerPosition = (layout_ === 0 ? CocoonJS["Ad"]["BannerLayout"]["TOP_CENTER"] : CocoonJS["Ad"]["BannerLayout"]["BOTTOM_CENTER"]);
		preloadingBanner = false;
		if (bannerReady)
		{
			showBanner = true;
			CocoonJS["Ad"]["setBannerLayout"](bannerPosition);
			CocoonJS["Ad"]["showBanner"]();
		}
		else
		{
			CocoonJS["Ad"]["preloadBanner"]();
		}
	};
	Acts.prototype.ShowFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingFullscreen = false;
		if (fullscreenReady)
			CocoonJS["Ad"]["showFullScreen"]();
		else
			CocoonJS["Ad"]["preloadFullScreen"]();
	};
	Acts.prototype.HideBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		showBanner = false;
		CocoonJS["Ad"]["hideBanner"]();
		this.isShowingBanner = false;
	};
	Acts.prototype.PreloadBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingBanner = true;
		CocoonJS["Ad"]["preloadBanner"]();
	};
	Acts.prototype.PreloadFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingFullscreen = true;
		CocoonJS["Ad"]["preloadFullScreen"]();
	};
	Acts.prototype.RefreshBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["refreshBanner"]();
	};
	Acts.prototype.RefreshFullScreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["refreshFullScreen"]();
	};
	Acts.prototype.Purchase = function (productid)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["purchaseProduct"](productid);
	};
	Acts.prototype.fetchProductsFromStore = function (products)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["fetchProductsFromStore"](products.split(","));
	};
	Acts.prototype.PurchasePreview = function (productid)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["purchaseProductModalWithPreview"](productid);
	};
	Acts.prototype.RestorePurchases = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["restorePurchases"]();
	};
	Acts.prototype.PromptKeyboard = function (title_, message_, initial_, type_, canceltext_, oktext_)
	{
		if (!this.runtime.isCocoonJs)
			return;
		var typestr = ["text", "num", "phone", "email", "url"][type_];
		CocoonJS["App"]["showTextDialog"](title_, message_, initial_, typestr, canceltext_, oktext_);
	};
	Acts.prototype.UpdateProductsList = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		if (!CocoonJS["Store"]["canPurchase"]())
			return;
		products_list = CocoonJS["Store"]["getProducts"]();
	};
	/**
	* Social service actions
	*/
	function socialServiceRequestLoginCallback(isAuthenticated, error){
		if(isAuthenticated){
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceLoginSuccess, self);
		}else{
			console.log(error);
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenLeaderBoardClosed, self);
		}
	};
	Acts.prototype.socialServiceRequestLogin = function ()
	{
		if(this.socialServiceInterface.isLoggedIn()){
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceLoginSuccess, self);
		}else{
			this.socialServiceInterface.login(socialServiceRequestLoginCallback);
		}
	};
	Acts.prototype.socialServiceRequestLogout = function ()
	{
		if(this.socialServiceInterface.isLoggedIn())
			this.socialServiceInterface.logout(socialServiceRequestLoginCallback);
	};
	function socialServiceSubmitScoreCallback(err){
		if(!err){
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitScoreSuccess, self);
		}else{
			console.log(err);
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitScoreFailed, self);
		}
	};
	Acts.prototype.socialServiceSubmitScore = function (score_, leaderboard_)
	{
		if(this.socialServiceInterface.isLoggedIn())
			this.socialServiceInterface.submitScore(
				score_,
				socialServiceSubmitScoreCallback,
				{ leaderboardID : leaderboard_ }
			);
	};
	function socialServiceRequestScoreCallback(loadedScore, err){
		if(!err){
			requested_score = loadedScore.score || 0;
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceRequestScoreSuccess, self);
		}else{
			console.log(err);
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceRequestScoreFailed, self);
		}
	};
	Acts.prototype.socialServiceRequestScore = function (leaderboard_)
	{
		if(this.socialServiceInterface.isLoggedIn())
			this.socialServiceInterface.requestScore(
				socialServiceRequestScoreCallback,
				{ leaderboardID : leaderboard_ } );
	};
	function socialServiceOpenLeaderboardCallback(err){
		if(err){
			console.log(err);
		}
		self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenLeaderBoardClosed, self);
	};
	Acts.prototype.socialServiceOpenLeaderboard = function (leaderboard_)
	{
		if(!this.socialServiceInterface.isLoggedIn()) return;
		self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenLeaderBoardSuccess, self);
		this.socialServiceInterface.showLeaderboard(
			socialServiceOpenLeaderboardCallback,
			{ leaderboardID : leaderboard_}
		);
	};
	function socialServiceOpenAchievementsCallback(err){
		if(err){
			console.log(err);
		}
		self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenAchievementsClosed, self);
	}
	Acts.prototype.socialServiceOpenAchievements = function(){
		if(!this.socialServiceInterface.isLoggedIn()) return;
		self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenAchievementsSuccess, self);
		this.socialServiceInterface.showAchievements(socialServiceOpenAchievementsCallback);
	};
	function socialServiceResetAchievementsCallback(err){
		if(err){
			try{
				console.log(JSON.stringify(err));
			}catch(e){
				for(var prop in err){
					console.log(err[prop]);
				}
				console.log(e);
			}
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceResetAchievementsFailed, self);
		}else{
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceResetAchievementsCompleted, self);
		}
	}
	Acts.prototype.socialServiceResetAchievements = function(){
		if(!this.socialServiceInterface.isLoggedIn()) return;
		this.socialServiceInterface.resetAchievements(socialServiceResetAchievementsCallback);
	};
	function socialServiceSubmitAchievementCallback(err){
		if(err){
			try{
				console.log(JSON.stringify(err));
			}catch(e){
				for(var prop in err){
					console.log(err[prop]);
				}
				console.log(e);
			}
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitAchievementFailed, self);
		}else{
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitAchievementCompleted, self);
		}
	}
	Acts.prototype.socialServiceSubmitAchievement = function(_achievementId){
		if(!this.socialServiceInterface.isLoggedIn()) return;
		this.socialServiceInterface.submitAchievement(_achievementId, socialServiceSubmitAchievementCallback);
	};
	pluginProto.acts = new Acts();
	/**
	* Expressions
	*/
	function Exps() {};
	Exps.prototype.InputText = function (ret)
	{
		ret.set_string(input_text);
	};
	Exps.prototype.ProductCount = function (ret)
	{
		ret.set_int(products_list.length);
	};
	Exps.prototype.ProductDescription = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["description"]);
	};
	Exps.prototype.ProductLocalizedPrice = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["localizedPrice"]);
	};
	Exps.prototype.ProductPrice = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["price"]);
	};
	Exps.prototype.ProductAlias = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["productAlias"]);
	};
	Exps.prototype.ProductID = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["productId"]);
	};
	Exps.prototype.ProductTitle = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["title"]);
	};
	Exps.prototype.PlayerScore = function (ret)
	{
		ret.set_float(requested_score);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Dictionary = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Dictionary.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.dictionary = {};
		this.cur_key = "";		// current key in for-each loop
		this.key_count = 0;
	};
	instanceProto.saveToJSON = function ()
	{
		return this.dictionary;
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.dictionary = o;
		this.key_count = 0;
		for (var p in this.dictionary)
		{
			if (this.dictionary.hasOwnProperty(p))
				this.key_count++;
		}
	};
	function Cnds() {};
	Cnds.prototype.CompareValue = function (key_, cmp_, value_)
	{
		return cr.do_cmp(this.dictionary[key_], cmp_, value_);
	};
	Cnds.prototype.ForEachKey = function ()
	{
		var current_event = this.runtime.getCurrentEventStack().current_event;
		for (var p in this.dictionary)
		{
			if (this.dictionary.hasOwnProperty(p))
			{
				this.cur_key = p;
				this.runtime.pushCopySol(current_event.solModifiers);
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		this.cur_key = "";
		return false;
	};
	Cnds.prototype.CompareCurrentValue = function (cmp_, value_)
	{
		return cr.do_cmp(this.dictionary[this.cur_key], cmp_, value_);
	};
	Cnds.prototype.HasKey = function (key_)
	{
		return this.dictionary.hasOwnProperty(key_);
	};
	Cnds.prototype.IsEmpty = function ()
	{
		return this.key_count === 0;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.AddKey = function (key_, value_)
	{
		if (!this.dictionary.hasOwnProperty(key_))
			this.key_count++;
		this.dictionary[key_] = value_;
	};
	Acts.prototype.SetKey = function (key_, value_)
	{
		if (this.dictionary.hasOwnProperty(key_))
			this.dictionary[key_] = value_;
	};
	Acts.prototype.DeleteKey = function (key_)
	{
		if (this.dictionary.hasOwnProperty(key_))
		{
			delete this.dictionary[key_];
			this.key_count--;
		}
	};
	Acts.prototype.Clear = function ()
	{
		cr.wipe(this.dictionary);		// avoid garbaging
		this.key_count = 0;
	};
	Acts.prototype.JSONLoad = function (json_)
	{
		var o;
		try {
			o = JSON.parse(json_);
		}
		catch(e) { return; }
		if (!o["c2dictionary"])		// presumably not a c2dictionary object
			return;
		this.dictionary = o["data"];
		this.key_count = 0;
		for (var p in this.dictionary)
		{
			if (this.dictionary.hasOwnProperty(p))
				this.key_count++;
		}
	};
	Acts.prototype.JSONDownload = function (filename)
	{
		var a = document.createElement("a");
		if (typeof a.download === "undefined")
		{
			var str = 'data:text/html,' + encodeURIComponent("<p><a download='data.json' href=\"data:application/json,"
				+ encodeURIComponent(JSON.stringify({
						"c2dictionary": true,
						"data": this.dictionary
					}))
				+ "\">Download link</a></p>");
			window.open(str);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename;
			a.href = "data:application/json," + encodeURIComponent(JSON.stringify({
						"c2dictionary": true,
						"data": this.dictionary
					}));
			a.download = filename;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Get = function (ret, key_)
	{
		if (this.dictionary.hasOwnProperty(key_))
			ret.set_any(this.dictionary[key_]);
		else
			ret.set_int(0);
	};
	Exps.prototype.KeyCount = function (ret)
	{
		ret.set_int(this.key_count);
	};
	Exps.prototype.CurrentKey = function (ret)
	{
		ret.set_string(this.cur_key);
	};
	Exps.prototype.CurrentValue = function (ret)
	{
		if (this.dictionary.hasOwnProperty(this.cur_key))
			ret.set_any(this.dictionary[this.cur_key]);
		else
			ret.set_int(0);
	};
	Exps.prototype.AsJSON = function (ret)
	{
		ret.set_string(JSON.stringify({
			"c2dictionary": true,
			"data": this.dictionary
		}));
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Function = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Function.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var funcStack = [];
	var funcStackPtr = -1;
	var isInPreview = false;	// set in onCreate
	function FuncStackEntry()
	{
		this.name = "";
		this.retVal = 0;
		this.params = [];
	};
	function pushFuncStack()
	{
		funcStackPtr++;
		if (funcStackPtr === funcStack.length)
			funcStack.push(new FuncStackEntry());
		return funcStack[funcStackPtr];
	};
	function getCurrentFuncStack()
	{
		if (funcStackPtr < 0)
			return null;
		return funcStack[funcStackPtr];
	};
	function getOneAboveFuncStack()
	{
		if (!funcStack.length)
			return null;
		var i = funcStackPtr + 1;
		if (i >= funcStack.length)
			i = funcStack.length - 1;
		return funcStack[i];
	};
	function popFuncStack()
	{
;
		funcStackPtr--;
	};
	instanceProto.onCreate = function()
	{
		isInPreview = (typeof cr_is_preview !== "undefined");
	};
	function Cnds() {};
	Cnds.prototype.OnFunction = function (name_)
	{
		var fs = getCurrentFuncStack();
		if (!fs)
			return false;
		return cr.equals_nocase(name_, fs.name);
	};
	Cnds.prototype.CompareParam = function (index_, cmp_, value_)
	{
		var fs = getCurrentFuncStack();
		if (!fs)
			return false;
		index_ = cr.floor(index_);
		if (index_ < 0 || index_ >= fs.params.length)
			return false;
		return cr.do_cmp(fs.params[index_], cmp_, value_);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.CallFunction = function (name_, params_)
	{
		var fs = pushFuncStack();
		fs.name = name_.toLowerCase();
		fs.retVal = 0;
		cr.shallowAssignArray(fs.params, params_);
		var ran = this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction, this, fs.name);
		if (isInPreview && !ran)
		{
;
		}
		popFuncStack();
	};
	Acts.prototype.SetReturnValue = function (value_)
	{
		var fs = getCurrentFuncStack();
		if (fs)
			fs.retVal = value_;
		else
;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.ReturnValue = function (ret)
	{
		var fs = getOneAboveFuncStack();
		if (fs)
			ret.set_any(fs.retVal);
		else
			ret.set_int(0);
	};
	Exps.prototype.ParamCount = function (ret)
	{
		var fs = getCurrentFuncStack();
		if (fs)
			ret.set_int(fs.params.length);
		else
		{
;
			ret.set_int(0);
		}
	};
	Exps.prototype.Param = function (ret, index_)
	{
		index_ = cr.floor(index_);
		var fs = getCurrentFuncStack();
		if (fs)
		{
			if (index_ >= 0 && index_ < fs.params.length)
			{
				ret.set_any(fs.params[index_]);
			}
			else
			{
;
				ret.set_int(0);
			}
		}
		else
		{
;
			ret.set_int(0);
		}
	};
	Exps.prototype.Call = function (ret, name_)
	{
		var fs = pushFuncStack();
		fs.name = name_.toLowerCase();
		fs.retVal = 0;
		fs.params.length = 0;
		var i, len;
		for (i = 2, len = arguments.length; i < len; i++)
			fs.params.push(arguments[i]);
		var ran = this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction, this, fs.name);
		if (isInPreview && !ran)
		{
;
		}
		popFuncStack();
		ret.set_any(fs.retVal);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Keyboard = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Keyboard.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		this.keyMap = new Array(256);	// stores key up/down state
		this.usedKeys = new Array(256);
		this.triggerKey = 0;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		var self = this;
		if (!this.runtime.isDomFree)
		{
			jQuery(document).keydown(
				function(info) {
					self.onKeyDown(info);
				}
			);
			jQuery(document).keyup(
				function(info) {
					self.onKeyUp(info);
				}
			);
		}
	};
	var keysToBlockWhenFramed = [32, 33, 34, 35, 36, 37, 38, 39, 40, 44];
	instanceProto.onKeyDown = function (info)
	{
		var alreadyPreventedDefault = false;
		if (window != window.top && keysToBlockWhenFramed.indexOf(info.which) > -1)
		{
			info.preventDefault();
			alreadyPreventedDefault = true;
			info.stopPropagation();
		}
		if (this.keyMap[info.which])
		{
			if (this.usedKeys[info.which] && !alreadyPreventedDefault)
				info.preventDefault();
			return;
		}
		this.keyMap[info.which] = true;
		this.triggerKey = info.which;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnAnyKey, this);
		var eventRan = this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKey, this);
		var eventRan2 = this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyCode, this);
		this.runtime.isInUserInputEvent = false;
		if (eventRan || eventRan2)
		{
			this.usedKeys[info.which] = true;
			if (!alreadyPreventedDefault)
				info.preventDefault();
		}
	};
	instanceProto.onKeyUp = function (info)
	{
		this.keyMap[info.which] = false;
		this.triggerKey = info.which;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnAnyKeyReleased, this);
		var eventRan = this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyReleased, this);
		var eventRan2 = this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyCodeReleased, this);
		this.runtime.isInUserInputEvent = false;
		if (eventRan || eventRan2 || this.usedKeys[info.which])
		{
			this.usedKeys[info.which] = true;
			info.preventDefault();
		}
	};
	instanceProto.saveToJSON = function ()
	{
		return { "triggerKey": this.triggerKey };
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.triggerKey = o["triggerKey"];
	};
	function Cnds() {};
	Cnds.prototype.IsKeyDown = function(key)
	{
		return this.keyMap[key];
	};
	Cnds.prototype.OnKey = function(key)
	{
		return (key === this.triggerKey);
	};
	Cnds.prototype.OnAnyKey = function(key)
	{
		return true;
	};
	Cnds.prototype.OnAnyKeyReleased = function(key)
	{
		return true;
	};
	Cnds.prototype.OnKeyReleased = function(key)
	{
		return (key === this.triggerKey);
	};
	Cnds.prototype.IsKeyCodeDown = function(key)
	{
		key = Math.floor(key);
		if (key < 0 || key >= this.keyMap.length)
			return false;
		return this.keyMap[key];
	};
	Cnds.prototype.OnKeyCode = function(key)
	{
		return (key === this.triggerKey);
	};
	Cnds.prototype.OnKeyCodeReleased = function(key)
	{
		return (key === this.triggerKey);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.LastKeyCode = function (ret)
	{
		ret.set_int(this.triggerKey);
	};
	function fixedStringFromCharCode(kc)
	{
		kc = Math.floor(kc);
		switch (kc) {
		case 8:		return "backspace";
		case 9:		return "tab";
		case 13:	return "enter";
		case 16:	return "shift";
		case 17:	return "control";
		case 18:	return "alt";
		case 19:	return "pause";
		case 20:	return "capslock";
		case 27:	return "esc";
		case 33:	return "pageup";
		case 34:	return "pagedown";
		case 35:	return "end";
		case 36:	return "home";
		case 37:	return "←";
		case 38:	return "↑";
		case 39:	return "→";
		case 40:	return "↓";
		case 45:	return "insert";
		case 46:	return "del";
		case 91:	return "left window key";
		case 92:	return "right window key";
		case 93:	return "select";
		case 96:	return "numpad 0";
		case 97:	return "numpad 1";
		case 98:	return "numpad 2";
		case 99:	return "numpad 3";
		case 100:	return "numpad 4";
		case 101:	return "numpad 5";
		case 102:	return "numpad 6";
		case 103:	return "numpad 7";
		case 104:	return "numpad 8";
		case 105:	return "numpad 9";
		case 106:	return "numpad *";
		case 107:	return "numpad +";
		case 109:	return "numpad -";
		case 110:	return "numpad .";
		case 111:	return "numpad /";
		case 112:	return "F1";
		case 113:	return "F2";
		case 114:	return "F3";
		case 115:	return "F4";
		case 116:	return "F5";
		case 117:	return "F6";
		case 118:	return "F7";
		case 119:	return "F8";
		case 120:	return "F9";
		case 121:	return "F10";
		case 122:	return "F11";
		case 123:	return "F12";
		case 144:	return "numlock";
		case 145:	return "scroll lock";
		case 186:	return ";";
		case 187:	return "=";
		case 188:	return ",";
		case 189:	return "-";
		case 190:	return ".";
		case 191:	return "/";
		case 192:	return "'";
		case 219:	return "[";
		case 220:	return "\\";
		case 221:	return "]";
		case 222:	return "#";
		case 223:	return "`";
		default:	return String.fromCharCode(kc);
		}
	};
	Exps.prototype.StringFromKeyCode = function (ret, kc)
	{
		ret.set_string(fixedStringFromCharCode(kc));
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.NinePatch = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.NinePatch.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.texture_img.cr_filesize = this.texture_filesize;
		this.runtime.waitForImageLoad(this.texture_img);
		this.fillPattern = null;
		this.leftPattern = null;
		this.rightPattern = null;
		this.topPattern = null;
		this.bottomPattern = null;
		this.webGL_texture = null;
		this.webGL_fillTexture = null;
		this.webGL_leftTexture = null;
		this.webGL_rightTexture = null;
		this.webGL_topTexture = null;
		this.webGL_bottomTexture = null;
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.webGL_texture = null;
		this.webGL_fillTexture = null;
		this.webGL_leftTexture = null;
		this.webGL_rightTexture = null;
		this.webGL_topTexture = null;
		this.webGL_bottomTexture = null;
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		if (!this.webGL_texture)
		{
			this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, true, this.runtime.linearSampling, this.texture_pixelformat);
		}
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length)
			return;
		if (this.runtime.glwrap)
		{
			this.runtime.glwrap.deleteTexture(this.webGL_texture);
			this.runtime.glwrap.deleteTexture(this.webGL_fillTexture);
			this.runtime.glwrap.deleteTexture(this.webGL_leftTexture);
			this.runtime.glwrap.deleteTexture(this.webGL_rightTexture);
			this.runtime.glwrap.deleteTexture(this.webGL_topTexture);
			this.runtime.glwrap.deleteTexture(this.webGL_bottomTexture);
			this.webGL_texture = null;
			this.webGL_fillTexture = null;
			this.webGL_leftTexture = null;
			this.webGL_rightTexture = null;
			this.webGL_topTexture = null;
			this.webGL_bottomTexture = null;
		}
	};
	typeProto.slicePatch = function (x1, y1, x2, y2)
	{
		var tmpcanvas = document.createElement("canvas");
		var w = x2 - x1;
		var h = y2 - y1;
		tmpcanvas.width = w;
		tmpcanvas.height = h;
		var tmpctx = tmpcanvas.getContext("2d");
		tmpctx.drawImage(this.texture_img, x1, y1, w, h, 0, 0, w, h);
		return tmpcanvas;
	};
	typeProto.createPatch = function (lm, rm, tm, bm)
	{
		var iw = this.texture_img.width;
		var ih = this.texture_img.height;
		var re = iw - rm;
		var be = ih - bm;
		if (this.runtime.glwrap)
		{
			if (this.webGL_fillTexture)
				return;		// already created
			var glwrap = this.runtime.glwrap;
			var ls = this.runtime.linearSampling;
			var tf = this.texture_pixelformat;
			if (re > lm && be > tm)
				this.webGL_fillTexture = glwrap.loadTexture(this.slicePatch(lm, tm, re, be), true, ls, tf);
			if (lm > 0 && be > tm)
				this.webGL_leftTexture = glwrap.loadTexture(this.slicePatch(0, tm, lm, be), true, ls, tf, "repeat-y");
			if (rm > 0 && be > tm)
				this.webGL_rightTexture = glwrap.loadTexture(this.slicePatch(re, tm, iw, be), true, ls, tf, "repeat-y");
			if (tm > 0 && re > lm)
				this.webGL_topTexture = glwrap.loadTexture(this.slicePatch(lm, 0, re, tm), true, ls, tf, "repeat-x");
			if (bm > 0 && re > lm)
				this.webGL_bottomTexture = glwrap.loadTexture(this.slicePatch(lm, be, re, ih), true, ls, tf, "repeat-x");
		}
		else
		{
			if (this.fillPattern)
				return;		// already created
			var ctx = this.runtime.ctx;
			if (re > lm && be > tm)
				this.fillPattern = ctx.createPattern(this.slicePatch(lm, tm, re, be), "repeat");
			if (lm > 0 && be > tm)
				this.leftPattern = ctx.createPattern(this.slicePatch(0, tm, lm, be), "repeat");
			if (rm > 0 && be > tm)
				this.rightPattern = ctx.createPattern(this.slicePatch(re, tm, iw, be), "repeat");
			if (tm > 0 && re > lm)
				this.topPattern = ctx.createPattern(this.slicePatch(lm, 0, re, tm), "repeat");
			if (bm > 0 && re > lm)
				this.bottomPattern = ctx.createPattern(this.slicePatch(lm, be, re, ih), "repeat");
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.leftMargin = this.properties[0];
		this.rightMargin = this.properties[1];
		this.topMargin = this.properties[2];
		this.bottomMargin = this.properties[3];
		this.edges = this.properties[4];					// 0=tile, 1=stretch
		this.fill = this.properties[5];						// 0=tile, 1=stretch, 2=transparent
		this.visible = (this.properties[6] === 0);			// 0=visible, 1=invisible
		this.seamless = (this.properties[8] !== 0);			// 1px overdraw to hide seams
		if (this.recycled)
			this.rcTex.set(0, 0, 0, 0);
		else
			this.rcTex = new cr.rect(0, 0, 0, 0);
		if (this.runtime.glwrap)
		{
			if (!this.type.webGL_texture)
			{
				this.type.webGL_texture = this.runtime.glwrap.loadTexture(this.type.texture_img, false, this.runtime.linearSampling, this.type.texture_pixelformat);
			}
		}
		this.type.createPatch(this.leftMargin, this.rightMargin, this.topMargin, this.bottomMargin);
	};
	function drawPatternProperly(ctx, pattern, pw, ph, drawX, drawY, w, h, ox, oy)
	{
		ctx.save();
		ctx.fillStyle = pattern;
		var offX = drawX % pw;
		var offY = drawY % ph;
		if (offX < 0)
			offX += pw;
		if (offY < 0)
			offY += ph;
		ctx.translate(offX + ox, offY + oy);
		ctx.fillRect(drawX - offX - ox, drawY - offY - oy, w, h);
		ctx.restore();
	};
	instanceProto.draw = function(ctx)
	{
		var img = this.type.texture_img;
		var lm = this.leftMargin;
		var rm = this.rightMargin;
		var tm = this.topMargin;
		var bm = this.bottomMargin;
		var iw = img.width;
		var ih = img.height;
		var re = iw - rm;
		var be = ih - bm;
		ctx.globalAlpha = this.opacity;
		ctx.save();
		var myx = this.x;
		var myy = this.y;
		var myw = this.width;
		var myh = this.height;
		if (this.runtime.pixel_rounding)
		{
			myx = (myx + 0.5) | 0;
			myy = (myy + 0.5) | 0;
		}
		var drawX = -(this.hotspotX * this.width);
		var drawY = -(this.hotspotY * this.height);
		var offX = drawX % iw;
		var offY = drawY % ih;
		if (offX < 0)
			offX += iw;
		if (offY < 0)
			offY += ih;
		ctx.translate(myx + offX, myy + offY);
		var x = drawX - offX;
		var y = drawY - offY;
		var s = (this.seamless ? 1 : 0);
		if (lm > 0 && tm > 0)
			ctx.drawImage(img, 0, 0, lm + s, tm + s, x, y, lm + s, tm + s);
		if (rm > 0 && tm > 0)
			ctx.drawImage(img, re - s, 0, rm + s, tm + s, x + myw - rm - s, y, rm + s, tm + s);
		if (rm > 0 && bm > 0)
			ctx.drawImage(img, re - s, be - s, rm + s, bm + s, x + myw - rm - s, y + myh - bm - s, rm + s, bm + s);
		if (lm > 0 && bm > 0)
			ctx.drawImage(img, 0, be - s, lm + s, bm + s, x, y + myh - bm - s, lm + s, bm + s);
		if (this.edges === 0)		// tile edges
		{
			var off = (this.fill === 2 ? 0 : s);
			if (lm > 0 && be > tm)
				drawPatternProperly(ctx, this.type.leftPattern, lm, be - tm, x, y + tm, lm + off, myh - tm - bm, 0, 0);
			if (rm > 0 && be > tm)
				drawPatternProperly(ctx, this.type.rightPattern, rm, be - tm, x + myw - rm - off, y + tm, rm + off, myh - tm - bm, off, 0);
			if (tm > 0 && re > lm)
				drawPatternProperly(ctx, this.type.topPattern, re - lm, tm, x + lm, y, myw - lm - rm, tm + off, 0, 0);
			if (bm > 0 && re > lm)
				drawPatternProperly(ctx, this.type.bottomPattern, re - lm, bm, x + lm, y + myh - bm - off, myw - lm - rm, bm + off, 0, off);
		}
		else if (this.edges === 1)	// stretch edges
		{
			if (lm > 0 && be > tm)
				ctx.drawImage(img, 0, tm, lm, be - tm, x, y + tm, lm, myh - tm - bm);
			if (rm > 0 && be > tm)
				ctx.drawImage(img, re, tm, rm, be - tm, x + myw - rm, y + tm, rm, myh - tm - bm);
			if (tm > 0 && re > lm)
				ctx.drawImage(img, lm, 0, re - lm, tm, x + lm, y, myw - lm - rm, tm);
			if (bm > 0 && re > lm)
				ctx.drawImage(img, lm, be, re - lm, bm, x + lm, y + myh - bm, myw - lm - rm, bm);
		}
		if (be > tm && re > lm)
		{
			if (this.fill === 0)		// tile fill
			{
				drawPatternProperly(ctx, this.type.fillPattern, re - lm, be - tm, x + lm, y + tm, myw - lm - rm, myh - tm - bm, 0, 0);
			}
			else if (this.fill === 1)	// stretch fill
			{
				ctx.drawImage(img, lm, tm, re - lm, be - tm, x + lm, y + tm, myw - lm - rm, myh - tm - bm);
			}
		}
		ctx.restore();
	};
	instanceProto.drawPatch = function(glw, tex, sx, sy, sw, sh, dx, dy, dw, dh)
	{
		glw.setTexture(tex);
		var rcTex = this.rcTex;
		rcTex.left = sx / tex.c2width;
		rcTex.top = sy / tex.c2height;
		rcTex.right = (sx + sw) / tex.c2width;
		rcTex.bottom = (sy + sh) / tex.c2height;
		glw.quadTex(dx, dy, dx + dw, dy, dx + dw, dy + dh, dx, dy + dh, rcTex);
	};
	instanceProto.tilePatch = function(glw, tex, dx, dy, dw, dh, ox, oy)
	{
		glw.setTexture(tex);
		var rcTex = this.rcTex;
		rcTex.left = -ox / tex.c2width;
		rcTex.top = -oy / tex.c2height;
		rcTex.right = (dw - ox) / tex.c2width;
		rcTex.bottom = (dh - oy) / tex.c2height;
		glw.quadTex(dx, dy, dx + dw, dy, dx + dw, dy + dh, dx, dy + dh, rcTex);
	};
	instanceProto.drawGL = function(glw)
	{
		var lm = this.leftMargin;
		var rm = this.rightMargin;
		var tm = this.topMargin;
		var bm = this.bottomMargin;
		var iw = this.type.texture_img.width;
		var ih = this.type.texture_img.height;
		var re = iw - rm;
		var be = ih - bm;
		glw.setOpacity(this.opacity);
		var rcTex = this.rcTex;
		var q = this.bquad;
		var myx = q.tlx;
		var myy = q.tly;
		var myw = this.width;
		var myh = this.height;
		if (this.runtime.pixel_rounding)
		{
			myx = (myx + 0.5) | 0;
			myy = (myy + 0.5) | 0;
		}
		var s = (this.seamless ? 1 : 0);
		if (lm > 0 && tm > 0)
			this.drawPatch(glw, this.type.webGL_texture, 0, 0, lm + s, tm + s, myx, myy, lm + s, tm + s);
		if (rm > 0 && tm > 0)
			this.drawPatch(glw, this.type.webGL_texture, re - s, 0, rm + s, tm + s, myx + myw - rm - s, myy, rm + s, tm + s);
		if (rm > 0 && bm > 0)
			this.drawPatch(glw, this.type.webGL_texture, re - s, be - s, rm + s, bm + s, myx + myw - rm - s, myy + myh - bm - s, rm + s, bm + s);
		if (lm > 0 && bm > 0)
			this.drawPatch(glw, this.type.webGL_texture, 0, be - s, lm + s, bm + s, myx, myy + myh - bm - s, lm + s, bm + s);
		if (this.edges === 0)		// tile edges
		{
			var off = (this.fill === 2 ? 0 : s);
			if (lm > 0 && be > tm)
				this.tilePatch(glw, this.type.webGL_leftTexture, myx, myy + tm, lm + off, myh - tm - bm, 0, 0);
			if (rm > 0 && be > tm)
				this.tilePatch(glw, this.type.webGL_rightTexture, myx + myw - rm - off, myy + tm, rm + off, myh - tm - bm, off, 0);
			if (tm > 0 && re > lm)
				this.tilePatch(glw, this.type.webGL_topTexture, myx + lm, myy, myw - lm - rm, tm + off, 0, 0);
			if (bm > 0 && re > lm)
				this.tilePatch(glw, this.type.webGL_bottomTexture, myx + lm, myy + myh - bm - off, myw - lm - rm, bm + off, 0, off);
		}
		else if (this.edges === 1)	// stretch edges
		{
			if (lm > 0 && be > tm)
				this.drawPatch(glw, this.type.webGL_texture, 0, tm, lm, be - tm, myx, myy + tm, lm, myh - tm - bm);
			if (rm > 0 && be > tm)
				this.drawPatch(glw, this.type.webGL_texture, re, tm, rm, be - tm, myx + myw - rm, myy + tm, rm, myh - tm - bm);
			if (tm > 0 && re > lm)
				this.drawPatch(glw, this.type.webGL_texture, lm, 0, re - lm, tm, myx + lm, myy, myw - lm - rm, tm);
			if (bm > 0 && re > lm)
				this.drawPatch(glw, this.type.webGL_texture, lm, be, re - lm, bm, myx + lm, myy + myh - bm, myw - lm - rm, bm);
		}
		if (be > tm && re > lm)
		{
			if (this.fill === 0)		// tile fill
			{
				this.tilePatch(glw, this.type.webGL_fillTexture, myx + lm, myy + tm, myw - lm - rm, myh - tm - bm, 0, 0);
			}
			else if (this.fill === 1)	// stretch fill
			{
				this.drawPatch(glw, this.type.webGL_texture, lm, tm, re - lm, be - tm, myx + lm, myy + tm, myw - lm - rm, myh - tm - bm);
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.OnURLLoaded = function ()
	{
		return true;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Particles = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Particles.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.texture_img.cr_filesize = this.texture_filesize;
		this.webGL_texture = null;
		this.runtime.waitForImageLoad(this.texture_img);
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.webGL_texture = null;
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		if (!this.webGL_texture)
		{
			this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, true, this.runtime.linearSampling, this.texture_pixelformat);
		}
	};
	typeProto.loadTextures = function ()
	{
		if (this.is_family || this.webGL_texture || !this.runtime.glwrap)
			return;
		this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, true, this.runtime.linearSampling, this.texture_pixelformat);
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.webGL_texture)
			return;
		this.runtime.glwrap.deleteTexture(this.webGL_texture);
		this.webGL_texture = null;
	};
	typeProto.preloadCanvas2D = function (ctx)
	{
		ctx.drawImage(this.texture_img, 0, 0);
	};
	function Particle(owner)
	{
		this.owner = owner;
		this.active = false;
		this.x = 0;
		this.y = 0;
		this.speed = 0;
		this.angle = 0;
		this.opacity = 1;
		this.grow = 0;
		this.size = 0;
		this.gs = 0;			// gravity speed
		this.age = 0;
		cr.seal(this);
	};
	Particle.prototype.init = function ()
	{
		var owner = this.owner;
		this.x = owner.x - (owner.xrandom / 2) + (Math.random() * owner.xrandom);
		this.y = owner.y - (owner.yrandom / 2) + (Math.random() * owner.yrandom);
		this.speed = owner.initspeed - (owner.speedrandom / 2) + (Math.random() * owner.speedrandom);
		this.angle = owner.angle - (owner.spraycone / 2) + (Math.random() * owner.spraycone);
		this.opacity = owner.initopacity;
		this.size = owner.initsize - (owner.sizerandom / 2) + (Math.random() * owner.sizerandom);
		this.grow = owner.growrate - (owner.growrandom / 2) + (Math.random() * owner.growrandom);
		this.gs = 0;
		this.age = 0;
	};
	Particle.prototype.tick = function (dt)
	{
		var owner = this.owner;
		this.x += Math.cos(this.angle) * this.speed * dt;
		this.y += Math.sin(this.angle) * this.speed * dt;
		this.y += this.gs * dt;
		this.speed += owner.acc * dt;
		this.size += this.grow * dt;
		this.gs += owner.g * dt;
		this.age += dt;
		if (this.size < 1)
		{
			this.active = false;
			return;
		}
		if (owner.lifeanglerandom !== 0)
			this.angle += (Math.random() * owner.lifeanglerandom * dt) - (owner.lifeanglerandom * dt / 2);
		if (owner.lifespeedrandom !== 0)
			this.speed += (Math.random() * owner.lifespeedrandom * dt) - (owner.lifespeedrandom * dt / 2);
		if (owner.lifeopacityrandom !== 0)
		{
			this.opacity += (Math.random() * owner.lifeopacityrandom * dt) - (owner.lifeopacityrandom * dt / 2);
			if (this.opacity < 0)
				this.opacity = 0;
			else if (this.opacity > 1)
				this.opacity = 1;
		}
		if (owner.destroymode <= 1 && this.age >= owner.timeout)
		{
			this.active = false;
		}
		if (owner.destroymode === 2 && this.speed <= 0)
		{
			this.active = false;
		}
	};
	Particle.prototype.draw = function (ctx)
	{
		var curopacity = this.owner.opacity * this.opacity;
		if (curopacity === 0)
			return;
		if (this.owner.destroymode === 0)
			curopacity *= 1 - (this.age / this.owner.timeout);
		ctx.globalAlpha = curopacity;
		var drawx = this.x - this.size / 2;
		var drawy = this.y - this.size / 2;
		if (this.owner.runtime.pixel_rounding)
		{
			drawx = (drawx + 0.5) | 0;
			drawy = (drawy + 0.5) | 0;
		}
		ctx.drawImage(this.owner.type.texture_img, drawx, drawy, this.size, this.size);
	};
	Particle.prototype.drawGL = function (glw)
	{
		var curopacity = this.owner.opacity * this.opacity;
		if (this.owner.destroymode === 0)
			curopacity *= 1 - (this.age / this.owner.timeout);
		var drawsize = this.size;
		var scaleddrawsize = drawsize * this.owner.particlescale;
		var drawx = this.x - drawsize / 2;
		var drawy = this.y - drawsize / 2;
		if (this.owner.runtime.pixel_rounding)
		{
			drawx = (drawx + 0.5) | 0;
			drawy = (drawy + 0.5) | 0;
		}
		if (scaleddrawsize < 1 || curopacity === 0)
			return;
		if (scaleddrawsize < glw.minPointSize || scaleddrawsize > glw.maxPointSize)
		{
			glw.setOpacity(curopacity);
			glw.quad(drawx, drawy, drawx + drawsize, drawy, drawx + drawsize, drawy + drawsize, drawx, drawy + drawsize);
		}
		else
			glw.point(this.x, this.y, scaleddrawsize, curopacity);
	};
	Particle.prototype.left = function ()
	{
		return this.x - this.size / 2;
	};
	Particle.prototype.right = function ()
	{
		return this.x + this.size / 2;
	};
	Particle.prototype.top = function ()
	{
		return this.y - this.size / 2;
	};
	Particle.prototype.bottom = function ()
	{
		return this.y + this.size / 2;
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var deadparticles = [];
	instanceProto.onCreate = function()
	{
		var props = this.properties;
		this.rate = props[0];
		this.spraycone = cr.to_radians(props[1]);
		this.spraytype = props[2];			// 0 = continuous, 1 = one-shot
		this.spraying = true;				// for continuous mode only
		this.initspeed = props[3];
		this.initsize = props[4];
		this.initopacity = props[5] / 100.0;
		this.growrate = props[6];
		this.xrandom = props[7];
		this.yrandom = props[8];
		this.speedrandom = props[9];
		this.sizerandom = props[10];
		this.growrandom = props[11];
		this.acc = props[12];
		this.g = props[13];
		this.lifeanglerandom = props[14];
		this.lifespeedrandom = props[15];
		this.lifeopacityrandom = props[16];
		this.destroymode = props[17];		// 0 = fade, 1 = timeout, 2 = stopped
		this.timeout = props[18];
		this.particleCreateCounter = 0;
		this.particlescale = 1;
		this.particleBoxLeft = this.x;
		this.particleBoxTop = this.y;
		this.particleBoxRight = this.x;
		this.particleBoxBottom = this.y;
		this.add_bbox_changed_callback(function (self) {
			self.bbox.set(self.particleBoxLeft, self.particleBoxTop, self.particleBoxRight, self.particleBoxBottom);
			self.bquad.set_from_rect(self.bbox);
			self.bbox_changed = false;
			self.update_collision_cell();
		});
		if (!this.recycled)
			this.particles = [];
		this.runtime.tickMe(this);
		this.type.loadTextures();
		if (this.spraytype === 1)
		{
			for (var i = 0; i < this.rate; i++)
				this.allocateParticle().opacity = 0;
		}
		this.first_tick = true;		// for re-init'ing one-shot particles on first tick so they assume any new angle/position
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"r": this.rate,
			"sc": this.spraycone,
			"st": this.spraytype,
			"s": this.spraying,
			"isp": this.initspeed,
			"isz": this.initsize,
			"io": this.initopacity,
			"gr": this.growrate,
			"xr": this.xrandom,
			"yr": this.yrandom,
			"spr": this.speedrandom,
			"szr": this.sizerandom,
			"grnd": this.growrandom,
			"acc": this.acc,
			"g": this.g,
			"lar": this.lifeanglerandom,
			"lsr": this.lifespeedrandom,
			"lor": this.lifeopacityrandom,
			"dm": this.destroymode,
			"to": this.timeout,
			"pcc": this.particleCreateCounter,
			"ft": this.first_tick,
			"p": []
		};
		var i, len, p;
		var arr = o["p"];
		for (i = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			arr.push([p.x, p.y, p.speed, p.angle, p.opacity, p.grow, p.size, p.gs, p.age]);
		}
		return o;
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.rate = o["r"];
		this.spraycone = o["sc"];
		this.spraytype = o["st"];
		this.spraying = o["s"];
		this.initspeed = o["isp"];
		this.initsize = o["isz"];
		this.initopacity = o["io"];
		this.growrate = o["gr"];
		this.xrandom = o["xr"];
		this.yrandom = o["yr"];
		this.speedrandom = o["spr"];
		this.sizerandom = o["szr"];
		this.growrandom = o["grnd"];
		this.acc = o["acc"];
		this.g = o["g"];
		this.lifeanglerandom = o["lar"];
		this.lifespeedrandom = o["lsr"];
		this.lifeopacityrandom = o["lor"];
		this.destroymode = o["dm"];
		this.timeout = o["to"];
		this.particleCreateCounter = o["pcc"];
		this.first_tick = o["ft"];
		deadparticles.push.apply(deadparticles, this.particles);
		this.particles.length = 0;
		var i, len, p, d;
		var arr = o["p"];
		for (i = 0, len = arr.length; i < len; i++)
		{
			p = this.allocateParticle();
			d = arr[i];
			p.x = d[0];
			p.y = d[1];
			p.speed = d[2];
			p.angle = d[3];
			p.opacity = d[4];
			p.grow = d[5];
			p.size = d[6];
			p.gs = d[7];
			p.age = d[8];
		}
	};
	instanceProto.onDestroy = function ()
	{
		deadparticles.push.apply(deadparticles, this.particles);
		this.particles.length = 0;
	};
	instanceProto.allocateParticle = function ()
	{
		var p;
		if (deadparticles.length)
		{
			p = deadparticles.pop();
			p.owner = this;
		}
		else
			p = new Particle(this);
		this.particles.push(p);
		p.active = true;
		return p;
	};
	instanceProto.tick = function()
	{
		var dt = this.runtime.getDt(this);
		var i, len, p, n, j;
		if (this.spraytype === 0 && this.spraying)
		{
			this.particleCreateCounter += dt * this.rate;
			n = cr.floor(this.particleCreateCounter);
			this.particleCreateCounter -= n;
			for (i = 0; i < n; i++)
			{
				p = this.allocateParticle();
				p.init();
			}
		}
		this.particleBoxLeft = this.x;
		this.particleBoxTop = this.y;
		this.particleBoxRight = this.x;
		this.particleBoxBottom = this.y;
		for (i = 0, j = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			this.particles[j] = p;
			this.runtime.redraw = true;
			if (this.spraytype === 1 && this.first_tick)
				p.init();
			p.tick(dt);
			if (!p.active)
			{
				deadparticles.push(p);
				continue;
			}
			if (p.left() < this.particleBoxLeft)
				this.particleBoxLeft = p.left();
			if (p.right() > this.particleBoxRight)
				this.particleBoxRight = p.right();
			if (p.top() < this.particleBoxTop)
				this.particleBoxTop = p.top();
			if (p.bottom() > this.particleBoxBottom)
				this.particleBoxBottom = p.bottom();
			j++;
		}
		this.particles.length = j;
		this.set_bbox_changed();
		this.first_tick = false;
		if (this.spraytype === 1 && this.particles.length === 0)
			this.runtime.DestroyInstance(this);
	};
	instanceProto.draw = function (ctx)
	{
		var i, len, p, layer = this.layer;
		for (i = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			if (p.right() >= layer.viewLeft && p.bottom() >= layer.viewTop && p.left() <= layer.viewRight && p.top() <= layer.viewBottom)
			{
				p.draw(ctx);
			}
		}
	};
	instanceProto.drawGL = function (glw)
	{
		this.particlescale = this.layer.getScale();
		glw.setTexture(this.type.webGL_texture);
		var i, len, p, layer = this.layer;
		for (i = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			if (p.right() >= layer.viewLeft && p.bottom() >= layer.viewTop && p.left() <= layer.viewRight && p.top() <= layer.viewBottom)
			{
				p.drawGL(glw);
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.IsSpraying = function ()
	{
		return this.spraying;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetSpraying = function (set_)
	{
		this.spraying = (set_ !== 0);
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.SetRate = function (x)
	{
		this.rate = x;
		var diff, i;
		if (this.spraytype === 1 && this.first_tick)
		{
			if (x < this.particles.length)
			{
				diff = this.particles.length - x;
				for (i = 0; i < diff; i++)
					deadparticles.push(this.particles.pop());
			}
			else if (x > this.particles.length)
			{
				diff = x - this.particles.length;
				for (i = 0; i < diff; i++)
					this.allocateParticle().opacity = 0;
			}
		}
	};
	Acts.prototype.SetSprayCone = function (x)
	{
		this.spraycone = cr.to_radians(x);
	};
	Acts.prototype.SetInitSpeed = function (x)
	{
		this.initspeed = x;
	};
	Acts.prototype.SetInitSize = function (x)
	{
		this.initsize = x;
	};
	Acts.prototype.SetInitOpacity = function (x)
	{
		this.initopacity = x / 100;
	};
	Acts.prototype.SetGrowRate = function (x)
	{
		this.growrate = x;
	};
	Acts.prototype.SetXRandomiser = function (x)
	{
		this.xrandom = x;
	};
	Acts.prototype.SetYRandomiser = function (x)
	{
		this.yrandom = x;
	};
	Acts.prototype.SetSpeedRandomiser = function (x)
	{
		this.speedrandom = x;
	};
	Acts.prototype.SetSizeRandomiser = function (x)
	{
		this.sizerandom = x;
	};
	Acts.prototype.SetGrowRateRandomiser = function (x)
	{
		this.growrandom = x;
	};
	Acts.prototype.SetParticleAcc = function (x)
	{
		this.acc = x;
	};
	Acts.prototype.SetGravity = function (x)
	{
		this.g = x;
	};
	Acts.prototype.SetAngleRandomiser = function (x)
	{
		this.lifeanglerandom = x;
	};
	Acts.prototype.SetSpeedRandomiser = function (x)
	{
		this.lifespeedrandom = x;
	};
	Acts.prototype.SetOpacityRandomiser = function (x)
	{
		this.lifeopacityrandom = x;
	};
	Acts.prototype.SetTimeout = function (x)
	{
		this.timeout = x;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.ParticleCount = function (ret)
	{
		ret.set_int(this.particles.length);
	};
	Exps.prototype.Rate = function (ret)
	{
		ret.set_float(this.rate);
	};
	Exps.prototype.SprayCone = function (ret)
	{
		ret.set_float(cr.to_degrees(this.spraycone));
	};
	Exps.prototype.InitSpeed = function (ret)
	{
		ret.set_float(this.initspeed);
	};
	Exps.prototype.InitSize = function (ret)
	{
		ret.set_float(this.initsize);
	};
	Exps.prototype.InitOpacity = function (ret)
	{
		ret.set_float(this.initopacity * 100);
	};
	Exps.prototype.InitGrowRate = function (ret)
	{
		ret.set_float(this.growrate);
	};
	Exps.prototype.XRandom = function (ret)
	{
		ret.set_float(this.xrandom);
	};
	Exps.prototype.YRandom = function (ret)
	{
		ret.set_float(this.yrandom);
	};
	Exps.prototype.InitSpeedRandom = function (ret)
	{
		ret.set_float(this.speedrandom);
	};
	Exps.prototype.InitSizeRandom = function (ret)
	{
		ret.set_float(this.sizerandom);
	};
	Exps.prototype.InitGrowRandom = function (ret)
	{
		ret.set_float(this.growrandom);
	};
	Exps.prototype.ParticleAcceleration = function (ret)
	{
		ret.set_float(this.acc);
	};
	Exps.prototype.Gravity = function (ret)
	{
		ret.set_float(this.g);
	};
	Exps.prototype.ParticleAngleRandom = function (ret)
	{
		ret.set_float(this.lifeanglerandom);
	};
	Exps.prototype.ParticleSpeedRandom = function (ret)
	{
		ret.set_float(this.lifespeedrandom);
	};
	Exps.prototype.ParticleOpacityRandom = function (ret)
	{
		ret.set_float(this.lifeopacityrandom);
	};
	Exps.prototype.Timeout = function (ret)
	{
		ret.set_float(this.timeout);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Sprite = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Sprite.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	function frame_getDataUri()
	{
		if (this.datauri.length === 0)
		{
			var tmpcanvas = document.createElement("canvas");
			tmpcanvas.width = this.width;
			tmpcanvas.height = this.height;
			var tmpctx = tmpcanvas.getContext("2d");
			if (this.spritesheeted)
			{
				tmpctx.drawImage(this.texture_img, this.offx, this.offy, this.width, this.height,
										 0, 0, this.width, this.height);
			}
			else
			{
				tmpctx.drawImage(this.texture_img, 0, 0, this.width, this.height);
			}
			this.datauri = tmpcanvas.toDataURL("image/png");
		}
		return this.datauri;
	};
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		var i, leni, j, lenj;
		var anim, frame, animobj, frameobj, wt, uv;
		this.all_frames = [];
		this.has_loaded_textures = false;
		for (i = 0, leni = this.animations.length; i < leni; i++)
		{
			anim = this.animations[i];
			animobj = {};
			animobj.name = anim[0];
			animobj.speed = anim[1];
			animobj.loop = anim[2];
			animobj.repeatcount = anim[3];
			animobj.repeatto = anim[4];
			animobj.pingpong = anim[5];
			animobj.sid = anim[6];
			animobj.frames = [];
			for (j = 0, lenj = anim[7].length; j < lenj; j++)
			{
				frame = anim[7][j];
				frameobj = {};
				frameobj.texture_file = frame[0];
				frameobj.texture_filesize = frame[1];
				frameobj.offx = frame[2];
				frameobj.offy = frame[3];
				frameobj.width = frame[4];
				frameobj.height = frame[5];
				frameobj.duration = frame[6];
				frameobj.hotspotX = frame[7];
				frameobj.hotspotY = frame[8];
				frameobj.image_points = frame[9];
				frameobj.poly_pts = frame[10];
				frameobj.pixelformat = frame[11];
				frameobj.spritesheeted = (frameobj.width !== 0);
				frameobj.datauri = "";		// generated on demand and cached
				frameobj.getDataUri = frame_getDataUri;
				uv = {};
				uv.left = 0;
				uv.top = 0;
				uv.right = 1;
				uv.bottom = 1;
				frameobj.sheetTex = uv;
				frameobj.webGL_texture = null;
				wt = this.runtime.findWaitingTexture(frame[0]);
				if (wt)
				{
					frameobj.texture_img = wt;
				}
				else
				{
					frameobj.texture_img = new Image();
					frameobj.texture_img["idtkLoadDisposed"] = true;
					frameobj.texture_img.src = frame[0];
					frameobj.texture_img.cr_src = frame[0];
					frameobj.texture_img.cr_filesize = frame[1];
					frameobj.texture_img.c2webGL_texture = null;
					this.runtime.waitForImageLoad(frameobj.texture_img);
				}
				cr.seal(frameobj);
				animobj.frames.push(frameobj);
				this.all_frames.push(frameobj);
			}
			cr.seal(animobj);
			this.animations[i] = animobj;		// swap array data for object
		}
	};
	typeProto.updateAllCurrentTexture = function ()
	{
		var i, len, inst;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			inst.curWebGLTexture = inst.curFrame.webGL_texture;
		}
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.texture_img.c2webGL_texture = null;
			frame.webGL_texture = null;
		}
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.webGL_texture = this.runtime.glwrap.loadTexture(frame.texture_img, false, this.runtime.linearSampling, frame.pixelformat);
		}
		this.updateAllCurrentTexture();
	};
	typeProto.loadTextures = function ()
	{
		if (this.is_family || this.has_loaded_textures || !this.runtime.glwrap)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.webGL_texture = this.runtime.glwrap.loadTexture(frame.texture_img, false, this.runtime.linearSampling, frame.pixelformat);
		}
		this.has_loaded_textures = true;
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.has_loaded_textures)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			this.runtime.glwrap.deleteTexture(frame.webGL_texture);
			frame.webGL_texture = null;
		}
		this.has_loaded_textures = false;
	};
	var already_drawn_images = [];
	typeProto.preloadCanvas2D = function (ctx)
	{
		var i, len, frameimg;
		already_drawn_images.length = 0;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frameimg = this.all_frames[i].texture_img;
			if (already_drawn_images.indexOf(frameimg) !== -1)
					continue;
			ctx.drawImage(frameimg, 0, 0);
			already_drawn_images.push(frameimg);
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		var poly_pts = this.type.animations[0].frames[0].poly_pts;
		if (this.recycled)
			this.collision_poly.set_pts(poly_pts);
		else
			this.collision_poly = new cr.CollisionPoly(poly_pts);
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.visible = (this.properties[0] === 0);	// 0=visible, 1=invisible
		this.isTicking = false;
		this.inAnimTrigger = false;
		this.collisionsEnabled = (this.properties[3] !== 0);
		if (!(this.type.animations.length === 1 && this.type.animations[0].frames.length === 1) && this.type.animations[0].speed !== 0)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		this.cur_animation = this.getAnimationByName(this.properties[1]) || this.type.animations[0];
		this.cur_frame = this.properties[2];
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		var curanimframe = this.cur_animation.frames[this.cur_frame];
		this.collision_poly.set_pts(curanimframe.poly_pts);
		this.hotspotX = curanimframe.hotspotX;
		this.hotspotY = curanimframe.hotspotY;
		this.cur_anim_speed = this.cur_animation.speed;
		if (this.recycled)
			this.animTimer.reset();
		else
			this.animTimer = new cr.KahanAdder();
		this.frameStart = this.getNowTime();
		this.animPlaying = true;
		this.animRepeats = 0;
		this.animForwards = true;
		this.animTriggerName = "";
		this.changeAnimName = "";
		this.changeAnimFrom = 0;
		this.changeAnimFrame = -1;
		this.type.loadTextures();
		var i, leni, j, lenj;
		var anim, frame, uv, maintex;
		for (i = 0, leni = this.type.animations.length; i < leni; i++)
		{
			anim = this.type.animations[i];
			for (j = 0, lenj = anim.frames.length; j < lenj; j++)
			{
				frame = anim.frames[j];
				if (frame.width === 0)
				{
					frame.width = frame.texture_img.width;
					frame.height = frame.texture_img.height;
				}
				if (frame.spritesheeted)
				{
					maintex = frame.texture_img;
					uv = frame.sheetTex;
					uv.left = frame.offx / maintex.width;
					uv.top = frame.offy / maintex.height;
					uv.right = (frame.offx + frame.width) / maintex.width;
					uv.bottom = (frame.offy + frame.height) / maintex.height;
					if (frame.offx === 0 && frame.offy === 0 && frame.width === maintex.width && frame.height === maintex.height)
					{
						frame.spritesheeted = false;
					}
				}
			}
		}
		this.curFrame = this.cur_animation.frames[this.cur_frame];
		this.curWebGLTexture = this.curFrame.webGL_texture;
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"a": this.cur_animation.sid,
			"f": this.cur_frame,
			"cas": this.cur_anim_speed,
			"fs": this.frameStart,
			"ar": this.animRepeats,
			"at": this.animTimer.sum
		};
		if (!this.animPlaying)
			o["ap"] = this.animPlaying;
		if (!this.animForwards)
			o["af"] = this.animForwards;
		return o;
	};
	instanceProto.loadFromJSON = function (o)
	{
		var anim = this.getAnimationBySid(o["a"]);
		if (anim)
			this.cur_animation = anim;
		this.cur_frame = o["f"];
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		this.cur_anim_speed = o["cas"];
		this.frameStart = o["fs"];
		this.animRepeats = o["ar"];
		this.animTimer.reset();
		this.animTimer.sum = o["at"];
		this.animPlaying = o.hasOwnProperty("ap") ? o["ap"] : true;
		this.animForwards = o.hasOwnProperty("af") ? o["af"] : true;
		this.curFrame = this.cur_animation.frames[this.cur_frame];
		this.curWebGLTexture = this.curFrame.webGL_texture;
		this.collision_poly.set_pts(this.curFrame.poly_pts);
		this.hotspotX = this.curFrame.hotspotX;
		this.hotspotY = this.curFrame.hotspotY;
	};
	instanceProto.animationFinish = function (reverse)
	{
		this.cur_frame = reverse ? 0 : this.cur_animation.frames.length - 1;
		this.animPlaying = false;
		this.animTriggerName = this.cur_animation.name;
		this.inAnimTrigger = true;
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished, this);
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnimFinished, this);
		this.inAnimTrigger = false;
		this.animRepeats = 0;
	};
	instanceProto.getNowTime = function()
	{
		return this.animTimer.sum;
	};
	instanceProto.tick = function()
	{
		this.animTimer.add(this.runtime.getDt(this));
		if (this.changeAnimName.length)
			this.doChangeAnim();
		if (this.changeAnimFrame >= 0)
			this.doChangeAnimFrame();
		var now = this.getNowTime();
		var cur_animation = this.cur_animation;
		var prev_frame = cur_animation.frames[this.cur_frame];
		var next_frame;
		var cur_frame_time = prev_frame.duration / this.cur_anim_speed;
		if (this.animPlaying && now >= this.frameStart + cur_frame_time)
		{
			if (this.animForwards)
			{
				this.cur_frame++;
			}
			else
			{
				this.cur_frame--;
			}
			this.frameStart += cur_frame_time;
			if (this.cur_frame >= cur_animation.frames.length)
			{
				if (cur_animation.pingpong)
				{
					this.animForwards = false;
					this.cur_frame = cur_animation.frames.length - 2;
				}
				else if (cur_animation.loop)
				{
					this.cur_frame = cur_animation.repeatto;
				}
				else
				{
					this.animRepeats++;
					if (this.animRepeats >= cur_animation.repeatcount)
					{
						this.animationFinish(false);
					}
					else
					{
						this.cur_frame = cur_animation.repeatto;
					}
				}
			}
			if (this.cur_frame < 0)
			{
				if (cur_animation.pingpong)
				{
					this.cur_frame = 1;
					this.animForwards = true;
					if (!cur_animation.loop)
					{
						this.animRepeats++;
						if (this.animRepeats >= cur_animation.repeatcount)
						{
							this.animationFinish(true);
						}
					}
				}
				else
				{
					if (cur_animation.loop)
					{
						this.cur_frame = cur_animation.repeatto;
					}
					else
					{
						this.animRepeats++;
						if (this.animRepeats >= cur_animation.repeatcount)
						{
							this.animationFinish(true);
						}
						else
						{
							this.cur_frame = cur_animation.repeatto;
						}
					}
				}
			}
			if (this.cur_frame < 0)
				this.cur_frame = 0;
			else if (this.cur_frame >= cur_animation.frames.length)
				this.cur_frame = cur_animation.frames.length - 1;
			if (now > this.frameStart + (cur_animation.frames[this.cur_frame].duration / this.cur_anim_speed))
			{
				this.frameStart = now;
			}
			next_frame = cur_animation.frames[this.cur_frame];
			this.OnFrameChanged(prev_frame, next_frame);
			this.runtime.redraw = true;
		}
	};
	instanceProto.getAnimationByName = function (name_)
	{
		var i, len, a;
		for (i = 0, len = this.type.animations.length; i < len; i++)
		{
			a = this.type.animations[i];
			if (cr.equals_nocase(a.name, name_))
				return a;
		}
		return null;
	};
	instanceProto.getAnimationBySid = function (sid_)
	{
		var i, len, a;
		for (i = 0, len = this.type.animations.length; i < len; i++)
		{
			a = this.type.animations[i];
			if (a.sid === sid_)
				return a;
		}
		return null;
	};
	instanceProto.doChangeAnim = function ()
	{
		var prev_frame = this.cur_animation.frames[this.cur_frame];
		var anim = this.getAnimationByName(this.changeAnimName);
		this.changeAnimName = "";
		if (!anim)
			return;
		if (cr.equals_nocase(anim.name, this.cur_animation.name) && this.animPlaying)
			return;
		this.cur_animation = anim;
		this.cur_anim_speed = anim.speed;
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		if (this.changeAnimFrom === 1)
			this.cur_frame = 0;
		this.animPlaying = true;
		this.frameStart = this.getNowTime();
		this.animForwards = true;
		this.OnFrameChanged(prev_frame, this.cur_animation.frames[this.cur_frame]);
		this.runtime.redraw = true;
	};
	instanceProto.doChangeAnimFrame = function ()
	{
		var prev_frame = this.cur_animation.frames[this.cur_frame];
		var prev_frame_number = this.cur_frame;
		this.cur_frame = cr.floor(this.changeAnimFrame);
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		if (prev_frame_number !== this.cur_frame)
		{
			this.OnFrameChanged(prev_frame, this.cur_animation.frames[this.cur_frame]);
			this.frameStart = this.getNowTime();
			this.runtime.redraw = true;
		}
		this.changeAnimFrame = -1;
	};
	instanceProto.OnFrameChanged = function (prev_frame, next_frame)
	{
		var oldw = prev_frame.width;
		var oldh = prev_frame.height;
		var neww = next_frame.width;
		var newh = next_frame.height;
		if (oldw != neww)
			this.width *= (neww / oldw);
		if (oldh != newh)
			this.height *= (newh / oldh);
		this.hotspotX = next_frame.hotspotX;
		this.hotspotY = next_frame.hotspotY;
		this.collision_poly.set_pts(next_frame.poly_pts);
		this.set_bbox_changed();
		this.curFrame = next_frame;
		this.curWebGLTexture = next_frame.webGL_texture;
		var i, len, b;
		for (i = 0, len = this.behavior_insts.length; i < len; i++)
		{
			b = this.behavior_insts[i];
			if (b.onSpriteFrameChanged)
				b.onSpriteFrameChanged(prev_frame, next_frame);
		}
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnFrameChanged, this);
	};
	instanceProto.draw = function(ctx)
	{
		ctx.globalAlpha = this.opacity;
		var cur_frame = this.curFrame;
		var spritesheeted = cur_frame.spritesheeted;
		var cur_image = cur_frame.texture_img;
		var myx = this.x;
		var myy = this.y;
		var w = this.width;
		var h = this.height;
		if (this.angle === 0 && w >= 0 && h >= 0)
		{
			myx -= this.hotspotX * w;
			myy -= this.hotspotY * h;
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			if (spritesheeted)
			{
				ctx.drawImage(cur_image, cur_frame.offx, cur_frame.offy, cur_frame.width, cur_frame.height,
										 myx, myy, w, h);
			}
			else
			{
				ctx.drawImage(cur_image, myx, myy, w, h);
			}
		}
		else
		{
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			ctx.save();
			var widthfactor = w > 0 ? 1 : -1;
			var heightfactor = h > 0 ? 1 : -1;
			ctx.translate(myx, myy);
			if (widthfactor !== 1 || heightfactor !== 1)
				ctx.scale(widthfactor, heightfactor);
			ctx.rotate(this.angle * widthfactor * heightfactor);
			var drawx = 0 - (this.hotspotX * cr.abs(w))
			var drawy = 0 - (this.hotspotY * cr.abs(h));
			if (spritesheeted)
			{
				ctx.drawImage(cur_image, cur_frame.offx, cur_frame.offy, cur_frame.width, cur_frame.height,
										 drawx, drawy, cr.abs(w), cr.abs(h));
			}
			else
			{
				ctx.drawImage(cur_image, drawx, drawy, cr.abs(w), cr.abs(h));
			}
			ctx.restore();
		}
		/*
		ctx.strokeStyle = "#f00";
		ctx.lineWidth = 3;
		ctx.beginPath();
		this.collision_poly.cache_poly(this.width, this.height, this.angle);
		var i, len, ax, ay, bx, by;
		for (i = 0, len = this.collision_poly.pts_count; i < len; i++)
		{
			ax = this.collision_poly.pts_cache[i*2] + this.x;
			ay = this.collision_poly.pts_cache[i*2+1] + this.y;
			bx = this.collision_poly.pts_cache[((i+1)%len)*2] + this.x;
			by = this.collision_poly.pts_cache[((i+1)%len)*2+1] + this.y;
			ctx.moveTo(ax, ay);
			ctx.lineTo(bx, by);
		}
		ctx.stroke();
		ctx.closePath();
		*/
		/*
		if (this.behavior_insts.length >= 1 && this.behavior_insts[0].draw)
		{
			this.behavior_insts[0].draw(ctx);
		}
		*/
	};
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.curWebGLTexture);
		glw.setOpacity(this.opacity);
		var cur_frame = this.curFrame;
		var q = this.bquad;
		if (this.runtime.pixel_rounding)
		{
			var ox = ((this.x + 0.5) | 0) - this.x;
			var oy = ((this.y + 0.5) | 0) - this.y;
			if (cur_frame.spritesheeted)
				glw.quadTex(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy, cur_frame.sheetTex);
			else
				glw.quad(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy);
		}
		else
		{
			if (cur_frame.spritesheeted)
				glw.quadTex(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly, cur_frame.sheetTex);
			else
				glw.quad(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly);
		}
	};
	instanceProto.getImagePointIndexByName = function(name_)
	{
		var cur_frame = this.curFrame;
		var i, len;
		for (i = 0, len = cur_frame.image_points.length; i < len; i++)
		{
			if (cr.equals_nocase(name_, cur_frame.image_points[i][0]))
				return i;
		}
		return -1;
	};
	instanceProto.getImagePoint = function(imgpt, getX)
	{
		var cur_frame = this.curFrame;
		var image_points = cur_frame.image_points;
		var index;
		if (cr.is_string(imgpt))
			index = this.getImagePointIndexByName(imgpt);
		else
			index = imgpt - 1;	// 0 is origin
		index = cr.floor(index);
		if (index < 0 || index >= image_points.length)
			return getX ? this.x : this.y;	// return origin
		var x = (image_points[index][1] - cur_frame.hotspotX) * this.width;
		var y = image_points[index][2];
		y = (y - cur_frame.hotspotY) * this.height;
		var cosa = Math.cos(this.angle);
		var sina = Math.sin(this.angle);
		var x_temp = (x * cosa) - (y * sina);
		y = (y * cosa) + (x * sina);
		x = x_temp;
		x += this.x;
		y += this.y;
		return getX ? x : y;
	};
	function Cnds() {};
	var arrCache = [];
	function allocArr()
	{
		if (arrCache.length)
			return arrCache.pop();
		else
			return [0, 0, 0];
	};
	function freeArr(a)
	{
		a[0] = 0;
		a[1] = 0;
		a[2] = 0;
		arrCache.push(a);
	};
	function makeCollKey(a, b)
	{
		if (a < b)
			return "" + a + "," + b;
		else
			return "" + b + "," + a;
	};
	function collmemory_add(collmemory, a, b, tickcount)
	{
		var a_uid = a.uid;
		var b_uid = b.uid;
		var key = makeCollKey(a_uid, b_uid);
		if (collmemory.hasOwnProperty(key))
		{
			collmemory[key][2] = tickcount;
			return;
		}
		var arr = allocArr();
		arr[0] = a_uid;
		arr[1] = b_uid;
		arr[2] = tickcount;
		collmemory[key] = arr;
	};
	function collmemory_remove(collmemory, a, b)
	{
		var key = makeCollKey(a.uid, b.uid);
		if (collmemory.hasOwnProperty(key))
		{
			freeArr(collmemory[key]);
			delete collmemory[key];
		}
	};
	function collmemory_removeInstance(collmemory, inst)
	{
		var uid = inst.uid;
		var p, entry;
		for (p in collmemory)
		{
			if (collmemory.hasOwnProperty(p))
			{
				entry = collmemory[p];
				if (entry[0] === uid || entry[1] === uid)
				{
					freeArr(collmemory[p]);
					delete collmemory[p];
				}
			}
		}
	};
	var last_coll_tickcount = -2;
	function collmemory_has(collmemory, a, b)
	{
		var key = makeCollKey(a.uid, b.uid);
		if (collmemory.hasOwnProperty(key))
		{
			last_coll_tickcount = collmemory[key][2];
			return true;
		}
		else
		{
			last_coll_tickcount = -2;
			return false;
		}
	};
	var candidates = [];
	Cnds.prototype.OnCollision = function (rtype)
	{
		if (!rtype)
			return false;
		var runtime = this.runtime;
		var cnd = runtime.getCurrentCondition();
		var ltype = cnd.type;
		if (!cnd.extra.collmemory)
		{
			cnd.extra.collmemory = {};
			runtime.addDestroyCallback((function (collmemory) {
				return function(inst) {
					collmemory_removeInstance(collmemory, inst);
				};
			})(cnd.extra.collmemory));
		}
		var collmemory = cnd.extra.collmemory;
		var lsol = ltype.getCurrentSol();
		var rsol = rtype.getCurrentSol();
		var linstances = lsol.getObjects();
		var rinstances;
		var l, linst, r, rinst;
		var curlsol, currsol;
		var tickcount = this.runtime.tickcount;
		var lasttickcount = tickcount - 1;
		var exists, run;
		var current_event = runtime.getCurrentEventStack().current_event;
		var orblock = current_event.orblock;
		for (l = 0; l < linstances.length; l++)
		{
			linst = linstances[l];
			if (rsol.select_all)
			{
				linst.update_bbox();
				this.runtime.getCollisionCandidates(linst.layer, rtype, linst.bbox, candidates);
				rinstances = candidates;
			}
			else
				rinstances = rsol.getObjects();
			for (r = 0; r < rinstances.length; r++)
			{
				rinst = rinstances[r];
				if (runtime.testOverlap(linst, rinst) || runtime.checkRegisteredCollision(linst, rinst))
				{
					exists = collmemory_has(collmemory, linst, rinst);
					run = (!exists || (last_coll_tickcount < lasttickcount));
					collmemory_add(collmemory, linst, rinst, tickcount);
					if (run)
					{
						runtime.pushCopySol(current_event.solModifiers);
						curlsol = ltype.getCurrentSol();
						currsol = rtype.getCurrentSol();
						curlsol.select_all = false;
						currsol.select_all = false;
						if (ltype === rtype)
						{
							curlsol.instances.length = 2;	// just use lsol, is same reference as rsol
							curlsol.instances[0] = linst;
							curlsol.instances[1] = rinst;
							ltype.applySolToContainer();
						}
						else
						{
							curlsol.instances.length = 1;
							currsol.instances.length = 1;
							curlsol.instances[0] = linst;
							currsol.instances[0] = rinst;
							ltype.applySolToContainer();
							rtype.applySolToContainer();
						}
						current_event.retrigger();
						runtime.popSol(current_event.solModifiers);
					}
				}
				else
				{
					collmemory_remove(collmemory, linst, rinst);
				}
			}
			candidates.length = 0;
		}
		return false;
	};
	var rpicktype = null;
	var rtopick = new cr.ObjectSet();
	var needscollisionfinish = false;
	function DoOverlapCondition(rtype, offx, offy)
	{
		if (!rtype)
			return false;
		var do_offset = (offx !== 0 || offy !== 0);
		var oldx, oldy, ret = false, r, lenr, rinst;
		var cnd = this.runtime.getCurrentCondition();
		var ltype = cnd.type;
		var inverted = cnd.inverted;
		var rsol = rtype.getCurrentSol();
		var orblock = this.runtime.getCurrentEventStack().current_event.orblock;
		var rinstances;
		if (rsol.select_all)
		{
			this.update_bbox();
			this.runtime.getCollisionCandidates(this.layer, rtype, this.bbox, candidates);
			rinstances = candidates;
		}
		else if (orblock)
			rinstances = rsol.else_instances;
		else
			rinstances = rsol.instances;
		rpicktype = rtype;
		needscollisionfinish = (ltype !== rtype && !inverted);
		if (do_offset)
		{
			oldx = this.x;
			oldy = this.y;
			this.x += offx;
			this.y += offy;
			this.set_bbox_changed();
		}
		for (r = 0, lenr = rinstances.length; r < lenr; r++)
		{
			rinst = rinstances[r];
			if (this.runtime.testOverlap(this, rinst))
			{
				ret = true;
				if (inverted)
					break;
				if (ltype !== rtype)
					rtopick.add(rinst);
			}
		}
		if (do_offset)
		{
			this.x = oldx;
			this.y = oldy;
			this.set_bbox_changed();
		}
		candidates.length = 0;
		return ret;
	};
	typeProto.finish = function (do_pick)
	{
		if (!needscollisionfinish)
			return;
		if (do_pick)
		{
			var orblock = this.runtime.getCurrentEventStack().current_event.orblock;
			var sol = rpicktype.getCurrentSol();
			var topick = rtopick.valuesRef();
			var i, len, inst;
			if (sol.select_all)
			{
				sol.select_all = false;
				sol.instances.length = topick.length;
				for (i = 0, len = topick.length; i < len; i++)
				{
					sol.instances[i] = topick[i];
				}
				if (orblock)
				{
					sol.else_instances.length = 0;
					for (i = 0, len = rpicktype.instances.length; i < len; i++)
					{
						inst = rpicktype.instances[i];
						if (!rtopick.contains(inst))
							sol.else_instances.push(inst);
					}
				}
			}
			else
			{
				if (orblock)
				{
					var initsize = sol.instances.length;
					sol.instances.length = initsize + topick.length;
					for (i = 0, len = topick.length; i < len; i++)
					{
						sol.instances[initsize + i] = topick[i];
						cr.arrayFindRemove(sol.else_instances, topick[i]);
					}
				}
				else
				{
					cr.shallowAssignArray(sol.instances, topick);
				}
			}
			rpicktype.applySolToContainer();
		}
		rtopick.clear();
		needscollisionfinish = false;
	};
	Cnds.prototype.IsOverlapping = function (rtype)
	{
		return DoOverlapCondition.call(this, rtype, 0, 0);
	};
	Cnds.prototype.IsOverlappingOffset = function (rtype, offx, offy)
	{
		return DoOverlapCondition.call(this, rtype, offx, offy);
	};
	Cnds.prototype.IsAnimPlaying = function (animname)
	{
		if (this.changeAnimName.length)
			return cr.equals_nocase(this.changeAnimName, animname);
		else
			return cr.equals_nocase(this.cur_animation.name, animname);
	};
	Cnds.prototype.CompareFrame = function (cmp, framenum)
	{
		return cr.do_cmp(this.cur_frame, cmp, framenum);
	};
	Cnds.prototype.CompareAnimSpeed = function (cmp, x)
	{
		var s = (this.animForwards ? this.cur_anim_speed : -this.cur_anim_speed);
		return cr.do_cmp(s, cmp, x);
	};
	Cnds.prototype.OnAnimFinished = function (animname)
	{
		return cr.equals_nocase(this.animTriggerName, animname);
	};
	Cnds.prototype.OnAnyAnimFinished = function ()
	{
		return true;
	};
	Cnds.prototype.OnFrameChanged = function ()
	{
		return true;
	};
	Cnds.prototype.IsMirrored = function ()
	{
		return this.width < 0;
	};
	Cnds.prototype.IsFlipped = function ()
	{
		return this.height < 0;
	};
	Cnds.prototype.OnURLLoaded = function ()
	{
		return true;
	};
	Cnds.prototype.IsCollisionEnabled = function ()
	{
		return this.collisionsEnabled;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Spawn = function (obj, layer, imgpt)
	{
		if (!obj || !layer)
			return;
		var inst = this.runtime.createInstance(obj, layer, this.getImagePoint(imgpt, true), this.getImagePoint(imgpt, false));
		if (!inst)
			return;
		if (typeof inst.angle !== "undefined")
		{
			inst.angle = this.angle;
			inst.set_bbox_changed();
		}
		this.runtime.isInOnDestroy++;
		var i, len, s;
		this.runtime.trigger(Object.getPrototypeOf(obj.plugin).cnds.OnCreated, inst);
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				this.runtime.trigger(Object.getPrototypeOf(s.type.plugin).cnds.OnCreated, s);
			}
		}
		this.runtime.isInOnDestroy--;
		var cur_act = this.runtime.getCurrentAction();
		var reset_sol = false;
		if (cr.is_undefined(cur_act.extra.Spawn_LastExec) || cur_act.extra.Spawn_LastExec < this.runtime.execcount)
		{
			reset_sol = true;
			cur_act.extra.Spawn_LastExec = this.runtime.execcount;
		}
		var sol;
		if (obj != this.type)
		{
			sol = obj.getCurrentSol();
			sol.select_all = false;
			if (reset_sol)
			{
				sol.instances.length = 1;
				sol.instances[0] = inst;
			}
			else
				sol.instances.push(inst);
			if (inst.is_contained)
			{
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					s = inst.siblings[i];
					sol = s.type.getCurrentSol();
					sol.select_all = false;
					if (reset_sol)
					{
						sol.instances.length = 1;
						sol.instances[0] = s;
					}
					else
						sol.instances.push(s);
				}
			}
		}
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.StopAnim = function ()
	{
		this.animPlaying = false;
	};
	Acts.prototype.StartAnim = function (from)
	{
		this.animPlaying = true;
		this.frameStart = this.getNowTime();
		if (from === 1 && this.cur_frame !== 0)
		{
			this.changeAnimFrame = 0;
			if (!this.inAnimTrigger)
				this.doChangeAnimFrame();
		}
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
	};
	Acts.prototype.SetAnim = function (animname, from)
	{
		this.changeAnimName = animname;
		this.changeAnimFrom = from;
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		if (!this.inAnimTrigger)
			this.doChangeAnim();
	};
	Acts.prototype.SetAnimFrame = function (framenumber)
	{
		this.changeAnimFrame = framenumber;
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		if (!this.inAnimTrigger)
			this.doChangeAnimFrame();
	};
	Acts.prototype.SetAnimSpeed = function (s)
	{
		this.cur_anim_speed = cr.abs(s);
		this.animForwards = (s >= 0);
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
	};
	Acts.prototype.SetMirrored = function (m)
	{
		var neww = cr.abs(this.width) * (m === 0 ? -1 : 1);
		if (this.width === neww)
			return;
		this.width = neww;
		this.set_bbox_changed();
	};
	Acts.prototype.SetFlipped = function (f)
	{
		var newh = cr.abs(this.height) * (f === 0 ? -1 : 1);
		if (this.height === newh)
			return;
		this.height = newh;
		this.set_bbox_changed();
	};
	Acts.prototype.SetScale = function (s)
	{
		var cur_frame = this.curFrame;
		var mirror_factor = (this.width < 0 ? -1 : 1);
		var flip_factor = (this.height < 0 ? -1 : 1);
		var new_width = cur_frame.width * s * mirror_factor;
		var new_height = cur_frame.height * s * flip_factor;
		if (this.width !== new_width || this.height !== new_height)
		{
			this.width = new_width;
			this.height = new_height;
			this.set_bbox_changed();
		}
	};
	Acts.prototype.LoadURL = function (url_, resize_)
	{
		var img = new Image();
		var self = this;
		var curFrame_ = this.curFrame;
		img.onload = function ()
		{
			if (curFrame_.texture_img.src === img.src)
			{
				if (self.runtime.glwrap && self.curFrame === curFrame_)
					self.curWebGLTexture = curFrame_.webGL_texture;
				self.runtime.redraw = true;
				self.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded, self);
				return;
			}
			curFrame_.texture_img = img;
			curFrame_.offx = 0;
			curFrame_.offy = 0;
			curFrame_.width = img.width;
			curFrame_.height = img.height;
			curFrame_.spritesheeted = false;
			curFrame_.datauri = "";
			if (self.runtime.glwrap)
			{
				if (curFrame_.webGL_texture)
					self.runtime.glwrap.deleteTexture(curFrame_.webGL_texture);
				curFrame_.webGL_texture = self.runtime.glwrap.loadTexture(img, false, self.runtime.linearSampling);
				if (self.curFrame === curFrame_)
					self.curWebGLTexture = curFrame_.webGL_texture;
				self.type.updateAllCurrentTexture();
			}
			if (resize_ === 0)		// resize to image size
			{
				self.width = img.width;
				self.height = img.height;
				self.set_bbox_changed();
			}
			self.runtime.redraw = true;
			self.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded, self);
		};
		if (url_.substr(0, 5) !== "data:")
			img.crossOrigin = 'anonymous';
		img.src = url_;
	};
	Acts.prototype.SetCollisions = function (set_)
	{
		if (this.collisionsEnabled === (set_ !== 0))
			return;		// no change
		this.collisionsEnabled = (set_ !== 0);
		if (this.collisionsEnabled)
			this.set_bbox_changed();		// needs to be added back to cells
		else
		{
			if (this.collcells.right >= this.collcells.left)
				this.type.collision_grid.update(this, this.collcells, null);
			this.collcells.set(0, 0, -1, -1);
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.AnimationFrame = function (ret)
	{
		ret.set_int(this.cur_frame);
	};
	Exps.prototype.AnimationFrameCount = function (ret)
	{
		ret.set_int(this.cur_animation.frames.length);
	};
	Exps.prototype.AnimationName = function (ret)
	{
		ret.set_string(this.cur_animation.name);
	};
	Exps.prototype.AnimationSpeed = function (ret)
	{
		ret.set_float(this.animForwards ? this.cur_anim_speed : -this.cur_anim_speed);
	};
	Exps.prototype.ImagePointX = function (ret, imgpt)
	{
		ret.set_float(this.getImagePoint(imgpt, true));
	};
	Exps.prototype.ImagePointY = function (ret, imgpt)
	{
		ret.set_float(this.getImagePoint(imgpt, false));
	};
	Exps.prototype.ImagePointCount = function (ret)
	{
		ret.set_int(this.curFrame.image_points.length);
	};
	Exps.prototype.ImageWidth = function (ret)
	{
		ret.set_float(this.curFrame.width);
	};
	Exps.prototype.ImageHeight = function (ret)
	{
		ret.set_float(this.curFrame.height);
	};
	pluginProto.exps = new Exps();
}());
/* global cr,log,assert2 */
/* jshint globalstrict: true */
/* jshint strict: true */
;
;
cr.plugins_.Spritefont2 = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Spritefont2.prototype;
	pluginProto.onCreate = function ()
	{
	};
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.runtime.waitForImageLoad(this.texture_img);
		this.webGL_texture = null;
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.webGL_texture = null;
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		if (!this.webGL_texture)
		{
			this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, false, this.runtime.linearSampling, this.texture_pixelformat);
		}
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].webGL_texture = this.webGL_texture;
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.webGL_texture)
			return;
		this.runtime.glwrap.deleteTexture(this.webGL_texture);
		this.webGL_texture = null;
	};
	typeProto.preloadCanvas2D = function (ctx)
	{
		ctx.drawImage(this.texture_img, 0, 0);
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onDestroy = function()
	{
		freeAllLines (this.lines);
		freeAllClip  (this.clipList);
		freeAllClipUV(this.clipUV);
		cr.wipe(this.characterWidthList);
	};
	instanceProto.onCreate = function()
	{
		this.texture_img      = this.type.texture_img;
		this.characterWidth   = this.properties[0];
		this.characterHeight  = this.properties[1];
		this.characterSet     = this.properties[2];
		this.text             = this.properties[3];
		this.characterScale   = this.properties[4];
		this.visible          = (this.properties[5] === 0);	// 0=visible, 1=invisible
		this.halign           = this.properties[6]/2.0;			// 0=left, 1=center, 2=right
		this.valign           = this.properties[7]/2.0;			// 0=top, 1=center, 2=bottom
		this.wrapbyword       = (this.properties[9] === 0);	// 0=word, 1=character
		this.characterSpacing = this.properties[10];
		this.lineHeight       = this.properties[11];
		this.textWidth  = 0;
		this.textHeight = 0;
		if (this.recycled)
		{
			this.lines.length = 0;
			cr.wipe(this.clipList);
			cr.wipe(this.clipUV);
			cr.wipe(this.characterWidthList);
		}
		else
		{
			this.lines = [];
			this.clipList = {};
			this.clipUV = {};
			this.characterWidthList = {};
		}
		this.text_changed = true;
		this.lastwrapwidth = this.width;
		if (this.runtime.glwrap)
		{
			if (!this.type.webGL_texture)
			{
				this.type.webGL_texture = this.runtime.glwrap.loadTexture(this.type.texture_img, false, this.runtime.linearSampling, this.type.texture_pixelformat);
			}
			this.webGL_texture = this.type.webGL_texture;
		}
		this.SplitSheet();
	};
	instanceProto.saveToJSON = function ()
	{
		var save = {
			"t": this.text,
			"csc": this.characterScale,
			"csp": this.characterSpacing,
			"lh": this.lineHeight,
			"tw": this.textWidth,
			"th": this.textHeight,
			"lrt": this.last_render_tick,
			"cw": {}
		};
		for (var ch in this.characterWidthList)
			save["cw"][ch] = this.characterWidthList[ch];
		return save;
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.text = o["t"];
		this.characterScale = o["csc"];
		this.characterSpacing = o["csp"];
		this.lineHeight = o["lh"];
		this.textWidth = o["tw"];
		this.textHeight = o["th"];
		this.last_render_tick = o["lrt"];
		for(var ch in o["cw"])
			this.characterWidthList[ch] = o["cw"][ch];
		this.text_changed = true;
		this.lastwrapwidth = this.width;
	};
	function trimRight(text)
	{
		return text.replace(/\s\s*$/, '');
	}
	var MAX_CACHE_SIZE = 1000;
	function alloc(cache,Constructor)
	{
		if (cache.length)
			return cache.pop();
		else
			return new Constructor();
	}
	function free(cache,data)
	{
		if (cache.length < MAX_CACHE_SIZE)
		{
			cache.push(data);
		}
	}
	function freeAll(cache,dataList,isArray)
	{
		if (isArray) {
			var i, len;
			for (i = 0, len = dataList.length; i < len; i++)
			{
				free(cache,dataList[i]);
			}
			dataList.length = 0;
		} else {
			var prop;
			for(prop in dataList) {
				if(Object.prototype.hasOwnProperty.call(dataList,prop)) {
					free(cache,dataList[prop]);
					delete dataList[prop];
				}
			}
		}
	}
	function addLine(inst,lineIndex,cur_line) {
		var lines = inst.lines;
		var line;
		cur_line = trimRight(cur_line);
		if (lineIndex >= lines.length)
			lines.push(allocLine());
		line = lines[lineIndex];
		line.text = cur_line;
		line.width = inst.measureWidth(cur_line);
		inst.textWidth = cr.max(inst.textWidth,line.width);
	}
	var linesCache = [];
	function allocLine()       { return alloc(linesCache,Object); }
	function freeLine(l)       { free(linesCache,l); }
	function freeAllLines(arr) { freeAll(linesCache,arr,true); }
	function addClip(obj,property,x,y,w,h) {
		if (obj[property] === undefined) {
			obj[property] = alloc(clipCache,Object);
		}
		obj[property].x = x;
		obj[property].y = y;
		obj[property].w = w;
		obj[property].h = h;
	}
	var clipCache = [];
	function allocClip()      { return alloc(clipCache,Object); }
	function freeAllClip(obj) { freeAll(clipCache,obj,false);}
	function addClipUV(obj,property,left,top,right,bottom) {
		if (obj[property] === undefined) {
			obj[property] = alloc(clipUVCache,cr.rect);
		}
		obj[property].left   = left;
		obj[property].top    = top;
		obj[property].right  = right;
		obj[property].bottom = bottom;
	}
	var clipUVCache = [];
	function allocClipUV()      { return alloc(clipUVCache,cr.rect);}
	function freeAllClipUV(obj) { freeAll(clipUVCache,obj,false);}
	instanceProto.SplitSheet = function() {
		var texture      = this.texture_img;
		var texWidth     = texture.width;
		var texHeight    = texture.height;
		var charWidth    = this.characterWidth;
		var charHeight   = this.characterHeight;
		var charU        = charWidth /texWidth;
		var charV        = charHeight/texHeight;
		var charSet      = this.characterSet ;
		var cols = Math.floor(texWidth/charWidth);
		var rows = Math.floor(texHeight/charHeight);
		for ( var c = 0; c < charSet.length; c++) {
			if  (c >= cols * rows) break;
			var x = c%cols;
			var y = Math.floor(c/cols);
			var letter = charSet.charAt(c);
			if (this.runtime.glwrap) {
				addClipUV(
					this.clipUV, letter,
					x * charU ,
					y * charV ,
					(x+1) * charU ,
					(y+1) * charV
				);
			} else {
				addClip(
					this.clipList, letter,
					x * charWidth,
					y * charHeight,
					charWidth,
					charHeight
				);
			}
		}
	};
	/*
     *	Word-Wrapping
     */
	var wordsCache = [];
	pluginProto.TokeniseWords = function (text)
	{
		wordsCache.length = 0;
		var cur_word = "";
		var ch;
		var i = 0;
		while (i < text.length)
		{
			ch = text.charAt(i);
			if (ch === "\n")
			{
				if (cur_word.length)
				{
					wordsCache.push(cur_word);
					cur_word = "";
				}
				wordsCache.push("\n");
				++i;
			}
			else if (ch === " " || ch === "\t" || ch === "-")
			{
				do {
					cur_word += text.charAt(i);
					i++;
				}
				while (i < text.length && (text.charAt(i) === " " || text.charAt(i) === "\t"));
				wordsCache.push(cur_word);
				cur_word = "";
			}
			else if (i < text.length)
			{
				cur_word += ch;
				i++;
			}
		}
		if (cur_word.length)
			wordsCache.push(cur_word);
	};
	pluginProto.WordWrap = function (inst)
	{
		var text = inst.text;
		var lines = inst.lines;
		if (!text || !text.length)
		{
			freeAllLines(lines);
			return;
		}
		var width = inst.width;
		if (width <= 2.0)
		{
			freeAllLines(lines);
			return;
		}
		var charWidth = inst.characterWidth;
		var charScale = inst.characterScale;
		var charSpacing = inst.characterSpacing;
		if ( (text.length * (charWidth * charScale + charSpacing) - charSpacing) <= width && text.indexOf("\n") === -1)
		{
			var all_width = inst.measureWidth(text);
			if (all_width <= width)
			{
				freeAllLines(lines);
				lines.push(allocLine());
				lines[0].text = text;
				lines[0].width = all_width;
				inst.textWidth  = all_width;
				inst.textHeight = inst.characterHeight * charScale + inst.lineHeight;
				return;
			}
		}
		var wrapbyword = inst.wrapbyword;
		this.WrapText(inst);
		inst.textHeight = lines.length * (inst.characterHeight * charScale + inst.lineHeight);
	};
	pluginProto.WrapText = function (inst)
	{
		var wrapbyword = inst.wrapbyword;
		var text       = inst.text;
		var lines      = inst.lines;
		var width      = inst.width;
		var wordArray;
		if (wrapbyword) {
			this.TokeniseWords(text);	// writes to wordsCache
			wordArray = wordsCache;
		} else {
			wordArray = text;
		}
		var cur_line = "";
		var prev_line;
		var line_width;
		var i;
		var lineIndex = 0;
		var line;
		var ignore_newline = false;
		for (i = 0; i < wordArray.length; i++)
		{
			if (wordArray[i] === "\n")
			{
				if (ignore_newline === true) {
					ignore_newline = false;
				} else {
					addLine(inst,lineIndex,cur_line);
					lineIndex++;
				}
				cur_line = "";
				continue;
			}
			ignore_newline = false;
			prev_line = cur_line;
			cur_line += wordArray[i];
			line_width = inst.measureWidth(trimRight(cur_line));
			if (line_width > width)
			{
				if (prev_line === "") {
					addLine(inst,lineIndex,cur_line);
					cur_line = "";
					ignore_newline = true;
				} else {
					addLine(inst,lineIndex,prev_line);
					cur_line = wordArray[i];
				}
				lineIndex++;
				if (!wrapbyword && cur_line === " ")
					cur_line = "";
			}
		}
		if (trimRight(cur_line).length)
		{
			addLine(inst,lineIndex,cur_line);
			lineIndex++;
		}
		for (i = lineIndex; i < lines.length; i++)
			freeLine(lines[i]);
		lines.length = lineIndex;
	};
	instanceProto.measureWidth = function(text) {
		var spacing = this.characterSpacing;
		var len     = text.length;
		var width   = 0;
		for (var i = 0; i < len; i++) {
			width += this.getCharacterWidth(text.charAt(i)) * this.characterScale + spacing;
		}
		width -= (width > 0) ? spacing : 0;
		return width;
	};
	/***/
	instanceProto.getCharacterWidth = function(character) {
		var widthList = this.characterWidthList;
		if (widthList[character] !== undefined) {
			return widthList[character];
		} else {
			return this.characterWidth;
		}
	};
	instanceProto.rebuildText = function() {
		if (this.text_changed || this.width !== this.lastwrapwidth) {
			this.textWidth = 0;
			this.textHeight = 0;
			this.type.plugin.WordWrap(this);
			this.text_changed = false;
			this.lastwrapwidth = this.width;
		}
	};
	var EPSILON = 0.00001;
	instanceProto.draw = function(ctx, glmode)
	{
		var texture = this.texture_img;
		if (this.text !== "" && texture != null) {
			this.rebuildText();
			if (this.height < this.characterHeight*this.characterScale + this.lineHeight) {
				return;
			}
			ctx.globalAlpha = this.opacity;
			var myx = this.x;
			var myy = this.y;
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			ctx.save();
			ctx.translate(myx, myy);
			ctx.rotate(this.angle);
			var ha         = this.halign;
			var va         = this.valign;
			var scale      = this.characterScale;
			var charHeight = this.characterHeight * scale;
			var lineHeight = this.lineHeight;
			var charSpace  = this.characterSpacing;
			var lines = this.lines;
			var textHeight = this.textHeight;
			var halign;
			var valign = va * cr.max(0,(this.height - textHeight));
			var offx = -(this.hotspotX * this.width);
			var offy = -(this.hotspotY * this.height);
			offy += valign;
			var drawX ;
			var drawY = offy;
			var roundX, roundY;
			for(var i = 0; i < lines.length; i++) {
				var line = lines[i].text;
				var len  = lines[i].width;
				halign = ha * cr.max(0,this.width - len);
				drawX = offx + halign;
				drawY += lineHeight;
				for(var j = 0; j < line.length; j++) {
					var letter = line.charAt(j);
					var clip = this.clipList[letter];
					if ( drawX + this.getCharacterWidth(letter) * scale > this.width + EPSILON ) {
						break;
					}
					if (clip !== undefined) {
						roundX = drawX;
						roundY = drawY;
						if (this.angle === 0)
						{
							roundX = Math.round(roundX);
							roundY = Math.round(roundY);
						}
						ctx.drawImage( this.texture_img,
									 clip.x, clip.y, clip.w, clip.h,
									 roundX,roundY,clip.w*scale,clip.h*scale);
					}
					drawX  += this.getCharacterWidth(letter) * scale + charSpace;
				}
				drawY += charHeight;
				if ( drawY + charHeight + lineHeight > this.height) {
					break;
				}
			}
			ctx.restore();
		}
	};
	var dQuad = new cr.quad();
	function rotateQuad(quad,cosa,sina) {
		var x_temp;
		x_temp   = (quad.tlx * cosa) - (quad.tly * sina);
		quad.tly = (quad.tly * cosa) + (quad.tlx * sina);
		quad.tlx = x_temp;
		x_temp    = (quad.trx * cosa) - (quad.try_ * sina);
		quad.try_ = (quad.try_ * cosa) + (quad.trx * sina);
		quad.trx  = x_temp;
		x_temp   = (quad.blx * cosa) - (quad.bly * sina);
		quad.bly = (quad.bly * cosa) + (quad.blx * sina);
		quad.blx = x_temp;
		x_temp    = (quad.brx * cosa) - (quad.bry * sina);
		quad.bry = (quad.bry * cosa) + (quad.brx * sina);
		quad.brx  = x_temp;
	}
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.webGL_texture);
		glw.setOpacity(this.opacity);
		if (this.text !== "") {
			this.rebuildText();
			if (this.height < this.characterHeight*this.characterScale + this.lineHeight) {
				return;
			}
			this.update_bbox();
			var q = this.bquad;
			var ox = 0;
			var oy = 0;
			if (this.runtime.pixel_rounding)
			{
				ox = ((this.x + 0.5) | 0) - this.x;
				oy = ((this.y + 0.5) | 0) - this.y;
			}
			var angle      = this.angle;
			var ha         = this.halign;
			var va         = this.valign;
			var scale      = this.characterScale;
			var charHeight = this.characterHeight * scale;   // to precalculate in onCreate or on change
			var lineHeight = this.lineHeight;
			var charSpace  = this.characterSpacing;
			var lines = this.lines;
			var textHeight = this.textHeight;
			var cosa,sina;
			if (angle !== 0)
			{
				cosa = Math.cos(angle);
				sina = Math.sin(angle);
			}
			var halign;
			var valign = va * cr.max(0,(this.height - textHeight));
			var offx = q.tlx + ox;
			var offy = q.tly + oy;
			var drawX ;
			var drawY = valign;
			var roundX, roundY;
			for(var i = 0; i < lines.length; i++) {
				var line       = lines[i].text;
				var lineWidth  = lines[i].width;
				halign = ha * cr.max(0,this.width - lineWidth);
				drawX = halign;
				drawY += lineHeight;
				for(var j = 0; j < line.length; j++) {
					var letter = line.charAt(j);
					var clipUV = this.clipUV[letter];
					if ( drawX + this.getCharacterWidth(letter) * scale  > this.width + EPSILON) {
						break;
					}
					if (clipUV !== undefined) {
						var clipWidth  = this.characterWidth*scale;
						var clipHeight = this.characterHeight*scale;
						roundX = drawX;
						roundY = drawY;
						if (angle === 0)
						{
							roundX = Math.round(roundX);
							roundY = Math.round(roundY);
						}
						dQuad.tlx  = roundX;
						dQuad.tly  = roundY;
						dQuad.trx  = roundX + clipWidth;
						dQuad.try_ = roundY ;
						dQuad.blx  = roundX;
						dQuad.bly  = roundY + clipHeight;
						dQuad.brx  = roundX + clipWidth;
						dQuad.bry  = roundY + clipHeight;
						if(angle !== 0)
						{
							rotateQuad(dQuad,cosa,sina);
						}
						dQuad.offset(offx,offy);
						glw.quadTex(
							dQuad.tlx, dQuad.tly,
							dQuad.trx, dQuad.try_,
							dQuad.brx, dQuad.bry,
							dQuad.blx, dQuad.bly,
							clipUV
						);
					}
					drawX  += this.getCharacterWidth(letter) * scale + charSpace;
				}
				drawY += charHeight;
				if ( drawY + charHeight + lineHeight > this.height) {
					break;
				}
			}
		}
	};
	function Cnds() {}
	Cnds.prototype.CompareText = function(text_to_compare, case_sensitive)
	{
		if (case_sensitive)
			return this.text == text_to_compare;
		else
			return cr.equals_nocase(this.text, text_to_compare);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {}
	Acts.prototype.SetText = function(param)
	{
		if (cr.is_number(param) && param < 1e9)
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_set = param.toString();
		if (this.text !== text_to_set)
		{
			this.text = text_to_set;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.AppendText = function(param)
	{
		if (cr.is_number(param))
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_append = param.toString();
		if (text_to_append)	// not empty
		{
			this.text += text_to_append;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetScale = function(param)
	{
		if (param !== this.characterScale) {
			this.characterScale = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetCharacterSpacing = function(param)
	{
		if (param !== this.CharacterSpacing) {
			this.characterSpacing = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetLineHeight = function(param)
	{
		if (param !== this.lineHeight) {
			this.lineHeight = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	instanceProto.SetCharWidth = function(character,width) {
		var w = parseInt(width,10);
		if (this.characterWidthList[character] !== w) {
			this.characterWidthList[character] = w;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetCharacterWidth = function(characterSet,width)
	{
		if (characterSet !== "") {
			for(var c = 0; c < characterSet.length; c++) {
				this.SetCharWidth(characterSet.charAt(c),width);
			}
		}
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.SetHAlign = function (a)
	{
		this.halign = a / 2.0;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	Acts.prototype.SetVAlign = function (a)
	{
		this.valign = a / 2.0;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	pluginProto.acts = new Acts();
	function Exps() {}
	Exps.prototype.CharacterWidth = function(ret,character)
	{
		ret.set_int(this.getCharacterWidth(character));
	};
	Exps.prototype.CharacterHeight = function(ret)
	{
		ret.set_int(this.characterHeight);
	};
	Exps.prototype.CharacterScale = function(ret)
	{
		ret.set_float(this.characterScale);
	};
	Exps.prototype.CharacterSpacing = function(ret)
	{
		ret.set_int(this.characterSpacing);
	};
	Exps.prototype.LineHeight = function(ret)
	{
		ret.set_int(this.lineHeight);
	};
	Exps.prototype.Text = function(ret)
	{
		ret.set_string(this.text);
	};
	Exps.prototype.TextWidth = function (ret)
	{
		this.rebuildText();
		ret.set_float(this.textWidth);
	};
	Exps.prototype.TextHeight = function (ret)
	{
		this.rebuildText();
		ret.set_float(this.textHeight);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Text = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Text.prototype;
	pluginProto.onCreate = function ()
	{
		pluginProto.acts.SetWidth = function (w)
		{
			if (this.width !== w)
			{
				this.width = w;
				this.text_changed = true;	// also recalculate text wrapping
				this.set_bbox_changed();
			}
		};
	};
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		var i, len, inst;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			inst.mycanvas = null;
			inst.myctx = null;
			inst.mytex = null;
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		if (this.recycled)
			this.lines.length = 0;
		else
			this.lines = [];		// for word wrapping
		this.text_changed = true;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var requestedWebFonts = {};		// already requested web fonts have an entry here
	instanceProto.onCreate = function()
	{
		this.text = this.properties[0];
		this.visible = (this.properties[1] === 0);		// 0=visible, 1=invisible
		this.font = this.properties[2];
		this.color = this.properties[3];
		this.halign = this.properties[4];				// 0=left, 1=center, 2=right
		this.valign = this.properties[5];				// 0=top, 1=center, 2=bottom
		this.wrapbyword = (this.properties[7] === 0);	// 0=word, 1=character
		this.lastwidth = this.width;
		this.lastwrapwidth = this.width;
		this.lastheight = this.height;
		this.line_height_offset = this.properties[8];
		this.facename = "";
		this.fontstyle = "";
		this.ptSize = 0;
		this.textWidth = 0;
		this.textHeight = 0;
		this.parseFont();
		this.mycanvas = null;
		this.myctx = null;
		this.mytex = null;
		this.need_text_redraw = false;
		this.last_render_tick = this.runtime.tickcount;
		if (this.recycled)
			this.rcTex.set(0, 0, 1, 1);
		else
			this.rcTex = new cr.rect(0, 0, 1, 1);
		if (this.runtime.glwrap)
			this.runtime.tickMe(this);
;
	};
	instanceProto.parseFont = function ()
	{
		var arr = this.font.split(" ");
		var i;
		for (i = 0; i < arr.length; i++)
		{
			if (arr[i].substr(arr[i].length - 2, 2) === "pt")
			{
				this.ptSize = parseInt(arr[i].substr(0, arr[i].length - 2));
				this.pxHeight = Math.ceil((this.ptSize / 72.0) * 96.0) + 4;	// assume 96dpi...
				if (i > 0)
					this.fontstyle = arr[i - 1];
				this.facename = arr[i + 1];
				for (i = i + 2; i < arr.length; i++)
					this.facename += " " + arr[i];
				break;
			}
		}
	};
	instanceProto.saveToJSON = function ()
	{
		return {
			"t": this.text,
			"f": this.font,
			"c": this.color,
			"ha": this.halign,
			"va": this.valign,
			"wr": this.wrapbyword,
			"lho": this.line_height_offset,
			"fn": this.facename,
			"fs": this.fontstyle,
			"ps": this.ptSize,
			"pxh": this.pxHeight,
			"tw": this.textWidth,
			"th": this.textHeight,
			"lrt": this.last_render_tick
		};
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.text = o["t"];
		this.font = o["f"];
		this.color = o["c"];
		this.halign = o["ha"];
		this.valign = o["va"];
		this.wrapbyword = o["wr"];
		this.line_height_offset = o["lho"];
		this.facename = o["fn"];
		this.fontstyle = o["fs"];
		this.ptSize = o["ps"];
		this.pxHeight = o["pxh"];
		this.textWidth = o["tw"];
		this.textHeight = o["th"];
		this.last_render_tick = o["lrt"];
		this.text_changed = true;
		this.lastwidth = this.width;
		this.lastwrapwidth = this.width;
		this.lastheight = this.height;
	};
	instanceProto.tick = function ()
	{
		if (this.runtime.glwrap && this.mytex && (this.runtime.tickcount - this.last_render_tick >= 300))
		{
			var layer = this.layer;
            this.update_bbox();
            var bbox = this.bbox;
            if (bbox.right < layer.viewLeft || bbox.bottom < layer.viewTop || bbox.left > layer.viewRight || bbox.top > layer.viewBottom)
			{
				this.runtime.glwrap.deleteTexture(this.mytex);
				this.mytex = null;
				this.myctx = null;
				this.mycanvas = null;
			}
		}
	};
	instanceProto.onDestroy = function ()
	{
		this.myctx = null;
		this.mycanvas = null;
		if (this.runtime.glwrap && this.mytex)
			this.runtime.glwrap.deleteTexture(this.mytex);
		this.mytex = null;
	};
	instanceProto.updateFont = function ()
	{
		this.font = this.fontstyle + " " + this.ptSize.toString() + "pt " + this.facename;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	instanceProto.draw = function(ctx, glmode)
	{
		ctx.font = this.font;
		ctx.textBaseline = "top";
		ctx.fillStyle = this.color;
		ctx.globalAlpha = glmode ? 1 : this.opacity;
		var myscale = 1;
		if (glmode)
		{
			myscale = this.layer.getScale();
			ctx.save();
			ctx.scale(myscale, myscale);
		}
		if (this.text_changed || this.width !== this.lastwrapwidth)
		{
			this.type.plugin.WordWrap(this.text, this.lines, ctx, this.width, this.wrapbyword);
			this.text_changed = false;
			this.lastwrapwidth = this.width;
		}
		this.update_bbox();
		var penX = glmode ? 0 : this.bquad.tlx;
		var penY = glmode ? 0 : this.bquad.tly;
		if (this.runtime.pixel_rounding)
		{
			penX = (penX + 0.5) | 0;
			penY = (penY + 0.5) | 0;
		}
		if (this.angle !== 0 && !glmode)
		{
			ctx.save();
			ctx.translate(penX, penY);
			ctx.rotate(this.angle);
			penX = 0;
			penY = 0;
		}
		var endY = penY + this.height;
		var line_height = this.pxHeight;
		line_height += this.line_height_offset;
		var drawX;
		var i;
		if (this.valign === 1)		// center
			penY += Math.max(this.height / 2 - (this.lines.length * line_height) / 2, 0);
		else if (this.valign === 2)	// bottom
			penY += Math.max(this.height - (this.lines.length * line_height) - 2, 0);
		for (i = 0; i < this.lines.length; i++)
		{
			drawX = penX;
			if (this.halign === 1)		// center
				drawX = penX + (this.width - this.lines[i].width) / 2;
			else if (this.halign === 2)	// right
				drawX = penX + (this.width - this.lines[i].width);
			ctx.fillText(this.lines[i].text, drawX, penY);
			penY += line_height;
			if (penY >= endY - line_height)
				break;
		}
		if (this.angle !== 0 || glmode)
			ctx.restore();
		this.last_render_tick = this.runtime.tickcount;
	};
	instanceProto.drawGL = function(glw)
	{
		if (this.width < 1 || this.height < 1)
			return;
		var need_redraw = this.text_changed || this.need_text_redraw;
		this.need_text_redraw = false;
		var layer_scale = this.layer.getScale();
		var layer_angle = this.layer.getAngle();
		var rcTex = this.rcTex;
		var floatscaledwidth = layer_scale * this.width;
		var floatscaledheight = layer_scale * this.height;
		var scaledwidth = Math.ceil(floatscaledwidth);
		var scaledheight = Math.ceil(floatscaledheight);
		var halfw = this.runtime.draw_width / 2;
		var halfh = this.runtime.draw_height / 2;
		if (!this.myctx)
		{
			this.mycanvas = document.createElement("canvas");
			this.mycanvas.width = scaledwidth;
			this.mycanvas.height = scaledheight;
			this.lastwidth = scaledwidth;
			this.lastheight = scaledheight;
			need_redraw = true;
			this.myctx = this.mycanvas.getContext("2d");
		}
		if (scaledwidth !== this.lastwidth || scaledheight !== this.lastheight)
		{
			this.mycanvas.width = scaledwidth;
			this.mycanvas.height = scaledheight;
			if (this.mytex)
			{
				glw.deleteTexture(this.mytex);
				this.mytex = null;
			}
			need_redraw = true;
		}
		if (need_redraw)
		{
			this.myctx.clearRect(0, 0, scaledwidth, scaledheight);
			this.draw(this.myctx, true);
			if (!this.mytex)
				this.mytex = glw.createEmptyTexture(scaledwidth, scaledheight, this.runtime.linearSampling, this.runtime.isMobile);
			glw.videoToTexture(this.mycanvas, this.mytex, this.runtime.isMobile);
		}
		this.lastwidth = scaledwidth;
		this.lastheight = scaledheight;
		glw.setTexture(this.mytex);
		glw.setOpacity(this.opacity);
		glw.resetModelView();
		glw.translate(-halfw, -halfh);
		glw.updateModelView();
		var q = this.bquad;
		var old_dpr = this.runtime.devicePixelRatio;
		this.runtime.devicePixelRatio = 1;
		var tlx = this.layer.layerToCanvas(q.tlx, q.tly, true, true);
		var tly = this.layer.layerToCanvas(q.tlx, q.tly, false, true);
		var trx = this.layer.layerToCanvas(q.trx, q.try_, true, true);
		var try_ = this.layer.layerToCanvas(q.trx, q.try_, false, true);
		var brx = this.layer.layerToCanvas(q.brx, q.bry, true, true);
		var bry = this.layer.layerToCanvas(q.brx, q.bry, false, true);
		var blx = this.layer.layerToCanvas(q.blx, q.bly, true, true);
		var bly = this.layer.layerToCanvas(q.blx, q.bly, false, true);
		this.runtime.devicePixelRatio = old_dpr;
		if (this.runtime.pixel_rounding || (this.angle === 0 && layer_angle === 0))
		{
			var ox = ((tlx + 0.5) | 0) - tlx;
			var oy = ((tly + 0.5) | 0) - tly
			tlx += ox;
			tly += oy;
			trx += ox;
			try_ += oy;
			brx += ox;
			bry += oy;
			blx += ox;
			bly += oy;
		}
		if (this.angle === 0 && layer_angle === 0)
		{
			trx = tlx + scaledwidth;
			try_ = tly;
			brx = trx;
			bry = tly + scaledheight;
			blx = tlx;
			bly = bry;
			rcTex.right = 1;
			rcTex.bottom = 1;
		}
		else
		{
			rcTex.right = floatscaledwidth / scaledwidth;
			rcTex.bottom = floatscaledheight / scaledheight;
		}
		glw.quadTex(tlx, tly, trx, try_, brx, bry, blx, bly, rcTex);
		glw.resetModelView();
		glw.scale(layer_scale, layer_scale);
		glw.rotateZ(-this.layer.getAngle());
		glw.translate((this.layer.viewLeft + this.layer.viewRight) / -2, (this.layer.viewTop + this.layer.viewBottom) / -2);
		glw.updateModelView();
		this.last_render_tick = this.runtime.tickcount;
	};
	var wordsCache = [];
	pluginProto.TokeniseWords = function (text)
	{
		wordsCache.length = 0;
		var cur_word = "";
		var ch;
		var i = 0;
		while (i < text.length)
		{
			ch = text.charAt(i);
			if (ch === "\n")
			{
				if (cur_word.length)
				{
					wordsCache.push(cur_word);
					cur_word = "";
				}
				wordsCache.push("\n");
				++i;
			}
			else if (ch === " " || ch === "\t" || ch === "-")
			{
				do {
					cur_word += text.charAt(i);
					i++;
				}
				while (i < text.length && (text.charAt(i) === " " || text.charAt(i) === "\t"));
				wordsCache.push(cur_word);
				cur_word = "";
			}
			else if (i < text.length)
			{
				cur_word += ch;
				i++;
			}
		}
		if (cur_word.length)
			wordsCache.push(cur_word);
	};
	var linesCache = [];
	function allocLine()
	{
		if (linesCache.length)
			return linesCache.pop();
		else
			return {};
	};
	function freeLine(l)
	{
		linesCache.push(l);
	};
	function freeAllLines(arr)
	{
		var i, len;
		for (i = 0, len = arr.length; i < len; i++)
		{
			freeLine(arr[i]);
		}
		arr.length = 0;
	};
	pluginProto.WordWrap = function (text, lines, ctx, width, wrapbyword)
	{
		if (!text || !text.length)
		{
			freeAllLines(lines);
			return;
		}
		if (width <= 2.0)
		{
			freeAllLines(lines);
			return;
		}
		if (text.length <= 100 && text.indexOf("\n") === -1)
		{
			var all_width = ctx.measureText(text).width;
			if (all_width <= width)
			{
				freeAllLines(lines);
				lines.push(allocLine());
				lines[0].text = text;
				lines[0].width = all_width;
				return;
			}
		}
		this.WrapText(text, lines, ctx, width, wrapbyword);
	};
	pluginProto.WrapText = function (text, lines, ctx, width, wrapbyword)
	{
		var wordArray;
		if (wrapbyword)
		{
			this.TokeniseWords(text);	// writes to wordsCache
			wordArray = wordsCache;
		}
		else
			wordArray = text;
		var cur_line = "";
		var prev_line;
		var line_width;
		var i;
		var lineIndex = 0;
		var line;
		for (i = 0; i < wordArray.length; i++)
		{
			if (wordArray[i] === "\n")
			{
				if (lineIndex >= lines.length)
					lines.push(allocLine());
				line = lines[lineIndex];
				line.text = cur_line;
				line.width = ctx.measureText(cur_line).width;
				lineIndex++;
				cur_line = "";
				continue;
			}
			prev_line = cur_line;
			cur_line += wordArray[i];
			line_width = ctx.measureText(cur_line).width;
			if (line_width >= width)
			{
				if (lineIndex >= lines.length)
					lines.push(allocLine());
				line = lines[lineIndex];
				line.text = prev_line;
				line.width = ctx.measureText(prev_line).width;
				lineIndex++;
				cur_line = wordArray[i];
				if (!wrapbyword && cur_line === " ")
					cur_line = "";
			}
		}
		if (cur_line.length)
		{
			if (lineIndex >= lines.length)
				lines.push(allocLine());
			line = lines[lineIndex];
			line.text = cur_line;
			line.width = ctx.measureText(cur_line).width;
			lineIndex++;
		}
		for (i = lineIndex; i < lines.length; i++)
			freeLine(lines[i]);
		lines.length = lineIndex;
	};
	function Cnds() {};
	Cnds.prototype.CompareText = function(text_to_compare, case_sensitive)
	{
		if (case_sensitive)
			return this.text == text_to_compare;
		else
			return cr.equals_nocase(this.text, text_to_compare);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetText = function(param)
	{
		if (cr.is_number(param) && param < 1e9)
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_set = param.toString();
		if (this.text !== text_to_set)
		{
			this.text = text_to_set;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.AppendText = function(param)
	{
		if (cr.is_number(param))
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_append = param.toString();
		if (text_to_append)	// not empty
		{
			this.text += text_to_append;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetFontFace = function (face_, style_)
	{
		var newstyle = "";
		switch (style_) {
		case 1: newstyle = "bold"; break;
		case 2: newstyle = "italic"; break;
		case 3: newstyle = "bold italic"; break;
		}
		if (face_ === this.facename && newstyle === this.fontstyle)
			return;		// no change
		this.facename = face_;
		this.fontstyle = newstyle;
		this.updateFont();
	};
	Acts.prototype.SetFontSize = function (size_)
	{
		if (this.ptSize === size_)
			return;
		this.ptSize = size_;
		this.pxHeight = Math.ceil((this.ptSize / 72.0) * 96.0) + 4;	// assume 96dpi...
		this.updateFont();
	};
	Acts.prototype.SetFontColor = function (rgb)
	{
		var newcolor = "rgb(" + cr.GetRValue(rgb).toString() + "," + cr.GetGValue(rgb).toString() + "," + cr.GetBValue(rgb).toString() + ")";
		if (newcolor === this.color)
			return;
		this.color = newcolor;
		this.need_text_redraw = true;
		this.runtime.redraw = true;
	};
	Acts.prototype.SetWebFont = function (familyname_, cssurl_)
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Text plugin: 'Set web font' not supported on this platform - the action has been ignored");
			return;		// DC todo
		}
		var self = this;
		var refreshFunc = (function () {
							self.runtime.redraw = true;
							self.text_changed = true;
						});
		if (requestedWebFonts.hasOwnProperty(cssurl_))
		{
			var newfacename = "'" + familyname_ + "'";
			if (this.facename === newfacename)
				return;	// no change
			this.facename = newfacename;
			this.updateFont();
			for (var i = 1; i < 10; i++)
			{
				setTimeout(refreshFunc, i * 100);
				setTimeout(refreshFunc, i * 1000);
			}
			return;
		}
		var wf = document.createElement("link");
		wf.href = cssurl_;
		wf.rel = "stylesheet";
		wf.type = "text/css";
		wf.onload = refreshFunc;
		document.getElementsByTagName('head')[0].appendChild(wf);
		requestedWebFonts[cssurl_] = true;
		this.facename = "'" + familyname_ + "'";
		this.updateFont();
		for (var i = 1; i < 10; i++)
		{
			setTimeout(refreshFunc, i * 100);
			setTimeout(refreshFunc, i * 1000);
		}
;
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Text = function(ret)
	{
		ret.set_string(this.text);
	};
	Exps.prototype.FaceName = function (ret)
	{
		ret.set_string(this.facename);
	};
	Exps.prototype.FaceSize = function (ret)
	{
		ret.set_int(this.ptSize);
	};
	Exps.prototype.TextWidth = function (ret)
	{
		var w = 0;
		var i, len, x;
		for (i = 0, len = this.lines.length; i < len; i++)
		{
			x = this.lines[i].width;
			if (w < x)
				w = x;
		}
		ret.set_int(w);
	};
	Exps.prototype.TextHeight = function (ret)
	{
		ret.set_int(this.lines.length * (this.pxHeight + this.line_height_offset) - this.line_height_offset);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.TiledBg = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.TiledBg.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.texture_img.cr_filesize = this.texture_filesize;
		this.runtime.waitForImageLoad(this.texture_img);
		this.pattern = null;
		this.webGL_texture = null;
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.webGL_texture = null;
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		if (!this.webGL_texture)
		{
			this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, true, this.runtime.linearSampling, this.texture_pixelformat);
		}
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].webGL_texture = this.webGL_texture;
	};
	typeProto.loadTextures = function ()
	{
		if (this.is_family || this.webGL_texture || !this.runtime.glwrap)
			return;
		this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, true, this.runtime.linearSampling, this.texture_pixelformat);
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.webGL_texture)
			return;
		this.runtime.glwrap.deleteTexture(this.webGL_texture);
		this.webGL_texture = null;
	};
	typeProto.preloadCanvas2D = function (ctx)
	{
		ctx.drawImage(this.texture_img, 0, 0);
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.visible = (this.properties[0] === 0);							// 0=visible, 1=invisible
		this.rcTex = new cr.rect(0, 0, 0, 0);
		this.has_own_texture = false;										// true if a texture loaded in from URL
		this.texture_img = this.type.texture_img;
		if (this.runtime.glwrap)
		{
			this.type.loadTextures();
			this.webGL_texture = this.type.webGL_texture;
		}
		else
		{
			if (!this.type.pattern)
				this.type.pattern = this.runtime.ctx.createPattern(this.type.texture_img, "repeat");
			this.pattern = this.type.pattern;
		}
	};
	instanceProto.afterLoad = function ()
	{
		this.has_own_texture = false;
		this.texture_img = this.type.texture_img;
	};
	instanceProto.onDestroy = function ()
	{
		if (this.runtime.glwrap && this.has_own_texture && this.webGL_texture)
		{
			this.runtime.glwrap.deleteTexture(this.webGL_texture);
			this.webGL_texture = null;
		}
	};
	instanceProto.draw = function(ctx)
	{
		ctx.globalAlpha = this.opacity;
		ctx.save();
		ctx.fillStyle = this.pattern;
		var myx = this.x;
		var myy = this.y;
		if (this.runtime.pixel_rounding)
		{
			myx = (myx + 0.5) | 0;
			myy = (myy + 0.5) | 0;
		}
		var drawX = -(this.hotspotX * this.width);
		var drawY = -(this.hotspotY * this.height);
		var offX = drawX % this.texture_img.width;
		var offY = drawY % this.texture_img.height;
		if (offX < 0)
			offX += this.texture_img.width;
		if (offY < 0)
			offY += this.texture_img.height;
		ctx.translate(myx, myy);
		ctx.rotate(this.angle);
		ctx.translate(offX, offY);
		ctx.fillRect(drawX - offX,
					 drawY - offY,
					 this.width,
					 this.height);
		ctx.restore();
	};
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.webGL_texture);
		glw.setOpacity(this.opacity);
		var rcTex = this.rcTex;
		rcTex.right = this.width / this.texture_img.width;
		rcTex.bottom = this.height / this.texture_img.height;
		var q = this.bquad;
		if (this.runtime.pixel_rounding)
		{
			var ox = ((this.x + 0.5) | 0) - this.x;
			var oy = ((this.y + 0.5) | 0) - this.y;
			glw.quadTex(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy, rcTex);
		}
		else
			glw.quadTex(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly, rcTex);
	};
	function Cnds() {};
	Cnds.prototype.OnURLLoaded = function ()
	{
		return true;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.LoadURL = function (url_)
	{
		var img = new Image();
		var self = this;
		img.onload = function ()
		{
			self.texture_img = img;
			if (self.runtime.glwrap)
			{
				if (self.has_own_texture && self.webGL_texture)
					self.runtime.glwrap.deleteTexture(self.webGL_texture);
				self.webGL_texture = self.runtime.glwrap.loadTexture(img, true, self.runtime.linearSampling);
			}
			else
			{
				self.pattern = self.runtime.ctx.createPattern(img, "repeat");
			}
			self.has_own_texture = true;
			self.runtime.redraw = true;
			self.runtime.trigger(cr.plugins_.TiledBg.prototype.cnds.OnURLLoaded, self);
		};
		if (url_.substr(0, 5) !== "data:")
			img.crossOrigin = 'anonymous';
		img.src = url_;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.ImageWidth = function (ret)
	{
		ret.set_float(this.texture_img.width);
	};
	Exps.prototype.ImageHeight = function (ret)
	{
		ret.set_float(this.texture_img.height);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Touch = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Touch.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		this.touches = [];
		this.mouseDown = false;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var dummyoffset = {left: 0, top: 0};
	instanceProto.findTouch = function (id)
	{
		var i, len;
		for (i = 0, len = this.touches.length; i < len; i++)
		{
			if (this.touches[i]["id"] === id)
				return i;
		}
		return -1;
	};
	var appmobi_accx = 0;
	var appmobi_accy = 0;
	var appmobi_accz = 0;
	function AppMobiGetAcceleration(evt)
	{
		appmobi_accx = evt.x;
		appmobi_accy = evt.y;
		appmobi_accz = evt.z;
	};
	var pg_accx = 0;
	var pg_accy = 0;
	var pg_accz = 0;
	function PhoneGapGetAcceleration(evt)
	{
		pg_accx = evt.x;
		pg_accy = evt.y;
		pg_accz = evt.z;
	};
	var theInstance = null;
	instanceProto.onCreate = function()
	{
		theInstance = this;
		this.isWindows8 = !!(typeof window["c2isWindows8"] !== "undefined" && window["c2isWindows8"]);
		this.orient_alpha = 0;
		this.orient_beta = 0;
		this.orient_gamma = 0;
		this.acc_g_x = 0;
		this.acc_g_y = 0;
		this.acc_g_z = 0;
		this.acc_x = 0;
		this.acc_y = 0;
		this.acc_z = 0;
		this.curTouchX = 0;
		this.curTouchY = 0;
		this.trigger_index = 0;
		this.trigger_id = 0;
		this.useMouseInput = (this.properties[0] !== 0);
		var elem = (this.runtime.fullscreen_mode > 0) ? document : this.runtime.canvas;
		var elem2 = document;
		if (this.runtime.isDirectCanvas)
			elem2 = elem = window["Canvas"];
		else if (this.runtime.isCocoonJs)
			elem2 = elem = window;
		var self = this;
		if (window.navigator["pointerEnabled"])
		{
			elem.addEventListener("pointerdown",
				function(info) {
					self.onPointerStart(info);
				},
				false
			);
			elem.addEventListener("pointermove",
				function(info) {
					self.onPointerMove(info);
				},
				false
			);
			elem2.addEventListener("pointerup",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			elem2.addEventListener("pointercancel",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			if (this.runtime.canvas)
			{
				this.runtime.canvas.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				this.runtime.canvas.addEventListener("gesturehold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("gesturehold", function(e) {
					e.preventDefault();
				}, false);
			}
		}
		else if (window.navigator["msPointerEnabled"])
		{
			elem.addEventListener("MSPointerDown",
				function(info) {
					self.onPointerStart(info);
				},
				false
			);
			elem.addEventListener("MSPointerMove",
				function(info) {
					self.onPointerMove(info);
				},
				false
			);
			elem2.addEventListener("MSPointerUp",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			elem2.addEventListener("MSPointerCancel",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			if (this.runtime.canvas)
			{
				this.runtime.canvas.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
			}
		}
		else
		{
			elem.addEventListener("touchstart",
				function(info) {
					self.onTouchStart(info);
				},
				false
			);
			elem.addEventListener("touchmove",
				function(info) {
					self.onTouchMove(info);
				},
				false
			);
			elem2.addEventListener("touchend",
				function(info) {
					self.onTouchEnd(info);
				},
				false
			);
			elem2.addEventListener("touchcancel",
				function(info) {
					self.onTouchEnd(info);
				},
				false
			);
		}
		if (this.isWindows8)
		{
			var win8accelerometerFn = function(e) {
					var reading = e["reading"];
					self.acc_x = reading["accelerationX"];
					self.acc_y = reading["accelerationY"];
					self.acc_z = reading["accelerationZ"];
				};
			var win8inclinometerFn = function(e) {
					var reading = e["reading"];
					self.orient_alpha = reading["yawDegrees"];
					self.orient_beta = reading["pitchDegrees"];
					self.orient_gamma = reading["rollDegrees"];
				};
			var accelerometer = Windows["Devices"]["Sensors"]["Accelerometer"]["getDefault"]();
            if (accelerometer)
			{
                accelerometer["reportInterval"] = Math.max(accelerometer["minimumReportInterval"], 16);
				accelerometer.addEventListener("readingchanged", win8accelerometerFn);
            }
			var inclinometer = Windows["Devices"]["Sensors"]["Inclinometer"]["getDefault"]();
			if (inclinometer)
			{
				inclinometer["reportInterval"] = Math.max(inclinometer["minimumReportInterval"], 16);
				inclinometer.addEventListener("readingchanged", win8inclinometerFn);
			}
			document.addEventListener("visibilitychange", function(e) {
				if (document["hidden"] || document["msHidden"])
				{
					if (accelerometer)
						accelerometer.removeEventListener("readingchanged", win8accelerometerFn);
					if (inclinometer)
						inclinometer.removeEventListener("readingchanged", win8inclinometerFn);
				}
				else
				{
					if (accelerometer)
						accelerometer.addEventListener("readingchanged", win8accelerometerFn);
					if (inclinometer)
						inclinometer.addEventListener("readingchanged", win8inclinometerFn);
				}
			}, false);
		}
		else
		{
			window.addEventListener("deviceorientation", function (eventData) {
				self.orient_alpha = eventData["alpha"] || 0;
				self.orient_beta = eventData["beta"] || 0;
				self.orient_gamma = eventData["gamma"] || 0;
			}, false);
			window.addEventListener("devicemotion", function (eventData) {
				if (eventData["accelerationIncludingGravity"])
				{
					self.acc_g_x = eventData["accelerationIncludingGravity"]["x"] || 0;
					self.acc_g_y = eventData["accelerationIncludingGravity"]["y"] || 0;
					self.acc_g_z = eventData["accelerationIncludingGravity"]["z"] || 0;
				}
				if (eventData["acceleration"])
				{
					self.acc_x = eventData["acceleration"]["x"] || 0;
					self.acc_y = eventData["acceleration"]["y"] || 0;
					self.acc_z = eventData["acceleration"]["z"] || 0;
				}
			}, false);
		}
		if (this.useMouseInput && !this.runtime.isDomFree)
		{
			jQuery(document).mousemove(
				function(info) {
					self.onMouseMove(info);
				}
			);
			jQuery(document).mousedown(
				function(info) {
					self.onMouseDown(info);
				}
			);
			jQuery(document).mouseup(
				function(info) {
					self.onMouseUp(info);
				}
			);
		}
		if (this.runtime.isAppMobi && !this.runtime.isDirectCanvas)
		{
			AppMobi["accelerometer"]["watchAcceleration"](AppMobiGetAcceleration, { "frequency": 40, "adjustForRotation": true });
		}
		if (this.runtime.isPhoneGap && navigator["accelerometer"] && navigator["accelerometer"]["watchAcceleration"])
		{
			navigator["accelerometer"]["watchAcceleration"](PhoneGapGetAcceleration, null, { "frequency": 40 });
		}
		this.runtime.tick2Me(this);
	};
	instanceProto.onPointerMove = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var i = this.findTouch(info["pointerId"]);
		var nowtime = cr.performance_now();
		if (i >= 0)
		{
			var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
			var t = this.touches[i];
			if (nowtime - t.time < 2)
				return;
			t.lasttime = t.time;
			t.lastx = t.x;
			t.lasty = t.y;
			t.time = nowtime;
			t.x = info.pageX - offset.left;
			t.y = info.pageY - offset.top;
		}
	};
	instanceProto.onPointerStart = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var touchx = info.pageX - offset.left;
		var touchy = info.pageY - offset.top;
		var nowtime = cr.performance_now();
		this.trigger_index = this.touches.length;
		this.trigger_id = info["pointerId"];
		this.touches.push({ time: nowtime,
							x: touchx,
							y: touchy,
							lasttime: nowtime,
							lastx: touchx,
							lasty: touchy,
							"id": info["pointerId"],
							startindex: this.trigger_index
						});
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart, this);
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart, this);
		this.curTouchX = touchx;
		this.curTouchY = touchy;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject, this);
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onPointerEnd = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var i = this.findTouch(info["pointerId"]);
		this.trigger_index = (i >= 0 ? this.touches[i].startindex : -1);
		this.trigger_id = (i >= 0 ? this.touches[i]["id"] : -1);
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd, this);
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd, this);
		this.runtime.isInUserInputEvent = false;
		if (i >= 0)
		{
			this.touches.splice(i, 1);
		}
	};
	instanceProto.onTouchMove = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var nowtime = cr.performance_now();
		var i, len, t, u;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			var j = this.findTouch(t["identifier"]);
			if (j >= 0)
			{
				var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
				u = this.touches[j];
				if (nowtime - u.time < 2)
					continue;
				u.lasttime = u.time;
				u.lastx = u.x;
				u.lasty = u.y;
				u.time = nowtime;
				u.x = t.pageX - offset.left;
				u.y = t.pageY - offset.top;
			}
		}
	};
	instanceProto.onTouchStart = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var nowtime = cr.performance_now();
		this.runtime.isInUserInputEvent = true;
		var i, len, t, j;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			j = this.findTouch(t["identifier"]);
			if (j !== -1)
				continue;
			var touchx = t.pageX - offset.left;
			var touchy = t.pageY - offset.top;
			this.trigger_index = this.touches.length;
			this.trigger_id = t["identifier"];
			this.touches.push({ time: nowtime,
								x: touchx,
								y: touchy,
								lasttime: nowtime,
								lastx: touchx,
								lasty: touchy,
								"id": t["identifier"],
								startindex: this.trigger_index
							});
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart, this);
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart, this);
			this.curTouchX = touchx;
			this.curTouchY = touchy;
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject, this);
		}
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onTouchEnd = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		this.runtime.isInUserInputEvent = true;
		var i, len, t, j;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			j = this.findTouch(t["identifier"]);
			if (j >= 0)
			{
				this.trigger_index = this.touches[j].startindex;
				this.trigger_id = this.touches[j]["id"];
				this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd, this);
				this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd, this);
				this.touches.splice(j, 1);
			}
		}
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.getAlpha = function ()
	{
		if (this.runtime.isAppMobi && this.orient_alpha === 0 && appmobi_accz !== 0)
			return appmobi_accz * 90;
		else if (this.runtime.isPhoneGap  && this.orient_alpha === 0 && pg_accz !== 0)
			return pg_accz * 90;
		else
			return this.orient_alpha;
	};
	instanceProto.getBeta = function ()
	{
		if (this.runtime.isAppMobi && this.orient_beta === 0 && appmobi_accy !== 0)
			return appmobi_accy * -90;
		else if (this.runtime.isPhoneGap  && this.orient_beta === 0 && pg_accy !== 0)
			return pg_accy * -90;
		else
			return this.orient_beta;
	};
	instanceProto.getGamma = function ()
	{
		if (this.runtime.isAppMobi && this.orient_gamma === 0 && appmobi_accx !== 0)
			return appmobi_accx * 90;
		else if (this.runtime.isPhoneGap  && this.orient_gamma === 0 && pg_accx !== 0)
			return pg_accx * 90;
		else
			return this.orient_gamma;
	};
	var noop_func = function(){};
	instanceProto.onMouseDown = function(info)
	{
		if (info.preventDefault && this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchStart(fakeinfo);
		this.mouseDown = true;
	};
	instanceProto.onMouseMove = function(info)
	{
		if (!this.mouseDown)
			return;
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchMove(fakeinfo);
	};
	instanceProto.onMouseUp = function(info)
	{
		if (info.preventDefault && this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		this.runtime.had_a_click = true;
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchEnd(fakeinfo);
		this.mouseDown = false;
	};
	instanceProto.tick2 = function()
	{
		var i, len, t;
		var nowtime = cr.performance_now();
		for (i = 0, len = this.touches.length; i < len; i++)
		{
			t = this.touches[i];
			if (t.time <= nowtime - 50)
				t.lasttime = nowtime;
		}
	};
	function Cnds() {};
	Cnds.prototype.OnTouchStart = function ()
	{
		return true;
	};
	Cnds.prototype.OnTouchEnd = function ()
	{
		return true;
	};
	Cnds.prototype.IsInTouch = function ()
	{
		return this.touches.length;
	};
	Cnds.prototype.OnTouchObject = function (type)
	{
		if (!type)
			return false;
		return this.runtime.testAndSelectCanvasPointOverlap(type, this.curTouchX, this.curTouchY, false);
	};
	Cnds.prototype.IsTouchingObject = function (type)
	{
		if (!type)
			return false;
		var sol = type.getCurrentSol();
		var instances = sol.getObjects();
		var px, py;
		var touching = [];
		var i, leni, j, lenj;
		for (i = 0, leni = instances.length; i < leni; i++)
		{
			var inst = instances[i];
			inst.update_bbox();
			for (j = 0, lenj = this.touches.length; j < lenj; j++)
			{
				var touch = this.touches[j];
				px = inst.layer.canvasToLayer(touch.x, touch.y, true);
				py = inst.layer.canvasToLayer(touch.x, touch.y, false);
				if (inst.contains_pt(px, py))
				{
					touching.push(inst);
					break;
				}
			}
		}
		if (touching.length)
		{
			sol.select_all = false;
			sol.instances = touching;
			type.applySolToContainer();
			return true;
		}
		else
			return false;
	};
	Cnds.prototype.CompareTouchSpeed = function (index, cmp, s)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
			return false;
		var t = this.touches[index];
		var dist = cr.distanceTo(t.x, t.y, t.lastx, t.lasty);
		var timediff = (t.time - t.lasttime) / 1000;
		var speed = 0;
		if (timediff > 0)
			speed = dist / timediff;
		return cr.do_cmp(speed, cmp, s);
	};
	Cnds.prototype.OrientationSupported = function ()
	{
		return typeof window["DeviceOrientationEvent"] !== "undefined";
	};
	Cnds.prototype.MotionSupported = function ()
	{
		return typeof window["DeviceMotionEvent"] !== "undefined";
	};
	Cnds.prototype.CompareOrientation = function (orientation_, cmp_, angle_)
	{
		var v = 0;
		if (orientation_ === 0)
			v = this.getAlpha();
		else if (orientation_ === 1)
			v = this.getBeta();
		else
			v = this.getGamma();
		return cr.do_cmp(v, cmp_, angle_);
	};
	Cnds.prototype.CompareAcceleration = function (acceleration_, cmp_, angle_)
	{
		var v = 0;
		if (acceleration_ === 0)
			v = this.acc_g_x;
		else if (acceleration_ === 1)
			v = this.acc_g_y;
		else if (acceleration_ === 2)
			v = this.acc_g_z;
		else if (acceleration_ === 3)
			v = this.acc_x;
		else if (acceleration_ === 4)
			v = this.acc_y;
		else if (acceleration_ === 5)
			v = this.acc_z;
		return cr.do_cmp(v, cmp_, angle_);
	};
	Cnds.prototype.OnNthTouchStart = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return touch_ === this.trigger_index;
	};
	Cnds.prototype.OnNthTouchEnd = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return touch_ === this.trigger_index;
	};
	Cnds.prototype.HasNthTouch = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return this.touches.length >= touch_ + 1;
	};
	pluginProto.cnds = new Cnds();
	function Exps() {};
	Exps.prototype.TouchCount = function (ret)
	{
		ret.set_int(this.touches.length);
	};
	Exps.prototype.X = function (ret, layerparam)
	{
		if (this.touches.length)
		{
			var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
			if (cr.is_undefined(layerparam))
			{
				layer = this.runtime.getLayerByNumber(0);
				oldScale = layer.scale;
				oldZoomRate = layer.zoomRate;
				oldParallaxX = layer.parallaxX;
				oldAngle = layer.angle;
				layer.scale = this.runtime.running_layout.scale;
				layer.zoomRate = 1.0;
				layer.parallaxX = 1.0;
				layer.angle = this.runtime.running_layout.angle;
				ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, true));
				layer.scale = oldScale;
				layer.zoomRate = oldZoomRate;
				layer.parallaxX = oldParallaxX;
				layer.angle = oldAngle;
			}
			else
			{
				if (cr.is_number(layerparam))
					layer = this.runtime.getLayerByNumber(layerparam);
				else
					layer = this.runtime.getLayerByName(layerparam);
				if (layer)
					ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, true));
				else
					ret.set_float(0);
			}
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.XAt = function (ret, index, layerparam)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.XForID = function (ret, id, layerparam)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(touch.x, touch.y, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(touch.x, touch.y, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.Y = function (ret, layerparam)
	{
		if (this.touches.length)
		{
			var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
			if (cr.is_undefined(layerparam))
			{
				layer = this.runtime.getLayerByNumber(0);
				oldScale = layer.scale;
				oldZoomRate = layer.zoomRate;
				oldParallaxY = layer.parallaxY;
				oldAngle = layer.angle;
				layer.scale = this.runtime.running_layout.scale;
				layer.zoomRate = 1.0;
				layer.parallaxY = 1.0;
				layer.angle = this.runtime.running_layout.angle;
				ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, false));
				layer.scale = oldScale;
				layer.zoomRate = oldZoomRate;
				layer.parallaxY = oldParallaxY;
				layer.angle = oldAngle;
			}
			else
			{
				if (cr.is_number(layerparam))
					layer = this.runtime.getLayerByNumber(layerparam);
				else
					layer = this.runtime.getLayerByName(layerparam);
				if (layer)
					ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, false));
				else
					ret.set_float(0);
			}
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.YAt = function (ret, index, layerparam)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.YForID = function (ret, id, layerparam)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(touch.x, touch.y, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(touch.x, touch.y, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.AbsoluteX = function (ret)
	{
		if (this.touches.length)
			ret.set_float(this.touches[0].x);
		else
			ret.set_float(0);
	};
	Exps.prototype.AbsoluteXAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		ret.set_float(this.touches[index].x);
	};
	Exps.prototype.AbsoluteXForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(touch.x);
	};
	Exps.prototype.AbsoluteY = function (ret)
	{
		if (this.touches.length)
			ret.set_float(this.touches[0].y);
		else
			ret.set_float(0);
	};
	Exps.prototype.AbsoluteYAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		ret.set_float(this.touches[index].y);
	};
	Exps.prototype.AbsoluteYForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(touch.y);
	};
	Exps.prototype.SpeedAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var t = this.touches[index];
		var dist = cr.distanceTo(t.x, t.y, t.lastx, t.lasty);
		var timediff = (t.time - t.lasttime) / 1000;
		if (timediff === 0)
			ret.set_float(0);
		else
			ret.set_float(dist / timediff);
	};
	Exps.prototype.SpeedForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var dist = cr.distanceTo(touch.x, touch.y, touch.lastx, touch.lasty);
		var timediff = (touch.time - touch.lasttime) / 1000;
		if (timediff === 0)
			ret.set_float(0);
		else
			ret.set_float(dist / timediff);
	};
	Exps.prototype.AngleAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var t = this.touches[index];
		ret.set_float(cr.to_degrees(cr.angleTo(t.lastx, t.lasty, t.x, t.y)));
	};
	Exps.prototype.AngleForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(cr.to_degrees(cr.angleTo(touch.lastx, touch.lasty, touch.x, touch.y)));
	};
	Exps.prototype.Alpha = function (ret)
	{
		ret.set_float(this.getAlpha());
	};
	Exps.prototype.Beta = function (ret)
	{
		ret.set_float(this.getBeta());
	};
	Exps.prototype.Gamma = function (ret)
	{
		ret.set_float(this.getGamma());
	};
	Exps.prototype.AccelerationXWithG = function (ret)
	{
		ret.set_float(this.acc_g_x);
	};
	Exps.prototype.AccelerationYWithG = function (ret)
	{
		ret.set_float(this.acc_g_y);
	};
	Exps.prototype.AccelerationZWithG = function (ret)
	{
		ret.set_float(this.acc_g_z);
	};
	Exps.prototype.AccelerationX = function (ret)
	{
		ret.set_float(this.acc_x);
	};
	Exps.prototype.AccelerationY = function (ret)
	{
		ret.set_float(this.acc_y);
	};
	Exps.prototype.AccelerationZ = function (ret)
	{
		ret.set_float(this.acc_z);
	};
	Exps.prototype.TouchIndex = function (ret)
	{
		ret.set_int(this.trigger_index);
	};
	Exps.prototype.TouchID = function (ret)
	{
		ret.set_float(this.trigger_id);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.WebStorage = function(runtime)
{
	this.runtime = runtime;
};
(function()
{
	var pluginProto = cr.plugins_.WebStorage.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var prefix = "";
	var is_arcade = (typeof window["is_scirra_arcade"] !== "undefined");
	if (is_arcade)
		prefix = "arcade" + window["scirra_arcade_id"];
	var logged_sessionnotsupported = false;
	function LogSessionNotSupported()
	{
		if (logged_sessionnotsupported)
			return;
		cr.logexport("[Construct 2] Webstorage plugin: session storage is not supported on this platform. Try using local storage or global variables instead.");
		logged_sessionnotsupported = true;
	};
	instanceProto.onCreate = function()
	{
	};
	function Cnds() {};
	Cnds.prototype.LocalStorageEnabled = function()
	{
		return true;
	};
	Cnds.prototype.SessionStorageEnabled = function()
	{
		return true;
	};
	Cnds.prototype.LocalStorageExists = function(key)
	{
		return localStorage.getItem(prefix + key) != null;
	};
	Cnds.prototype.SessionStorageExists = function(key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return false;
		}
		return sessionStorage.getItem(prefix + key) != null;
	};
	Cnds.prototype.OnQuotaExceeded = function ()
	{
		return true;
	};
	Cnds.prototype.CompareKeyText = function (key, text_to_compare, case_sensitive)
	{
		var value = localStorage.getItem(prefix + key) || "";
		if (case_sensitive)
			return value == text_to_compare;
		else
			return cr.equals_nocase(value, text_to_compare);
	};
	Cnds.prototype.CompareKeyNumber = function (key, cmp, x)
	{
		var value = localStorage.getItem(prefix + key) || "";
		return cr.do_cmp(parseFloat(value), cmp, x);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.StoreLocal = function(key, data)
	{
		try {
			localStorage.setItem(prefix + key, data);
		}
		catch (e)
		{
			this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
		}
	};
	Acts.prototype.StoreSession = function(key,data)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		try {
			sessionStorage.setItem(prefix + key, data);
		}
		catch (e)
		{
			this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
		}
	};
	Acts.prototype.RemoveLocal = function(key)
	{
		localStorage.removeItem(prefix + key);
	};
	Acts.prototype.RemoveSession = function(key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		sessionStorage.removeItem(prefix + key);
	};
	Acts.prototype.ClearLocal = function()
	{
		if (!is_arcade)
			localStorage.clear();
	};
	Acts.prototype.ClearSession = function()
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		if (!is_arcade)
			sessionStorage.clear();
	};
	Acts.prototype.JSONLoad = function (json_, mode_)
	{
		var d;
		try {
			d = JSON.parse(json_);
		}
		catch(e) { return; }
		if (!d["c2dictionary"])			// presumably not a c2dictionary object
			return;
		var o = d["data"];
		if (mode_ === 0 && !is_arcade)	// 'set' mode: must clear webstorage first
			localStorage.clear();
		var p;
		for (p in o)
		{
			if (o.hasOwnProperty(p))
			{
				try {
					localStorage.setItem(prefix + p, o[p]);
				}
				catch (e)
				{
					this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
					return;
				}
			}
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.LocalValue = function(ret,key)
	{
		ret.set_string(localStorage.getItem(prefix + key) || "");
	};
	Exps.prototype.SessionValue = function(ret,key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		ret.set_string(sessionStorage.getItem(prefix + key) || "");
	};
	Exps.prototype.LocalCount = function(ret)
	{
		ret.set_int(is_arcade ? 0 : localStorage.length);
	};
	Exps.prototype.SessionCount = function(ret)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_int(0);
			return;
		}
		ret.set_int(is_arcade ? 0 : sessionStorage.length);
	};
	Exps.prototype.LocalAt = function(ret,n)
	{
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(localStorage.getItem(localStorage.key(n)) || "");
	};
	Exps.prototype.SessionAt = function(ret,n)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(sessionStorage.getItem(sessionStorage.key(n)) || "");
	};
	Exps.prototype.LocalKeyAt = function(ret,n)
	{
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(localStorage.key(n) || "");
	};
	Exps.prototype.SessionKeyAt = function(ret,n)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(sessionStorage.key(n) || "");
	};
	Exps.prototype.AsJSON = function (ret)
	{
		var o = {}, i, len, k;
		for (i = 0, len = localStorage.length; i < len; i++)
		{
			k = localStorage.key(i);
			if (is_arcade)
			{
				if (k.substr(0, prefix.length) === prefix)
				{
					o[k.substr(prefix.length)] = localStorage.getItem(k);
				}
			}
			else
				o[k] = localStorage.getItem(k);
		}
		ret.set_string(JSON.stringify({
			"c2dictionary": true,
			"data": o
		}));
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.behaviors.Bullet = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Bullet.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		var speed = this.properties[0];
		this.acc = this.properties[1];
		this.g = this.properties[2];
		this.bounceOffSolid = (this.properties[3] !== 0);
		this.setAngle = (this.properties[4] !== 0);
		this.dx = Math.cos(this.inst.angle) * speed;
		this.dy = Math.sin(this.inst.angle) * speed;
		this.lastx = this.inst.x;
		this.lasty = this.inst.y;
		this.lastKnownAngle = this.inst.angle;
		this.travelled = 0;
		this.enabled = (this.properties[5] !== 0);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"acc": this.acc,
			"g": this.g,
			"dx": this.dx,
			"dy": this.dy,
			"lx": this.lastx,
			"ly": this.lasty,
			"lka": this.lastKnownAngle,
			"t": this.travelled,
			"e": this.enabled
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.acc = o["acc"];
		this.g = o["g"];
		this.dx = o["dx"];
		this.dy = o["dy"];
		this.lastx = o["lx"];
		this.lasty = o["ly"];
		this.lastKnownAngle = o["lka"];
		this.travelled = o["t"];
		this.enabled = o["e"];
	};
	behinstProto.tick = function ()
	{
		if (!this.enabled)
			return;
		var dt = this.runtime.getDt(this.inst);
		var s, a;
		var bounceSolid, bounceAngle;
		if (this.inst.angle !== this.lastKnownAngle)
		{
			if (this.setAngle)
			{
				s = cr.distanceTo(0, 0, this.dx, this.dy);
				this.dx = Math.cos(this.inst.angle) * s;
				this.dy = Math.sin(this.inst.angle) * s;
			}
			this.lastKnownAngle = this.inst.angle;
		}
		if (this.acc !== 0)
		{
			s = cr.distanceTo(0, 0, this.dx, this.dy);
			if (this.dx === 0 && this.dy === 0)
				a = this.inst.angle;
			else
				a = cr.angleTo(0, 0, this.dx, this.dy);
			s += this.acc * dt;
			if (s < 0)
				s = 0;
			this.dx = Math.cos(a) * s;
			this.dy = Math.sin(a) * s;
		}
		if (this.g !== 0)
			this.dy += this.g * dt;
		this.lastx = this.inst.x;
		this.lasty = this.inst.y;
		if (this.dx !== 0 || this.dy !== 0)
		{
			this.inst.x += this.dx * dt;
			this.inst.y += this.dy * dt;
			this.travelled += cr.distanceTo(0, 0, this.dx * dt, this.dy * dt)
			if (this.setAngle)
			{
				this.inst.angle = cr.angleTo(0, 0, this.dx, this.dy);
				this.inst.set_bbox_changed();
				this.lastKnownAngle = this.inst.angle;
			}
			this.inst.set_bbox_changed();
			if (this.bounceOffSolid)
			{
				bounceSolid = this.runtime.testOverlapSolid(this.inst);
				if (bounceSolid)
				{
					this.runtime.registerCollision(this.inst, bounceSolid);
					s = cr.distanceTo(0, 0, this.dx, this.dy);
					bounceAngle = this.runtime.calculateSolidBounceAngle(this.inst, this.lastx, this.lasty);
					this.dx = Math.cos(bounceAngle) * s;
					this.dy = Math.sin(bounceAngle) * s;
					this.inst.x += this.dx * dt;			// move out for one tick since the object can't have spent a tick in the solid
					this.inst.y += this.dy * dt;
					this.inst.set_bbox_changed();
					if (this.setAngle)
					{
						this.inst.angle = bounceAngle;
						this.lastKnownAngle = bounceAngle;
						this.inst.set_bbox_changed();
					}
					if (!this.runtime.pushOutSolid(this.inst, this.dx / s, this.dy / s, Math.max(s * 2.5 * dt, 30)))
						this.runtime.pushOutSolidNearest(this.inst, 100);
				}
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.CompareSpeed = function (cmp, s)
	{
		return cr.do_cmp(cr.distanceTo(0, 0, this.dx, this.dy), cmp, s);
	};
	Cnds.prototype.CompareTravelled = function (cmp, d)
	{
		return cr.do_cmp(this.travelled, cmp, d);
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetSpeed = function (s)
	{
		var a = cr.angleTo(0, 0, this.dx, this.dy);
		this.dx = Math.cos(a) * s;
		this.dy = Math.sin(a) * s;
	};
	Acts.prototype.SetAcceleration = function (a)
	{
		this.acc = a;
	};
	Acts.prototype.SetGravity = function (g)
	{
		this.g = g;
	};
	Acts.prototype.SetAngleOfMotion = function (a)
	{
		a = cr.to_radians(a);
		var s = cr.distanceTo(0, 0, this.dx, this.dy)
		this.dx = Math.cos(a) * s;
		this.dy = Math.sin(a) * s;
	};
	Acts.prototype.Bounce = function (objtype)
	{
		if (!objtype)
			return;
		var otherinst = objtype.getFirstPicked(this.inst);
		if (!otherinst)
			return;
		var dt = this.runtime.getDt(this.inst);
		var s = cr.distanceTo(0, 0, this.dx, this.dy);
		var bounceAngle = this.runtime.calculateSolidBounceAngle(this.inst, this.lastx, this.lasty, otherinst);
		this.dx = Math.cos(bounceAngle) * s;
		this.dy = Math.sin(bounceAngle) * s;
		this.inst.x += this.dx * dt;			// move out for one tick since the object can't have spent a tick in the solid
		this.inst.y += this.dy * dt;
		this.inst.set_bbox_changed();
		if (this.setAngle)
		{
			this.inst.angle = bounceAngle;
			this.lastKnownAngle = bounceAngle;
			this.inst.set_bbox_changed();
		}
		if (this.bounceOffSolid)
		{
			if (!this.runtime.pushOutSolid(this.inst, this.dx / s, this.dy / s, Math.max(s * 2.5 * dt, 30)))
				this.runtime.pushOutSolidNearest(this.inst, 100);
		}
		else
		{
			this.runtime.pushOut(this.inst, this.dx / s, this.dy / s, Math.max(s * 2.5 * dt, 30), otherinst)
		}
	};
	Acts.prototype.SetEnabled = function (en)
	{
		this.enabled = (en === 1);
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Speed = function (ret)
	{
		var s = cr.distanceTo(0, 0, this.dx, this.dy);
		s = cr.round6dp(s);
		ret.set_float(s);
	};
	Exps.prototype.Acceleration = function (ret)
	{
		ret.set_float(this.acc);
	};
	Exps.prototype.AngleOfMotion = function (ret)
	{
		ret.set_float(cr.to_degrees(cr.angleTo(0, 0, this.dx, this.dy)));
	};
	Exps.prototype.DistanceTravelled = function (ret)
	{
		ret.set_float(this.travelled);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Pin = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Pin.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.pinObject = null;
		this.pinObjectUid = -1;		// for loading
		this.pinAngle = 0;
		this.pinDist = 0;
		this.myStartAngle = 0;
		this.theirStartAngle = 0;
		this.lastKnownAngle = 0;
		this.mode = 0;				// 0 = position & angle; 1 = position; 2 = angle; 3 = rope; 4 = bar
		var self = this;
		if (!this.recycled)
		{
			this.myDestroyCallback = (function(inst) {
													self.onInstanceDestroyed(inst);
												});
		}
		this.runtime.addDestroyCallback(this.myDestroyCallback);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"uid": this.pinObject ? this.pinObject.uid : -1,
			"pa": this.pinAngle,
			"pd": this.pinDist,
			"msa": this.myStartAngle,
			"tsa": this.theirStartAngle,
			"lka": this.lastKnownAngle,
			"m": this.mode
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.pinObjectUid = o["uid"];		// wait until afterLoad to look up
		this.pinAngle = o["pa"];
		this.pinDist = o["pd"];
		this.myStartAngle = o["msa"];
		this.theirStartAngle = o["tsa"];
		this.lastKnownAngle = o["lka"];
		this.mode = o["m"];
	};
	behinstProto.afterLoad = function ()
	{
		if (this.pinObjectUid === -1)
			this.pinObject = null;
		else
		{
			this.pinObject = this.runtime.getObjectByUID(this.pinObjectUid);
;
		}
		this.pinObjectUid = -1;
	};
	behinstProto.onInstanceDestroyed = function (inst)
	{
		if (this.pinObject == inst)
			this.pinObject = null;
	};
	behinstProto.onDestroy = function()
	{
		this.pinObject = null;
		this.runtime.removeDestroyCallback(this.myDestroyCallback);
	};
	behinstProto.tick = function ()
	{
	};
	behinstProto.tick2 = function ()
	{
		if (!this.pinObject)
			return;
		if (this.lastKnownAngle !== this.inst.angle)
			this.myStartAngle = cr.clamp_angle(this.myStartAngle + (this.inst.angle - this.lastKnownAngle));
		var newx = this.inst.x;
		var newy = this.inst.y;
		if (this.mode === 3 || this.mode === 4)		// rope mode or bar mode
		{
			var dist = cr.distanceTo(this.inst.x, this.inst.y, this.pinObject.x, this.pinObject.y);
			if ((dist > this.pinDist) || (this.mode === 4 && dist < this.pinDist))
			{
				var a = cr.angleTo(this.pinObject.x, this.pinObject.y, this.inst.x, this.inst.y);
				newx = this.pinObject.x + Math.cos(a) * this.pinDist;
				newy = this.pinObject.y + Math.sin(a) * this.pinDist;
			}
		}
		else
		{
			newx = this.pinObject.x + Math.cos(this.pinObject.angle + this.pinAngle) * this.pinDist;
			newy = this.pinObject.y + Math.sin(this.pinObject.angle + this.pinAngle) * this.pinDist;
		}
		var newangle = cr.clamp_angle(this.myStartAngle + (this.pinObject.angle - this.theirStartAngle));
		this.lastKnownAngle = newangle;
		if ((this.mode === 0 || this.mode === 1 || this.mode === 3 || this.mode === 4)
			&& (this.inst.x !== newx || this.inst.y !== newy))
		{
			this.inst.x = newx;
			this.inst.y = newy;
			this.inst.set_bbox_changed();
		}
		if ((this.mode === 0 || this.mode === 2) && (this.inst.angle !== newangle))
		{
			this.inst.angle = newangle;
			this.inst.set_bbox_changed();
		}
	};
	function Cnds() {};
	Cnds.prototype.IsPinned = function ()
	{
		return !!this.pinObject;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Pin = function (obj, mode_)
	{
		if (!obj)
			return;
		var otherinst = obj.getFirstPicked(this.inst);
		if (!otherinst)
			return;
		this.pinObject = otherinst;
		this.pinAngle = cr.angleTo(otherinst.x, otherinst.y, this.inst.x, this.inst.y) - otherinst.angle;
		this.pinDist = cr.distanceTo(otherinst.x, otherinst.y, this.inst.x, this.inst.y);
		this.myStartAngle = this.inst.angle;
		this.lastKnownAngle = this.inst.angle;
		this.theirStartAngle = otherinst.angle;
		this.mode = mode_;
	};
	Acts.prototype.Unpin = function ()
	{
		this.pinObject = null;
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.PinnedUID = function (ret)
	{
		ret.set_int(this.pinObject ? this.pinObject.uid : -1);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Rotate = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Rotate.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.speed = cr.to_radians(this.properties[0]);
		this.acc = cr.to_radians(this.properties[1]);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"speed": this.speed,
			"acc": this.acc
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.speed = o["speed"];
		this.acc = o["acc"];
	};
	behinstProto.tick = function ()
	{
		var dt = this.runtime.getDt(this.inst);
		if (dt === 0)
			return;
		if (this.acc !== 0)
			this.speed += this.acc * dt;
		if (this.speed !== 0)
		{
			this.inst.angle = cr.clamp_angle(this.inst.angle + this.speed * dt);
			this.inst.set_bbox_changed();
		}
	};
	function Cnds() {};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetSpeed = function (s)
	{
		this.speed = cr.to_radians(s);
	};
	Acts.prototype.SetAcceleration = function (a)
	{
		this.acc = cr.to_radians(a);
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Speed = function (ret)
	{
		ret.set_float(cr.to_degrees(this.speed));
	};
	Exps.prototype.Acceleration = function (ret)
	{
		ret.set_float(cr.to_degrees(this.acc));
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Sin = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Sin.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
		this.i = 0;		// period offset (radians)
	};
	var behinstProto = behaviorProto.Instance.prototype;
	var _2pi = 2 * Math.PI;
	var _pi_2 = Math.PI / 2;
	var _3pi_2 = (3 * Math.PI) / 2;
	behinstProto.onCreate = function()
	{
		this.active = (this.properties[0] === 1);
		this.movement = this.properties[1]; // 0=Horizontal|1=Vertical|2=Size|3=Width|4=Height|5=Angle|6=Opacity|7=Value only
		this.wave = this.properties[2];		// 0=Sine|1=Triangle|2=Sawtooth|3=Reverse sawtooth|4=Square
		this.period = this.properties[3];
		this.period += Math.random() * this.properties[4];								// period random
		if (this.period === 0)
			this.i = 0;
		else
		{
			this.i = (this.properties[5] / this.period) * _2pi;								// period offset
			this.i += ((Math.random() * this.properties[6]) / this.period) * _2pi;			// period offset random
		}
		this.mag = this.properties[7];													// magnitude
		this.mag += Math.random() * this.properties[8];									// magnitude random
		this.initialValue = 0;
		this.initialValue2 = 0;
		this.ratio = 0;
		this.init();
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"i": this.i,
			"a": this.active,
			"mv": this.movement,
			"w": this.wave,
			"p": this.period,
			"mag": this.mag,
			"iv": this.initialValue,
			"iv2": this.initialValue2,
			"r": this.ratio,
			"lkv": this.lastKnownValue,
			"lkv2": this.lastKnownValue2
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.i = o["i"];
		this.active = o["a"];
		this.movement = o["mv"];
		this.wave = o["w"];
		this.period = o["p"];
		this.mag = o["mag"];
		this.initialValue = o["iv"];
		this.initialValue2 = o["iv2"] || 0;
		this.ratio = o["r"];
		this.lastKnownValue = o["lkv"];
		this.lastKnownValue2 = o["lkv2"] || 0;
	};
	behinstProto.init = function ()
	{
		switch (this.movement) {
		case 0:		// horizontal
			this.initialValue = this.inst.x;
			break;
		case 1:		// vertical
			this.initialValue = this.inst.y;
			break;
		case 2:		// size
			this.initialValue = this.inst.width;
			this.ratio = this.inst.height / this.inst.width;
			break;
		case 3:		// width
			this.initialValue = this.inst.width;
			break;
		case 4:		// height
			this.initialValue = this.inst.height;
			break;
		case 5:		// angle
			this.initialValue = this.inst.angle;
			this.mag = cr.to_radians(this.mag);		// convert magnitude from degrees to radians
			break;
		case 6:		// opacity
			this.initialValue = this.inst.opacity;
			break;
		case 7:
			this.initialValue = 0;
			break;
		case 8:		// forwards/backwards
			this.initialValue = this.inst.x;
			this.initialValue2 = this.inst.y;
			break;
		default:
;
		}
		this.lastKnownValue = this.initialValue;
		this.lastKnownValue2 = this.initialValue2;
	};
	behinstProto.waveFunc = function (x)
	{
		x = x % _2pi;
		switch (this.wave) {
		case 0:		// sine
			return Math.sin(x);
		case 1:		// triangle
			if (x <= _pi_2)
				return x / _pi_2;
			else if (x <= _3pi_2)
				return 1 - (2 * (x - _pi_2) / Math.PI);
			else
				return (x - _3pi_2) / _pi_2 - 1;
		case 2:		// sawtooth
			return 2 * x / _2pi - 1;
		case 3:		// reverse sawtooth
			return -2 * x / _2pi + 1;
		case 4:		// square
			return x < Math.PI ? -1 : 1;
		};
		return 0;
	};
	behinstProto.tick = function ()
	{
		var dt = this.runtime.getDt(this.inst);
		if (!this.active || dt === 0)
			return;
		if (this.period === 0)
			this.i = 0;
		else
		{
			this.i += (dt / this.period) * _2pi;
			this.i = this.i % _2pi;
		}
		switch (this.movement) {
		case 0:		// horizontal
			if (this.inst.x !== this.lastKnownValue)
				this.initialValue += this.inst.x - this.lastKnownValue;
			this.inst.x = this.initialValue + this.waveFunc(this.i) * this.mag;
			this.lastKnownValue = this.inst.x;
			break;
		case 1:		// vertical
			if (this.inst.y !== this.lastKnownValue)
				this.initialValue += this.inst.y - this.lastKnownValue;
			this.inst.y = this.initialValue + this.waveFunc(this.i) * this.mag;
			this.lastKnownValue = this.inst.y;
			break;
		case 2:		// size
			this.inst.width = this.initialValue + this.waveFunc(this.i) * this.mag;
			this.inst.height = this.inst.width * this.ratio;
			break;
		case 3:		// width
			this.inst.width = this.initialValue + this.waveFunc(this.i) * this.mag;
			break;
		case 4:		// height
			this.inst.height = this.initialValue + this.waveFunc(this.i) * this.mag;
			break;
		case 5:		// angle
			if (this.inst.angle !== this.lastKnownValue)
				this.initialValue = cr.clamp_angle(this.initialValue + (this.inst.angle - this.lastKnownValue));
			this.inst.angle = cr.clamp_angle(this.initialValue + this.waveFunc(this.i) * this.mag);
			this.lastKnownValue = this.inst.angle;
			break;
		case 6:		// opacity
			this.inst.opacity = this.initialValue + (this.waveFunc(this.i) * this.mag) / 100;
			if (this.inst.opacity < 0)
				this.inst.opacity = 0;
			else if (this.inst.opacity > 1)
				this.inst.opacity = 1;
			break;
		case 8:		// forwards/backwards
			if (this.inst.x !== this.lastKnownValue)
				this.initialValue += this.inst.x - this.lastKnownValue;
			if (this.inst.y !== this.lastKnownValue2)
				this.initialValue2 += this.inst.y - this.lastKnownValue2;
			this.inst.x = this.initialValue + Math.cos(this.inst.angle) * this.waveFunc(this.i) * this.mag;
			this.inst.y = this.initialValue2 + Math.sin(this.inst.angle) * this.waveFunc(this.i) * this.mag;
			this.lastKnownValue = this.inst.x;
			this.lastKnownValue2 = this.inst.y;
			break;
		}
		this.inst.set_bbox_changed();
	};
	behinstProto.onSpriteFrameChanged = function (prev_frame, next_frame)
	{
		switch (this.movement) {
		case 2:	// size
			this.initialValue *= (next_frame.width / prev_frame.width);
			this.ratio = next_frame.height / next_frame.width;
			break;
		case 3:	// width
			this.initialValue *= (next_frame.width / prev_frame.width);
			break;
		case 4:	// height
			this.initialValue *= (next_frame.height / prev_frame.height);
			break;
		}
	};
	function Cnds() {};
	Cnds.prototype.IsActive = function ()
	{
		return this.active;
	};
	Cnds.prototype.CompareMovement = function (m)
	{
		return this.movement === m;
	};
	Cnds.prototype.ComparePeriod = function (cmp, v)
	{
		return cr.do_cmp(this.period, cmp, v);
	};
	Cnds.prototype.CompareMagnitude = function (cmp, v)
	{
		if (this.movement === 5)
			return cr.do_cmp(this.mag, cmp, cr.to_radians(v));
		else
			return cr.do_cmp(this.mag, cmp, v);
	};
	Cnds.prototype.CompareWave = function (w)
	{
		return this.wave === w;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetActive = function (a)
	{
		this.active = (a === 1);
	};
	Acts.prototype.SetPeriod = function (x)
	{
		this.period = x;
	};
	Acts.prototype.SetMagnitude = function (x)
	{
		this.mag = x;
		if (this.movement === 5)	// angle
			this.mag = cr.to_radians(this.mag);
	};
	Acts.prototype.SetMovement = function (m)
	{
		if (this.movement === 5)
			this.mag = cr.to_degrees(this.mag);
		this.movement = m;
		this.init();
	};
	Acts.prototype.SetWave = function (w)
	{
		this.wave = w;
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.CyclePosition = function (ret)
	{
		ret.set_float(this.i / _2pi);
	};
	Exps.prototype.Period = function (ret)
	{
		ret.set_float(this.period);
	};
	Exps.prototype.Magnitude = function (ret)
	{
		if (this.movement === 5)	// angle
			ret.set_float(cr.to_degrees(this.mag));
		else
			ret.set_float(this.mag);
	};
	Exps.prototype.Value = function (ret)
	{
		ret.set_float(this.waveFunc(this.i) * this.mag);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.bound = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.bound.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
		this.mode = 0;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.mode = this.properties[0];	// 0 = origin, 1 = edge
	};
	behinstProto.tick = function ()
	{
	};
	behinstProto.tick2 = function ()
	{
		this.inst.update_bbox();
		var bbox = this.inst.bbox;
		var layout = this.inst.layer.layout;
		var changed = false;
		if (this.mode === 0)	// origin
		{
			if (this.inst.x < 0)
			{
				this.inst.x = 0;
				changed = true;
			}
			if (this.inst.y < 0)
			{
				this.inst.y = 0;
				changed = true;
			}
			if (this.inst.x > layout.width)
			{
				this.inst.x = layout.width;
				changed = true;
			}
			if (this.inst.y > layout.height)
			{
				this.inst.y = layout.height;
				changed = true;
			}
		}
		else
		{
			if (bbox.left < 0)
			{
				this.inst.x -= bbox.left;
				changed = true;
			}
			if (bbox.top < 0)
			{
				this.inst.y -= bbox.top;
				changed = true;
			}
			if (bbox.right > layout.width)
			{
				this.inst.x -= (bbox.right - layout.width);
				changed = true;
			}
			if (bbox.bottom > layout.height)
			{
				this.inst.y -= (bbox.bottom - layout.height);
				changed = true;
			}
		}
		if (changed)
			this.inst.set_bbox_changed();
	};
}());
cr.getProjectModel = function() { return [
	null,
	"LoadGame",
	[
	[
		cr.plugins_.NinePatch,
		false,
		true,
		true,
		true,
		false,
		true,
		true,
		true,
		true
	]
,	[
		cr.plugins_.Arr,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Audio,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Browser,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.CJSAds,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Function,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Dictionary,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Keyboard,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Particles,
		false,
		true,
		true,
		false,
		true,
		true,
		true,
		true,
		true
	]
,	[
		cr.plugins_.Sprite,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		false
	]
,	[
		cr.plugins_.Spritefont2,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		true
	]
,	[
		cr.plugins_.Text,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		false
	]
,	[
		cr.plugins_.TiledBg,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		true
	]
,	[
		cr.plugins_.Touch,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.WebStorage,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
	],
	[
	[
		"t0",
		cr.plugins_.Sprite,
		false,
		[1507163886355554,6896102463493058,6175196450951961,7468561491023138,4566537777354406,7089859588144989,2612862985091129,8567441719013915,2543808994024992,6733520432680759,9875402668842589,3282625843093156,3197500915051444,7474600157893932,6014222178843938,5823929738679657,797892025033802,5867925808836471,2508879031971129,307436084865596,3347238606075545],
		1,
		0,
		null,
		[
			[
			"Standard0",
			0,
			false,
			1,
			0,
			false,
			1819036299424261,
			[
				["ship-sheet0.png", 4671, 196, 1, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.125, 0.75],["ShootWingRight", 0.875, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet0.png", 4671, 196, 34, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.34375, 0.75],["ShootWingRight", 0.71875, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet0.png", 4671, 196, 67, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.28125, 0.75],["ShootWingRight", 0.65625, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0]
			]
			]
,			[
			"Standard1",
			0,
			false,
			1,
			0,
			false,
			1182018973384183,
			[
				["ship-sheet0.png", 4671, 196, 100, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.125, 0.75],["ShootWingRight", 0.875, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet0.png", 4671, 196, 133, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.34375, 0.75],["ShootWingRight", 0.71875, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet0.png", 4671, 196, 166, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.28125, 0.75],["ShootWingRight", 0.65625, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0]
			]
			]
,			[
			"Standard2",
			0,
			false,
			1,
			0,
			false,
			3918871416121412,
			[
				["ship-sheet0.png", 4671, 1, 196, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.125, 0.75],["ShootWingRight", 0.875, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet0.png", 4671, 34, 196, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.34375, 0.75],["ShootWingRight", 0.71875, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet0.png", 4671, 67, 196, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.28125, 0.75],["ShootWingRight", 0.65625, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0]
			]
			]
,			[
			"Standard3",
			0,
			false,
			1,
			0,
			false,
			5958785358427937,
			[
				["ship-sheet0.png", 4671, 100, 196, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.125, 0.75],["ShootWingRight", 0.875, 0.75],["ShootCenterLow", 0.5, 0.5]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet0.png", 4671, 133, 196, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.34375, 0.75],["ShootWingRight", 0.71875, 0.75],["ShootCenterLow", 0.5, 0.5]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet0.png", 4671, 166, 199, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.28125, 0.75],["ShootWingRight", 0.65625, 0.75],["ShootCenterLow", 0.5, 0.5]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0]
			]
			]
,			[
			"Standard4",
			0,
			false,
			1,
			0,
			false,
			5193040560977924,
			[
				["ship-sheet0.png", 4671, 199, 199, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.125, 0.75],["ShootWingRight", 0.875, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet1.png", 6053, 196, 1, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.34375, 0.75],["ShootWingRight", 0.71875, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet1.png", 6053, 196, 34, 32, 32, 1, 0.5, 0.5,[["Shoot1Left", 0.375, 0.09375],["Shoot1Right", 0.625, 0.09375],["Shoot1Center", 0.5, 0.09375],["ShootWingLeft", 0.28125, 0.75],["ShootWingRight", 0.65625, 0.75]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0]
			]
			]
,			[
			"StandardMenu",
			0,
			false,
			1,
			0,
			false,
			3973382136804898,
			[
				["ship-sheet0.png", 4671, 1, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet0.png", 4671, 66, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet0.png", 4671, 131, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet0.png", 4671, 1, 66, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet0.png", 4671, 66, 66, 64, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"Option0",
			0,
			false,
			1,
			0,
			false,
			6342614314882338,
			[
				["ship-sheet1.png", 6053, 196, 67, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.125, 0.59375],["ShootWingRight", 0.875, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0],
				["ship-sheet1.png", 6053, 196, 100, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.25, 0.59375],["ShootWingRight", 0.78125, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0],
				["ship-sheet1.png", 6053, 1, 131, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.21875, 0.59375],["ShootWingRight", 0.75, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0]
			]
			]
,			[
			"Option1",
			0,
			false,
			1,
			0,
			false,
			8179954781088989,
			[
				["ship-sheet1.png", 6053, 34, 131, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.125, 0.59375],["ShootWingRight", 0.875, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0],
				["ship-sheet1.png", 6053, 67, 131, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.25, 0.59375],["ShootWingRight", 0.78125, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0],
				["ship-sheet1.png", 6053, 100, 131, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.21875, 0.59375],["ShootWingRight", 0.75, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0]
			]
			]
,			[
			"Option2",
			0,
			false,
			1,
			0,
			false,
			9372142936505061,
			[
				["ship-sheet1.png", 6053, 133, 131, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.125, 0.59375],["ShootWingRight", 0.875, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0],
				["ship-sheet1.png", 6053, 166, 133, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.25, 0.59375],["ShootWingRight", 0.78125, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0],
				["ship-sheet1.png", 6053, 199, 133, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.21875, 0.59375],["ShootWingRight", 0.75, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0]
			]
			]
,			[
			"Option3",
			0,
			false,
			1,
			0,
			false,
			8964085296451309,
			[
				["ship-sheet1.png", 6053, 1, 164, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.125, 0.59375],["ShootWingRight", 0.875, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0],
				["ship-sheet1.png", 6053, 34, 164, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.25, 0.59375],["ShootWingRight", 0.78125, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0],
				["ship-sheet1.png", 6053, 67, 164, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.21875, 0.59375],["ShootWingRight", 0.75, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0]
			]
			]
,			[
			"Option4",
			0,
			false,
			1,
			0,
			false,
			121799298850868,
			[
				["ship-sheet1.png", 6053, 100, 164, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.125, 0.59375],["ShootWingRight", 0.875, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0],
				["ship-sheet1.png", 6053, 133, 164, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.25, 0.59375],["ShootWingRight", 0.78125, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0],
				["ship-sheet1.png", 6053, 166, 166, 32, 32, 1, 0.5, 0.34375,[["Shoot1Center", 0.5, 0.1875],["ShootWingLeft", 0.21875, 0.59375],["ShootWingRight", 0.75, 0.59375]],[-0.09375,-0.0625,0.09375,-0.0625,0.09375,0.40625,-0.09375,0.40625],0]
			]
			]
,			[
			"OptionMenu",
			0,
			false,
			1,
			0,
			false,
			1109610868173296,
			[
				["ship-sheet0.png", 4671, 131, 66, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet0.png", 4671, 1, 131, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet0.png", 4671, 66, 131, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet0.png", 4671, 131, 131, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet1.png", 6053, 1, 1, 64, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"Stork0",
			0,
			false,
			1,
			0,
			false,
			957138016807236,
			[
				["ship-sheet1.png", 6053, 199, 166, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet1.png", 6053, 1, 197, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet1.png", 6053, 34, 197, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0]
			]
			]
,			[
			"Stork1",
			0,
			false,
			1,
			0,
			false,
			3654063947673893,
			[
				["ship-sheet1.png", 6053, 67, 197, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet1.png", 6053, 100, 197, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet1.png", 6053, 133, 197, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0]
			]
			]
,			[
			"Stork2",
			0,
			false,
			1,
			0,
			false,
			7520989699764757,
			[
				["ship-sheet1.png", 6053, 166, 199, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet1.png", 6053, 199, 199, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet2.png", 1473, 1, 1, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0]
			]
			]
,			[
			"Stork3",
			0,
			false,
			1,
			0,
			false,
			2701594517426411,
			[
				["ship-sheet2.png", 1473, 34, 1, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet2.png", 1473, 67, 1, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet2.png", 1473, 1, 34, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0]
			]
			]
,			[
			"Stork4",
			0,
			false,
			1,
			0,
			false,
			3341940333208134,
			[
				["ship-sheet2.png", 1473, 34, 34, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet2.png", 1473, 67, 34, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0],
				["ship-sheet2.png", 1473, 1, 67, 32, 32, 1, 0.5, 0.5,[["ShootCenter", 0.5, 0.21875]],[-0.09375,-0.1875,0.09375,-0.1875,0.09375,0.25,-0.09375,0.25],0]
			]
			]
,			[
			"StorkMenu",
			0,
			false,
			1,
			0,
			false,
			7808345131680344,
			[
				["ship-sheet1.png", 6053, 66, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet1.png", 6053, 131, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet1.png", 6053, 1, 66, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet1.png", 6053, 66, 66, 64, 64, 1, 0.5, 0.5,[],[],0],
				["ship-sheet1.png", 6053, 131, 66, 64, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"BoundToLayout",
			cr.behaviors.bound,
			2757425454357782
		]
		],
		false,
		false,
		6523927394571573,
		[],
		null
	]
,	[
		"t1",
		cr.plugins_.Keyboard,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		9677450703713213,
		[],
		null
		,[]
	]
,	[
		"t2",
		cr.plugins_.Sprite,
		false,
		[2214511024326453],
		1,
		0,
		null,
		[
			[
			"Idle",
			10,
			true,
			1,
			0,
			false,
			7294351688438315,
			[
				["propulsor-sheet0.png", 353, 1, 1, 16, 16, 1, 0.5, 0,[],[],0],
				["propulsor-sheet0.png", 353, 18, 1, 16, 16, 1, 0.5, 0,[],[],0]
			]
			]
,			[
			"Left",
			10,
			true,
			1,
			0,
			false,
			278780583300672,
			[
				["propulsor-sheet0.png", 353, 35, 1, 16, 16, 1, 0.5, 0,[],[],0],
				["propulsor-sheet0.png", 353, 1, 18, 16, 16, 1, 0.5, 0,[],[],0]
			]
			]
,			[
			"Right",
			10,
			true,
			1,
			0,
			false,
			8763497442850366,
			[
				["propulsor-sheet0.png", 353, 18, 18, 16, 16, 1, 0.5, 0,[],[],0],
				["propulsor-sheet0.png", 353, 35, 18, 16, 16, 1, 0.5, 0,[],[],0]
			]
			]
,			[
			"IdleLow",
			10,
			true,
			1,
			0,
			false,
			596488893340684,
			[
				["propulsor-sheet0.png", 353, 1, 35, 16, 16, 1, 0.5, 0,[],[],0],
				["propulsor-sheet0.png", 353, 18, 35, 16, 16, 1, 0.5, 0,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			3005435839094723
		]
		],
		false,
		false,
		8311021292190755,
		[],
		null
	]
,	[
		"t3",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5034390791672758,
			[
				["bg-sheet0.png", 461, 0, 0, 320, 480, 1, 0.5, 0,[],[-0.5,1,-0.5,0,0.5,0,0.5,1],1]
			]
			]
		],
		[
		],
		false,
		false,
		3086234805458015,
		[],
		null
	]
,	[
		"t4",
		cr.plugins_.Sprite,
		false,
		[2656635932178653,6997776844695619,4759434120450696,2129097428736109],
		3,
		0,
		null,
		[
			[
			"StandardNormal",
			30,
			true,
			1,
			0,
			true,
			672229552164083,
			[
				["shoot-sheet0.png", 316, 26, 1, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0],
				["shoot-sheet0.png", 316, 26, 8, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0],
				["shoot-sheet0.png", 316, 18, 14, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0],
				["shoot-sheet0.png", 316, 23, 15, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0]
			]
			]
,			[
			"StandardBlue",
			30,
			true,
			1,
			0,
			true,
			641698746523765,
			[
				["shoot-sheet0.png", 316, 1, 18, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0],
				["shoot-sheet0.png", 316, 6, 18, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0],
				["shoot-sheet0.png", 316, 11, 18, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0],
				["shoot-sheet0.png", 316, 16, 21, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0]
			]
			]
,			[
			"OptionNormal",
			5,
			false,
			1,
			0,
			false,
			2615569380407298,
			[
				["shoot-sheet0.png", 316, 18, 1, 3, 12, 1, 0.6666666865348816, 0.4166666567325592,[],[-0.3333337008953095,-0.3333334624767304,2.980232238769531e-007,-0.3333334624767304,2.980232238769531e-007,0.5000003576278687,-0.3333337008953095,0.5000003576278687],0]
			]
			]
,			[
			"OptionRed",
			5,
			false,
			1,
			0,
			false,
			9372060407095263,
			[
				["shoot-sheet0.png", 316, 22, 1, 3, 12, 1, 0.6666666865348816, 0.4166666567325592,[],[-0.3333337008953095,-0.3333334624767304,2.980232238769531e-007,-0.3333334624767304,2.980232238769531e-007,0.5000003576278687,-0.3333337008953095,0.5000003576278687],0]
			]
			]
,			[
			"Enemy",
			10,
			true,
			1,
			0,
			true,
			867701908798678,
			[
				["shoot-sheet0.png", 316, 1, 1, 16, 16, 1, 0.5, 0.5,[],[-0.125,-0.125,0.125,-0.125,0.125,0.125,-0.125,0.125],0],
				["shoot-sheet1.png", 148, 0, 0, 16, 16, 1, 0.5, 0.5,[],[-0.125,-0.125,0.125,-0.125,0.125,0.125,-0.125,0.125],0],
				["shoot-sheet2.png", 142, 0, 0, 16, 16, 1, 0.5, 0.5,[],[-0.125,-0.125,0.125,-0.125,0.125,0.125,-0.125,0.125],0]
			]
			]
,			[
			"StorkNormal",
			30,
			true,
			1,
			0,
			true,
			7019817180487309,
			[
				["shoot-sheet0.png", 316, 21, 22, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0],
				["shoot-sheet0.png", 316, 26, 22, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0],
				["shoot-sheet0.png", 316, 1, 25, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0],
				["shoot-sheet0.png", 316, 6, 25, 4, 6, 1, 0.5, 0.5,[],[-0.25,-0.3333330154418945,0.25,-0.3333330154418945,0.25,0.3333330154418945,-0.25,0.3333330154418945],0]
			]
			]
		],
		[
		[
			"Bullet",
			cr.behaviors.Bullet,
			742862441737696
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			628901637251209
		]
,		[
			"Rotate",
			cr.behaviors.Rotate,
			9763543885705619
		]
		],
		false,
		false,
		2952098592922837,
		[],
		null
	]
,	[
		"t5",
		cr.plugins_.Audio,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		6508543097725796,
		[],
		null
		,[0,0,1,1,600,600,10000,1,5000,1]
	]
,	[
		"t6",
		cr.plugins_.Touch,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		8096562222195911,
		[],
		null
		,[1]
	]
,	[
		"t7",
		cr.plugins_.Sprite,
		false,
		[6302641970050132,3305814445712944,6059378762028462,9118792109840623,4084212842989654,1748093518963012,3357771589925714,4577484555985958,8275740377901074,514772667817186,1593383021096494,1446690327651173,5440044640569137,5081659828397524,2086822701644746,7295952833358295,5059938349932453,8208556319158979,2551272909013719,4685202192069142,9287663313250153,1409491992096434],
		4,
		0,
		null,
		[
			[
			"Delta",
			20,
			false,
			1,
			0,
			false,
			6761253546032179,
			[
				["enemy-sheet0.png", 8687, 196, 1, 32, 32, 1, 0.5, 0.5,[],[-0.40625,-0.09375,-0.046875,-0.25,0.03125,-0.25,0.40625,-0.09375,0.09375,0.34375,-0.09375,0.34375],0]
			]
			]
,			[
			"DeltaRED",
			20,
			false,
			1,
			0,
			false,
			1380524718935037,
			[
				["enemy-sheet0.png", 8687, 196, 34, 32, 32, 1, 0.5, 0.5,[],[-0.40625,-0.09375,-0.046875,-0.25,0.03125,-0.25,0.40625,-0.09375,0.09375,0.34375,-0.09375,0.34375],0]
			]
			]
,			[
			"DeltaHoming",
			20,
			false,
			1,
			0,
			false,
			2794589931329399,
			[
				["enemy-sheet0.png", 8687, 196, 67, 32, 32, 1, 0.5, 0.5,[],[0,-0.25,0.40625,0,0.1874999403953552,0.1874999403953552,0,0.375,-0.1875,0.1874999403953552,-0.40625,0],0]
			]
			]
,			[
			"DeltaHomingRED",
			20,
			false,
			1,
			0,
			false,
			129273008890697,
			[
				["enemy-sheet0.png", 8687, 196, 100, 32, 32, 1, 0.5, 0.5,[],[-0.40625,-0.09375,-0.046875,-0.25,0.03125,-0.25,0.40625,-0.09375,0.09375,0.34375,-0.09375,0.34375],0]
			]
			]
,			[
			"Rock",
			5,
			false,
			1,
			0,
			false,
			6851015696214511,
			[
				["enemy-sheet0.png", 8687, 196, 133, 32, 32, 1, 0.5, 0.5,[],[-0.28125,-0.28125,0,-0.40625,0.28125,-0.28125,0.40625,0,0.28125,0.28125,0,0.40625,-0.28125,0.28125,-0.375,0],0]
			]
			]
,			[
			"Juggernaut",
			20,
			false,
			1,
			0,
			false,
			3173038565297884,
			[
				["enemy-sheet0.png", 8687, 1, 1, 64, 64, 1, 0.5, 0.5,[["PropulsorLeft", 0.375, 0.3125],["PropulsorRight", 0.625, 0.3125]],[-0.4375,-0.203125,0.4374999403953552,-0.203125,0.4374999403953552,0,0.234375,0.03125,0.109375,0.234375,-0.109375,0.234375,-0.234375,0.03125,-0.4375,0],0]
			]
			]
,			[
			"JuggernautRED",
			20,
			false,
			1,
			0,
			false,
			9429765715593966,
			[
				["enemy-sheet0.png", 8687, 66, 1, 64, 64, 1, 0.5, 0.5,[["PropulsorLeft", 0.375, 0.3125],["PropulsorRight", 0.625, 0.3125]],[-0.4375,-0.203125,0.4374999403953552,-0.203125,0.4374999403953552,0,0.234375,0.03125,0.109375,0.234375,-0.109375,0.234375,-0.234375,0.03125,-0.4375,0],0]
			]
			]
,			[
			"Piranha",
			10,
			true,
			1,
			0,
			false,
			3851593869513813,
			[
				["enemy-sheet0.png", 8687, 196, 166, 32, 32, 1, 0.5, 0.5,[["Propulsor", 0.34375, 0.5]],[-0.28125,0.28125,-0.21875,0,-0.28125,-0.28125,0,-0.21875,0.25,-0.25,0.09375,0,0.25,0.25,0,0.21875],0],
				["enemy-sheet0.png", 8687, 1, 196, 32, 32, 1, 0.5, 0.5,[["Propulsor", 0.34375, 0.5]],[-0.28125,0.28125,-0.21875,0,-0.28125,-0.28125,0,-0.21875,0.25,-0.25,0.09375,0,0.25,0.25,0,0.21875],0],
				["enemy-sheet0.png", 8687, 34, 196, 32, 32, 1, 0.5, 0.5,[["Propulsor", 0.34375, 0.5]],[-0.28125,0.28125,-0.21875,0,-0.28125,-0.28125,0,-0.21875,0.25,-0.25,0.09375,0,0.25,0.25,0,0.21875],0]
			]
			]
,			[
			"PiranhaFast",
			10,
			true,
			1,
			0,
			false,
			3818723453240133,
			[
				["enemy-sheet0.png", 8687, 67, 196, 32, 32, 1, 0.5, 0.5,[["Propulsor", 0.34375, 0.5]],[-0.28125,0.28125,-0.21875,0,-0.28125,-0.28125,0,-0.21875,0.25,-0.25,0.09375,0,0.25,0.25,0,0.21875],0],
				["enemy-sheet0.png", 8687, 100, 196, 32, 32, 1, 0.5, 0.5,[["Propulsor", 0.34375, 0.5]],[-0.28125,0.28125,-0.21875,0,-0.28125,-0.28125,0,-0.21875,0.25,-0.25,0.09375,0,0.25,0.25,0,0.21875],0],
				["enemy-sheet0.png", 8687, 133, 196, 32, 32, 1, 0.5, 0.5,[["Propulsor", 0.34375, 0.5]],[-0.28125,0.28125,-0.21875,0,-0.28125,-0.28125,0,-0.21875,0.25,-0.25,0.09375,0,0.25,0.25,0,0.21875],0]
			]
			]
,			[
			"PiranhaRED",
			20,
			false,
			1,
			0,
			false,
			7034494846261255,
			[
				["enemy-sheet0.png", 8687, 166, 199, 32, 32, 1, 0.5, 0.5,[["Propulsor", 0.34375, 0.5]],[-0.28125,0.28125,-0.21875,0,-0.28125,-0.28125,0,-0.21875,0.25,-0.25,0.09375,0,0.25,0.25,0,0.21875],0]
			]
			]
,			[
			"PiranhaKing",
			10,
			true,
			1,
			0,
			false,
			5828211744271327,
			[
				["enemy-sheet0.png", 8687, 131, 1, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0],
				["enemy-sheet0.png", 8687, 1, 66, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0],
				["enemy-sheet0.png", 8687, 66, 66, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0],
				["enemy-sheet0.png", 8687, 131, 66, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0],
				["enemy-sheet0.png", 8687, 1, 131, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0],
				["enemy-sheet0.png", 8687, 66, 131, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0]
			]
			]
,			[
			"PiranhaKingRED",
			10,
			true,
			1,
			0,
			false,
			9249459893420129,
			[
				["enemy-sheet0.png", 8687, 131, 131, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0],
				["enemy-sheet1.png", 9781, 1, 1, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0],
				["enemy-sheet1.png", 9781, 66, 1, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0],
				["enemy-sheet1.png", 9781, 131, 1, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0],
				["enemy-sheet1.png", 9781, 1, 66, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0],
				["enemy-sheet1.png", 9781, 66, 66, 64, 64, 1, 0.5, 0.5,[],[-0.15625,-0.15625,0,-0.28125,0.15625,-0.15625,0.265625,0,0.140625,0.140625,0,0.125,-0.140625,0.140625,-0.265625,0],0]
			]
			]
,			[
			"Ray",
			20,
			false,
			1,
			0,
			false,
			7405505449709922,
			[
				["enemy-sheet0.png", 8687, 199, 199, 32, 32, 1, 0.5, 0.5,[["Porpulsor", 0.5, 0.40625],["Shoot", 0.5, 0.78125]],[-0.34375,-0.34375,0,-0.28125,0.34375,-0.34375,0.40625,0,0.125,0.125,0,0.375,-0.125,0.125,-0.40625,0],0]
			]
			]
,			[
			"RayRED",
			20,
			false,
			1,
			0,
			false,
			2315708082533826,
			[
				["enemy-sheet1.png", 9781, 196, 1, 32, 32, 1, 0.5, 0.5,[["Porpulsor", 0.5, 0.40625],["Shoot", 0.5, 0.78125]],[-0.34375,-0.34375,0,-0.28125,0.34375,-0.34375,0.40625,0,0.125,0.125,0,0.375,-0.125,0.125,-0.40625,0],0]
			]
			]
,			[
			"PhalanxBlock",
			10,
			false,
			1,
			0,
			false,
			5517605520577147,
			[
				["enemy-sheet1.png", 9781, 196, 34, 32, 32, 1, 0.5, 0.5,[["ShootRight", 0.71875, 0.6875],["ShootLeft", 0.28125, 0.6875]],[-0.25,-0.25,0,-0.375,0.25,-0.25,0.46875,0,0.3125,0.3125,0,-0.03125,-0.3125,0.3125,-0.46875,0],0],
				["enemy-sheet1.png", 9781, 131, 66, 32, 32, 1, 0.5, 0.5,[],[-0.25,-0.25,0,-0.375,0.25,-0.25,0.46875,0,0.3125,0.3125,0,-0.03125,-0.3125,0.3125,-0.46875,0],0],
				["enemy-sheet1.png", 9781, 164, 67, 32, 32, 1, 0.5, 0.5,[],[-0.25,-0.25,0,-0.375,0.25,-0.25,0.46875,0,0.3125,0.3125,0,0.375,-0.3125,0.3125,-0.46875,0],0]
			]
			]
,			[
			"Phalanx",
			10,
			false,
			1,
			0,
			false,
			6077549345353852,
			[
				["enemy-sheet1.png", 9781, 197, 67, 32, 32, 1, 0.5, 0.5,[],[-0.25,-0.25,0,-0.375,0.25,-0.25,0.46875,0,0.3125,0.3125,0,0.375,-0.3125,0.3125,-0.46875,0],0],
				["enemy-sheet1.png", 9781, 131, 99, 32, 32, 1, 0.5, 0.5,[],[-0.25,-0.25,0,-0.375,0.25,-0.25,0.46875,0,0.3125,0.3125,0,0,-0.3125,0.3125,-0.46875,0],0],
				["enemy-sheet1.png", 9781, 164, 100, 32, 32, 1, 0.5, 0.5,[["ShootRight", 0.71875, 0.6875],["ShootLeft", 0.28125, 0.6875]],[-0.25,-0.25,0,-0.375,0.25,-0.25,0.46875,0,0.3125,0.3125,0,-0.03125,-0.3125,0.3125,-0.46875,0],0]
			]
			]
,			[
			"PhalanxRED",
			20,
			false,
			1,
			0,
			false,
			8064914900678414,
			[
				["enemy-sheet1.png", 9781, 197, 100, 32, 32, 1, 0.5, 0.5,[["ShootRight", 0.71875, 0.6875],["ShootLeft", 0.28125, 0.6875]],[-0.25,-0.25,0,-0.375,0.25,-0.25,0.46875,0,0.3125,0.3125,0,-0.03125,-0.3125,0.3125,-0.46875,0],0]
			]
			]
,			[
			"Wind",
			20,
			false,
			1,
			0,
			false,
			781788510868313,
			[
				["enemy-sheet1.png", 9781, 1, 131, 32, 32, 1, 0.5, 0.5,[],[-0.21875,-0.21875,0,-0.4375,0.4374999403953552,0,0.21875,0.21875,0,0.40625,-0.21875,0.21875,-0.40625,0],0]
			]
			]
,			[
			"WindRED",
			20,
			false,
			1,
			0,
			false,
			7525865469816492,
			[
				["enemy-sheet1.png", 9781, 34, 131, 32, 32, 1, 0.5, 0.5,[],[-0.21875,-0.21875,0,-0.4375,0.4374999403953552,0,0.21875,0.21875,0,0.40625,-0.21875,0.21875,-0.40625,0],0]
			]
			]
,			[
			"Shop",
			5,
			false,
			1,
			0,
			false,
			2918509567641502,
			[
				["enemy-sheet1.png", 9781, 67, 131, 32, 32, 1, 0.5, 0.5,[],[-0.21875,-0.21875,0,-0.3125,0.21875,-0.21875,0.4374999403953552,0,0.21875,0.21875,0,0.25,-0.21875,0.21875,-0.4375,0],0]
			]
			]
,			[
			"Rock2",
			10,
			false,
			1,
			0,
			false,
			5950216374451656,
			[
				["enemy-sheet1.png", 9781, 100, 132, 32, 32, 1, 0.5, 0.5,[],[-0.28125,-0.28125,0,-0.40625,0.28125,-0.28125,0.40625,0,0.28125,0.28125,0,0.40625,-0.28125,0.28125,-0.375,0],0],
				["enemy-sheet1.png", 9781, 133, 133, 32, 32, 1, 0.5, 0.5,[],[-0.28125,-0.28125,0,-0.40625,0.28125,-0.28125,0.40625,0,0.28125,0.28125,0,0.40625,-0.28125,0.28125,-0.375,0],0],
				["enemy-sheet1.png", 9781, 166, 133, 32, 32, 1, 0.5, 0.5,[],[-0.28125,-0.28125,0,-0.40625,0.28125,-0.28125,0.40625,0,0.28125,0.28125,0,0.40625,-0.28125,0.28125,-0.375,0],0],
				["enemy-sheet1.png", 9781, 199, 133, 32, 32, 1, 0.5, 0.5,[],[-0.28125,-0.28125,0,-0.40625,0.28125,-0.28125,0.40625,0,0.28125,0.28125,0,0.40625,-0.28125,0.28125,-0.375,0],0]
			]
			]
,			[
			"Rock2RED",
			1,
			false,
			1,
			0,
			false,
			6403082393968686,
			[
				["enemy-sheet1.png", 9781, 1, 164, 32, 32, 1, 0.5, 0.5,[],[-0.28125,-0.28125,0,-0.40625,0.28125,-0.28125,0.40625,0,0.28125,0.28125,0,0.40625,-0.28125,0.28125,-0.375,0],0],
				["enemy-sheet1.png", 9781, 34, 164, 32, 32, 1, 0.5, 0.5,[],[-0.28125,-0.28125,0,-0.40625,0.28125,-0.28125,0.40625,0,0.28125,0.28125,0,0.40625,-0.28125,0.28125,-0.375,0],0],
				["enemy-sheet1.png", 9781, 67, 164, 32, 32, 1, 0.5, 0.5,[],[-0.28125,-0.28125,0,-0.40625,0.28125,-0.28125,0.40625,0,0.28125,0.28125,0,0.40625,-0.28125,0.28125,-0.375,0],0]
			]
			]
		],
		[
		[
			"SineY",
			cr.behaviors.Sin,
			2828031342488556
		]
,		[
			"SineX",
			cr.behaviors.Sin,
			2424165338853006
		]
,		[
			"Bullet",
			cr.behaviors.Bullet,
			5576393152815741
		]
,		[
			"Rotate",
			cr.behaviors.Rotate,
			6677422787077272
		]
		],
		false,
		false,
		23112934460601,
		[],
		null
	]
,	[
		"t8",
		cr.plugins_.Function,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		1824025234291872,
		[],
		null
		,[]
	]
,	[
		"t9",
		cr.plugins_.Arr,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		true,
		false,
		8787622341342625,
		[],
		null
	]
,	[
		"t10",
		cr.plugins_.Particles,
		false,
		[],
		0,
		0,
		["part_hit.png", 91, 1],
		null,
		[
		],
		false,
		false,
		3891555591294911,
		[],
		null
	]
,	[
		"t11",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			15,
			false,
			1,
			0,
			false,
			7447953665115036,
			[
				["explosion-sheet0.png", 1116, 1, 1, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet0.png", 1116, 34, 1, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet0.png", 1116, 67, 1, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet0.png", 1116, 1, 34, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet0.png", 1116, 34, 34, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet0.png", 1116, 67, 34, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet0.png", 1116, 1, 67, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet0.png", 1116, 34, 67, 32, 32, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"Animation2",
			15,
			false,
			1,
			0,
			false,
			3450822888284331,
			[
				["explosion-sheet0.png", 1116, 67, 67, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet1.png", 477, 1, 1, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet1.png", 477, 34, 1, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet1.png", 477, 67, 1, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet1.png", 477, 1, 34, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet1.png", 477, 34, 34, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet1.png", 477, 67, 34, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet1.png", 477, 1, 67, 32, 32, 1, 0.5, 0.5,[],[],0],
				["explosion-sheet1.png", 477, 34, 67, 32, 32, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		4028920659040105,
		[],
		null
	]
,	[
		"t12",
		cr.plugins_.Particles,
		false,
		[],
		0,
		0,
		["part_explosion.png", 91, 1],
		null,
		[
		],
		false,
		false,
		452556396555772,
		[],
		null
	]
,	[
		"t13",
		cr.plugins_.Sprite,
		false,
		[6563802894180323],
		1,
		0,
		null,
		[
			[
			"PowerUP",
			10,
			true,
			1,
			0,
			true,
			9021520300525274,
			[
				["bonus-sheet0.png", 411, 1, 1, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0],
				["bonus-sheet0.png", 411, 18, 1, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0],
				["bonus-sheet0.png", 411, 35, 1, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0],
				["bonus-sheet0.png", 411, 1, 18, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0]
			]
			]
,			[
			"ExtraOption",
			10,
			true,
			1,
			0,
			true,
			7401179650929213,
			[
				["bonus-sheet0.png", 411, 18, 18, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0],
				["bonus-sheet0.png", 411, 35, 18, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0],
				["bonus-sheet0.png", 411, 1, 35, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0],
				["bonus-sheet0.png", 411, 18, 35, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0]
			]
			]
,			[
			"ExtraScore",
			10,
			true,
			1,
			0,
			true,
			14960820568777,
			[
				["bonus-sheet0.png", 411, 35, 35, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0],
				["bonus-sheet1.png", 502, 1, 1, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0],
				["bonus-sheet1.png", 502, 18, 1, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0],
				["bonus-sheet1.png", 502, 35, 1, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.3125,-0.5,0.3046879768371582],0]
			]
			]
,			[
			"Bomb",
			10,
			true,
			1,
			0,
			true,
			9313492292882394,
			[
				["bonus-sheet1.png", 502, 1, 18, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.25,-0.5,0.25],0],
				["bonus-sheet1.png", 502, 18, 18, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.25,-0.5,0.25],0],
				["bonus-sheet1.png", 502, 35, 18, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.25,-0.5,0.25],0],
				["bonus-sheet1.png", 502, 1, 35, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.25,-0.5,0.25],0]
			]
			]
		],
		[
		[
			"Bullet",
			cr.behaviors.Bullet,
			1492031200859101
		]
		],
		false,
		false,
		2106025985378894,
		[],
		null
	]
,	[
		"t14",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			10,
			true,
			1,
			0,
			false,
			3170433056855983,
			[
				["coin-sheet0.png", 1617, 1, 1, 16, 16, 1, 0.5, 0.5,[],[],0],
				["coin-sheet0.png", 1617, 18, 1, 16, 16, 1, 0.5, 0.5,[],[],0],
				["coin-sheet0.png", 1617, 35, 1, 16, 16, 1, 0.5, 0.5,[],[],0],
				["coin-sheet0.png", 1617, 1, 18, 16, 16, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"Animation2",
			10,
			true,
			1,
			0,
			false,
			7736805717128651,
			[
				["coin-sheet0.png", 1617, 18, 18, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.25,-0.5,0.25],0],
				["coin-sheet0.png", 1617, 35, 18, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.25,-0.5,0.25],0],
				["coin-sheet0.png", 1617, 1, 35, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.25,-0.5,0.25],0],
				["coin-sheet0.png", 1617, 18, 35, 16, 16, 1, 0.5, 0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.25,-0.5,0.25],0]
			]
			]
		],
		[
		[
			"Bullet",
			cr.behaviors.Bullet,
			2059479837009365
		]
		],
		false,
		false,
		7717194907147512,
		[],
		null
	]
,	[
		"t15",
		cr.plugins_.Spritefont2,
		false,
		[8831463348255627,5888250274181987],
		0,
		0,
		["font.png", 834, 3],
		null,
		[
		],
		false,
		false,
		6577247680420639,
		[],
		null
	]
,	[
		"t16",
		cr.plugins_.TiledBg,
		false,
		[],
		0,
		0,
		["bgmobile.png", 93, 4],
		null,
		[
		],
		false,
		false,
		1720047627610466,
		[],
		null
	]
,	[
		"t17",
		cr.plugins_.Sprite,
		false,
		[8726357588242549,2657201993284549,8964290481043019,6240129615773752,3394691091885464],
		2,
		0,
		null,
		[
			[
			"Normal",
			0,
			false,
			1,
			0,
			false,
			1621152107763556,
			[
				["icons-sheet0.png", 1077, 34, 1, 16, 16, 1, 0, 0,[["Shoot1Left", 0.375, 0.125],["Shoot1Right", 0.625, 0.125],["Shoot1Center", 0.5, 0.125]],[0.375,0.3125,0.625,0.3125,0.625,0.875,0.375,0.875],0],
				["coin-sheet0.png", 1617, 18, 1, 16, 16, 1, 0, 0,[],[],0]
			]
			]
,			[
			"Max",
			10,
			true,
			1,
			0,
			true,
			8534976489051212,
			[
				["icons-sheet0.png", 1077, 1, 1, 32, 16, 1, 0.5, 0.5,[],[],0],
				["icons-sheet0.png", 1077, 1, 18, 32, 16, 1, 0.5, 0.5,[],[],0],
				["icons-sheet0.png", 1077, 1, 35, 32, 16, 1, 0.5, 0.5,[],[],0],
				["icons-sheet1.png", 190, 0, 0, 32, 16, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"BoundToLayout",
			cr.behaviors.bound,
			755381473771451
		]
,		[
			"Bullet",
			cr.behaviors.Bullet,
			2286855207286054
		]
		],
		false,
		false,
		9163986940679626,
		[],
		null
	]
,	[
		"t18",
		cr.plugins_.WebStorage,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		3062386578744532,
		[],
		null
		,[]
	]
,	[
		"t19",
		cr.plugins_.Sprite,
		false,
		[8735324140982129,6417986145387227,5431570886457754],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4174631955786764,
			[
				["missile-sheet0.png", 130, 0, 0, 8, 8, 1, 0.375, 0.5,[],[0.625,-0.5,0.625,0.5,-0.375,0.5,-0.375,-0.5],0]
			]
			]
		],
		[
		[
			"Bullet",
			cr.behaviors.Bullet,
			79652022135971
		]
		],
		false,
		false,
		6482025001579835,
		[],
		null
	]
,	[
		"t20",
		cr.plugins_.Sprite,
		false,
		[7629083560926538,5396012920433125,470765095959399,6130412788750768,5146007791235783,3773690768349231,9568884208884548,2351452121840218],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			4406205701774729,
			[
				["level-sheet0.png", 116, 0, 0, 32, 32, 1, 0.5, 0.5,[],[],0],
				["level-sheet1.png", 116, 0, 0, 32, 32, 1, 0.5, 0.5,[],[],0],
				["level-sheet2.png", 116, 0, 0, 32, 32, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		6581725052673266,
		[],
		null
	]
,	[
		"t21",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9807700306079469,
			[
				["levellink-sheet0.png", 92, 0, 0, 48, 2, 1, 0, 0.5,[],[0,-0.5,0.6666669845581055,-0.5,0.6666669845581055,0.5,0,0.5],1]
			]
			]
		],
		[
		],
		false,
		false,
		6527726721257713,
		[],
		null
	]
,	[
		"t22",
		cr.plugins_.Dictionary,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		true,
		false,
		4121838974294834,
		[],
		null
	]
,	[
		"t23",
		cr.plugins_.Sprite,
		false,
		[1104698667911921],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3901256102724027,
			[
				["boton-sheet0.png", 94, 0, 0, 64, 32, 1, 0.5, 0.5,[],[],1]
			]
			]
		],
		[
		],
		false,
		false,
		8328325060018991,
		[],
		null
	]
,	[
		"t24",
		cr.plugins_.Arr,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		true,
		false,
		5033935424412487,
		[],
		null
	]
,	[
		"t25",
		cr.plugins_.Sprite,
		false,
		[2341692901582882,9571797251229623,6787174146194133],
		1,
		0,
		null,
		[
			[
			"Shoot",
			20,
			true,
			1,
			0,
			false,
			330983804393265,
			[
				["rayweapon-sheet0.png", 1178, 1, 1, 32, 480, 1, 0.5, 0.03333333507180214,[["Imagepoint 1", 0.5, 0.5]],[-0.125,-0.008333334699273109,0.125,-0.008333334699273109,0.15625,0.4666666686534882,0.15625,0.9437496662139893,0,0.9666666388511658,-0.15625,0.9437496662139893,-0.15625,0.4666666686534882],0],
				["rayweapon-sheet0.png", 1178, 34, 1, 32, 480, 1, 0.5, 0.03333333507180214,[["Imagepoint 1", 0.5, 0.5]],[-0.125,-0.008333334699273109,0.125,-0.008333334699273109,0.15625,0.4666666686534882,0.15625,0.9437496662139893,0,0.9666666388511658,-0.15625,0.9437496662139893,-0.15625,0.4666666686534882],0]
			]
			]
,			[
			"Charge",
			20,
			true,
			1,
			0,
			false,
			9168736155040135,
			[
				["rayweapon-sheet0.png", 1178, 67, 1, 32, 32, 1, 0.5, 0.5,[["Imagepoint 1", 0.5, 0.5]],[-0.125,-0.125,0,-0.15625,0.125,-0.125,0.40625,0,0.15625,0.15625,0,0.21875,-0.15625,0.15625,-0.40625,0],0],
				["rayweapon-sheet0.png", 1178, 100, 1, 32, 32, 1, 0.5, 0.5,[["Imagepoint 1", 0.5, 0.5]],[-0.125,-0.125,0,-0.15625,0.125,-0.125,0.40625,0,0.15625,0.15625,0,0.21875,-0.15625,0.15625,-0.40625,0],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			2509303000664146
		]
		],
		false,
		false,
		1319550397962181,
		[],
		null
	]
,	[
		"t26",
		cr.plugins_.CJSAds,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		2961354408511783,
		[],
		null
		,[0,0,3,1,"342634993250"]
	]
,	[
		"t27",
		cr.plugins_.Browser,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		1850780881118784,
		[],
		null
		,[]
	]
,	[
		"t28",
		cr.plugins_.Sprite,
		false,
		[2190695340640287,7530886450714001,6458184494695032,8055604436053343,698670100288899],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			499777052260742,
			[
				["aux_ship-sheet0.png", 580, 1, 1, 32, 32, 1, 0.5, 0.5625,[["Left", 0.40625, 0.59375],["Right", 0.59375, 0.59375]],[-0.09375,0.1875,0.09375,0.1875,0.09375,0.34375,-0.09375,0.34375],0],
				["aux_ship-sheet0.png", 580, 34, 1, 32, 32, 1, 0.5, 0.5625,[["Left", 0.40625, 0.59375],["Right", 0.59375, 0.59375]],[-0.09375,0.1875,0.09375,0.1875,0.09375,0.34375,-0.09375,0.34375],0],
				["aux_ship-sheet0.png", 580, 67, 1, 32, 32, 1, 0.5, 0.5625,[["Left", 0.40625, 0.59375],["Right", 0.59375, 0.59375]],[-0.09375,0.1875,0.09375,0.1875,0.09375,0.34375,-0.09375,0.34375],0],
				["aux_ship-sheet0.png", 580, 1, 34, 32, 32, 1, 0.5, 0.5625,[["Left", 0.40625, 0.59375],["Right", 0.59375, 0.59375]],[-0.09375,0.1875,0.09375,0.1875,0.09375,0.34375,-0.09375,0.34375],0],
				["aux_ship-sheet0.png", 580, 34, 34, 32, 32, 1, 0.5, 0.5625,[["Left", 0.40625, 0.59375],["Right", 0.59375, 0.59375]],[-0.09375,0.1875,0.09375,0.1875,0.09375,0.34375,-0.09375,0.34375],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			1745009112297924
		]
		],
		false,
		false,
		369850328311965,
		[],
		null
	]
,	[
		"t29",
		cr.plugins_.Sprite,
		false,
		[3040866878119938],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			true,
			1,
			0,
			false,
			4911369012346644,
			[
				["arrow-sheet0.png", 163, 0, 0, 32, 32, 1, 0.5, 0.5,[],[],0],
				["arrow-sheet1.png", 168, 0, 0, 32, 32, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		6554596070281628,
		[],
		null
	]
,	[
		"t30",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			5522299557819719,
			[
				["title-sheet0.png", 2471, 1, 1, 320, 128, 1, 0.5, 0.5,[],[],0],
				["title-sheet0.png", 2471, 1, 388, 256, 64, 1, 0.515625, 0.5,[],[],0]
			]
			]
,			[
			"EStart",
			5,
			false,
			1,
			0,
			false,
			1708720742746362,
			[
				["title-sheet0.png", 2471, 1, 130, 320, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"SStart",
			5,
			false,
			1,
			0,
			false,
			5512927955010558,
			[
				["title-sheet0.png", 2471, 1, 259, 320, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"EPause",
			0,
			false,
			1,
			0,
			false,
			6057910017100627,
			[
				["title-sheet1.png", 932, 1, 1, 320, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"SPause",
			0,
			false,
			1,
			0,
			false,
			5821190630024526,
			[
				["title-sheet1.png", 932, 1, 130, 320, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		4377862325254284,
		[],
		null
	]
,	[
		"t31",
		cr.plugins_.Sprite,
		false,
		[4322057309551408],
		0,
		0,
		null,
		[
			[
			"ERate",
			0,
			false,
			1,
			0,
			false,
			9787332136974743,
			[
				["button-sheet0.png", 4977, 1, 1, 128, 64, 1, 0.5, 0.5,[],[],0],
				["button-sheet0.png", 4977, 130, 1, 128, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"SRate",
			0,
			false,
			1,
			0,
			false,
			1380118863035718,
			[
				["button-sheet0.png", 4977, 259, 1, 128, 64, 1, 0.5, 0.5,[],[],0],
				["button-sheet0.png", 4977, 1, 66, 128, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"EExit",
			0,
			false,
			1,
			0,
			false,
			4024314411633094,
			[
				["button-sheet0.png", 4977, 130, 66, 128, 64, 1, 0.5, 0.5,[],[],0],
				["button-sheet0.png", 4977, 259, 66, 128, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"SExit",
			0,
			false,
			1,
			0,
			false,
			4440657285794463,
			[
				["button-sheet0.png", 4977, 1, 131, 128, 64, 1, 0.5, 0.5,[],[],0],
				["button-sheet0.png", 4977, 130, 131, 128, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"EReplay",
			0,
			false,
			1,
			0,
			false,
			9444466865962031,
			[
				["button-sheet0.png", 4977, 259, 131, 128, 64, 1, 0.5, 0.5,[],[],0],
				["button-sheet0.png", 4977, 1, 196, 128, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"SReplay",
			0,
			false,
			1,
			0,
			false,
			8599871234584052,
			[
				["button-sheet0.png", 4977, 130, 196, 128, 64, 1, 0.5, 0.5,[],[],0],
				["button-sheet0.png", 4977, 259, 196, 128, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"ETwitter",
			0,
			false,
			1,
			0,
			false,
			9213856703421907,
			[
				["button-sheet0.png", 4977, 1, 261, 128, 64, 1, 0.5, 0.5,[],[],0],
				["button-sheet0.png", 4977, 130, 261, 128, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"STwitter",
			0,
			false,
			1,
			0,
			false,
			3012074292908818,
			[
				["button-sheet0.png", 4977, 259, 261, 128, 64, 1, 0.5, 0.5,[],[],0],
				["button-sheet0.png", 4977, 1, 326, 128, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		2820387785025773,
		[],
		null
	]
,	[
		"t32",
		cr.plugins_.Sprite,
		false,
		[4184312834581465],
		0,
		0,
		null,
		[
			[
			"Bronze",
			0,
			false,
			1,
			0,
			false,
			7992037128042805,
			[
				["medal-sheet0.png", 2099, 1, 1, 32, 32, 1, 0.5, 0.5,[],[],0],
				["medal-sheet0.png", 2099, 34, 1, 32, 32, 1, 0.5, 0.5,[],[],0],
				["medal-sheet0.png", 2099, 67, 1, 32, 32, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"Empty",
			0,
			false,
			1,
			0,
			false,
			7466631665583569,
			[
				["medal-sheet0.png", 2099, 1, 34, 32, 32, 1, 0.5, 0.5,[],[],0],
				["medal-sheet0.png", 2099, 34, 34, 32, 32, 1, 0.5, 0.5,[],[],0],
				["medal-sheet0.png", 2099, 67, 34, 32, 32, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"Silver",
			0,
			false,
			1,
			0,
			false,
			4297110625489746,
			[
				["medal-sheet0.png", 2099, 1, 67, 32, 32, 1, 0.5, 0.5,[],[],0],
				["medal-sheet0.png", 2099, 34, 67, 32, 32, 1, 0.5, 0.5,[],[],0],
				["medal-sheet0.png", 2099, 67, 67, 32, 32, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"Gold",
			0,
			false,
			1,
			0,
			false,
			1996936044642121,
			[
				["medal-sheet1.png", 1000, 1, 1, 32, 32, 1, 0.5, 0.5,[],[],0],
				["medal-sheet1.png", 1000, 34, 1, 32, 32, 1, 0.5, 0.5,[],[],0],
				["medal-sheet1.png", 1000, 67, 1, 32, 32, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		902039120829807,
		[],
		null
	]
,	[
		"t33",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			6359367774418744,
			[
				["tuto-sheet0.png", 1194, 322, 1, 130, 200, 1, 0.5, 0.5,[],[],0],
				["tuto-sheet0.png", 1194, 1, 102, 130, 200, 1, 0.5, 0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0],
				["tuto-sheet0.png", 1194, 1, 1, 320, 100, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		2112549096644545,
		[],
		null
	]
,	[
		"t34",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"OptionIdle",
			10,
			true,
			1,
			0,
			true,
			4575281678108696,
			[
				["shield-sheet0.png", 559, 1, 1, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet0.png", 559, 34, 1, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet0.png", 559, 67, 1, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet0.png", 559, 1, 34, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet0.png", 559, 34, 34, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet0.png", 559, 67, 34, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet0.png", 559, 1, 67, 32, 32, 1, 0.5, 0.34375,[],[],0]
			]
			]
,			[
			"OptionRight",
			10,
			true,
			1,
			0,
			true,
			4929995923675248,
			[
				["shield-sheet0.png", 559, 34, 67, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet0.png", 559, 67, 67, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet1.png", 490, 1, 1, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet1.png", 490, 34, 1, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet1.png", 490, 67, 1, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet1.png", 490, 1, 34, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet1.png", 490, 34, 34, 32, 32, 1, 0.5, 0.34375,[],[],0]
			]
			]
,			[
			"OptionLeft",
			10,
			true,
			1,
			0,
			true,
			9676549185482827,
			[
				["shield-sheet1.png", 490, 67, 34, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet1.png", 490, 1, 67, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet1.png", 490, 34, 67, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet1.png", 490, 67, 67, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet2.png", 312, 1, 1, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet2.png", 312, 34, 1, 32, 32, 1, 0.5, 0.34375,[],[],0],
				["shield-sheet2.png", 312, 67, 1, 32, 32, 1, 0.5, 0.34375,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			3513166742276055
		]
		],
		false,
		false,
		1700267893089033,
		[],
		null
	]
,	[
		"t35",
		cr.plugins_.Spritefont2,
		false,
		[8577001948088724,7211918579328006],
		0,
		0,
		["font2.png", 1790, 0],
		null,
		[
		],
		false,
		false,
		492528628861422,
		[],
		null
	]
,	[
		"t36",
		cr.plugins_.Text,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		9348709903316992,
		[],
		null
	]
,	[
		"t37",
		cr.plugins_.Sprite,
		false,
		[7651387050221534,4107330988804884],
		0,
		0,
		null,
		[
			[
			"Items",
			0,
			false,
			1,
			0,
			false,
			7715014165077595,
			[
				["items-sheet0.png", 226, 0, 0, 32, 32, 1, 0.5, 0.5,[],[],0],
				["items-sheet1.png", 231, 0, 0, 32, 32, 1, 0.5, 0.5,[],[],0],
				["items-sheet2.png", 226, 0, 0, 32, 32, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		2497356066793561,
		[],
		null
	]
,	[
		"t38",
		cr.plugins_.Sprite,
		false,
		[7148629855548427,197633402713775,9896725881718333,511278736540042,9266726741421333,4227276668671725,3742570045640504,5645729923346828,593120707259632,7435549616786494],
		2,
		0,
		null,
		[
			[
			"Boss1Base",
			0,
			false,
			1,
			0,
			false,
			2177325551292554,
			[
				["boss-sheet0.png", 694, 0, 0, 96, 96, 1, 0.5, 0.5,[["Top", 0.5, 0.2604166567325592],["Bottom", 0.5, 0.7395833134651184],["Left", 0.2604166567325592, 0.5],["Right", 0.7395833134651184, 0.5]],[-0.2395829856395721,-0.2395829856395721,0,-0.3333330154418945,0.2395830154418945,-0.2395829856395721,0.3333330154418945,0,0.2395830154418945,0.2395830154418945,0,0.3333330154418945,-0.2395829856395721,0.2395830154418945,-0.3333330154418945,0],0]
			]
			]
,			[
			"Boss1Center",
			0,
			false,
			1,
			0,
			false,
			6182058991084152,
			[
				["boss-sheet1.png", 387, 0, 0, 96, 96, 1, 0.5, 0.5,[],[-0.125,-0.125,0,-0.1770829856395721,0.125,-0.125,0.1770830154418945,0,0.125,0.125,0,0.1770830154418945,-0.125,0.125,-0.1770829856395721,0],0]
			]
			]
,			[
			"Boss1Saw",
			0,
			false,
			1,
			0,
			false,
			4112256599299704,
			[
				["boss-sheet2.png", 752, 0, 0, 96, 96, 1, 0.5, 0.5,[["1", 0.5, 0.1666666716337204],["2", 0.7291666865348816, 0.2604166567325592],["3", 0.8333333134651184, 0.5],["4", 0.7395833134651184, 0.7395833134651184],["5", 0.4895833432674408, 0.8229166865348816],["6", 0.2604166567325592, 0.7291666865348816],["7", 0.1770833283662796, 0.4895833432674408],["8", 0.2604166567325592, 0.2708333432674408]],[-0.125,-0.09375,0.125,-0.1145829856395721,0.125,0.15625,-0.125,0.1041669845581055],0]
			]
			]
		],
		[
		[
			"Bullet",
			cr.behaviors.Bullet,
			494038434340941
		]
,		[
			"Rotate",
			cr.behaviors.Rotate,
			9863886503198059
		]
		],
		false,
		false,
		5680212745180457,
		[],
		null
	]
,	[
		"t39",
		cr.plugins_.NinePatch,
		false,
		[],
		0,
		0,
		["barborder.png", 121, 3],
		null,
		[
		],
		false,
		false,
		8588399045809244,
		[],
		null
	]
,	[
		"t40",
		cr.plugins_.NinePatch,
		false,
		[1282902467561251,3140430507557146],
		0,
		0,
		["barfill.png", 115, 0],
		null,
		[
		],
		false,
		false,
		9333904017136845,
		[],
		null
	]
,	[
		"t41",
		cr.plugins_.Sprite,
		true,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		7093692434772328,
		[],
		null
	]
	],
	[
		[41,2,0]
	],
	[
	[
		"Game",
		320,
		480,
		false,
		"Game",
		9374674310388577,
		[
		[
			"Black",
			0,
			4665702427166047,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			],
			[			]
		]
,		[
			"BG",
			1,
			9626630127276625,
			true,
			[255, 255, 255],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[160, 0, 0, 320, 480, 0, 0, 1, 0.5, 0, 0, 0, []],
				3,
				3,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[160, -480, 0, 320, 480, 0, 0, 1, 0.5, 0, 0, 0, []],
				3,
				4,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Boss",
			2,
			1005596737509147,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			],
			[			]
		]
,		[
			"Shoots",
			3,
			776868395521014,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			],
			[			]
		]
,		[
			"Enemies",
			4,
			7599449671227019,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			],
			[			]
		]
,		[
			"Player",
			5,
			3414213210424999,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[160, 422, 0, 16, 16, 0, 0, 1, 0.5, 0, 0, 0, []],
				2,
				2,
				[
					[0]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[160, 410, 0, 16, 16, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				0,
				0,
				[
					[0],
					[10],
					[120],
					[0],
					[7],
					["Option"],
					[0],
					[500],
					[1],
					[2],
					[160],
					[410],
					[100],
					[100],
					[0],
					[0],
					[0],
					[0],
					[0],
					[270],
					[0]
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"UI",
			6,
			9236969925042176,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[32, 32, 0, 256, 8, 0, 0, 1, 0, 0, 0, 0, []],
				40,
				73,
				[
					[0],
					[256]
				],
				[
				],
				[
					2,
					2,
					2,
					2,
					0,
					0,
					1,
					0,
					1
				]
			]
,			[
				[144, 0, 0, 64, 16, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				23,
				[
					["ScoreTxt"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Score",
					0.5,
					0,
					1,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[224, 0, 0, 96, 16, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				24,
				[
					["Hi-ScoreTxt"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Hi-Score",
					0.5,
					0,
					1,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[128, 10, 0, 96, 16, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				25,
				[
					["Score"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Score",
					0.5,
					0,
					1,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[224, 10, 0, 96, 16, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				26,
				[
					["Hi-Score"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Hi-Score",
					0.5,
					0,
					1,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 0, 0, 64, 16, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				29,
				[
					["Lives"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Text",
					0.5,
					0,
					0,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 16, 0, 16, 16, 0, 0, 1, 0, 0, 0, 0, []],
				17,
				28,
				[
					["Money"],
					[0],
					[0],
					[0],
					[0]
				],
				[
				[
					1
				],
				[
					100,
					0,
					0,
					0,
					0,
					0
				]
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
,			[
				[16, 16, 0, 48, 16, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				32,
				[
					["Money"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Text",
					0.5,
					0,
					0,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[64, 0, 0, 64, 16, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				22,
				[
					["BonusTxt"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Bonus",
					0.5,
					0,
					1,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[64, 10, 0, 64, 16, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				33,
				[
					["Bonus"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Score",
					0.5,
					0,
					1,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[96, 16, 0, 16, 16, 0, 0, 1, 0, 0, 0, 0, []],
				17,
				97,
				[
					["Max"],
					[0],
					[0],
					[0],
					[0]
				],
				[
				[
					1
				],
				[
					100,
					0,
					0,
					0,
					0,
					0
				]
				],
				[
					1,
					"Default",
					1,
					1
				]
			]
,			[
				[0, 447, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				36,
				58,
				[
				],
				[
				],
				[
					"Text",
					0,
					"12pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[32, 32, 0, 256, 8, 0, 0, 1, 0, 0, 0, 0, []],
				39,
				72,
				[
				],
				[
				],
				[
					4,
					4,
					4,
					4,
					0,
					0,
					1,
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"UIPauseMenu",
			7,
			6835277393017931,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[160, 96, 0, 256, 64, 0, 0, 1, 0.515625, 0.5, 0, 0, []],
				30,
				138,
				[
				],
				[
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
,			[
				[0, 160, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				48,
				[
					["PauseContinue"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Back",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 224, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				49,
				[
					["PauseExit"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Back",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
			],
			[			]
		]
,		[
			"UIStart",
			8,
			4775072928221146,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 48, 0, 320, 64, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				56,
				[
					["TouchPause"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Touch here to Pause",
					0.5,
					0,
					1,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 256, 0, 128, 80, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				85,
				[
					["TouchLeft"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Touch here to move left",
					0.5,
					0,
					1,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[192, 256, 0, 128, 80, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				86,
				[
					["TouchRight"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Touch here to move Right",
					0.5,
					0,
					1,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[160, 192, 0, 256, 64, 0, 0, 1, 0.515625, 0.5, 0, 0, []],
				30,
				83,
				[
				],
				[
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
,			[
				[64, 352, 0, 130, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				33,
				17,
				[
				],
				[
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
,			[
				[256, 352, 0, 130, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				33,
				84,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[160, 80, 0, 320, 100, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				33,
				55,
				[
				],
				[
				],
				[
					0,
					"Default",
					2,
					1
				]
			]
			],
			[			]
		]
,		[
			"UIGameOver",
			9,
			1813407567016764,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[160, 144, 0, 32, 32, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				32,
				76,
				[
					["Normal"]
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[170, 112, 0, 256, 64, 0, 0, 1, 0.515625, 0.5, 0, 0, []],
				30,
				79,
				[
				],
				[
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
,			[
				[0, 208, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				80,
				[
					["GOScore"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Continue",
					1,
					0,
					1,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 240, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				81,
				[
					["GOBest"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Continue",
					1,
					0,
					1,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 160, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				82,
				[
					["GOMedal"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Continue",
					1,
					0,
					1,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 304, 0, 144, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				74,
				[
					["RateMe"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Back",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[176, 304, 0, 144, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				77,
				[
					["Records"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Records",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 384, 0, 144, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				78,
				[
					["Play"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Back",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[176, 384, 0, 144, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				91,
				[
					["Exit"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Back",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
			],
			[			]
		]
,		[
			"Borders",
			10,
			8194030137555978,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[320, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				19,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, -160, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				20,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, 480, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				21,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[-256, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				18,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
			],
			[			]
		]
		],
		[
			[
				null,
				9,
				10,
				[
				],
				[
				],
				[
					10,
					11,
					1
				]
			]
,			[
				null,
				22,
				62,
				[
				],
				[
				],
				[
				]
			]
,			[
				null,
				24,
				38,
				[
				],
				[
				],
				[
					20,
					1,
					1
				]
			]
		],
		[]
	]
,	[
		"Container",
		1280,
		1024,
		false,
		null,
		7718843782106438,
		[
		[
			"Layer 0",
			0,
			2832825734310449,
			true,
			[255, 255, 255],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[370, 136, 0, 32, 32, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				7,
				8,
				[
					[2],
					[0],
					["Ready"],
					[120],
					[120],
					[1],
					[1],
					[0],
					[100],
					[3],
					[8],
					["Basic"],
					[100],
					[300],
					[300],
					[2],
					["Charge"],
					[""],
					[0],
					[3],
					[0],
					[0]
				],
				[
				[
					0,
					1,
					0,
					8,
					0,
					0,
					0,
					300,
					0
				],
				[
					0,
					0,
					0,
					60,
					0,
					0,
					0,
					450,
					0
				],
				[
					50,
					0,
					0,
					0,
					0,
					0
				],
				[
					0,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[295, 231, 0, 4, 6, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				4,
				5,
				[
					["Player"],
					[0],
					[0],
					[0]
				],
				[
				[
					500,
					0,
					0,
					0,
					0,
					1
				],
				[
				],
				[
					0,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[109, -28, 0, 128, 128, 0, 0, 1, 0, 0.5, 0, 0, []],
				10,
				12,
				[
				],
				[
				],
				[
					2,
					60,
					1,
					150,
					1,
					100,
					0,
					0,
					0,
					50,
					0,
					0,
					-50,
					0,
					0,
					800,
					0,
					1,
					0.4
				]
			]
,			[
				[407, -58, 0, 32, 32, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				11,
				13,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[247, -123, 0, 128, 128, 0, 0, 1, 0, 0.5, 0, 0, []],
				12,
				14,
				[
				],
				[
				],
				[
					6,
					360,
					1,
					150,
					1,
					100,
					0,
					0,
					0,
					50,
					2,
					0,
					-50,
					0,
					0,
					800,
					0,
					1,
					0.7
				]
			]
,			[
				[565, 56, 0, 16, 16, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				13,
				15,
				[
					["PowerUP"]
				],
				[
				[
					100,
					0,
					0,
					0,
					0,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[118, 267, 0, 16, 16, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				14,
				16,
				[
				],
				[
				[
					100,
					0,
					0,
					0,
					0,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[129, 81, 0, 16, 16, 0, 0, 1, 0, 0, 0, 0, []],
				17,
				27,
				[
					["Lives"],
					[0],
					[0],
					[0],
					[0]
				],
				[
				[
					1
				],
				[
					100,
					0,
					0,
					0,
					0,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[284, 242, 0, 8, 8, 0, 0, 1, 0.375, 0.5, 0, 0, []],
				19,
				34,
				[
					[300],
					[100],
					[4]
				],
				[
				[
					10,
					1,
					0,
					0,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[266, 132, 0, 32, 32, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				20,
				35,
				[
					[0],
					[0],
					[0],
					[0],
					[0],
					[0],
					[0],
					[0]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[214, 188, 0, 48, 2, 0, 0, 1, 0, 0.5, 0, 0, []],
				21,
				36,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[47, 16, 0, 32, 480, 0, 0, 1, 0.5, 0.03333333507180214, 0, 0, []],
				25,
				45,
				[
					[0],
					[0],
					[""]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[315, 277, 0, 32, 32, 0, 0, 1, 0.5, 0.5625, 0, 0, []],
				28,
				87,
				[
					[0],
					[0],
					[10],
					[0],
					[1]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[379, 84, 0, 32, 32, 0, 0, 1, 0.5, 0.34375, 0, 0, []],
				34,
				141,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[462, 156, 0, 200, 30, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				57,
				[
					[""],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"()",
					1,
					0,
					0,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[294, 83, 0, 96, 96, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				38,
				70,
				[
					[0],
					[""],
					[""],
					[0],
					[120],
					[40],
					[40],
					[60],
					[60],
					[0]
				],
				[
				[
					0,
					0,
					0,
					0,
					0,
					0
				],
				[
					0,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"LoadGame",
		320,
		480,
		false,
		"LoadGame",
		5029461199689216,
		[
		[
			"Layer 0",
			0,
			7671518050448716,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"Title",
		320,
		480,
		false,
		"Title",
		7735362687620722,
		[
		[
			"Layer 0",
			0,
			3732048201108688,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[320, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				98,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, -160, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				99,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, 480, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				100,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[-256, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				101,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[160, 64, 0, 320, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				30,
				39,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[0, 160, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				59,
				[
					["Play"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Play",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 224, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				61,
				[
					["Options"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Options",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 288, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				63,
				[
					["Premium"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Premium",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 352, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				41,
				[
					["Exit"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Exit",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"ModeSelect",
		320,
		480,
		false,
		"ModeSelect",
		3675184130016127,
		[
		[
			"Layer 0",
			0,
			3436779298984425,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[320, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				102,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, -160, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				103,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, 480, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				104,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[-256, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				105,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, 144, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				50,
				[
					["RecordNormal"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Record: 75045623",
					0.5,
					0,
					1,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 256, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				51,
				[
					["RecordHardcore"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Record: 5043623",
					0.5,
					0,
					1,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 352, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				68,
				[
					["Back"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Back",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 240, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				69,
				[
					["Hardcore"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Hardcore",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 128, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				71,
				[
					["Normal"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Normal",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 32, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				54,
				[
					["SelectMode"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Play",
					1.2,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"Options",
		320,
		480,
		false,
		"Options",
		9690934827147979,
		[
		[
			"Layer 0",
			0,
			3980915238173241,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[320, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				163,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, -160, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				164,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, 480, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				165,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[-256, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				166,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, 144, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				65,
				[
					["LANG"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Lang",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 224, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				66,
				[
					["MUSIC"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"MUSIC",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 352, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				67,
				[
					["Back"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Back",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 32, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				31,
				[
					["OPTIONS"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Play",
					1.2,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"LANG",
		320,
		480,
		false,
		"LANG",
		2225772720441237,
		[
		[
			"Layer 0",
			0,
			4319600559113062,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[320, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				189,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, -160, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				190,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, 480, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				191,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[-256, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				192,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, 208, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				60,
				[
					["English"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"English",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 304, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				64,
				[
					["Spanish"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Spanish",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 32, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				47,
				[
					[""],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"LANGUAGE",
					1.2,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"ShipSelect",
		320,
		480,
		false,
		"ShipSelect",
		3599896307015662,
		[
		[
			"Layer 0",
			0,
			8054146078314453,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[160, 128, 0, 32, 32, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				0,
				88,
				[
					[0],
					[10],
					[120],
					[0],
					[7],
					["Standard"],
					[0],
					[500],
					[1],
					[2],
					[160],
					[410],
					[100],
					[100],
					[0],
					[0],
					[0],
					[0],
					[0],
					[270],
					[0]
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[16, 176, 0, 288, 144, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				89,
				[
					["Desc"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"",
					0.5,
					0,
					0,
					0,
					0,
					0,
					0,
					5
				]
			]
,			[
				[216, 128, 0, 32, 32, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				29,
				93,
				[
					["Right"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[104, 128, 0, 32, 32, 0, 3.141592741012573, 1, 0.5, 0.5, 0, 0, []],
				29,
				94,
				[
					["Left"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[159, 80, 0, 32, 32, 0, -1.570796489715576, 1, 0.5, 0.5, 0, 0, []],
				29,
				90,
				[
					["Up"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[160, 176, 0, 32, 32, 0, 1.570796370506287, 1, 0.5, 0.5, 0, 0, []],
				29,
				95,
				[
					["Down"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[176, 192, 0, 112, 80, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				96,
				[
					["Price"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"",
					0.5,
					0,
					2,
					0,
					0,
					0,
					0,
					5
				]
			]
,			[
				[320, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				106,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, -160, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				107,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, 480, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				108,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[-256, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				109,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[288, 176, 0, 16, 16, 0, 0, 1, 0, 0, 0, 0, []],
				17,
				40,
				[
					["Money"],
					[0],
					[0],
					[0],
					[0]
				],
				[
				[
					1
				],
				[
					100,
					0,
					0,
					0,
					0,
					0
				]
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
,			[
				[192, 176, 0, 96, 16, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				124,
				[
					["Money"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Play",
					0.5,
					0,
					2,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[288, 192, 0, 16, 16, 0, 0, 1, 0, 0, 0, 0, []],
				17,
				125,
				[
					["Price"],
					[0],
					[0],
					[0],
					[0]
				],
				[
				[
					1
				],
				[
					100,
					0,
					0,
					0,
					0,
					0
				]
				],
				[
					1,
					"Default",
					1,
					1
				]
			]
,			[
				[296, 104, 0, 16, 16, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				32,
				75,
				[
					["Hardcore"]
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[24, 104, 0, 16, 16, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				32,
				11,
				[
					["Normal"]
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[16, 80, 0, 64, 16, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				37,
				[
					["NormalMedal"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Normal",
					0.5,
					0,
					0,
					0,
					0,
					0,
					0,
					5
				]
			]
,			[
				[240, 80, 0, 64, 16, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				52,
				[
					["NormalMedal"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Hardcore",
					0.5,
					0,
					0,
					0,
					0,
					0,
					0,
					5
				]
			]
,			[
				[0, 320, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				42,
				[
					["Play"],
					["Play"]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Play",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 384, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				43,
				[
					["Back"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Back",
					1,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
,			[
				[0, 32, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				53,
				[
					["SelectShip"],
					[""]
				],
				[
				],
				[
					18,
					20,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"SELECT SHIP",
					1.2,
					0,
					1,
					1,
					0,
					0,
					-1,
					0
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"Achievements",
		320,
		480,
		false,
		"Achievements",
		5051281536621709,
		[
		[
			"Layer 0",
			0,
			8863943606719836,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[320, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				110,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, -160, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				111,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, 480, 0, 320, 160, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				112,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[-256, -160, 0, 256, 800, 0, 0, 1, 0, 0, 0, 0, []],
				16,
				113,
				[
				],
				[
				],
				[
					0,
					0
				]
			]
,			[
				[0, 32, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				114,
				[
					["AchTxt"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"ACHIEVEMENTS",
					1,
					0,
					1,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 432, 0, 320, 32, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				115,
				[
					["Back"],
					[""]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"Back",
					1,
					0,
					1,
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[48, 80, 0, 240, 48, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				116,
				[
					["1"],
					["Ach"]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"ACHIEVEMENTS",
					0.5,
					0,
					0,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[48, 144, 0, 240, 48, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				117,
				[
					["2"],
					["Ach"]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"ACHIEVEMENTS",
					0.5,
					0,
					0,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[48, 208, 0, 240, 48, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				118,
				[
					["3"],
					["Ach"]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"ACHIEVEMENTS",
					0.5,
					0,
					0,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[48, 272, 0, 240, 48, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				119,
				[
					["4"],
					["Ach"]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"ACHIEVEMENTS",
					0.5,
					0,
					0,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[48, 336, 0, 240, 48, 0, 0, 1, 0, 0, 0, 0, []],
				15,
				120,
				[
					["5"],
					["Ach"]
				],
				[
				],
				[
					16,
					18,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-=*/()?!.,;:<>[]'$%",
					"ACHIEVEMENTS",
					0.5,
					0,
					0,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[216, 400, 0, 32, 32, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				29,
				122,
				[
					["Right"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[104, 400, 0, 32, 32, 0, 3.141592741012573, 1, 0.5, 0.5, 0, 0, []],
				29,
				123,
				[
					["Left"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
	],
	[
	[
		"Game",
		[
		[
			1,
			"DELAY",
			0,
			0,
false,false,447393019164327,false
		]
,		[
			1,
			"BOSS_HP",
			0,
			0,
false,false,8569444414413724,false
		]
,		[
			1,
			"DIFFICULTY",
			0,
			0,
false,false,5995716238575684,false
		]
,		[
			1,
			"EVERY_X_LVLs",
			0,
			0,
false,false,2769446906193042,false
		]
,		[
			1,
			"EVERY_X_LVLs_Chain",
			0,
			0,
false,false,5279572488793272,false
		]
,		[
			1,
			"SCORE",
			0,
			0,
false,false,2137973320346342,false
		]
,		[
			1,
			"MONEY",
			0,
			0,
false,false,6294951574264229,false
		]
,		[
			1,
			"COMBO",
			0,
			0,
false,false,6391827685688793,false
		]
,		[
			1,
			"TIME_LEFT",
			0,
			10,
false,false,3844543655871279,false
		]
,		[
			1,
			"TIME_LEFT_MAX",
			0,
			10,
false,false,5490330402461561,false
		]
,		[
			1,
			"GAMESTATE",
			1,
			"START",
false,false,401162710732841,false
		]
,		[
			1,
			"LAST_GAMESTATE",
			1,
			"",
false,false,7346321206263365,false
		]
,		[
			1,
			"GAME_MODE",
			1,
			"NORMAL",
false,false,7121491124386341,false
		]
,		[
			2,
			"FUNCIONES",
			false
		]
,		[
			0,
			null,
			false,
			null,
			4748025435960277,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				8654998272509399,
				false
			]
			],
			[
			[
				8,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				893508643466768,
				false
				,[
				[
					1,
					[
						2,
						"OnStartLayout"
					]
				]
,				[
					13,
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				5457929645274841,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					6923314026971856,
					false
					,[
					[
						1,
						[
							2,
							"PREMIUM"
						]
					]
,					[
						8,
						1
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.PreloadBanner,
					null,
					6127886724020276,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8263722551056697,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsPreview,
				null,
				0,
				false,
				false,
				false,
				2439959556894073,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				9115082891134904,
				[
				[
					-1,
					cr.system_object.prototype.cnds.EveryTick,
					null,
					0,
					false,
					false,
					false,
					52054237505907,
					false
				]
				],
				[
				[
					36,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					4440883278629024,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								"objectcount:"
							]
							,[
								19,
								cr.system_object.prototype.exps.objectcount
							]
						]
					]
					]
				]
				]
				,[
				[
					1,
					"count",
					0,
					0,
false,false,6907826220187329,false
				]
,				[
					0,
					null,
					false,
					null,
					9218412848287965,
					[
					[
						-1,
						cr.system_object.prototype.cnds.ForEach,
						null,
						0,
						true,
						false,
						false,
						435380691097278,
						false
						,[
						[
							4,
							7
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						8879500806942802,
						false
						,[
						[
							11,
							"count"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					92064023325108,
					[
					],
					[
					[
						36,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						6069552829587722,
						false
						,[
						[
							7,
							[
								10,
								[
									10,
									[
										10,
										[
											10,
											[
												10,
												[
													2,
													"enemycount: "
												]
												,[
													23,
													"count"
												]
											]
											,[
												2,
												" objectCount: "
											]
										]
										,[
											19,
											cr.system_object.prototype.exps.objectcount
										]
									]
									,[
										2,
										" fps: "
									]
								]
								,[
									19,
									cr.system_object.prototype.exps.fps
								]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9100874609898627,
			[
			[
				-1,
				cr.system_object.prototype.cnds.Else,
				null,
				0,
				false,
				false,
				false,
				8306004731713523,
				false
			]
			],
			[
			[
				36,
				cr.plugins_.Text.prototype.acts.Destroy,
				null,
				3532418262315688,
				false
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5658280258527481,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				7299905960976549,
				false
				,[
				[
					11,
					"GAMESTATE"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"START"
					]
				]
				]
			]
			],
			[
			[
				8,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				67120498947432,
				false
				,[
				[
					1,
					[
						2,
						"UpdateUI"
					]
				]
,				[
					13,
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				6639586366022167,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					7932962529157335,
					false
					,[
					[
						1,
						[
							2,
							"PREMIUM"
						]
					]
,					[
						8,
						1
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.ShowBanner,
					null,
					8892623257060812,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				4374687753588711,
				[
				[
					6,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					406411734111605,
					false
				]
,				[
					1,
					cr.plugins_.Keyboard.prototype.cnds.OnAnyKey,
					null,
					1,
					false,
					false,
					false,
					9272624227890077,
					false
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					1047067966212575,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4655224941933716,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						7,
						[
							2,
							"PLAY"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			true,
			null,
			9911984531648032,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				8861142207585334,
				false
				,[
				[
					11,
					"GAMESTATE"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"PLAY"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				2320113147813502,
				false
				,[
				[
					11,
					"GAMESTATE"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"BOSS"
					]
				]
				]
			]
			],
			[
			[
				8,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				7084404142096623,
				false
				,[
				[
					1,
					[
						2,
						"CallEnemy"
					]
				]
,				[
					13,
											[
							7,
							[
								2,
								"Random"
							]
						]
				]
				]
			]
,			[
				8,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				4273902893563656,
				false
				,[
				[
					1,
					[
						2,
						"MoveBG"
					]
				]
,				[
					13,
				]
				]
			]
,			[
				8,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				3602756769894918,
				false
				,[
				[
					1,
					[
						2,
						"MoveEnemy"
					]
				]
,				[
					13,
				]
				]
			]
,			[
				8,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				1255862046039141,
				false
				,[
				[
					1,
					[
						2,
						"UpdateUI"
					]
				]
,				[
					13,
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				7199235476839602,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					3920504824722173,
					false
					,[
					[
						1,
						[
							2,
							"PREMIUM"
						]
					]
,					[
						8,
						1
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					26,
					cr.plugins_.CJSAds.prototype.cnds.IsShowingBanner,
					null,
					0,
					false,
					false,
					false,
					7338440921542915,
					false
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.HideBanner,
					null,
					9550848313318975,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1180855587752537,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					8369671812701162,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"BOSS"
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.NinePatch.prototype.acts.SetWidth,
					null,
					9364229634721403,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.clamp
							,[
[
								6,
								[
									23,
									"BOSS_HP"
								]
								,[
									7,
									[
										21,
										40,
										false,
										null
										,1
									]
									,[
										21,
										40,
										false,
										null
										,0
									]
								]
							]
,[
								0,
								0
							]
,[
								21,
								40,
								false,
								null
								,1
							]
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2777057961820836,
					[
					[
						-1,
						cr.system_object.prototype.cnds.ForEach,
						null,
						0,
						true,
						false,
						false,
						4867263688890874,
						false
						,[
						[
							4,
							7
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6121090617762989,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.IsOutsideLayout,
							null,
							0,
							false,
							false,
							false,
							1385846360771762,
							false
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							49652218869105,
							false
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6468963080657827,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						8292975465300204,
						false
						,[
						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.Count,
								false,
								null
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						556959241996696,
						false
						,[
						[
							1,
							[
								2,
								"MoveBoss"
							]
						]
,						[
							13,
															[
									7,
									[
										0,
										1
									]
								]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						5360277339754188,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							5351387845192075,
							false
							,[
							[
								7,
								[
									20,
									5,
									cr.plugins_.Audio.prototype.exps.Volume,
									false,
									null
									,[
[
										2,
										"Music"
									]
									]
								]
							]
,							[
								8,
								4
							]
,							[
								7,
								[
									0,
									-100
								]
							]
							]
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.SetVolume,
							null,
							5853914211666334,
							false
							,[
							[
								1,
								[
									2,
									"Music"
								]
							]
,							[
								0,
								[
									5,
									[
										20,
										5,
										cr.plugins_.Audio.prototype.exps.Volume,
										false,
										null
										,[
[
											2,
											"Music"
										]
										]
									]
									,[
										1,
										0.2
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3948942199341118,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							5740770616826736,
							false
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.Stop,
							null,
							471473086377303,
							false
							,[
							[
								1,
								[
									2,
									"Music"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3606655047541061,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							4279144371662207,
							false
							,[
							[
								7,
								[
									20,
									5,
									cr.plugins_.Audio.prototype.exps.Volume,
									false,
									null
									,[
[
										2,
										"BossMusic"
									]
									]
								]
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									-10
								]
							]
							]
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.SetVolume,
							null,
							5775303516971284,
							false
							,[
							[
								1,
								[
									2,
									"BossMusic"
								]
							]
,							[
								0,
								[
									4,
									[
										20,
										5,
										cr.plugins_.Audio.prototype.exps.Volume,
										false,
										null
										,[
[
											2,
											"BossMusic"
										]
										]
									]
									,[
										1,
										0.2
									]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3713893608402626,
					[
					[
						4,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						1257726801067861,
						false
						,[
						[
							4,
							38
						]
						]
					]
,					[
						4,
						cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
						null,
						0,
						false,
						true,
						false,
						9930657722311181,
						false
						,[
						[
							10,
							2
						]
						]
					]
,					[
						38,
						cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
						null,
						0,
						false,
						false,
						false,
						1896766495876071,
						false
						,[
						[
							10,
							9
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						9588671728716868,
						[
						[
							4,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							524209110211234,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Player"
								]
							]
							]
						]
						],
						[
						[
							4,
							cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
							null,
							3217534617423239,
							false
							,[
							[
								10,
								1
							]
,							[
								3,
								0
							]
							]
						]
,						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3903019758812258,
							false
							,[
							[
								1,
								[
									2,
									"EnemyHurts"
								]
							]
,							[
								13,
																	[
										7,
										[
											20,
											38,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
,
									[
										7,
										[
											20,
											4,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
,
									[
										7,
										[
											21,
											0,
											false,
											null
											,8
										]
									]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8083188113242614,
					[
					[
						19,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						678901529387055,
						false
						,[
						[
							4,
							38
						]
						]
					]
,					[
						38,
						cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
						null,
						0,
						false,
						false,
						false,
						3217634846227301,
						false
						,[
						[
							10,
							9
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3404998889861674,
						false
						,[
						[
							1,
							[
								2,
								"EnemyHurts"
							]
						]
,						[
							13,
															[
									7,
									[
										20,
										38,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
,
								[
									7,
									[
										20,
										19,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
,
								[
									7,
									[
										21,
										0,
										false,
										null
										,9
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4499474883337809,
					[
					[
						38,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						2745389270917405,
						false
						,[
						[
							4,
							0
						]
						]
					]
,					[
						38,
						cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
						null,
						0,
						false,
						false,
						false,
						7884540137601727,
						false
						,[
						[
							10,
							9
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						160163515116143,
						false
						,[
						[
							1,
							[
								2,
								"PlayerHurts"
							]
						]
,						[
							13,
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6066916674276751,
				[
				[
					25,
					cr.behaviors.Pin.prototype.cnds.IsPinned,
					"Pin",
					0,
					false,
					true,
					false,
					3789829357182034,
					false
				]
				],
				[
				[
					25,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1650546206028131,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4992163100159788,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					4180916298471473,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					0,
					cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
					null,
					2941585883279607,
					false
					,[
					[
						10,
						0
					]
,					[
						7,
						[
							6,
							[
								19,
								cr.system_object.prototype.exps.dt
							]
							,[
								0,
								60
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5321493623767603,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					464385349281874,
					false
					,[
					[
						10,
						12
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					0,
					cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
					null,
					3764602182388053,
					false
					,[
					[
						10,
						12
					]
,					[
						7,
						[
							6,
							[
								19,
								cr.system_object.prototype.exps.dt
							]
							,[
								0,
								60
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1891873197532344,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3668699188140328,
					false
					,[
					[
						10,
						3
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							21,
							0,
							false,
							null
							,4
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					true,
					null,
					8245796786613691,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8026546159650734,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Standard"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8614277281286878,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Stork"
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
						null,
						4132077811227165,
						false
						,[
						[
							10,
							17
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					1,
					"fullUpgraded",
					0,
					0,
false,false,3849998684587451,false
				]
,				[
					0,
					null,
					false,
					null,
					4584781968982988,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7959768953397469,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Option"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4733897380633982,
						false
						,[
						[
							10,
							14
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								3
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						2727735835895889,
						[
						[
							-1,
							cr.system_object.prototype.cnds.ForEach,
							null,
							0,
							true,
							false,
							false,
							9232297347804219,
							false
							,[
							[
								4,
								28
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7105659603680946,
							[
							[
								28,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								478530959842684,
								false
								,[
								[
									10,
									3
								]
,								[
									8,
									5
								]
,								[
									7,
									[
										21,
										28,
										false,
										null
										,4
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.AddVar,
								null,
								3430109247353461,
								false
								,[
								[
									11,
									"fullUpgraded"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9984429051842974,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8017841631757483,
							false
							,[
							[
								11,
								"fullUpgraded"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
							null,
							9370960553522616,
							false
							,[
							[
								10,
								17
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6962696579533397,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					3236899265192698,
					false
					,[
					[
						4,
						28
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8090114789582866,
					false
					,[
					[
						10,
						1
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					28,
					cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
					null,
					9462057819776266,
					false
					,[
					[
						10,
						1
					]
,					[
						7,
						[
							6,
							[
								19,
								cr.system_object.prototype.exps.dt
							]
							,[
								0,
								60
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6564240226364661,
				[
				[
					19,
					cr.behaviors.Bullet.prototype.cnds.CompareSpeed,
					"Bullet",
					0,
					false,
					false,
					false,
					1616502316783855,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							21,
							19,
							false,
							null
							,0
						]
					]
					]
				]
				],
				[
				[
					19,
					cr.behaviors.Bullet.prototype.acts.SetSpeed,
					"Bullet",
					1803620941050591,
					false
					,[
					[
						0,
						[
							4,
							[
								22,
								19,
								"Bullet",
								cr.behaviors.Bullet.prototype.exps.Speed,
								false,
								null
							]
							,[
								6,
								[
									19,
									cr.system_object.prototype.exps.dt
								]
								,[
									0,
									150
								]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5479898519741047,
				[
				[
					19,
					cr.plugins_.Sprite.prototype.cnds.IsOutsideLayout,
					null,
					0,
					false,
					false,
					false,
					7655579697817177,
					false
				]
				],
				[
				[
					19,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1136379209556843,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6016462912014012,
				[
				[
					2,
					cr.behaviors.Pin.prototype.cnds.IsPinned,
					"Pin",
					0,
					false,
					true,
					false,
					4113869269542615,
					false
				]
				],
				[
				[
					2,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2785011114776018,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2847883001853679,
				[
				[
					7,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					false,
					false,
					2656122555660179,
					false
					,[
					[
						1,
						[
							10,
							[
								21,
								7,
								true,
								null
								,17
							]
							,[
								2,
								"RED"
							]
						]
					]
					]
				]
				],
				[
				[
					7,
					cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
					null,
					9839795184812584,
					false
					,[
					[
						10,
						18
					]
,					[
						7,
						[
							6,
							[
								19,
								cr.system_object.prototype.exps.dt
							]
							,[
								0,
								60
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6881003765684819,
				[
				[
					7,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					false,
					false,
					4592323367875319,
					false
					,[
					[
						1,
						[
							10,
							[
								21,
								7,
								true,
								null
								,17
							]
							,[
								2,
								"RED"
							]
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					2498127393602806,
					false
					,[
					[
						10,
						18
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					4300965965562979,
					false
					,[
					[
						1,
						[
							21,
							7,
							true,
							null
							,17
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					4963532680217942,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5058073257379513,
						false
						,[
						[
							10,
							11
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Phalanx"
							]
						]
						]
					]
					],
					[
					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						487379895912007,
						false
						,[
						[
							0,
							[
								0,
								2
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1680535331336947,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					8890738940453768,
					false
				]
				],
				[
				]
			]
,			[
				0,
				null,
				false,
				null,
				1758563804145701,
				[
				[
					13,
					cr.plugins_.Sprite.prototype.cnds.IsOutsideLayout,
					null,
					0,
					false,
					false,
					false,
					4639223076570874,
					false
				]
,				[
					13,
					cr.plugins_.Sprite.prototype.cnds.CompareY,
					null,
					0,
					false,
					false,
					false,
					2542554222144769,
					false
					,[
					[
						8,
						4
					]
,					[
						0,
						[
							4,
							[
								19,
								cr.system_object.prototype.exps.layoutheight
							]
							,[
								0,
								100
							]
						]
					]
					]
				]
				],
				[
				[
					13,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4845777306214303,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1193714640566366,
				[
				[
					14,
					cr.plugins_.Sprite.prototype.cnds.IsOutsideLayout,
					null,
					0,
					false,
					false,
					false,
					9712004855531368,
					false
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.cnds.CompareY,
					null,
					0,
					false,
					false,
					false,
					749288409272815,
					false
					,[
					[
						8,
						4
					]
,					[
						0,
						[
							4,
							[
								19,
								cr.system_object.prototype.exps.layoutheight
							]
							,[
								0,
								100
							]
						]
					]
					]
				]
				],
				[
				[
					14,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5654593065429059,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5462862629212241,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1385414181938294,
					false
					,[
					[
						11,
						"COMBO"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							10
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6868676727730153,
					[
					[
						17,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2087195255622005,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Max"
							]
						]
						]
					]
					],
					[
					[
						17,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						366476930717835,
						false
						,[
						[
							1,
							[
								2,
								"Max"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						17,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5676763277874094,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2215684269069063,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8445939229857655,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Bonus"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						2033743165595389,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				668468856628124,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					5217794033518848,
					false
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					2712912026597867,
					[
					[
						17,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1145422160433469,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Max"
							]
						]
						]
					]
					],
					[
					[
						17,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2438361300177743,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4966508132304595,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5438291334784064,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Bonus"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						533473914238481,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8022712370045967,
				[
				[
					6,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					9738453097558814,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					4664704656880964,
					false
					,[
					[
						7,
						[
							20,
							6,
							cr.plugins_.Touch.prototype.exps.Y,
							false,
							null
						]
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							0,
							200
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					1222243270703997,
					false
					,[
					[
						11,
						"LAST_GAMESTATE"
					]
,					[
						7,
						[
							23,
							"GAMESTATE"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4290257113151582,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						7,
						[
							2,
							"PAUSE"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9014542424357055,
				[
				[
					6,
					cr.plugins_.Touch.prototype.cnds.IsInTouch,
					null,
					0,
					false,
					false,
					false,
					8102709855118305,
					false
				]
,				[
					26,
					cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,
					null,
					0,
					false,
					false,
					false,
					3779943972538046,
					false
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					1885703092677137,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						7445937302286683,
						false
						,[
						[
							7,
							[
								20,
								6,
								cr.plugins_.Touch.prototype.exps.X,
								false,
								null
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								7,
								[
									19,
									cr.system_object.prototype.exps.layoutwidth
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						5643451257195677,
						false
						,[
						[
							1,
							[
								2,
								"control"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Left"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8754770756129486,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						5033388766045822,
						false
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8020017884935667,
						false
						,[
						[
							1,
							[
								2,
								"control"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Right"
									]
								]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6447259946696963,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					508675163192405,
					false
				]
,				[
					1,
					cr.plugins_.Keyboard.prototype.cnds.IsKeyDown,
					null,
					0,
					false,
					false,
					false,
					5959086209795853,
					false
					,[
					[
						9,
						37
					]
					]
				]
				],
				[
				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					589552350824212,
					false
					,[
					[
						1,
						[
							2,
							"control"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Left"
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8887959113818197,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					3881250598523833,
					false
				]
,				[
					1,
					cr.plugins_.Keyboard.prototype.cnds.IsKeyDown,
					null,
					0,
					false,
					false,
					false,
					778375878651498,
					false
					,[
					[
						9,
						39
					]
					]
				]
				],
				[
				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8381792351549892,
					false
					,[
					[
						1,
						[
							2,
							"control"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Right"
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2239301784751111,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					2831281374617781,
					false
				]
				],
				[
				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3783728239938295,
					false
					,[
					[
						1,
						[
							2,
							"control"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Idle"
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7669737689208019,
				[
				],
				[
				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8224667669493129,
					false
					,[
					[
						1,
						[
							2,
							"control"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Shoot"
								]
							]
,
							[
								7,
								[
									21,
									0,
									false,
									null
									,3
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2286938256582878,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1543370992098563,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"PLAY"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9897621811552591,
					[
					[
						-1,
						cr.system_object.prototype.cnds.EveryTick,
						null,
						0,
						false,
						false,
						false,
						6233356737727922,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						8763764451754761,
						false
						,[
						[
							11,
							"TIME_LEFT"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						858120236944574,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9680007439820238,
							false
							,[
							[
								11,
								"TIME_LEFT"
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7872188734223683,
							false
							,[
							[
								11,
								"DIFFICULTY"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.clamp
									,[
[
										4,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											1
										]
									]
,[
										0,
										0
									]
,[
										0,
										25
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7166795587442062,
							false
							,[
							[
								11,
								"TIME_LEFT"
							]
,							[
								7,
								[
									23,
									"TIME_LEFT_MAX"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.AddVar,
							null,
							8919323648834867,
							false
							,[
							[
								11,
								"EVERY_X_LVLs"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.AddVar,
							null,
							8324933188650884,
							false
							,[
							[
								11,
								"EVERY_X_LVLs_Chain"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				229560203532625,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					6672049406582497,
					false
					,[
					[
						4,
						19
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8554962975069586,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.PickDistance,
						null,
						0,
						false,
						false,
						true,
						5670969901610546,
						false
						,[
						[
							3,
							0
						]
,						[
							0,
							[
								20,
								19,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								19,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						7275717795545952,
						false
						,[
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.distance
								,[
[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
,[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
,[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
,[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								]
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								21,
								19,
								false,
								null
								,1
							]
						]
						]
					]
					],
					[
					[
						19,
						cr.plugins_.Sprite.prototype.acts.RotateTowardAngle,
						null,
						3773253648270043,
						false
						,[
						[
							0,
							[
								6,
								[
									6,
									[
										21,
										19,
										false,
										null
										,2
									]
									,[
										0,
										60
									]
								]
								,[
									19,
									cr.system_object.prototype.exps.dt
								]
							]
						]
,						[
							0,
							[
								19,
								cr.system_object.prototype.exps.angle
								,[
[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
,[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
,[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
,[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4501518151020462,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4850946330116917,
						false
						,[
						[
							11,
							"GAMESTATE"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"BOSS"
							]
						]
						]
					]
,					[
						38,
						cr.plugins_.Sprite.prototype.cnds.PickDistance,
						null,
						0,
						false,
						false,
						true,
						7791055066407749,
						false
						,[
						[
							3,
							0
						]
,						[
							0,
							[
								20,
								19,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								19,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						4084704988333615,
						false
						,[
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.distance
								,[
[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
,[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
,[
									20,
									38,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
,[
									20,
									38,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								]
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								21,
								19,
								false,
								null
								,1
							]
						]
						]
					]
					],
					[
					[
						19,
						cr.plugins_.Sprite.prototype.acts.RotateTowardAngle,
						null,
						1620683148798877,
						false
						,[
						[
							0,
							[
								6,
								[
									6,
									[
										21,
										19,
										false,
										null
										,2
									]
									,[
										0,
										60
									]
								]
								,[
									19,
									cr.system_object.prototype.exps.dt
								]
							]
						]
,						[
							0,
							[
								19,
								cr.system_object.prototype.exps.angle
								,[
[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
,[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
,[
									20,
									38,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
,[
									20,
									38,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4424351294607006,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6479445744919277,
					false
					,[
					[
						10,
						5
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Standard"
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					5767390515518519,
					false
					,[
					[
						10,
						16
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							4
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					4855413225930763,
					[
					[
						-1,
						cr.system_object.prototype.cnds.ForEach,
						null,
						0,
						true,
						false,
						false,
						4201536649366907,
						false
						,[
						[
							4,
							14
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4620020316395789,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							6715525792507178,
							false
							,[
							[
								7,
								[
									19,
									cr.system_object.prototype.exps.distance
									,[
[
										20,
										0,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
,[
										20,
										0,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
,[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
,[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									]
								]
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									150
								]
							]
							]
						]
						],
						[
						[
							14,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							4515770292326082,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.anglelerp
									,[
[
										22,
										14,
										"Bullet",
										cr.behaviors.Bullet.prototype.exps.AngleOfMotion,
										false,
										null
									]
,[
										19,
										cr.system_object.prototype.exps.angle
										,[
[
											20,
											14,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
,[
											20,
											14,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
,[
											20,
											0,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
,[
											20,
											0,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										]
									]
,[
										6,
										[
											0,
											2
										]
										,[
											19,
											cr.system_object.prototype.exps.dt
										]
									]
									]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5085812397315269,
					[
					[
						-1,
						cr.system_object.prototype.cnds.ForEach,
						null,
						0,
						true,
						false,
						false,
						9235529739659334,
						false
						,[
						[
							4,
							13
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						597702500389585,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							6814407064547167,
							false
							,[
							[
								7,
								[
									19,
									cr.system_object.prototype.exps.distance
									,[
[
										20,
										0,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
,[
										20,
										0,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
,[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
,[
										20,
										13,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									]
								]
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									150
								]
							]
							]
						]
						],
						[
						[
							13,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							3438457072811782,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.anglelerp
									,[
[
										22,
										13,
										"Bullet",
										cr.behaviors.Bullet.prototype.exps.AngleOfMotion,
										false,
										null
									]
,[
										19,
										cr.system_object.prototype.exps.angle
										,[
[
											20,
											13,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
,[
											20,
											13,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
,[
											20,
											0,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
,[
											20,
											0,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										]
									]
,[
										6,
										[
											0,
											2
										]
										,[
											19,
											cr.system_object.prototype.exps.dt
										]
									]
									]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5393973735862387,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					3694747763473234,
					false
					,[
					[
						4,
						4
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7105287611951224,
					[
					[
						4,
						cr.plugins_.Sprite.prototype.cnds.IsOutsideLayout,
						null,
						0,
						false,
						false,
						false,
						803727400809715,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4925247458239979,
						[
						[
							4,
							cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
							null,
							0,
							false,
							true,
							false,
							7787315516281796,
							false
							,[
							[
								10,
								2
							]
							]
						]
						],
						[
						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2077933464836208,
							false
							,[
							[
								1,
								[
									2,
									"StoreBullet"
								]
							]
,							[
								13,
																	[
										7,
										[
											20,
											4,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6148958195266153,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						7226323715316947,
						false
					]
					],
					[
					[
						4,
						cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
						"Bullet",
						550591419038612,
						false
						,[
						[
							0,
							[
								4,
								[
									22,
									4,
									"Bullet",
									cr.behaviors.Bullet.prototype.exps.AngleOfMotion,
									false,
									null
								]
								,[
									6,
									[
										6,
										[
											21,
											4,
											false,
											null
											,3
										]
										,[
											0,
											60
										]
									]
									,[
										19,
										cr.system_object.prototype.exps.dt
									]
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9622809688472863,
				[
				[
					4,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					9514985966859939,
					false
					,[
					[
						4,
						7
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
					null,
					0,
					false,
					true,
					false,
					597667803306266,
					false
					,[
					[
						10,
						2
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					9850179510758224,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					true,
					null,
					4937679916299071,
					[
					[
						4,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6995529142412263,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Player"
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6770723913986828,
						false
						,[
						[
							10,
							11
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Rock"
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						4643080423058143,
						false
						,[
						[
							1,
							[
								2,
								"EnemyHurts"
							]
						]
,						[
							13,
															[
									7,
									[
										20,
										7,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
,
								[
									7,
									[
										20,
										4,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
,
								[
									7,
									[
										21,
										0,
										false,
										null
										,8
									]
								]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8354770786967282,
				[
				[
					19,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					2313035947023625,
					false
					,[
					[
						4,
						7
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					9472374992527244,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3767216050321568,
					false
					,[
					[
						1,
						[
							2,
							"EnemyHurts"
						]
					]
,					[
						13,
													[
								7,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
,
							[
								7,
								[
									20,
									19,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
,
							[
								7,
								[
									21,
									0,
									false,
									null
									,9
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9904115988042479,
				[
				[
					11,
					cr.plugins_.Sprite.prototype.cnds.CompareFrame,
					null,
					0,
					false,
					false,
					false,
					9591956525516589,
					false
					,[
					[
						8,
						0
					]
,					[
						0,
						[
							5,
							[
								20,
								11,
								cr.plugins_.Sprite.prototype.exps.AnimationFrameCount,
								false,
								null
							]
							,[
								0,
								1
							]
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6156151005862607,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8215895308075072,
				[
				[
					13,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					4975047632136914,
					false
					,[
					[
						4,
						0
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					4055697826841511,
					false
					,[
					[
						2,
						["powerup",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							-15
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					13,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8748571112324674,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					3574767274165859,
					[
					[
						13,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7728567020738238,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"PowerUP"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4115369299970107,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3483618991180819,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									21,
									0,
									false,
									null
									,4
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							252430888635212,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8662941559218306,
					[
					[
						13,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9158116688101595,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"ExtraOption"
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
						null,
						9752135171383673,
						false
						,[
						[
							10,
							14
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8882270867968354,
						false
						,[
						[
							1,
							[
								2,
								"CreateAuxShip"
							]
						]
,						[
							13,
															[
									7,
									[
										21,
										0,
										false,
										null
										,14
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3831134958704954,
					[
					[
						13,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7732556613176978,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"ExtraScore"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						9366116532542592,
						false
						,[
						[
							11,
							"SCORE"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									6,
									[
										0,
										1500
									]
									,[
										4,
										[
											23,
											"COMBO"
										]
										,[
											0,
											1
										]
									]
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					565998368566331,
					[
					[
						13,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9877956899895882,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Bomb"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1215503632905421,
						[
						[
							-1,
							cr.system_object.prototype.cnds.ForEach,
							null,
							0,
							true,
							false,
							false,
							8812230606221495,
							false
							,[
							[
								4,
								7
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
							null,
							0,
							false,
							false,
							false,
							6886461946089909,
							false
						]
						],
						[
						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							110080952559819,
							false
							,[
							[
								1,
								[
									2,
									"EnemyHurts"
								]
							]
,							[
								13,
																	[
										7,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
,
									[
										7,
										[
											2,
											""
										]
									]
,
									[
										7,
										[
											21,
											7,
											false,
											null
											,0
										]
									]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4239347783156891,
				[
				[
					13,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					3656060714778005,
					false
					,[
					[
						4,
						28
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					3415461525153886,
					[
					[
						13,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1506396309787837,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"PowerUP"
							]
						]
						]
					]
					],
					[
					[
						13,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						2644326650632456,
						false
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						7760061990454718,
						[
						[
							28,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8874103669997315,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									21,
									28,
									false,
									null
									,4
								]
							]
							]
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.Play,
							null,
							7554123426912827,
							false
							,[
							[
								2,
								["powerup",false]
							]
,							[
								3,
								0
							]
,							[
								0,
								[
									0,
									-15
								]
							]
,							[
								1,
								[
									2,
									""
								]
							]
							]
						]
,						[
							28,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							76901250303861,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				787898535956236,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					4284839384400625,
					false
					,[
					[
						4,
						4
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1558293945499287,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Enemy"
						]
					]
					]
				]
				],
				[
				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1618606163605632,
					false
					,[
					[
						1,
						[
							2,
							"PlayerHurts"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7683569512013937,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8575927768219021,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					3567597660725784,
					false
					,[
					[
						4,
						25
					]
					]
				]
				],
				[
				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					9810014312465661,
					false
					,[
					[
						1,
						[
							2,
							"PlayerHurts"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8865758062670576,
				[
				[
					7,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					1536562275870683,
					false
					,[
					[
						4,
						25
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6883902442670578,
					false
					,[
					[
						10,
						11
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Rock"
						]
					]
					]
				]
				],
				[
				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					752293878542468,
					false
					,[
					[
						1,
						[
							2,
							"EnemyHurts"
						]
					]
,					[
						13,
													[
								7,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
,
							[
								7,
								[
									0,
									0
								]
							]
,
							[
								7,
								[
									4,
									[
										21,
										7,
										false,
										null
										,0
									]
									,[
										0,
										1
									]
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				488656464858466,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					9591551302161219,
					false
					,[
					[
						4,
						7
					]
					]
				]
				],
				[
				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					7800606074848446,
					false
					,[
					[
						1,
						[
							2,
							"PlayerHurts"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					6045329918867997,
					false
					,[
					[
						1,
						[
							2,
							"EnemyHurts"
						]
					]
,					[
						13,
													[
								7,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
,
							[
								7,
								[
									0,
									0
								]
							]
,
							[
								7,
								[
									21,
									7,
									false,
									null
									,0
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6550977560595383,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.OnCollision,
					null,
					0,
					false,
					false,
					true,
					583703948248969,
					false
					,[
					[
						4,
						14
					]
					]
				]
				],
				[
				[
					14,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7293513218549731,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					5016347394558462,
					false
					,[
					[
						11,
						"MONEY"
					]
,					[
						7,
						[
							0,
							10
						]
					]
					]
				]
,				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					5563707571317299,
					false
					,[
					[
						2,
						["pickupcoin",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							-15
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					5360340248032894,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1584279395884711,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Option"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5838554408285121,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							4166187308212502,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.AddVar,
							null,
							657233274202555,
							false
							,[
							[
								11,
								"MONEY"
							]
,							[
								7,
								[
									0,
									10
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9623515881046341,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						287795131909011,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Stork"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						2900644652857996,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9982505842852367,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							4469686549153757,
							[
							],
							[
							[
								0,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								270199071850897,
								false
								,[
								[
									4,
									19
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										2,
										"ShootWingLeft"
									]
								]
								]
							]
,							[
								19,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								1156677294422049,
								false
								,[
								[
									0,
									[
										0,
										255
									]
								]
								]
							]
,							[
								19,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								8528461962459332,
								false
								,[
								[
									4,
									2
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.RotateClockwise,
								null,
								5194511358893544,
								false
								,[
								[
									0,
									[
										0,
										90
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								2593025453944137,
								false
								,[
								[
									4,
									19
								]
,								[
									3,
									0
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetScale,
								null,
								2932987794189311,
								false
								,[
								[
									0,
									[
										1,
										0.7
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.MoveToBottom,
								null,
								2757454095499675,
								false
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								868170302243317,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										19,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								4172865185797318,
								false
								,[
								[
									4,
									19
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										2,
										"ShootWingRight"
									]
								]
								]
							]
,							[
								19,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								8660976409293226,
								false
								,[
								[
									0,
									[
										0,
										285
									]
								]
								]
							]
,							[
								19,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								2829704625603065,
								false
								,[
								[
									4,
									2
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.RotateClockwise,
								null,
								50300893548903,
								false
								,[
								[
									0,
									[
										0,
										90
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								3647778132718478,
								false
								,[
								[
									4,
									19
								]
,								[
									3,
									0
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetScale,
								null,
								5522938022117187,
								false
								,[
								[
									0,
									[
										1,
										0.7
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.MoveToBottom,
								null,
								1655417340315429,
								false
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								3622592469668966,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										19,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								7008390052495773,
								false
								,[
								[
									4,
									19
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										2,
										"ShootWingLeft"
									]
								]
								]
							]
,							[
								19,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								5952920955744692,
								false
								,[
								[
									0,
									[
										0,
										250
									]
								]
								]
							]
,							[
								19,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								3023065887358381,
								false
								,[
								[
									4,
									2
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.RotateClockwise,
								null,
								5653738023642653,
								false
								,[
								[
									0,
									[
										0,
										90
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								5089557251578984,
								false
								,[
								[
									4,
									19
								]
,								[
									3,
									0
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetScale,
								null,
								6463851485681148,
								false
								,[
								[
									0,
									[
										1,
										0.7
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.MoveToBottom,
								null,
								5997044015769025,
								false
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								7318999010970682,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										19,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								3773270854088877,
								false
								,[
								[
									4,
									19
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										2,
										"ShootWingRight"
									]
								]
								]
							]
,							[
								19,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								477918940142661,
								false
								,[
								[
									0,
									[
										0,
										290
									]
								]
								]
							]
,							[
								19,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								5989007683849095,
								false
								,[
								[
									4,
									2
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.RotateClockwise,
								null,
								8501642536207249,
								false
								,[
								[
									0,
									[
										0,
										90
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								1725869370089104,
								false
								,[
								[
									4,
									19
								]
,								[
									3,
									0
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetScale,
								null,
								4981894280465979,
								false
								,[
								[
									0,
									[
										1,
										0.7
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.MoveToBottom,
								null,
								7868770100569513,
								false
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								4619690769637551,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										19,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								6292618208086446,
								false
								,[
								[
									4,
									19
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										2,
										"ShootWingLeft"
									]
								]
								]
							]
,							[
								19,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								315298665447662,
								false
								,[
								[
									0,
									[
										0,
										245
									]
								]
								]
							]
,							[
								19,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								3193206934744884,
								false
								,[
								[
									4,
									2
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.RotateClockwise,
								null,
								4799391165759251,
								false
								,[
								[
									0,
									[
										0,
										90
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								5964250433482795,
								false
								,[
								[
									4,
									19
								]
,								[
									3,
									0
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetScale,
								null,
								2291292239115758,
								false
								,[
								[
									0,
									[
										1,
										0.7
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.MoveToBottom,
								null,
								8129343473756536,
								false
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								4623020987930335,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										19,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
								]
							]
,							[
								0,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								6996788156101536,
								false
								,[
								[
									4,
									19
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										2,
										"ShootWingRight"
									]
								]
								]
							]
,							[
								19,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								6263329751797953,
								false
								,[
								[
									0,
									[
										0,
										295
									]
								]
								]
							]
,							[
								19,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								7184996641174081,
								false
								,[
								[
									4,
									2
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.RotateClockwise,
								null,
								5750202345171801,
								false
								,[
								[
									0,
									[
										0,
										90
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								7400726398879341,
								false
								,[
								[
									4,
									19
								]
,								[
									3,
									0
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetScale,
								null,
								9271080827799816,
								false
								,[
								[
									0,
									[
										1,
										0.7
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.MoveToBottom,
								null,
								7213191784370532,
								false
							]
,							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								3973695765267379,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										19,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1203007936935513,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8640518972813337,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							985773245131852,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									1,
									0.5
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6520646291010589,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2124704878592429,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							6037785983029084,
							false
							,[
							[
								11,
								"MONEY"
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4787607236696636,
							false
							,[
							[
								11,
								"COMBO"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.clamp
									,[
[
										4,
										[
											23,
											"COMBO"
										]
										,[
											0,
											1
										]
									]
,[
										0,
										0
									]
,[
										0,
										10
									]
									]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3406896886953391,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				8943108207716436,
				false
				,[
				[
					11,
					"GAMESTATE"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"GAMEOVER"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				1490491585454774,
				[
				[
					6,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					3249601733694217,
					false
					,[
					[
						4,
						35
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8612190273427478,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5899528242641002,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Play"
							]
						]
						]
					]
					],
					[
					[
						5,
						cr.plugins_.Audio.prototype.acts.Play,
						null,
						9332081597853589,
						false
						,[
						[
							2,
							["menu",false]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								2,
								""
							]
						]
						]
					]
,					[
						5,
						cr.plugins_.Audio.prototype.acts.Stop,
						null,
						1227754353326167,
						false
						,[
						[
							1,
							[
								2,
								"BossMusic"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6474307082014149,
						false
						,[
						[
							0,
							[
								1,
								0.3
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.GoToLayout,
						null,
						5413648856178816,
						false
						,[
						[
							6,
							"Game"
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						8226470018705159,
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
							null,
							0,
							false,
							false,
							false,
							373773597564239,
							false
							,[
							[
								1,
								[
									2,
									"PREMIUM"
								]
							]
,							[
								8,
								1
							]
,							[
								0,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							26,
							cr.plugins_.CJSAds.prototype.acts.ShowBanner,
							null,
							354263983607212,
							false
							,[
							[
								3,
								1
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6526999517008936,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4533484947841319,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Exit"
							]
						]
						]
					]
					],
					[
					[
						5,
						cr.plugins_.Audio.prototype.acts.Stop,
						null,
						4287855119031917,
						false
						,[
						[
							1,
							[
								2,
								"Music"
							]
						]
						]
					]
,					[
						5,
						cr.plugins_.Audio.prototype.acts.Stop,
						null,
						8846509215742463,
						false
						,[
						[
							1,
							[
								2,
								"BossMusic"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						5110630766358298,
						false
						,[
						[
							0,
							[
								1,
								0.3
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.GoToLayout,
						null,
						4663158516283907,
						false
						,[
						[
							6,
							"Title"
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7207930160291999,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5139703045809619,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"RateMe"
							]
						]
						]
					]
					],
					[
					[
						5,
						cr.plugins_.Audio.prototype.acts.Play,
						null,
						1363718397447109,
						false
						,[
						[
							2,
							["menu",false]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								2,
								""
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						4226980989373969,
						[
						[
							26,
							cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,
							null,
							0,
							false,
							false,
							false,
							8601096270535251,
							false
						]
						],
						[
						[
							27,
							cr.plugins_.Browser.prototype.acts.GoToURL,
							null,
							40504908114115,
							false
							,[
							[
								1,
								[
									2,
									"market://details?id=com.Navecicas.byr&write_review=true"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5018735003604438,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							9743501926028197,
							false
						]
						],
						[
						[
							27,
							cr.plugins_.Browser.prototype.acts.GoToURL,
							null,
							2799760132334937,
							false
							,[
							[
								1,
								[
									2,
									"https://play.google.com/store/apps/details?id=com.Navecicas.byr&hl=es"
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3028498469449198,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4763586534895884,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Records"
							]
						]
						]
					]
					],
					[
					[
						26,
						cr.plugins_.CJSAds.prototype.acts.socialServiceRequestLogin,
						null,
						314897817829569,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6642699184913605,
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.cnds.onSocialServiceLoginSuccess,
					null,
					1,
					false,
					false,
					false,
					3268487475385968,
					false
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7113818997399893,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2472825852545025,
						false
						,[
						[
							11,
							"GAME_MODE"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"HARDCORE"
							]
						]
						]
					]
					],
					[
					[
						26,
						cr.plugins_.CJSAds.prototype.acts.socialServiceSubmitScore,
						null,
						2312407993373517,
						false
						,[
						[
							0,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"RECORD_HARDCORE"
									]
									]
								]
								]
							]
						]
,						[
							1,
							[
								2,
								"CgkI4qyMtfwJEAIQCQ"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5346617985412406,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						2803989046564388,
						false
					]
					],
					[
					[
						26,
						cr.plugins_.CJSAds.prototype.acts.socialServiceSubmitScore,
						null,
						3701390527764517,
						false
						,[
						[
							0,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"RECORD"
									]
									]
								]
								]
							]
						]
,						[
							1,
							[
								2,
								"CgkI4qyMtfwJEAIQAA"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4396848752949245,
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitScoreSuccess,
					null,
					1,
					false,
					false,
					false,
					3641684425982515,
					false
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					720333951802618,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7880661764515417,
						false
						,[
						[
							11,
							"GAME_MODE"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"HARDCORE"
							]
						]
						]
					]
					],
					[
					[
						26,
						cr.plugins_.CJSAds.prototype.acts.socialServiceOpenLeaderboard,
						null,
						8853662302323517,
						false
						,[
						[
							1,
							[
								2,
								"CgkI4qyMtfwJEAIQCQ"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4303841423746972,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						5972664483501389,
						false
					]
					],
					[
					[
						26,
						cr.plugins_.CJSAds.prototype.acts.socialServiceOpenLeaderboard,
						null,
						4291535528032232,
						false
						,[
						[
							1,
							[
								2,
								"CgkI4qyMtfwJEAIQAA"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5189551315362779,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					8109435263981953,
					false
					,[
					[
						11,
						"GAME_MODE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"HARDCORE"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9174100588619065,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						1495895653994668,
						false
						,[
						[
							7,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"RECORD_HARDCORE"
									]
									]
								]
								]
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								23,
								"SCORE"
							]
						]
						]
					]
					],
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3264159198191194,
						false
						,[
						[
							1,
							[
								2,
								"RECORD_HARDCORE"
							]
						]
,						[
							7,
							[
								23,
								"SCORE"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6412513792824067,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					8953112431091475,
					false
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					1912887509652538,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						3840768729218584,
						false
						,[
						[
							7,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"RECORD"
									]
									]
								]
								]
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								23,
								"SCORE"
							]
						]
						]
					]
					],
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3810752272562316,
						false
						,[
						[
							1,
							[
								2,
								"RECORD"
							]
						]
,						[
							7,
							[
								23,
								"SCORE"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9943072781806984,
				[
				[
					-1,
					cr.system_object.prototype.cnds.TriggerOnce,
					null,
					0,
					false,
					false,
					false,
					5485259660338674,
					false
				]
				],
				[
				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1591174432867179,
					false
					,[
					[
						1,
						[
							2,
							"ClearScreen"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					2755569155058399,
					false
					,[
					[
						1,
						[
							2,
							"SetMedal"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3430978128053287,
					false
					,[
					[
						1,
						[
							2,
							"UpdateUI"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					18,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					41906050385077,
					false
					,[
					[
						1,
						[
							2,
							"Money"
						]
					]
,					[
						7,
						[
							4,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"Money"
									]
									]
								]
								]
							]
							,[
								23,
								"MONEY"
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					5765979120689605,
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						6999809057620215,
						false
						,[
						[
							1,
							[
								2,
								"PREMIUM"
							]
						]
,						[
							8,
							1
						]
,						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						26,
						cr.plugins_.CJSAds.prototype.acts.ShowBanner,
						null,
						3492783482176593,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2824893595170525,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				6514982309880368,
				false
				,[
				[
					11,
					"GAMESTATE"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"PAUSE"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetTimescale,
				null,
				6862573891515921,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				8,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				1695625320620242,
				false
				,[
				[
					1,
					[
						2,
						"UpdateUI"
					]
				]
,				[
					13,
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				6971508461182473,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					6592613003194046,
					false
					,[
					[
						1,
						[
							2,
							"PREMIUM"
						]
					]
,					[
						8,
						1
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.ShowBanner,
					null,
					3420373251229756,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4087029492970646,
				[
				[
					6,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					6447396655329215,
					false
					,[
					[
						4,
						35
					]
					]
				]
,				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					4451403687066773,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"PauseContinue"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4992538721071329,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						7,
						[
							23,
							"LAST_GAMESTATE"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					7998318723477743,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7181934254887891,
				[
				[
					6,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					6168728659082616,
					false
					,[
					[
						4,
						35
					]
					]
				]
,				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8086122054144184,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"PauseExit"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetTimescale,
					null,
					4023655223389152,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					7330529888720197,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						7,
						[
							2,
							"GAMEOVER"
						]
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"FUNCIONES",
		[
		[
			0,
			null,
			false,
			null,
			2233972842867642,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				8402066410633485,
				false
				,[
				[
					1,
					[
						2,
						"OnStartLayout"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8662879678253947,
				[
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					2939442396630853,
					false
					,[
					[
						2,
						["music",true]
					]
,					[
						3,
						1
					]
,					[
						0,
						[
							0,
							-10
						]
					]
,					[
						1,
						[
							2,
							"Music"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2956049062662861,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						7,
						[
							2,
							"START"
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					7662157060701755,
					false
					,[
					[
						10,
						5
					]
,					[
						7,
						[
							23,
							"SELECTED_SHIP"
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					5764226380359695,
					false
					,[
					[
						10,
						16
					]
,					[
						7,
						[
							23,
							"SELECTED_COLOR"
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetSize,
					null,
					5529778858980685,
					false
					,[
					[
						0,
						[
							0,
							32
						]
					]
,					[
						0,
						[
							0,
							32
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					431528789953676,
					false
					,[
					[
						1,
						[
							10,
							[
								21,
								0,
								true,
								null
								,5
							]
							,[
								21,
								0,
								false,
								null
								,16
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					2,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					6395698315756306,
					false
					,[
					[
						4,
						0
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8404796525866547,
					false
					,[
					[
						11,
						"TIME_LEFT_MAX"
					]
,					[
						7,
						[
							0,
							10
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					1774511923466984,
					false
					,[
					[
						11,
						"TIME_LEFT"
					]
,					[
						7,
						[
							23,
							"TIME_LEFT_MAX"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					9567529398169408,
					false
					,[
					[
						11,
						"DELAY"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					7601837623695626,
					false
					,[
					[
						11,
						"COMBO"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3190562482415501,
					false
					,[
					[
						11,
						"SCORE"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8561780611297598,
					false
					,[
					[
						11,
						"MONEY"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					5715008603343106,
					false
					,[
					[
						11,
						"DIFFICULTY"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4650466277339034,
					false
					,[
					[
						11,
						"EVERY_X_LVLs"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					5263384406931285,
					false
					,[
					[
						11,
						"EVERY_X_LVLs_Chain"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				1635997406595081,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2958787214817249,
					false
					,[
					[
						11,
						"GAME_MODE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"NORMAL"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					3395915116091043,
					false
					,[
					[
						11,
						"GAME_MODE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"HARDCORE"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					true,
					null,
					4318027208442147,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						637878966380681,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Standard"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5777198660407071,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Stork"
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1038758290969826,
						false
						,[
						[
							10,
							2
						]
,						[
							7,
							[
								0,
								160
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2947780313346214,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1042431454535076,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Option"
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3401220521046833,
						false
						,[
						[
							10,
							4
						]
,						[
							7,
							[
								0,
								3
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1211055074876675,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3038213163540575,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Standard"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6709343369986435,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							7931520248573809,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							8474167428194294,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						true,
						null,
						2714825766137229,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							7884625965095319,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1458120391175372,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6780132609059552,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									8
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5078932413105063,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						248213693280766,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Option"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						9936721958559287,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2113655497946188,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							4875998294506719,
							false
							,[
							[
								10,
								18
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							0,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							9604904110232109,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Player"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToBottom,
							null,
							369980946396175,
							false
						]
,						[
							34,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							7421805147224909,
							false
							,[
							[
								4,
								0
							]
,							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1046343592545823,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9965734352689971,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							858431864651801,
							false
							,[
							[
								10,
								14
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5354221941683419,
							false
							,[
							[
								1,
								[
									2,
									"CreateAuxShip"
								]
							]
,							[
								13,
																	[
										7,
										[
											21,
											0,
											false,
											null
											,14
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4302707653290442,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8015680295992335,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							4944751975307247,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6735962649981759,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5428181094595233,
						false
						,[
						[
							11,
							"GAME_MODE"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"HARDCORE"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7380311263136753,
						false
						,[
						[
							11,
							"DIFFICULTY"
						]
,						[
							7,
							[
								0,
								15
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3998994014178689,
						false
						,[
						[
							11,
							"TIME_LEFT_MAX"
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1896034181669549,
						false
						,[
						[
							11,
							"TIME_LEFT"
						]
,						[
							7,
							[
								23,
								"TIME_LEFT_MAX"
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						6078684481931164,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5472528648218318,
							false
							,[
							[
								10,
								5
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Standard"
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6923777792331015,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									0,
									false,
									null
									,4
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5019228808660472,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3606233000131427,
							false
							,[
							[
								10,
								5
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Option"
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							8795262537484818,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									0,
									false,
									null
									,4
								]
							]
							]
						]
,						[
							0,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							5266570207539094,
							false
							,[
							[
								10,
								14
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4218225813956472,
							false
							,[
							[
								1,
								[
									2,
									"CreateAuxShip"
								]
							]
,							[
								13,
																	[
										7,
										[
											21,
											0,
											false,
											null
											,14
										]
									]
							]
							]
						]
,						[
							0,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							3233220734372401,
							false
							,[
							[
								10,
								14
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7601877860344228,
							false
							,[
							[
								1,
								[
									2,
									"CreateAuxShip"
								]
							]
,							[
								13,
																	[
										7,
										[
											21,
											0,
											false,
											null
											,14
										]
									]
							]
							]
						]
,						[
							0,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							7429472161973317,
							false
							,[
							[
								10,
								14
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4312596126839781,
							false
							,[
							[
								1,
								[
									2,
									"CreateAuxShip"
								]
							]
,							[
								13,
																	[
										7,
										[
											21,
											0,
											false,
											null
											,14
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5976252351784548,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2990143996603568,
							false
							,[
							[
								10,
								5
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Stork"
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							5295639221021467,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									0,
									false,
									null
									,4
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			198870871150775,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				2988263913008983,
				false
				,[
				[
					1,
					[
						2,
						"Control"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				1095983122260209,
				[
				[
					8,
					cr.plugins_.Function.prototype.cnds.CompareParam,
					null,
					0,
					false,
					false,
					false,
					2133395733238989,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Idle"
						]
					]
					]
				]
				],
				[
				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					3817421076320538,
					false
					,[
					[
						1,
						[
							10,
							[
								21,
								0,
								true,
								null
								,5
							]
							,[
								21,
								0,
								false,
								null
								,16
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8507871815300996,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					1546551759873332,
					false
					,[
					[
						1,
						[
							10,
							[
								21,
								0,
								true,
								null
								,5
							]
							,[
								2,
								"Idle"
							]
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7899682207021387,
					[
					[
						-1,
						cr.system_object.prototype.cnds.PickByEvaluate,
						null,
						0,
						false,
						false,
						false,
						8006140924042306,
						false
						,[
						[
							4,
							2
						]
,						[
							0,
							[
								12,
								[
									22,
									2,
									"Pin",
									cr.behaviors.Pin.prototype.exps.PinnedUID,
									false,
									null
								]
								,[
									20,
									0,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						5427458635894067,
						false
						,[
						[
							1,
							[
								2,
								"Idle"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9667006738767059,
				[
				[
					8,
					cr.plugins_.Function.prototype.cnds.CompareParam,
					null,
					0,
					false,
					false,
					false,
					2916999835518361,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Left"
						]
					]
					]
				]
				],
				[
				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					8844547664709438,
					false
					,[
					[
						1,
						[
							10,
							[
								21,
								0,
								true,
								null
								,5
							]
							,[
								21,
								0,
								false,
								null
								,16
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4720528738166878,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					8001073085773287,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
,					[
						0,
						[
							6,
							[
								21,
								0,
								false,
								null
								,2
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					3089807634888242,
					false
					,[
					[
						1,
						[
							10,
							[
								21,
								0,
								true,
								null
								,5
							]
							,[
								2,
								"Left"
							]
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					5202393970406489,
					[
					[
						-1,
						cr.system_object.prototype.cnds.PickByEvaluate,
						null,
						0,
						false,
						false,
						false,
						5178088123678418,
						false
						,[
						[
							4,
							2
						]
,						[
							0,
							[
								12,
								[
									22,
									2,
									"Pin",
									cr.behaviors.Pin.prototype.exps.PinnedUID,
									false,
									null
								]
								,[
									20,
									0,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						1563392411058513,
						false
						,[
						[
							1,
							[
								2,
								"Left"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5304985816418801,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6014242352947713,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Stork"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4027393346936398,
						false
						,[
						[
							10,
							16
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								3
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4304478300457661,
						false
						,[
						[
							10,
							19
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										21,
										0,
										false,
										null
										,19
									]
									,[
										6,
										[
											6,
											[
												1,
												0.6
											]
											,[
												19,
												cr.system_object.prototype.exps.dt
											]
										]
										,[
											0,
											60
										]
									]
								]
,[
									0,
									250
								]
,[
									0,
									290
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5928066483004271,
				[
				[
					8,
					cr.plugins_.Function.prototype.cnds.CompareParam,
					null,
					0,
					false,
					false,
					false,
					3873331785266878,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Right"
						]
					]
					]
				]
				],
				[
				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					7792868932626914,
					false
					,[
					[
						1,
						[
							10,
							[
								21,
								0,
								true,
								null
								,5
							]
							,[
								21,
								0,
								false,
								null
								,16
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8384140341676689,
					false
					,[
					[
						0,
						[
							0,
							2
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
					null,
					7064511931209955,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							6,
							[
								21,
								0,
								false,
								null
								,2
							]
							,[
								19,
								cr.system_object.prototype.exps.dt
							]
						]
					]
					]
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					4098623460267908,
					false
					,[
					[
						1,
						[
							10,
							[
								21,
								0,
								true,
								null
								,5
							]
							,[
								2,
								"Right"
							]
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					6243370548685222,
					[
					[
						-1,
						cr.system_object.prototype.cnds.PickByEvaluate,
						null,
						0,
						false,
						false,
						false,
						9866756014099198,
						false
						,[
						[
							4,
							2
						]
,						[
							0,
							[
								12,
								[
									22,
									2,
									"Pin",
									cr.behaviors.Pin.prototype.exps.PinnedUID,
									false,
									null
								]
								,[
									20,
									0,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						2752399545442846,
						false
						,[
						[
							1,
							[
								2,
								"Right"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8536187119203607,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						186556499717004,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Stork"
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9695772166804806,
						false
						,[
						[
							10,
							16
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								3
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1980317732428399,
						false
						,[
						[
							10,
							19
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									4,
									[
										21,
										0,
										false,
										null
										,19
									]
									,[
										6,
										[
											6,
											[
												1,
												0.6
											]
											,[
												19,
												cr.system_object.prototype.exps.dt
											]
										]
										,[
											0,
											60
										]
									]
								]
,[
									0,
									250
								]
,[
									0,
									290
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8328960144471945,
				[
				[
					8,
					cr.plugins_.Function.prototype.cnds.CompareParam,
					null,
					0,
					false,
					false,
					false,
					7522189909197158,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Shoot"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					1,
					"bulletType",
					1,
					"StandardNormal",
false,false,1235064075279334,false
				]
,				[
					1,
					"bulletPiercing",
					0,
					0,
false,false,9907379246332776,false
				]
,				[
					1,
					"rotation",
					0,
					0,
false,false,6485876661755607,false
				]
,				[
					0,
					null,
					false,
					null,
					3595111530636869,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4088234695121967,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Standard"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5085408812681587,
						false
						,[
						[
							11,
							"rotation"
						]
,						[
							7,
							[
								0,
								720
							]
						]
						]
					]
					]
					,[
					[
						1,
						"ShootAngle",
						0,
						270,
false,false,3839437921841104,false
					]
,					[
						0,
						null,
						false,
						null,
						978078657509264,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8645532702798813,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.Play,
							null,
							804839128864126,
							false
							,[
							[
								2,
								["shot3",false]
							]
,							[
								3,
								0
							]
,							[
								0,
								[
									0,
									-15
								]
							]
,							[
								1,
								[
									2,
									""
								]
							]
							]
						]
,						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6957533513918289,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									21,
									0,
									false,
									null
									,1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							2971969168281445,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								2492999147213457,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
,								[
									8,
									5
								]
,								[
									7,
									[
										0,
										6
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								1312620905878256,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Player"
									]
								]
								]
							]
							],
							[
							[
								0,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								9087569437974489,
								false
								,[
								[
									10,
									8
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								596670715690018,
								false
								,[
								[
									11,
									"bulletType"
								]
,								[
									7,
									[
										2,
										"StandardBlue"
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9875050686754368,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								2891818787600134,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8305760818527621,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"Shoot1Center"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												23,
												"ShootAngle"
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4928761682311053,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								8386968759485141,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7828992958219967,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"Shoot1Left"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												23,
												"ShootAngle"
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												3,
												[
													23,
													"rotation"
												]
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8505479909988698,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"Shoot1Right"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												23,
												"ShootAngle"
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2522953318072552,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								7410479076866158,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6907995407345,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"ShootWingLeft"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												23,
												"ShootAngle"
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												3,
												[
													23,
													"rotation"
												]
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6256499524314002,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"ShootWingRight"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												23,
												"ShootAngle"
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								5551966935814221,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"Shoot1Center"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												23,
												"ShootAngle"
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							6219277978457274,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								3855875371249752,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
,								[
									8,
									5
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6493247211631881,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"Shoot1Left"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												23,
												"ShootAngle"
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												3,
												[
													23,
													"rotation"
												]
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8782733080686814,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"Shoot1Right"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												23,
												"ShootAngle"
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7561349993241117,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"Shoot1Left"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												5,
												[
													23,
													"ShootAngle"
												]
												,[
													0,
													10
												]
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												3,
												[
													23,
													"rotation"
												]
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								5719087273395988,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"Shoot1Right"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												4,
												[
													23,
													"ShootAngle"
												]
												,[
													0,
													10
												]
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3253060739114283,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								7948793717358178,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
,								[
									8,
									5
								]
,								[
									7,
									[
										0,
										8
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								5908484121146984,
								[
								[
									0,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									6609468642048018,
									false
									,[
									[
										10,
										5
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Standard"
										]
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									5841272825459815,
									[
									[
										0,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										3117629508694732,
										false
										,[
										[
											10,
											16
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												0,
												3
											]
										]
										]
									]
									],
									[
									[
										8,
										cr.plugins_.Function.prototype.acts.CallFunction,
										null,
										729904296188107,
										false
										,[
										[
											1,
											[
												2,
												"Shoot"
											]
										]
,										[
											13,
																							[
													7,
													[
														20,
														0,
														cr.plugins_.Sprite.prototype.exps.UID,
														false,
														null
													]
												]
,
												[
													7,
													[
														2,
														"ShootCenterLow"
													]
												]
,
												[
													7,
													[
														2,
														"Player"
													]
												]
,
												[
													7,
													[
														0,
														270
													]
												]
,
												[
													7,
													[
														23,
														"bulletType"
													]
												]
,
												[
													7,
													[
														23,
														"bulletPiercing"
													]
												]
										]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8086231316264882,
							[
							[
								0,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								1801833523169537,
								false
								,[
								[
									10,
									12
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								0,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								4352359979378028,
								false
								,[
								[
									10,
									12
								]
,								[
									7,
									[
										21,
										0,
										false,
										null
										,13
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								1895740686821933,
								[
								[
									8,
									cr.plugins_.Function.prototype.cnds.CompareParam,
									null,
									0,
									false,
									false,
									false,
									5472354529365605,
									false
									,[
									[
										0,
										[
											0,
											1
										]
									]
,									[
										8,
										5
									]
,									[
										7,
										[
											0,
											4
										]
									]
									]
								]
								],
								[
								[
									0,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									7041820920907125,
									false
									,[
									[
										4,
										19
									]
,									[
										5,
										[
											2,
											"Shoots"
										]
									]
,									[
										7,
										[
											2,
											"ShootWingLeft"
										]
									]
									]
								]
,								[
									19,
									cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
									"Bullet",
									4242454259443668,
									false
									,[
									[
										0,
										[
											0,
											268
										]
									]
									]
								]
,								[
									19,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									2576405463667385,
									false
									,[
									[
										4,
										2
									]
,									[
										5,
										[
											2,
											"Shoots"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.RotateClockwise,
									null,
									4756306157110657,
									false
									,[
									[
										0,
										[
											0,
											90
										]
									]
									]
								]
,								[
									2,
									cr.behaviors.Pin.prototype.acts.Pin,
									"Pin",
									2414097904291437,
									false
									,[
									[
										4,
										19
									]
,									[
										3,
										0
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.SetScale,
									null,
									3559539476453649,
									false
									,[
									[
										0,
										[
											1,
											0.7
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
									null,
									3960027874527574,
									false
									,[
									[
										3,
										1
									]
,									[
										4,
										19
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									7822533349112237,
									false
									,[
									[
										10,
										0
									]
,									[
										7,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								6892726507277529,
								[
								[
									8,
									cr.plugins_.Function.prototype.cnds.CompareParam,
									null,
									0,
									false,
									false,
									false,
									4607613523974751,
									false
									,[
									[
										0,
										[
											0,
											1
										]
									]
,									[
										8,
										5
									]
,									[
										7,
										[
											0,
											5
										]
									]
									]
								]
								],
								[
								[
									0,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									881210589031178,
									false
									,[
									[
										4,
										19
									]
,									[
										5,
										[
											2,
											"Shoots"
										]
									]
,									[
										7,
										[
											2,
											"ShootWingRight"
										]
									]
									]
								]
,								[
									19,
									cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
									"Bullet",
									4737930486845047,
									false
									,[
									[
										0,
										[
											0,
											272
										]
									]
									]
								]
,								[
									19,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8318361880173381,
									false
									,[
									[
										4,
										2
									]
,									[
										5,
										[
											2,
											"Shoots"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.RotateClockwise,
									null,
									9704207547760451,
									false
									,[
									[
										0,
										[
											0,
											90
										]
									]
									]
								]
,								[
									2,
									cr.behaviors.Pin.prototype.acts.Pin,
									"Pin",
									6641574115930846,
									false
									,[
									[
										4,
										19
									]
,									[
										3,
										0
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.SetScale,
									null,
									7025274725853256,
									false
									,[
									[
										0,
										[
											1,
											0.7
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
									null,
									2166808401759508,
									false
									,[
									[
										3,
										1
									]
,									[
										4,
										19
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									4579404391861016,
									false
									,[
									[
										10,
										0
									]
,									[
										7,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								87851483504539,
								[
								[
									8,
									cr.plugins_.Function.prototype.cnds.CompareParam,
									null,
									0,
									false,
									false,
									false,
									5641018936298805,
									false
									,[
									[
										0,
										[
											0,
											1
										]
									]
,									[
										8,
										5
									]
,									[
										7,
										[
											0,
											7
										]
									]
									]
								]
								],
								[
								[
									0,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									9799895679955174,
									false
									,[
									[
										10,
										12
									]
,									[
										7,
										[
											7,
											[
												21,
												0,
												false,
												null
												,13
											]
											,[
												0,
												2
											]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								5374273413165335,
								[
								[
									8,
									cr.plugins_.Function.prototype.cnds.CompareParam,
									null,
									0,
									false,
									false,
									false,
									5786600549471102,
									false
									,[
									[
										0,
										[
											0,
											1
										]
									]
,									[
										8,
										5
									]
,									[
										7,
										[
											0,
											8
										]
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									3841526816136549,
									[
									[
										0,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										9414521420016601,
										false
										,[
										[
											10,
											5
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"Standard"
											]
										]
										]
									]
									],
									[
									]
									,[
									[
										0,
										null,
										false,
										null,
										9947782470067871,
										[
										[
											0,
											cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
											null,
											0,
											false,
											false,
											false,
											7004940103509167,
											false
											,[
											[
												10,
												16
											]
,											[
												8,
												0
											]
,											[
												7,
												[
													0,
													1
												]
											]
											]
										]
										],
										[
										[
											0,
											cr.plugins_.Sprite.prototype.acts.Spawn,
											null,
											2279568199918529,
											false
											,[
											[
												4,
												19
											]
,											[
												5,
												[
													2,
													"Shoots"
												]
											]
,											[
												7,
												[
													2,
													"Shoot1Center"
												]
											]
											]
										]
,										[
											19,
											cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
											"Bullet",
											6129289338643544,
											false
											,[
											[
												0,
												[
													0,
													267
												]
											]
											]
										]
,										[
											19,
											cr.plugins_.Sprite.prototype.acts.Spawn,
											null,
											9266873244240807,
											false
											,[
											[
												4,
												2
											]
,											[
												5,
												[
													2,
													"Shoots"
												]
											]
,											[
												7,
												[
													0,
													0
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Sprite.prototype.acts.RotateClockwise,
											null,
											6968225083980143,
											false
											,[
											[
												0,
												[
													0,
													90
												]
											]
											]
										]
,										[
											2,
											cr.behaviors.Pin.prototype.acts.Pin,
											"Pin",
											8235436169105265,
											false
											,[
											[
												4,
												19
											]
,											[
												3,
												0
											]
											]
										]
,										[
											2,
											cr.plugins_.Sprite.prototype.acts.SetScale,
											null,
											4895027869004581,
											false
											,[
											[
												0,
												[
													1,
													0.7
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
											null,
											1743520418730893,
											false
											,[
											[
												3,
												1
											]
,											[
												4,
												19
											]
											]
										]
,										[
											2,
											cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
											null,
											4259578740021397,
											false
											,[
											[
												10,
												0
											]
,											[
												7,
												[
													20,
													19,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
											]
										]
,										[
											0,
											cr.plugins_.Sprite.prototype.acts.Spawn,
											null,
											5271553593598068,
											false
											,[
											[
												4,
												19
											]
,											[
												5,
												[
													2,
													"Shoots"
												]
											]
,											[
												7,
												[
													2,
													"Shoot1Center"
												]
											]
											]
										]
,										[
											19,
											cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
											"Bullet",
											5083750259781541,
											false
											,[
											[
												0,
												[
													0,
													273
												]
											]
											]
										]
,										[
											19,
											cr.plugins_.Sprite.prototype.acts.Spawn,
											null,
											116862442771477,
											false
											,[
											[
												4,
												2
											]
,											[
												5,
												[
													2,
													"Shoots"
												]
											]
,											[
												7,
												[
													0,
													0
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Sprite.prototype.acts.RotateClockwise,
											null,
											8502781106189181,
											false
											,[
											[
												0,
												[
													0,
													90
												]
											]
											]
										]
,										[
											2,
											cr.behaviors.Pin.prototype.acts.Pin,
											"Pin",
											8921240676876779,
											false
											,[
											[
												4,
												19
											]
,											[
												3,
												0
											]
											]
										]
,										[
											2,
											cr.plugins_.Sprite.prototype.acts.SetScale,
											null,
											6339747532737626,
											false
											,[
											[
												0,
												[
													1,
													0.7
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
											null,
											1872132992842919,
											false
											,[
											[
												3,
												1
											]
,											[
												4,
												19
											]
											]
										]
,										[
											2,
											cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
											null,
											6693739332314464,
											false
											,[
											[
												10,
												0
											]
,											[
												7,
												[
													20,
													19,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					827209376286395,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3044907776732161,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Option"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6807463577749468,
						false
						,[
						[
							11,
							"bulletType"
						]
,						[
							7,
							[
								2,
								"OptionNormal"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9218883743343401,
						false
						,[
						[
							11,
							"bulletPiercing"
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						29619179968298,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							3763633514555604,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								5
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5692020877605972,
							false
							,[
							[
								11,
								"bulletType"
							]
,							[
								7,
								[
									2,
									"OptionRed"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7730178500092024,
							false
							,[
							[
								11,
								"bulletPiercing"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7139248860615892,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							4910680820680991,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								5
							]
,							[
								7,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7408680546482387,
							false
							,[
							[
								11,
								"bulletType"
							]
,							[
								7,
								[
									2,
									"OptionRed"
								]
							]
							]
						]
,						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2138504883803069,
							false
							,[
							[
								10,
								1
							]
,							[
								7,
								[
									0,
									7
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7352975967965368,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6450728062278281,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.Play,
							null,
							6332266679703268,
							false
							,[
							[
								2,
								["shot3",false]
							]
,							[
								3,
								0
							]
,							[
								0,
								[
									0,
									-15
								]
							]
,							[
								1,
								[
									2,
									""
								]
							]
							]
						]
,						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							8418134978150003,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									21,
									0,
									false,
									null
									,1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							6232355712532085,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								5379910892873937,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
,								[
									8,
									2
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3334018794364749,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"Shoot1Center"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												0,
												270
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4818416337457042,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								2452856391169118,
								false
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8259654580555659,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"Shoot1Center"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												0,
												270
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								9120266668589504,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"ShootWingLeft"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												0,
												270
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								1117518038289133,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"ShootWingRight"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												0,
												270
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4271175181471235,
						[
						[
							28,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							4852146473158637,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							8816033877431465,
							[
							[
								28,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7989852423591285,
								false
								,[
								[
									10,
									1
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								28,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								320186262067975,
								false
								,[
								[
									10,
									1
								]
,								[
									7,
									[
										21,
										28,
										false,
										null
										,2
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								452691975101349,
								[
								[
									28,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									4974901827249904,
									false
									,[
									[
										10,
										3
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									8478218968037126,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													28,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Shoot1Center"
												]
											]
,
											[
												7,
												[
													2,
													"Player"
												]
											]
,
											[
												7,
												[
													0,
													270
												]
											]
,
											[
												7,
												[
													23,
													"bulletType"
												]
											]
,
											[
												7,
												[
													23,
													"bulletPiercing"
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								7626453608374959,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Else,
									null,
									0,
									false,
									false,
									false,
									9707834173842437,
									false
								]
								],
								[
								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									8777455287571852,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													28,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Left"
												]
											]
,
											[
												7,
												[
													2,
													"Player"
												]
											]
,
											[
												7,
												[
													0,
													270
												]
											]
,
											[
												7,
												[
													23,
													"bulletType"
												]
											]
,
											[
												7,
												[
													23,
													"bulletPiercing"
												]
											]
									]
									]
								]
,								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									2303830010980068,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													28,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Right"
												]
											]
,
											[
												7,
												[
													2,
													"Player"
												]
											]
,
											[
												7,
												[
													0,
													270
												]
											]
,
											[
												7,
												[
													23,
													"bulletType"
												]
											]
,
											[
												7,
												[
													23,
													"bulletPiercing"
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5390377894390175,
						[
						[
							28,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8980927121139729,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							321944517163355,
							[
							[
								28,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								8777784109452722,
								false
								,[
								[
									10,
									1
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								28,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								266432530518577,
								false
								,[
								[
									10,
									1
								]
,								[
									7,
									[
										21,
										28,
										false,
										null
										,2
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								8843611945828465,
								[
								[
									28,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									401916484932397,
									false
									,[
									[
										10,
										3
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									2863995073971741,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													28,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Shoot1Center"
												]
											]
,
											[
												7,
												[
													2,
													"Player"
												]
											]
,
											[
												7,
												[
													0,
													270
												]
											]
,
											[
												7,
												[
													23,
													"bulletType"
												]
											]
,
											[
												7,
												[
													23,
													"bulletPiercing"
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								2739577881550511,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Else,
									null,
									0,
									false,
									false,
									false,
									7316834303728885,
									false
								]
								],
								[
								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									6435682137305501,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													28,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Left"
												]
											]
,
											[
												7,
												[
													2,
													"Player"
												]
											]
,
											[
												7,
												[
													0,
													270
												]
											]
,
											[
												7,
												[
													23,
													"bulletType"
												]
											]
,
											[
												7,
												[
													23,
													"bulletPiercing"
												]
											]
									]
									]
								]
,								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									6577325348543207,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													28,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Right"
												]
											]
,
											[
												7,
												[
													2,
													"Player"
												]
											]
,
											[
												7,
												[
													0,
													270
												]
											]
,
											[
												7,
												[
													23,
													"bulletType"
												]
											]
,
											[
												7,
												[
													23,
													"bulletPiercing"
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5124374284162119,
						[
						[
							28,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9579806016475205,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7676743431509376,
							[
							[
								28,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								295524259973709,
								false
								,[
								[
									10,
									1
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								28,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								7234085493617059,
								false
								,[
								[
									10,
									1
								]
,								[
									7,
									[
										21,
										28,
										false,
										null
										,2
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								985015058438014,
								[
								[
									28,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									3843797448615101,
									false
									,[
									[
										10,
										3
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									1070864724418085,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													28,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Shoot1Center"
												]
											]
,
											[
												7,
												[
													2,
													"Player"
												]
											]
,
											[
												7,
												[
													0,
													270
												]
											]
,
											[
												7,
												[
													23,
													"bulletType"
												]
											]
,
											[
												7,
												[
													23,
													"bulletPiercing"
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								398179061932017,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Else,
									null,
									0,
									false,
									false,
									false,
									2880699281480504,
									false
								]
								],
								[
								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									6352601782015878,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													28,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Left"
												]
											]
,
											[
												7,
												[
													2,
													"Player"
												]
											]
,
											[
												7,
												[
													0,
													265
												]
											]
,
											[
												7,
												[
													23,
													"bulletType"
												]
											]
,
											[
												7,
												[
													23,
													"bulletPiercing"
												]
											]
									]
									]
								]
,								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									758839833664122,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													28,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Right"
												]
											]
,
											[
												7,
												[
													2,
													"Player"
												]
											]
,
											[
												7,
												[
													0,
													275
												]
											]
,
											[
												7,
												[
													23,
													"bulletType"
												]
											]
,
											[
												7,
												[
													23,
													"bulletPiercing"
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5485644763908594,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1512954289890375,
						false
						,[
						[
							10,
							5
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Stork"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1838086960697305,
						false
						,[
						[
							11,
							"bulletType"
						]
,						[
							7,
							[
								2,
								"StorkNormal"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						271360233390092,
						false
						,[
						[
							11,
							"rotation"
						]
,						[
							7,
							[
								0,
								720
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3764049546682083,
						false
						,[
						[
							11,
							"bulletPiercing"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						8256408736429951,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3450643585026687,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.Play,
							null,
							1397091593124895,
							false
							,[
							[
								2,
								["shot3",false]
							]
,							[
								3,
								0
							]
,							[
								0,
								[
									0,
									-15
								]
							]
,							[
								1,
								[
									2,
									""
								]
							]
							]
						]
,						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							9864948878341705,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									21,
									0,
									false,
									null
									,1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							9068323524245023,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								9407004541379889,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
,								[
									8,
									2
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								807074618591087,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"ShootCenter"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												21,
												0,
												false,
												null
												,19
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4779054869383001,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								1861032661155819,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
,								[
									8,
									5
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7402140333403489,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"ShootCenter"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												21,
												0,
												false,
												null
												,19
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3693225014392303,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"ShootCenter"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												4,
												[
													21,
													0,
													false,
													null
													,19
												]
												,[
													0,
													10
												]
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
,
										[
											7,
											[
												1,
												-0.55
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								1409630097169781,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"ShootCenter"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												5,
												[
													21,
													0,
													false,
													null
													,19
												]
												,[
													0,
													10
												]
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
,
										[
											7,
											[
												1,
												0.55
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4080915784316553,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								6881294348265752,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
,								[
									8,
									5
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								2589743334350246,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"ShootCenter"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												4,
												[
													21,
													0,
													false,
													null
													,19
												]
												,[
													0,
													19
												]
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
,
										[
											7,
											[
												1,
												-0.5
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7223066089101538,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												2,
												"ShootCenter"
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												5,
												[
													21,
													0,
													false,
													null
													,19
												]
												,[
													0,
													19
												]
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
,
										[
											7,
											[
												1,
												0.5
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5728841857859524,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								9811261299781185,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
,								[
									8,
									5
								]
,								[
									7,
									[
										0,
										6
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								9769822150440454,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												0,
												0
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												5,
												[
													21,
													0,
													false,
													null
													,19
												]
												,[
													0,
													20
												]
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
,
										[
											7,
											[
												1,
												-2.2
											]
										]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								1638312927227988,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												0,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												0,
												0
											]
										]
,
										[
											7,
											[
												2,
												"Player"
											]
										]
,
										[
											7,
											[
												4,
												[
													21,
													0,
													false,
													null
													,19
												]
												,[
													0,
													20
												]
											]
										]
,
										[
											7,
											[
												23,
												"bulletType"
											]
										]
,
										[
											7,
											[
												23,
												"bulletPiercing"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												23,
												"rotation"
											]
										]
,
										[
											7,
											[
												1,
												2.2
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3607325330934066,
							[
							[
								0,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								9673672274195736,
								false
								,[
								[
									10,
									12
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								0,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								8492536980240604,
								false
								,[
								[
									10,
									12
								]
,								[
									7,
									[
										6,
										[
											21,
											0,
											false,
											null
											,13
										]
										,[
											1,
											1.5
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								1837933979508289,
								[
								[
									8,
									cr.plugins_.Function.prototype.cnds.CompareParam,
									null,
									0,
									false,
									false,
									false,
									9914272210610908,
									false
									,[
									[
										0,
										[
											0,
											1
										]
									]
,									[
										8,
										5
									]
,									[
										7,
										[
											0,
											3
										]
									]
									]
								]
,								[
									8,
									cr.plugins_.Function.prototype.cnds.CompareParam,
									null,
									0,
									false,
									false,
									false,
									1774289993584028,
									false
									,[
									[
										0,
										[
											0,
											1
										]
									]
,									[
										8,
										2
									]
,									[
										7,
										[
											0,
											4
										]
									]
									]
								]
								],
								[
								[
									0,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									4306464671019606,
									false
									,[
									[
										4,
										19
									]
,									[
										5,
										[
											2,
											"Shoots"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									19,
									cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
									"Bullet",
									287697172260057,
									false
									,[
									[
										0,
										[
											0,
											270
										]
									]
									]
								]
,								[
									19,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									9765004823209025,
									false
									,[
									[
										4,
										2
									]
,									[
										5,
										[
											2,
											"Shoots"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.RotateClockwise,
									null,
									6630939398093951,
									false
									,[
									[
										0,
										[
											0,
											90
										]
									]
									]
								]
,								[
									2,
									cr.behaviors.Pin.prototype.acts.Pin,
									"Pin",
									928028430819754,
									false
									,[
									[
										4,
										19
									]
,									[
										3,
										0
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.SetScale,
									null,
									83557208890457,
									false
									,[
									[
										0,
										[
											1,
											0.7
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
									null,
									7953909427120191,
									false
									,[
									[
										3,
										1
									]
,									[
										4,
										19
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									1696799840903052,
									false
									,[
									[
										10,
										0
									]
,									[
										7,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								5031862069733807,
								[
								[
									8,
									cr.plugins_.Function.prototype.cnds.CompareParam,
									null,
									0,
									false,
									false,
									false,
									3140024651653126,
									false
									,[
									[
										0,
										[
											0,
											1
										]
									]
,									[
										8,
										5
									]
,									[
										7,
										[
											0,
											4
										]
									]
									]
								]
								],
								[
								[
									0,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									6932120087631606,
									false
									,[
									[
										4,
										19
									]
,									[
										5,
										[
											2,
											"Shoots"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									19,
									cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
									"Bullet",
									6254165147840309,
									false
									,[
									[
										0,
										[
											0,
											255
										]
									]
									]
								]
,								[
									19,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									1852343192713749,
									false
									,[
									[
										4,
										2
									]
,									[
										5,
										[
											2,
											"Shoots"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.RotateClockwise,
									null,
									358915876046959,
									false
									,[
									[
										0,
										[
											0,
											90
										]
									]
									]
								]
,								[
									2,
									cr.behaviors.Pin.prototype.acts.Pin,
									"Pin",
									2479578295177781,
									false
									,[
									[
										4,
										19
									]
,									[
										3,
										0
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.SetScale,
									null,
									1802080513490089,
									false
									,[
									[
										0,
										[
											1,
											0.7
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.MoveToBottom,
									null,
									4666082753561372,
									false
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									744124434657468,
									false
									,[
									[
										10,
										0
									]
,									[
										7,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
									]
								]
,								[
									0,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									6172634241260789,
									false
									,[
									[
										4,
										19
									]
,									[
										5,
										[
											2,
											"Shoots"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									19,
									cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
									"Bullet",
									9671266768555976,
									false
									,[
									[
										0,
										[
											0,
											285
										]
									]
									]
								]
,								[
									19,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									6683064008851109,
									false
									,[
									[
										4,
										2
									]
,									[
										5,
										[
											2,
											"Shoots"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.RotateClockwise,
									null,
									6102737544206231,
									false
									,[
									[
										0,
										[
											0,
											90
										]
									]
									]
								]
,								[
									2,
									cr.behaviors.Pin.prototype.acts.Pin,
									"Pin",
									5507792869760131,
									false
									,[
									[
										4,
										19
									]
,									[
										3,
										0
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.SetScale,
									null,
									6114634719894991,
									false
									,[
									[
										0,
										[
											1,
											0.7
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
									null,
									6942976335371905,
									false
									,[
									[
										3,
										1
									]
,									[
										4,
										19
									]
									]
								]
,								[
									2,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									6178349319806963,
									false
									,[
									[
										10,
										0
									]
,									[
										7,
										[
											20,
											19,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								1344230177783508,
								[
								[
									8,
									cr.plugins_.Function.prototype.cnds.CompareParam,
									null,
									0,
									false,
									false,
									false,
									9796850273218297,
									false
									,[
									[
										0,
										[
											0,
											1
										]
									]
,									[
										8,
										5
									]
,									[
										7,
										[
											0,
											5
										]
									]
									]
								]
								],
								[
								[
									0,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									2362588890576969,
									false
									,[
									[
										10,
										12
									]
,									[
										7,
										[
											7,
											[
												21,
												0,
												false,
												null
												,13
											]
											,[
												1,
												1.5
											]
										]
									]
									]
								]
,								[
									0,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									3264795460628562,
									false
									,[
									[
										10,
										1
									]
,									[
										7,
										[
											0,
											9
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								3211632421748479,
								[
								[
									8,
									cr.plugins_.Function.prototype.cnds.CompareParam,
									null,
									0,
									false,
									false,
									false,
									4164534472141142,
									false
									,[
									[
										0,
										[
											0,
											1
										]
									]
,									[
										8,
										5
									]
,									[
										7,
										[
											0,
											7
										]
									]
									]
								]
								],
								[
								[
									0,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									4479303945114252,
									false
									,[
									[
										10,
										12
									]
,									[
										7,
										[
											7,
											[
												21,
												0,
												false,
												null
												,13
											]
											,[
												0,
												2
											]
										]
									]
									]
								]
,								[
									0,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									1637835081636323,
									false
									,[
									[
										10,
										1
									]
,									[
										7,
										[
											0,
											8
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7789394042688916,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				5975274775470119,
				false
				,[
				[
					1,
					[
						2,
						"MoveBG"
					]
				]
				]
			]
			],
			[
			[
				3,
				cr.plugins_.Sprite.prototype.acts.MoveAtAngle,
				null,
				4093023514831925,
				false
				,[
				[
					0,
					[
						0,
						90
					]
				]
,				[
					0,
					[
						6,
						[
							0,
							60
						]
						,[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				2384343337109236,
				[
				[
					3,
					cr.plugins_.Sprite.prototype.cnds.CompareY,
					null,
					0,
					false,
					false,
					false,
					4729398637895724,
					false
					,[
					[
						8,
						5
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps.layoutheight
						]
					]
					]
				]
				],
				[
				[
					3,
					cr.plugins_.Sprite.prototype.acts.SetY,
					null,
					5897751551419341,
					false
					,[
					[
						0,
						[
							5,
							[
								20,
								3,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
							,[
								6,
								[
									19,
									cr.system_object.prototype.exps.layoutheight
								]
								,[
									0,
									2
								]
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					6074249034308471,
					[
					[
						3,
						cr.plugins_.Sprite.prototype.cnds.IsMirrored,
						null,
						0,
						false,
						false,
						false,
						2997081996160013,
						false
					]
					],
					[
					[
						3,
						cr.plugins_.Sprite.prototype.acts.SetMirrored,
						null,
						5375820769859957,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9456248603335455,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						2215807203316357,
						false
					]
					],
					[
					[
						3,
						cr.plugins_.Sprite.prototype.acts.SetMirrored,
						null,
						1161468364740742,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2407172782127502,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				3383862688495981,
				false
				,[
				[
					1,
					[
						2,
						"MoveEnemy"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6603457891793101,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					4909603938540324,
					false
					,[
					[
						4,
						7
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					2590543517595033,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
						null,
						0,
						false,
						false,
						false,
						2791131192566086,
						false
					]
					],
					[
					[
						7,
						cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
						null,
						4752838007674883,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								6,
								[
									0,
									60
								]
								,[
									19,
									cr.system_object.prototype.exps.dt
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
						null,
						8428174535234947,
						false
						,[
						[
							10,
							13
						]
,						[
							7,
							[
								6,
								[
									0,
									60
								]
								,[
									19,
									cr.system_object.prototype.exps.dt
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					575306114554812,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.IsOutsideLayout,
						null,
						0,
						false,
						false,
						false,
						7641890476204377,
						false
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3870286429605635,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								2,
								"Ready"
							]
						]
						]
					]
					],
					[
					[
						7,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						2214209920426644,
						false
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						5902189722383794,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							3432124247777242,
							false
							,[
							[
								1,
								[
									2,
									"Rock"
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
							null,
							0,
							false,
							true,
							false,
							2265579069023267,
							false
							,[
							[
								10,
								20
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							4828824457286983,
							false
							,[
							[
								11,
								"DIFFICULTY"
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									25
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4533359972723311,
							false
							,[
							[
								11,
								"COMBO"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7236668937778783,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.IsOutsideLayout,
						null,
						0,
						false,
						true,
						false,
						2275050888740923,
						false
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6195866513578862,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Ready"
							]
						]
						]
					]
					],
					[
					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7674458955457355,
						false
						,[
						[
							10,
							2
						]
,						[
							7,
							[
								2,
								"OnScreen"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					525626047159617,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						581854106005548,
						false
						,[
						[
							10,
							11
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Juggernaut"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1791260264944165,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							220327683179104,
							false
							,[
							[
								10,
								13
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetEnabled,
							"Bullet",
							4006184988849888,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5485815092389717,
							[
							[
								-1,
								cr.system_object.prototype.cnds.PickByEvaluate,
								null,
								0,
								false,
								false,
								false,
								6120341335759388,
								false
								,[
								[
									4,
									2
								]
,								[
									0,
									[
										12,
										[
											22,
											2,
											"Pin",
											cr.behaviors.Pin.prototype.exps.PinnedUID,
											false,
											null
										]
										,[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6894273811924987,
								false
								,[
								[
									1,
									[
										2,
										"IdleLow"
									]
								]
,								[
									3,
									0
								]
								]
							]
							]
						]
						]
					]
,					[
						1,
						"randomShoot",
						0,
						0,
false,false,2389611450897806,false
					]
,					[
						0,
						null,
						false,
						null,
						6962112307487111,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5870563967218687,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9409476544586816,
							false
							,[
							[
								10,
								13
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7904882089490387,
							false
							,[
							[
								11,
								"randomShoot"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											-5
										]
,[
											0,
											0
										]
										]
									]
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							4402672938247191,
							[
							[
								-1,
								cr.system_object.prototype.cnds.For,
								null,
								0,
								true,
								false,
								false,
								4290934595597303,
								false
								,[
								[
									1,
									[
										2,
										""
									]
								]
,								[
									0,
									[
										0,
										1
									]
								]
,								[
									0,
									[
										21,
										7,
										false,
										null
										,5
									]
								]
								]
							]
							],
							[
							[
								7,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								4037606075388316,
								false
								,[
								[
									10,
									3
								]
,								[
									7,
									[
										21,
										7,
										false,
										null
										,4
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								9192771543524799,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												0,
												0
											]
										]
,
										[
											7,
											[
												2,
												"Enemy"
											]
										]
,
										[
											7,
											[
												4,
												[
													4,
													[
														0,
														60
													]
													,[
														6,
														[
															7,
															[
																0,
																60
															]
															,[
																21,
																7,
																false,
																null
																,5
															]
														]
														,[
															19,
															cr.system_object.prototype.exps.loopindex
														]
													]
												]
												,[
													23,
													"randomShoot"
												]
											]
										]
,
										[
											7,
											[
												2,
												"Enemy"
											]
										]
,
										[
											7,
											[
												0,
												0
											]
										]
,
										[
											7,
											[
												21,
												7,
												false,
												null
												,12
											]
										]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1294328298923428,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2643840600206583,
						false
						,[
						[
							10,
							11
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"PiranhaKing"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						3917830965991915,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8780646974519975,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareY,
							null,
							0,
							false,
							false,
							false,
							6056218065781804,
							false
							,[
							[
								8,
								2
							]
,							[
								0,
								[
									0,
									260
								]
							]
							]
						]
						],
						[
						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3536643556188064,
							false
							,[
							[
								1,
								[
									2,
									"LoadEnemyType"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"Piranha"
										]
									]
,
									[
										7,
										[
											2,
											"King"
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.clamp
											,[
[
												4,
												[
													0,
													2
												]
												,[
													7,
													[
														23,
														"DIFFICULTY"
													]
													,[
														0,
														4
													]
												]
											]
,[
												0,
												0
											]
,[
												0,
												6
											]
											]
										]
									]
,
									[
										7,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,
									[
										7,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							8525735691634762,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									7,
									false,
									null
									,4
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3968024911762154,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8873703030662506,
						false
						,[
						[
							10,
							11
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Delta"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5415503589237075,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							803450966837469,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							7180199629480626,
							false
							,[
							[
								10,
								5
							]
,							[
								8,
								4
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareY,
							null,
							0,
							false,
							false,
							false,
							9589841173539406,
							false
							,[
							[
								8,
								2
							]
,							[
								0,
								[
									0,
									270
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							1638972232506845,
							false
							,[
							[
								10,
								5
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2388086803069462,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									7,
									false,
									null
									,4
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							1897847206370602,
							[
							[
								7,
								cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
								null,
								0,
								false,
								false,
								false,
								3170716952768519,
								false
								,[
								[
									10,
									7
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								4074670765497403,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												0,
												0
											]
										]
,
										[
											7,
											[
												2,
												"Enemy"
											]
										]
,
										[
											7,
											[
												19,
												cr.system_object.prototype.exps.angle
												,[
[
													20,
													7,
													cr.plugins_.Sprite.prototype.exps.X,
													false,
													null
												]
,[
													20,
													7,
													cr.plugins_.Sprite.prototype.exps.Y,
													false,
													null
												]
,[
													20,
													0,
													cr.plugins_.Sprite.prototype.exps.X,
													false,
													null
												]
,[
													20,
													0,
													cr.plugins_.Sprite.prototype.exps.Y,
													false,
													null
												]
												]
											]
										]
,
										[
											7,
											[
												2,
												"Enemy"
											]
										]
,
										[
											7,
											[
												0,
												0
											]
										]
,
										[
											7,
											[
												21,
												7,
												false,
												null
												,12
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5149979144630093,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								9409333707061585,
								false
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								4936543991684273,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
,
										[
											7,
											[
												0,
												0
											]
										]
,
										[
											7,
											[
												2,
												"Enemy"
											]
										]
,
										[
											7,
											[
												0,
												90
											]
										]
,
										[
											7,
											[
												2,
												"Enemy"
											]
										]
,
										[
											7,
											[
												0,
												0
											]
										]
,
										[
											7,
											[
												21,
												7,
												false,
												null
												,12
											]
										]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9213661274894662,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1225645866871511,
						false
						,[
						[
							10,
							11
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Piranha"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4944051398613746,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
							null,
							0,
							false,
							false,
							false,
							8083364659813626,
							false
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.RotateTowardAngle,
							null,
							8824519426693696,
							false
							,[
							[
								0,
								[
									6,
									[
										6,
										[
											19,
											cr.system_object.prototype.exps.dt
										]
										,[
											0,
											60
										]
									]
									,[
										21,
										7,
										false,
										null
										,15
									]
								]
							]
,							[
								0,
								[
									19,
									cr.system_object.prototype.exps.angle
									,[
[
										20,
										7,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
,[
										20,
										7,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
,[
										20,
										0,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
,[
										20,
										0,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							7159475472092284,
							false
							,[
							[
								0,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.Angle,
									false,
									null
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6131781199917583,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8489094722721173,
						false
						,[
						[
							10,
							11
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Wind"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						8983201683807065,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1202118862869742,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5801544038965869,
							false
							,[
							[
								10,
								5
							]
,							[
								8,
								4
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							4032410302230844,
							false
							,[
							[
								10,
								5
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2785492726075955,
							false
							,[
							[
								1,
								[
									2,
									"Shoot"
								]
							]
,							[
								13,
																	[
										7,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
,
									[
										7,
										[
											0,
											0
										]
									]
,
									[
										7,
										[
											2,
											"Enemy"
										]
									]
,
									[
										7,
										[
											0,
											90
										]
									]
,
									[
										7,
										[
											2,
											"Enemy"
										]
									]
,
									[
										7,
										[
											0,
											0
										]
									]
,
									[
										7,
										[
											21,
											7,
											false,
											null
											,12
										]
									]
							]
							]
						]
,						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4085506030421294,
							false
							,[
							[
								1,
								[
									2,
									"Shoot"
								]
							]
,							[
								13,
																	[
										7,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
,
									[
										7,
										[
											0,
											0
										]
									]
,
									[
										7,
										[
											2,
											"Enemy"
										]
									]
,
									[
										7,
										[
											5,
											[
												0,
												80
											]
											,[
												6,
												[
													21,
													7,
													false,
													null
													,5
												]
												,[
													0,
													7
												]
											]
										]
									]
,
									[
										7,
										[
											2,
											"Enemy"
										]
									]
,
									[
										7,
										[
											0,
											0
										]
									]
,
									[
										7,
										[
											21,
											7,
											false,
											null
											,12
										]
									]
							]
							]
						]
,						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4226017941621298,
							false
							,[
							[
								1,
								[
									2,
									"Shoot"
								]
							]
,							[
								13,
																	[
										7,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
,
									[
										7,
										[
											0,
											0
										]
									]
,
									[
										7,
										[
											2,
											"Enemy"
										]
									]
,
									[
										7,
										[
											4,
											[
												0,
												100
											]
											,[
												6,
												[
													21,
													7,
													false,
													null
													,5
												]
												,[
													0,
													7
												]
											]
										]
									]
,
									[
										7,
										[
											2,
											"Enemy"
										]
									]
,
									[
										7,
										[
											0,
											0
										]
									]
,
									[
										7,
										[
											21,
											7,
											false,
											null
											,12
										]
									]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2119795606894254,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									7,
									[
										21,
										7,
										false,
										null
										,4
									]
									,[
										0,
										7
									]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2486767575141251,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3259976539357846,
						false
						,[
						[
							10,
							11
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Ray"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1121051386722752,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6496080362959076,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9929495266366884,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Move"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetEnabled,
							"Bullet",
							5911549646988321,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							691708775299104,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									7,
									false,
									null
									,4
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							3694645743863728,
							[
							[
								-1,
								cr.system_object.prototype.cnds.PickByEvaluate,
								null,
								0,
								false,
								false,
								false,
								8499144934751424,
								false
								,[
								[
									4,
									25
								]
,								[
									0,
									[
										12,
										[
											21,
											25,
											false,
											null
											,0
										]
										,[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
								]
								]
							]
							],
							[
							[
								25,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								5057110650317367,
								false
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2322027444551498,
							[
							[
								7,
								cr.plugins_.Sprite.prototype.cnds.CompareY,
								null,
								0,
								false,
								false,
								false,
								3892426171591924,
								false
								,[
								[
									8,
									2
								]
,								[
									0,
									[
										0,
										270
									]
								]
								]
							]
							],
							[
							[
								7,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								9649426216662887,
								false
								,[
								[
									10,
									16
								]
,								[
									7,
									[
										2,
										"Charge"
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2541643465887075,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3190799425115269,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							7908612283409117,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Charge"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetEnabled,
							"Bullet",
							869624865094838,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2814741833328381,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									7,
									[
										21,
										7,
										false,
										null
										,4
									]
									,[
										0,
										2
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							4501123397334474,
							false
							,[
							[
								10,
								16
							]
,							[
								7,
								[
									2,
									"Shoot"
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							9489332483390509,
							false
							,[
							[
								4,
								25
							]
,							[
								5,
								[
									2,
									"Shoots"
								]
							]
,							[
								7,
								[
									2,
									"Shoot"
								]
							]
							]
						]
,						[
							25,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							3007815448182191,
							false
							,[
							[
								4,
								7
							]
,							[
								3,
								0
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5249016696541895,
							[
							[
								7,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								4210751860222473,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								25,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								3561297529825296,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										7,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
								]
							]
,							[
								25,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2710661067053426,
								false
								,[
								[
									1,
									[
										2,
										"Charge"
									]
								]
,								[
									3,
									0
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2223154506197147,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5291700965683698,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							7634866797860357,
							false
							,[
							[
								10,
								16
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Shoot"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							9787791426947759,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									7,
									[
										21,
										7,
										false,
										null
										,4
									]
									,[
										1,
										1.5
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							1394674511865118,
							false
							,[
							[
								10,
								16
							]
,							[
								7,
								[
									2,
									"Move"
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							6649845179428953,
							[
							[
								-1,
								cr.system_object.prototype.cnds.PickByEvaluate,
								null,
								0,
								false,
								false,
								false,
								406410570324065,
								false
								,[
								[
									4,
									25
								]
,								[
									0,
									[
										12,
										[
											21,
											25,
											false,
											null
											,0
										]
										,[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
								]
								]
							]
							],
							[
							[
								25,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4952568448406714,
								false
								,[
								[
									1,
									[
										2,
										"Shoot"
									]
								]
,								[
									3,
									0
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3003412015754578,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1627169370230053,
						false
						,[
						[
							10,
							11
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Phalanx"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7866696234797591,
						[
						[
							-1,
							cr.system_object.prototype.cnds.ForEach,
							null,
							0,
							true,
							false,
							false,
							6709264938271607,
							false
							,[
							[
								4,
								7
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							6474883376046335,
							[
							[
								7,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								8108296385370901,
								false
								,[
								[
									10,
									13
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								7,
								cr.plugins_.Sprite.prototype.cnds.CompareY,
								null,
								0,
								false,
								false,
								false,
								4578928358686468,
								false
								,[
								[
									8,
									2
								]
,								[
									0,
									[
										0,
										300
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3357300600308116,
								[
								[
									7,
									cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
									null,
									0,
									false,
									false,
									false,
									4750636665016091,
									false
									,[
									[
										1,
										[
											2,
											"PhalanxBlock"
										]
									]
									]
								]
								],
								[
								[
									7,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									2960867094194623,
									false
									,[
									[
										1,
										[
											2,
											"Phalanx"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									7,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									7237584756398099,
									false
									,[
									[
										10,
										17
									]
,									[
										7,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.AnimationName,
											true,
											null
										]
									]
									]
								]
,								[
									7,
									cr.behaviors.Bullet.prototype.acts.SetEnabled,
									"Bullet",
									5005388000650986,
									false
									,[
									[
										3,
										0
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								1349096773783603,
								[
								[
									7,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									8463244029028779,
									false
									,[
									[
										10,
										3
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									73453011733561,
									[
									[
										7,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										2246256508116127,
										false
										,[
										[
											10,
											5
										]
,										[
											8,
											4
										]
,										[
											7,
											[
												0,
												0
											]
										]
										]
									]
									],
									[
									[
										7,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										970558915489084,
										false
										,[
										[
											10,
											3
										]
,										[
											7,
											[
												21,
												7,
												false,
												null
												,4
											]
										]
										]
									]
,									[
										7,
										cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
										null,
										3212096026896191,
										false
										,[
										[
											10,
											5
										]
,										[
											7,
											[
												0,
												1
											]
										]
										]
									]
,									[
										8,
										cr.plugins_.Function.prototype.acts.CallFunction,
										null,
										1031284100902086,
										false
										,[
										[
											1,
											[
												2,
												"Shoot"
											]
										]
,										[
											13,
																							[
													7,
													[
														20,
														7,
														cr.plugins_.Sprite.prototype.exps.UID,
														false,
														null
													]
												]
,
												[
													7,
													[
														2,
														"ShootLeft"
													]
												]
,
												[
													7,
													[
														2,
														"Enemy"
													]
												]
,
												[
													7,
													[
														0,
														65
													]
												]
,
												[
													7,
													[
														2,
														"Enemy"
													]
												]
,
												[
													7,
													[
														0,
														0
													]
												]
,
												[
													7,
													[
														21,
														7,
														false,
														null
														,12
													]
												]
										]
										]
									]
,									[
										8,
										cr.plugins_.Function.prototype.acts.CallFunction,
										null,
										1968140918397254,
										false
										,[
										[
											1,
											[
												2,
												"Shoot"
											]
										]
,										[
											13,
																							[
													7,
													[
														20,
														7,
														cr.plugins_.Sprite.prototype.exps.UID,
														false,
														null
													]
												]
,
												[
													7,
													[
														2,
														"ShootRight"
													]
												]
,
												[
													7,
													[
														2,
														"Enemy"
													]
												]
,
												[
													7,
													[
														0,
														115
													]
												]
,
												[
													7,
													[
														2,
														"Enemy"
													]
												]
,
												[
													7,
													[
														0,
														0
													]
												]
,
												[
													7,
													[
														21,
														7,
														false,
														null
														,12
													]
												]
										]
										]
									]
									]
								]
,								[
									0,
									null,
									false,
									null,
									2851793754847657,
									[
									[
										-1,
										cr.system_object.prototype.cnds.Else,
										null,
										0,
										false,
										false,
										false,
										5748592734999574,
										false
									]
									],
									[
									[
										7,
										cr.behaviors.Bullet.prototype.acts.SetEnabled,
										"Bullet",
										9870542100028533,
										false
										,[
										[
											3,
											1
										]
										]
									]
,									[
										7,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										1174114969960598,
										false
										,[
										[
											10,
											3
										]
,										[
											7,
											[
												21,
												7,
												false,
												null
												,4
											]
										]
										]
									]
,									[
										7,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										138591905711433,
										false
										,[
										[
											10,
											5
										]
,										[
											7,
											[
												21,
												7,
												false,
												null
												,6
											]
										]
										]
									]
,									[
										7,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										9151174922514586,
										false
										,[
										[
											10,
											13
										]
,										[
											7,
											[
												21,
												7,
												false,
												null
												,14
											]
										]
										]
									]
,									[
										7,
										cr.plugins_.Sprite.prototype.acts.SetAnim,
										null,
										3721320696450678,
										false
										,[
										[
											1,
											[
												2,
												"PhalanxBlock"
											]
										]
,										[
											3,
											1
										]
										]
									]
,									[
										7,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										4632771185512608,
										false
										,[
										[
											10,
											17
										]
,										[
											7,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.AnimationName,
												true,
												null
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9007949408965542,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8063026831208959,
						false
						,[
						[
							10,
							11
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Rock2"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1225263516926011,
						[
						],
						[
						]
					]
,					[
						0,
						null,
						false,
						null,
						4339999686921515,
						[
						[
							-1,
							cr.system_object.prototype.cnds.ForEach,
							null,
							0,
							true,
							false,
							false,
							9573032008785069,
							false
							,[
							[
								4,
								7
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							8431079501145203,
							[
							[
								7,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								1838614976710055,
								false
								,[
								[
									10,
									13
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								1032477459338938,
								[
								[
									7,
									cr.plugins_.Sprite.prototype.cnds.CompareFrame,
									null,
									0,
									false,
									false,
									false,
									34783081538366,
									false
									,[
									[
										8,
										0
									]
,									[
										0,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									7,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									7618031307811155,
									false
									,[
									[
										1,
										[
											21,
											7,
											true,
											null
											,17
										]
									]
,									[
										3,
										0
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								6442603260597938,
								[
								[
									7,
									cr.plugins_.Sprite.prototype.cnds.CompareFrame,
									null,
									0,
									false,
									false,
									false,
									3169666418928695,
									false
									,[
									[
										8,
										0
									]
,									[
										0,
										[
											5,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.AnimationFrameCount,
												false,
												null
											]
											,[
												0,
												1
											]
										]
									]
									]
								]
,								[
									7,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									7652859150680227,
									false
									,[
									[
										10,
										3
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									7998801724031315,
									[
									[
										7,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										5081264424866952,
										false
										,[
										[
											10,
											5
										]
,										[
											8,
											4
										]
,										[
											7,
											[
												0,
												0
											]
										]
										]
									]
,									[
										7,
										cr.plugins_.Sprite.prototype.cnds.CompareY,
										null,
										0,
										false,
										false,
										false,
										7507754808798772,
										false
										,[
										[
											8,
											2
										]
,										[
											0,
											[
												0,
												300
											]
										]
										]
									]
									],
									[
									[
										7,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										2568257495563112,
										false
										,[
										[
											10,
											3
										]
,										[
											7,
											[
												21,
												7,
												false,
												null
												,4
											]
										]
										]
									]
,									[
										7,
										cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
										null,
										1086746351355116,
										false
										,[
										[
											10,
											5
										]
,										[
											7,
											[
												0,
												1
											]
										]
										]
									]
,									[
										8,
										cr.plugins_.Function.prototype.acts.CallFunction,
										null,
										4545117774290682,
										false
										,[
										[
											1,
											[
												2,
												"Shoot"
											]
										]
,										[
											13,
																							[
													7,
													[
														20,
														7,
														cr.plugins_.Sprite.prototype.exps.UID,
														false,
														null
													]
												]
,
												[
													7,
													[
														0,
														0
													]
												]
,
												[
													7,
													[
														2,
														"Enemy"
													]
												]
,
												[
													7,
													[
														4,
														[
															19,
															cr.system_object.prototype.exps.angle
															,[
[
																20,
																7,
																cr.plugins_.Sprite.prototype.exps.X,
																false,
																null
															]
,[
																20,
																7,
																cr.plugins_.Sprite.prototype.exps.Y,
																false,
																null
															]
,[
																20,
																0,
																cr.plugins_.Sprite.prototype.exps.X,
																false,
																null
															]
,[
																20,
																0,
																cr.plugins_.Sprite.prototype.exps.Y,
																false,
																null
															]
															]
														]
														,[
															19,
															cr.system_object.prototype.exps.random
															,[
[
																5,
																[
																	0,
																	10
																]
																,[
																	7,
																	[
																		23,
																		"DIFFICULTY"
																	]
																	,[
																		0,
																		5
																	]
																]
															]
															]
														]
													]
												]
,
												[
													7,
													[
														2,
														"Enemy"
													]
												]
,
												[
													7,
													[
														0,
														0
													]
												]
,
												[
													7,
													[
														21,
														7,
														false,
														null
														,12
													]
												]
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4320097125210399,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				9648872678203697,
				false
				,[
				[
					1,
					[
						2,
						"EnemyHurts"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6584193681382397,
				[
				[
					4,
					cr.plugins_.Sprite.prototype.cnds.PickByUID,
					null,
					0,
					false,
					false,
					true,
					7456981000012909,
					false
					,[
					[
						0,
						[
							20,
							8,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								1
							]
							]
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5214959511590844,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						9356728018297368,
						false
						,[
						[
							7,
							[
								20,
								10,
								cr.plugins_.Particles.prototype.exps.Count,
								false,
								null
							]
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
					],
					[
					[
						4,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						7480333875330801,
						false
						,[
						[
							4,
							10
						]
,						[
							5,
							[
								2,
								"Shoots"
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						10,
						cr.plugins_.Particles.prototype.acts.SetAngle,
						null,
						7404050467976781,
						false
						,[
						[
							0,
							[
								0,
								90
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2346311175533352,
					[
					[
						4,
						cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
						null,
						0,
						false,
						true,
						false,
						913139933760367,
						false
						,[
						[
							10,
							1
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2536396717024514,
						false
						,[
						[
							1,
							[
								2,
								"StoreBullet"
							]
						]
,						[
							13,
															[
									7,
									[
										20,
										4,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7106530554863048,
				[
				[
					19,
					cr.plugins_.Sprite.prototype.cnds.PickByUID,
					null,
					0,
					false,
					false,
					true,
					6820091073617617,
					false
					,[
					[
						0,
						[
							20,
							8,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								1
							]
							]
						]
					]
					]
				]
				],
				[
				[
					19,
					cr.plugins_.Sprite.prototype.acts.Spawn,
					null,
					9727159033286102,
					false
					,[
					[
						4,
						10
					]
,					[
						5,
						[
							2,
							"Shoots"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					10,
					cr.plugins_.Particles.prototype.acts.SetAngle,
					null,
					7390319612091453,
					false
					,[
					[
						0,
						[
							5,
							[
								20,
								19,
								cr.plugins_.Sprite.prototype.exps.Angle,
								false,
								null
							]
							,[
								0,
								180
							]
						]
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2344087456973033,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7138821023174985,
					[
					[
						2,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8805838324636999,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								20,
								19,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						9594083120842172,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				29567832038426,
				[
				[
					38,
					cr.plugins_.Sprite.prototype.cnds.PickByUID,
					null,
					0,
					false,
					false,
					true,
					2324846869954737,
					false
					,[
					[
						0,
						[
							20,
							8,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8414807372928291,
					[
					[
						38,
						cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
						null,
						0,
						false,
						false,
						false,
						4542002090939512,
						false
						,[
						[
							10,
							9
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						true,
						null,
						5077187925862405,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6037529962068667,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							7246229999829277,
							false
							,[
							[
								11,
								"BOSS_HP"
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.Play,
							null,
							5635668679876309,
							false
							,[
							[
								2,
								["clinck",false]
							]
,							[
								3,
								0
							]
,							[
								0,
								[
									0,
									-15
								]
							]
,							[
								1,
								[
									2,
									""
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1728682138732265,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							1710958368790277,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							9857994088703107,
							false
							,[
							[
								11,
								"BOSS_HP"
							]
,							[
								7,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										2
									]
									]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2077753693619218,
				[
				[
					7,
					cr.plugins_.Sprite.prototype.cnds.PickByUID,
					null,
					0,
					false,
					false,
					true,
					7304116318727793,
					false
					,[
					[
						0,
						[
							20,
							8,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6571651415910134,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2477933100057643,
						false
						,[
						[
							10,
							11
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Phalanx"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						8073730134743746,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							4513430438754189,
							false
							,[
							[
								1,
								[
									2,
									"Phalanx"
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.cnds.CompareFrame,
							null,
							0,
							false,
							false,
							false,
							6786688902942127,
							false
							,[
							[
								8,
								0
							]
,							[
								0,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							4044907156808274,
							false
							,[
							[
								1,
								[
									10,
									[
										21,
										7,
										true,
										null
										,17
									]
									,[
										2,
										"RED"
									]
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							4462336725301952,
							false
							,[
							[
								10,
								18
							]
,							[
								7,
								[
									21,
									7,
									false,
									null
									,19
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							3635280930327857,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										2
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7914362564946352,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							864378872397495,
							false
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							8900652712277515,
							[
							[
								7,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								9269563009083056,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								5,
								cr.plugins_.Audio.prototype.acts.Play,
								null,
								843627251396702,
								false
								,[
								[
									2,
									["clinck",false]
								]
,								[
									3,
									0
								]
,								[
									0,
									[
										0,
										-15
									]
								]
,								[
									1,
									[
										2,
										""
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5127564216688663,
							[
							[
								4,
								cr.plugins_.Sprite.prototype.cnds.PickByUID,
								null,
								0,
								false,
								false,
								true,
								1432601288635661,
								false
								,[
								[
									0,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								2195071475279133,
								false
								,[
								[
									1,
									[
										2,
										"StoreBullet"
									]
								]
,								[
									13,
																			[
											7,
											[
												20,
												4,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9424674580819108,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						2854546933238374,
						false
					]
					],
					[
					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						4822678773633692,
						false
						,[
						[
							1,
							[
								10,
								[
									21,
									7,
									true,
									null
									,17
								]
								,[
									2,
									"RED"
								]
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						2211763991918985,
						false
						,[
						[
							10,
							18
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,19
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
						null,
						5578379273986052,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									2
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					1,
					"RND",
					0,
					0,
false,false,9545656400702814,false
				]
,				[
					0,
					null,
					false,
					null,
					8456458650879112,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7512611562567432,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						2652858810034132,
						[
						[
							2,
							cr.behaviors.Pin.prototype.cnds.IsPinned,
							"Pin",
							0,
							false,
							false,
							false,
							5276533120062393,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							3553094276858211,
							false
							,[
							[
								7,
								[
									22,
									2,
									"Pin",
									cr.behaviors.Pin.prototype.exps.PinnedUID,
									false,
									null
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									20,
									7,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							416365883020033,
							false
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7795283093111184,
						[
						[
							-1,
							cr.system_object.prototype.cnds.PickByEvaluate,
							null,
							0,
							false,
							false,
							false,
							4866730674965964,
							false
							,[
							[
								4,
								25
							]
,							[
								0,
								[
									12,
									[
										21,
										25,
										false,
										null
										,0
									]
									,[
										20,
										7,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
							]
							]
						]
						],
						[
						[
							25,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6548782900846804,
							false
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7688993171599857,
						[
						[
							-1,
							cr.system_object.prototype.cnds.PickByEvaluate,
							null,
							0,
							false,
							false,
							false,
							9207955608411795,
							false
							,[
							[
								4,
								25
							]
,							[
								0,
								[
									12,
									[
										21,
										25,
										false,
										null
										,0
									]
									,[
										0,
										0
									]
								]
							]
							]
						]
						],
						[
						[
							25,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							4384199461307422,
							false
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2864046582018175,
						[
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							6493248488348523,
							false
							,[
							[
								4,
								11
							]
,							[
								5,
								[
									2,
									"Shoots"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							7579143238499251,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											360
										]
										]
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.AddVar,
							null,
							3086118903924149,
							false
							,[
							[
								11,
								"SCORE"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										6,
										[
											21,
											7,
											false,
											null
											,8
										]
										,[
											4,
											[
												23,
												"COMBO"
											]
											,[
												0,
												1
											]
										]
									]
									]
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7451418318754702,
							false
							,[
							[
								11,
								"COMBO"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.clamp
									,[
[
										4,
										[
											23,
											"COMBO"
										]
										,[
											1,
											0.1
										]
									]
,[
										0,
										0
									]
,[
										0,
										10
									]
									]
								]
							]
							]
						]
,						[
							5,
							cr.plugins_.Audio.prototype.acts.Play,
							null,
							8672236387899367,
							false
							,[
							[
								2,
								["explo",false]
							]
,							[
								3,
								0
							]
,							[
								0,
								[
									0,
									-15
								]
							]
,							[
								1,
								[
									2,
									""
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							8521108490802469,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8909477067217083,
							false
							,[
							[
								11,
								"RND"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										100
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						true,
						null,
						9817224959356291,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							2912373308492087,
							false
							,[
							[
								11,
								"GAME_MODE"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"NORMAL"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1266607144244489,
							false
							,[
							[
								11,
								"GAME_MODE"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"HARDCORE"
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							1,
							"TotalPowerUP",
							0,
							0,
false,false,2452236543464385,false
						]
,						[
							0,
							null,
							false,
							null,
							4125960553763435,
							[
							[
								0,
								cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
								null,
								0,
								false,
								false,
								false,
								1518002278329545,
								false
								,[
								[
									10,
									17
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								565039588626628,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									2586441682150467,
									false
									,[
									[
										11,
										"RND"
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											7,
											[
												21,
												7,
												false,
												null
												,9
											]
											,[
												0,
												2
											]
										]
									]
									]
								]
								],
								[
								[
									7,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8491339283339445,
									false
									,[
									[
										4,
										13
									]
,									[
										5,
										[
											2,
											"BG"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									13,
									cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
									"Bullet",
									3016719377670213,
									false
									,[
									[
										0,
										[
											0,
											90
										]
									]
									]
								]
,								[
									13,
									cr.plugins_.Sprite.prototype.acts.SetAngle,
									null,
									934644730840591,
									false
									,[
									[
										0,
										[
											0,
											0
										]
									]
									]
								]
,								[
									13,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									3454315000494252,
									false
									,[
									[
										10,
										0
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												2,
												"ExtraScore"
											]
,[
												2,
												"ExtraScore"
											]
,[
												2,
												"ExtraScore"
											]
,[
												2,
												"ExtraScore"
											]
,[
												2,
												"ExtraScore"
											]
,[
												2,
												"ExtraScore"
											]
,[
												2,
												"ExtraScore"
											]
,[
												2,
												"ExtraScore"
											]
,[
												2,
												"ExtraScore"
											]
,[
												2,
												"Bomb"
											]
											]
										]
									]
									]
								]
,								[
									13,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									9928620687412909,
									false
									,[
									[
										1,
										[
											21,
											13,
											true,
											null
											,0
										]
									]
,									[
										3,
										1
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								8484276122707595,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Else,
									null,
									0,
									false,
									false,
									false,
									519087717708392,
									false
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									7533170527364458,
									[
									[
										-1,
										cr.system_object.prototype.cnds.CompareVar,
										null,
										0,
										false,
										false,
										false,
										7587755206228528,
										false
										,[
										[
											11,
											"RND"
										]
,										[
											8,
											3
										]
,										[
											7,
											[
												21,
												7,
												false,
												null
												,10
											]
										]
										]
									]
									],
									[
									[
										7,
										cr.plugins_.Sprite.prototype.acts.Spawn,
										null,
										3422199864121974,
										false
										,[
										[
											4,
											14
										]
,										[
											5,
											[
												2,
												"BG"
											]
										]
,										[
											7,
											[
												0,
												0
											]
										]
										]
									]
,									[
										14,
										cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
										"Bullet",
										4406881679163098,
										false
										,[
										[
											0,
											[
												0,
												90
											]
										]
										]
									]
,									[
										14,
										cr.plugins_.Sprite.prototype.acts.SetAngle,
										null,
										554311499511823,
										false
										,[
										[
											0,
											[
												0,
												0
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							6939402871681468,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								9625539112577964,
								false
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8242781059585036,
								false
								,[
								[
									11,
									"TotalPowerUP"
								]
,								[
									7,
									[
										4,
										[
											21,
											0,
											false,
											null
											,3
										]
										,[
											21,
											0,
											false,
											null
											,14
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								1805940609693351,
								[
								[
									-1,
									cr.system_object.prototype.cnds.ForEach,
									null,
									0,
									true,
									false,
									false,
									1482981950449788,
									false
									,[
									[
										4,
										28
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.AddVar,
									null,
									9322241088053217,
									false
									,[
									[
										11,
										"TotalPowerUP"
									]
,									[
										7,
										[
											21,
											28,
											false,
											null
											,3
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								5175313962867571,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									5846505297429747,
									false
									,[
									[
										11,
										"TotalPowerUP"
									]
,									[
										8,
										2
									]
,									[
										7,
										[
											7,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												2
											]
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									1063751604157471,
									false
									,[
									[
										11,
										"RND"
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											6,
											[
												21,
												7,
												false,
												null
												,9
											]
											,[
												1,
												1.5
											]
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.cnds.Compare,
									null,
									0,
									false,
									false,
									false,
									416874369082502,
									false
									,[
									[
										7,
										[
											20,
											13,
											cr.plugins_.Sprite.prototype.exps.Count,
											false,
											null
										]
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									7,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									784032669219602,
									false
									,[
									[
										4,
										13
									]
,									[
										5,
										[
											2,
											"BG"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									13,
									cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
									"Bullet",
									6432832317348447,
									false
									,[
									[
										0,
										[
											0,
											90
										]
									]
									]
								]
,								[
									13,
									cr.plugins_.Sprite.prototype.acts.SetAngle,
									null,
									17639373570201,
									false
									,[
									[
										0,
										[
											0,
											0
										]
									]
									]
								]
,								[
									13,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									3985587389387436,
									false
									,[
									[
										10,
										0
									]
,									[
										7,
										[
											2,
											"PowerUP"
										]
									]
									]
								]
,								[
									13,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									8976849347544811,
									false
									,[
									[
										1,
										[
											21,
											13,
											true,
											null
											,0
										]
									]
,									[
										3,
										1
									]
									]
								]
								]
								,[
								[
									0,
									null,
									false,
									null,
									8949060942679166,
									[
									[
										0,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										5598465360685133,
										false
										,[
										[
											10,
											5
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"Option"
											]
										]
										]
									]
,									[
										0,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										6795194314816085,
										false
										,[
										[
											10,
											14
										]
,										[
											8,
											2
										]
,										[
											7,
											[
												0,
												3
											]
										]
										]
									]
									],
									[
									[
										13,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										7014962850129647,
										false
										,[
										[
											10,
											0
										]
,										[
											7,
											[
												19,
												cr.system_object.prototype.exps.choose
												,[
[
													2,
													"PowerUP"
												]
,[
													2,
													"ExtraOption"
												]
												]
											]
										]
										]
									]
,									[
										13,
										cr.plugins_.Sprite.prototype.acts.SetAnim,
										null,
										7049482203390039,
										false
										,[
										[
											1,
											[
												21,
												13,
												true,
												null
												,0
											]
										]
,										[
											3,
											1
										]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								7449661206299261,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Else,
									null,
									0,
									false,
									false,
									false,
									8884407364510299,
									false
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									9047788573884016,
									[
									[
										-1,
										cr.system_object.prototype.cnds.CompareVar,
										null,
										0,
										false,
										false,
										false,
										2540359650145755,
										false
										,[
										[
											11,
											"RND"
										]
,										[
											8,
											3
										]
,										[
											7,
											[
												21,
												7,
												false,
												null
												,10
											]
										]
										]
									]
									],
									[
									[
										7,
										cr.plugins_.Sprite.prototype.acts.Spawn,
										null,
										7698657369207939,
										false
										,[
										[
											4,
											14
										]
,										[
											5,
											[
												2,
												"BG"
											]
										]
,										[
											7,
											[
												0,
												0
											]
										]
										]
									]
,									[
										14,
										cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
										"Bullet",
										8182908304991934,
										false
										,[
										[
											0,
											[
												0,
												90
											]
										]
										]
									]
,									[
										14,
										cr.plugins_.Sprite.prototype.acts.SetAngle,
										null,
										7053867575167961,
										false
										,[
										[
											0,
											[
												0,
												0
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8124882752192815,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				1184145583045926,
				false
				,[
				[
					1,
					[
						2,
						"PlayerHurts"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7019215813624943,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8024458613258314,
					false
					,[
					[
						10,
						18
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					0,
					cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
					null,
					7318871584044248,
					false
					,[
					[
						10,
						18
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7028493584972429,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1371376005745054,
						false
						,[
						[
							10,
							18
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						5,
						cr.plugins_.Audio.prototype.acts.Play,
						null,
						7918334076649792,
						false
						,[
						[
							2,
							["shielddown",false]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								-15
							]
						]
,						[
							1,
							[
								2,
								""
							]
						]
						]
					]
,					[
						34,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						7975130066742501,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8502420604536367,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					7573390996588349,
					false
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5288085628789187,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8301039462269632,
						false
						,[
						[
							10,
							6
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
						null,
						3652998623036365,
						false
						,[
						[
							10,
							6
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						2932154598569473,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										21,
										0,
										false,
										null
										,3
									]
									,[
										0,
										1
									]
								]
,[
									0,
									0
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5987200484379113,
						false
						,[
						[
							11,
							"GAMESTATE"
						]
,						[
							7,
							[
								2,
								"START"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1926042696348731,
						false
						,[
						[
							11,
							"COMBO"
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9774309725511216,
						false
						,[
						[
							11,
							"DIFFICULTY"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										2
									]
								]
,[
									0,
									0
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						41,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6872122458114497,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						72213749875243,
						false
						,[
						[
							1,
							[
								2,
								"Idle"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1824261118519197,
						false
						,[
						[
							0,
							[
								21,
								0,
								false,
								null
								,10
							]
						]
,						[
							0,
							[
								21,
								0,
								false,
								null
								,11
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3846918935199494,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						746488459976732,
						false
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						3056005602796176,
						false
						,[
						[
							4,
							11
						]
,						[
							5,
							[
								2,
								"Player"
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						8160572998921034,
						false
						,[
						[
							4,
							12
						]
,						[
							5,
							[
								2,
								"Player"
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						4171208027574997,
						false
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetTimescale,
						null,
						1169085196251591,
						false
						,[
						[
							0,
							[
								1,
								0.5
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6743923332290245,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetTimescale,
						null,
						8474193443736513,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4634826666424195,
						false
						,[
						[
							11,
							"GAMESTATE"
						]
,						[
							7,
							[
								2,
								"GAMEOVER"
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2136540831139846,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				7128452870330577,
				false
				,[
				[
					1,
					[
						2,
						"UpdateUI"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4748904888115717,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7851992826208276,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"START"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					4162753586345702,
					false
					,[
					[
						5,
						[
							2,
							"UIGameOver"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					5022552488911309,
					false
					,[
					[
						5,
						[
							2,
							"UIPauseMenu"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					8373474898645642,
					false
					,[
					[
						5,
						[
							2,
							"UIStart"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					3528096416910509,
					false
					,[
					[
						5,
						[
							2,
							"BG"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					5042132696299906,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					2194600844020518,
					false
					,[
					[
						5,
						[
							2,
							"Shop"
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					true,
					null,
					7864057996559062,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6953945873534602,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"TouchLeft"
							]
						]
						]
					]
,					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7213036602351641,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"TouchRight"
							]
						]
						]
					]
,					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5151566074178381,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"TouchPause"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7096367528678787,
						[
						[
							26,
							cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,
							null,
							0,
							false,
							false,
							false,
							4570652199746983,
							false
						]
						],
						[
						[
							15,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							9727849147549863,
							false
							,[
							[
								7,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										10,
										[
											20,
											18,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"LANG"
											]
											]
										]
										,[
											21,
											15,
											true,
											null
											,0
										]
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8281571910949283,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							4803061947952028,
							false
						]
						],
						[
						[
							15,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							5349502510784825,
							false
							,[
							[
								7,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										10,
										[
											10,
											[
												20,
												18,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"LANG"
												]
												]
											]
											,[
												21,
												15,
												true,
												null
												,0
											]
										]
										,[
											2,
											"PC"
										]
									]
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							4048407271413929,
							[
							[
								15,
								cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								6278717467683926,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"TouchPause"
									]
								]
								]
							]
							],
							[
							[
								15,
								cr.plugins_.Spritefont2.prototype.acts.Destroy,
								null,
								761445450973735,
								false
							]
,							[
								33,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								2859014443320215,
								false
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4516347302125569,
					[
					[
						-1,
						cr.system_object.prototype.cnds.PickByEvaluate,
						null,
						0,
						false,
						false,
						false,
						8713565097925806,
						false
						,[
						[
							4,
							30
						]
,						[
							0,
							[
								12,
								[
									20,
									30,
									cr.plugins_.Sprite.prototype.exps.LayerName,
									true,
									null
								]
								,[
									2,
									"UIStart"
								]
							]
						]
						]
					]
					],
					[
					[
						30,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						5825586061398872,
						false
						,[
						[
							1,
							[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"Start"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7691736099188281,
					[
					[
						-1,
						cr.system_object.prototype.cnds.PickByEvaluate,
						null,
						0,
						false,
						false,
						false,
						8132561233718642,
						false
						,[
						[
							4,
							30
						]
,						[
							0,
							[
								12,
								[
									20,
									30,
									cr.plugins_.Sprite.prototype.exps.LayerName,
									true,
									null
								]
								,[
									2,
									"UIPauseMenu"
								]
							]
						]
						]
					]
					],
					[
					[
						30,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						6386530707542141,
						false
						,[
						[
							1,
							[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"Pause"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5363466215731543,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7108998806448454,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"PauseText"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						7820558244714396,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"PAUSE"
									]
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7911822716530762,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8488582919513329,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"PauseContinue"
							]
						]
						]
					]
					],
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						378187942700056,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Continue"
									]
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4970472690299107,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3597371072978438,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"PauseExit"
							]
						]
						]
					]
					],
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						9074504882544321,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Exit"
									]
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8913873085498975,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5788445511484567,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Lives"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						4657353726114169,
						false
						,[
						[
							7,
							[
								10,
								[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											10,
											[
												20,
												18,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"LANG"
												]
												]
											]
											,[
												2,
												"Level"
											]
										]
										]
									]
									,[
										2,
										" "
									]
								]
								,[
									23,
									"DIFFICULTY"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6123283765180048,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8146963204872486,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Score"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						1432250217380481,
						false
						,[
						[
							7,
							[
								23,
								"SCORE"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7096522729841836,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3656486938947996,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"ScoreTxt"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						8810694698398997,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Score"
									]
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1209558914260121,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4690379148416274,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Bonus"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						54341853317727,
						false
						,[
						[
							7,
							[
								10,
								[
									2,
									"x"
								]
								,[
									23,
									"COMBO"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7617022700745112,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7137259324258175,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Hi-Score"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						639285546206007,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							846103357387971,
							false
							,[
							[
								11,
								"GAME_MODE"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"HARDCORE"
								]
							]
							]
						]
						],
						[
						[
							15,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							1877061103608299,
							false
							,[
							[
								7,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"RECORD_HARDCORE"
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						583363081222008,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							973135949398719,
							false
						]
						],
						[
						[
							15,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							517933034022219,
							false
							,[
							[
								7,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"RECORD"
									]
									]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2880795019841454,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1972119458954422,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Hi-ScoreTxt"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						4420731467842037,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Record"
									]
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6016848792981812,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5276361081740831,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Money"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						3496797802456214,
						false
						,[
						[
							7,
							[
								23,
								"MONEY"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				2541109509997089,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					691534333043427,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"PLAY"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1802748693216931,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"BOSS"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					8753934941781583,
					false
					,[
					[
						5,
						[
							2,
							"UIGameOver"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					1399772640606444,
					false
					,[
					[
						5,
						[
							2,
							"UIPauseMenu"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					8537823197832277,
					false
					,[
					[
						5,
						[
							2,
							"UIStart"
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					1376068022915901,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5918492535021847,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Lives"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						4145679749817788,
						false
						,[
						[
							7,
							[
								10,
								[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											10,
											[
												20,
												18,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"LANG"
												]
												]
											]
											,[
												2,
												"Level"
											]
										]
										]
									]
									,[
										2,
										" "
									]
								]
								,[
									23,
									"DIFFICULTY"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1924636861229571,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7423794873597628,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Score"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						1865221610026589,
						false
						,[
						[
							7,
							[
								23,
								"SCORE"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2832024846571245,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8831956285048916,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Bonus"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						5026152223992102,
						false
						,[
						[
							7,
							[
								10,
								[
									2,
									"x"
								]
								,[
									23,
									"COMBO"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2501287330190431,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5264053762759208,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Money"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						7545086654444579,
						false
						,[
						[
							7,
							[
								23,
								"MONEY"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3936413543178267,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					4395658761345164,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"GAMEOVER"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					3707703919469689,
					false
					,[
					[
						5,
						[
							2,
							"UIGameOver"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					7229543570090828,
					false
					,[
					[
						5,
						[
							2,
							"UIPauseMenu"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					7126839113770263,
					false
					,[
					[
						5,
						[
							2,
							"UIStart"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					2749734451477501,
					false
					,[
					[
						5,
						[
							2,
							"BG"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					7621439366780439,
					false
					,[
					[
						5,
						[
							2,
							"UI"
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					4274637617963665,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2809397688859265,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Play"
							]
						]
						]
					]
					],
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						7549682204050139,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Play"
									]
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6045808401991407,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3637130902571458,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Exit"
							]
						]
						]
					]
					],
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						7370778470414765,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Exit"
									]
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6526335748536159,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2438835125123485,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"RateMe"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5326620659527261,
						[
						[
							26,
							cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,
							null,
							0,
							false,
							false,
							false,
							9084777535051538,
							false
						]
						],
						[
						[
							35,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							7213252650781866,
							false
							,[
							[
								7,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										10,
										[
											20,
											18,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"LANG"
											]
											]
										]
										,[
											2,
											"RateMe"
										]
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5685043211540863,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							2465688454172463,
							false
						]
						],
						[
						[
							35,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							6379866847237929,
							false
							,[
							[
								7,
								[
									2,
									"Android"
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7365454889249057,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8483310200398409,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Twitter"
							]
						]
						]
					]
					],
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						6326046812202322,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Twitter"
									]
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4272875332982258,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8518063763769149,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"GOScore"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						1143422772199602,
						false
						,[
						[
							7,
							[
								10,
								[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											10,
											[
												20,
												18,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"LANG"
												]
												]
											]
											,[
												2,
												"Score"
											]
										]
										]
									]
									,[
										2,
										": "
									]
								]
								,[
									23,
									"SCORE"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2849982356910452,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4915393577047595,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"GOBest"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						8843865188043203,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							2642194647280635,
							false
							,[
							[
								11,
								"GAME_MODE"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"HARDCORE"
								]
							]
							]
						]
						],
						[
						[
							15,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							2755175805521839,
							false
							,[
							[
								7,
								[
									10,
									[
										10,
										[
											20,
											18,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												10,
												[
													20,
													18,
													cr.plugins_.WebStorage.prototype.exps.LocalValue,
													true,
													null
													,[
[
														2,
														"LANG"
													]
													]
												]
												,[
													2,
													"Record"
												]
											]
											]
										]
										,[
											2,
											": "
										]
									]
									,[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"RECORD_HARDCORE"
										]
										]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9382602933868281,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							4177896907774611,
							false
						]
						],
						[
						[
							15,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							7613006115186009,
							false
							,[
							[
								7,
								[
									10,
									[
										10,
										[
											20,
											18,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												10,
												[
													20,
													18,
													cr.plugins_.WebStorage.prototype.exps.LocalValue,
													true,
													null
													,[
[
														2,
														"LANG"
													]
													]
												]
												,[
													2,
													"Record"
												]
											]
											]
										]
										,[
											2,
											": "
										]
									]
									,[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"RECORD"
										]
										]
									]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					672887568392386,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3242061871266558,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"GOMedal"
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2084438082586836,
						false
						,[
						[
							1,
							[
								2,
								"SetMedal"
							]
						]
,						[
							13,
						]
						]
					]
,					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						6046350747111103,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										20,
										8,
										cr.plugins_.Function.prototype.exps.ReturnValue,
										false,
										null
									]
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8465068173185303,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					8056116551855924,
					false
					,[
					[
						11,
						"GAMESTATE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"PAUSE"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					4156735998642987,
					false
					,[
					[
						5,
						[
							2,
							"UIPauseMenu"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					1031350389976553,
					false
					,[
					[
						5,
						[
							2,
							"UIGameOver"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					7606382576785924,
					false
					,[
					[
						5,
						[
							2,
							"UIStart"
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			596815621479877,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				4162135285069278,
				false
				,[
				[
					1,
					[
						2,
						"ClearScreen"
					]
				]
				]
			]
			],
			[
			[
				41,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				622683573149169,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				34,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				423816902335011,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				8262557113346483,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					6805191865815893,
					false
					,[
					[
						4,
						7
					]
					]
				]
				],
				[
				[
					7,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4453962630641174,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4348738827281697,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					3921891053736252,
					false
					,[
					[
						4,
						4
					]
					]
				]
				],
				[
				[
					4,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8394716669353451,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3128213437999437,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					3130319545916631,
					false
					,[
					[
						4,
						11
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					78151149841955,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4771310582129853,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					6993152069733088,
					false
					,[
					[
						4,
						14
					]
					]
				]
				],
				[
				[
					14,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5106045670062854,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4262620080909192,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					9121699817285594,
					false
					,[
					[
						4,
						13
					]
					]
				]
				],
				[
				[
					13,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6388544940117482,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1978689892095766,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					5965674433236646,
					false
					,[
					[
						4,
						19
					]
					]
				]
				],
				[
				[
					19,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2943522230111698,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7525596320074449,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					4849149562031893,
					false
					,[
					[
						4,
						25
					]
					]
				]
				],
				[
				[
					25,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3725616282527633,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3583151250276309,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					51636802933052,
					false
					,[
					[
						4,
						28
					]
					]
				]
				],
				[
				[
					28,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9825177420011193,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				928782894869147,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					4862817337777009,
					false
					,[
					[
						4,
						38
					]
					]
				]
				],
				[
				[
					38,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					509304532966112,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4219391750655171,
				[
				[
					-1,
					cr.system_object.prototype.cnds.PickByEvaluate,
					null,
					0,
					false,
					false,
					false,
					4171380488821719,
					false
					,[
					[
						4,
						2
					]
,					[
						0,
						[
							13,
							[
								22,
								2,
								"Pin",
								cr.behaviors.Pin.prototype.exps.PinnedUID,
								false,
								null
							]
							,[
								20,
								0,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
					]
					]
				]
				],
				[
				[
					2,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6787190152910594,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			148364064632835,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				6286532945230868,
				false
				,[
				[
					1,
					[
						2,
						"CreateAuxShip"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				1610040054171812,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1291431599941711,
					false
					,[
					[
						10,
						14
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1507509968758811,
					false
					,[
					[
						4,
						28
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							5,
							[
								20,
								0,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								20,
								0,
								cr.plugins_.Sprite.prototype.exps.Width,
								false,
								null
							]
						]
					]
,					[
						0,
						[
							20,
							0,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
					]
					]
				]
,				[
					28,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					3462469349156001,
					false
					,[
					[
						4,
						0
					]
,					[
						3,
						3
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.MoveToBottom,
					null,
					4040948269828178,
					false
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					5662517716030785,
					false
					,[
					[
						10,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetPosToObject,
					null,
					189956704593184,
					false
					,[
					[
						4,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					1277672974361659,
					false
					,[
					[
						0,
						[
							21,
							0,
							false,
							null
							,16
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					8580209577486257,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8388076432429429,
						false
						,[
						[
							11,
							"GAME_MODE"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"HARDCORE"
							]
						]
						]
					]
					],
					[
					[
						28,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3624839149181919,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								21,
								28,
								false,
								null
								,4
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5257986021890135,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					496134463310851,
					false
					,[
					[
						10,
						14
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					9890105183742874,
					false
					,[
					[
						4,
						28
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							5,
							[
								20,
								0,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								6,
								[
									20,
									0,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
								,[
									0,
									2
								]
							]
						]
					]
,					[
						0,
						[
							20,
							0,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
					]
					]
				]
,				[
					28,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					1991135545026384,
					false
					,[
					[
						4,
						0
					]
,					[
						3,
						3
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.MoveToBottom,
					null,
					2495435304545776,
					false
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					1203544917777607,
					false
					,[
					[
						10,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetPosToObject,
					null,
					3832691751331944,
					false
					,[
					[
						4,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					6916880503146777,
					false
					,[
					[
						0,
						[
							21,
							0,
							false,
							null
							,16
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					385577653833343,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8906301285150626,
						false
						,[
						[
							11,
							"GAME_MODE"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"HARDCORE"
							]
						]
						]
					]
					],
					[
					[
						28,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						2762738854964095,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								21,
								28,
								false,
								null
								,4
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7522201129867768,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					9116785379042083,
					false
					,[
					[
						10,
						14
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2366221367839329,
					false
					,[
					[
						4,
						28
					]
,					[
						5,
						[
							2,
							"Player"
						]
					]
,					[
						0,
						[
							5,
							[
								20,
								0,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
							,[
								6,
								[
									20,
									0,
									cr.plugins_.Sprite.prototype.exps.Width,
									false,
									null
								]
								,[
									0,
									3
								]
							]
						]
					]
,					[
						0,
						[
							20,
							0,
							cr.plugins_.Sprite.prototype.exps.Y,
							false,
							null
						]
					]
					]
				]
,				[
					28,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					212883846890437,
					false
					,[
					[
						4,
						0
					]
,					[
						3,
						3
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.MoveToBottom,
					null,
					2320349227768999,
					false
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					9246816843827355,
					false
					,[
					[
						10,
						0
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetPosToObject,
					null,
					5175631828292699,
					false
					,[
					[
						4,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					969799005019258,
					false
					,[
					[
						0,
						[
							21,
							0,
							false,
							null
							,16
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					5523485839147722,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9792131129044915,
						false
						,[
						[
							11,
							"GAME_MODE"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"HARDCORE"
							]
						]
						]
					]
					],
					[
					[
						28,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3164580536605919,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								21,
								28,
								false,
								null
								,4
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			360114938287368,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				9196320836534347,
				false
				,[
				[
					1,
					[
						2,
						"Shoot"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				898920597199518,
				[
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7566666806612026,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.PickByUID,
						null,
						0,
						false,
						false,
						true,
						6782930409561133,
						false
						,[
						[
							0,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5970559705122041,
						[
						[
							4,
							cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
							null,
							0,
							false,
							false,
							false,
							230316808617644,
							false
							,[
							[
								10,
								2
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							9251480521545449,
							[
							[
								-1,
								cr.system_object.prototype.cnds.PickRandom,
								null,
								0,
								false,
								false,
								false,
								1029017901333791,
								false
								,[
								[
									4,
									4
								]
								]
							]
							],
							[
							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetPosToObject,
								null,
								8722715617973775,
								false
								,[
								[
									4,
									0
								]
,								[
									7,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								566055820185764,
								false
								,[
								[
									0,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											3
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4043615998805768,
								false
								,[
								[
									1,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											4
										]
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								743761444744963,
								false
								,[
								[
									0,
									[
										21,
										0,
										false,
										null
										,7
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								2591130723556529,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											2
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
								null,
								2553391152204191,
								false
								,[
								[
									10,
									2
								]
,								[
									3,
									0
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								6614605232894351,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								8637476405333291,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetEnabled,
								"Bullet",
								58839857757452,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.behaviors.Rotate.prototype.acts.SetSpeed,
								"Rotate",
								2762039405725249,
								false
								,[
								[
									0,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											7
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								2688226364396636,
								false
								,[
								[
									10,
									3
								]
,								[
									7,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											8
										]
										]
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								6534852061481806,
								[
								[
									8,
									cr.plugins_.Function.prototype.cnds.CompareParam,
									null,
									0,
									false,
									false,
									false,
									7232932634627844,
									false
									,[
									[
										0,
										[
											0,
											5
										]
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									4,
									cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
									null,
									8324565709036527,
									false
									,[
									[
										10,
										1
									]
,									[
										3,
										0
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								6418282818638132,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Else,
									null,
									0,
									false,
									false,
									false,
									9940277796184532,
									false
								]
								],
								[
								[
									4,
									cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
									null,
									4164703358192195,
									false
									,[
									[
										10,
										1
									]
,									[
										3,
										1
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5630270332605709,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							6265889833051066,
							false
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							3924266779097651,
							false
							,[
							[
								4,
								4
							]
,							[
								5,
								[
									2,
									"Shoots"
								]
							]
,							[
								7,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							4,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							468788937880174,
							false
							,[
							[
								0,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										3
									]
									]
								]
							]
							]
						]
,						[
							4,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							5478902739199375,
							false
							,[
							[
								1,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										4
									]
									]
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							4,
							cr.behaviors.Rotate.prototype.acts.SetSpeed,
							"Rotate",
							3607951078224294,
							false
							,[
							[
								0,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										7
									]
									]
								]
							]
							]
						]
,						[
							4,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							230047233083359,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										8
									]
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							1417275930579178,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								8659853694346436,
								false
								,[
								[
									0,
									[
										0,
										5
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
								null,
								4207274269143173,
								false
								,[
								[
									10,
									1
								]
,								[
									3,
									0
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5259298078855935,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								9749074076416005,
								false
							]
							],
							[
							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
								null,
								1568039310098918,
								false
								,[
								[
									10,
									1
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3815385045354641,
					[
					[
						28,
						cr.plugins_.Sprite.prototype.cnds.PickByUID,
						null,
						0,
						false,
						false,
						true,
						5867733875533477,
						false
						,[
						[
							0,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1115103012633997,
						[
						[
							4,
							cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
							null,
							0,
							false,
							false,
							false,
							4828940807882099,
							false
							,[
							[
								10,
								2
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							5349949948461139,
							[
							[
								-1,
								cr.system_object.prototype.cnds.PickRandom,
								null,
								0,
								false,
								false,
								false,
								5544786556561252,
								false
								,[
								[
									4,
									4
								]
								]
							]
							],
							[
							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetPosToObject,
								null,
								4937226090389996,
								false
								,[
								[
									4,
									28
								]
,								[
									7,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								5374289095467953,
								false
								,[
								[
									0,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											3
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								3994629779674747,
								false
								,[
								[
									1,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											4
										]
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								9648322552530247,
								false
								,[
								[
									0,
									[
										21,
										0,
										false,
										null
										,7
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								8487683566398967,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											2
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
								null,
								9107013207023581,
								false
								,[
								[
									10,
									2
								]
,								[
									3,
									0
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								140203391946804,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								4313520512967181,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetEnabled,
								"Bullet",
								214931679507324,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								487273908991844,
								[
								[
									8,
									cr.plugins_.Function.prototype.cnds.CompareParam,
									null,
									0,
									false,
									false,
									false,
									6386072930847859,
									false
									,[
									[
										0,
										[
											0,
											5
										]
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									4,
									cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
									null,
									7688499504978829,
									false
									,[
									[
										10,
										1
									]
,									[
										3,
										0
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								4272339403558413,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Else,
									null,
									0,
									false,
									false,
									false,
									2696540454165876,
									false
								]
								],
								[
								[
									4,
									cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
									null,
									3803614518311699,
									false
									,[
									[
										10,
										1
									]
,									[
										3,
										1
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6590973486527033,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							1505472720951934,
							false
						]
						],
						[
						[
							28,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							4326434779607494,
							false
							,[
							[
								4,
								4
							]
,							[
								5,
								[
									2,
									"Shoots"
								]
							]
,							[
								7,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							4,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							5695827409050923,
							false
							,[
							[
								0,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										3
									]
									]
								]
							]
							]
						]
,						[
							4,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							6743921155075554,
							false
							,[
							[
								1,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										4
									]
									]
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							7499347099055738,
							[
							[
								8,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								9817163597466888,
								false
								,[
								[
									0,
									[
										0,
										5
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
								null,
								1016361787391582,
								false
								,[
								[
									10,
									1
								]
,								[
									3,
									0
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7409723690400814,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								8141197854585812,
								false
							]
							],
							[
							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
								null,
								444109977926307,
								false
								,[
								[
									10,
									1
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5560503835529285,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.PickByUID,
						null,
						0,
						false,
						false,
						true,
						5493785336906448,
						false
						,[
						[
							0,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6627078559974749,
						[
						[
							4,
							cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
							null,
							0,
							false,
							false,
							false,
							5015563315174553,
							false
							,[
							[
								10,
								2
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							253162315700052,
							[
							[
								-1,
								cr.system_object.prototype.cnds.PickRandom,
								null,
								0,
								false,
								false,
								false,
								3545567968604681,
								false
								,[
								[
									4,
									4
								]
								]
							]
							],
							[
							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetPosToObject,
								null,
								1782604731754498,
								false
								,[
								[
									4,
									7
								]
,								[
									7,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								8233152438081482,
								false
								,[
								[
									0,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											3
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2296207348582096,
								false
								,[
								[
									1,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											4
										]
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								9762140915325628,
								false
								,[
								[
									0,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											6
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								8217651409343139,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											2
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
								null,
								5065445016922017,
								false
								,[
								[
									10,
									2
								]
,								[
									3,
									0
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								1675798381348452,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								5389537131263474,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetEnabled,
								"Bullet",
								9793663102343503,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6161752030320342,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							5515189036336756,
							false
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							2583068808848555,
							false
							,[
							[
								4,
								4
							]
,							[
								5,
								[
									2,
									"Shoots"
								]
							]
,							[
								7,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							4,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							9751179583962097,
							false
							,[
							[
								0,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										3
									]
									]
								]
							]
							]
						]
,						[
							4,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							9171767592748922,
							false
							,[
							[
								1,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										4
									]
									]
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							4,
							cr.behaviors.Bullet.prototype.acts.SetSpeed,
							"Bullet",
							2926404377029821,
							false
							,[
							[
								0,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										6
									]
									]
								]
							]
							]
						]
,						[
							4,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2788847335437155,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										2
									]
									]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8983201561012917,
					[
					[
						38,
						cr.plugins_.Sprite.prototype.cnds.PickByUID,
						null,
						0,
						false,
						false,
						true,
						621289673157774,
						false
						,[
						[
							0,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5767331078945805,
						[
						[
							4,
							cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
							null,
							0,
							false,
							false,
							false,
							4968675092071429,
							false
							,[
							[
								10,
								2
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							5595732586172008,
							[
							[
								-1,
								cr.system_object.prototype.cnds.PickRandom,
								null,
								0,
								false,
								false,
								false,
								3015639402196157,
								false
								,[
								[
									4,
									4
								]
								]
							]
							],
							[
							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetPosToObject,
								null,
								7829417107683152,
								false
								,[
								[
									4,
									38
								]
,								[
									7,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								1298901627860612,
								false
								,[
								[
									0,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											3
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2142359157347091,
								false
								,[
								[
									1,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											4
										]
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								3815533140479049,
								false
								,[
								[
									0,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											6
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								1793190905569222,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											2
										]
										]
									]
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
								null,
								2544780480184019,
								false
								,[
								[
									10,
									2
								]
,								[
									3,
									0
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								1728064797323194,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								4139687644489743,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								4,
								cr.behaviors.Bullet.prototype.acts.SetEnabled,
								"Bullet",
								9212517133685252,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2039533002379599,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							4935642479115936,
							false
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							7393110972200844,
							false
							,[
							[
								4,
								4
							]
,							[
								5,
								[
									2,
									"Shoots"
								]
							]
,							[
								7,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
,						[
							4,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							9256108245563789,
							false
							,[
							[
								0,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										3
									]
									]
								]
							]
							]
						]
,						[
							4,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							8975312124667322,
							false
							,[
							[
								1,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										4
									]
									]
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							4,
							cr.behaviors.Bullet.prototype.acts.SetSpeed,
							"Bullet",
							7328751189237949,
							false
							,[
							[
								0,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										6
									]
									]
								]
							]
							]
						]
,						[
							4,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2550392263688562,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										2
									]
									]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2610010507187564,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				1719985020464085,
				false
				,[
				[
					1,
					[
						2,
						"StoreBullet"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7539109217233067,
				[
				[
					4,
					cr.plugins_.Sprite.prototype.cnds.PickByUID,
					null,
					0,
					false,
					false,
					true,
					5364134625125383,
					false
					,[
					[
						0,
						[
							20,
							8,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
					]
				]
				],
				[
				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
					null,
					7408101304597045,
					false
					,[
					[
						10,
						2
					]
,					[
						3,
						1
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2855231040870115,
					false
					,[
					[
						0,
						[
							0,
							-100
						]
					]
,					[
						0,
						[
							0,
							-100
						]
					]
					]
				]
,				[
					4,
					cr.behaviors.Rotate.prototype.acts.SetSpeed,
					"Rotate",
					5363044222264001,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetAngle,
					null,
					1848841490485229,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					9563905575566373,
					false
					,[
					[
						10,
						3
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1069856075738544,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					1850713232520405,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					4,
					cr.behaviors.Bullet.prototype.acts.SetEnabled,
					"Bullet",
					3769421982631566,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2247769263644824,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				6304261136423491,
				false
				,[
				[
					1,
					[
						2,
						"SetMedal"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				1,
				"ShipID",
				0,
				0,
false,false,4416756605357952,false
			]
,			[
				0,
				null,
				false,
				null,
				2095674369008309,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5456681036342733,
					false
					,[
					[
						11,
						"SELECTED_SHIP"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Standard"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4333900741114908,
					false
					,[
					[
						11,
						"ShipID"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5550849486507518,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2338367073511871,
					false
					,[
					[
						11,
						"SELECTED_SHIP"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Option"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					1887861126497688,
					false
					,[
					[
						11,
						"ShipID"
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4888115531416446,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					3882523889302469,
					false
					,[
					[
						11,
						"SELECTED_SHIP"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Stork"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2633238538303927,
					false
					,[
					[
						11,
						"ShipID"
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				433271887138993,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5610892412648233,
					false
					,[
					[
						11,
						"GAME_MODE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"NORMAL"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5345738958004773,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						7162479699751721,
						false
						,[
						[
							7,
							[
								23,
								"SCORE"
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								100000
							]
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						9466196046192213,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						3669243153558564,
						false
						,[
						[
							1,
							[
								2,
								"Bronze"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5339691022834937,
						false
						,[
						[
							0,
							[
								5,
								[
									23,
									"ShipID"
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Function.prototype.acts.SetReturnValue,
						null,
						7896420136107317,
						false
						,[
						[
							7,
							[
								2,
								"Bronze"
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						3540000708395312,
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							true,
							false,
							1795731080070498,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Medal"
									]
									,[
										23,
										"ShipID"
									]
								]
							]
,							[
								1,
								[
									2,
									"Silver"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							18,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							true,
							false,
							876480158310172,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Medal"
									]
									,[
										23,
										"ShipID"
									]
								]
							]
,							[
								1,
								[
									2,
									"Gold"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							537424018436563,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Medal"
									]
									,[
										23,
										"ShipID"
									]
								]
							]
,							[
								7,
								[
									2,
									"Bronze"
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2619694466027511,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						8023931045350514,
						false
						,[
						[
							7,
							[
								23,
								"SCORE"
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								400000
							]
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3384906641123216,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						3617944154129286,
						false
						,[
						[
							1,
							[
								2,
								"Silver"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6995395994495886,
						false
						,[
						[
							0,
							[
								5,
								[
									23,
									"ShipID"
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Function.prototype.acts.SetReturnValue,
						null,
						2678630828929098,
						false
						,[
						[
							7,
							[
								2,
								"Silver"
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						6277208047922809,
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							true,
							false,
							6300762681100189,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Medal"
									]
									,[
										23,
										"ShipID"
									]
								]
							]
,							[
								1,
								[
									2,
									"Gold"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							6165695714655845,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Medal"
									]
									,[
										23,
										"ShipID"
									]
								]
							]
,							[
								7,
								[
									2,
									"Silver"
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8050681614932689,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						5313714575967614,
						false
						,[
						[
							7,
							[
								23,
								"SCORE"
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								700000
							]
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3060676753663367,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						9201599812033437,
						false
						,[
						[
							1,
							[
								2,
								"Gold"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						4922966911076072,
						false
						,[
						[
							0,
							[
								5,
								[
									23,
									"ShipID"
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3563369685693071,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Medal"
								]
								,[
									23,
									"ShipID"
								]
							]
						]
,						[
							7,
							[
								2,
								"Gold"
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Function.prototype.acts.SetReturnValue,
						null,
						3438071869414461,
						false
						,[
						[
							7,
							[
								2,
								"Gold"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2918196395002329,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2289630788567598,
					false
					,[
					[
						11,
						"GAME_MODE"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"HARDCORE"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					2892428214444853,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						2937673362612872,
						false
						,[
						[
							7,
							[
								23,
								"SCORE"
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								20000
							]
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5471730568215538,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						251152210216876,
						false
						,[
						[
							1,
							[
								2,
								"Bronze"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3974057023782442,
						false
						,[
						[
							0,
							[
								5,
								[
									23,
									"ShipID"
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Function.prototype.acts.SetReturnValue,
						null,
						5539733963787807,
						false
						,[
						[
							7,
							[
								2,
								"Bronze"
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						1322153018907923,
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							true,
							false,
							2599839347647482,
							false
							,[
							[
								1,
								[
									10,
									[
										10,
										[
											2,
											"Medal"
										]
										,[
											23,
											"ShipID"
										]
									]
									,[
										2,
										"Hardcore"
									]
								]
							]
,							[
								1,
								[
									2,
									"Silver"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							18,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							true,
							false,
							8406211749507752,
							false
							,[
							[
								1,
								[
									10,
									[
										10,
										[
											2,
											"Medal"
										]
										,[
											23,
											"ShipID"
										]
									]
									,[
										2,
										"Hardcore"
									]
								]
							]
,							[
								1,
								[
									2,
									"Gold"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							3337610869235823,
							false
							,[
							[
								1,
								[
									10,
									[
										10,
										[
											2,
											"Medal"
										]
										,[
											23,
											"ShipID"
										]
									]
									,[
										2,
										"Hardcore"
									]
								]
							]
,							[
								7,
								[
									2,
									"Bronze"
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9820517880118348,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						8824005479782135,
						false
						,[
						[
							7,
							[
								23,
								"SCORE"
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								100000
							]
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2982013983576971,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						680008835333171,
						false
						,[
						[
							1,
							[
								2,
								"Silver"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7707448944810369,
						false
						,[
						[
							0,
							[
								5,
								[
									23,
									"ShipID"
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Function.prototype.acts.SetReturnValue,
						null,
						2897016932370749,
						false
						,[
						[
							7,
							[
								2,
								"Silver"
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						2564350908612259,
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							true,
							false,
							2403875783660762,
							false
							,[
							[
								1,
								[
									10,
									[
										10,
										[
											2,
											"Medal"
										]
										,[
											23,
											"ShipID"
										]
									]
									,[
										2,
										"Hardcore"
									]
								]
							]
,							[
								1,
								[
									2,
									"Gold"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							5842362233563752,
							false
							,[
							[
								1,
								[
									10,
									[
										10,
										[
											2,
											"Medal"
										]
										,[
											23,
											"ShipID"
										]
									]
									,[
										2,
										"Hardcore"
									]
								]
							]
,							[
								7,
								[
									2,
									"Silver"
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4929839271283743,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						7524480553693722,
						false
						,[
						[
							7,
							[
								23,
								"SCORE"
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								300000
							]
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5969369471903483,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						2656935577894728,
						false
						,[
						[
							1,
							[
								2,
								"Gold"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7733999055287011,
						false
						,[
						[
							0,
							[
								5,
								[
									23,
									"ShipID"
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9485379094405135,
						false
						,[
						[
							1,
							[
								10,
								[
									10,
									[
										2,
										"Medal"
									]
									,[
										23,
										"ShipID"
									]
								]
								,[
									2,
									"Hardcore"
								]
							]
						]
,						[
							7,
							[
								2,
								"Gold"
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Function.prototype.acts.SetReturnValue,
						null,
						3234523977620111,
						false
						,[
						[
							7,
							[
								2,
								"Gold"
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2205776422311531,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				6747475668084841,
				false
				,[
				[
					1,
					[
						2,
						"CallEnemy"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				1,
				"rnd",
				0,
				0,
false,false,2520484169225011,false
			]
,			[
				0,
				null,
				false,
				null,
				4446950306798387,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7767154827691006,
					false
					,[
					[
						11,
						"DELAY"
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					3384492932129347,
					false
					,[
					[
						11,
						"DELAY"
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.dt
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4614589893372379,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					8394200334705016,
					false
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4547814284916901,
					false
					,[
					[
						11,
						"rnd"
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								0,
								100
							]
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7905685470046587,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						2098031720638402,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Piranhas"
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						851334136179781,
						false
						,[
						[
							1,
							[
								2,
								"LoadEnemyType"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Piranha"
									]
								]
,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.choose
										,[
[
											2,
											"Top"
										]
,[
											2,
											"Top"
										]
,[
											2,
											"Left"
										]
,[
											2,
											"Right"
										]
										]
									]
								]
,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												3
											]
,[
												0,
												6
											]
											]
										]
										]
									]
								]
,
								[
									7,
									[
										0,
										0
									]
								]
,
								[
									7,
									[
										0,
										0
									]
								]
,
								[
									7,
									[
										0,
										0
									]
								]
,
								[
									7,
									[
										2,
										"ExtraSpeed"
									]
								]
,
								[
									7,
									[
										1,
										1.2
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8941479686519414,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						8862295534733924,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Random"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						988129890946286,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1194596595956423,
							false
							,[
							[
								11,
								"DIFFICULTY"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									24
								]
							]
							]
						]
						],
						[
						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5500127355124804,
							false
							,[
							[
								1,
								[
									2,
									"LoadBoss"
								]
							]
,							[
								13,
																	[
										7,
										[
											0,
											1
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7691017815509776,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							2577473651604399,
							false
							,[
							[
								11,
								"EVERY_X_LVLs"
							]
,							[
								8,
								4
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9717623288326917,
							false
							,[
							[
								11,
								"DIFFICULTY"
							]
,							[
								8,
								5
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						],
						[
						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							715295468880281,
							false
							,[
							[
								1,
								[
									2,
									"LoadEnemyType"
								]
							]
,							[
								13,
																	[
										7,
										[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												2,
												"Juggernaut"
											]
,[
												2,
												"PiranhaKing"
											]
											]
										]
									]
,
									[
										7,
										[
											2,
											"Top"
										]
									]
,
									[
										7,
										[
											0,
											1
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							9722717261111587,
							false
							,[
							[
								11,
								"EVERY_X_LVLs"
							]
,							[
								7,
								[
									0,
									-2
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6071850011467469,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							2415365752040267,
							false
							,[
							[
								7,
								[
									23,
									"rnd"
								]
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							9340838250166556,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								1824733755478811,
								false
								,[
								[
									11,
									"DIFFICULTY"
								]
,								[
									8,
									5
								]
,								[
									7,
									[
										0,
										6
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3463943566130176,
								false
								,[
								[
									1,
									[
										2,
										"LoadEnemyType"
									]
								]
,								[
									13,
																			[
											7,
											[
												19,
												cr.system_object.prototype.exps.choose
												,[
[
													2,
													"Rock"
												]
,[
													2,
													"Rock2"
												]
												]
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												0,
												1
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5179333539227896,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								4606213844101204,
								false
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7410415989300011,
								false
								,[
								[
									1,
									[
										2,
										"LoadEnemyType"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"Rock"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
,
										[
											7,
											[
												0,
												1
											]
										]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3542922995275193,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							9168202004056144,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							1640055854614581,
							false
							,[
							[
								7,
								[
									23,
									"rnd"
								]
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1728306234031803,
							false
							,[
							[
								11,
								"EVERY_X_LVLs_Chain"
							]
,							[
								8,
								4
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							998263557287952,
							false
							,[
							[
								11,
								"EVERY_X_LVLs_Chain"
							]
,							[
								7,
								[
									3,
									[
										19,
										cr.system_object.prototype.exps.choose
										,[
[
											0,
											2
										]
,[
											0,
											3
										]
,[
											0,
											4
										]
,[
											0,
											5
										]
										]
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							9072596300373708,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								9147022428552443,
								false
								,[
								[
									11,
									"DIFFICULTY"
								]
,								[
									8,
									2
								]
,								[
									7,
									[
										0,
										6
									]
								]
								]
							]
							],
							[
							]
						]
,						[
							0,
							null,
							false,
							null,
							1669616089692765,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								9703668346292859,
								false
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								797882035942918,
								false
								,[
								[
									11,
									"DIFFICULTY"
								]
,								[
									8,
									5
								]
,								[
									7,
									[
										0,
										6
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								5996255855135551,
								false
								,[
								[
									11,
									"DIFFICULTY"
								]
,								[
									8,
									2
								]
,								[
									7,
									[
										0,
										15
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7762000272514688,
								false
								,[
								[
									1,
									[
										2,
										"LoadEnemyChain"
									]
								]
,								[
									13,
																			[
											7,
											[
												19,
												cr.system_object.prototype.exps.choose
												,[
[
													2,
													"Wind"
												]
,[
													2,
													"Delta"
												]
												]
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							367034580583857,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								8917283187536038,
								false
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								5520441267984227,
								false
								,[
								[
									11,
									"DIFFICULTY"
								]
,								[
									8,
									2
								]
,								[
									7,
									[
										0,
										19
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								963328303403956,
								false
								,[
								[
									1,
									[
										2,
										"LoadEnemyChain"
									]
								]
,								[
									13,
																			[
											7,
											[
												19,
												cr.system_object.prototype.exps.choose
												,[
[
													2,
													"Wind"
												]
,[
													2,
													"Delta"
												]
,[
													2,
													"Mixed1"
												]
,[
													2,
													"Rock"
												]
												]
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							636520147887774,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								4699593935203263,
								false
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								726190745317987,
								false
								,[
								[
									1,
									[
										2,
										"LoadEnemyChain"
									]
								]
,								[
									13,
																			[
											7,
											[
												19,
												cr.system_object.prototype.exps.choose
												,[
[
													2,
													"Wind"
												]
,[
													2,
													"Delta"
												]
,[
													2,
													"Juggernaut"
												]
,[
													2,
													"Mixed1"
												]
,[
													2,
													"Rock"
												]
												]
											]
										]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7757213902380107,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							9386302967780081,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							2135943650063763,
							false
							,[
							[
								7,
								[
									23,
									"rnd"
								]
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									36
								]
							]
							]
						]
						],
						[
						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1898067893409691,
							false
							,[
							[
								1,
								[
									2,
									"LoadEnemyType"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"Piranha"
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												2,
												"Top"
											]
,[
												2,
												"Top"
											]
,[
												2,
												"Left"
											]
,[
												2,
												"Right"
											]
											]
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													3
												]
,[
													0,
													6
												]
												]
											]
											]
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2596252031425457,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							9760667348470062,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							3559947071445664,
							false
							,[
							[
								7,
								[
									23,
									"rnd"
								]
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									70
								]
							]
							]
						]
						],
						[
						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8625035135649446,
							false
							,[
							[
								1,
								[
									2,
									"LoadEnemyType"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"Delta"
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												2,
												"Top"
											]
,[
												2,
												"Top"
											]
,[
												2,
												"Left"
											]
,[
												2,
												"Right"
											]
											]
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													1
												]
,[
													0,
													5
												]
												]
											]
											]
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8173261432164414,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							520845201742507,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							1645117263799041,
							false
							,[
							[
								7,
								[
									23,
									"rnd"
								]
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									84
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9638810389423872,
							false
							,[
							[
								11,
								"DIFFICULTY"
							]
,							[
								8,
								5
							]
,							[
								7,
								[
									0,
									8
								]
							]
							]
						]
						],
						[
						[
							8,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7109968633618167,
							false
							,[
							[
								1,
								[
									2,
									"LoadEnemyType"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"Wind"
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												2,
												"Top"
											]
,[
												2,
												"Top"
											]
,[
												2,
												"Left"
											]
,[
												2,
												"Right"
											]
											]
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													1
												]
,[
													4,
													[
														0,
														1
													]
													,[
														7,
														[
															23,
															"DIFFICULTY"
														]
														,[
															0,
															12
														]
													]
												]
												]
											]
											]
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7298295556335866,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							2367445439144362,
							false
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							4543452000846982,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								3418825357232932,
								false
								,[
								[
									11,
									"DIFFICULTY"
								]
,								[
									8,
									2
								]
,								[
									7,
									[
										0,
										5
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7711648962460932,
								false
								,[
								[
									1,
									[
										2,
										"LoadEnemyType"
									]
								]
,								[
									13,
																			[
											7,
											[
												19,
												cr.system_object.prototype.exps.choose
												,[
[
													2,
													"Piranha"
												]
,[
													2,
													"Delta"
												]
												]
											]
										]
,
										[
											7,
											[
												19,
												cr.system_object.prototype.exps.choose
												,[
[
													2,
													"Top"
												]
,[
													2,
													"Top"
												]
,[
													2,
													"Left"
												]
,[
													2,
													"Right"
												]
												]
											]
										]
,
										[
											7,
											[
												19,
												cr.system_object.prototype.exps["int"]
												,[
[
													19,
													cr.system_object.prototype.exps.random
													,[
[
														0,
														3
													]
,[
														0,
														6
													]
													]
												]
												]
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4179348326034616,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								5115848159168602,
								false
							]
,							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6303431596196483,
								false
								,[
								[
									11,
									"DIFFICULTY"
								]
,								[
									8,
									2
								]
,								[
									7,
									[
										0,
										12
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3162945948023067,
								false
								,[
								[
									1,
									[
										2,
										"LoadEnemyType"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"Phalanx"
											]
										]
,
										[
											7,
											[
												19,
												cr.system_object.prototype.exps.choose
												,[
[
													2,
													"Top"
												]
,[
													2,
													"Top"
												]
,[
													2,
													"Left"
												]
,[
													2,
													"Right"
												]
												]
											]
										]
,
										[
											7,
											[
												0,
												1
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3530750868017426,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								703212813624051,
								false
							]
							],
							[
							[
								8,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3996375257779951,
								false
								,[
								[
									1,
									[
										2,
										"LoadEnemyType"
									]
								]
,								[
									13,
																			[
											7,
											[
												19,
												cr.system_object.prototype.exps.choose
												,[
[
													2,
													"Ray"
												]
,[
													2,
													"Phalanx"
												]
												]
											]
										]
,
										[
											7,
											[
												19,
												cr.system_object.prototype.exps.choose
												,[
[
													2,
													"Top"
												]
,[
													2,
													"Top"
												]
,[
													2,
													"Left"
												]
,[
													2,
													"Right"
												]
												]
											]
										]
,
										[
											7,
											[
												0,
												1
											]
										]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3236675250615827,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				5113124362854978,
				false
				,[
				[
					1,
					[
						2,
						"LoadEnemyType"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				1,
				"Speed",
				0,
				0,
false,false,7401008722509732,false
			]
,			[
				1,
				"posX",
				0,
				0,
false,false,3015281935625173,false
			]
,			[
				1,
				"posY",
				0,
				0,
false,false,4979056696389195,false
			]
,			[
				0,
				null,
				false,
				null,
				9899582700400688,
				[
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3391888442451953,
					false
					,[
					[
						11,
						"Speed"
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								4,
								[
									0,
									40
								]
								,[
									6,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										3
									]
								]
							]
,[
								4,
								[
									0,
									90
								]
								,[
									6,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										3
									]
								]
							]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8946902178850986,
					false
					,[
					[
						11,
						"posX"
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								0,
								20
							]
,[
								0,
								300
							]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2680242199455787,
					false
					,[
					[
						11,
						"posY"
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								0,
								20
							]
,[
								0,
								300
							]
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					377957209173367,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						3163912425283118,
						false
						,[
						[
							0,
							[
								0,
								3
							]
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2018550512716826,
						false
						,[
						[
							11,
							"posX"
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									3
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9947177271089026,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						8823390113035176,
						false
						,[
						[
							0,
							[
								0,
								4
							]
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5791435511415692,
						false
						,[
						[
							11,
							"posY"
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									4
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6290047227440002,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						6450142352043895,
						false
						,[
						[
							0,
							[
								0,
								5
							]
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1702691714318767,
						false
						,[
						[
							11,
							"Speed"
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									5
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5836949230306934,
				[
				[
					-1,
					cr.system_object.prototype.cnds.For,
					null,
					0,
					true,
					false,
					false,
					1056845214976626,
					false
					,[
					[
						1,
						[
							2,
							""
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							5,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									2
								]
								]
							]
							,[
								0,
								1
							]
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					1,
					"enemyID",
					0,
					0,
false,false,6180595735165577,false
				]
,				[
					0,
					null,
					false,
					null,
					3478757644015617,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						2835555449384966,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Delta"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						4433572961194445,
						false
						,[
						[
							11,
							"DELAY"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										0,
										1
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											20
										]
									]
								]
,[
									1,
									0.2
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						5973462948241487,
						false
						,[
						[
							4,
							7
						]
,						[
							5,
							[
								2,
								"Enemies"
							]
						]
,						[
							0,
							[
								0,
								-30
							]
						]
,						[
							0,
							[
								0,
								-30
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						2623255381139978,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									4,
									[
										0,
										1
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						9427290034599406,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps.choose
									,[
[
										0,
										1
									]
,[
										0,
										1
									]
,[
										0,
										2
									]
									]
								]
								,[
									7,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										4
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8128161076462596,
						false
						,[
						[
							10,
							4
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										5,
										[
											0,
											80
										]
										,[
											6,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												2
											]
										]
									]
,[
										5,
										[
											0,
											200
										]
										,[
											6,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												3
											]
										]
									]
									]
								]
,[
									0,
									15
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3582047629662013,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,4
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6361286607207575,
						false
						,[
						[
							10,
							11
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5961103630065671,
						false
						,[
						[
							10,
							17
						]
,						[
							7,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						9332832084418023,
						false
						,[
						[
							1,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						803589005195215,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetEnabled,
						"Bullet",
						7890336833192978,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						1729046018931645,
						false
						,[
						[
							0,
							[
								23,
								"Speed"
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
						null,
						3833257012081706,
						false
						,[
						[
							10,
							7
						]
,						[
							3,
							0
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5784218624250346,
						false
						,[
						[
							10,
							9
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5521456710019257,
						false
						,[
						[
							10,
							10
						]
,						[
							7,
							[
								0,
								8
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4885553517352158,
						false
						,[
						[
							10,
							8
						]
,						[
							7,
							[
								0,
								100
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4623069575076652,
						false
						,[
						[
							10,
							12
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									4,
									[
										0,
										130
									]
									,[
										6,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											3
										]
									]
								]
,[
									0,
									0
								]
,[
									0,
									200
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6385403898516075,
						false
						,[
						[
							11,
							"enemyID"
						]
,						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						8455341596793649,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							6675517336304428,
							false
							,[
							[
								7,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										100
									]
									]
								]
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									4,
									[
										0,
										5
									]
									,[
										6,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											2
										]
									]
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
							null,
							8023932908374363,
							false
							,[
							[
								10,
								7
							]
,							[
								3,
								1
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							2884904132159698,
							false
							,[
							[
								1,
								[
									10,
									[
										21,
										7,
										true,
										null
										,11
									]
									,[
										2,
										"Homing"
									]
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							1562728773569796,
							false
							,[
							[
								10,
								17
							]
,							[
								7,
								[
									10,
									[
										21,
										7,
										true,
										null
										,11
									]
									,[
										2,
										"Homing"
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1885898920927707,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							1464869976929618,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Top"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							7403633661704883,
							false
							,[
							[
								0,
								[
									23,
									"posX"
								]
							]
,							[
								0,
								[
									5,
									[
										5,
										[
											0,
											-10
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Height,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							2502445375390944,
							false
							,[
							[
								0,
								[
									0,
									90
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						23243752398174,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							1779832248593764,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Left"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							3560105037279509,
							false
							,[
							[
								0,
								[
									5,
									[
										5,
										[
											0,
											-10
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							5145431036906888,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9491481181254395,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							6530205692173509,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Right"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							3765347048775505,
							false
							,[
							[
								0,
								[
									4,
									[
										4,
										[
											0,
											330
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							555571775337329,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						413805217512525,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							2344235543879767,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Custom"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							8469212718686229,
							false
							,[
							[
								0,
								[
									23,
									"posX"
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							8589372079004735,
							false
							,[
							[
								0,
								[
									0,
									90
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1647523343332198,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						5524702575756899,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Piranha"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						6216773657285963,
						false
						,[
						[
							4,
							7
						]
,						[
							5,
							[
								2,
								"Enemies"
							]
						]
,						[
							0,
							[
								0,
								-30
							]
						]
,						[
							0,
							[
								0,
								-30
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4721332055597299,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									4,
									[
										0,
										1
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											12
										]
									]
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8554808468232876,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1521135994457218,
						false
						,[
						[
							10,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8735023787624569,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,4
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						165510630340401,
						false
						,[
						[
							10,
							11
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7894453486855144,
						false
						,[
						[
							10,
							17
						]
,						[
							7,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						6611336580365797,
						false
						,[
						[
							1,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7702767480775455,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetEnabled,
						"Bullet",
						8344088398760926,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						4527232876101803,
						false
						,[
						[
							0,
							[
								4,
								[
									4,
									[
										23,
										"Speed"
									]
									,[
										0,
										40
									]
								]
								,[
									6,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										2
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
						null,
						6223714429639037,
						false
						,[
						[
							10,
							7
						]
,						[
							3,
							0
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5427777017684887,
						false
						,[
						[
							10,
							9
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5680722752639177,
						false
						,[
						[
							10,
							10
						]
,						[
							7,
							[
								0,
								8
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						9632290073132478,
						false
						,[
						[
							10,
							8
						]
,						[
							7,
							[
								0,
								100
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						9478707596850761,
						false
						,[
						[
							10,
							12
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						2328845737039807,
						false
						,[
						[
							10,
							15
						]
,						[
							7,
							[
								4,
								[
									1,
									0.5
								]
								,[
									7,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										40
									]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5234622507270134,
						false
						,[
						[
							11,
							"enemyID"
						]
,						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						2384246337555541,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							96473515847284,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								1
							]
,							[
								7,
								[
									2,
									"King"
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.AddVar,
							null,
							5123374920230426,
							false
							,[
							[
								11,
								"DELAY"
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.clamp
									,[
[
										5,
										[
											0,
											1
										]
										,[
											7,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												20
											]
										]
									]
,[
										1,
										0.2
									]
,[
										19,
										cr.system_object.prototype.exps.infinity
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2709350932163361,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							4729119789823414,
							false
							,[
							[
								7,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										100
									]
									]
								]
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									4,
									[
										0,
										5
									]
									,[
										6,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											2
										]
									]
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							8833115057239301,
							false
							,[
							[
								1,
								[
									10,
									[
										21,
										7,
										true,
										null
										,11
									]
									,[
										2,
										"Fast"
									]
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetSpeed,
							"Bullet",
							3667646999101171,
							false
							,[
							[
								0,
								[
									4,
									[
										22,
										7,
										"Bullet",
										cr.behaviors.Bullet.prototype.exps.Speed,
										false,
										null
									]
									,[
										0,
										20
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							160549740203595,
							false
							,[
							[
								10,
								15
							]
,							[
								7,
								[
									1,
									0.5
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1053968227882072,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							7200643570489582,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Top"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							2447450887753218,
							false
							,[
							[
								0,
								[
									4,
									[
										23,
										"posX"
									]
									,[
										6,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.Height,
											false,
											null
										]
										,[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												0,
												1
											]
,[
												0,
												-1
											]
,[
												0,
												0
											]
											]
										]
									]
								]
							]
,							[
								0,
								[
									5,
									[
										0,
										-10
									]
									,[
										6,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.Height,
											false,
											null
										]
										,[
											4,
											[
												19,
												cr.system_object.prototype.exps.loopindex
											]
											,[
												0,
												1
											]
										]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							7508284862972961,
							false
							,[
							[
								0,
								[
									0,
									90
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							2713229799360571,
							false
							,[
							[
								0,
								[
									22,
									7,
									"Bullet",
									cr.behaviors.Bullet.prototype.exps.AngleOfMotion,
									false,
									null
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8676259727712869,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							7691537385400527,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Left"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							4344779396576473,
							false
							,[
							[
								0,
								[
									5,
									[
										0,
										-10
									]
									,[
										6,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.Width,
											false,
											null
										]
										,[
											4,
											[
												19,
												cr.system_object.prototype.exps.loopindex
											]
											,[
												0,
												1
											]
										]
									]
								]
							]
,							[
								0,
								[
									4,
									[
										7,
										[
											23,
											"posY"
										]
										,[
											0,
											2
										]
									]
									,[
										6,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.Width,
											false,
											null
										]
										,[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												0,
												1
											]
,[
												0,
												-1
											]
,[
												0,
												0
											]
											]
										]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							5019388817372641,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							6796873337410877,
							false
							,[
							[
								0,
								[
									22,
									7,
									"Bullet",
									cr.behaviors.Bullet.prototype.exps.AngleOfMotion,
									false,
									null
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8392167270881626,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							4657772771127244,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Right"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							9270213863393357,
							false
							,[
							[
								0,
								[
									4,
									[
										0,
										330
									]
									,[
										6,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.Width,
											false,
											null
										]
										,[
											4,
											[
												19,
												cr.system_object.prototype.exps.loopindex
											]
											,[
												0,
												1
											]
										]
									]
								]
							]
,							[
								0,
								[
									4,
									[
										7,
										[
											23,
											"posY"
										]
										,[
											0,
											2
										]
									]
									,[
										6,
										[
											20,
											7,
											cr.plugins_.Sprite.prototype.exps.Width,
											false,
											null
										]
										,[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												0,
												1
											]
,[
												0,
												-1
											]
,[
												0,
												0
											]
											]
										]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							412071224270113,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							4374247850606372,
							false
							,[
							[
								0,
								[
									22,
									7,
									"Bullet",
									cr.behaviors.Bullet.prototype.exps.AngleOfMotion,
									false,
									null
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6165881666461119,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							5277998235128757,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"King"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							5576984369556974,
							false
							,[
							[
								0,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										3
									]
									]
								]
							]
,							[
								0,
								[
									20,
									8,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										4
									]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							5615295835819123,
							false
							,[
							[
								0,
								[
									4,
									[
										0,
										180
									]
									,[
										6,
										[
											5,
											[
												7,
												[
													0,
													180
												]
												,[
													20,
													8,
													cr.plugins_.Function.prototype.exps.Param,
													false,
													null
													,[
[
														0,
														2
													]
													]
												]
											]
											,[
												0,
												1
											]
										]
										,[
											4,
											[
												19,
												cr.system_object.prototype.exps.loopindex
											]
											,[
												0,
												1
											]
										]
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							1415847349500394,
							false
							,[
							[
								0,
								[
									22,
									7,
									"Bullet",
									cr.behaviors.Bullet.prototype.exps.AngleOfMotion,
									false,
									null
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetSpeed,
							"Bullet",
							3431674677080808,
							false
							,[
							[
								0,
								[
									4,
									[
										4,
										[
											23,
											"Speed"
										]
										,[
											0,
											20
										]
									]
									,[
										6,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											2
										]
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							9839464934037828,
							false
							,[
							[
								10,
								15
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.clamp
									,[
[
										4,
										[
											0,
											1
										]
										,[
											7,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												5
											]
										]
									]
,[
										0,
										1
									]
,[
										0,
										4
									]
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.MoveToBottom,
							null,
							2354960406313417,
							false
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							9364703566643129,
							false
							,[
							[
								10,
								8
							]
,							[
								7,
								[
									0,
									10
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
							null,
							3081618087424836,
							false
							,[
							[
								10,
								20
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8269759820718137,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						8479313431558237,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Wind"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						6796821873964253,
						false
						,[
						[
							11,
							"DELAY"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										1,
										1.6
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											20
										]
									]
								]
,[
									1,
									0.2
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						534374977552688,
						false
						,[
						[
							4,
							7
						]
,						[
							5,
							[
								2,
								"Enemies"
							]
						]
,						[
							0,
							[
								0,
								-30
							]
						]
,						[
							0,
							[
								0,
								-30
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						266680005044313,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									4,
									[
										0,
										2
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											2
										]
									]
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5811946062576434,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						202393281121058,
						false
						,[
						[
							10,
							11
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3792701532353573,
						false
						,[
						[
							10,
							17
						]
,						[
							7,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						6982197562606413,
						false
						,[
						[
							1,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						4060821701232739,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetEnabled,
						"Bullet",
						96910321238075,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						6723642227026967,
						false
						,[
						[
							0,
							[
								7,
								[
									23,
									"Speed"
								]
								,[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										2
									]
,[
										0,
										6
									]
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
						null,
						6873195571031258,
						false
						,[
						[
							10,
							7
						]
,						[
							3,
							0
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						2909691188512942,
						false
						,[
						[
							10,
							9
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3107091632305004,
						false
						,[
						[
							10,
							10
						]
,						[
							7,
							[
								0,
								12
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3822087291285386,
						false
						,[
						[
							10,
							8
						]
,						[
							7,
							[
								0,
								200
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						553018132566083,
						false
						,[
						[
							10,
							12
						]
,						[
							7,
							[
								4,
								[
									0,
									130
								]
								,[
									23,
									"DIFFICULTY"
								]
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Rotate.prototype.acts.SetSpeed,
						"Rotate",
						8710090842623179,
						false
						,[
						[
							0,
							[
								0,
								360
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1000616801940122,
						false
						,[
						[
							11,
							"enemyID"
						]
,						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						3919690537018714,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8366862913340341,
							false
							,[
							[
								11,
								"DIFFICULTY"
							]
,							[
								8,
								4
							]
,							[
								7,
								[
									0,
									15
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							9325132852842214,
							false
							,[
							[
								10,
								5
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2276518164943386,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6478547241631971,
							false
							,[
							[
								11,
								"DIFFICULTY"
							]
,							[
								8,
								4
							]
,							[
								7,
								[
									0,
									20
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							5374039374045614,
							false
							,[
							[
								10,
								5
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8611041955532358,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1143200447620828,
							false
							,[
							[
								11,
								"DIFFICULTY"
							]
,							[
								8,
								5
							]
,							[
								7,
								[
									0,
									25
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							6839745789339823,
							false
							,[
							[
								10,
								5
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9335501525750568,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							1391806328968407,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Top"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							2620471217797345,
							false
							,[
							[
								0,
								[
									23,
									"posX"
								]
							]
,							[
								0,
								[
									5,
									[
										5,
										[
											0,
											-10
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Height,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetActive,
							"SineY",
							2880548273004874,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetPeriod,
							"SineY",
							1335922858837057,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.clamp
									,[
[
										5,
										[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												0,
												10
											]
,[
												0,
												11
											]
,[
												0,
												12
											]
											]
										]
										,[
											7,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												6
											]
										]
									]
,[
										0,
										8
									]
,[
										0,
										12
									]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetMagnitude,
							"SineY",
							9546086347402709,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										200
									]
,[
										0,
										300
									]
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2875999558171959,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									6,
									[
										7,
										[
											22,
											7,
											"SineY",
											cr.behaviors.Sin.prototype.exps.Period,
											false,
											null
										]
										,[
											1,
											3.5
										]
									]
									,[
										0,
										60
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							697014214191103,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									7,
									false,
									null
									,4
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							1679947374496845,
							[
							[
								7,
								cr.plugins_.Sprite.prototype.cnds.CompareX,
								null,
								0,
								false,
								false,
								false,
								8620321764940651,
								false
								,[
								[
									8,
									3
								]
,								[
									0,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.layoutwidth
										]
										,[
											0,
											2
										]
									]
								]
								]
							]
							],
							[
							[
								7,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								2616608743138241,
								false
								,[
								[
									0,
									[
										0,
										0
									]
								]
								]
							]
,							[
								7,
								cr.plugins_.Sprite.prototype.acts.SetMirrored,
								null,
								1569988400431465,
								false
								,[
								[
									3,
									0
								]
								]
							]
,							[
								7,
								cr.behaviors.Rotate.prototype.acts.SetSpeed,
								"Rotate",
								5553841664383129,
								false
								,[
								[
									0,
									[
										0,
										360
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9513065103588304,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								500262842026624,
								false
							]
							],
							[
							[
								7,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								7630538064211286,
								false
								,[
								[
									0,
									[
										0,
										180
									]
								]
								]
							]
,							[
								7,
								cr.behaviors.Rotate.prototype.acts.SetSpeed,
								"Rotate",
								7873980795103188,
								false
								,[
								[
									0,
									[
										0,
										-360
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2781035034722321,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							8614778235771306,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Left"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							274611543076194,
							false
							,[
							[
								0,
								[
									5,
									[
										5,
										[
											0,
											-10
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetMirrored,
							null,
							2873359023802845,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							7,
							cr.behaviors.Rotate.prototype.acts.SetSpeed,
							"Rotate",
							2124279413371384,
							false
							,[
							[
								0,
								[
									0,
									360
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetActive,
							"SineX",
							8781261771160412,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetPeriod,
							"SineX",
							1274401343175931,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.clamp
									,[
[
										5,
										[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												0,
												10
											]
,[
												0,
												11
											]
,[
												0,
												12
											]
											]
										]
										,[
											7,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												6
											]
										]
									]
,[
										0,
										8
									]
,[
										0,
										12
									]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetMagnitude,
							"SineX",
							5845050689203545,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										200
									]
,[
										0,
										300
									]
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							330474124499844,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									6,
									[
										7,
										[
											22,
											7,
											"SineX",
											cr.behaviors.Sin.prototype.exps.Period,
											false,
											null
										]
										,[
											1,
											3.5
										]
									]
									,[
										0,
										60
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							9740594403569263,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									7,
									false,
									null
									,4
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5874834162486797,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								5739089602762125,
								false
								,[
								[
									11,
									"posY"
								]
,								[
									8,
									2
								]
,								[
									7,
									[
										0,
										150
									]
								]
								]
							]
							],
							[
							[
								7,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								7120554532317657,
								false
								,[
								[
									0,
									[
										0,
										90
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8862259594927341,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								4948163903978328,
								false
							]
							],
							[
							[
								7,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								706799326847425,
								false
								,[
								[
									0,
									[
										0,
										270
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3712632767070177,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							2342479734653823,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Right"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							4094961542725639,
							false
							,[
							[
								0,
								[
									4,
									[
										4,
										[
											0,
											330
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Rotate.prototype.acts.SetSpeed,
							"Rotate",
							9131155713791027,
							false
							,[
							[
								0,
								[
									0,
									-360
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetActive,
							"SineX",
							6040596197540807,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetPeriod,
							"SineX",
							6800315103163552,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.clamp
									,[
[
										5,
										[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												0,
												10
											]
,[
												0,
												11
											]
,[
												0,
												12
											]
											]
										]
										,[
											7,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												6
											]
										]
									]
,[
										0,
										8
									]
,[
										0,
										12
									]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetMagnitude,
							"SineX",
							3417857172572533,
							false
							,[
							[
								0,
								[
									6,
									[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											200
										]
,[
											0,
											300
										]
										]
									]
									,[
										0,
										-1
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6302302640497418,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									6,
									[
										7,
										[
											22,
											7,
											"SineX",
											cr.behaviors.Sin.prototype.exps.Period,
											false,
											null
										]
										,[
											1,
											3.5
										]
									]
									,[
										0,
										60
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6504528427471122,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									7,
									false,
									null
									,4
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							3056101538053062,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								2019575227432247,
								false
								,[
								[
									11,
									"posY"
								]
,								[
									8,
									2
								]
,								[
									7,
									[
										0,
										150
									]
								]
								]
							]
							],
							[
							[
								7,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								4438535605364664,
								false
								,[
								[
									0,
									[
										0,
										90
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5225990738347377,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								4362456333882943,
								false
							]
							],
							[
							[
								7,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								3014891893141906,
								false
								,[
								[
									0,
									[
										0,
										270
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3878243137474061,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							7762519529561282,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Custom"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							9775757647667883,
							false
							,[
							[
								0,
								[
									23,
									"posX"
								]
							]
,							[
								0,
								[
									5,
									[
										5,
										[
											0,
											-10
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Height,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Rotate.prototype.acts.SetSpeed,
							"Rotate",
							163782796619008,
							false
							,[
							[
								0,
								[
									0,
									360
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetActive,
							"SineY",
							7505335543795563,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetPeriod,
							"SineY",
							8306486777047938,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.clamp
									,[
[
										5,
										[
											0,
											11
										]
										,[
											7,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												6
											]
										]
									]
,[
										0,
										8
									]
,[
										0,
										12
									]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Sin.prototype.acts.SetMagnitude,
							"SineY",
							6389355721872132,
							false
							,[
							[
								0,
								[
									0,
									250
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							5344712093987666,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									6,
									[
										7,
										[
											22,
											7,
											"SineY",
											cr.behaviors.Sin.prototype.exps.Period,
											false,
											null
										]
										,[
											1,
											3.5
										]
									]
									,[
										0,
										60
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2844374799053719,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									7,
									false,
									null
									,4
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetSpeed,
							"Bullet",
							220860446393756,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6292172055756308,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						3490245182811385,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Rock"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						5041651464548339,
						false
						,[
						[
							11,
							"DELAY"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										0,
										1
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											10
										]
									]
								]
,[
									1,
									0.2
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						6177075176229611,
						false
						,[
						[
							4,
							7
						]
,						[
							5,
							[
								2,
								"Enemies"
							]
						]
,						[
							0,
							[
								19,
								cr.system_object.prototype.exps.random
								,[
[
									0,
									20
								]
,[
									0,
									300
								]
								]
							]
						]
,						[
							0,
							[
								0,
								-10
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						311399105025994,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								4,
								[
									0,
									40
								]
								,[
									23,
									"DIFFICULTY"
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8805073208533715,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7066882961740759,
						false
						,[
						[
							10,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8326377653545562,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,4
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3529207118319531,
						false
						,[
						[
							10,
							11
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4878833330474249,
						false
						,[
						[
							10,
							17
						]
,						[
							7,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						1784447657938883,
						false
						,[
						[
							1,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetEnabled,
						"Bullet",
						2664805972629021,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						4762084810499021,
						false
						,[
						[
							0,
							[
								19,
								cr.system_object.prototype.exps.random
								,[
[
									0,
									30
								]
,[
									0,
									70
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
						"Bullet",
						2212873351535509,
						false
						,[
						[
							0,
							[
								0,
								90
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Rotate.prototype.acts.SetSpeed,
						"Rotate",
						6504413716064085,
						false
						,[
						[
							0,
							[
								19,
								cr.system_object.prototype.exps.choose
								,[
[
									0,
									10
								]
,[
									0,
									-10
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8143331340233885,
						false
						,[
						[
							10,
							9
						]
,						[
							7,
							[
								0,
								40
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5419719357793603,
						false
						,[
						[
							10,
							10
						]
,						[
							7,
							[
								0,
								60
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7448569842183506,
						false
						,[
						[
							10,
							8
						]
,						[
							7,
							[
								0,
								2000
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5351346511712818,
						false
						,[
						[
							11,
							"enemyID"
						]
,						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4013229289293006,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						3466920642012786,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Juggernaut"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						7553450683438035,
						false
						,[
						[
							11,
							"DELAY"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										0,
										7
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											5
										]
									]
								]
,[
									0,
									2
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						9192066574587757,
						false
						,[
						[
							4,
							7
						]
,						[
							5,
							[
								2,
								"Enemies"
							]
						]
,						[
							0,
							[
								19,
								cr.system_object.prototype.exps.random
								,[
[
									0,
									60
								]
,[
									0,
									260
								]
								]
							]
						]
,						[
							0,
							[
								0,
								-20
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1313969561761017,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									4,
									[
										0,
										40
									]
									,[
										6,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											4
										]
									]
								]
,[
									0,
									0
								]
,[
									0,
									100
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						9037798143674471,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									4,
									[
										0,
										3
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											4
										]
									]
								]
,[
									0,
									0
								]
,[
									0,
									8
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1160965818682946,
						false
						,[
						[
							10,
							4
						]
,						[
							7,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										120
									]
,[
										0,
										140
									]
									]
								]
								,[
									6,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										3
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7785479224499044,
						false
						,[
						[
							10,
							13
						]
,						[
							7,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										220
									]
,[
										0,
										260
									]
									]
								]
								,[
									6,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										2
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1934394334376715,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,4
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8342116984337026,
						false
						,[
						[
							10,
							11
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5061293559911657,
						false
						,[
						[
							10,
							17
						]
,						[
							7,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						2617795367532287,
						false
						,[
						[
							1,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetEnabled,
						"Bullet",
						2102175933155074,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						9355271842828118,
						false
						,[
						[
							0,
							[
								19,
								cr.system_object.prototype.exps.random
								,[
[
									0,
									10
								]
,[
									4,
									[
										0,
										30
									]
									,[
										23,
										"DIFFICULTY"
									]
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
						"Bullet",
						6496315577749165,
						false
						,[
						[
							0,
							[
								0,
								90
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4459725664751331,
						false
						,[
						[
							10,
							9
						]
,						[
							7,
							[
								0,
								60
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6798715776885197,
						false
						,[
						[
							10,
							10
						]
,						[
							7,
							[
								0,
								40
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						639910179657877,
						false
						,[
						[
							10,
							8
						]
,						[
							7,
							[
								0,
								1000
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7627363358986535,
						false
						,[
						[
							10,
							12
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									4,
									[
										0,
										130
									]
									,[
										6,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											3
										]
									]
								]
,[
									0,
									0
								]
,[
									0,
									200
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						3381486506758228,
						false
						,[
						[
							4,
							2
						]
,						[
							5,
							[
								2,
								"Enemies"
							]
						]
,						[
							7,
							[
								2,
								"PropulsorLeft"
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Sprite.prototype.acts.SetAngle,
						null,
						8231858706372891,
						false
						,[
						[
							0,
							[
								0,
								180
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Sprite.prototype.acts.MoveToBottom,
						null,
						5064879316336401,
						false
					]
,					[
						2,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						64784304121003,
						false
						,[
						[
							4,
							7
						]
,						[
							3,
							0
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						2758496736868982,
						false
						,[
						[
							4,
							2
						]
,						[
							5,
							[
								2,
								"Enemies"
							]
						]
,						[
							7,
							[
								2,
								"PropulsorRight"
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Sprite.prototype.acts.SetAngle,
						null,
						9263955902153603,
						false
						,[
						[
							0,
							[
								0,
								180
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Sprite.prototype.acts.MoveToBottom,
						null,
						3218607965123314,
						false
					]
,					[
						2,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						7000238929053191,
						false
						,[
						[
							4,
							7
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9621435883112217,
						false
						,[
						[
							11,
							"enemyID"
						]
,						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						4384686608971685,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							6677739231019653,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Custom"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							2037127519884588,
							false
							,[
							[
								0,
								[
									23,
									"posX"
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.AddVar,
							null,
							1983258215442149,
							false
							,[
							[
								11,
								"DELAY"
							]
,							[
								7,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.clamp
										,[
[
											5,
											[
												0,
												7
											]
											,[
												7,
												[
													23,
													"DIFFICULTY"
												]
												,[
													0,
													5
												]
											]
										]
,[
											0,
											2
										]
,[
											19,
											cr.system_object.prototype.exps.infinity
										]
										]
									]
									,[
										0,
										2
									]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6823873605209015,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						1908348537382542,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"PiranhaKing"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						4450314257743996,
						false
						,[
						[
							11,
							"DELAY"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										0,
										7
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											5
										]
									]
								]
,[
									0,
									2
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						5431849879129896,
						false
						,[
						[
							4,
							7
						]
,						[
							5,
							[
								2,
								"Enemies"
							]
						]
,						[
							0,
							[
								19,
								cr.system_object.prototype.exps.random
								,[
[
									0,
									60
								]
,[
									0,
									260
								]
								]
							]
						]
,						[
							0,
							[
								0,
								-20
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3587958811806203,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									4,
									[
										0,
										40
									]
									,[
										6,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											4
										]
									]
								]
,[
									0,
									0
								]
,[
									0,
									80
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7343435198217963,
						false
						,[
						[
							10,
							4
						]
,						[
							7,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										120
									]
,[
										0,
										170
									]
									]
								]
								,[
									7,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										2
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6613568922361261,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,4
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6486410759298604,
						false
						,[
						[
							10,
							13
						]
,						[
							7,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										200
									]
,[
										0,
										300
									]
									]
								]
								,[
									6,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										4
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1393922479617533,
						false
						,[
						[
							10,
							14
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,13
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6538860895435364,
						false
						,[
						[
							10,
							11
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8943867644467488,
						false
						,[
						[
							10,
							17
						]
,						[
							7,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						4965679522215596,
						false
						,[
						[
							1,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetEnabled,
						"Bullet",
						8427940435639825,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						3635449925634578,
						false
						,[
						[
							0,
							[
								19,
								cr.system_object.prototype.exps.random
								,[
[
									0,
									10
								]
,[
									4,
									[
										0,
										20
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											2
										]
									]
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
						"Bullet",
						3190109514813171,
						false
						,[
						[
							0,
							[
								0,
								90
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6776220412843854,
						false
						,[
						[
							10,
							9
						]
,						[
							7,
							[
								0,
								60
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						26470638489026,
						false
						,[
						[
							10,
							10
						]
,						[
							7,
							[
								0,
								40
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8319216607194128,
						false
						,[
						[
							10,
							8
						]
,						[
							7,
							[
								0,
								1000
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4126975205918673,
						false
						,[
						[
							10,
							12
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									4,
									[
										0,
										180
									]
									,[
										6,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											4
										]
									]
								]
,[
									0,
									0
								]
,[
									0,
									300
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						128301422892648,
						false
						,[
						[
							11,
							"enemyID"
						]
,						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2362445999095995,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						2350018371872295,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Ray"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						9251957693954974,
						false
						,[
						[
							11,
							"DELAY"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										0,
										2
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											20
										]
									]
								]
,[
									1,
									0.2
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1675685831562579,
						false
						,[
						[
							4,
							7
						]
,						[
							5,
							[
								2,
								"Enemies"
							]
						]
,						[
							0,
							[
								0,
								-100
							]
						]
,						[
							0,
							[
								0,
								-100
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						9606722436721438,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								4,
								[
									0,
									10
								]
								,[
									23,
									"DIFFICULTY"
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6081576027727636,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5665520646984389,
						false
						,[
						[
							10,
							4
						]
,						[
							7,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										160
									]
,[
										0,
										240
									]
									]
								]
								,[
									6,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										3
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4318890209435271,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,4
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8157799040625239,
						false
						,[
						[
							10,
							11
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6577133546248565,
						false
						,[
						[
							10,
							17
						]
,						[
							7,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						8767145286091575,
						false
						,[
						[
							1,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetEnabled,
						"Bullet",
						3614674493056959,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						3554228195347787,
						false
						,[
						[
							0,
							[
								19,
								cr.system_object.prototype.exps.random
								,[
[
									0,
									30
								]
,[
									4,
									[
										0,
										60
									]
									,[
										23,
										"DIFFICULTY"
									]
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8534570860247677,
						false
						,[
						[
							10,
							9
						]
,						[
							7,
							[
								0,
								8
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						9837615861077988,
						false
						,[
						[
							10,
							10
						]
,						[
							7,
							[
								0,
								16
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8334676012899409,
						false
						,[
						[
							10,
							8
						]
,						[
							7,
							[
								0,
								500
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6407982934567339,
						false
						,[
						[
							11,
							"enemyID"
						]
,						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						9063181856205549,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							5081401890068084,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Top"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							7005845579180388,
							false
							,[
							[
								0,
								[
									23,
									"posX"
								]
							]
,							[
								0,
								[
									5,
									[
										5,
										[
											0,
											-10
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Height,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							1768336815303072,
							false
							,[
							[
								0,
								[
									0,
									90
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2518879943986287,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							8571437575647374,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Left"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							6815837992688535,
							false
							,[
							[
								0,
								[
									5,
									[
										5,
										[
											0,
											-10
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							1705037491085156,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						89543602221146,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							6236646408371377,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Right"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							6039303673901624,
							false
							,[
							[
								0,
								[
									4,
									[
										4,
										[
											0,
											330
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							3739240269559505,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5863135105537461,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							3269046885464215,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Custom"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							1762676508078198,
							false
							,[
							[
								0,
								[
									23,
									"posX"
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							2165499816329564,
							false
							,[
							[
								0,
								[
									0,
									90
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetSpeed,
							"Bullet",
							3933052520826055,
							false
							,[
							[
								0,
								[
									7,
									[
										23,
										"Speed"
									]
									,[
										0,
										2
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							5293887091946974,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									190
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6909988890134657,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									7,
									false,
									null
									,4
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2640767341309737,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						4184016533364664,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Phalanx"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						6208668757605117,
						false
						,[
						[
							11,
							"DELAY"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										0,
										2
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											20
										]
									]
								]
,[
									1,
									0.2
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						7435284821308143,
						false
						,[
						[
							4,
							7
						]
,						[
							5,
							[
								2,
								"Enemies"
							]
						]
,						[
							0,
							[
								0,
								-100
							]
						]
,						[
							0,
							[
								0,
								-100
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1149980073999888,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									4,
									[
										0,
										1
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4806926087800923,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								4,
								[
									0,
									3
								]
								,[
									7,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										5
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7191649309665205,
						false
						,[
						[
							10,
							6
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,5
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3570550046773812,
						false
						,[
						[
							10,
							4
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											40
										]
,[
											0,
											70
										]
										]
									]
									,[
										23,
										"DIFFICULTY"
									]
								]
,[
									0,
									15
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4947238086092819,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,4
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3700821771873276,
						false
						,[
						[
							10,
							13
						]
,						[
							7,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										150
									]
,[
										0,
										200
									]
									]
								]
								,[
									6,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										2
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6657065134382518,
						false
						,[
						[
							10,
							14
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,13
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						167653017959244,
						false
						,[
						[
							10,
							11
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						2144336052737059,
						false
						,[
						[
							1,
							[
								10,
								[
									21,
									7,
									true,
									null
									,11
								]
								,[
									2,
									"Block"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						320148989270491,
						false
						,[
						[
							10,
							17
						]
,						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.AnimationName,
								true,
								null
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetEnabled,
						"Bullet",
						4646673069691257,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						6113699267786055,
						false
						,[
						[
							0,
							[
								7,
								[
									23,
									"Speed"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						2074543994329022,
						false
						,[
						[
							10,
							9
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5353433356067661,
						false
						,[
						[
							10,
							10
						]
,						[
							7,
							[
								0,
								20
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						9586995483124686,
						false
						,[
						[
							10,
							8
						]
,						[
							7,
							[
								0,
								500
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						2798208849885878,
						false
						,[
						[
							10,
							12
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									4,
									[
										0,
										130
									]
									,[
										6,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											3
										]
									]
								]
,[
									0,
									0
								]
,[
									0,
									200
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4030581657409427,
						false
						,[
						[
							11,
							"enemyID"
						]
,						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						5726849630422905,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							6160432675292015,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Top"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							7016693048938743,
							false
							,[
							[
								0,
								[
									23,
									"posX"
								]
							]
,							[
								0,
								[
									5,
									[
										5,
										[
											0,
											-10
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Height,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							9074535329403471,
							false
							,[
							[
								0,
								[
									0,
									90
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8196695399281486,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							4766827039810301,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Left"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							2860619598548298,
							false
							,[
							[
								0,
								[
									5,
									[
										5,
										[
											0,
											-10
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							1420165921697462,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3620589379804896,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							4486791886800844,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Right"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							1043062249137635,
							false
							,[
							[
								0,
								[
									4,
									[
										4,
										[
											0,
											330
										]
										,[
											6,
											[
												20,
												7,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												4,
												[
													19,
													cr.system_object.prototype.exps.loopindex
												]
												,[
													0,
													1
												]
											]
										]
									]
									,[
										6,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
										,[
											0,
											10
										]
									]
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							2427633511431075,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1171464964185006,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							1610641174006221,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Custom"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							2911143056079446,
							false
							,[
							[
								0,
								[
									23,
									"posX"
								]
							]
,							[
								0,
								[
									5,
									[
										0,
										-10
									]
									,[
										20,
										7,
										cr.plugins_.Sprite.prototype.exps.Height,
										false,
										null
									]
								]
							]
							]
						]
,						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							7744451644242475,
							false
							,[
							[
								0,
								[
									0,
									90
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2270699658653378,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.clamp
									,[
[
										5,
										[
											0,
											50
										]
										,[
											23,
											"DIFFICULTY"
										]
									]
,[
										0,
										15
									]
,[
										19,
										cr.system_object.prototype.exps.infinity
									]
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							9411962107903876,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									21,
									7,
									false,
									null
									,4
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6421947783889148,
							false
							,[
							[
								10,
								13
							]
,							[
								7,
								[
									0,
									250
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							1954112890291541,
							false
							,[
							[
								10,
								14
							]
,							[
								7,
								[
									21,
									7,
									false,
									null
									,13
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1835738564628603,
					[
					[
						8,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						3833892897892177,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Rock2"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						960438020286732,
						false
						,[
						[
							11,
							"DELAY"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										0,
										2
									]
									,[
										7,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											20
										]
									]
								]
,[
									1,
									0.2
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						6731409992245157,
						false
						,[
						[
							4,
							7
						]
,						[
							5,
							[
								2,
								"Enemies"
							]
						]
,						[
							0,
							[
								19,
								cr.system_object.prototype.exps.random
								,[
[
									0,
									20
								]
,[
									0,
									300
								]
								]
							]
						]
,						[
							0,
							[
								0,
								-10
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7914547729467817,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								4,
								[
									0,
									40
								]
								,[
									23,
									"DIFFICULTY"
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						458395611632287,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								4,
								[
									0,
									3
								]
								,[
									7,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										5
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4316091906085408,
						false
						,[
						[
							10,
							6
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,5
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						132467006611568,
						false
						,[
						[
							10,
							4
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									5,
									[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											100
										]
,[
											0,
											150
										]
										]
									]
									,[
										23,
										"DIFFICULTY"
									]
								]
,[
									0,
									15
								]
,[
									19,
									cr.system_object.prototype.exps.infinity
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7951722554628053,
						false
						,[
						[
							10,
							3
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,4
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8805751451146266,
						false
						,[
						[
							10,
							13
						]
,						[
							7,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										80
									]
,[
										0,
										130
									]
									]
								]
								,[
									6,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										2
									]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1860164475414726,
						false
						,[
						[
							10,
							14
						]
,						[
							7,
							[
								21,
								7,
								false,
								null
								,13
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7356301784212467,
						false
						,[
						[
							10,
							11
						]
,						[
							7,
							[
								20,
								8,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						600104996185958,
						false
						,[
						[
							1,
							[
								21,
								7,
								true,
								null
								,11
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.StopAnim,
						null,
						9947003253026151,
						false
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5981757599596478,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1533677456942604,
						false
						,[
						[
							10,
							17
						]
,						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.AnimationName,
								true,
								null
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetEnabled,
						"Bullet",
						8324515017234757,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						6733283118241819,
						false
						,[
						[
							0,
							[
								19,
								cr.system_object.prototype.exps.random
								,[
[
									0,
									20
								]
,[
									0,
									40
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6438804474658724,
						false
						,[
						[
							10,
							9
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1484386687395664,
						false
						,[
						[
							10,
							10
						]
,						[
							7,
							[
								0,
								20
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3871919015585869,
						false
						,[
						[
							10,
							12
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.clamp
								,[
[
									4,
									[
										0,
										130
									]
									,[
										6,
										[
											23,
											"DIFFICULTY"
										]
										,[
											0,
											3
										]
									]
								]
,[
									0,
									0
								]
,[
									0,
									200
								]
								]
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
						"Bullet",
						5829760825113391,
						false
						,[
						[
							0,
							[
								0,
								90
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1517065289821124,
						false
						,[
						[
							10,
							8
						]
,						[
							7,
							[
								0,
								2000
							]
						]
						]
					]
,					[
						7,
						cr.behaviors.Rotate.prototype.acts.SetSpeed,
						"Rotate",
						6473619010158148,
						false
						,[
						[
							0,
							[
								19,
								cr.system_object.prototype.exps.choose
								,[
[
									0,
									10
								]
,[
									0,
									-10
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3646646373719162,
						false
						,[
						[
							11,
							"enemyID"
						]
,						[
							7,
							[
								20,
								7,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						4803252092761564,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							7338024573831662,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Custom"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							7309603679831198,
							false
							,[
							[
								0,
								[
									23,
									"posX"
								]
							]
,							[
								0,
								[
									23,
									"posY"
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2912604041040997,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									4,
									[
										0,
										30
									]
									,[
										23,
										"DIFFICULTY"
									]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5492239828189769,
					[
					[
						7,
						cr.plugins_.Sprite.prototype.cnds.PickByUID,
						null,
						0,
						false,
						false,
						true,
						4545061092372842,
						false
						,[
						[
							0,
							[
								23,
								"enemyID"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5833380018523027,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							9205631015177622,
							false
							,[
							[
								0,
								[
									0,
									6
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"ExtraHP"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6968042447966142,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									6,
									[
										21,
										7,
										false,
										null
										,0
									]
									,[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											7
										]
										]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5804294215614374,
						[
						[
							8,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							5262738853896524,
							false
							,[
							[
								0,
								[
									0,
									6
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"ExtraSpeed"
								]
							]
							]
						]
						],
						[
						[
							7,
							cr.behaviors.Bullet.prototype.acts.SetSpeed,
							"Bullet",
							2383567599162447,
							false
							,[
							[
								0,
								[
									6,
									[
										22,
										7,
										"Bullet",
										cr.behaviors.Bullet.prototype.exps.Speed,
										false,
										null
									]
									,[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											7
										]
										]
									]
								]
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							4377982008604231,
							false
							,[
							[
								10,
								15
							]
,							[
								7,
								[
									6,
									[
										21,
										7,
										false,
										null
										,15
									]
									,[
										20,
										8,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											7
										]
										]
									]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1475531312388067,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				4122326598567435,
				false
				,[
				[
					1,
					[
						2,
						"LoadEnemyChain"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				1,
				"loopINI",
				0,
				0,
false,false,6980047127643685,false
			]
,			[
				1,
				"loopEND",
				0,
				0,
false,false,4552859214707845,false
			]
,			[
				1,
				"invert",
				1,
				"no",
false,false,9079724444956273,false
			]
,			[
				0,
				null,
				false,
				null,
				7093684778532066,
				[
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					5371479587325767,
					false
					,[
					[
						11,
						"loopEND"
					]
,					[
						7,
						[
							4,
							[
								0,
								5
							]
							,[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									7,
									[
										23,
										"DIFFICULTY"
									]
									,[
										0,
										8
									]
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2165214885431275,
					false
					,[
					[
						11,
						"invert"
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.choose
							,[
[
								2,
								"yes"
							]
,[
								2,
								"no"
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4413523120258499,
				[
				[
					8,
					cr.plugins_.Function.prototype.cnds.CompareParam,
					null,
					0,
					false,
					false,
					false,
					1300688164484169,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Delta"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7626816630517195,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8831238563969743,
						false
						,[
						[
							11,
							"invert"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"no"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.For,
						null,
						0,
						true,
						false,
						false,
						7251689324096224,
						false
						,[
						[
							1,
							[
								2,
								""
							]
						]
,						[
							0,
							[
								23,
								"loopINI"
							]
						]
,						[
							0,
							[
								23,
								"loopEND"
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						1663347963377106,
						false
						,[
						[
							1,
							[
								2,
								"LoadEnemyType"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Delta"
									]
								]
,
								[
									7,
									[
										2,
										"Custom"
									]
								]
,
								[
									7,
									[
										0,
										1
									]
								]
,
								[
									7,
									[
										4,
										[
											0,
											30
										]
										,[
											6,
											[
												7,
												[
													0,
													270
												]
												,[
													23,
													"loopEND"
												]
											]
											,[
												19,
												cr.system_object.prototype.exps.loopindex
											]
										]
									]
								]
,
								[
									7,
									[
										5,
										[
											0,
											-42
										]
										,[
											6,
											[
												19,
												cr.system_object.prototype.exps.loopindex
											]
											,[
												0,
												10
											]
										]
									]
								]
,
								[
									7,
									[
										4,
										[
											0,
											60
										]
										,[
											6,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												2
											]
										]
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1892979149802653,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6092979161937107,
						false
						,[
						[
							11,
							"invert"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"yes"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.For,
						null,
						0,
						true,
						false,
						false,
						2476105870581502,
						false
						,[
						[
							1,
							[
								2,
								""
							]
						]
,						[
							0,
							[
								23,
								"loopEND"
							]
						]
,						[
							0,
							[
								23,
								"loopINI"
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						6632868422732123,
						false
						,[
						[
							1,
							[
								2,
								"LoadEnemyType"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Delta"
									]
								]
,
								[
									7,
									[
										2,
										"Custom"
									]
								]
,
								[
									7,
									[
										0,
										1
									]
								]
,
								[
									7,
									[
										5,
										[
											0,
											300
										]
										,[
											6,
											[
												7,
												[
													0,
													270
												]
												,[
													23,
													"loopEND"
												]
											]
											,[
												19,
												cr.system_object.prototype.exps.loopindex
											]
										]
									]
								]
,
								[
									7,
									[
										5,
										[
											0,
											-42
										]
										,[
											6,
											[
												19,
												cr.system_object.prototype.exps.loopindex
											]
											,[
												0,
												10
											]
										]
									]
								]
,
								[
									7,
									[
										4,
										[
											0,
											60
										]
										,[
											6,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												2
											]
										]
									]
								]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7167110947954447,
				[
				[
					8,
					cr.plugins_.Function.prototype.cnds.CompareParam,
					null,
					0,
					false,
					false,
					false,
					5352810866244703,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Wind"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					7009684250291284,
					false
					,[
					[
						11,
						"loopEND"
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					4655798454098864,
					[
					[
						-1,
						cr.system_object.prototype.cnds.For,
						null,
						0,
						true,
						false,
						false,
						7918970877031113,
						false
						,[
						[
							1,
							[
								2,
								""
							]
						]
,						[
							0,
							[
								23,
								"loopINI"
							]
						]
,						[
							0,
							[
								23,
								"loopEND"
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7313792270861983,
						false
						,[
						[
							1,
							[
								2,
								"LoadEnemyType"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Wind"
									]
								]
,
								[
									7,
									[
										2,
										"Custom"
									]
								]
,
								[
									7,
									[
										0,
										1
									]
								]
,
								[
									7,
									[
										4,
										[
											0,
											20
										]
										,[
											6,
											[
												7,
												[
													0,
													270
												]
												,[
													23,
													"loopEND"
												]
											]
											,[
												19,
												cr.system_object.prototype.exps.loopindex
											]
										]
									]
								]
,
								[
									7,
									[
										0,
										0
									]
								]
,
								[
									7,
									[
										4,
										[
											0,
											60
										]
										,[
											6,
											[
												23,
												"DIFFICULTY"
											]
											,[
												0,
												2
											]
										]
									]
								]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1496984148374941,
				[
				[
					8,
					cr.plugins_.Function.prototype.cnds.CompareParam,
					null,
					0,
					false,
					false,
					false,
					767470230063129,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Juggernaut"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					929827594865353,
					false
					,[
					[
						11,
						"loopEND"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					9039344329738216,
					[
					[
						-1,
						cr.system_object.prototype.cnds.For,
						null,
						0,
						true,
						false,
						false,
						618111614288466,
						false
						,[
						[
							1,
							[
								2,
								""
							]
						]
,						[
							0,
							[
								23,
								"loopINI"
							]
						]
,						[
							0,
							[
								23,
								"loopEND"
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						5902191028435369,
						false
						,[
						[
							1,
							[
								2,
								"LoadEnemyType"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Juggernaut"
									]
								]
,
								[
									7,
									[
										2,
										"Custom"
									]
								]
,
								[
									7,
									[
										0,
										1
									]
								]
,
								[
									7,
									[
										4,
										[
											0,
											40
										]
										,[
											6,
											[
												19,
												cr.system_object.prototype.exps.loopindex
											]
											,[
												0,
												240
											]
										]
									]
								]
,
								[
									7,
									[
										0,
										-20
									]
								]
,
								[
									7,
									[
										0,
										0
									]
								]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2995898602350672,
				[
				[
					8,
					cr.plugins_.Function.prototype.cnds.CompareParam,
					null,
					0,
					false,
					false,
					false,
					747386176204477,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Mixed1"
						]
					]
					]
				]
				],
				[
				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					2606202495426814,
					false
					,[
					[
						1,
						[
							2,
							"LoadEnemyType"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Phalanx"
								]
							]
,
							[
								7,
								[
									2,
									"Custom"
								]
							]
,
							[
								7,
								[
									0,
									1
								]
							]
,
							[
								7,
								[
									1,
									160
								]
							]
,
							[
								7,
								[
									0,
									-10
								]
							]
,
							[
								7,
								[
									0,
									70
								]
							]
					]
					]
				]
,				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					6518502566487635,
					false
					,[
					[
						1,
						[
							2,
							"LoadEnemyType"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Phalanx"
								]
							]
,
							[
								7,
								[
									2,
									"Custom"
								]
							]
,
							[
								7,
								[
									0,
									1
								]
							]
,
							[
								7,
								[
									1,
									193
								]
							]
,
							[
								7,
								[
									0,
									-10
								]
							]
,
							[
								7,
								[
									0,
									70
								]
							]
					]
					]
				]
,				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					2029401073616171,
					false
					,[
					[
						1,
						[
							2,
							"LoadEnemyType"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Phalanx"
								]
							]
,
							[
								7,
								[
									2,
									"Custom"
								]
							]
,
							[
								7,
								[
									0,
									1
								]
							]
,
							[
								7,
								[
									1,
									127
								]
							]
,
							[
								7,
								[
									0,
									-10
								]
							]
,
							[
								7,
								[
									0,
									70
								]
							]
					]
					]
				]
,				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					6544100606198935,
					false
					,[
					[
						1,
						[
							2,
							"LoadEnemyType"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Ray"
								]
							]
,
							[
								7,
								[
									2,
									"Custom"
								]
							]
,
							[
								7,
								[
									0,
									1
								]
							]
,
							[
								7,
								[
									1,
									160
								]
							]
,
							[
								7,
								[
									0,
									-68
								]
							]
,
							[
								7,
								[
									0,
									70
								]
							]
					]
					]
				]
,				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3735936512033413,
					false
					,[
					[
						1,
						[
							2,
							"LoadEnemyType"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Ray"
								]
							]
,
							[
								7,
								[
									2,
									"Custom"
								]
							]
,
							[
								7,
								[
									0,
									1
								]
							]
,
							[
								7,
								[
									1,
									193
								]
							]
,
							[
								7,
								[
									0,
									-68
								]
							]
,
							[
								7,
								[
									0,
									70
								]
							]
					]
					]
				]
,				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					7695667548091242,
					false
					,[
					[
						1,
						[
							2,
							"LoadEnemyType"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Ray"
								]
							]
,
							[
								7,
								[
									2,
									"Custom"
								]
							]
,
							[
								7,
								[
									0,
									1
								]
							]
,
							[
								7,
								[
									1,
									127
								]
							]
,
							[
								7,
								[
									0,
									-68
								]
							]
,
							[
								7,
								[
									0,
									70
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4273602574526846,
				[
				[
					8,
					cr.plugins_.Function.prototype.cnds.CompareParam,
					null,
					0,
					false,
					false,
					false,
					1946364507161142,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Rock"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					899218980695499,
					[
					[
						-1,
						cr.system_object.prototype.cnds.For,
						null,
						0,
						true,
						false,
						false,
						5479204398287856,
						false
						,[
						[
							1,
							[
								2,
								""
							]
						]
,						[
							0,
							[
								23,
								"loopINI"
							]
						]
,						[
							0,
							[
								23,
								"loopEND"
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2704259154413593,
						false
						,[
						[
							1,
							[
								2,
								"LoadEnemyType"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Rock2"
									]
								]
,
								[
									7,
									[
										2,
										"Custom"
									]
								]
,
								[
									7,
									[
										0,
										1
									]
								]
,
								[
									7,
									[
										4,
										[
											0,
											30
										]
										,[
											6,
											[
												7,
												[
													0,
													270
												]
												,[
													23,
													"loopEND"
												]
											]
											,[
												19,
												cr.system_object.prototype.exps.loopindex
											]
										]
									]
								]
,
								[
									7,
									[
										4,
										[
											0,
											-42
										]
										,[
											6,
											[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													20
												]
												]
											]
											,[
												19,
												cr.system_object.prototype.exps.choose
												,[
[
													0,
													1
												]
,[
													0,
													-1
												]
												]
											]
										]
									]
								]
,
								[
									7,
									[
										0,
										0
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						224561171097907,
						false
						,[
						[
							11,
							"DELAY"
						]
,						[
							7,
							[
								1,
								0.5
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5435537285624212,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				7938224216312457,
				false
				,[
				[
					1,
					[
						2,
						"LoadBoss"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				1881217930029984,
				false
				,[
				[
					11,
					"DELAY"
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.infinity
					]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Play,
				null,
				9714838989177386,
				false
				,[
				[
					2,
					["bossmusic",true]
				]
,				[
					3,
					1
				]
,				[
					0,
					[
						0,
						-100
					]
				]
,				[
					1,
					[
						2,
						"BossMusic"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				2989365933005749,
				false
				,[
				[
					11,
					"GAMESTATE"
				]
,				[
					7,
					[
						2,
						"BOSS"
					]
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				1228353126424968,
				[
				[
					8,
					cr.plugins_.Function.prototype.cnds.CompareParam,
					null,
					0,
					false,
					false,
					false,
					8491724130973701,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2841990129035969,
					false
					,[
					[
						4,
						38
					]
,					[
						5,
						[
							2,
							"Boss"
						]
					]
,					[
						0,
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.layoutwidth
							]
							,[
								0,
								2
							]
						]
					]
,					[
						0,
						[
							0,
							-100
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.MoveToBottom,
					null,
					9973724652398033,
					false
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					496756689278361,
					false
					,[
					[
						10,
						1
					]
,					[
						7,
						[
							2,
							"Base"
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					2972072926091368,
					false
					,[
					[
						1,
						[
							2,
							"Boss1Base"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					38,
					cr.behaviors.Rotate.prototype.acts.SetSpeed,
					"Rotate",
					6857540585806512,
					false
					,[
					[
						0,
						[
							0,
							45
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					9558620645787567,
					false
					,[
					[
						10,
						2
					]
,					[
						7,
						[
							2,
							"Boss1"
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
					null,
					1846343377338491,
					false
					,[
					[
						10,
						9
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					6433234037915412,
					false
					,[
					[
						4,
						38
					]
,					[
						5,
						[
							2,
							"Boss"
						]
					]
,					[
						0,
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.layoutwidth
							]
							,[
								0,
								2
							]
						]
					]
,					[
						0,
						[
							0,
							-100
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.MoveToBottom,
					null,
					1577820762690766,
					false
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					4312630913650825,
					false
					,[
					[
						10,
						1
					]
,					[
						7,
						[
							2,
							"Saw"
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					496073944208093,
					false
					,[
					[
						1,
						[
							2,
							"Boss1Saw"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					38,
					cr.behaviors.Rotate.prototype.acts.SetSpeed,
					"Rotate",
					4282947644848427,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					6075711709662803,
					false
					,[
					[
						10,
						2
					]
,					[
						7,
						[
							2,
							"Boss1"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					8285951899095524,
					false
					,[
					[
						4,
						38
					]
,					[
						5,
						[
							2,
							"Boss"
						]
					]
,					[
						0,
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.layoutwidth
							]
							,[
								0,
								2
							]
						]
					]
,					[
						0,
						[
							0,
							-100
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.MoveToBottom,
					null,
					6943259308151731,
					false
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					192388630011882,
					false
					,[
					[
						10,
						1
					]
,					[
						7,
						[
							2,
							"Center"
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					6921768878465483,
					false
					,[
					[
						1,
						[
							2,
							"Boss1Center"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					38,
					cr.behaviors.Rotate.prototype.acts.SetSpeed,
					"Rotate",
					7868330636545237,
					false
					,[
					[
						0,
						[
							0,
							-180
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					9774990784889526,
					false
					,[
					[
						10,
						2
					]
,					[
						7,
						[
							2,
							"Boss1"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					5977345589920956,
					false
					,[
					[
						11,
						"BOSS_HP"
					]
,					[
						7,
						[
							0,
							1000
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.NinePatch.prototype.acts.SetInstanceVar,
					null,
					8413635804800691,
					false
					,[
					[
						10,
						0
					]
,					[
						7,
						[
							23,
							"BOSS_HP"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7537007335405848,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				7721771312428249,
				false
				,[
				[
					1,
					[
						2,
						"MoveBoss"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				1,
				"randomMult",
				0,
				0,
false,false,235632565980881,false
			]
,			[
				1,
				"randomNum",
				0,
				0,
false,false,712423950255712,false
			]
,			[
				0,
				null,
				false,
				null,
				1933990039521279,
				[
				[
					8,
					cr.plugins_.Function.prototype.cnds.CompareParam,
					null,
					0,
					false,
					false,
					false,
					1754589258931547,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					7341285277494584,
					false
					,[
					[
						11,
						"randomMult"
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.choose
							,[
[
								0,
								1
							]
,[
								0,
								-1
							]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					7836854797694678,
					false
					,[
					[
						11,
						"randomNum"
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.random
							,[
[
								0,
								7
							]
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					6764901604846526,
					[
					[
						-1,
						cr.system_object.prototype.cnds.ForEach,
						null,
						0,
						true,
						false,
						false,
						7156240123335878,
						false
						,[
						[
							4,
							38
						]
						]
					]
					],
					[
					[
						38,
						cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
						null,
						1211741507944926,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								6,
								[
									19,
									cr.system_object.prototype.exps.dt
								]
								,[
									0,
									60
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						7220324380404116,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1752792601390872,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							38,
							cr.behaviors.Bullet.prototype.acts.SetEnabled,
							"Bullet",
							2741955329070277,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							38,
							cr.behaviors.Bullet.prototype.acts.SetSpeed,
							"Bullet",
							2782176630212602,
							false
							,[
							[
								0,
								[
									0,
									20
								]
							]
							]
						]
,						[
							38,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							8719310932311519,
							false
							,[
							[
								0,
								[
									0,
									90
								]
							]
							]
						]
,						[
							38,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							7396948541980968,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7374873471709144,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							4239894080287554,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							3602768017157384,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareY,
								null,
								0,
								false,
								false,
								false,
								3495261440619288,
								false
								,[
								[
									8,
									5
								]
,								[
									0,
									[
										0,
										100
									]
								]
								]
							]
							],
							[
							[
								38,
								cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
								null,
								7042985290698766,
								false
								,[
								[
									10,
									7
								]
,								[
									7,
									[
										6,
										[
											0,
											60
										]
										,[
											19,
											cr.system_object.prototype.exps.dt
										]
									]
								]
								]
							]
,							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetEnabled,
								"Bullet",
								6070327747632714,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								49753732607528,
								[
								[
									38,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									1997906563463969,
									false
									,[
									[
										10,
										1
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Saw"
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.cnds.TriggerOnce,
									null,
									0,
									false,
									false,
									false,
									4986862935571229,
									false
								]
								],
								[
								[
									38,
									cr.behaviors.Rotate.prototype.acts.SetSpeed,
									"Rotate",
									8176611141666915,
									false
									,[
									[
										0,
										[
											0,
											0
										]
									]
									]
								]
								]
								,[
								[
									0,
									null,
									false,
									null,
									5893600710471801,
									[
									[
										-1,
										cr.system_object.prototype.cnds.For,
										null,
										0,
										true,
										false,
										false,
										2202671224974545,
										false
										,[
										[
											1,
											[
												2,
												""
											]
										]
,										[
											0,
											[
												0,
												1
											]
										]
,										[
											0,
											[
												0,
												8
											]
										]
										]
									]
									],
									[
									[
										38,
										cr.plugins_.Sprite.prototype.acts.Spawn,
										null,
										7574551285478176,
										false
										,[
										[
											4,
											10
										]
,										[
											5,
											[
												2,
												"Shoots"
											]
										]
,										[
											7,
											[
												19,
												cr.system_object.prototype.exps.loopindex
											]
										]
										]
									]
,									[
										10,
										cr.plugins_.Particles.prototype.acts.SetRate,
										null,
										141056490483853,
										false
										,[
										[
											0,
											[
												0,
												6
											]
										]
										]
									]
,									[
										10,
										cr.plugins_.Particles.prototype.acts.SetInitSpeed,
										null,
										8580730260912857,
										false
										,[
										[
											0,
											[
												0,
												70
											]
										]
										]
									]
,									[
										10,
										cr.plugins_.Particles.prototype.acts.SetAngle,
										null,
										9861634779615131,
										false
										,[
										[
											0,
											[
												4,
												[
													20,
													38,
													cr.plugins_.Sprite.prototype.exps.Angle,
													false,
													null
												]
												,[
													6,
													[
														0,
														45
													]
													,[
														5,
														[
															19,
															cr.system_object.prototype.exps.loopindex
														]
														,[
															0,
															1
														]
													]
												]
											]
										]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								706474131063247,
								[
								[
									38,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									7102946415934662,
									false
									,[
									[
										10,
										7
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									38,
									cr.behaviors.Bullet.prototype.acts.SetEnabled,
									"Bullet",
									4718259318190733,
									false
									,[
									[
										3,
										1
									]
									]
								]
,								[
									38,
									cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
									"Bullet",
									9711645328864229,
									false
									,[
									[
										0,
										[
											6,
											[
												0,
												180
											]
											,[
												23,
												"randomMult"
											]
										]
									]
									]
								]
,								[
									38,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									1116517889151392,
									false
									,[
									[
										10,
										3
									]
,									[
										7,
										[
											0,
											2
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3446367075236308,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3403398239181654,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						[
							40,
							cr.plugins_.NinePatch.prototype.acts.SetVisible,
							null,
							5169694224583794,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							39,
							cr.plugins_.NinePatch.prototype.acts.SetVisible,
							null,
							7689345759975165,
							false
							,[
							[
								3,
								1
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5698538386000063,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareX,
								null,
								0,
								false,
								false,
								false,
								330780188246821,
								false
								,[
								[
									8,
									5
								]
,								[
									0,
									[
										5,
										[
											0,
											320
										]
										,[
											7,
											[
												20,
												38,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												0,
												2
											]
										]
									]
								]
								]
							]
							],
							[
							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								9871111957184791,
								false
								,[
								[
									0,
									[
										0,
										180
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7042684903845796,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareX,
								null,
								0,
								false,
								false,
								false,
								1570732497893136,
								false
								,[
								[
									8,
									2
								]
,								[
									0,
									[
										7,
										[
											20,
											38,
											cr.plugins_.Sprite.prototype.exps.Width,
											false,
											null
										]
										,[
											0,
											2
										]
									]
								]
								]
							]
							],
							[
							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								8973918504376565,
								false
								,[
								[
									0,
									[
										0,
										0
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2198166801505681,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								4868091602599542,
								false
								,[
								[
									10,
									1
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Base"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2141999699887331,
								[
								[
									38,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									5392662174017933,
									false
									,[
									[
										10,
										5
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									38,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									6039845288394435,
									false
									,[
									[
										10,
										5
									]
,									[
										7,
										[
											21,
											38,
											false,
											null
											,6
										]
									]
									]
								]
,								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									5827362134224111,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													38,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Top"
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													4,
													[
														0,
														90
													]
													,[
														19,
														cr.system_object.prototype.exps.random
														,[
[
															0,
															-10
														]
,[
															0,
															10
														]
														]
													]
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													0,
													0
												]
											]
,
											[
												7,
												[
													21,
													38,
													false,
													null
													,4
												]
											]
									]
									]
								]
,								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									4035757135070029,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													38,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Bottom"
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													4,
													[
														0,
														90
													]
													,[
														19,
														cr.system_object.prototype.exps.random
														,[
[
															0,
															-10
														]
,[
															0,
															10
														]
														]
													]
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													0,
													0
												]
											]
,
											[
												7,
												[
													21,
													38,
													false,
													null
													,4
												]
											]
									]
									]
								]
,								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									8775732661161084,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													38,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Left"
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													4,
													[
														0,
														90
													]
													,[
														19,
														cr.system_object.prototype.exps.random
														,[
[
															0,
															-10
														]
,[
															0,
															10
														]
														]
													]
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													0,
													0
												]
											]
,
											[
												7,
												[
													21,
													38,
													false,
													null
													,4
												]
											]
									]
									]
								]
,								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									5047489137511446,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													38,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Right"
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													4,
													[
														0,
														90
													]
													,[
														19,
														cr.system_object.prototype.exps.random
														,[
[
															0,
															-10
														]
,[
															0,
															10
														]
														]
													]
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													0,
													0
												]
											]
,
											[
												7,
												[
													21,
													38,
													false,
													null
													,4
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2672878394686477,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3721304267429748,
							false
							,[
							[
								11,
								"BOSS_HP"
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									700
								]
							]
							]
						]
,						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9386618660652976,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							9597616461056593,
							false
							,[
							[
								10,
								7
							]
,							[
								7,
								[
									21,
									38,
									false,
									null
									,8
								]
							]
							]
						]
,						[
							38,
							cr.behaviors.Bullet.prototype.acts.SetEnabled,
							"Bullet",
							4539641404694731,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							38,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2810454549560831,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									0,
									3
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7261488811587389,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6570001461141021,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							5231856110744563,
							false
							,[
							[
								10,
								7
							]
,							[
								7,
								[
									6,
									[
										0,
										60
									]
									,[
										19,
										cr.system_object.prototype.exps.dt
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							4447176352779109,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Compare,
								null,
								0,
								false,
								false,
								false,
								9720712692732185,
								false
								,[
								[
									7,
									[
										22,
										38,
										"Rotate",
										cr.behaviors.Rotate.prototype.exps.Speed,
										false,
										null
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								2968340618591247,
								false
								,[
								[
									10,
									1
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Saw"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.cnds.TriggerOnce,
								null,
								0,
								false,
								false,
								false,
								7242414664435248,
								false
							]
							],
							[
							[
								38,
								cr.behaviors.Rotate.prototype.acts.SetSpeed,
								"Rotate",
								9762895698396812,
								false
								,[
								[
									0,
									[
										0,
										180
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								125825461416682,
								[
								[
									-1,
									cr.system_object.prototype.cnds.For,
									null,
									0,
									true,
									false,
									false,
									7649053119966496,
									false
									,[
									[
										1,
										[
											2,
											""
										]
									]
,									[
										0,
										[
											0,
											1
										]
									]
,									[
										0,
										[
											0,
											8
										]
									]
									]
								]
								],
								[
								[
									38,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									6551375305409835,
									false
									,[
									[
										4,
										10
									]
,									[
										5,
										[
											2,
											"Shoots"
										]
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps.loopindex
										]
									]
									]
								]
,								[
									10,
									cr.plugins_.Particles.prototype.acts.SetRate,
									null,
									2916627968093849,
									false
									,[
									[
										0,
										[
											0,
											6
										]
									]
									]
								]
,								[
									10,
									cr.plugins_.Particles.prototype.acts.SetInitSpeed,
									null,
									446618978634199,
									false
									,[
									[
										0,
										[
											0,
											70
										]
									]
									]
								]
,								[
									10,
									cr.plugins_.Particles.prototype.acts.SetAngle,
									null,
									7119041505868662,
									false
									,[
									[
										0,
										[
											4,
											[
												4,
												[
													20,
													38,
													cr.plugins_.Sprite.prototype.exps.Angle,
													false,
													null
												]
												,[
													0,
													180
												]
											]
											,[
												6,
												[
													0,
													45
												]
												,[
													5,
													[
														19,
														cr.system_object.prototype.exps.loopindex
													]
													,[
														0,
														1
													]
												]
											]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2748866669474706,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7194541812614653,
								false
								,[
								[
									10,
									7
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetEnabled,
								"Bullet",
								3250768489228612,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								2970806964398532,
								false
								,[
								[
									0,
									[
										6,
										[
											0,
											180
										]
										,[
											23,
											"randomMult"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								3027904782321686,
								false
								,[
								[
									10,
									7
								]
,								[
									7,
									[
										6,
										[
											21,
											38,
											false,
											null
											,8
										]
										,[
											23,
											"randomNum"
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								8019255451626792,
								false
								,[
								[
									10,
									3
								]
,								[
									7,
									[
										0,
										4
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9159059637722738,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8533817370639602,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							4658743324497438,
							false
							,[
							[
								10,
								7
							]
,							[
								7,
								[
									6,
									[
										0,
										60
									]
									,[
										19,
										cr.system_object.prototype.exps.dt
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							3954283613656049,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								6066260402027702,
								false
								,[
								[
									10,
									7
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								5802504109304291,
								false
								,[
								[
									0,
									[
										0,
										90
									]
								]
								]
							]
,							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								6272640515433152,
								false
								,[
								[
									0,
									[
										0,
										400
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								3515609711648303,
								false
								,[
								[
									10,
									7
								]
,								[
									7,
									[
										7,
										[
											21,
											38,
											false,
											null
											,8
										]
										,[
											0,
											2
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								119999925281329,
								false
								,[
								[
									10,
									3
								]
,								[
									7,
									[
										0,
										5
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								9913691375119778,
								[
								[
									38,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									1885260655243974,
									false
									,[
									[
										10,
										1
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Saw"
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.cnds.TriggerOnce,
									null,
									0,
									false,
									false,
									false,
									2135883075364553,
									false
								]
								],
								[
								[
									38,
									cr.behaviors.Rotate.prototype.acts.SetSpeed,
									"Rotate",
									2395457472765405,
									false
									,[
									[
										0,
										[
											0,
											360
										]
									]
									]
								]
								]
								,[
								[
									0,
									null,
									false,
									null,
									7153361971455195,
									[
									[
										-1,
										cr.system_object.prototype.cnds.For,
										null,
										0,
										true,
										false,
										false,
										6514261052810989,
										false
										,[
										[
											1,
											[
												2,
												""
											]
										]
,										[
											0,
											[
												0,
												1
											]
										]
,										[
											0,
											[
												0,
												8
											]
										]
										]
									]
									],
									[
									[
										38,
										cr.plugins_.Sprite.prototype.acts.Spawn,
										null,
										735694639337745,
										false
										,[
										[
											4,
											10
										]
,										[
											5,
											[
												2,
												"Shoots"
											]
										]
,										[
											7,
											[
												19,
												cr.system_object.prototype.exps.loopindex
											]
										]
										]
									]
,									[
										10,
										cr.plugins_.Particles.prototype.acts.SetRate,
										null,
										7189098420353269,
										false
										,[
										[
											0,
											[
												0,
												6
											]
										]
										]
									]
,									[
										10,
										cr.plugins_.Particles.prototype.acts.SetInitSpeed,
										null,
										5093725459540983,
										false
										,[
										[
											0,
											[
												0,
												70
											]
										]
										]
									]
,									[
										10,
										cr.plugins_.Particles.prototype.acts.SetAngle,
										null,
										9946977496839775,
										false
										,[
										[
											0,
											[
												4,
												[
													20,
													38,
													cr.plugins_.Sprite.prototype.exps.Angle,
													false,
													null
												]
												,[
													6,
													[
														0,
														45
													]
													,[
														5,
														[
															19,
															cr.system_object.prototype.exps.loopindex
														]
														,[
															0,
															1
														]
													]
												]
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5686454048177798,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								1673090949571425,
								false
							]
							],
							[
							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								6065566568808791,
								false
								,[
								[
									0,
									[
										0,
										100
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								6053092109585706,
								[
								[
									38,
									cr.plugins_.Sprite.prototype.cnds.CompareX,
									null,
									0,
									false,
									false,
									false,
									46067649998916,
									false
									,[
									[
										8,
										5
									]
,									[
										0,
										[
											5,
											[
												0,
												320
											]
											,[
												7,
												[
													20,
													38,
													cr.plugins_.Sprite.prototype.exps.Width,
													false,
													null
												]
												,[
													0,
													2
												]
											]
										]
									]
									]
								]
								],
								[
								[
									38,
									cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
									"Bullet",
									7715264993486001,
									false
									,[
									[
										0,
										[
											0,
											180
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								3666554731756283,
								[
								[
									38,
									cr.plugins_.Sprite.prototype.cnds.CompareX,
									null,
									0,
									false,
									false,
									false,
									4905880428445416,
									false
									,[
									[
										8,
										2
									]
,									[
										0,
										[
											7,
											[
												20,
												38,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												0,
												2
											]
										]
									]
									]
								]
								],
								[
								[
									38,
									cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
									"Bullet",
									4095034677276696,
									false
									,[
									[
										0,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9689769766440704,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9267095976030468,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7279337886977962,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareY,
								null,
								0,
								false,
								false,
								false,
								9121520129766266,
								false
								,[
								[
									8,
									5
								]
,								[
									0,
									[
										0,
										400
									]
								]
								]
							]
							],
							[
							[
								38,
								cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
								null,
								7061961789436727,
								false
								,[
								[
									10,
									7
								]
,								[
									7,
									[
										6,
										[
											0,
											60
										]
										,[
											19,
											cr.system_object.prototype.exps.dt
										]
									]
								]
								]
							]
,							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetEnabled,
								"Bullet",
								2683125108819262,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								8750324136610553,
								[
								[
									38,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									1532250461219442,
									false
									,[
									[
										10,
										7
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									38,
									cr.behaviors.Bullet.prototype.acts.SetEnabled,
									"Bullet",
									1146102469487472,
									false
									,[
									[
										3,
										1
									]
									]
								]
,								[
									38,
									cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
									"Bullet",
									6099508179125365,
									false
									,[
									[
										0,
										[
											0,
											-90
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							6772848883440309,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareY,
								null,
								0,
								false,
								false,
								false,
								5902003707396947,
								false
								,[
								[
									8,
									3
								]
,								[
									0,
									[
										0,
										100
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								1476063166454126,
								false
								,[
								[
									10,
									7
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								38,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								5055030070362768,
								false
								,[
								[
									10,
									3
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								9208855840303411,
								false
								,[
								[
									10,
									7
								]
,								[
									7,
									[
										21,
										38,
										false,
										null
										,8
									]
								]
								]
							]
,							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetEnabled,
								"Bullet",
								5020152006823363,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								1252986250077885,
								[
								[
									38,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									8765362136141436,
									false
									,[
									[
										10,
										1
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Saw"
										]
									]
									]
								]
								],
								[
								[
									38,
									cr.behaviors.Rotate.prototype.acts.SetSpeed,
									"Rotate",
									8582030391555356,
									false
									,[
									[
										0,
										[
											0,
											180
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								4915894173680982,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									6005306430251891,
									false
									,[
									[
										11,
										"BOSS_HP"
									]
,									[
										8,
										4
									]
,									[
										7,
										[
											0,
											400
										]
									]
									]
								]
								],
								[
								[
									38,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									5483713604230725,
									false
									,[
									[
										10,
										3
									]
,									[
										7,
										[
											0,
											3
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								1819381686488153,
								[
								[
									-1,
									cr.system_object.prototype.cnds.Else,
									null,
									0,
									false,
									false,
									false,
									3109124878153143,
									false
								]
								],
								[
								[
									38,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									9884386331894135,
									false
									,[
									[
										10,
										3
									]
,									[
										7,
										[
											0,
											6
										]
									]
									]
								]
								]
								,[
								[
									0,
									null,
									false,
									null,
									646815231375781,
									[
									[
										38,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										8624110819424485,
										false
										,[
										[
											10,
											1
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"Base"
											]
										]
										]
									]
									],
									[
									[
										38,
										cr.behaviors.Rotate.prototype.acts.SetSpeed,
										"Rotate",
										1790936689071388,
										false
										,[
										[
											0,
											[
												0,
												0
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8777514955317738,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							7340818791815684,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									6
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							91628965342224,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Compare,
								null,
								0,
								false,
								false,
								false,
								3463867407509189,
								false
								,[
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.distance
										,[
[
											20,
											38,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
,[
											20,
											38,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
,[
											0,
											160
										]
,[
											0,
											100
										]
										]
									]
								]
,								[
									8,
									4
								]
,								[
									7,
									[
										0,
										2
									]
								]
								]
							]
							],
							[
							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetEnabled,
								"Bullet",
								9332730461390955,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								5229459312940407,
								false
								,[
								[
									0,
									[
										0,
										100
									]
								]
								]
							]
,							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
								"Bullet",
								2786815174381613,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.angle
										,[
[
											20,
											38,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
,[
											20,
											38,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
,[
											0,
											160
										]
,[
											0,
											100
										]
										]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8451065693495958,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								1515351088877937,
								false
							]
							],
							[
							[
								38,
								cr.plugins_.Sprite.prototype.acts.SetPos,
								null,
								7457917564108328,
								false
								,[
								[
									0,
									[
										0,
										160
									]
								]
,								[
									0,
									[
										0,
										100
									]
								]
								]
							]
,							[
								38,
								cr.behaviors.Bullet.prototype.acts.SetEnabled,
								"Bullet",
								2487143655385901,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								6687064179164688,
								[
								[
									38,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									2222891617565403,
									false
									,[
									[
										10,
										1
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Base"
										]
									]
									]
								]
								],
								[
								[
									38,
									cr.plugins_.Sprite.prototype.acts.SetAngle,
									null,
									9740961428368463,
									false
									,[
									[
										0,
										[
											19,
											cr.system_object.prototype.exps.anglelerp
											,[
[
												20,
												38,
												cr.plugins_.Sprite.prototype.exps.Angle,
												false,
												null
											]
,[
												0,
												0
											]
,[
												6,
												[
													0,
													2
												]
												,[
													19,
													cr.system_object.prototype.exps.dt
												]
											]
											]
										]
									]
									]
								]
								]
								,[
								[
									0,
									null,
									false,
									null,
									9899814602064719,
									[
									[
										38,
										cr.plugins_.Sprite.prototype.cnds.IsBetweenAngles,
										null,
										0,
										false,
										false,
										false,
										8014264696811733,
										false
										,[
										[
											0,
											[
												0,
												-2
											]
										]
,										[
											0,
											[
												0,
												2
											]
										]
										]
									]
									],
									[
									[
										38,
										cr.plugins_.Sprite.prototype.acts.SetAngle,
										null,
										2486611891578532,
										false
										,[
										[
											0,
											[
												0,
												0
											]
										]
										]
									]
,									[
										38,
										cr.behaviors.Rotate.prototype.acts.SetSpeed,
										"Rotate",
										292446715919788,
										false
										,[
										[
											0,
											[
												0,
												0
											]
										]
										]
									]
,									[
										38,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										4206440928818016,
										false
										,[
										[
											10,
											7
										]
,										[
											7,
											[
												7,
												[
													21,
													38,
													false,
													null
													,8
												]
												,[
													0,
													2
												]
											]
										]
										]
									]
,									[
										38,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										7260650095000986,
										false
										,[
										[
											10,
											3
										]
,										[
											7,
											[
												0,
												7
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6344279448721506,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							613356584718962,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									7
								]
							]
							]
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							8928138721454505,
							false
							,[
							[
								10,
								7
							]
,							[
								7,
								[
									6,
									[
										0,
										60
									]
									,[
										19,
										cr.system_object.prototype.exps.dt
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							1458663418947954,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								1181358034685134,
								false
								,[
								[
									10,
									7
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								3896316196233907,
								false
								,[
								[
									10,
									1
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Base"
									]
								]
								]
							]
							],
							[
							[
								38,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								7214863235578113,
								false
								,[
								[
									4,
									25
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										2,
										"Left"
									]
								]
								]
							]
,							[
								25,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								636861071018062,
								false
								,[
								[
									0,
									[
										0,
										90
									]
								]
								]
							]
,							[
								25,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								5483676134480457,
								false
								,[
								[
									1,
									[
										2,
										"Charge"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								25,
								cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
								null,
								42561244148911,
								false
								,[
								[
									10,
									1
								]
,								[
									3,
									1
								]
								]
							]
,							[
								25,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								1891458441292713,
								false
								,[
								[
									10,
									2
								]
,								[
									7,
									[
										2,
										"Left"
									]
								]
								]
							]
,							[
								25,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								8105142497855013,
								false
								,[
								[
									4,
									38
								]
,								[
									3,
									1
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								6347068100456786,
								false
								,[
								[
									4,
									25
								]
,								[
									5,
									[
										2,
										"Shoots"
									]
								]
,								[
									7,
									[
										2,
										"Right"
									]
								]
								]
							]
,							[
								25,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								330068674730199,
								false
								,[
								[
									0,
									[
										0,
										-90
									]
								]
								]
							]
,							[
								25,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								742407093926214,
								false
								,[
								[
									1,
									[
										2,
										"Charge"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								25,
								cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
								null,
								4608479182315981,
								false
								,[
								[
									10,
									1
								]
,								[
									3,
									1
								]
								]
							]
,							[
								25,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								3337861111311237,
								false
								,[
								[
									10,
									2
								]
,								[
									7,
									[
										2,
										"Right"
									]
								]
								]
							]
,							[
								25,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								901831107892633,
								false
								,[
								[
									4,
									38
								]
,								[
									3,
									1
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								1628762846442047,
								false
								,[
								[
									10,
									7
								]
,								[
									7,
									[
										7,
										[
											21,
											38,
											false,
											null
											,8
										]
										,[
											0,
											2
										]
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								5677109374036491,
								false
								,[
								[
									10,
									3
								]
,								[
									7,
									[
										0,
										8
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3819474382280164,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6010864556629659,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									8
								]
							]
							]
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							3148134664508989,
							false
							,[
							[
								10,
								7
							]
,							[
								7,
								[
									6,
									[
										0,
										60
									]
									,[
										19,
										cr.system_object.prototype.exps.dt
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							1963686330692795,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								9459895090219414,
								false
								,[
								[
									10,
									7
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								8509090695603449,
								false
								,[
								[
									10,
									1
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Base"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								8291791108070346,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									6807567278337696,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Left"
										]
									]
									]
								]
								],
								[
								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									1818691079761644,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAngle,
									null,
									6997617272784171,
									false
									,[
									[
										0,
										[
											19,
											cr.system_object.prototype.exps.anglelerp
											,[
[
												20,
												25,
												cr.plugins_.Sprite.prototype.exps.Angle,
												false,
												null
											]
,[
												0,
												0
											]
,[
												6,
												[
													0,
													2
												]
												,[
													19,
													cr.system_object.prototype.exps.dt
												]
											]
											]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								7487787841282962,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									1289208806540735,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Right"
										]
									]
									]
								]
								],
								[
								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									225068958700398,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAngle,
									null,
									8510264620401438,
									false
									,[
									[
										0,
										[
											19,
											cr.system_object.prototype.exps.anglelerp
											,[
[
												20,
												25,
												cr.plugins_.Sprite.prototype.exps.Angle,
												false,
												null
											]
,[
												0,
												0
											]
,[
												6,
												[
													0,
													2
												]
												,[
													19,
													cr.system_object.prototype.exps.dt
												]
											]
											]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								912480772059951,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									968406471936629,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Left"
										]
									]
									]
								]
,								[
									25,
									cr.plugins_.Sprite.prototype.cnds.IsBetweenAngles,
									null,
									0,
									false,
									false,
									false,
									7652598095238745,
									false
									,[
									[
										0,
										[
											0,
											-1
										]
									]
,									[
										0,
										[
											0,
											1
										]
									]
									]
								]
								],
								[
								[
									38,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									7373906083042062,
									false
									,[
									[
										10,
										7
									]
,									[
										7,
										[
											7,
											[
												21,
												38,
												false,
												null
												,8
											]
											,[
												0,
												2
											]
										]
									]
									]
								]
,								[
									38,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									5603107141885243,
									false
									,[
									[
										10,
										3
									]
,									[
										7,
										[
											19,
											cr.system_object.prototype.exps.choose
											,[
[
												0,
												9
											]
,[
												0,
												10
											]
											]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						785408727926807,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5130779820701123,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									9
								]
							]
							]
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							847305590787579,
							false
							,[
							[
								10,
								7
							]
,							[
								7,
								[
									6,
									[
										0,
										60
									]
									,[
										19,
										cr.system_object.prototype.exps.dt
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							7947030248376328,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								5784915548336572,
								false
								,[
								[
									10,
									7
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								4881399145587507,
								false
								,[
								[
									10,
									1
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Base"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3386228325507274,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									9333396501321446,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Left"
										]
									]
									]
								]
								],
								[
								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									7881618715417596,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAngle,
									null,
									529341365675249,
									false
									,[
									[
										0,
										[
											19,
											cr.system_object.prototype.exps.anglelerp
											,[
[
												20,
												25,
												cr.plugins_.Sprite.prototype.exps.Angle,
												false,
												null
											]
,[
												0,
												10
											]
,[
												6,
												[
													1,
													0.3
												]
												,[
													19,
													cr.system_object.prototype.exps.dt
												]
											]
											]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								8612739253175098,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									6819371712613571,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Right"
										]
									]
									]
								]
								],
								[
								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									9222712435658515,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAngle,
									null,
									5576489532498181,
									false
									,[
									[
										0,
										[
											19,
											cr.system_object.prototype.exps.anglelerp
											,[
[
												20,
												25,
												cr.plugins_.Sprite.prototype.exps.Angle,
												false,
												null
											]
,[
												0,
												10
											]
,[
												6,
												[
													1,
													0.3
												]
												,[
													19,
													cr.system_object.prototype.exps.dt
												]
											]
											]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								143154717303518,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									2348887263639233,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Left"
										]
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									true,
									null,
									4661090798023227,
									[
									[
										25,
										cr.plugins_.Sprite.prototype.cnds.IsBetweenAngles,
										null,
										0,
										false,
										false,
										false,
										4234532979184333,
										false
										,[
										[
											0,
											[
												0,
												7
											]
										]
,										[
											0,
											[
												0,
												9
											]
										]
										]
									]
,									[
										25,
										cr.plugins_.Sprite.prototype.cnds.IsBetweenAngles,
										null,
										0,
										false,
										false,
										false,
										8778539862721774,
										false
										,[
										[
											0,
											[
												0,
												-9
											]
										]
,										[
											0,
											[
												0,
												-7
											]
										]
										]
									]
									],
									[
									[
										38,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										6244282454768702,
										false
										,[
										[
											10,
											7
										]
,										[
											7,
											[
												7,
												[
													21,
													38,
													false,
													null
													,8
												]
												,[
													0,
													2
												]
											]
										]
										]
									]
,									[
										38,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										4106107532450066,
										false
										,[
										[
											10,
											3
										]
,										[
											7,
											[
												0,
												11
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3972076666818846,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5874084446715917,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									10
								]
							]
							]
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							3892022544872271,
							false
							,[
							[
								10,
								7
							]
,							[
								7,
								[
									6,
									[
										0,
										60
									]
									,[
										19,
										cr.system_object.prototype.exps.dt
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							7005224743367262,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								2623269073258697,
								false
								,[
								[
									10,
									7
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								1054214129632361,
								false
								,[
								[
									10,
									1
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Base"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2190321790127683,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									9725199373299607,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Left"
										]
									]
									]
								]
								],
								[
								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									4174179784113723,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAngle,
									null,
									2067376180264511,
									false
									,[
									[
										0,
										[
											19,
											cr.system_object.prototype.exps.anglelerp
											,[
[
												20,
												25,
												cr.plugins_.Sprite.prototype.exps.Angle,
												false,
												null
											]
,[
												0,
												-10
											]
,[
												6,
												[
													1,
													0.3
												]
												,[
													19,
													cr.system_object.prototype.exps.dt
												]
											]
											]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								1903495150754001,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									5968534435043792,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Right"
										]
									]
									]
								]
								],
								[
								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									3813575313057588,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAngle,
									null,
									2526019254807117,
									false
									,[
									[
										0,
										[
											19,
											cr.system_object.prototype.exps.anglelerp
											,[
[
												20,
												25,
												cr.plugins_.Sprite.prototype.exps.Angle,
												false,
												null
											]
,[
												0,
												-10
											]
,[
												6,
												[
													1,
													0.3
												]
												,[
													19,
													cr.system_object.prototype.exps.dt
												]
											]
											]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								5647643725510653,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									954807515157536,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Left"
										]
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									true,
									null,
									1701820973846294,
									[
									[
										25,
										cr.plugins_.Sprite.prototype.cnds.IsBetweenAngles,
										null,
										0,
										false,
										false,
										false,
										2044671919408309,
										false
										,[
										[
											0,
											[
												0,
												7
											]
										]
,										[
											0,
											[
												0,
												9
											]
										]
										]
									]
,									[
										25,
										cr.plugins_.Sprite.prototype.cnds.IsBetweenAngles,
										null,
										0,
										false,
										false,
										false,
										9661479270385702,
										false
										,[
										[
											0,
											[
												0,
												-9
											]
										]
,										[
											0,
											[
												0,
												-7
											]
										]
										]
									]
									],
									[
									[
										38,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										6878132216949796,
										false
										,[
										[
											10,
											7
										]
,										[
											7,
											[
												7,
												[
													21,
													38,
													false,
													null
													,8
												]
												,[
													0,
													2
												]
											]
										]
										]
									]
,									[
										38,
										cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
										null,
										5774979803680802,
										false
										,[
										[
											10,
											3
										]
,										[
											7,
											[
												0,
												11
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7857311565411439,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1891052323520958,
							false
							,[
							[
								10,
								3
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									11
								]
							]
							]
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							2552743575291519,
							false
							,[
							[
								10,
								7
							]
,							[
								7,
								[
									6,
									[
										0,
										60
									]
									,[
										19,
										cr.system_object.prototype.exps.dt
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							1131683151009818,
							[
							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								5786387258515318,
								false
								,[
								[
									10,
									7
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								38,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								2664447998106535,
								false
								,[
								[
									10,
									1
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Base"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								8661467835082574,
								[
								[
									-1,
									cr.system_object.prototype.cnds.TriggerOnce,
									null,
									0,
									false,
									false,
									false,
									1800130468670645,
									false
								]
								],
								[
								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									7248872578884357,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													38,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Top"
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													4,
													[
														0,
														90
													]
													,[
														19,
														cr.system_object.prototype.exps.random
														,[
[
															0,
															-10
														]
,[
															0,
															10
														]
														]
													]
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													0,
													0
												]
											]
,
											[
												7,
												[
													21,
													38,
													false,
													null
													,4
												]
											]
									]
									]
								]
,								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									3673653151681076,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													38,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													2,
													"Bottom"
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													4,
													[
														0,
														90
													]
													,[
														19,
														cr.system_object.prototype.exps.random
														,[
[
															0,
															-10
														]
,[
															0,
															10
														]
														]
													]
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													0,
													0
												]
											]
,
											[
												7,
												[
													21,
													38,
													false,
													null
													,4
												]
											]
									]
									]
								]
,								[
									8,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									2602012572284305,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										13,
																					[
												7,
												[
													20,
													38,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
,
											[
												7,
												[
													0,
													0
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													4,
													[
														0,
														90
													]
													,[
														19,
														cr.system_object.prototype.exps.random
														,[
[
															0,
															-10
														]
,[
															0,
															10
														]
														]
													]
												]
											]
,
											[
												7,
												[
													2,
													"Enemy"
												]
											]
,
											[
												7,
												[
													0,
													0
												]
											]
,
											[
												7,
												[
													21,
													38,
													false,
													null
													,4
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								2847901718580856,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									9090416186762712,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Left"
										]
									]
									]
								]
								],
								[
								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									2774481827892932,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAngle,
									null,
									540200691895755,
									false
									,[
									[
										0,
										[
											19,
											cr.system_object.prototype.exps.anglelerp
											,[
[
												20,
												25,
												cr.plugins_.Sprite.prototype.exps.Angle,
												false,
												null
											]
,[
												0,
												90
											]
,[
												6,
												[
													0,
													2
												]
												,[
													19,
													cr.system_object.prototype.exps.dt
												]
											]
											]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								5249012112805614,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									1541771802096854,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Right"
										]
									]
									]
								]
								],
								[
								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									4934489158357497,
									false
									,[
									[
										1,
										[
											2,
											"Shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									25,
									cr.plugins_.Sprite.prototype.acts.SetAngle,
									null,
									8854278836926897,
									false
									,[
									[
										0,
										[
											19,
											cr.system_object.prototype.exps.anglelerp
											,[
[
												20,
												25,
												cr.plugins_.Sprite.prototype.exps.Angle,
												false,
												null
											]
,[
												0,
												-90
											]
,[
												6,
												[
													0,
													2
												]
												,[
													19,
													cr.system_object.prototype.exps.dt
												]
											]
											]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								3127617528518004,
								[
								[
									25,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									1768869792757821,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Left"
										]
									]
									]
								]
,								[
									25,
									cr.plugins_.Sprite.prototype.cnds.IsBetweenAngles,
									null,
									0,
									false,
									false,
									false,
									9254940889216292,
									false
									,[
									[
										0,
										[
											0,
											89
										]
									]
,									[
										0,
										[
											0,
											91
										]
									]
									]
								]
								],
								[
								[
									38,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									6632969666946312,
									false
									,[
									[
										10,
										7
									]
,									[
										7,
										[
											7,
											[
												21,
												38,
												false,
												null
												,8
											]
											,[
												0,
												2
											]
										]
									]
									]
								]
,								[
									38,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									9287455668173498,
									false
									,[
									[
										10,
										3
									]
,									[
										7,
										[
											0,
											8
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5122547342120217,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						820098182646186,
						false
						,[
						[
							11,
							"BOSS_HP"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3029444611744489,
						false
						,[
						[
							11,
							"BOSS_HP"
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.NinePatch.prototype.acts.SetVisible,
						null,
						9634312738783787,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						39,
						cr.plugins_.NinePatch.prototype.acts.SetVisible,
						null,
						9569152033827641,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						2313924649841747,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							4672752972777593,
							false
							,[
							[
								7,
								[
									20,
									5,
									cr.plugins_.Audio.prototype.exps.Volume,
									false,
									null
									,[
[
										2,
										"BossMusic"
									]
									]
								]
							]
,							[
								8,
								4
							]
,							[
								7,
								[
									0,
									-100
								]
							]
							]
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.SetVolume,
							null,
							1106372062225223,
							false
							,[
							[
								1,
								[
									2,
									"BossMusic"
								]
							]
,							[
								0,
								[
									5,
									[
										20,
										5,
										cr.plugins_.Audio.prototype.exps.Volume,
										false,
										null
										,[
[
											2,
											"BossMusic"
										]
										]
									]
									,[
										1,
										0.2
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8427494061725051,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							131919329177807,
							false
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.Stop,
							null,
							7349279636286551,
							false
							,[
							[
								1,
								[
									2,
									"BossMusic"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4732471568765709,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							877930914170638,
							false
							,[
							[
								7,
								[
									20,
									5,
									cr.plugins_.Audio.prototype.exps.Volume,
									false,
									null
									,[
[
										2,
										"Music"
									]
									]
								]
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									-10
								]
							]
							]
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.SetVolume,
							null,
							2815050833607444,
							false
							,[
							[
								1,
								[
									2,
									"Music"
								]
							]
,							[
								0,
								[
									4,
									[
										20,
										5,
										cr.plugins_.Audio.prototype.exps.Volume,
										false,
										null
										,[
[
											2,
											"Music"
										]
										]
									]
									,[
										1,
										0.2
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5933100514514423,
						[
						[
							-1,
							cr.system_object.prototype.cnds.ForEach,
							null,
							0,
							true,
							false,
							false,
							8720010663259448,
							false
							,[
							[
								4,
								38
							]
							]
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							106670095916272,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									0,
									-1
								]
							]
							]
						]
,						[
							38,
							cr.behaviors.Bullet.prototype.acts.SetEnabled,
							"Bullet",
							1701027596705708,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							38,
							cr.behaviors.Bullet.prototype.acts.SetSpeed,
							"Bullet",
							6293323822487376,
							false
							,[
							[
								0,
								[
									0,
									40
								]
							]
							]
						]
,						[
							38,
							cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
							"Bullet",
							483805591051104,
							false
							,[
							[
								0,
								[
									0,
									-90
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5770564873204444,
						[
						[
							25,
							cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
							null,
							0,
							false,
							false,
							false,
							419486726132119,
							false
							,[
							[
								10,
								1
							]
							]
						]
						],
						[
						[
							25,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							4082434387900227,
							false
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6493836276410427,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							865413671617685,
							false
							,[
							[
								0,
								[
									6,
									[
										0,
										10
									]
									,[
										19,
										cr.system_object.prototype.exps.dt
									]
								]
							]
							]
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							9917431292051582,
							false
							,[
							[
								4,
								11
							]
,							[
								5,
								[
									2,
									"Shoots"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							9158398764558706,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											360
										]
										]
									]
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							8556186822324343,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										5,
										[
											20,
											38,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											7,
											[
												20,
												38,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												0,
												2
											]
										]
									]
,[
										4,
										[
											20,
											38,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											7,
											[
												20,
												38,
												cr.plugins_.Sprite.prototype.exps.Width,
												false,
												null
											]
											,[
												0,
												2
											]
										]
									]
									]
								]
							]
,							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										5,
										[
											20,
											38,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											7,
											[
												20,
												38,
												cr.plugins_.Sprite.prototype.exps.Height,
												false,
												null
											]
											,[
												0,
												2
											]
										]
									]
,[
										4,
										[
											20,
											38,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											7,
											[
												20,
												38,
												cr.plugins_.Sprite.prototype.exps.Height,
												false,
												null
											]
											,[
												0,
												2
											]
										]
									]
									]
								]
							]
							]
						]
,						[
							5,
							cr.plugins_.Audio.prototype.acts.Play,
							null,
							6598653493020622,
							false
							,[
							[
								2,
								["explo",false]
							]
,							[
								3,
								0
							]
,							[
								0,
								[
									0,
									-15
								]
							]
,							[
								1,
								[
									2,
									""
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7747694452267493,
						[
						[
							38,
							cr.plugins_.Sprite.prototype.cnds.CompareY,
							null,
							0,
							false,
							false,
							false,
							5585069995489672,
							false
							,[
							[
								8,
								2
							]
,							[
								0,
								[
									7,
									[
										3,
										[
											20,
											38,
											cr.plugins_.Sprite.prototype.exps.Height,
											false,
											null
										]
									]
									,[
										0,
										2
									]
								]
							]
							]
						]
						],
						[
						[
							38,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							3078320914513263,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							3549277754936353,
							false
							,[
							[
								11,
								"DELAY"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5258954818738898,
							false
							,[
							[
								11,
								"GAMESTATE"
							]
,							[
								7,
								[
									2,
									"PLAY"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.AddVar,
							null,
							7290395198478856,
							false
							,[
							[
								11,
								"SCORE"
							]
,							[
								7,
								[
									0,
									50000
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.AddVar,
							null,
							3730888923382174,
							false
							,[
							[
								11,
								"DIFFICULTY"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5310382019069351,
							false
							,[
							[
								11,
								"COMBO"
							]
,							[
								7,
								[
									0,
									10
								]
							]
							]
						]
,						[
							5,
							cr.plugins_.Audio.prototype.acts.Play,
							null,
							1757879990300745,
							false
							,[
							[
								2,
								["yep",false]
							]
,							[
								3,
								0
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								1,
								[
									2,
									""
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"LoadGame",
		[
		[
			2,
			"FUNCIONES",
			false
		]
,		[
			0,
			null,
			false,
			null,
			3996319081020014,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				7786341551701744,
				false
			]
			],
			[
			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				3567302833723334,
				false
				,[
				[
					2,
					["music",true]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				9546783892590758,
				false
				,[
				[
					2,
					["bossmusic",true]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				9334066732817428,
				false
				,[
				[
					2,
					["shot",false]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				3103686225119488,
				false
				,[
				[
					2,
					["shot3",false]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				6168079999015875,
				false
				,[
				[
					2,
					["explo",false]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				9435570892813237,
				false
				,[
				[
					2,
					["yep",false]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				6784127603209778,
				false
				,[
				[
					2,
					["nope",false]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				8547615552638943,
				false
				,[
				[
					2,
					["clinck",false]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				5271888109734152,
				false
				,[
				[
					2,
					["shielddown",false]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				6545287427296623,
				false
				,[
				[
					2,
					["pickupcoin",false]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				4961202262683357,
				false
				,[
				[
					2,
					["powerup",false]
				]
				]
			]
,			[
				5,
				cr.plugins_.Audio.prototype.acts.Preload,
				null,
				3342012208378476,
				false
				,[
				[
					2,
					["menu",false]
				]
				]
			]
,			[
				22,
				cr.plugins_.Dictionary.prototype.acts.AddKey,
				null,
				3478087162557545,
				false
				,[
				[
					1,
					[
						2,
						"Ship1"
					]
				]
,				[
					7,
					[
						2,
						"Standard"
					]
				]
				]
			]
,			[
				22,
				cr.plugins_.Dictionary.prototype.acts.AddKey,
				null,
				3137735530922699,
				false
				,[
				[
					1,
					[
						2,
						"Ship2"
					]
				]
,				[
					7,
					[
						2,
						"Option"
					]
				]
				]
			]
,			[
				22,
				cr.plugins_.Dictionary.prototype.acts.AddKey,
				null,
				484522351932428,
				false
				,[
				[
					1,
					[
						2,
						"Ship3"
					]
				]
,				[
					7,
					[
						2,
						"Stork"
					]
				]
				]
			]
,			[
				22,
				cr.plugins_.Dictionary.prototype.acts.AddKey,
				null,
				6061886188271272,
				false
				,[
				[
					1,
					[
						2,
						"TotalShips"
					]
				]
,				[
					7,
					[
						0,
						3
					]
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				5334089628704607,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					2260456108679602,
					false
					,[
					[
						1,
						[
							2,
							"MUSIC"
						]
					]
					]
				]
				],
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					9325638741730283,
					false
					,[
					[
						1,
						[
							2,
							"MUSIC"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				207386610146822,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					8724202732317955,
					false
					,[
					[
						1,
						[
							2,
							"MUSIC"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.SetSilent,
					null,
					2091022522700491,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5736283171439303,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					5949941245087001,
					false
					,[
					[
						1,
						[
							2,
							"RECORD"
						]
					]
					]
				]
				],
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8010792676794191,
					false
					,[
					[
						1,
						[
							2,
							"RECORD"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				130597039044268,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					923338287499832,
					false
					,[
					[
						1,
						[
							2,
							"RECORD_HARDCORE"
						]
					]
					]
				]
				],
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8113796962073304,
					false
					,[
					[
						1,
						[
							2,
							"RECORD_HARDCORE"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6124181939581017,
				[
				],
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					7465377197209647,
					false
					,[
					[
						1,
						[
							2,
							"FirstTime"
						]
					]
,					[
						7,
						[
							2,
							"No"
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					5281609435195798,
					[
					],
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						725894201929426,
						false
						,[
						[
							1,
							[
								2,
								"Ship1Color0Purchased"
							]
						]
,						[
							7,
							[
								2,
								"Yes"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5200904687354407,
						false
						,[
						[
							1,
							[
								2,
								"Ship1Color1Price"
							]
						]
,						[
							7,
							[
								0,
								1000
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7830732033147381,
						false
						,[
						[
							1,
							[
								2,
								"Ship1Color2Price"
							]
						]
,						[
							7,
							[
								0,
								1000
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3747559971581163,
						false
						,[
						[
							1,
							[
								2,
								"Ship1Color3Price"
							]
						]
,						[
							7,
							[
								0,
								1000
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5878094720893019,
						false
						,[
						[
							1,
							[
								2,
								"Ship1Color4Price"
							]
						]
,						[
							7,
							[
								0,
								1000
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1824176269900587,
						false
						,[
						[
							1,
							[
								2,
								"Ship2Color0Purchased"
							]
						]
,						[
							7,
							[
								2,
								"Yes"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9862587625169867,
						false
						,[
						[
							1,
							[
								2,
								"Ship2Color1Price"
							]
						]
,						[
							7,
							[
								0,
								1200
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						256770252250712,
						false
						,[
						[
							1,
							[
								2,
								"Ship2Color2Price"
							]
						]
,						[
							7,
							[
								0,
								1200
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						731406340838457,
						false
						,[
						[
							1,
							[
								2,
								"Ship2Color3Price"
							]
						]
,						[
							7,
							[
								0,
								1200
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						690173020631419,
						false
						,[
						[
							1,
							[
								2,
								"Ship2Color4Price"
							]
						]
,						[
							7,
							[
								0,
								1200
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5948673955002993,
						false
						,[
						[
							1,
							[
								2,
								"Ship3Color0Purchased"
							]
						]
,						[
							7,
							[
								2,
								"Yes"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5576692096434161,
						false
						,[
						[
							1,
							[
								2,
								"Ship3Color1Price"
							]
						]
,						[
							7,
							[
								0,
								1400
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5202423736494711,
						false
						,[
						[
							1,
							[
								2,
								"Ship3Color2Price"
							]
						]
,						[
							7,
							[
								0,
								1400
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5395747340052125,
						false
						,[
						[
							1,
							[
								2,
								"Ship3Color3Price"
							]
						]
,						[
							7,
							[
								0,
								1400
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8608757137412297,
						false
						,[
						[
							1,
							[
								2,
								"Ship3Color4Price"
							]
						]
,						[
							7,
							[
								0,
								1400
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						811567563200559,
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
							null,
							0,
							false,
							true,
							false,
							8129467432379363,
							false
							,[
							[
								1,
								[
									2,
									"Money"
								]
							]
							]
						]
						],
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							4936076585671612,
							false
							,[
							[
								1,
								[
									2,
									"Money"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				243716889378086,
				[
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7236220278092501,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						4498133837800799,
						false
						,[
						[
							7,
							[
								2,
								"OPTIONS"
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"OPTIONS"
							]
						]
						]
					]
					],
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7402444567996338,
						false
						,[
						[
							1,
							[
								2,
								"EExit"
							]
						]
,						[
							7,
							[
								2,
								"Exit"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7189835810669408,
						false
						,[
						[
							1,
							[
								2,
								"SExit"
							]
						]
,						[
							7,
							[
								2,
								"Salir"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3756443829166811,
						false
						,[
						[
							1,
							[
								2,
								"EOptions"
							]
						]
,						[
							7,
							[
								2,
								"Options"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						133003746484574,
						false
						,[
						[
							1,
							[
								2,
								"SOptions"
							]
						]
,						[
							7,
							[
								2,
								"Opciones"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3416379002834838,
						false
						,[
						[
							1,
							[
								2,
								"EOPTIONS"
							]
						]
,						[
							7,
							[
								2,
								"OPTIONS"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						806062187674124,
						false
						,[
						[
							1,
							[
								2,
								"SOPTIONS"
							]
						]
,						[
							7,
							[
								2,
								"OPCIONES"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9632589556872211,
						false
						,[
						[
							1,
							[
								2,
								"EMusic"
							]
						]
,						[
							7,
							[
								2,
								"Sound"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7305192722904374,
						false
						,[
						[
							1,
							[
								2,
								"SMusic"
							]
						]
,						[
							7,
							[
								2,
								"Sonido"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5366321238142748,
						false
						,[
						[
							1,
							[
								2,
								"ELang"
							]
						]
,						[
							7,
							[
								2,
								"English"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1961803313351412,
						false
						,[
						[
							1,
							[
								2,
								"SLang"
							]
						]
,						[
							7,
							[
								2,
								"Spanish"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4230566698501919,
						false
						,[
						[
							1,
							[
								2,
								"EBack"
							]
						]
,						[
							7,
							[
								2,
								"Back"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2740059485489625,
						false
						,[
						[
							1,
							[
								2,
								"SBack"
							]
						]
,						[
							7,
							[
								2,
								"Volver"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9723927207578625,
						false
						,[
						[
							1,
							[
								2,
								"EPlay"
							]
						]
,						[
							7,
							[
								2,
								"Play"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2594494288889956,
						false
						,[
						[
							1,
							[
								2,
								"SPlay"
							]
						]
,						[
							7,
							[
								2,
								"Jugar"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2026071574901202,
						false
						,[
						[
							1,
							[
								2,
								"ESelect"
							]
						]
,						[
							7,
							[
								2,
								"SELECT SHIP"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9504701968488354,
						false
						,[
						[
							1,
							[
								2,
								"SSelect"
							]
						]
,						[
							7,
							[
								2,
								"ELIGE NAVE"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6756274425490153,
						false
						,[
						[
							1,
							[
								2,
								"EScore"
							]
						]
,						[
							7,
							[
								2,
								"Score"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5933675105278723,
						false
						,[
						[
							1,
							[
								2,
								"SScore"
							]
						]
,						[
							7,
							[
								2,
								"Punticos"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2386064349048545,
						false
						,[
						[
							1,
							[
								2,
								"ELevel"
							]
						]
,						[
							7,
							[
								2,
								"Level"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2859012911262641,
						false
						,[
						[
							1,
							[
								2,
								"SLevel"
							]
						]
,						[
							7,
							[
								2,
								"Nivel"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2769088247067538,
						false
						,[
						[
							1,
							[
								2,
								"ETouch"
							]
						]
,						[
							7,
							[
								2,
								"TOUCH TO START!"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7521675311637329,
						false
						,[
						[
							1,
							[
								2,
								"STouch"
							]
						]
,						[
							7,
							[
								2,
								"TOCA PARA EMPEZAR!"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2388631551351483,
						false
						,[
						[
							1,
							[
								2,
								"ERecord"
							]
						]
,						[
							7,
							[
								2,
								"Hi-Score"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						430404633374508,
						false
						,[
						[
							1,
							[
								2,
								"SRecord"
							]
						]
,						[
							7,
							[
								2,
								"Record"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8204170265220513,
						false
						,[
						[
							1,
							[
								2,
								"EPosition"
							]
						]
,						[
							7,
							[
								2,
								"Position"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5198006505752934,
						false
						,[
						[
							1,
							[
								2,
								"SPosition"
							]
						]
,						[
							7,
							[
								2,
								"Posicion"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7853275007189488,
						false
						,[
						[
							1,
							[
								2,
								"EPurchase"
							]
						]
,						[
							7,
							[
								2,
								"Purchase"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2594466158184621,
						false
						,[
						[
							1,
							[
								2,
								"SPurchase"
							]
						]
,						[
							7,
							[
								2,
								"Comprar"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1063469823505687,
						false
						,[
						[
							1,
							[
								2,
								"EOwned"
							]
						]
,						[
							7,
							[
								2,
								"Owned"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7874573349209636,
						false
						,[
						[
							1,
							[
								2,
								"SOwned"
							]
						]
,						[
							7,
							[
								2,
								"Comprado"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1454930696613758,
						false
						,[
						[
							1,
							[
								2,
								"EPrice"
							]
						]
,						[
							7,
							[
								2,
								"Price"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5247707773344379,
						false
						,[
						[
							1,
							[
								2,
								"SPrice"
							]
						]
,						[
							7,
							[
								2,
								"Precio"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						103659828046028,
						false
						,[
						[
							1,
							[
								2,
								"EPAUSE"
							]
						]
,						[
							7,
							[
								2,
								"PAUSE"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3336037806191126,
						false
						,[
						[
							1,
							[
								2,
								"SPAUSE"
							]
						]
,						[
							7,
							[
								2,
								"PAUSA"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8286089734894711,
						false
						,[
						[
							1,
							[
								2,
								"EContinue"
							]
						]
,						[
							7,
							[
								2,
								"Continue"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						840186986463413,
						false
						,[
						[
							1,
							[
								2,
								"SContinue"
							]
						]
,						[
							7,
							[
								2,
								"Continuar"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						341654338483974,
						false
						,[
						[
							1,
							[
								2,
								"EBronze"
							]
						]
,						[
							7,
							[
								2,
								"Bronze Medal"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1420655163848472,
						false
						,[
						[
							1,
							[
								2,
								"SBronze"
							]
						]
,						[
							7,
							[
								2,
								"Medalla de Bronce"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2392446693101552,
						false
						,[
						[
							1,
							[
								2,
								"ESilver"
							]
						]
,						[
							7,
							[
								2,
								"Silver Medal"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						706246346293588,
						false
						,[
						[
							1,
							[
								2,
								"SSilver"
							]
						]
,						[
							7,
							[
								2,
								"Medalla de Plata"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4296473651626618,
						false
						,[
						[
							1,
							[
								2,
								"EGold"
							]
						]
,						[
							7,
							[
								2,
								"Gold Medal"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9749015819749193,
						false
						,[
						[
							1,
							[
								2,
								"SGold"
							]
						]
,						[
							7,
							[
								2,
								"Medalla de Oro"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9221681236941288,
						false
						,[
						[
							1,
							[
								2,
								"ETouchLeft"
							]
						]
,						[
							7,
							[
								2,
								"Touch here to move left"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4282475425866564,
						false
						,[
						[
							1,
							[
								2,
								"STouchLeft"
							]
						]
,						[
							7,
							[
								2,
								"Toca aqui para moverte hacia la izquierda"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						200723166361488,
						false
						,[
						[
							1,
							[
								2,
								"ETouchRight"
							]
						]
,						[
							7,
							[
								2,
								"Touch here to move right"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6452330956140299,
						false
						,[
						[
							1,
							[
								2,
								"STouchRight"
							]
						]
,						[
							7,
							[
								2,
								"Toca aqui para moverte hacia la derecha"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8099579092471793,
						false
						,[
						[
							1,
							[
								2,
								"ETouchPause"
							]
						]
,						[
							7,
							[
								2,
								"Touch here to Pause"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6860975371741175,
						false
						,[
						[
							1,
							[
								2,
								"STouchPause"
							]
						]
,						[
							7,
							[
								2,
								"Toca aqui para Pausar"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8993368972414851,
						false
						,[
						[
							1,
							[
								2,
								"ETouchLeftPC"
							]
						]
,						[
							7,
							[
								2,
								"Press Left Arrow key to move left"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4953089739076746,
						false
						,[
						[
							1,
							[
								2,
								"STouchLeftPC"
							]
						]
,						[
							7,
							[
								2,
								"Usa la flecha izquierda para moverte hacia la izquierda"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1322068698504578,
						false
						,[
						[
							1,
							[
								2,
								"ETouchRightPC"
							]
						]
,						[
							7,
							[
								2,
								"Press Right Arrow key to move right"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						665921165114284,
						false
						,[
						[
							1,
							[
								2,
								"STouchRightPC"
							]
						]
,						[
							7,
							[
								2,
								"Usa la flecha derecha para moverte hacia la derecha"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3314758819895677,
						false
						,[
						[
							1,
							[
								2,
								"ESelectMode"
							]
						]
,						[
							7,
							[
								2,
								"SELECT MODE"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2933581777406438,
						false
						,[
						[
							1,
							[
								2,
								"SSelectMode"
							]
						]
,						[
							7,
							[
								2,
								"SELECCIONA MODO"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8228336527634028,
						false
						,[
						[
							1,
							[
								2,
								"ENormalMode"
							]
						]
,						[
							7,
							[
								2,
								"Normal Mode"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1929474524792878,
						false
						,[
						[
							1,
							[
								2,
								"SNormalMode"
							]
						]
,						[
							7,
							[
								2,
								"Modo Normal"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2577575946461637,
						false
						,[
						[
							1,
							[
								2,
								"EHardcoreMode"
							]
						]
,						[
							7,
							[
								2,
								"Hardcore Mode"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4151459372208469,
						false
						,[
						[
							1,
							[
								2,
								"SHardcoreMode"
							]
						]
,						[
							7,
							[
								2,
								"Modo Hardcore"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4628510591611177,
						false
						,[
						[
							1,
							[
								2,
								"ENormalMedal"
							]
						]
,						[
							7,
							[
								2,
								"Normal Medal"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9847478770635462,
						false
						,[
						[
							1,
							[
								2,
								"SNormalMedal"
							]
						]
,						[
							7,
							[
								2,
								"Medalla Normal"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2893305729888294,
						false
						,[
						[
							1,
							[
								2,
								"EHardcoreMedal"
							]
						]
,						[
							7,
							[
								2,
								"Hardcore Medal"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4087054588683307,
						false
						,[
						[
							1,
							[
								2,
								"SHardcoreMedal"
							]
						]
,						[
							7,
							[
								2,
								"Medalla Hardcore"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						281774289452801,
						false
						,[
						[
							1,
							[
								2,
								"ERateMe"
							]
						]
,						[
							7,
							[
								2,
								"Rate me"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6677119738871027,
						false
						,[
						[
							1,
							[
								2,
								"SRateMe"
							]
						]
,						[
							7,
							[
								2,
								"Puntuame"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2559569507714689,
						false
						,[
						[
							1,
							[
								2,
								"ETwitter"
							]
						]
,						[
							7,
							[
								2,
								"Twitter"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5703050472119362,
						false
						,[
						[
							1,
							[
								2,
								"STwitter"
							]
						]
,						[
							7,
							[
								2,
								"Twitter"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5709803086788001,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						2602910765438676,
						false
						,[
						[
							7,
							[
								2,
								"DESCRIPTIONS"
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"DESCRIPTIONS"
							]
						]
						]
					]
					],
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6731883387756991,
						false
						,[
						[
							1,
							[
								2,
								"EDescStandard"
							]
						]
,						[
							7,
							[
								2,
								"-THUNDER-\n\n-Speed: Fast\n-Firepower: Normal\n*\n\nStandard Ship. This ship can launch missiles and improve his firepower when you get Power-Ups."
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8125632684815438,
						false
						,[
						[
							1,
							[
								2,
								"SDescStandard"
							]
						]
,						[
							7,
							[
								2,
								"-THUNDER-\n\n-Velocidad: Alta\n-Potencia de fuego: Normal\n*\n\nNave estandar. Con mejoras puede lanzar misiles y doblar la potencia de sus disparos."
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4107969470989443,
						false
						,[
						[
							1,
							[
								2,
								"EDescOption"
							]
						]
,						[
							7,
							[
								2,
								"-COMMANDER-\n\n-Speed: Normal\n-Firepower: Great\n*\n\nYou can get aux. ships that follow you. These ships can get Power-Ups too."
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5764535804110669,
						false
						,[
						[
							1,
							[
								2,
								"SDescOption"
							]
						]
,						[
							7,
							[
								2,
								"-COMMANDER-\n\n-Velocidad: Normal\n-Potencia de fuego: Alta\n*\n\nPuedes conseguir mininaves que te seguiran. Estas mininaves pueden conseguir mejoras."
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6212424041001493,
						false
						,[
						[
							1,
							[
								2,
								"EDescStork"
							]
						]
,						[
							7,
							[
								2,
								"-STORK-\n\n-Speed: Fast\n-Firepower: Great\n*\n\nThe shooting angle varies when you turn, It is a fast Spaceship but hard to control."
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						259758758906151,
						false
						,[
						[
							1,
							[
								2,
								"SDescStork"
							]
						]
,						[
							7,
							[
								2,
								"-STORK-\n\n-Velocidad: Alta\n-Potencia de fuego: Alta\n*\n\nEl angulo de disparo varia con los giros, es una nave rapida pero dificil de manejar."
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2765515880759659,
						false
						,[
						[
							1,
							[
								2,
								"EShip1Color1Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Extra missile"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2802610017605662,
						false
						,[
						[
							1,
							[
								2,
								"SShip1Color1Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Misil extra"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1791468365799831,
						false
						,[
						[
							1,
							[
								2,
								"EShip1Color2Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Begins with one powerUP"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8673955355850694,
						false
						,[
						[
							1,
							[
								2,
								"SShip1Color2Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Empieza con un PowerUP"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6582885540708844,
						false
						,[
						[
							1,
							[
								2,
								"EShip1Color3Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Extra bullets"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1649692062898002,
						false
						,[
						[
							1,
							[
								2,
								"SShip1Color3Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Balas extra"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9830454811979134,
						false
						,[
						[
							1,
							[
								2,
								"EShip1Color4Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Item Atraction"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5215925874256576,
						false
						,[
						[
							1,
							[
								2,
								"SShip1Color4Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Atraccion de objetos"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						678945170644688,
						false
						,[
						[
							1,
							[
								2,
								"EShip2Color1Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Energy shield"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8572869542522319,
						false
						,[
						[
							1,
							[
								2,
								"SShip2Color1Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Escudo de energia"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7300696635355904,
						false
						,[
						[
							1,
							[
								2,
								"EShip2Color2Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Begins with one Aux. Ship"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5568883556103542,
						false
						,[
						[
							1,
							[
								2,
								"SShip2Color2Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Empieza con una nave Aux."
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1466574532836413,
						false
						,[
						[
							1,
							[
								2,
								"EShip2Color3Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Red coins have double value"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						742017795926261,
						false
						,[
						[
							1,
							[
								2,
								"SShip2Color3Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Las monedas rojas valen doble"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1628198948349624,
						false
						,[
						[
							1,
							[
								2,
								"EShip2Color4Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Begins with one powerUP"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9468824785115689,
						false
						,[
						[
							1,
							[
								2,
								"SShip2Color4Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Empieza con un PowerUP"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8884661956671981,
						false
						,[
						[
							1,
							[
								2,
								"EShip3Color1Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Shoots 6 missiles when you pick a coin"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7265712223283024,
						false
						,[
						[
							1,
							[
								2,
								"SShip3Color1Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Dispara 6 misiles cuando consigues una moneda"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6968449133559578,
						false
						,[
						[
							1,
							[
								2,
								"EShip3Color2Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Gains one powerUP every two coins."
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4986890540131859,
						false
						,[
						[
							1,
							[
								2,
								"SShip3Color2Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Ganas una mejora por cada dos monedas"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4681258490152397,
						false
						,[
						[
							1,
							[
								2,
								"EShip3Color3Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Shoot angle locked"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9282520743518543,
						false
						,[
						[
							1,
							[
								2,
								"SShip3Color3Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Angulo de disparo bloqueado"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3504762840884995,
						false
						,[
						[
							1,
							[
								2,
								"EShip3Color4Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Coins have half value but give x1.0 Bonus"
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8221319350363047,
						false
						,[
						[
							1,
							[
								2,
								"SShip3Color4Extra"
							]
						]
,						[
							7,
							[
								2,
								"-Extras: Las monedas valen la mitad pero dan x1.0 Bonus"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7640399223229117,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						6580910049537947,
						false
						,[
						[
							7,
							[
								2,
								"ACHIEVEMENTS"
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"ACHIEVEMENTS"
							]
						]
						]
					]
					],
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7431623162124562,
						false
						,[
						[
							1,
							[
								2,
								"Ach1"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"MAX COMBO REACHED\n\nKill 100 consecutive enemies to reach Max combo."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9598818935686285,
						false
						,[
						[
							1,
							[
								2,
								"Ach2"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"MAX COMBO MASTER\n\nMaintain Max combo during one minute."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6250929282770996,
						false
						,[
						[
							1,
							[
								2,
								"Ach3"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"LEVEL 10 REACHED\n\nReach difficulty level 10."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3483777239980974,
						false
						,[
						[
							1,
							[
								2,
								"Ach4"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"LEVEL 20 REACHED\n\nReach difficulty level 20."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9456737728957699,
						false
						,[
						[
							1,
							[
								2,
								"Ach5"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"TOO MUCH BULLETS\n\nReach difficulty level 25."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9970194350767534,
						false
						,[
						[
							1,
							[
								2,
								"Ach6"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"COMMANDER IS READY\n\nPlay with the Commander Spaceship."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8526818777331185,
						false
						,[
						[
							1,
							[
								2,
								"Ach7"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"POOR ONE\n\nReach Level 15 without take power ups or money."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2196639598966867,
						false
						,[
						[
							1,
							[
								2,
								"Ach8"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"PATIENCE IS NEEDED\n\nKill a Juggernaut without take power ups."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3858105769818736,
						false
						,[
						[
							1,
							[
								2,
								"Ach9"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"KILLER\n\nKill 1000 enemies."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8506847570376832,
						false
						,[
						[
							1,
							[
								2,
								"Ach10"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"RECOGNISED KILLER\n\nKill 50000 enemies."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9208735656912509,
						false
						,[
						[
							1,
							[
								2,
								"Ach11"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"DELTA KILLER\n\nKill 10000 Delta Spaceships."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1052892608572314,
						false
						,[
						[
							1,
							[
								2,
								"Ach12"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"PIRANHA EATER\n\nKill 10000 Piranhas."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4414961831736671,
						false
						,[
						[
							1,
							[
								2,
								"Ach13"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"THE FALL OF ROME\n\nKill 10000 Phalanx Spaceships."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1977742690733811,
						false
						,[
						[
							1,
							[
								2,
								"Ach14"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"RAY DESTROYER\n\nKill 10000 Ray Spaceships."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2917938340474381,
						false
						,[
						[
							1,
							[
								2,
								"Ach15"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"NO MORE SUPER-VILLAINS\n\nKill 10000 Juggernaut Spaceships."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6089460585418457,
						false
						,[
						[
							1,
							[
								2,
								"Ach16"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"ALIEN-FREE GALAXY\n\nKill 10000 Piranha Kings."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						337870807081679,
						false
						,[
						[
							1,
							[
								2,
								"Ach17"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"LEARNING\n\nReach 50000 points."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1823086788095585,
						false
						,[
						[
							1,
							[
								2,
								"Ach18"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"NOT HARD\n\nReach 100000 points."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8149646229566293,
						false
						,[
						[
							1,
							[
								2,
								"Ach19"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"GOOD SCORE\n\nReach 250000 points."
								]
								]
							]
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6464336270937163,
						false
						,[
						[
							1,
							[
								2,
								"Ach20"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.str
								,[
[
									2,
									"BEAT ME!\n\nReach 500000 points."
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6110684213544948,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLoadFinished,
				null,
				1,
				false,
				false,
				false,
				4224114922333924,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				9876779024522658,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					false,
					false,
					5693881011011472,
					false
					,[
					[
						1,
						[
							2,
							"LANG"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					8818302000927305,
					false
					,[
					[
						6,
						"Title"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4949837802505716,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					4853655966664643,
					false
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					2346164455047238,
					false
					,[
					[
						6,
						"LANG"
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"Title",
		[
		[
			2,
			"FUNCIONES",
			false
		]
,		[
			0,
			null,
			false,
			null,
			7520757487023554,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				6884883069571908,
				false
			]
			],
			[
			[
				26,
				cr.plugins_.CJSAds.prototype.acts.fetchProductsFromStore,
				null,
				4020791380468094,
				false
				,[
				[
					1,
					[
						2,
						"navecicas_premium_01"
					]
				]
				]
			]
,			[
				26,
				cr.plugins_.CJSAds.prototype.acts.RestorePurchases,
				null,
				7103785533547696,
				false
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				4379365318721596,
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.cnds.IsProductPurchased,
					null,
					0,
					false,
					false,
					false,
					62018197921876,
					false
					,[
					[
						1,
						[
							2,
							"navecicas_premium_01"
						]
					]
					]
				]
				],
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					9852105480736775,
					false
					,[
					[
						1,
						[
							2,
							"PREMIUM"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				570259956275802,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3942960772867839,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Options"
						]
					]
					]
				]
				],
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4416799427423192,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"Options"
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2343202856604424,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7173688461483989,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Play"
						]
					]
					]
				]
				],
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4558402827563631,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"Play"
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				57200927961961,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					5382217023435153,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Premium"
						]
					]
					]
				]
,				[
					26,
					cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,
					null,
					0,
					false,
					true,
					false,
					3578926902502451,
					false
				]
				],
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					5642151154068618,
					false
					,[
					[
						7,
						[
							2,
							"Android"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5416079795199543,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					7613027635389428,
					false
					,[
					[
						1,
						[
							2,
							"PREMIUM"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9481312599541819,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2011959016863655,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Premium"
							]
						]
						]
					]
					],
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.acts.Destroy,
						null,
						8868222671948655,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5115563522363041,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					9469565673667021,
					false
					,[
					[
						1,
						[
							2,
							"PREMIUM"
						]
					]
,					[
						8,
						1
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.PreloadBanner,
					null,
					9561192016638885,
					false
				]
,				[
					26,
					cr.plugins_.CJSAds.prototype.acts.ShowBanner,
					null,
					5561128316994577,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1150275671327806,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					7703751309407892,
					false
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.HideBanner,
					null,
					5626918318529977,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7444654287971069,
			[
			[
				6,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				7097952170550449,
				false
				,[
				[
					4,
					35
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3143009522994366,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1014948082593726,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Play"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					6825306730070739,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					1990754064498737,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					60962311633753,
					false
					,[
					[
						6,
						"ShipSelect"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7643768596732879,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7050197549986753,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Options"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					6759271021602607,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					8993031150620021,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					8856822046015629,
					false
					,[
					[
						6,
						"Options"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1004289079603844,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					843507292957851,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Premium"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					7509080022843027,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					8915418529553234,
					[
					[
						26,
						cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,
						null,
						0,
						false,
						false,
						false,
						4064974981424042,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						9946726078530268,
						[
						[
							26,
							cr.plugins_.CJSAds.prototype.cnds.IsStoreAvailable,
							null,
							0,
							false,
							false,
							false,
							9576397928449515,
							false
						]
						],
						[
						[
							26,
							cr.plugins_.CJSAds.prototype.acts.Purchase,
							null,
							586999906293492,
							false
							,[
							[
								1,
								[
									2,
									"navecicas_premium_01"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6998070357402542,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							5279177638542111,
							false
						]
						],
						[
						[
							27,
							cr.plugins_.Browser.prototype.acts.Alert,
							null,
							2267814847121695,
							false
							,[
							[
								7,
								[
									2,
									"Error: Store Unavaliable"
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4286132062027874,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						7163753527085125,
						false
					]
					],
					[
					[
						27,
						cr.plugins_.Browser.prototype.acts.GoToURL,
						null,
						4504123989469472,
						false
						,[
						[
							1,
							[
								2,
								"https://play.google.com/store/apps/details?id=com.Navecicas.byr&hl=en"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3122942369721431,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6368537415187624,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Exit"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					9817127077815257,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					27,
					cr.plugins_.Browser.prototype.acts.Close,
					null,
					4856768155051763,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5420656780301431,
			[
			[
				26,
				cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,
				null,
				1,
				false,
				false,
				false,
				1418337540599785,
				false
				,[
				[
					1,
					[
						2,
						"navecicas_premium_01"
					]
				]
				]
			]
			],
			[
			[
				5,
				cr.plugins_.Audio.prototype.acts.Play,
				null,
				7854234158641908,
				false
				,[
				[
					2,
					["yep",false]
				]
,				[
					3,
					0
				]
,				[
					0,
					[
						0,
						0
					]
				]
,				[
					1,
					[
						2,
						""
					]
				]
				]
			]
,			[
				18,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7026794056383441,
				false
				,[
				[
					1,
					[
						2,
						"PREMIUM"
					]
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
,			[
				26,
				cr.plugins_.CJSAds.prototype.acts.HideBanner,
				null,
				913803549739817,
				false
			]
			]
		]
		]
	]
,	[
		"ModeSelect",
		[
		[
			2,
			"FUNCIONES",
			false
		]
,		[
			0,
			null,
			false,
			null,
			4073676982431954,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				2008176513743388,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8074310633161174,
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					5783123744100528,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"RecordNormal"
						]
					]
					]
				]
				],
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					6902125306698699,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								"Record: "
							]
							,[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									2,
									"RECORD"
								]
								]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				839880559920344,
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					2133566148254943,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"RecordHardcore"
						]
					]
					]
				]
				],
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					9688166051281915,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								"Record: "
							]
							,[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									2,
									"RECORD_HARDCORE"
								]
								]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7229114056708552,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3706891621835365,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"SelectMode"
						]
					]
					]
				]
				],
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					1072107310512779,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"SelectMode"
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9899474386178286,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6040392190118175,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Normal"
						]
					]
					]
				]
				],
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					7170304728037611,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"NormalMode"
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7101446374809664,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3874803273414649,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Hardcore"
						]
					]
					]
				]
				],
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					5736400888784786,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"HardcoreMode"
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3622553974146566,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3053399030352495,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Back"
						]
					]
					]
				]
				],
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					323659757816524,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"Back"
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5457723866984722,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					1683620632628829,
					false
					,[
					[
						1,
						[
							2,
							"PREMIUM"
						]
					]
,					[
						8,
						1
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.ShowBanner,
					null,
					9025383023414561,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7302717865765519,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					7450604714949071,
					false
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.HideBanner,
					null,
					4027105861494925,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1717007710194169,
			[
			[
				6,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				5079550138407721,
				false
				,[
				[
					4,
					35
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7427651214739025,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					5536013457034243,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Back"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					8047677439834714,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6413897346030908,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					5725134047889291,
					false
					,[
					[
						6,
						"ShipSelect"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1921361130389041,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					9745824591689827,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Normal"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					9029017960322636,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					7908257805908093,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					1414544880211117,
					false
					,[
					[
						11,
						"GAME_MODE"
					]
,					[
						7,
						[
							2,
							"NORMAL"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					4420827512736484,
					false
					,[
					[
						6,
						"Game"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7676411466042798,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					9449232628921403,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Hardcore"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					7653316014063727,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					8082765412463963,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					9774295243207526,
					false
					,[
					[
						11,
						"GAME_MODE"
					]
,					[
						7,
						[
							2,
							"HARDCORE"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					5799523438559772,
					false
					,[
					[
						6,
						"Game"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4950757975367928,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8358147268060286,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"TEST"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					6681730757983257,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					8302455642807853,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					7749614026140913,
					false
					,[
					[
						11,
						"GAME_MODE"
					]
,					[
						7,
						[
							2,
							"ROGUELIKE"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					3895824886617672,
					false
					,[
					[
						6,
						"Game"
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"ShipSelect",
		[
		[
			2,
			"FUNCIONES",
			false
		]
,		[
			1,
			"SELECTED_SHIP",
			1,
			"",
false,false,4898112009150401,false
		]
,		[
			1,
			"SELECTED_COLOR",
			0,
			0,
false,false,7758524654096216,false
		]
,		[
			0,
			null,
			false,
			null,
			263398226455483,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				3869981891336435,
				false
			]
			],
			[
			[
				0,
				cr.plugins_.Sprite.prototype.acts.SetAnim,
				null,
				64877000220406,
				false
				,[
				[
					1,
					[
						10,
						[
							20,
							22,
							cr.plugins_.Dictionary.prototype.exps.Get,
							false,
							null
							,[
[
								2,
								"Ship1"
							]
							]
						]
						,[
							2,
							"Menu"
						]
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				0,
				cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
				null,
				806682715365778,
				false
				,[
				[
					10,
					5
				]
,				[
					7,
					[
						20,
						22,
						cr.plugins_.Dictionary.prototype.exps.Get,
						false,
						null
						,[
[
							2,
							"Ship1"
						]
						]
					]
				]
				]
			]
,			[
				0,
				cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
				null,
				651808071015466,
				false
				,[
				[
					10,
					15
				]
,				[
					7,
					[
						0,
						1
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6102691705406785,
				false
				,[
				[
					11,
					"SELECTED_SHIP"
				]
,				[
					7,
					[
						21,
						0,
						true,
						null
						,5
					]
				]
				]
			]
,			[
				8,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				7971421043638552,
				false
				,[
				[
					1,
					[
						2,
						"CheckMedal"
					]
				]
,				[
					13,
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				2641630136752917,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					2386164442806214,
					false
					,[
					[
						1,
						[
							2,
							"PREMIUM"
						]
					]
,					[
						8,
						1
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.ShowBanner,
					null,
					3235120424147036,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				569521873120853,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					2789823720786594,
					false
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.HideBanner,
					null,
					6694940536724731,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6397747951394753,
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3094002070649824,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Desc"
						]
					]
					]
				]
				],
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4057424146693772,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Desc"
									]
								]
								,[
									21,
									0,
									true,
									null
									,5
								]
							]
							]
						]
					]
					]
				]
,				[
					15,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					7721653078321619,
					false
					,[
					[
						7,
						[
							19,
							cr.system_object.prototype.exps.replace
							,[
[
								20,
								15,
								cr.plugins_.Spritefont2.prototype.exps.Text,
								true,
								null
							]
,[
								2,
								"*"
							]
,[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										10,
										[
											10,
											[
												10,
												[
													10,
													[
														20,
														18,
														cr.plugins_.WebStorage.prototype.exps.LocalValue,
														true,
														null
														,[
[
															2,
															"LANG"
														]
														]
													]
													,[
														2,
														"Ship"
													]
												]
												,[
													21,
													0,
													false,
													null
													,15
												]
											]
											,[
												2,
												"Color"
											]
										]
										,[
											21,
											0,
											false,
											null
											,16
										]
									]
									,[
										2,
										"Extra"
									]
								]
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5466543763976856,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					2832006356270414,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"SelectShip"
						]
					]
					]
				]
				],
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					5547655538918061,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"Select"
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3871663830228374,
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7392078601392114,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Play"
						]
					]
					]
				]
				],
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					3797065351171703,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"Play"
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5137012403276781,
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					5042192063339509,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Back"
						]
					]
					]
				]
				],
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					549083683050361,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"Back"
								]
							]
							]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1130935602600219,
			[
			],
			[
			[
				8,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				8901481809711375,
				false
				,[
				[
					1,
					[
						2,
						"GetScore"
					]
				]
,				[
					13,
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6246505145851837,
			[
			[
				15,
				cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
				null,
				0,
				false,
				false,
				false,
				36460407405652,
				false
				,[
				[
					10,
					0
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"Money"
					]
				]
				]
			]
			],
			[
			[
				15,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				1158014770870029,
				false
				,[
				[
					7,
					[
						20,
						18,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Money"
						]
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4191392021578819,
			[
			[
				6,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				8128369353213534,
				false
				,[
				[
					4,
					35
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				647348604022242,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					5048519759075959,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Back"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					6509819391938838,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2366288271514604,
					false
					,[
					[
						11,
						"SELECTED_SHIP"
					]
,					[
						7,
						[
							2,
							""
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					844254326638699,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					4920215605784993,
					false
					,[
					[
						6,
						"Title"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1861979552454312,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					4623517585275982,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Play"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					576398019012628,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2818296320869834,
						false
						,[
						[
							10,
							1
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Play"
							]
						]
						]
					]
					],
					[
					[
						5,
						cr.plugins_.Audio.prototype.acts.Play,
						null,
						2315097912244422,
						false
						,[
						[
							2,
							["menu",false]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								2,
								""
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6149727581375764,
						false
						,[
						[
							0,
							[
								1,
								0.3
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.GoToLayout,
						null,
						7629955460749208,
						false
						,[
						[
							6,
							"ModeSelect"
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4509553950949397,
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8771933619146999,
						false
						,[
						[
							10,
							1
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Purchase"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5565097033389688,
						[
						[
							18,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
							null,
							0,
							false,
							false,
							false,
							4272169514254101,
							false
							,[
							[
								1,
								[
									2,
									"Money"
								]
							]
,							[
								8,
								5
							]
,							[
								0,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											10,
											[
												10,
												[
													10,
													[
														10,
														[
															2,
															"Ship"
														]
														,[
															21,
															0,
															false,
															null
															,15
														]
													]
													,[
														2,
														"Color"
													]
												]
												,[
													21,
													0,
													false,
													null
													,16
												]
											]
											,[
												2,
												"Price"
											]
										]
										]
									]
									]
								]
							]
							]
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.Play,
							null,
							2225371222485801,
							false
							,[
							[
								2,
								["yep",false]
							]
,							[
								3,
								0
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								1,
								[
									2,
									""
								]
							]
							]
						]
,						[
							18,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							3374697188382134,
							false
							,[
							[
								1,
								[
									10,
									[
										10,
										[
											10,
											[
												10,
												[
													2,
													"Ship"
												]
												,[
													21,
													0,
													false,
													null
													,15
												]
											]
											,[
												2,
												"Color"
											]
										]
										,[
											21,
											0,
											false,
											null
											,16
										]
									]
									,[
										2,
										"Purchased"
									]
								]
							]
,							[
								7,
								[
									2,
									"Yes"
								]
							]
							]
						]
,						[
							18,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							4602790835099349,
							false
							,[
							[
								1,
								[
									2,
									"Money"
								]
							]
,							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											20,
											18,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"Money"
											]
											]
										]
										]
									]
									,[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											20,
											18,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												10,
												[
													10,
													[
														10,
														[
															10,
															[
																2,
																"Ship"
															]
															,[
																21,
																0,
																false,
																null
																,15
															]
														]
														,[
															2,
															"Color"
														]
													]
													,[
														21,
														0,
														false,
														null
														,16
													]
												]
												,[
													2,
													"Price"
												]
											]
											]
										]
										]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2988441302329605,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							3129852645870797,
							false
						]
						],
						[
						[
							5,
							cr.plugins_.Audio.prototype.acts.Play,
							null,
							233808481262409,
							false
							,[
							[
								2,
								["nope",false]
							]
,							[
								3,
								0
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								1,
								[
									2,
									""
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4972930447683463,
			[
			[
				6,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				5530697286138252,
				false
				,[
				[
					4,
					29
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3796268814196482,
				[
				[
					29,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1766759786424728,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Left"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					8651525641426102,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					5437121396535349,
					false
					,[
					[
						10,
						16
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					9827771401912448,
					false
					,[
					[
						11,
						"SELECTED_COLOR"
					]
,					[
						7,
						[
							21,
							0,
							false,
							null
							,16
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2914591255850751,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9517520324731678,
						false
						,[
						[
							10,
							15
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3157763064533288,
						false
						,[
						[
							10,
							15
						]
,						[
							7,
							[
								20,
								22,
								cr.plugins_.Dictionary.prototype.exps.Get,
								false,
								null
								,[
[
									2,
									"TotalShips"
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6537915886911963,
						false
						,[
						[
							11,
							"SELECTED_SHIP"
						]
,						[
							7,
							[
								20,
								22,
								cr.plugins_.Dictionary.prototype.exps.Get,
								false,
								null
								,[
[
									10,
									[
										2,
										"Ship"
									]
									,[
										21,
										0,
										false,
										null
										,15
									]
								]
								]
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5308579425696147,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								23,
								"SELECTED_SHIP"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7616549095147425,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						9218177136626947,
						false
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5413990965828354,
						false
						,[
						[
							10,
							15
						]
,						[
							7,
							[
								5,
								[
									21,
									0,
									false,
									null
									,15
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5865149684963471,
						false
						,[
						[
							11,
							"SELECTED_SHIP"
						]
,						[
							7,
							[
								20,
								22,
								cr.plugins_.Dictionary.prototype.exps.Get,
								false,
								null
								,[
[
									10,
									[
										2,
										"Ship"
									]
									,[
										21,
										0,
										false,
										null
										,15
									]
								]
								]
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6659304104534344,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								23,
								"SELECTED_SHIP"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9878213600535226,
				[
				[
					29,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1019174718993091,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Right"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					4646264369080127,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
					null,
					4437447406084188,
					false
					,[
					[
						10,
						16
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4090293111895009,
					false
					,[
					[
						11,
						"SELECTED_COLOR"
					]
,					[
						7,
						[
							21,
							0,
							false,
							null
							,16
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					4855659899392104,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3408025139722152,
						false
						,[
						[
							10,
							15
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								20,
								22,
								cr.plugins_.Dictionary.prototype.exps.Get,
								false,
								null
								,[
[
									2,
									"TotalShips"
								]
								]
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7891052826304809,
						false
						,[
						[
							10,
							15
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6841880244004149,
						false
						,[
						[
							11,
							"SELECTED_SHIP"
						]
,						[
							7,
							[
								20,
								22,
								cr.plugins_.Dictionary.prototype.exps.Get,
								false,
								null
								,[
[
									10,
									[
										2,
										"Ship"
									]
									,[
										21,
										0,
										false,
										null
										,15
									]
								]
								]
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5211579994619861,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								23,
								"SELECTED_SHIP"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2535281263099464,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						2579906557687966,
						false
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5683289194276878,
						false
						,[
						[
							10,
							15
						]
,						[
							7,
							[
								4,
								[
									21,
									0,
									false,
									null
									,15
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7931555654223496,
						false
						,[
						[
							11,
							"SELECTED_SHIP"
						]
,						[
							7,
							[
								20,
								22,
								cr.plugins_.Dictionary.prototype.exps.Get,
								false,
								null
								,[
[
									10,
									[
										2,
										"Ship"
									]
									,[
										21,
										0,
										false,
										null
										,15
									]
								]
								]
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						647179531702477,
						false
						,[
						[
							10,
							5
						]
,						[
							7,
							[
								23,
								"SELECTED_SHIP"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3862803082336341,
				[
				[
					29,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					345894982078359,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Up"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					2137063058486839,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					3505247596667047,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6087030733984667,
						false
						,[
						[
							10,
							16
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								5,
								[
									20,
									0,
									cr.plugins_.Sprite.prototype.exps.AnimationFrameCount,
									false,
									null
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1174716886540759,
						false
						,[
						[
							10,
							16
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9078999786471185,
						false
						,[
						[
							0,
							[
								21,
								0,
								false,
								null
								,16
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9907120237503351,
						false
						,[
						[
							11,
							"SELECTED_COLOR"
						]
,						[
							7,
							[
								21,
								0,
								false,
								null
								,16
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4859637364954395,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						822417577472022,
						false
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
						null,
						1118275802292821,
						false
						,[
						[
							10,
							16
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1281550976660559,
						false
						,[
						[
							0,
							[
								21,
								0,
								false,
								null
								,16
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						213465295728341,
						false
						,[
						[
							11,
							"SELECTED_COLOR"
						]
,						[
							7,
							[
								21,
								0,
								false,
								null
								,16
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1227062025141553,
				[
				[
					29,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3864626209864572,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Down"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					9505851849440509,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					1560505985937303,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8241854948790226,
						false
						,[
						[
							10,
							16
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1152983911157037,
						false
						,[
						[
							10,
							16
						]
,						[
							7,
							[
								5,
								[
									20,
									0,
									cr.plugins_.Sprite.prototype.exps.AnimationFrameCount,
									false,
									null
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2860742544419413,
						false
						,[
						[
							0,
							[
								21,
								0,
								false,
								null
								,16
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5585219219247693,
						false
						,[
						[
							11,
							"SELECTED_COLOR"
						]
,						[
							7,
							[
								21,
								0,
								false,
								null
								,16
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3141367355796041,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						4301834440327278,
						false
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
						null,
						6570362614684612,
						false
						,[
						[
							10,
							16
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2250490570944586,
						false
						,[
						[
							0,
							[
								21,
								0,
								false,
								null
								,16
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2349941096773117,
						false
						,[
						[
							11,
							"SELECTED_COLOR"
						]
,						[
							7,
							[
								21,
								0,
								false,
								null
								,16
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3907710550764477,
				[
				],
				[
				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					8128391900655801,
					false
					,[
					[
						1,
						[
							10,
							[
								21,
								0,
								true,
								null
								,5
							]
							,[
								2,
								"Menu"
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					8,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					687195695576392,
					false
					,[
					[
						1,
						[
							2,
							"CheckMedal"
						]
					]
,					[
						13,
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					6651853562085933,
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9602240590484712,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Desc"
							]
						]
						]
					]
					],
					[
					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						2177676279211106,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										10,
										[
											20,
											18,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"LANG"
											]
											]
										]
										,[
											2,
											"Desc"
										]
									]
									,[
										21,
										0,
										true,
										null
										,5
									]
								]
								]
							]
						]
						]
					]
,					[
						15,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						4891613267185575,
						false
						,[
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.replace
								,[
[
									20,
									15,
									cr.plugins_.Spritefont2.prototype.exps.Text,
									true,
									null
								]
,[
									2,
									"*"
								]
,[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										10,
										[
											10,
											[
												10,
												[
													10,
													[
														10,
														[
															20,
															18,
															cr.plugins_.WebStorage.prototype.exps.LocalValue,
															true,
															null
															,[
[
																2,
																"LANG"
															]
															]
														]
														,[
															2,
															"Ship"
														]
													]
													,[
														21,
														0,
														false,
														null
														,15
													]
												]
												,[
													2,
													"Color"
												]
											]
											,[
												21,
												0,
												false,
												null
												,16
											]
										]
										,[
											2,
											"Extra"
										]
									]
									]
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3393071830467019,
			[
			[
				15,
				cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
				null,
				0,
				false,
				false,
				false,
				9688764833975605,
				false
				,[
				[
					10,
					0
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"Price"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4184139161638961,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Compare,
					null,
					0,
					false,
					false,
					false,
					1103345264275267,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									10,
									[
										10,
										[
											10,
											[
												2,
												"Ship"
											]
											,[
												21,
												0,
												false,
												null
												,15
											]
										]
										,[
											2,
											"Color"
										]
									]
									,[
										21,
										0,
										false,
										null
										,16
									]
								]
								,[
									2,
									"Purchased"
								]
							]
							]
						]
					]
,					[
						8,
						1
					]
,					[
						7,
						[
							2,
							"Yes"
						]
					]
					]
				]
				],
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					6327252575093165,
					false
					,[
					[
						7,
						[
							10,
							[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										10,
										[
											20,
											18,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"LANG"
											]
											]
										]
										,[
											2,
											"Price"
										]
									]
									]
								]
								,[
									2,
									": "
								]
							]
							,[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										10,
										[
											10,
											[
												10,
												[
													2,
													"Ship"
												]
												,[
													21,
													0,
													false,
													null
													,15
												]
											]
											,[
												2,
												"Color"
											]
										]
										,[
											21,
											0,
											false,
											null
											,16
										]
									]
									,[
										2,
										"Price"
									]
								]
								]
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					8769469533895057,
					[
					[
						-1,
						cr.system_object.prototype.cnds.PickAll,
						null,
						0,
						false,
						false,
						false,
						2608587204120221,
						false
						,[
						[
							4,
							35
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.PickByEvaluate,
						null,
						0,
						false,
						false,
						false,
						112550232882037,
						false
						,[
						[
							4,
							35
						]
,						[
							0,
							[
								12,
								[
									21,
									35,
									true,
									null
									,0
								]
								,[
									2,
									"Play"
								]
							]
						]
						]
					]
					],
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						7680992554833981,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Purchase"
									]
								]
								]
							]
						]
						]
					]
,					[
						35,
						cr.plugins_.Spritefont2.prototype.acts.SetInstanceVar,
						null,
						622066465476348,
						false
						,[
						[
							10,
							1
						]
,						[
							7,
							[
								2,
								"Purchase"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7024731561718404,
					[
					[
						17,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						543018686506441,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Price"
							]
						]
						]
					]
					],
					[
					[
						17,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						890322756978725,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1191367289730964,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					2726073462764503,
					false
				]
				],
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					7258903597456956,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									20,
									18,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"LANG"
									]
									]
								]
								,[
									2,
									"Owned"
								]
							]
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					3079148285767722,
					[
					[
						-1,
						cr.system_object.prototype.cnds.PickAll,
						null,
						0,
						false,
						false,
						false,
						4589892781495026,
						false
						,[
						[
							4,
							35
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.PickByEvaluate,
						null,
						0,
						false,
						false,
						false,
						1558084665395084,
						false
						,[
						[
							4,
							35
						]
,						[
							0,
							[
								12,
								[
									21,
									35,
									true,
									null
									,0
								]
								,[
									2,
									"Play"
								]
							]
						]
						]
					]
					],
					[
					[
						35,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						2287225853791019,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Play"
									]
								]
								]
							]
						]
						]
					]
,					[
						35,
						cr.plugins_.Spritefont2.prototype.acts.SetInstanceVar,
						null,
						6936281338025334,
						false
						,[
						[
							10,
							1
						]
,						[
							7,
							[
								2,
								"Play"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2346418510931322,
					[
					[
						17,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3379050207173274,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Price"
							]
						]
						]
					]
					],
					[
					[
						17,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8801693364248106,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			957896395220996,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				2456542142984413,
				false
				,[
				[
					1,
					[
						2,
						"CheckMedal"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3969658168695326,
				[
				[
					32,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3105029507486803,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Normal"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7184999691485843,
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						3779527010367071,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Medal"
								]
								,[
									21,
									0,
									false,
									null
									,15
								]
							]
						]
,						[
							1,
							[
								2,
								"Bronze"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8584871216489814,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						1116494444011355,
						false
						,[
						[
							1,
							[
								2,
								"Bronze"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3486413328821676,
						false
						,[
						[
							0,
							[
								5,
								[
									21,
									0,
									false,
									null
									,15
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					661262823177615,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						770232098778384,
						false
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						4456539912230085,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Medal"
								]
								,[
									21,
									0,
									false,
									null
									,15
								]
							]
						]
,						[
							1,
							[
								2,
								"Silver"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7808461483835001,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						9284554551375517,
						false
						,[
						[
							1,
							[
								2,
								"Silver"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6524503908547225,
						false
						,[
						[
							0,
							[
								5,
								[
									21,
									0,
									false,
									null
									,15
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5135764940124174,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						9205564927389783,
						false
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						7711208766951508,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Medal"
								]
								,[
									21,
									0,
									false,
									null
									,15
								]
							]
						]
,						[
							1,
							[
								2,
								"Gold"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8961650972286441,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						5221076140899362,
						false
						,[
						[
							1,
							[
								2,
								"Gold"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3540260895662029,
						false
						,[
						[
							0,
							[
								5,
								[
									21,
									0,
									false,
									null
									,15
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7973087861289355,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						2475927009623377,
						false
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8625878099921104,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						7694362627528973,
						false
						,[
						[
							1,
							[
								2,
								"Empty"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						4464034792851971,
						false
						,[
						[
							0,
							[
								5,
								[
									21,
									0,
									false,
									null
									,15
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7743999384185544,
				[
				[
					32,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					2558995604641503,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Hardcore"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					4264786920885591,
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						1507547931461255,
						false
						,[
						[
							1,
							[
								10,
								[
									10,
									[
										2,
										"Medal"
									]
									,[
										21,
										0,
										false,
										null
										,15
									]
								]
								,[
									2,
									"Hardcore"
								]
							]
						]
,						[
							1,
							[
								2,
								"Bronze"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7914797590024005,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						9025102249641078,
						false
						,[
						[
							1,
							[
								2,
								"Bronze"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6452786228693614,
						false
						,[
						[
							0,
							[
								5,
								[
									21,
									0,
									false,
									null
									,15
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6879786227531877,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						2164335399945232,
						false
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9547952639728142,
						false
						,[
						[
							1,
							[
								10,
								[
									10,
									[
										2,
										"Medal"
									]
									,[
										21,
										0,
										false,
										null
										,15
									]
								]
								,[
									2,
									"Hardcore"
								]
							]
						]
,						[
							1,
							[
								2,
								"Silver"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						9731205143727484,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						519696863576839,
						false
						,[
						[
							1,
							[
								2,
								"Silver"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3882920117162479,
						false
						,[
						[
							0,
							[
								5,
								[
									21,
									0,
									false,
									null
									,15
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8776481858777707,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						8821611082585423,
						false
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9698561774717004,
						false
						,[
						[
							1,
							[
								10,
								[
									10,
									[
										2,
										"Medal"
									]
									,[
										21,
										0,
										false,
										null
										,15
									]
								]
								,[
									2,
									"Hardcore"
								]
							]
						]
,						[
							1,
							[
								2,
								"Gold"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4013308963694857,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						9759418715547605,
						false
						,[
						[
							1,
							[
								2,
								"Gold"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6456194128200112,
						false
						,[
						[
							0,
							[
								5,
								[
									21,
									0,
									false,
									null
									,15
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7072324646339695,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						6318712148116663,
						false
					]
					],
					[
					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7440842414154599,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						2764614302794837,
						false
						,[
						[
							1,
							[
								2,
								"Empty"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						32,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1406380728628032,
						false
						,[
						[
							0,
							[
								5,
								[
									21,
									0,
									false,
									null
									,15
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"Achievements",
		[
		[
			1,
			"PAGE",
			0,
			1,
false,false,2651869289862427,false
		]
,		[
			2,
			"FUNCIONES",
			false
		]
,		[
			0,
			null,
			false,
			null,
			5549120862343608,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				8938440076554066,
				false
			]
			],
			[
			[
				8,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				1508453573280722,
				false
				,[
				[
					1,
					[
						2,
						"LoadPage"
					]
				]
,				[
					13,
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9989901935116673,
			[
			[
				6,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				5067422720335865,
				false
				,[
				[
					4,
					29
				]
				]
			]
			],
			[
			[
				5,
				cr.plugins_.Audio.prototype.acts.Play,
				null,
				4839989107409266,
				false
				,[
				[
					2,
					["menu",false]
				]
,				[
					3,
					0
				]
,				[
					0,
					[
						0,
						0
					]
				]
,				[
					1,
					[
						2,
						""
					]
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				3911542692806593,
				[
				[
					29,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					874302962532324,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Left"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5796068943331215,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						true,
						false,
						8037419965766468,
						false
						,[
						[
							11,
							"PAGE"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						9616297184978896,
						false
						,[
						[
							11,
							"PAGE"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3209932610431714,
						false
						,[
						[
							1,
							[
								2,
								"LoadPage"
							]
						]
,						[
							13,
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				647930085819252,
				[
				[
					29,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7980225448290868,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Right"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5907882275390562,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						true,
						false,
						6770069835106425,
						false
						,[
						[
							11,
							"PAGE"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						4502509374734793,
						false
						,[
						[
							11,
							"PAGE"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3565269482040251,
						false
						,[
						[
							1,
							[
								2,
								"LoadPage"
							]
						]
,						[
							13,
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4520693277590068,
			[
			[
				8,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				5765006851490059,
				false
				,[
				[
					1,
					[
						2,
						"LoadPage"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				1,
				"linesPerPage",
				0,
				5,
false,false,7931292786873585,false
			]
,			[
				0,
				null,
				false,
				null,
				5575138037140955,
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					2863837792267193,
					false
					,[
					[
						10,
						1
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Ach"
						]
					]
					]
				]
				],
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					9765662064791304,
					false
					,[
					[
						7,
						[
							20,
							18,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								10,
								[
									2,
									"Ach"
								]
								,[
									4,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											21,
											15,
											true,
											null
											,0
										]
										]
									]
									,[
										6,
										[
											5,
											[
												23,
												"PAGE"
											]
											,[
												0,
												1
											]
										]
										,[
											0,
											5
										]
									]
								]
							]
							]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8383362161970565,
			[
			[
				6,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				6665290059057445,
				false
				,[
				[
					4,
					15
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8892043073165681,
				[
				[
					15,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3509381908676915,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Back"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Audio.prototype.acts.Play,
					null,
					7273167772249088,
					false
					,[
					[
						2,
						["menu",false]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							2,
							""
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5874045432553712,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					8691453810454728,
					false
					,[
					[
						6,
						"Title"
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"Options",
		[
		[
			0,
			null,
			false,
			null,
			6044128146729247,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				3584988442983659,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2585837241370168,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					1651800984799524,
					false
					,[
					[
						1,
						[
							2,
							"PREMIUM"
						]
					]
,					[
						8,
						1
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.ShowBanner,
					null,
					8528329518357511,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7715220936383215,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					1562826707313747,
					false
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.HideBanner,
					null,
					6469074595427218,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1930689153727503,
			[
			[
				6,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				533549437560154,
				false
				,[
				[
					4,
					35
				]
				]
			]
			],
			[
			[
				5,
				cr.plugins_.Audio.prototype.acts.Play,
				null,
				8147319079301079,
				false
				,[
				[
					2,
					["menu",false]
				]
,				[
					3,
					0
				]
,				[
					0,
					[
						0,
						0
					]
				]
,				[
					1,
					[
						2,
						""
					]
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				3321046188808436,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					4406152482341876,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Back"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					9280818420742167,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					2216500623719649,
					false
					,[
					[
						6,
						"Title"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				986953686613399,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6315836371577986,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"MUSIC"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9739916442226016,
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						1603384601255662,
						false
						,[
						[
							1,
							[
								2,
								"MUSIC"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						5,
						cr.plugins_.Audio.prototype.acts.SetSilent,
						null,
						1298454481505522,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4340130253100694,
						false
						,[
						[
							1,
							[
								2,
								"MUSIC"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3091616353167516,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						1694309377575821,
						false
					]
					],
					[
					[
						5,
						cr.plugins_.Audio.prototype.acts.SetSilent,
						null,
						6706795974336164,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2048533006819341,
						false
						,[
						[
							1,
							[
								2,
								"MUSIC"
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2513935381784137,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6732019473707905,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"LANG"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6366835570198046,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						2530550821130865,
						false
						,[
						[
							7,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									2,
									"LANG"
								]
								]
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"E"
							]
						]
						]
					]
					],
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5149909881859898,
						false
						,[
						[
							1,
							[
								2,
								"LANG"
							]
						]
,						[
							7,
							[
								2,
								"S"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5727668233466723,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						3350303114684301,
						false
					]
					],
					[
					[
						18,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						110045815592492,
						false
						,[
						[
							1,
							[
								2,
								"LANG"
							]
						]
,						[
							7,
							[
								2,
								"E"
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3967160763711114,
			[
			[
				35,
				cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
				null,
				0,
				false,
				false,
				false,
				6604705780522679,
				false
				,[
				[
					10,
					0
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"MUSIC"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6406165714875819,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					7693324646015831,
					false
					,[
					[
						1,
						[
							2,
							"MUSIC"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					6323088807125756,
					false
					,[
					[
						7,
						[
							10,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Music"
									]
								]
								]
							]
							,[
								2,
								" OFF"
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7109607922955697,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					7713136659214973,
					false
				]
				],
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					1689727035582806,
					false
					,[
					[
						7,
						[
							10,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									10,
									[
										20,
										18,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"LANG"
										]
										]
									]
									,[
										2,
										"Music"
									]
								]
								]
							]
							,[
								2,
								" ON"
							]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7281366121787769,
			[
			[
				35,
				cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
				null,
				0,
				false,
				false,
				false,
				1139673758798978,
				false
				,[
				[
					10,
					0
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"LANG"
					]
				]
				]
			]
			],
			[
			[
				35,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				7989295187045915,
				false
				,[
				[
					7,
					[
						20,
						18,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							10,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									2,
									"LANG"
								]
								]
							]
							,[
								2,
								"Lang"
							]
						]
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7412219225274758,
			[
			[
				35,
				cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
				null,
				0,
				false,
				false,
				false,
				5327987839738884,
				false
				,[
				[
					10,
					0
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"Back"
					]
				]
				]
			]
			],
			[
			[
				35,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				3947585648986116,
				false
				,[
				[
					7,
					[
						20,
						18,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							10,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									2,
									"LANG"
								]
								]
							]
							,[
								2,
								"Back"
							]
						]
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1595564215255405,
			[
			[
				35,
				cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
				null,
				0,
				false,
				false,
				false,
				4086990490546809,
				false
				,[
				[
					10,
					0
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"OPTIONS"
					]
				]
				]
			]
			],
			[
			[
				35,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				413388210795322,
				false
				,[
				[
					7,
					[
						20,
						18,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							10,
							[
								20,
								18,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									2,
									"LANG"
								]
								]
							]
							,[
								2,
								"OPTIONS"
							]
						]
						]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"LANG",
		[
		[
			0,
			null,
			false,
			null,
			7394213884457209,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				263511915820447,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				5360763473420676,
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					9391004152272794,
					false
					,[
					[
						1,
						[
							2,
							"PREMIUM"
						]
					]
,					[
						8,
						1
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.ShowBanner,
					null,
					2338127292696504,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1207995744483831,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					4720864553792855,
					false
				]
				],
				[
				[
					26,
					cr.plugins_.CJSAds.prototype.acts.HideBanner,
					null,
					6865259403211364,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6992480022202222,
			[
			[
				6,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				9419597773443466,
				false
				,[
				[
					4,
					35
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8831150254511191,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					2206239425257236,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"English"
						]
					]
					]
				]
				],
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					4774349267511791,
					false
					,[
					[
						1,
						[
							2,
							"LANG"
						]
					]
,					[
						7,
						[
							2,
							"E"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2392160351886188,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					579115546392334,
					false
					,[
					[
						6,
						"Title"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4144579384833458,
				[
				[
					35,
					cr.plugins_.Spritefont2.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					9926460548498015,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"Spanish"
						]
					]
					]
				]
				],
				[
				[
					18,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					4982396034543974,
					false
					,[
					[
						1,
						[
							2,
							"LANG"
						]
					]
,					[
						7,
						[
							2,
							"S"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5569416891886193,
					false
					,[
					[
						0,
						[
							1,
							0.3
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					3886497536124373,
					false
					,[
					[
						6,
						"Title"
					]
					]
				]
				]
			]
			]
		]
		]
	]
	],
	"",
	false,
	320,
	480,
	4,
	true,
	false,
	false,
	"1.2",
	true,
	true,
	2,
	1,
	193,
	false,
	true,
	[
	]
];};

createCocoonJSRuntime();

})();
